/*
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package elemental2.dom;

import java.lang.String;
import jsinterop.annotations.JsPackage;
import jsinterop.annotations.JsProperty;
import jsinterop.annotations.JsType;

@JsType(isNative = true, namespace = JsPackage.GLOBAL)
public class HashChangeEvent extends Event {
  @JsType
  public interface HashChangeEventEventInitDictType {
    @JsProperty
    String getNewURL();

    @JsProperty
    String getOldURL();

    @JsProperty
    void setNewURL(String newURL);

    @JsProperty
    void setOldURL(String oldURL);
  }

  public String newURL;
  public String oldURL;

  public HashChangeEvent(String type, HashChangeEventEventInitDictType eventInitDict) {
    // This call is only here for java compilation purpose.
    super((String) null, (EventInit) null);
  }

  public HashChangeEvent(String type) {
    // This call is only here for java compilation purpose.
    super((String) null, (EventInit) null);
  }

  public native void initHashChangeEvent(
      String typeArg,
      boolean canBubbleArg,
      boolean cancelableArg,
      String oldURLArg,
      String newURLArg);
}
