/*
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package elemental2.dom;

import java.lang.Object;
import java.lang.String;
import jsinterop.annotations.JsOverlay;
import jsinterop.annotations.JsPackage;
import jsinterop.annotations.JsProperty;
import jsinterop.annotations.JsType;
import jsinterop.base.Js;

@JsType(isNative = true, namespace = JsPackage.GLOBAL)
public interface RTCConfigurationInterface_ {
  @JsType(isNative = true, name = "?", namespace = JsPackage.GLOBAL)
  public interface GetIceServersArrayUnionType {
    @JsOverlay
    static GetIceServersArrayUnionType of(Object o) {
      return Js.cast(o);
    }

    @JsOverlay
    default IceServersFieldType asIceServersFieldType() {
      return Js.cast(this);
    }

    @JsOverlay
    default RTCIceServerInterface_ asRTCIceServerInterface_() {
      return Js.cast(this);
    }

    @JsOverlay
    default UrlsFieldType asUrlsFieldType() {
      return Js.cast(this);
    }

    @JsOverlay
    default boolean isIceServersFieldType() {
      return (Object) this instanceof IceServersFieldType;
    }

    @JsOverlay
    default boolean isUrlsFieldType() {
      return (Object) this instanceof UrlsFieldType;
    }
  }

  @JsType
  public interface IceServersFieldType {
    @JsProperty
    String getUrls();

    @JsProperty
    void setUrls(String urls);
  }

  @JsType
  public interface UrlsFieldType {
    @JsProperty
    String[] getUrls();

    @JsProperty
    void setUrls(String[] urls);
  }

  @JsProperty
  GetIceServersArrayUnionType[] getIceServers();

  @JsProperty
  void setIceServers(GetIceServersArrayUnionType[] iceServers);
}
