package org.jboss.errai.ioc.client;

import java.lang.annotation.Annotation;
import javax.enterprise.context.Dependent;
import javax.enterprise.event.Event;
import org.drools.workbench.screens.guided.dtable.client.editor.clipboard.Clipboard;
import org.drools.workbench.screens.guided.dtable.client.editor.clipboard.impl.DefaultClipboard;
import org.drools.workbench.screens.guided.dtable.client.editor.menu.EditMenuBuilder.SupportsEditMenu;
import org.drools.workbench.screens.guided.dtable.client.editor.menu.InsertMenuBuilder.SupportsAppendRow;
import org.drools.workbench.screens.guided.dtable.client.editor.menu.InsertMenuBuilder.SupportsInsertRowAbove;
import org.drools.workbench.screens.guided.dtable.client.editor.menu.InsertMenuBuilder.SupportsInsertRowBelow;
import org.drools.workbench.screens.guided.dtable.client.editor.menu.ViewMenuBuilder.HasAuditLog;
import org.drools.workbench.screens.guided.dtable.client.editor.menu.ViewMenuBuilder.HasMergedView;
import org.drools.workbench.screens.guided.dtable.client.type.GuidedDTableResourceType;
import org.drools.workbench.screens.guided.dtable.client.widget.analysis.DecisionTableAnalyzerProvider;
import org.drools.workbench.screens.guided.dtable.client.widget.table.GuidedDecisionTablePresenter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.GuidedDecisionTableView.Presenter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.PluginHandler;
import org.drools.workbench.screens.guided.dtable.client.widget.table.events.cdi.DecisionTableColumnSelectedEvent;
import org.drools.workbench.screens.guided.dtable.client.widget.table.events.cdi.DecisionTableSelectedEvent;
import org.drools.workbench.screens.guided.dtable.client.widget.table.events.cdi.DecisionTableSelectionsChangedEvent;
import org.drools.workbench.screens.guided.dtable.client.widget.table.events.cdi.RefreshActionsPanelEvent;
import org.drools.workbench.screens.guided.dtable.client.widget.table.events.cdi.RefreshAttributesPanelEvent;
import org.drools.workbench.screens.guided.dtable.client.widget.table.events.cdi.RefreshConditionsPanelEvent;
import org.drools.workbench.screens.guided.dtable.client.widget.table.events.cdi.RefreshMenusEvent;
import org.drools.workbench.screens.guided.dtable.client.widget.table.events.cdi.RefreshMetaDataPanelEvent;
import org.drools.workbench.screens.guided.dtable.client.widget.table.lockmanager.GuidedDecisionTableLockManager;
import org.drools.workbench.screens.guided.dtable.client.widget.table.lockmanager.GuidedDecisionTableLockManagerImpl;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.cell.GridWidgetCellFactory;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.cell.impl.GridWidgetCellFactoryImpl;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.GridWidgetColumnFactory;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.GridWidgetColumnFactoryImpl;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.ModelSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.ModelSynchronizerImpl;
import org.drools.workbench.screens.guided.dtable.client.widget.table.utilities.EnumLoaderUtilities;
import org.drools.workbench.screens.guided.dtable.service.GuidedDecisionTableLinkManager;
import org.drools.workbench.screens.guided.dtable.shared.DefaultGuidedDecisionTableLinkManager;
import org.jboss.errai.bus.client.api.Subscription;
import org.jboss.errai.common.client.api.Caller;
import org.jboss.errai.enterprise.client.cdi.AbstractCDIEventCallback;
import org.jboss.errai.enterprise.client.cdi.api.CDI;
import org.jboss.errai.ioc.client.container.ContextManager;
import org.jboss.errai.ioc.client.container.Factory;
import org.jboss.errai.ioc.client.container.FactoryHandleImpl;
import org.jboss.errai.ioc.client.container.SyncBeanManager;
import org.jboss.errai.security.shared.api.identity.User;
import org.kie.workbench.common.services.shared.rulename.RuleNamesService;
import org.kie.workbench.common.services.verifier.reporting.client.panel.IssueSelectedEvent;
import org.kie.workbench.common.widgets.client.datamodel.AsyncPackageDataModelOracleFactory;
import org.kie.workbench.common.widgets.client.workitems.IBindingProvider;
import org.kie.workbench.common.widgets.metadata.client.KieDocument;
import org.uberfire.client.mvp.UpdatedLockStatusEvent;
import org.uberfire.ext.wires.core.grids.client.widget.layer.GridSelectionManager;
import org.uberfire.ext.wires.core.grids.client.widget.layer.pinning.GridPinnedModeManager;
import org.uberfire.ext.wires.core.grids.client.widget.layer.pinning.IsPinnedModeAware;
import org.uberfire.rpc.SessionInfo;
import org.uberfire.security.authz.AuthorizationManager;
import org.uberfire.security.impl.authz.DefaultAuthorizationManager;
import org.uberfire.workbench.events.NotificationEvent;

public class Type_factory__o_d_w_s_g_d_c_w_t_GuidedDecisionTablePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDecisionTablePresenter> { public Type_factory__o_d_w_s_g_d_c_w_t_GuidedDecisionTablePresenter__quals__j_e_i_Any_j_e_i_Default() {
    super(new FactoryHandleImpl(GuidedDecisionTablePresenter.class, "Type_factory__o_d_w_s_g_d_c_w_t_GuidedDecisionTablePresenter__quals__j_e_i_Any_j_e_i_Default", Dependent.class, false, null, true));
    handle.setAssignableTypes(new Class[] { GuidedDecisionTablePresenter.class, Object.class, Presenter.class, IBindingProvider.class, GridSelectionManager.class, GridPinnedModeManager.class, IsPinnedModeAware.class, SupportsEditMenu.class, HasMergedView.class, HasAuditLog.class, SupportsAppendRow.class, SupportsInsertRowAbove.class, SupportsInsertRowBelow.class, KieDocument.class });
  }

  public GuidedDecisionTablePresenter createInstance(final ContextManager contextManager) {
    final GuidedDecisionTableLinkManager _linkManager_18 = (DefaultGuidedDecisionTableLinkManager) contextManager.getInstance("Type_factory__o_d_w_s_g_d_s_DefaultGuidedDecisionTableLinkManager__quals__j_e_i_Any_j_e_i_Default");
    final User _identity_0 = (User) contextManager.getInstance("Producer_factory__o_j_e_s_s_a_i_User__quals__j_e_i_Any_j_e_i_Default");
    final Event<NotificationEvent> _notificationEvent_11 = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { NotificationEvent.class }, new Annotation[] { });
    final SyncBeanManager _beanManager_16 = (SyncBeanManager) contextManager.getInstance("Producer_factory__o_j_e_i_c_c_SyncBeanManager__quals__j_e_i_Any_j_e_i_Default");
    final Clipboard _clipboard_19 = (DefaultClipboard) contextManager.getInstance("Type_factory__o_d_w_s_g_d_c_e_c_i_DefaultClipboard__quals__j_e_i_Any_j_e_i_Default");
    final ModelSynchronizer _synchronizer_15 = (ModelSynchronizerImpl) contextManager.getInstance("Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ModelSynchronizerImpl__quals__j_e_i_Any_j_e_i_Default");
    final Event<DecisionTableSelectedEvent> _decisionTableSelectedEvent_3 = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { DecisionTableSelectedEvent.class }, new Annotation[] { });
    final GuidedDTableResourceType _resourceType_1 = (GuidedDTableResourceType) contextManager.getInstance("Type_factory__o_d_w_s_g_d_c_t_GuidedDTableResourceType__quals__j_e_i_Any_j_e_i_Default");
    final Event<RefreshMetaDataPanelEvent> _refreshMetaDataPanelEvent_7 = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { RefreshMetaDataPanelEvent.class }, new Annotation[] { });
    final Event<DecisionTableColumnSelectedEvent> _decisionTableColumnSelectedEvent_4 = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { DecisionTableColumnSelectedEvent.class }, new Annotation[] { });
    final PluginHandler _pluginHandler_22 = (PluginHandler) contextManager.getInstance("Type_factory__o_d_w_s_g_d_c_w_t_PluginHandler__quals__j_e_i_Any_j_e_i_Default");
    final DecisionTableAnalyzerProvider _decisionTableAnalyzerProvider_20 = (DecisionTableAnalyzerProvider) contextManager.getInstance("Type_factory__o_d_w_s_g_d_c_w_a_DecisionTableAnalyzerProvider__quals__j_e_i_Any_j_e_i_Default");
    final Event<RefreshActionsPanelEvent> _refreshActionsPanelEvent_9 = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { RefreshActionsPanelEvent.class }, new Annotation[] { });
    final Event<RefreshMenusEvent> _refreshMenusEvent_10 = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { RefreshMenusEvent.class }, new Annotation[] { });
    final EnumLoaderUtilities _enumLoaderUtilities_21 = (EnumLoaderUtilities) contextManager.getInstance("Type_factory__o_d_w_s_g_d_c_w_t_u_EnumLoaderUtilities__quals__j_e_i_Any_j_e_i_Default");
    final AsyncPackageDataModelOracleFactory _oracleFactory_14 = (AsyncPackageDataModelOracleFactory) contextManager.getInstance("Type_factory__o_k_w_c_w_c_d_AsyncPackageDataModelOracleFactory__quals__j_e_i_Any_j_e_i_Default");
    final GridWidgetCellFactory _gridWidgetCellFactory_12 = (GridWidgetCellFactoryImpl) contextManager.getInstance("Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_GridWidgetCellFactoryImpl__quals__j_e_i_Any_j_e_i_Default");
    final AuthorizationManager _authorizationManager_23 = (DefaultAuthorizationManager) contextManager.getInstance("Type_factory__o_u_s_i_a_DefaultAuthorizationManager__quals__j_e_i_Any_j_e_i_Default");
    final SessionInfo _sessionInfo_24 = (SessionInfo) contextManager.getInstance("Producer_factory__o_u_r_SessionInfo__quals__j_e_i_Any_j_e_i_Default");
    final Event<DecisionTableSelectionsChangedEvent> _decisionTableSelectionsChangedEvent_5 = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { DecisionTableSelectionsChangedEvent.class }, new Annotation[] { });
    final GridWidgetColumnFactory _gridWidgetColumnFactory_13 = (GridWidgetColumnFactoryImpl) contextManager.getInstance("Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_GridWidgetColumnFactoryImpl__quals__j_e_i_Any_j_e_i_Default");
    final Event<RefreshAttributesPanelEvent> _refreshAttributesPanelEvent_6 = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { RefreshAttributesPanelEvent.class }, new Annotation[] { });
    final Caller<RuleNamesService> _ruleNameService_2 = (Caller) contextManager.getContextualInstance("ContextualProvider_factory__o_j_e_c_c_a_Caller__quals__Universal", new Class[] { RuleNamesService.class }, new Annotation[] { });
    final Event<RefreshConditionsPanelEvent> _refreshConditionsPanelEvent_8 = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { RefreshConditionsPanelEvent.class }, new Annotation[] { });
    final GuidedDecisionTableLockManager _lockManager_17 = (GuidedDecisionTableLockManagerImpl) contextManager.getInstance("Type_factory__o_d_w_s_g_d_c_w_t_l_GuidedDecisionTableLockManagerImpl__quals__j_e_i_Any_o_d_w_s_g_d_c_GuidedDecisionTable");
    final GuidedDecisionTablePresenter instance = new GuidedDecisionTablePresenter(_identity_0, _resourceType_1, _ruleNameService_2, _decisionTableSelectedEvent_3, _decisionTableColumnSelectedEvent_4, _decisionTableSelectionsChangedEvent_5, _refreshAttributesPanelEvent_6, _refreshMetaDataPanelEvent_7, _refreshConditionsPanelEvent_8, _refreshActionsPanelEvent_9, _refreshMenusEvent_10, _notificationEvent_11, _gridWidgetCellFactory_12, _gridWidgetColumnFactory_13, _oracleFactory_14, _synchronizer_15, _beanManager_16, _lockManager_17, _linkManager_18, _clipboard_19, _decisionTableAnalyzerProvider_20, _enumLoaderUtilities_21, _pluginHandler_22, _authorizationManager_23, _sessionInfo_24);
    registerDependentScopedReference(instance, _linkManager_18);
    registerDependentScopedReference(instance, _identity_0);
    registerDependentScopedReference(instance, _notificationEvent_11);
    registerDependentScopedReference(instance, _beanManager_16);
    registerDependentScopedReference(instance, _synchronizer_15);
    registerDependentScopedReference(instance, _decisionTableSelectedEvent_3);
    registerDependentScopedReference(instance, _refreshMetaDataPanelEvent_7);
    registerDependentScopedReference(instance, _decisionTableColumnSelectedEvent_4);
    registerDependentScopedReference(instance, _pluginHandler_22);
    registerDependentScopedReference(instance, _decisionTableAnalyzerProvider_20);
    registerDependentScopedReference(instance, _refreshActionsPanelEvent_9);
    registerDependentScopedReference(instance, _refreshMenusEvent_10);
    registerDependentScopedReference(instance, _enumLoaderUtilities_21);
    registerDependentScopedReference(instance, _gridWidgetCellFactory_12);
    registerDependentScopedReference(instance, _decisionTableSelectionsChangedEvent_5);
    registerDependentScopedReference(instance, _gridWidgetColumnFactory_13);
    registerDependentScopedReference(instance, _refreshAttributesPanelEvent_6);
    registerDependentScopedReference(instance, _ruleNameService_2);
    registerDependentScopedReference(instance, _refreshConditionsPanelEvent_8);
    registerDependentScopedReference(instance, _lockManager_17);
    setIncompleteInstance(instance);
    thisInstance.setReference(instance, "onUpdatedLockStatusEventSubscription", CDI.subscribeLocal("org.uberfire.client.mvp.UpdatedLockStatusEvent", new AbstractCDIEventCallback<UpdatedLockStatusEvent>() {
      public void fireEvent(final UpdatedLockStatusEvent event) {
        GuidedDecisionTablePresenter_onUpdatedLockStatusEvent_UpdatedLockStatusEvent(instance, event);
      }
      public String toString() {
        return "Observer: org.uberfire.client.mvp.UpdatedLockStatusEvent []";
      }
    }));
    thisInstance.setReference(instance, "onIssueSelectedEventSubscription", CDI.subscribeLocal("org.kie.workbench.common.services.verifier.reporting.client.panel.IssueSelectedEvent", new AbstractCDIEventCallback<IssueSelectedEvent>() {
      public void fireEvent(final IssueSelectedEvent event) {
        GuidedDecisionTablePresenter_onIssueSelectedEvent_IssueSelectedEvent(instance, event);
      }
      public String toString() {
        return "Observer: org.kie.workbench.common.services.verifier.reporting.client.panel.IssueSelectedEvent []";
      }
    }));
    setIncompleteInstance(null);
    return instance;
  }

  public void generatedDestroyInstance(final Object instance, final ContextManager contextManager) {
    destroyInstanceHelper((GuidedDecisionTablePresenter) instance, contextManager);
  }

  public void destroyInstanceHelper(final GuidedDecisionTablePresenter instance, final ContextManager contextManager) {
    ((Subscription) thisInstance.getReferenceAs(instance, "onUpdatedLockStatusEventSubscription", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onIssueSelectedEventSubscription", Subscription.class)).remove();
  }

  public native static void GuidedDecisionTablePresenter_onIssueSelectedEvent_IssueSelectedEvent(GuidedDecisionTablePresenter instance, IssueSelectedEvent a0) /*-{
    instance.@org.drools.workbench.screens.guided.dtable.client.widget.table.GuidedDecisionTablePresenter::onIssueSelectedEvent(Lorg/kie/workbench/common/services/verifier/reporting/client/panel/IssueSelectedEvent;)(a0);
  }-*/;

  public native static void GuidedDecisionTablePresenter_onUpdatedLockStatusEvent_UpdatedLockStatusEvent(GuidedDecisionTablePresenter instance, UpdatedLockStatusEvent a0) /*-{
    instance.@org.drools.workbench.screens.guided.dtable.client.widget.table.GuidedDecisionTablePresenter::onUpdatedLockStatusEvent(Lorg/uberfire/client/mvp/UpdatedLockStatusEvent;)(a0);
  }-*/;
}