package org.jboss.errai.ioc.client;

import java.lang.annotation.Annotation;
import javax.enterprise.context.Dependent;
import javax.enterprise.event.Event;
import org.drools.workbench.models.datamodel.rule.RuleModel;
import org.drools.workbench.screens.guided.rule.client.editor.GuidedRuleEditorPresenter;
import org.drools.workbench.screens.guided.rule.client.editor.GuidedRuleEditorView;
import org.drools.workbench.screens.guided.rule.client.editor.GuidedRuleEditorViewImpl;
import org.drools.workbench.screens.guided.rule.client.editor.plugin.RuleModellerActionPlugin;
import org.drools.workbench.screens.guided.rule.client.type.GuidedRuleDRLResourceType;
import org.drools.workbench.screens.guided.rule.client.type.GuidedRuleDSLRResourceType;
import org.drools.workbench.screens.guided.rule.service.GuidedRuleEditorService;
import org.guvnor.common.services.project.client.context.WorkspaceProjectContext;
import org.guvnor.common.services.project.client.security.ProjectController;
import org.guvnor.common.services.shared.metadata.model.Metadata;
import org.guvnor.messageconsole.client.console.widget.button.AlertsButtonMenuItemBuilder;
import org.guvnor.structure.repositories.RepositoryRemovedEvent;
import org.jboss.errai.bus.client.ErraiBus;
import org.jboss.errai.bus.client.api.Subscription;
import org.jboss.errai.common.client.api.Caller;
import org.jboss.errai.enterprise.client.cdi.AbstractCDIEventCallback;
import org.jboss.errai.enterprise.client.cdi.api.CDI;
import org.jboss.errai.ioc.client.api.ManagedInstance;
import org.jboss.errai.ioc.client.container.ContextManager;
import org.jboss.errai.ioc.client.container.Factory;
import org.jboss.errai.ioc.client.container.FactoryHandleImpl;
import org.kie.workbench.common.services.shared.rulename.RuleNamesService;
import org.kie.workbench.common.widgets.client.datamodel.AsyncPackageDataModelOracleFactory;
import org.kie.workbench.common.widgets.client.datamodel.ImportAddedEvent;
import org.kie.workbench.common.widgets.client.datamodel.ImportRemovedEvent;
import org.kie.workbench.common.widgets.client.menu.FileMenuBuilder;
import org.kie.workbench.common.widgets.client.menu.FileMenuBuilderImpl;
import org.kie.workbench.common.widgets.client.popups.validation.ValidationPopup;
import org.kie.workbench.common.widgets.client.source.ViewSourceView;
import org.kie.workbench.common.widgets.client.source.ViewSourceViewImpl;
import org.kie.workbench.common.widgets.configresource.client.widget.bound.ImportsWidgetPresenter;
import org.kie.workbench.common.widgets.metadata.client.KieEditor;
import org.kie.workbench.common.widgets.metadata.client.KieEditorWrapperView;
import org.kie.workbench.common.widgets.metadata.client.KieEditorWrapperView.KieEditorWrapperPresenter;
import org.kie.workbench.common.widgets.metadata.client.KieEditorWrapperViewImpl;
import org.kie.workbench.common.widgets.metadata.client.validation.AssetUpdateValidator;
import org.kie.workbench.common.widgets.metadata.client.widget.OverviewWidgetPresenter;
import org.uberfire.client.mvp.PlaceManager;
import org.uberfire.client.mvp.PlaceManagerImpl;
import org.uberfire.client.workbench.events.ChangeTitleWidgetEvent;
import org.uberfire.ext.editor.commons.client.BaseEditor;
import org.uberfire.ext.editor.commons.client.event.ConcurrentDeleteAcceptedEvent;
import org.uberfire.ext.editor.commons.client.event.ConcurrentDeleteIgnoredEvent;
import org.uberfire.ext.editor.commons.client.event.ConcurrentRenameAcceptedEvent;
import org.uberfire.ext.editor.commons.client.event.ConcurrentRenameIgnoredEvent;
import org.uberfire.ext.editor.commons.client.file.popups.CopyPopUpPresenter;
import org.uberfire.ext.editor.commons.client.file.popups.DeletePopUpPresenter;
import org.uberfire.ext.editor.commons.client.file.popups.RenamePopUpPresenter;
import org.uberfire.ext.editor.commons.client.file.popups.SavePopUpPresenter;
import org.uberfire.ext.editor.commons.client.history.VersionRecordManager;
import org.uberfire.ext.editor.commons.client.menu.BasicFileMenuBuilder;
import org.uberfire.ext.editor.commons.client.menu.BasicFileMenuBuilderImpl;
import org.uberfire.ext.editor.commons.client.menu.DownloadMenuItem;
import org.uberfire.ext.editor.commons.client.menu.common.SaveAndRenameCommandBuilder;
import org.uberfire.ext.editor.commons.client.validation.DefaultFileNameValidator;
import org.uberfire.ext.editor.commons.version.events.RestoreEvent;
import org.uberfire.workbench.events.NotificationEvent;

public class Type_factory__o_d_w_s_g_r_c_e_GuidedRuleEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedRuleEditorPresenter> { public Type_factory__o_d_w_s_g_r_c_e_GuidedRuleEditorPresenter__quals__j_e_i_Any_j_e_i_Default() {
    super(new FactoryHandleImpl(GuidedRuleEditorPresenter.class, "Type_factory__o_d_w_s_g_r_c_e_GuidedRuleEditorPresenter__quals__j_e_i_Any_j_e_i_Default", Dependent.class, false, null, true));
    handle.setAssignableTypes(new Class[] { GuidedRuleEditorPresenter.class, KieEditor.class, BaseEditor.class, Object.class, KieEditorWrapperPresenter.class });
  }

  public GuidedRuleEditorPresenter createInstance(final ContextManager contextManager) {
    final GuidedRuleEditorView _view_0 = (GuidedRuleEditorViewImpl) contextManager.getInstance("Type_factory__o_d_w_s_g_r_c_e_GuidedRuleEditorViewImpl__quals__j_e_i_Any_j_e_i_Default");
    final GuidedRuleEditorPresenter instance = new GuidedRuleEditorPresenter(_view_0);
    registerDependentScopedReference(instance, _view_0);
    setIncompleteInstance(instance);
    final OverviewWidgetPresenter KieEditor_overviewWidget = (OverviewWidgetPresenter) contextManager.getInstance("Type_factory__o_k_w_c_w_m_c_w_OverviewWidgetPresenter__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, KieEditor_overviewWidget);
    KieEditor_OverviewWidgetPresenter_overviewWidget(instance, KieEditor_overviewWidget);
    final DefaultFileNameValidator BaseEditor_fileNameValidator = (DefaultFileNameValidator) contextManager.getInstance("Type_factory__o_u_e_e_c_c_v_DefaultFileNameValidator__quals__j_e_i_Any_j_e_i_Default");
    BaseEditor_DefaultFileNameValidator_fileNameValidator(instance, BaseEditor_fileNameValidator);
    final PlaceManagerImpl BaseEditor_placeManager = (PlaceManagerImpl) contextManager.getInstance("Type_factory__o_u_c_m_PlaceManagerImpl__quals__j_e_i_Any_j_e_i_Default");
    BaseEditor_PlaceManager_placeManager(instance, BaseEditor_placeManager);
    final Event BaseEditor_concurrentDeleteAcceptedEvent = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { ConcurrentDeleteAcceptedEvent.class }, new Annotation[] { });
    registerDependentScopedReference(instance, BaseEditor_concurrentDeleteAcceptedEvent);
    BaseEditor_Event_concurrentDeleteAcceptedEvent(instance, BaseEditor_concurrentDeleteAcceptedEvent);
    final Caller GuidedRuleEditorPresenter_service = (Caller) contextManager.getContextualInstance("ContextualProvider_factory__o_j_e_c_c_a_Caller__quals__Universal", new Class[] { GuidedRuleEditorService.class }, new Annotation[] { });
    registerDependentScopedReference(instance, GuidedRuleEditorPresenter_service);
    GuidedRuleEditorPresenter_Caller_service(instance, GuidedRuleEditorPresenter_service);
    final ProjectController KieEditor_projectController = (ProjectController) contextManager.getInstance("Type_factory__o_g_c_s_p_c_s_ProjectController__quals__j_e_i_Any_j_e_i_Default");
    KieEditor_ProjectController_projectController(instance, KieEditor_projectController);
    final ViewSourceViewImpl GuidedRuleEditorPresenter_viewSource = (ViewSourceViewImpl) contextManager.getInstance("Type_factory__o_k_w_c_w_c_s_ViewSourceViewImpl__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, GuidedRuleEditorPresenter_viewSource);
    GuidedRuleEditorPresenter_ViewSourceView_viewSource(instance, GuidedRuleEditorPresenter_viewSource);
    final DownloadMenuItem BaseEditor_downloadMenuItem = (DownloadMenuItem) contextManager.getInstance("Type_factory__o_u_e_e_c_c_m_DownloadMenuItem__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, BaseEditor_downloadMenuItem);
    BaseEditor_DownloadMenuItem_downloadMenuItem(instance, BaseEditor_downloadMenuItem);
    final ManagedInstance BaseEditor_menuBuilderManagedInstance = (ManagedInstance) contextManager.getContextualInstance("ContextualProvider_factory__o_j_e_i_c_a_ManagedInstance__quals__Universal", new Class[] { BasicFileMenuBuilder.class }, new Annotation[] { });
    registerDependentScopedReference(instance, BaseEditor_menuBuilderManagedInstance);
    BaseEditor_ManagedInstance_menuBuilderManagedInstance(instance, BaseEditor_menuBuilderManagedInstance);
    final AlertsButtonMenuItemBuilder KieEditor_alertsButtonMenuItemBuilder = (AlertsButtonMenuItemBuilder) contextManager.getInstance("Type_factory__o_g_m_c_c_w_b_AlertsButtonMenuItemBuilder__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, KieEditor_alertsButtonMenuItemBuilder);
    KieEditor_AlertsButtonMenuItemBuilder_alertsButtonMenuItemBuilder(instance, KieEditor_alertsButtonMenuItemBuilder);
    final ManagedInstance GuidedRuleEditorPresenter_actionPluginInstance = (ManagedInstance) contextManager.getContextualInstance("ContextualProvider_factory__o_j_e_i_c_a_ManagedInstance__quals__Universal", new Class[] { RuleModellerActionPlugin.class }, new Annotation[] { });
    registerDependentScopedReference(instance, GuidedRuleEditorPresenter_actionPluginInstance);
    GuidedRuleEditorPresenter_ManagedInstance_actionPluginInstance(instance, GuidedRuleEditorPresenter_actionPluginInstance);
    final KieEditorWrapperViewImpl KieEditor_kieView = (KieEditorWrapperViewImpl) contextManager.getInstance("Type_factory__o_k_w_c_w_m_c_KieEditorWrapperViewImpl__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, KieEditor_kieView);
    KieEditor_KieEditorWrapperView_kieView(instance, KieEditor_kieView);
    final DeletePopUpPresenter KieEditor_deletePopUpPresenter = (DeletePopUpPresenter) contextManager.getInstance("Type_factory__o_u_e_e_c_c_f_p_DeletePopUpPresenter__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, KieEditor_deletePopUpPresenter);
    KieEditor_DeletePopUpPresenter_deletePopUpPresenter(instance, KieEditor_deletePopUpPresenter);
    final ImportsWidgetPresenter GuidedRuleEditorPresenter_importsWidget = (ImportsWidgetPresenter) contextManager.getInstance("Type_factory__o_k_w_c_w_c_c_w_b_ImportsWidgetPresenter__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, GuidedRuleEditorPresenter_importsWidget);
    GuidedRuleEditorPresenter_ImportsWidgetPresenter_importsWidget(instance, GuidedRuleEditorPresenter_importsWidget);
    final Event BaseEditor_changeTitleNotification = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { ChangeTitleWidgetEvent.class }, new Annotation[] { });
    registerDependentScopedReference(instance, BaseEditor_changeTitleNotification);
    BaseEditor_Event_changeTitleNotification(instance, BaseEditor_changeTitleNotification);
    final SaveAndRenameCommandBuilder BaseEditor_saveAndRenameCommandBuilder = (SaveAndRenameCommandBuilder) contextManager.getInstance("Type_factory__o_u_e_e_c_c_m_c_SaveAndRenameCommandBuilder__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, BaseEditor_saveAndRenameCommandBuilder);
    BaseEditor_SaveAndRenameCommandBuilder_saveAndRenameCommandBuilder(instance, BaseEditor_saveAndRenameCommandBuilder);
    final Event BaseEditor_concurrentRenameAcceptedEvent = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { ConcurrentRenameAcceptedEvent.class }, new Annotation[] { });
    registerDependentScopedReference(instance, BaseEditor_concurrentRenameAcceptedEvent);
    BaseEditor_Event_concurrentRenameAcceptedEvent(instance, BaseEditor_concurrentRenameAcceptedEvent);
    final AssetUpdateValidator KieEditor_assetUpdateValidator = (AssetUpdateValidator) contextManager.getInstance("Type_factory__o_k_w_c_w_m_c_v_AssetUpdateValidator__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, KieEditor_assetUpdateValidator);
    KieEditor_AssetUpdateValidator_assetUpdateValidator(instance, KieEditor_assetUpdateValidator);
    final WorkspaceProjectContext KieEditor_workbenchContext = (WorkspaceProjectContext) contextManager.getInstance("Type_factory__o_g_c_s_p_c_c_WorkspaceProjectContext__quals__j_e_i_Any_j_e_i_Default");
    KieEditor_WorkspaceProjectContext_workbenchContext(instance, KieEditor_workbenchContext);
    final CopyPopUpPresenter KieEditor_copyPopUpPresenter = (CopyPopUpPresenter) contextManager.getInstance("Type_factory__o_u_e_e_c_c_f_p_CopyPopUpPresenter__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, KieEditor_copyPopUpPresenter);
    KieEditor_CopyPopUpPresenter_copyPopUpPresenter(instance, KieEditor_copyPopUpPresenter);
    final Event BaseEditor_notification = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { NotificationEvent.class }, new Annotation[] { });
    registerDependentScopedReference(instance, BaseEditor_notification);
    BaseEditor_Event_notification(instance, BaseEditor_notification);
    final AsyncPackageDataModelOracleFactory GuidedRuleEditorPresenter_oracleFactory = (AsyncPackageDataModelOracleFactory) contextManager.getInstance("Type_factory__o_k_w_c_w_c_d_AsyncPackageDataModelOracleFactory__quals__j_e_i_Any_j_e_i_Default");
    GuidedRuleEditorPresenter_AsyncPackageDataModelOracleFactory_oracleFactory(instance, GuidedRuleEditorPresenter_oracleFactory);
    final FileMenuBuilderImpl KieEditor_fileMenuBuilder = (FileMenuBuilderImpl) contextManager.getInstance("Type_factory__o_k_w_c_w_c_m_FileMenuBuilderImpl__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, KieEditor_fileMenuBuilder);
    KieEditor_FileMenuBuilder_fileMenuBuilder(instance, KieEditor_fileMenuBuilder);
    final RenamePopUpPresenter KieEditor_renamePopUpPresenter = (RenamePopUpPresenter) contextManager.getInstance("Type_factory__o_u_e_e_c_c_f_p_RenamePopUpPresenter__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, KieEditor_renamePopUpPresenter);
    KieEditor_RenamePopUpPresenter_renamePopUpPresenter(instance, KieEditor_renamePopUpPresenter);
    final Event BaseEditor_concurrentDeleteIgnoredEvent = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { ConcurrentDeleteIgnoredEvent.class }, new Annotation[] { });
    registerDependentScopedReference(instance, BaseEditor_concurrentDeleteIgnoredEvent);
    BaseEditor_Event_concurrentDeleteIgnoredEvent(instance, BaseEditor_concurrentDeleteIgnoredEvent);
    final GuidedRuleDSLRResourceType GuidedRuleEditorPresenter_resourceTypeDSL = (GuidedRuleDSLRResourceType) contextManager.getInstance("Type_factory__o_d_w_s_g_r_c_t_GuidedRuleDSLRResourceType__quals__j_e_i_Any_j_e_i_Default");
    GuidedRuleEditorPresenter_GuidedRuleDSLRResourceType_resourceTypeDSL(instance, GuidedRuleEditorPresenter_resourceTypeDSL);
    final Event BaseEditor_concurrentRenameIgnoredEvent = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { ConcurrentRenameIgnoredEvent.class }, new Annotation[] { });
    registerDependentScopedReference(instance, BaseEditor_concurrentRenameIgnoredEvent);
    BaseEditor_Event_concurrentRenameIgnoredEvent(instance, BaseEditor_concurrentRenameIgnoredEvent);
    final Caller GuidedRuleEditorPresenter_ruleNamesService = (Caller) contextManager.getContextualInstance("ContextualProvider_factory__o_j_e_c_c_a_Caller__quals__Universal", new Class[] { RuleNamesService.class }, new Annotation[] { });
    registerDependentScopedReference(instance, GuidedRuleEditorPresenter_ruleNamesService);
    GuidedRuleEditorPresenter_Caller_ruleNamesService(instance, GuidedRuleEditorPresenter_ruleNamesService);
    final GuidedRuleDRLResourceType GuidedRuleEditorPresenter_resourceTypeDRL = (GuidedRuleDRLResourceType) contextManager.getInstance("Type_factory__o_d_w_s_g_r_c_t_GuidedRuleDRLResourceType__quals__j_e_i_Any_j_e_i_Default");
    GuidedRuleEditorPresenter_GuidedRuleDRLResourceType_resourceTypeDRL(instance, GuidedRuleEditorPresenter_resourceTypeDRL);
    final VersionRecordManager BaseEditor_versionRecordManager = (VersionRecordManager) contextManager.getInstance("Type_factory__o_u_e_e_c_c_h_VersionRecordManager__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, BaseEditor_versionRecordManager);
    BaseEditor_VersionRecordManager_versionRecordManager(instance, BaseEditor_versionRecordManager);
    final SavePopUpPresenter KieEditor_savePopUpPresenter = (SavePopUpPresenter) contextManager.getInstance("Type_factory__o_u_e_e_c_c_f_p_SavePopUpPresenter__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, KieEditor_savePopUpPresenter);
    KieEditor_SavePopUpPresenter_savePopUpPresenter(instance, KieEditor_savePopUpPresenter);
    final BasicFileMenuBuilderImpl BaseEditor_menuBuilder = (BasicFileMenuBuilderImpl) contextManager.getInstance("Type_factory__o_u_e_e_c_c_m_BasicFileMenuBuilderImpl__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, BaseEditor_menuBuilder);
    BaseEditor_BasicFileMenuBuilder_menuBuilder(instance, BaseEditor_menuBuilder);
    final ValidationPopup GuidedRuleEditorPresenter_validationPopup = (ValidationPopup) contextManager.getInstance("Type_factory__o_k_w_c_w_c_p_v_ValidationPopup__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, GuidedRuleEditorPresenter_validationPopup);
    GuidedRuleEditorPresenter_ValidationPopup_validationPopup(instance, GuidedRuleEditorPresenter_validationPopup);
    thisInstance.setReference(instance, "handleImportAddedEventSubscription", CDI.subscribeLocal("org.kie.workbench.common.widgets.client.datamodel.ImportAddedEvent", new AbstractCDIEventCallback<ImportAddedEvent>() {
      public void fireEvent(final ImportAddedEvent event) {
        instance.handleImportAddedEvent(event);
      }
      public String toString() {
        return "Observer: org.kie.workbench.common.widgets.client.datamodel.ImportAddedEvent []";
      }
    }));
    thisInstance.setReference(instance, "handleImportRemovedEventSubscription", CDI.subscribeLocal("org.kie.workbench.common.widgets.client.datamodel.ImportRemovedEvent", new AbstractCDIEventCallback<ImportRemovedEvent>() {
      public void fireEvent(final ImportRemovedEvent event) {
        instance.handleImportRemovedEvent(event);
      }
      public String toString() {
        return "Observer: org.kie.workbench.common.widgets.client.datamodel.ImportRemovedEvent []";
      }
    }));
    thisInstance.setReference(instance, "onRepositoryRemovedSubscription", CDI.subscribe("org.guvnor.structure.repositories.RepositoryRemovedEvent", new AbstractCDIEventCallback<RepositoryRemovedEvent>() {
      public void fireEvent(final RepositoryRemovedEvent event) {
        instance.onRepositoryRemoved(event);
      }
      public String toString() {
        return "Observer: org.guvnor.structure.repositories.RepositoryRemovedEvent []";
      }
    }));
    thisInstance.setReference(instance, "onRepositoryRemovedSubscriptionForRepositoryRemovedEvent", ErraiBus.get().subscribe("cdi.event:org.guvnor.structure.repositories.RepositoryRemovedEvent", CDI.ROUTING_CALLBACK));
    thisInstance.setReference(instance, "onRestoreSubscription", CDI.subscribeLocal("org.uberfire.ext.editor.commons.version.events.RestoreEvent", new AbstractCDIEventCallback<RestoreEvent>() {
      public void fireEvent(final RestoreEvent event) {
        instance.onRestore(event);
      }
      public String toString() {
        return "Observer: org.uberfire.ext.editor.commons.version.events.RestoreEvent []";
      }
    }));
    setIncompleteInstance(null);
    return instance;
  }

  public void generatedDestroyInstance(final Object instance, final ContextManager contextManager) {
    destroyInstanceHelper((GuidedRuleEditorPresenter) instance, contextManager);
  }

  public void destroyInstanceHelper(final GuidedRuleEditorPresenter instance, final ContextManager contextManager) {
    ((Subscription) thisInstance.getReferenceAs(instance, "handleImportAddedEventSubscription", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "handleImportRemovedEventSubscription", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onRepositoryRemovedSubscription", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onRepositoryRemovedSubscriptionForRepositoryRemovedEvent", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onRestoreSubscription", Subscription.class)).remove();
  }

  native static WorkspaceProjectContext KieEditor_WorkspaceProjectContext_workbenchContext(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::workbenchContext;
  }-*/;

  native static void KieEditor_WorkspaceProjectContext_workbenchContext(KieEditor instance, WorkspaceProjectContext value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::workbenchContext = value;
  }-*/;

  native static PlaceManager BaseEditor_PlaceManager_placeManager(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::placeManager;
  }-*/;

  native static void BaseEditor_PlaceManager_placeManager(BaseEditor instance, PlaceManager value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::placeManager = value;
  }-*/;

  native static ViewSourceView GuidedRuleEditorPresenter_ViewSourceView_viewSource(GuidedRuleEditorPresenter instance) /*-{
    return instance.@org.drools.workbench.screens.guided.rule.client.editor.GuidedRuleEditorPresenter::viewSource;
  }-*/;

  native static void GuidedRuleEditorPresenter_ViewSourceView_viewSource(GuidedRuleEditorPresenter instance, ViewSourceView value) /*-{
    instance.@org.drools.workbench.screens.guided.rule.client.editor.GuidedRuleEditorPresenter::viewSource = value;
  }-*/;

  native static RenamePopUpPresenter KieEditor_RenamePopUpPresenter_renamePopUpPresenter(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::renamePopUpPresenter;
  }-*/;

  native static void KieEditor_RenamePopUpPresenter_renamePopUpPresenter(KieEditor instance, RenamePopUpPresenter value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::renamePopUpPresenter = value;
  }-*/;

  native static AsyncPackageDataModelOracleFactory GuidedRuleEditorPresenter_AsyncPackageDataModelOracleFactory_oracleFactory(GuidedRuleEditorPresenter instance) /*-{
    return instance.@org.drools.workbench.screens.guided.rule.client.editor.GuidedRuleEditorPresenter::oracleFactory;
  }-*/;

  native static void GuidedRuleEditorPresenter_AsyncPackageDataModelOracleFactory_oracleFactory(GuidedRuleEditorPresenter instance, AsyncPackageDataModelOracleFactory value) /*-{
    instance.@org.drools.workbench.screens.guided.rule.client.editor.GuidedRuleEditorPresenter::oracleFactory = value;
  }-*/;

  native static ManagedInstance BaseEditor_ManagedInstance_menuBuilderManagedInstance(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::menuBuilderManagedInstance;
  }-*/;

  native static void BaseEditor_ManagedInstance_menuBuilderManagedInstance(BaseEditor instance, ManagedInstance<BasicFileMenuBuilder> value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::menuBuilderManagedInstance = value;
  }-*/;

  native static ManagedInstance GuidedRuleEditorPresenter_ManagedInstance_actionPluginInstance(GuidedRuleEditorPresenter instance) /*-{
    return instance.@org.drools.workbench.screens.guided.rule.client.editor.GuidedRuleEditorPresenter::actionPluginInstance;
  }-*/;

  native static void GuidedRuleEditorPresenter_ManagedInstance_actionPluginInstance(GuidedRuleEditorPresenter instance, ManagedInstance<RuleModellerActionPlugin> value) /*-{
    instance.@org.drools.workbench.screens.guided.rule.client.editor.GuidedRuleEditorPresenter::actionPluginInstance = value;
  }-*/;

  native static Event BaseEditor_Event_concurrentRenameIgnoredEvent(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::concurrentRenameIgnoredEvent;
  }-*/;

  native static void BaseEditor_Event_concurrentRenameIgnoredEvent(BaseEditor instance, Event<ConcurrentRenameIgnoredEvent> value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::concurrentRenameIgnoredEvent = value;
  }-*/;

  native static DefaultFileNameValidator BaseEditor_DefaultFileNameValidator_fileNameValidator(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::fileNameValidator;
  }-*/;

  native static void BaseEditor_DefaultFileNameValidator_fileNameValidator(BaseEditor instance, DefaultFileNameValidator value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::fileNameValidator = value;
  }-*/;

  native static GuidedRuleDRLResourceType GuidedRuleEditorPresenter_GuidedRuleDRLResourceType_resourceTypeDRL(GuidedRuleEditorPresenter instance) /*-{
    return instance.@org.drools.workbench.screens.guided.rule.client.editor.GuidedRuleEditorPresenter::resourceTypeDRL;
  }-*/;

  native static void GuidedRuleEditorPresenter_GuidedRuleDRLResourceType_resourceTypeDRL(GuidedRuleEditorPresenter instance, GuidedRuleDRLResourceType value) /*-{
    instance.@org.drools.workbench.screens.guided.rule.client.editor.GuidedRuleEditorPresenter::resourceTypeDRL = value;
  }-*/;

  native static SavePopUpPresenter KieEditor_SavePopUpPresenter_savePopUpPresenter(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::savePopUpPresenter;
  }-*/;

  native static void KieEditor_SavePopUpPresenter_savePopUpPresenter(KieEditor instance, SavePopUpPresenter value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::savePopUpPresenter = value;
  }-*/;

  native static Event BaseEditor_Event_changeTitleNotification(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::changeTitleNotification;
  }-*/;

  native static void BaseEditor_Event_changeTitleNotification(BaseEditor instance, Event<ChangeTitleWidgetEvent> value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::changeTitleNotification = value;
  }-*/;

  native static Event BaseEditor_Event_concurrentDeleteAcceptedEvent(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::concurrentDeleteAcceptedEvent;
  }-*/;

  native static void BaseEditor_Event_concurrentDeleteAcceptedEvent(BaseEditor instance, Event<ConcurrentDeleteAcceptedEvent> value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::concurrentDeleteAcceptedEvent = value;
  }-*/;

  native static ProjectController KieEditor_ProjectController_projectController(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::projectController;
  }-*/;

  native static void KieEditor_ProjectController_projectController(KieEditor instance, ProjectController value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::projectController = value;
  }-*/;

  native static Event BaseEditor_Event_notification(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::notification;
  }-*/;

  native static void BaseEditor_Event_notification(BaseEditor instance, Event<NotificationEvent> value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::notification = value;
  }-*/;

  native static Event BaseEditor_Event_concurrentDeleteIgnoredEvent(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::concurrentDeleteIgnoredEvent;
  }-*/;

  native static void BaseEditor_Event_concurrentDeleteIgnoredEvent(BaseEditor instance, Event<ConcurrentDeleteIgnoredEvent> value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::concurrentDeleteIgnoredEvent = value;
  }-*/;

  native static SaveAndRenameCommandBuilder BaseEditor_SaveAndRenameCommandBuilder_saveAndRenameCommandBuilder(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::saveAndRenameCommandBuilder;
  }-*/;

  native static void BaseEditor_SaveAndRenameCommandBuilder_saveAndRenameCommandBuilder(BaseEditor instance, SaveAndRenameCommandBuilder<RuleModel, Metadata> value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::saveAndRenameCommandBuilder = value;
  }-*/;

  native static BasicFileMenuBuilder BaseEditor_BasicFileMenuBuilder_menuBuilder(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::menuBuilder;
  }-*/;

  native static void BaseEditor_BasicFileMenuBuilder_menuBuilder(BaseEditor instance, BasicFileMenuBuilder value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::menuBuilder = value;
  }-*/;

  native static AssetUpdateValidator KieEditor_AssetUpdateValidator_assetUpdateValidator(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::assetUpdateValidator;
  }-*/;

  native static void KieEditor_AssetUpdateValidator_assetUpdateValidator(KieEditor instance, AssetUpdateValidator value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::assetUpdateValidator = value;
  }-*/;

  native static DownloadMenuItem BaseEditor_DownloadMenuItem_downloadMenuItem(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::downloadMenuItem;
  }-*/;

  native static void BaseEditor_DownloadMenuItem_downloadMenuItem(BaseEditor instance, DownloadMenuItem value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::downloadMenuItem = value;
  }-*/;

  native static AlertsButtonMenuItemBuilder KieEditor_AlertsButtonMenuItemBuilder_alertsButtonMenuItemBuilder(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::alertsButtonMenuItemBuilder;
  }-*/;

  native static void KieEditor_AlertsButtonMenuItemBuilder_alertsButtonMenuItemBuilder(KieEditor instance, AlertsButtonMenuItemBuilder value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::alertsButtonMenuItemBuilder = value;
  }-*/;

  native static ImportsWidgetPresenter GuidedRuleEditorPresenter_ImportsWidgetPresenter_importsWidget(GuidedRuleEditorPresenter instance) /*-{
    return instance.@org.drools.workbench.screens.guided.rule.client.editor.GuidedRuleEditorPresenter::importsWidget;
  }-*/;

  native static void GuidedRuleEditorPresenter_ImportsWidgetPresenter_importsWidget(GuidedRuleEditorPresenter instance, ImportsWidgetPresenter value) /*-{
    instance.@org.drools.workbench.screens.guided.rule.client.editor.GuidedRuleEditorPresenter::importsWidget = value;
  }-*/;

  native static ValidationPopup GuidedRuleEditorPresenter_ValidationPopup_validationPopup(GuidedRuleEditorPresenter instance) /*-{
    return instance.@org.drools.workbench.screens.guided.rule.client.editor.GuidedRuleEditorPresenter::validationPopup;
  }-*/;

  native static void GuidedRuleEditorPresenter_ValidationPopup_validationPopup(GuidedRuleEditorPresenter instance, ValidationPopup value) /*-{
    instance.@org.drools.workbench.screens.guided.rule.client.editor.GuidedRuleEditorPresenter::validationPopup = value;
  }-*/;

  native static OverviewWidgetPresenter KieEditor_OverviewWidgetPresenter_overviewWidget(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::overviewWidget;
  }-*/;

  native static void KieEditor_OverviewWidgetPresenter_overviewWidget(KieEditor instance, OverviewWidgetPresenter value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::overviewWidget = value;
  }-*/;

  native static CopyPopUpPresenter KieEditor_CopyPopUpPresenter_copyPopUpPresenter(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::copyPopUpPresenter;
  }-*/;

  native static void KieEditor_CopyPopUpPresenter_copyPopUpPresenter(KieEditor instance, CopyPopUpPresenter value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::copyPopUpPresenter = value;
  }-*/;

  native static Caller GuidedRuleEditorPresenter_Caller_ruleNamesService(GuidedRuleEditorPresenter instance) /*-{
    return instance.@org.drools.workbench.screens.guided.rule.client.editor.GuidedRuleEditorPresenter::ruleNamesService;
  }-*/;

  native static void GuidedRuleEditorPresenter_Caller_ruleNamesService(GuidedRuleEditorPresenter instance, Caller<RuleNamesService> value) /*-{
    instance.@org.drools.workbench.screens.guided.rule.client.editor.GuidedRuleEditorPresenter::ruleNamesService = value;
  }-*/;

  native static Caller GuidedRuleEditorPresenter_Caller_service(GuidedRuleEditorPresenter instance) /*-{
    return instance.@org.drools.workbench.screens.guided.rule.client.editor.GuidedRuleEditorPresenter::service;
  }-*/;

  native static void GuidedRuleEditorPresenter_Caller_service(GuidedRuleEditorPresenter instance, Caller<GuidedRuleEditorService> value) /*-{
    instance.@org.drools.workbench.screens.guided.rule.client.editor.GuidedRuleEditorPresenter::service = value;
  }-*/;

  native static KieEditorWrapperView KieEditor_KieEditorWrapperView_kieView(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::kieView;
  }-*/;

  native static void KieEditor_KieEditorWrapperView_kieView(KieEditor instance, KieEditorWrapperView value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::kieView = value;
  }-*/;

  native static VersionRecordManager BaseEditor_VersionRecordManager_versionRecordManager(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::versionRecordManager;
  }-*/;

  native static void BaseEditor_VersionRecordManager_versionRecordManager(BaseEditor instance, VersionRecordManager value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::versionRecordManager = value;
  }-*/;

  native static DeletePopUpPresenter KieEditor_DeletePopUpPresenter_deletePopUpPresenter(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::deletePopUpPresenter;
  }-*/;

  native static void KieEditor_DeletePopUpPresenter_deletePopUpPresenter(KieEditor instance, DeletePopUpPresenter value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::deletePopUpPresenter = value;
  }-*/;

  native static FileMenuBuilder KieEditor_FileMenuBuilder_fileMenuBuilder(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::fileMenuBuilder;
  }-*/;

  native static void KieEditor_FileMenuBuilder_fileMenuBuilder(KieEditor instance, FileMenuBuilder value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::fileMenuBuilder = value;
  }-*/;

  native static Event BaseEditor_Event_concurrentRenameAcceptedEvent(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::concurrentRenameAcceptedEvent;
  }-*/;

  native static void BaseEditor_Event_concurrentRenameAcceptedEvent(BaseEditor instance, Event<ConcurrentRenameAcceptedEvent> value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::concurrentRenameAcceptedEvent = value;
  }-*/;

  native static GuidedRuleDSLRResourceType GuidedRuleEditorPresenter_GuidedRuleDSLRResourceType_resourceTypeDSL(GuidedRuleEditorPresenter instance) /*-{
    return instance.@org.drools.workbench.screens.guided.rule.client.editor.GuidedRuleEditorPresenter::resourceTypeDSL;
  }-*/;

  native static void GuidedRuleEditorPresenter_GuidedRuleDSLRResourceType_resourceTypeDSL(GuidedRuleEditorPresenter instance, GuidedRuleDSLRResourceType value) /*-{
    instance.@org.drools.workbench.screens.guided.rule.client.editor.GuidedRuleEditorPresenter::resourceTypeDSL = value;
  }-*/;
}