package org.jboss.errai.ioc.client;

import java.lang.annotation.Annotation;
import javax.enterprise.context.Dependent;
import javax.enterprise.event.Event;
import org.guvnor.common.services.project.client.context.WorkspaceProjectContext;
import org.guvnor.common.services.project.client.security.ProjectController;
import org.guvnor.common.services.shared.metadata.model.Metadata;
import org.guvnor.messageconsole.client.console.widget.button.AlertsButtonMenuItemBuilder;
import org.guvnor.messageconsole.events.PublishBatchMessagesEvent;
import org.guvnor.messageconsole.events.UnpublishMessagesEvent;
import org.guvnor.structure.repositories.RepositoryRemovedEvent;
import org.jboss.errai.bus.client.ErraiBus;
import org.jboss.errai.bus.client.api.Subscription;
import org.jboss.errai.common.client.api.Caller;
import org.jboss.errai.enterprise.client.cdi.AbstractCDIEventCallback;
import org.jboss.errai.enterprise.client.cdi.api.CDI;
import org.jboss.errai.ioc.client.api.ManagedInstance;
import org.jboss.errai.ioc.client.container.ContextManager;
import org.jboss.errai.ioc.client.container.Factory;
import org.jboss.errai.ioc.client.container.FactoryHandleImpl;
import org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter;
import org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter.DataModelerScreenView;
import org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.context.DataModelerWorkbenchContext;
import org.kie.workbench.common.screens.datamodeller.client.context.DataModelerWorkbenchFocusEvent;
import org.kie.workbench.common.screens.datamodeller.client.validation.ValidatorService;
import org.kie.workbench.common.screens.datamodeller.events.DataModelerEvent;
import org.kie.workbench.common.screens.datamodeller.events.DataObjectChangeEvent;
import org.kie.workbench.common.screens.datamodeller.events.DataObjectCreatedEvent;
import org.kie.workbench.common.screens.datamodeller.events.DataObjectDeletedEvent;
import org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldChangeEvent;
import org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldCreatedEvent;
import org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldDeletedEvent;
import org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldSelectedEvent;
import org.kie.workbench.common.screens.datamodeller.events.DataObjectSelectedEvent;
import org.kie.workbench.common.screens.datamodeller.service.DataModelerService;
import org.kie.workbench.common.screens.javaeditor.client.type.JavaResourceType;
import org.kie.workbench.common.screens.javaeditor.client.widget.EditJavaSourceWidget;
import org.kie.workbench.common.services.refactoring.client.usages.ShowAssetUsagesDisplayer;
import org.kie.workbench.common.services.shared.validation.ValidationService;
import org.kie.workbench.common.widgets.client.menu.FileMenuBuilder;
import org.kie.workbench.common.widgets.client.menu.FileMenuBuilderImpl;
import org.kie.workbench.common.widgets.client.popups.validation.ValidationPopup;
import org.kie.workbench.common.widgets.metadata.client.KieEditor;
import org.kie.workbench.common.widgets.metadata.client.KieEditorWrapperView;
import org.kie.workbench.common.widgets.metadata.client.KieEditorWrapperView.KieEditorWrapperPresenter;
import org.kie.workbench.common.widgets.metadata.client.KieEditorWrapperViewImpl;
import org.kie.workbench.common.widgets.metadata.client.validation.AssetUpdateValidator;
import org.kie.workbench.common.widgets.metadata.client.validation.JavaAssetUpdateValidator;
import org.kie.workbench.common.widgets.metadata.client.widget.OverviewWidgetPresenter;
import org.uberfire.client.mvp.LockRequiredEvent;
import org.uberfire.client.mvp.PlaceManager;
import org.uberfire.client.mvp.PlaceManagerImpl;
import org.uberfire.client.workbench.events.ChangeTitleWidgetEvent;
import org.uberfire.client.workbench.events.PlaceHiddenEvent;
import org.uberfire.ext.editor.commons.client.BaseEditor;
import org.uberfire.ext.editor.commons.client.event.ConcurrentDeleteAcceptedEvent;
import org.uberfire.ext.editor.commons.client.event.ConcurrentDeleteIgnoredEvent;
import org.uberfire.ext.editor.commons.client.event.ConcurrentRenameAcceptedEvent;
import org.uberfire.ext.editor.commons.client.event.ConcurrentRenameIgnoredEvent;
import org.uberfire.ext.editor.commons.client.file.popups.CopyPopUpPresenter;
import org.uberfire.ext.editor.commons.client.file.popups.DeletePopUpPresenter;
import org.uberfire.ext.editor.commons.client.file.popups.RenamePopUpPresenter;
import org.uberfire.ext.editor.commons.client.file.popups.SavePopUpPresenter;
import org.uberfire.ext.editor.commons.client.history.VersionRecordManager;
import org.uberfire.ext.editor.commons.client.menu.BasicFileMenuBuilder;
import org.uberfire.ext.editor.commons.client.menu.BasicFileMenuBuilderImpl;
import org.uberfire.ext.editor.commons.client.menu.DownloadMenuItem;
import org.uberfire.ext.editor.commons.client.menu.common.SaveAndRenameCommandBuilder;
import org.uberfire.ext.editor.commons.client.validation.DefaultFileNameValidator;
import org.uberfire.ext.editor.commons.version.events.RestoreEvent;
import org.uberfire.rpc.SessionInfo;
import org.uberfire.security.authz.AuthorizationManager;
import org.uberfire.security.impl.authz.DefaultAuthorizationManager;
import org.uberfire.workbench.events.NotificationEvent;

public class Type_factory__o_k_w_c_s_d_c_DataModelerScreenPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DataModelerScreenPresenter> { public Type_factory__o_k_w_c_s_d_c_DataModelerScreenPresenter__quals__j_e_i_Any_j_e_i_Default() {
    super(new FactoryHandleImpl(DataModelerScreenPresenter.class, "Type_factory__o_k_w_c_s_d_c_DataModelerScreenPresenter__quals__j_e_i_Any_j_e_i_Default", Dependent.class, false, null, true));
    handle.setAssignableTypes(new Class[] { DataModelerScreenPresenter.class, KieEditor.class, BaseEditor.class, Object.class, KieEditorWrapperPresenter.class });
  }

  public DataModelerScreenPresenter createInstance(final ContextManager contextManager) {
    final SessionInfo _sessionInfo_1 = (SessionInfo) contextManager.getInstance("Producer_factory__o_u_r_SessionInfo__quals__j_e_i_Any_j_e_i_Default");
    final DataModelerScreenView _baseView_0 = (DataModelerScreenViewImpl) contextManager.getInstance("Type_factory__o_k_w_c_s_d_c_DataModelerScreenViewImpl__quals__j_e_i_Any_j_e_i_Default");
    final DataModelerScreenPresenter instance = new DataModelerScreenPresenter(_baseView_0, _sessionInfo_1);
    registerDependentScopedReference(instance, _baseView_0);
    setIncompleteInstance(instance);
    final EditJavaSourceWidget DataModelerScreenPresenter_javaSourceEditor = (EditJavaSourceWidget) contextManager.getInstance("ExtensionProvided_factory__o_k_w_c_s_j_c_w_EditJavaSourceWidget__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, DataModelerScreenPresenter_javaSourceEditor);
    DataModelerScreenPresenter_EditJavaSourceWidget_javaSourceEditor(instance, DataModelerScreenPresenter_javaSourceEditor);
    final RenamePopUpPresenter KieEditor_renamePopUpPresenter = (RenamePopUpPresenter) contextManager.getInstance("Type_factory__o_u_e_e_c_c_f_p_RenamePopUpPresenter__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, KieEditor_renamePopUpPresenter);
    KieEditor_RenamePopUpPresenter_renamePopUpPresenter(instance, KieEditor_renamePopUpPresenter);
    final Event DataModelerScreenPresenter_lockRequired = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { LockRequiredEvent.class }, new Annotation[] { });
    registerDependentScopedReference(instance, DataModelerScreenPresenter_lockRequired);
    DataModelerScreenPresenter_Event_lockRequired(instance, DataModelerScreenPresenter_lockRequired);
    final JavaAssetUpdateValidator DataModelerScreenPresenter_javaAssetUpdateValidator = (JavaAssetUpdateValidator) contextManager.getInstance("Type_factory__o_k_w_c_w_m_c_v_JavaAssetUpdateValidator__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, DataModelerScreenPresenter_javaAssetUpdateValidator);
    DataModelerScreenPresenter_JavaAssetUpdateValidator_javaAssetUpdateValidator(instance, DataModelerScreenPresenter_javaAssetUpdateValidator);
    final JavaResourceType DataModelerScreenPresenter_resourceType = (JavaResourceType) contextManager.getInstance("Type_factory__o_k_w_c_s_j_c_t_JavaResourceType__quals__j_e_i_Any_j_e_i_Default");
    DataModelerScreenPresenter_JavaResourceType_resourceType(instance, DataModelerScreenPresenter_resourceType);
    final CopyPopUpPresenter KieEditor_copyPopUpPresenter = (CopyPopUpPresenter) contextManager.getInstance("Type_factory__o_u_e_e_c_c_f_p_CopyPopUpPresenter__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, KieEditor_copyPopUpPresenter);
    KieEditor_CopyPopUpPresenter_copyPopUpPresenter(instance, KieEditor_copyPopUpPresenter);
    final DeletePopUpPresenter KieEditor_deletePopUpPresenter = (DeletePopUpPresenter) contextManager.getInstance("Type_factory__o_u_e_e_c_c_f_p_DeletePopUpPresenter__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, KieEditor_deletePopUpPresenter);
    KieEditor_DeletePopUpPresenter_deletePopUpPresenter(instance, KieEditor_deletePopUpPresenter);
    final SaveAndRenameCommandBuilder BaseEditor_saveAndRenameCommandBuilder = (SaveAndRenameCommandBuilder) contextManager.getInstance("Type_factory__o_u_e_e_c_c_m_c_SaveAndRenameCommandBuilder__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, BaseEditor_saveAndRenameCommandBuilder);
    BaseEditor_SaveAndRenameCommandBuilder_saveAndRenameCommandBuilder(instance, BaseEditor_saveAndRenameCommandBuilder);
    final ValidatorService DataModelerScreenPresenter_validatorService = (ValidatorService) contextManager.getInstance("Type_factory__o_k_w_c_s_d_c_v_ValidatorService__quals__j_e_i_Any_j_e_i_Default");
    DataModelerScreenPresenter_ValidatorService_validatorService(instance, DataModelerScreenPresenter_validatorService);
    final Caller DataModelerScreenPresenter_validationService = (Caller) contextManager.getContextualInstance("ContextualProvider_factory__o_j_e_c_c_a_Caller__quals__Universal", new Class[] { ValidationService.class }, new Annotation[] { });
    registerDependentScopedReference(instance, DataModelerScreenPresenter_validationService);
    DataModelerScreenPresenter_Caller_validationService(instance, DataModelerScreenPresenter_validationService);
    final Event BaseEditor_concurrentDeleteAcceptedEvent = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { ConcurrentDeleteAcceptedEvent.class }, new Annotation[] { });
    registerDependentScopedReference(instance, BaseEditor_concurrentDeleteAcceptedEvent);
    BaseEditor_Event_concurrentDeleteAcceptedEvent(instance, BaseEditor_concurrentDeleteAcceptedEvent);
    final Event BaseEditor_changeTitleNotification = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { ChangeTitleWidgetEvent.class }, new Annotation[] { });
    registerDependentScopedReference(instance, BaseEditor_changeTitleNotification);
    BaseEditor_Event_changeTitleNotification(instance, BaseEditor_changeTitleNotification);
    final AlertsButtonMenuItemBuilder KieEditor_alertsButtonMenuItemBuilder = (AlertsButtonMenuItemBuilder) contextManager.getInstance("Type_factory__o_g_m_c_c_w_b_AlertsButtonMenuItemBuilder__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, KieEditor_alertsButtonMenuItemBuilder);
    KieEditor_AlertsButtonMenuItemBuilder_alertsButtonMenuItemBuilder(instance, KieEditor_alertsButtonMenuItemBuilder);
    final AssetUpdateValidator KieEditor_assetUpdateValidator = (AssetUpdateValidator) contextManager.getInstance("Type_factory__o_k_w_c_w_m_c_v_AssetUpdateValidator__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, KieEditor_assetUpdateValidator);
    KieEditor_AssetUpdateValidator_assetUpdateValidator(instance, KieEditor_assetUpdateValidator);
    final ValidationPopup DataModelerScreenPresenter_validationPopup = (ValidationPopup) contextManager.getInstance("Type_factory__o_k_w_c_w_c_p_v_ValidationPopup__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, DataModelerScreenPresenter_validationPopup);
    DataModelerScreenPresenter_ValidationPopup_validationPopup(instance, DataModelerScreenPresenter_validationPopup);
    final WorkspaceProjectContext KieEditor_workbenchContext = (WorkspaceProjectContext) contextManager.getInstance("Type_factory__o_g_c_s_p_c_c_WorkspaceProjectContext__quals__j_e_i_Any_j_e_i_Default");
    KieEditor_WorkspaceProjectContext_workbenchContext(instance, KieEditor_workbenchContext);
    final Event BaseEditor_notification = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { NotificationEvent.class }, new Annotation[] { });
    registerDependentScopedReference(instance, BaseEditor_notification);
    BaseEditor_Event_notification(instance, BaseEditor_notification);
    final Event BaseEditor_concurrentRenameIgnoredEvent = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { ConcurrentRenameIgnoredEvent.class }, new Annotation[] { });
    registerDependentScopedReference(instance, BaseEditor_concurrentRenameIgnoredEvent);
    BaseEditor_Event_concurrentRenameIgnoredEvent(instance, BaseEditor_concurrentRenameIgnoredEvent);
    final Event DataModelerScreenPresenter_dataModelerFocusEvent = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { DataModelerWorkbenchFocusEvent.class }, new Annotation[] { });
    registerDependentScopedReference(instance, DataModelerScreenPresenter_dataModelerFocusEvent);
    DataModelerScreenPresenter_Event_dataModelerFocusEvent(instance, DataModelerScreenPresenter_dataModelerFocusEvent);
    final Caller DataModelerScreenPresenter_modelerService = (Caller) contextManager.getContextualInstance("ContextualProvider_factory__o_j_e_c_c_a_Caller__quals__Universal", new Class[] { DataModelerService.class }, new Annotation[] { });
    registerDependentScopedReference(instance, DataModelerScreenPresenter_modelerService);
    DataModelerScreenPresenter_Caller_modelerService(instance, DataModelerScreenPresenter_modelerService);
    final OverviewWidgetPresenter KieEditor_overviewWidget = (OverviewWidgetPresenter) contextManager.getInstance("Type_factory__o_k_w_c_w_m_c_w_OverviewWidgetPresenter__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, KieEditor_overviewWidget);
    KieEditor_OverviewWidgetPresenter_overviewWidget(instance, KieEditor_overviewWidget);
    final PlaceManagerImpl BaseEditor_placeManager = (PlaceManagerImpl) contextManager.getInstance("Type_factory__o_u_c_m_PlaceManagerImpl__quals__j_e_i_Any_j_e_i_Default");
    BaseEditor_PlaceManager_placeManager(instance, BaseEditor_placeManager);
    final SavePopUpPresenter KieEditor_savePopUpPresenter = (SavePopUpPresenter) contextManager.getInstance("Type_factory__o_u_e_e_c_c_f_p_SavePopUpPresenter__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, KieEditor_savePopUpPresenter);
    KieEditor_SavePopUpPresenter_savePopUpPresenter(instance, KieEditor_savePopUpPresenter);
    final DownloadMenuItem BaseEditor_downloadMenuItem = (DownloadMenuItem) contextManager.getInstance("Type_factory__o_u_e_e_c_c_m_DownloadMenuItem__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, BaseEditor_downloadMenuItem);
    BaseEditor_DownloadMenuItem_downloadMenuItem(instance, BaseEditor_downloadMenuItem);
    final Event BaseEditor_concurrentDeleteIgnoredEvent = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { ConcurrentDeleteIgnoredEvent.class }, new Annotation[] { });
    registerDependentScopedReference(instance, BaseEditor_concurrentDeleteIgnoredEvent);
    BaseEditor_Event_concurrentDeleteIgnoredEvent(instance, BaseEditor_concurrentDeleteIgnoredEvent);
    final ManagedInstance BaseEditor_menuBuilderManagedInstance = (ManagedInstance) contextManager.getContextualInstance("ContextualProvider_factory__o_j_e_i_c_a_ManagedInstance__quals__Universal", new Class[] { BasicFileMenuBuilder.class }, new Annotation[] { });
    registerDependentScopedReference(instance, BaseEditor_menuBuilderManagedInstance);
    BaseEditor_ManagedInstance_menuBuilderManagedInstance(instance, BaseEditor_menuBuilderManagedInstance);
    final BasicFileMenuBuilderImpl BaseEditor_menuBuilder = (BasicFileMenuBuilderImpl) contextManager.getInstance("Type_factory__o_u_e_e_c_c_m_BasicFileMenuBuilderImpl__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, BaseEditor_menuBuilder);
    BaseEditor_BasicFileMenuBuilder_menuBuilder(instance, BaseEditor_menuBuilder);
    final Event DataModelerScreenPresenter_dataModelerEvent = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { DataModelerEvent.class }, new Annotation[] { });
    registerDependentScopedReference(instance, DataModelerScreenPresenter_dataModelerEvent);
    DataModelerScreenPresenter_Event_dataModelerEvent(instance, DataModelerScreenPresenter_dataModelerEvent);
    final Event DataModelerScreenPresenter_publishBatchMessagesEvent = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { PublishBatchMessagesEvent.class }, new Annotation[] { });
    registerDependentScopedReference(instance, DataModelerScreenPresenter_publishBatchMessagesEvent);
    DataModelerScreenPresenter_Event_publishBatchMessagesEvent(instance, DataModelerScreenPresenter_publishBatchMessagesEvent);
    final ShowAssetUsagesDisplayer DataModelerScreenPresenter_showAssetUsagesDisplayer = (ShowAssetUsagesDisplayer) contextManager.getInstance("Type_factory__o_k_w_c_s_r_c_u_ShowAssetUsagesDisplayer__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, DataModelerScreenPresenter_showAssetUsagesDisplayer);
    DataModelerScreenPresenter_ShowAssetUsagesDisplayer_showAssetUsagesDisplayer(instance, DataModelerScreenPresenter_showAssetUsagesDisplayer);
    final DataModelerWorkbenchContext DataModelerScreenPresenter_dataModelerWBContext = (DataModelerWorkbenchContext) contextManager.getInstance("Type_factory__o_k_w_c_s_d_c_c_DataModelerWorkbenchContext__quals__j_e_i_Any_j_e_i_Default");
    DataModelerScreenPresenter_DataModelerWorkbenchContext_dataModelerWBContext(instance, DataModelerScreenPresenter_dataModelerWBContext);
    final DefaultFileNameValidator BaseEditor_fileNameValidator = (DefaultFileNameValidator) contextManager.getInstance("Type_factory__o_u_e_e_c_c_v_DefaultFileNameValidator__quals__j_e_i_Any_j_e_i_Default");
    BaseEditor_DefaultFileNameValidator_fileNameValidator(instance, BaseEditor_fileNameValidator);
    final DefaultAuthorizationManager DataModelerScreenPresenter_authorizationManager = (DefaultAuthorizationManager) contextManager.getInstance("Type_factory__o_u_s_i_a_DefaultAuthorizationManager__quals__j_e_i_Any_j_e_i_Default");
    DataModelerScreenPresenter_AuthorizationManager_authorizationManager(instance, DataModelerScreenPresenter_authorizationManager);
    final VersionRecordManager BaseEditor_versionRecordManager = (VersionRecordManager) contextManager.getInstance("Type_factory__o_u_e_e_c_c_h_VersionRecordManager__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, BaseEditor_versionRecordManager);
    BaseEditor_VersionRecordManager_versionRecordManager(instance, BaseEditor_versionRecordManager);
    final ProjectController KieEditor_projectController = (ProjectController) contextManager.getInstance("Type_factory__o_g_c_s_p_c_s_ProjectController__quals__j_e_i_Any_j_e_i_Default");
    KieEditor_ProjectController_projectController(instance, KieEditor_projectController);
    final Event DataModelerScreenPresenter_unpublishMessagesEvent = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { UnpublishMessagesEvent.class }, new Annotation[] { });
    registerDependentScopedReference(instance, DataModelerScreenPresenter_unpublishMessagesEvent);
    DataModelerScreenPresenter_Event_unpublishMessagesEvent(instance, DataModelerScreenPresenter_unpublishMessagesEvent);
    final KieEditorWrapperViewImpl KieEditor_kieView = (KieEditorWrapperViewImpl) contextManager.getInstance("Type_factory__o_k_w_c_w_m_c_KieEditorWrapperViewImpl__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, KieEditor_kieView);
    KieEditor_KieEditorWrapperView_kieView(instance, KieEditor_kieView);
    final FileMenuBuilderImpl KieEditor_fileMenuBuilder = (FileMenuBuilderImpl) contextManager.getInstance("Type_factory__o_k_w_c_w_c_m_FileMenuBuilderImpl__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, KieEditor_fileMenuBuilder);
    KieEditor_FileMenuBuilder_fileMenuBuilder(instance, KieEditor_fileMenuBuilder);
    final Event BaseEditor_concurrentRenameAcceptedEvent = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { ConcurrentRenameAcceptedEvent.class }, new Annotation[] { });
    registerDependentScopedReference(instance, BaseEditor_concurrentRenameAcceptedEvent);
    BaseEditor_Event_concurrentRenameAcceptedEvent(instance, BaseEditor_concurrentRenameAcceptedEvent);
    thisInstance.setReference(instance, "hideDataModellerDocksSubscription", CDI.subscribeLocal("org.uberfire.client.workbench.events.PlaceHiddenEvent", new AbstractCDIEventCallback<PlaceHiddenEvent>() {
      public void fireEvent(final PlaceHiddenEvent event) {
        DataModelerScreenPresenter_hideDataModellerDocks_PlaceHiddenEvent(instance, event);
      }
      public String toString() {
        return "Observer: org.uberfire.client.workbench.events.PlaceHiddenEvent []";
      }
    }));
    thisInstance.setReference(instance, "onDataObjectDeletedSubscription", CDI.subscribe("org.kie.workbench.common.screens.datamodeller.events.DataObjectDeletedEvent", new AbstractCDIEventCallback<DataObjectDeletedEvent>() {
      public void fireEvent(final DataObjectDeletedEvent event) {
        DataModelerScreenPresenter_onDataObjectDeleted_DataObjectDeletedEvent(instance, event);
      }
      public String toString() {
        return "Observer: org.kie.workbench.common.screens.datamodeller.events.DataObjectDeletedEvent []";
      }
    }));
    thisInstance.setReference(instance, "onDataObjectDeletedSubscriptionForDataObjectDeletedEvent", ErraiBus.get().subscribe("cdi.event:org.kie.workbench.common.screens.datamodeller.events.DataObjectDeletedEvent", CDI.ROUTING_CALLBACK));
    thisInstance.setReference(instance, "onDataObjectCreatedSubscription", CDI.subscribe("org.kie.workbench.common.screens.datamodeller.events.DataObjectCreatedEvent", new AbstractCDIEventCallback<DataObjectCreatedEvent>() {
      public void fireEvent(final DataObjectCreatedEvent event) {
        DataModelerScreenPresenter_onDataObjectCreated_DataObjectCreatedEvent(instance, event);
      }
      public String toString() {
        return "Observer: org.kie.workbench.common.screens.datamodeller.events.DataObjectCreatedEvent []";
      }
    }));
    thisInstance.setReference(instance, "onDataObjectCreatedSubscriptionForDataObjectCreatedEvent", ErraiBus.get().subscribe("cdi.event:org.kie.workbench.common.screens.datamodeller.events.DataObjectCreatedEvent", CDI.ROUTING_CALLBACK));
    thisInstance.setReference(instance, "onDataObjectFieldChangeEventSubscription", CDI.subscribe("org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldChangeEvent", new AbstractCDIEventCallback<DataObjectFieldChangeEvent>() {
      public void fireEvent(final DataObjectFieldChangeEvent event) {
        DataModelerScreenPresenter_onDataObjectFieldChangeEvent_DataObjectFieldChangeEvent(instance, event);
      }
      public String toString() {
        return "Observer: org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldChangeEvent []";
      }
    }));
    thisInstance.setReference(instance, "onDataObjectFieldChangeEventSubscriptionForDataObjectFieldChangeEvent", ErraiBus.get().subscribe("cdi.event:org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldChangeEvent", CDI.ROUTING_CALLBACK));
    thisInstance.setReference(instance, "onDataObjectFieldDeletedSubscription", CDI.subscribe("org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldDeletedEvent", new AbstractCDIEventCallback<DataObjectFieldDeletedEvent>() {
      public void fireEvent(final DataObjectFieldDeletedEvent event) {
        DataModelerScreenPresenter_onDataObjectFieldDeleted_DataObjectFieldDeletedEvent(instance, event);
      }
      public String toString() {
        return "Observer: org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldDeletedEvent []";
      }
    }));
    thisInstance.setReference(instance, "onDataObjectFieldDeletedSubscriptionForDataObjectFieldDeletedEvent", ErraiBus.get().subscribe("cdi.event:org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldDeletedEvent", CDI.ROUTING_CALLBACK));
    thisInstance.setReference(instance, "onDataObjectChangeEventSubscription", CDI.subscribe("org.kie.workbench.common.screens.datamodeller.events.DataObjectChangeEvent", new AbstractCDIEventCallback<DataObjectChangeEvent>() {
      public void fireEvent(final DataObjectChangeEvent event) {
        DataModelerScreenPresenter_onDataObjectChangeEvent_DataObjectChangeEvent(instance, event);
      }
      public String toString() {
        return "Observer: org.kie.workbench.common.screens.datamodeller.events.DataObjectChangeEvent []";
      }
    }));
    thisInstance.setReference(instance, "onDataObjectChangeEventSubscriptionForDataObjectChangeEvent", ErraiBus.get().subscribe("cdi.event:org.kie.workbench.common.screens.datamodeller.events.DataObjectChangeEvent", CDI.ROUTING_CALLBACK));
    thisInstance.setReference(instance, "onDataObjectFieldCreatedSubscription", CDI.subscribe("org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldCreatedEvent", new AbstractCDIEventCallback<DataObjectFieldCreatedEvent>() {
      public void fireEvent(final DataObjectFieldCreatedEvent event) {
        DataModelerScreenPresenter_onDataObjectFieldCreated_DataObjectFieldCreatedEvent(instance, event);
      }
      public String toString() {
        return "Observer: org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldCreatedEvent []";
      }
    }));
    thisInstance.setReference(instance, "onDataObjectFieldCreatedSubscriptionForDataObjectFieldCreatedEvent", ErraiBus.get().subscribe("cdi.event:org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldCreatedEvent", CDI.ROUTING_CALLBACK));
    thisInstance.setReference(instance, "onDataObjectSelectedEventSubscription", CDI.subscribe("org.kie.workbench.common.screens.datamodeller.events.DataObjectSelectedEvent", new AbstractCDIEventCallback<DataObjectSelectedEvent>() {
      public void fireEvent(final DataObjectSelectedEvent event) {
        DataModelerScreenPresenter_onDataObjectSelectedEvent_DataObjectSelectedEvent(instance, event);
      }
      public String toString() {
        return "Observer: org.kie.workbench.common.screens.datamodeller.events.DataObjectSelectedEvent []";
      }
    }));
    thisInstance.setReference(instance, "onDataObjectSelectedEventSubscriptionForDataObjectSelectedEvent", ErraiBus.get().subscribe("cdi.event:org.kie.workbench.common.screens.datamodeller.events.DataObjectSelectedEvent", CDI.ROUTING_CALLBACK));
    thisInstance.setReference(instance, "onDataObjectFieldSelectedEventSubscription", CDI.subscribe("org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldSelectedEvent", new AbstractCDIEventCallback<DataObjectFieldSelectedEvent>() {
      public void fireEvent(final DataObjectFieldSelectedEvent event) {
        DataModelerScreenPresenter_onDataObjectFieldSelectedEvent_DataObjectFieldSelectedEvent(instance, event);
      }
      public String toString() {
        return "Observer: org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldSelectedEvent []";
      }
    }));
    thisInstance.setReference(instance, "onDataObjectFieldSelectedEventSubscriptionForDataObjectFieldSelectedEvent", ErraiBus.get().subscribe("cdi.event:org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldSelectedEvent", CDI.ROUTING_CALLBACK));
    thisInstance.setReference(instance, "onRepositoryRemovedSubscription", CDI.subscribe("org.guvnor.structure.repositories.RepositoryRemovedEvent", new AbstractCDIEventCallback<RepositoryRemovedEvent>() {
      public void fireEvent(final RepositoryRemovedEvent event) {
        instance.onRepositoryRemoved(event);
      }
      public String toString() {
        return "Observer: org.guvnor.structure.repositories.RepositoryRemovedEvent []";
      }
    }));
    thisInstance.setReference(instance, "onRepositoryRemovedSubscriptionForRepositoryRemovedEvent", ErraiBus.get().subscribe("cdi.event:org.guvnor.structure.repositories.RepositoryRemovedEvent", CDI.ROUTING_CALLBACK));
    thisInstance.setReference(instance, "onRestoreSubscription", CDI.subscribeLocal("org.uberfire.ext.editor.commons.version.events.RestoreEvent", new AbstractCDIEventCallback<RestoreEvent>() {
      public void fireEvent(final RestoreEvent event) {
        instance.onRestore(event);
      }
      public String toString() {
        return "Observer: org.uberfire.ext.editor.commons.version.events.RestoreEvent []";
      }
    }));
    setIncompleteInstance(null);
    return instance;
  }

  public void generatedDestroyInstance(final Object instance, final ContextManager contextManager) {
    destroyInstanceHelper((DataModelerScreenPresenter) instance, contextManager);
  }

  public void destroyInstanceHelper(final DataModelerScreenPresenter instance, final ContextManager contextManager) {
    ((Subscription) thisInstance.getReferenceAs(instance, "hideDataModellerDocksSubscription", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onDataObjectDeletedSubscription", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onDataObjectDeletedSubscriptionForDataObjectDeletedEvent", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onDataObjectCreatedSubscription", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onDataObjectCreatedSubscriptionForDataObjectCreatedEvent", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onDataObjectFieldChangeEventSubscription", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onDataObjectFieldChangeEventSubscriptionForDataObjectFieldChangeEvent", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onDataObjectFieldDeletedSubscription", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onDataObjectFieldDeletedSubscriptionForDataObjectFieldDeletedEvent", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onDataObjectChangeEventSubscription", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onDataObjectChangeEventSubscriptionForDataObjectChangeEvent", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onDataObjectFieldCreatedSubscription", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onDataObjectFieldCreatedSubscriptionForDataObjectFieldCreatedEvent", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onDataObjectSelectedEventSubscription", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onDataObjectSelectedEventSubscriptionForDataObjectSelectedEvent", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onDataObjectFieldSelectedEventSubscription", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onDataObjectFieldSelectedEventSubscriptionForDataObjectFieldSelectedEvent", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onRepositoryRemovedSubscription", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onRepositoryRemovedSubscriptionForRepositoryRemovedEvent", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onRestoreSubscription", Subscription.class)).remove();
  }

  native static ValidationPopup DataModelerScreenPresenter_ValidationPopup_validationPopup(DataModelerScreenPresenter instance) /*-{
    return instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::validationPopup;
  }-*/;

  native static void DataModelerScreenPresenter_ValidationPopup_validationPopup(DataModelerScreenPresenter instance, ValidationPopup value) /*-{
    instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::validationPopup = value;
  }-*/;

  native static WorkspaceProjectContext KieEditor_WorkspaceProjectContext_workbenchContext(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::workbenchContext;
  }-*/;

  native static void KieEditor_WorkspaceProjectContext_workbenchContext(KieEditor instance, WorkspaceProjectContext value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::workbenchContext = value;
  }-*/;

  native static Caller DataModelerScreenPresenter_Caller_modelerService(DataModelerScreenPresenter instance) /*-{
    return instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::modelerService;
  }-*/;

  native static void DataModelerScreenPresenter_Caller_modelerService(DataModelerScreenPresenter instance, Caller<DataModelerService> value) /*-{
    instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::modelerService = value;
  }-*/;

  native static PlaceManager BaseEditor_PlaceManager_placeManager(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::placeManager;
  }-*/;

  native static void BaseEditor_PlaceManager_placeManager(BaseEditor instance, PlaceManager value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::placeManager = value;
  }-*/;

  native static Event DataModelerScreenPresenter_Event_lockRequired(DataModelerScreenPresenter instance) /*-{
    return instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::lockRequired;
  }-*/;

  native static void DataModelerScreenPresenter_Event_lockRequired(DataModelerScreenPresenter instance, Event<LockRequiredEvent> value) /*-{
    instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::lockRequired = value;
  }-*/;

  native static EditJavaSourceWidget DataModelerScreenPresenter_EditJavaSourceWidget_javaSourceEditor(DataModelerScreenPresenter instance) /*-{
    return instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::javaSourceEditor;
  }-*/;

  native static void DataModelerScreenPresenter_EditJavaSourceWidget_javaSourceEditor(DataModelerScreenPresenter instance, EditJavaSourceWidget value) /*-{
    instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::javaSourceEditor = value;
  }-*/;

  native static Event DataModelerScreenPresenter_Event_dataModelerFocusEvent(DataModelerScreenPresenter instance) /*-{
    return instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::dataModelerFocusEvent;
  }-*/;

  native static void DataModelerScreenPresenter_Event_dataModelerFocusEvent(DataModelerScreenPresenter instance, Event<DataModelerWorkbenchFocusEvent> value) /*-{
    instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::dataModelerFocusEvent = value;
  }-*/;

  native static JavaAssetUpdateValidator DataModelerScreenPresenter_JavaAssetUpdateValidator_javaAssetUpdateValidator(DataModelerScreenPresenter instance) /*-{
    return instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::javaAssetUpdateValidator;
  }-*/;

  native static void DataModelerScreenPresenter_JavaAssetUpdateValidator_javaAssetUpdateValidator(DataModelerScreenPresenter instance, JavaAssetUpdateValidator value) /*-{
    instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::javaAssetUpdateValidator = value;
  }-*/;

  native static JavaResourceType DataModelerScreenPresenter_JavaResourceType_resourceType(DataModelerScreenPresenter instance) /*-{
    return instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::resourceType;
  }-*/;

  native static void DataModelerScreenPresenter_JavaResourceType_resourceType(DataModelerScreenPresenter instance, JavaResourceType value) /*-{
    instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::resourceType = value;
  }-*/;

  native static RenamePopUpPresenter KieEditor_RenamePopUpPresenter_renamePopUpPresenter(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::renamePopUpPresenter;
  }-*/;

  native static void KieEditor_RenamePopUpPresenter_renamePopUpPresenter(KieEditor instance, RenamePopUpPresenter value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::renamePopUpPresenter = value;
  }-*/;

  native static ValidatorService DataModelerScreenPresenter_ValidatorService_validatorService(DataModelerScreenPresenter instance) /*-{
    return instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::validatorService;
  }-*/;

  native static void DataModelerScreenPresenter_ValidatorService_validatorService(DataModelerScreenPresenter instance, ValidatorService value) /*-{
    instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::validatorService = value;
  }-*/;

  native static ManagedInstance BaseEditor_ManagedInstance_menuBuilderManagedInstance(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::menuBuilderManagedInstance;
  }-*/;

  native static void BaseEditor_ManagedInstance_menuBuilderManagedInstance(BaseEditor instance, ManagedInstance<BasicFileMenuBuilder> value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::menuBuilderManagedInstance = value;
  }-*/;

  native static Event BaseEditor_Event_concurrentRenameIgnoredEvent(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::concurrentRenameIgnoredEvent;
  }-*/;

  native static void BaseEditor_Event_concurrentRenameIgnoredEvent(BaseEditor instance, Event<ConcurrentRenameIgnoredEvent> value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::concurrentRenameIgnoredEvent = value;
  }-*/;

  native static DefaultFileNameValidator BaseEditor_DefaultFileNameValidator_fileNameValidator(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::fileNameValidator;
  }-*/;

  native static void BaseEditor_DefaultFileNameValidator_fileNameValidator(BaseEditor instance, DefaultFileNameValidator value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::fileNameValidator = value;
  }-*/;

  native static SavePopUpPresenter KieEditor_SavePopUpPresenter_savePopUpPresenter(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::savePopUpPresenter;
  }-*/;

  native static void KieEditor_SavePopUpPresenter_savePopUpPresenter(KieEditor instance, SavePopUpPresenter value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::savePopUpPresenter = value;
  }-*/;

  native static Event BaseEditor_Event_changeTitleNotification(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::changeTitleNotification;
  }-*/;

  native static void BaseEditor_Event_changeTitleNotification(BaseEditor instance, Event<ChangeTitleWidgetEvent> value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::changeTitleNotification = value;
  }-*/;

  native static Event BaseEditor_Event_concurrentDeleteAcceptedEvent(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::concurrentDeleteAcceptedEvent;
  }-*/;

  native static void BaseEditor_Event_concurrentDeleteAcceptedEvent(BaseEditor instance, Event<ConcurrentDeleteAcceptedEvent> value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::concurrentDeleteAcceptedEvent = value;
  }-*/;

  native static ProjectController KieEditor_ProjectController_projectController(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::projectController;
  }-*/;

  native static void KieEditor_ProjectController_projectController(KieEditor instance, ProjectController value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::projectController = value;
  }-*/;

  native static Event BaseEditor_Event_notification(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::notification;
  }-*/;

  native static void BaseEditor_Event_notification(BaseEditor instance, Event<NotificationEvent> value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::notification = value;
  }-*/;

  native static Caller DataModelerScreenPresenter_Caller_validationService(DataModelerScreenPresenter instance) /*-{
    return instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::validationService;
  }-*/;

  native static void DataModelerScreenPresenter_Caller_validationService(DataModelerScreenPresenter instance, Caller<ValidationService> value) /*-{
    instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::validationService = value;
  }-*/;

  native static Event BaseEditor_Event_concurrentDeleteIgnoredEvent(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::concurrentDeleteIgnoredEvent;
  }-*/;

  native static void BaseEditor_Event_concurrentDeleteIgnoredEvent(BaseEditor instance, Event<ConcurrentDeleteIgnoredEvent> value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::concurrentDeleteIgnoredEvent = value;
  }-*/;

  native static Event DataModelerScreenPresenter_Event_dataModelerEvent(DataModelerScreenPresenter instance) /*-{
    return instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::dataModelerEvent;
  }-*/;

  native static void DataModelerScreenPresenter_Event_dataModelerEvent(DataModelerScreenPresenter instance, Event<DataModelerEvent> value) /*-{
    instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::dataModelerEvent = value;
  }-*/;

  native static SaveAndRenameCommandBuilder BaseEditor_SaveAndRenameCommandBuilder_saveAndRenameCommandBuilder(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::saveAndRenameCommandBuilder;
  }-*/;

  native static void BaseEditor_SaveAndRenameCommandBuilder_saveAndRenameCommandBuilder(BaseEditor instance, SaveAndRenameCommandBuilder<String, Metadata> value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::saveAndRenameCommandBuilder = value;
  }-*/;

  native static BasicFileMenuBuilder BaseEditor_BasicFileMenuBuilder_menuBuilder(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::menuBuilder;
  }-*/;

  native static void BaseEditor_BasicFileMenuBuilder_menuBuilder(BaseEditor instance, BasicFileMenuBuilder value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::menuBuilder = value;
  }-*/;

  native static AssetUpdateValidator KieEditor_AssetUpdateValidator_assetUpdateValidator(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::assetUpdateValidator;
  }-*/;

  native static void KieEditor_AssetUpdateValidator_assetUpdateValidator(KieEditor instance, AssetUpdateValidator value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::assetUpdateValidator = value;
  }-*/;

  native static AlertsButtonMenuItemBuilder KieEditor_AlertsButtonMenuItemBuilder_alertsButtonMenuItemBuilder(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::alertsButtonMenuItemBuilder;
  }-*/;

  native static void KieEditor_AlertsButtonMenuItemBuilder_alertsButtonMenuItemBuilder(KieEditor instance, AlertsButtonMenuItemBuilder value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::alertsButtonMenuItemBuilder = value;
  }-*/;

  native static DownloadMenuItem BaseEditor_DownloadMenuItem_downloadMenuItem(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::downloadMenuItem;
  }-*/;

  native static void BaseEditor_DownloadMenuItem_downloadMenuItem(BaseEditor instance, DownloadMenuItem value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::downloadMenuItem = value;
  }-*/;

  native static AuthorizationManager DataModelerScreenPresenter_AuthorizationManager_authorizationManager(DataModelerScreenPresenter instance) /*-{
    return instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::authorizationManager;
  }-*/;

  native static void DataModelerScreenPresenter_AuthorizationManager_authorizationManager(DataModelerScreenPresenter instance, AuthorizationManager value) /*-{
    instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::authorizationManager = value;
  }-*/;

  native static CopyPopUpPresenter KieEditor_CopyPopUpPresenter_copyPopUpPresenter(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::copyPopUpPresenter;
  }-*/;

  native static void KieEditor_CopyPopUpPresenter_copyPopUpPresenter(KieEditor instance, CopyPopUpPresenter value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::copyPopUpPresenter = value;
  }-*/;

  native static OverviewWidgetPresenter KieEditor_OverviewWidgetPresenter_overviewWidget(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::overviewWidget;
  }-*/;

  native static void KieEditor_OverviewWidgetPresenter_overviewWidget(KieEditor instance, OverviewWidgetPresenter value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::overviewWidget = value;
  }-*/;

  native static Event DataModelerScreenPresenter_Event_publishBatchMessagesEvent(DataModelerScreenPresenter instance) /*-{
    return instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::publishBatchMessagesEvent;
  }-*/;

  native static void DataModelerScreenPresenter_Event_publishBatchMessagesEvent(DataModelerScreenPresenter instance, Event<PublishBatchMessagesEvent> value) /*-{
    instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::publishBatchMessagesEvent = value;
  }-*/;

  native static DataModelerWorkbenchContext DataModelerScreenPresenter_DataModelerWorkbenchContext_dataModelerWBContext(DataModelerScreenPresenter instance) /*-{
    return instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::dataModelerWBContext;
  }-*/;

  native static void DataModelerScreenPresenter_DataModelerWorkbenchContext_dataModelerWBContext(DataModelerScreenPresenter instance, DataModelerWorkbenchContext value) /*-{
    instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::dataModelerWBContext = value;
  }-*/;

  native static KieEditorWrapperView KieEditor_KieEditorWrapperView_kieView(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::kieView;
  }-*/;

  native static void KieEditor_KieEditorWrapperView_kieView(KieEditor instance, KieEditorWrapperView value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::kieView = value;
  }-*/;

  native static ShowAssetUsagesDisplayer DataModelerScreenPresenter_ShowAssetUsagesDisplayer_showAssetUsagesDisplayer(DataModelerScreenPresenter instance) /*-{
    return instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::showAssetUsagesDisplayer;
  }-*/;

  native static void DataModelerScreenPresenter_ShowAssetUsagesDisplayer_showAssetUsagesDisplayer(DataModelerScreenPresenter instance, ShowAssetUsagesDisplayer value) /*-{
    instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::showAssetUsagesDisplayer = value;
  }-*/;

  native static VersionRecordManager BaseEditor_VersionRecordManager_versionRecordManager(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::versionRecordManager;
  }-*/;

  native static void BaseEditor_VersionRecordManager_versionRecordManager(BaseEditor instance, VersionRecordManager value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::versionRecordManager = value;
  }-*/;

  native static Event DataModelerScreenPresenter_Event_unpublishMessagesEvent(DataModelerScreenPresenter instance) /*-{
    return instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::unpublishMessagesEvent;
  }-*/;

  native static void DataModelerScreenPresenter_Event_unpublishMessagesEvent(DataModelerScreenPresenter instance, Event<UnpublishMessagesEvent> value) /*-{
    instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::unpublishMessagesEvent = value;
  }-*/;

  native static DeletePopUpPresenter KieEditor_DeletePopUpPresenter_deletePopUpPresenter(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::deletePopUpPresenter;
  }-*/;

  native static void KieEditor_DeletePopUpPresenter_deletePopUpPresenter(KieEditor instance, DeletePopUpPresenter value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::deletePopUpPresenter = value;
  }-*/;

  native static FileMenuBuilder KieEditor_FileMenuBuilder_fileMenuBuilder(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::fileMenuBuilder;
  }-*/;

  native static void KieEditor_FileMenuBuilder_fileMenuBuilder(KieEditor instance, FileMenuBuilder value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::fileMenuBuilder = value;
  }-*/;

  native static Event BaseEditor_Event_concurrentRenameAcceptedEvent(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::concurrentRenameAcceptedEvent;
  }-*/;

  native static void BaseEditor_Event_concurrentRenameAcceptedEvent(BaseEditor instance, Event<ConcurrentRenameAcceptedEvent> value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::concurrentRenameAcceptedEvent = value;
  }-*/;

  public native static void DataModelerScreenPresenter_onDataObjectFieldChangeEvent_DataObjectFieldChangeEvent(DataModelerScreenPresenter instance, DataObjectFieldChangeEvent a0) /*-{
    instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::onDataObjectFieldChangeEvent(Lorg/kie/workbench/common/screens/datamodeller/events/DataObjectFieldChangeEvent;)(a0);
  }-*/;

  public native static void DataModelerScreenPresenter_onDataObjectFieldDeleted_DataObjectFieldDeletedEvent(DataModelerScreenPresenter instance, DataObjectFieldDeletedEvent a0) /*-{
    instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::onDataObjectFieldDeleted(Lorg/kie/workbench/common/screens/datamodeller/events/DataObjectFieldDeletedEvent;)(a0);
  }-*/;

  public native static void DataModelerScreenPresenter_onDataObjectCreated_DataObjectCreatedEvent(DataModelerScreenPresenter instance, DataObjectCreatedEvent a0) /*-{
    instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::onDataObjectCreated(Lorg/kie/workbench/common/screens/datamodeller/events/DataObjectCreatedEvent;)(a0);
  }-*/;

  public native static void DataModelerScreenPresenter_onDataObjectFieldCreated_DataObjectFieldCreatedEvent(DataModelerScreenPresenter instance, DataObjectFieldCreatedEvent a0) /*-{
    instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::onDataObjectFieldCreated(Lorg/kie/workbench/common/screens/datamodeller/events/DataObjectFieldCreatedEvent;)(a0);
  }-*/;

  public native static void DataModelerScreenPresenter_onDataObjectDeleted_DataObjectDeletedEvent(DataModelerScreenPresenter instance, DataObjectDeletedEvent a0) /*-{
    instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::onDataObjectDeleted(Lorg/kie/workbench/common/screens/datamodeller/events/DataObjectDeletedEvent;)(a0);
  }-*/;

  public native static void DataModelerScreenPresenter_onDataObjectSelectedEvent_DataObjectSelectedEvent(DataModelerScreenPresenter instance, DataObjectSelectedEvent a0) /*-{
    instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::onDataObjectSelectedEvent(Lorg/kie/workbench/common/screens/datamodeller/events/DataObjectSelectedEvent;)(a0);
  }-*/;

  public native static void DataModelerScreenPresenter_hideDataModellerDocks_PlaceHiddenEvent(DataModelerScreenPresenter instance, PlaceHiddenEvent a0) /*-{
    instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::hideDataModellerDocks(Lorg/uberfire/client/workbench/events/PlaceHiddenEvent;)(a0);
  }-*/;

  public native static void DataModelerScreenPresenter_onDataObjectChangeEvent_DataObjectChangeEvent(DataModelerScreenPresenter instance, DataObjectChangeEvent a0) /*-{
    instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::onDataObjectChangeEvent(Lorg/kie/workbench/common/screens/datamodeller/events/DataObjectChangeEvent;)(a0);
  }-*/;

  public native static void DataModelerScreenPresenter_onDataObjectFieldSelectedEvent_DataObjectFieldSelectedEvent(DataModelerScreenPresenter instance, DataObjectFieldSelectedEvent a0) /*-{
    instance.@org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter::onDataObjectFieldSelectedEvent(Lorg/kie/workbench/common/screens/datamodeller/events/DataObjectFieldSelectedEvent;)(a0);
  }-*/;
}