package org.jboss.errai.ioc.client;

import java.lang.annotation.Annotation;
import java.util.Map;
import java.util.Set;
import javax.enterprise.context.ApplicationScoped;
import javax.enterprise.event.Event;
import org.ext.uberfire.social.activities.model.SocialFileSelectedEvent;
import org.guvnor.common.services.project.client.context.WorkspaceProjectContext;
import org.guvnor.common.services.project.context.WorkspaceProjectContextChangeEvent;
import org.guvnor.common.services.project.context.WorkspaceProjectContextChangeHandler;
import org.guvnor.common.services.project.model.WorkspaceProject;
import org.guvnor.common.services.project.service.WorkspaceProjectService;
import org.guvnor.structure.organizationalunit.OrganizationalUnit;
import org.guvnor.structure.organizationalunit.RemoveOrganizationalUnitEvent;
import org.guvnor.structure.repositories.Branch;
import org.guvnor.structure.repositories.Repository;
import org.guvnor.structure.repositories.RepositoryRemovedEvent;
import org.guvnor.structure.repositories.RepositoryService;
import org.jboss.errai.bus.client.ErraiBus;
import org.jboss.errai.common.client.api.Caller;
import org.jboss.errai.enterprise.client.cdi.AbstractCDIEventCallback;
import org.jboss.errai.enterprise.client.cdi.api.CDI;
import org.jboss.errai.ioc.client.api.ManagedInstance;
import org.jboss.errai.ioc.client.container.Context;
import org.jboss.errai.ioc.client.container.ContextManager;
import org.jboss.errai.ioc.client.container.Factory;
import org.jboss.errai.ioc.client.container.FactoryHandleImpl;
import org.jboss.errai.ioc.client.container.Proxy;
import org.jboss.errai.ioc.client.container.ProxyHelper;
import org.jboss.errai.ioc.client.container.ProxyHelperImpl;
import org.jboss.errai.security.shared.api.identity.User;
import org.jboss.errai.ui.client.local.spi.TranslationService;
import org.kie.workbench.common.screens.library.api.LibraryService;
import org.kie.workbench.common.screens.library.api.ProjectAssetListUpdated;
import org.kie.workbench.common.screens.library.api.Routed;
import org.kie.workbench.common.screens.library.api.preferences.LibraryInternalPreferences;
import org.kie.workbench.common.screens.library.api.preferences.LibraryInternalPreferencesBeanGeneratedImpl;
import org.kie.workbench.common.screens.library.client.events.AssetDetailEvent;
import org.kie.workbench.common.screens.library.client.perspective.LibraryPerspective;
import org.kie.workbench.common.screens.library.client.screens.importrepository.ImportProjectsSetupEvent;
import org.kie.workbench.common.screens.library.client.screens.importrepository.ImportRepositoryPopUpPresenter;
import org.kie.workbench.common.screens.library.client.screens.importrepository.Source;
import org.kie.workbench.common.screens.library.client.screens.importrepository.Source.Kind;
import org.kie.workbench.common.screens.library.client.screens.project.close.CloseUnsavedProjectAssetsPopUpPresenter;
import org.kie.workbench.common.screens.library.client.util.LibraryPlaces;
import org.kie.workbench.common.screens.library.client.util.TranslationUtils;
import org.kie.workbench.common.screens.library.client.util.breadcrumb.LibraryBreadcrumbs;
import org.kie.workbench.common.services.shared.project.KieModuleService;
import org.kie.workbench.common.widgets.client.handlers.NewResourceSuccessEvent;
import org.kie.workbench.common.workbench.client.docks.AuthoringWorkbenchDocks;
import org.uberfire.backend.vfs.Path;
import org.uberfire.backend.vfs.VFSService;
import org.uberfire.client.mvp.PlaceManager;
import org.uberfire.client.mvp.PlaceManagerImpl;
import org.uberfire.client.workbench.events.PlaceGainFocusEvent;
import org.uberfire.client.workbench.events.PlaceMaximizedEvent;
import org.uberfire.client.workbench.events.PlaceMinimizedEvent;
import org.uberfire.ext.editor.commons.client.event.ConcurrentDeleteAcceptedEvent;
import org.uberfire.ext.editor.commons.client.event.ConcurrentRenameAcceptedEvent;
import org.uberfire.ext.preferences.client.event.PreferencesCentralSaveEvent;
import org.uberfire.ext.preferences.client.event.PreferencesCentralUndoChangesEvent;
import org.uberfire.ext.widgets.common.client.breadcrumbs.UberfireBreadcrumbs;
import org.uberfire.ext.widgets.common.client.common.HasBusyIndicator;
import org.uberfire.mvp.Command;
import org.uberfire.mvp.PlaceRequest;
import org.uberfire.rpc.SessionInfo;
import org.uberfire.workbench.events.NotificationEvent;
import org.uberfire.workbench.events.ResourceDeletedEvent;

public class Type_factory__o_k_w_c_s_l_c_u_LibraryPlaces__quals__j_e_i_Any_j_e_i_Default extends Factory<LibraryPlaces> { private class Type_factory__o_k_w_c_s_l_c_u_LibraryPlaces__quals__j_e_i_Any_j_e_i_DefaultProxyImpl extends LibraryPlaces implements Proxy<LibraryPlaces> {
    private final ProxyHelper<LibraryPlaces> proxyHelper = new ProxyHelperImpl<LibraryPlaces>("Type_factory__o_k_w_c_s_l_c_u_LibraryPlaces__quals__j_e_i_Any_j_e_i_Default");
    public void initProxyProperties(final LibraryPlaces instance) {

    }

    public LibraryPlaces asBeanType() {
      return this;
    }

    public void setInstance(final LibraryPlaces instance) {
      proxyHelper.setInstance(instance);
    }

    public void clearInstance() {
      proxyHelper.clearInstance();
    }

    public void setProxyContext(final Context context) {
      proxyHelper.setProxyContext(context);
    }

    public Context getProxyContext() {
      return proxyHelper.getProxyContext();
    }

    public Object unwrap() {
      return proxyHelper.getInstance(this);
    }

    public boolean equals(Object obj) {
      obj = Factory.maybeUnwrapProxy(obj);
      return proxyHelper.getInstance(this).equals(obj);
    }

    @Override public void setup() {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.setup();
      } else {
        super.setup();
      }
    }

    @Override public void onSelectPlaceEvent(PlaceGainFocusEvent placeGainFocusEvent) {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.onSelectPlaceEvent(placeGainFocusEvent);
      } else {
        super.onSelectPlaceEvent(placeGainFocusEvent);
      }
    }

    @Override public void showDocksWhenMinimizingEditor(PlaceMinimizedEvent placeMinimizedEvent) {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.showDocksWhenMinimizingEditor(placeMinimizedEvent);
      } else {
        super.showDocksWhenMinimizingEditor(placeMinimizedEvent);
      }
    }

    @Override public void hideDocksWhenMaximizingEditor(PlaceMaximizedEvent placeMaximizedEvent) {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.hideDocksWhenMaximizingEditor(placeMaximizedEvent);
      } else {
        super.hideDocksWhenMaximizingEditor(placeMaximizedEvent);
      }
    }

    @Override public void onAssetListUpdateEvent(ProjectAssetListUpdated event) {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.onAssetListUpdateEvent(event);
      } else {
        super.onAssetListUpdateEvent(event);
      }
    }

    @Override public void hideDocks() {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.hideDocks();
      } else {
        super.hideDocks();
      }
    }

    @Override public void showDocks() {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.showDocks();
      } else {
        super.showDocks();
      }
    }

    @Override public void onNewResourceCreated(NewResourceSuccessEvent newResourceSuccessEvent) {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.onNewResourceCreated(newResourceSuccessEvent);
      } else {
        super.onNewResourceCreated(newResourceSuccessEvent);
      }
    }

    @Override public void onAssetRenamedAccepted(ConcurrentRenameAcceptedEvent concurrentRenameAcceptedEvent) {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.onAssetRenamedAccepted(concurrentRenameAcceptedEvent);
      } else {
        super.onAssetRenamedAccepted(concurrentRenameAcceptedEvent);
      }
    }

    @Override public void onProjectDeleted(RepositoryRemovedEvent repositoryRemovedEvent) {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.onProjectDeleted(repositoryRemovedEvent);
      } else {
        super.onProjectDeleted(repositoryRemovedEvent);
      }
    }

    @Override public void deleteProject(WorkspaceProject project, HasBusyIndicator view) {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.deleteProject(project, view);
      } else {
        super.deleteProject(project, view);
      }
    }

    @Override public void onOrganizationalUnitRemoved(RemoveOrganizationalUnitEvent removedOrganizationalUnitEvent) {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.onOrganizationalUnitRemoved(removedOrganizationalUnitEvent);
      } else {
        super.onOrganizationalUnitRemoved(removedOrganizationalUnitEvent);
      }
    }

    @Override public void onAssetSelected(AssetDetailEvent assetDetails) {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.onAssetSelected(assetDetails);
      } else {
        super.onAssetSelected(assetDetails);
      }
    }

    @Override public void onPreferencesSave(PreferencesCentralSaveEvent event) {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.onPreferencesSave(event);
      } else {
        super.onPreferencesSave(event);
      }
    }

    @Override public void onPreferencesCancel(PreferencesCentralUndoChangesEvent event) {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.onPreferencesCancel(event);
      } else {
        super.onPreferencesCancel(event);
      }
    }

    @Override public void onSocialFileSelected(SocialFileSelectedEvent event) {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.onSocialFileSelected(event);
      } else {
        super.onSocialFileSelected(event);
      }
    }

    @Override public void refresh(Command callback) {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.refresh(callback);
      } else {
        super.refresh(callback);
      }
    }

    @Override public void goToOrganizationalUnits() {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.goToOrganizationalUnits();
      } else {
        super.goToOrganizationalUnits();
      }
    }

    @Override public void goToLibrary() {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.goToLibrary();
      } else {
        super.goToLibrary();
      }
    }

    @Override public void goToProject(WorkspaceProject project) {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.goToProject(project);
      } else {
        super.goToProject(project);
      }
    }

    @Override public void goToProject(WorkspaceProject project, Branch branch) {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.goToProject(project, branch);
      } else {
        super.goToProject(project, branch);
      }
    }

    @Override public void goToAsset(Path path) {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.goToAsset(path);
      } else {
        super.goToAsset(path);
      }
    }

    @Override public void goToAddAsset() {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.goToAddAsset();
      } else {
        super.goToAddAsset();
      }
    }

    @Override public void goToTrySamples() {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.goToTrySamples();
      } else {
        super.goToTrySamples();
      }
    }

    @Override public void goToImportRepositoryPopUp() {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.goToImportRepositoryPopUp();
      } else {
        super.goToImportRepositoryPopUp();
      }
    }

    @Override public void goToExternalImportPresenter(Set projects) {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.goToExternalImportPresenter(projects);
      } else {
        super.goToExternalImportPresenter(projects);
      }
    }

    @Override public void setupExternalImportBreadCrumbs() {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.setupExternalImportBreadCrumbs();
      } else {
        super.setupExternalImportBreadCrumbs();
      }
    }

    @Override public void closeAllPlacesOrNothing(Command successCallback) {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.closeAllPlacesOrNothing(successCallback);
      } else {
        super.closeAllPlacesOrNothing(successCallback);
      }
    }

    @Override public void closePlace(Command successCallback, PlaceRequest place) {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.closePlace(successCallback, place);
      } else {
        super.closePlace(successCallback, place);
      }
    }

    @Override public WorkspaceProjectContext getWorkbenchContext() {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        final WorkspaceProjectContext retVal = proxiedInstance.getWorkbenchContext();
        return retVal;
      } else {
        return super.getWorkbenchContext();
      }
    }

    @Override public WorkspaceProject getActiveWorkspace() {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        final WorkspaceProject retVal = proxiedInstance.getActiveWorkspace();
        return retVal;
      } else {
        return super.getActiveWorkspace();
      }
    }

    @Override public OrganizationalUnit getActiveSpace() {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        final OrganizationalUnit retVal = proxiedInstance.getActiveSpace();
        return retVal;
      } else {
        return super.getActiveSpace();
      }
    }

    @Override public boolean isThisUserAccessingThisRepository(User user, Repository repository) {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        final boolean retVal = proxiedInstance.isThisUserAccessingThisRepository(user, repository);
        return retVal;
      } else {
        return super.isThisUserAccessingThisRepository(user, repository);
      }
    }

    @Override public boolean isThisRepositoryBeingAccessed(Repository repository) {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        final boolean retVal = proxiedInstance.isThisRepositoryBeingAccessed(repository);
        return retVal;
      } else {
        return super.isThisRepositoryBeingAccessed(repository);
      }
    }

    @Override public void init(LibraryPerspective libraryPerspective) {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.init(libraryPerspective);
      } else {
        super.init(libraryPerspective);
      }
    }

    @Override public void onChange(WorkspaceProjectContextChangeEvent previous, WorkspaceProjectContextChangeEvent current) {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.onChange(previous, current);
      } else {
        super.onChange(previous, current);
      }
    }

    @Override public void onDeletedResource(ResourceDeletedEvent deleteFileEvent) {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.onDeletedResource(deleteFileEvent);
      } else {
        super.onDeletedResource(deleteFileEvent);
      }
    }

    @Override public void onConcurrentDelete(ConcurrentDeleteAcceptedEvent concurrentDeleteAcceptedEvent) {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        proxiedInstance.onConcurrentDelete(concurrentDeleteAcceptedEvent);
      } else {
        super.onConcurrentDelete(concurrentDeleteAcceptedEvent);
      }
    }

    @Override protected Map getParameterMap() {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        final Map retVal = LibraryPlaces_getParameterMap(proxiedInstance);
        return retVal;
      } else {
        return super.getParameterMap();
      }
    }

    @Override public int hashCode() {
      if (proxyHelper != null) {
        final LibraryPlaces proxiedInstance = proxyHelper.getInstance(this);
        final int retVal = proxiedInstance.hashCode();
        return retVal;
      } else {
        return super.hashCode();
      }
    }
  }
  public Type_factory__o_k_w_c_s_l_c_u_LibraryPlaces__quals__j_e_i_Any_j_e_i_Default() {
    super(new FactoryHandleImpl(LibraryPlaces.class, "Type_factory__o_k_w_c_s_l_c_u_LibraryPlaces__quals__j_e_i_Any_j_e_i_Default", ApplicationScoped.class, false, null, true));
    handle.setAssignableTypes(new Class[] { LibraryPlaces.class, Object.class, WorkspaceProjectContextChangeHandler.class });
  }

  public void init(final Context context) {
    CDI.subscribeLocal("org.uberfire.client.workbench.events.PlaceGainFocusEvent", new AbstractCDIEventCallback<PlaceGainFocusEvent>() {
      public void fireEvent(final PlaceGainFocusEvent event) {
        final LibraryPlaces instance = Factory.maybeUnwrapProxy((LibraryPlaces) context.getInstance("Type_factory__o_k_w_c_s_l_c_u_LibraryPlaces__quals__j_e_i_Any_j_e_i_Default"));
        instance.onSelectPlaceEvent(event);
      }
      public String toString() {
        return "Observer: org.uberfire.client.workbench.events.PlaceGainFocusEvent []";
      }
    });
    CDI.subscribeLocal("org.uberfire.client.workbench.events.PlaceMinimizedEvent", new AbstractCDIEventCallback<PlaceMinimizedEvent>() {
      public void fireEvent(final PlaceMinimizedEvent event) {
        final LibraryPlaces instance = Factory.maybeUnwrapProxy((LibraryPlaces) context.getInstance("Type_factory__o_k_w_c_s_l_c_u_LibraryPlaces__quals__j_e_i_Any_j_e_i_Default"));
        instance.showDocksWhenMinimizingEditor(event);
      }
      public String toString() {
        return "Observer: org.uberfire.client.workbench.events.PlaceMinimizedEvent []";
      }
    });
    CDI.subscribeLocal("org.uberfire.client.workbench.events.PlaceMaximizedEvent", new AbstractCDIEventCallback<PlaceMaximizedEvent>() {
      public void fireEvent(final PlaceMaximizedEvent event) {
        final LibraryPlaces instance = Factory.maybeUnwrapProxy((LibraryPlaces) context.getInstance("Type_factory__o_k_w_c_s_l_c_u_LibraryPlaces__quals__j_e_i_Any_j_e_i_Default"));
        instance.hideDocksWhenMaximizingEditor(event);
      }
      public String toString() {
        return "Observer: org.uberfire.client.workbench.events.PlaceMaximizedEvent []";
      }
    });
    CDI.subscribe("org.kie.workbench.common.screens.library.api.ProjectAssetListUpdated", new AbstractCDIEventCallback<ProjectAssetListUpdated>() {
      {
        qualifierSet.add("org.kie.workbench.common.screens.library.api.Remote");
      }
      public void fireEvent(final ProjectAssetListUpdated event) {
        final LibraryPlaces instance = Factory.maybeUnwrapProxy((LibraryPlaces) context.getInstance("Type_factory__o_k_w_c_s_l_c_u_LibraryPlaces__quals__j_e_i_Any_j_e_i_Default"));
        instance.onAssetListUpdateEvent(event);
      }
      public String toString() {
        return "Observer: org.kie.workbench.common.screens.library.api.ProjectAssetListUpdated [@org.kie.workbench.common.screens.library.api.Remote()]";
      }
    });
    ErraiBus.get().subscribe("cdi.event:org.kie.workbench.common.screens.library.api.ProjectAssetListUpdated", CDI.ROUTING_CALLBACK);
    CDI.subscribeLocal("org.kie.workbench.common.widgets.client.handlers.NewResourceSuccessEvent", new AbstractCDIEventCallback<NewResourceSuccessEvent>() {
      public void fireEvent(final NewResourceSuccessEvent event) {
        final LibraryPlaces instance = Factory.maybeUnwrapProxy((LibraryPlaces) context.getInstance("Type_factory__o_k_w_c_s_l_c_u_LibraryPlaces__quals__j_e_i_Any_j_e_i_Default"));
        instance.onNewResourceCreated(event);
      }
      public String toString() {
        return "Observer: org.kie.workbench.common.widgets.client.handlers.NewResourceSuccessEvent []";
      }
    });
    CDI.subscribeLocal("org.uberfire.ext.editor.commons.client.event.ConcurrentRenameAcceptedEvent", new AbstractCDIEventCallback<ConcurrentRenameAcceptedEvent>() {
      public void fireEvent(final ConcurrentRenameAcceptedEvent event) {
        final LibraryPlaces instance = Factory.maybeUnwrapProxy((LibraryPlaces) context.getInstance("Type_factory__o_k_w_c_s_l_c_u_LibraryPlaces__quals__j_e_i_Any_j_e_i_Default"));
        instance.onAssetRenamedAccepted(event);
      }
      public String toString() {
        return "Observer: org.uberfire.ext.editor.commons.client.event.ConcurrentRenameAcceptedEvent []";
      }
    });
    CDI.subscribe("org.guvnor.structure.repositories.RepositoryRemovedEvent", new AbstractCDIEventCallback<RepositoryRemovedEvent>() {
      public void fireEvent(final RepositoryRemovedEvent event) {
        final LibraryPlaces instance = Factory.maybeUnwrapProxy((LibraryPlaces) context.getInstance("Type_factory__o_k_w_c_s_l_c_u_LibraryPlaces__quals__j_e_i_Any_j_e_i_Default"));
        instance.onProjectDeleted(event);
      }
      public String toString() {
        return "Observer: org.guvnor.structure.repositories.RepositoryRemovedEvent []";
      }
    });
    ErraiBus.get().subscribe("cdi.event:org.guvnor.structure.repositories.RepositoryRemovedEvent", CDI.ROUTING_CALLBACK);
    CDI.subscribe("org.guvnor.structure.organizationalunit.RemoveOrganizationalUnitEvent", new AbstractCDIEventCallback<RemoveOrganizationalUnitEvent>() {
      public void fireEvent(final RemoveOrganizationalUnitEvent event) {
        final LibraryPlaces instance = Factory.maybeUnwrapProxy((LibraryPlaces) context.getInstance("Type_factory__o_k_w_c_s_l_c_u_LibraryPlaces__quals__j_e_i_Any_j_e_i_Default"));
        instance.onOrganizationalUnitRemoved(event);
      }
      public String toString() {
        return "Observer: org.guvnor.structure.organizationalunit.RemoveOrganizationalUnitEvent []";
      }
    });
    ErraiBus.get().subscribe("cdi.event:org.guvnor.structure.organizationalunit.RemoveOrganizationalUnitEvent", CDI.ROUTING_CALLBACK);
    CDI.subscribeLocal("org.kie.workbench.common.screens.library.client.events.AssetDetailEvent", new AbstractCDIEventCallback<AssetDetailEvent>() {
      public void fireEvent(final AssetDetailEvent event) {
        final LibraryPlaces instance = Factory.maybeUnwrapProxy((LibraryPlaces) context.getInstance("Type_factory__o_k_w_c_s_l_c_u_LibraryPlaces__quals__j_e_i_Any_j_e_i_Default"));
        instance.onAssetSelected(event);
      }
      public String toString() {
        return "Observer: org.kie.workbench.common.screens.library.client.events.AssetDetailEvent []";
      }
    });
    CDI.subscribeLocal("org.uberfire.ext.preferences.client.event.PreferencesCentralSaveEvent", new AbstractCDIEventCallback<PreferencesCentralSaveEvent>() {
      public void fireEvent(final PreferencesCentralSaveEvent event) {
        final LibraryPlaces instance = Factory.maybeUnwrapProxy((LibraryPlaces) context.getInstance("Type_factory__o_k_w_c_s_l_c_u_LibraryPlaces__quals__j_e_i_Any_j_e_i_Default"));
        instance.onPreferencesSave(event);
      }
      public String toString() {
        return "Observer: org.uberfire.ext.preferences.client.event.PreferencesCentralSaveEvent []";
      }
    });
    CDI.subscribeLocal("org.uberfire.ext.preferences.client.event.PreferencesCentralUndoChangesEvent", new AbstractCDIEventCallback<PreferencesCentralUndoChangesEvent>() {
      public void fireEvent(final PreferencesCentralUndoChangesEvent event) {
        final LibraryPlaces instance = Factory.maybeUnwrapProxy((LibraryPlaces) context.getInstance("Type_factory__o_k_w_c_s_l_c_u_LibraryPlaces__quals__j_e_i_Any_j_e_i_Default"));
        instance.onPreferencesCancel(event);
      }
      public String toString() {
        return "Observer: org.uberfire.ext.preferences.client.event.PreferencesCentralUndoChangesEvent []";
      }
    });
    CDI.subscribe("org.ext.uberfire.social.activities.model.SocialFileSelectedEvent", new AbstractCDIEventCallback<SocialFileSelectedEvent>() {
      public void fireEvent(final SocialFileSelectedEvent event) {
        final LibraryPlaces instance = Factory.maybeUnwrapProxy((LibraryPlaces) context.getInstance("Type_factory__o_k_w_c_s_l_c_u_LibraryPlaces__quals__j_e_i_Any_j_e_i_Default"));
        instance.onSocialFileSelected(event);
      }
      public String toString() {
        return "Observer: org.ext.uberfire.social.activities.model.SocialFileSelectedEvent []";
      }
    });
    ErraiBus.get().subscribe("cdi.event:org.ext.uberfire.social.activities.model.SocialFileSelectedEvent", CDI.ROUTING_CALLBACK);
    CDI.subscribe("org.uberfire.workbench.events.ResourceDeletedEvent", new AbstractCDIEventCallback<ResourceDeletedEvent>() {
      public void fireEvent(final ResourceDeletedEvent event) {
        final LibraryPlaces instance = Factory.maybeUnwrapProxy((LibraryPlaces) context.getInstance("Type_factory__o_k_w_c_s_l_c_u_LibraryPlaces__quals__j_e_i_Any_j_e_i_Default"));
        instance.onDeletedResource(event);
      }
      public String toString() {
        return "Observer: org.uberfire.workbench.events.ResourceDeletedEvent []";
      }
    });
    ErraiBus.get().subscribe("cdi.event:org.uberfire.workbench.events.ResourceDeletedEvent", CDI.ROUTING_CALLBACK);
    CDI.subscribeLocal("org.uberfire.ext.editor.commons.client.event.ConcurrentDeleteAcceptedEvent", new AbstractCDIEventCallback<ConcurrentDeleteAcceptedEvent>() {
      public void fireEvent(final ConcurrentDeleteAcceptedEvent event) {
        final LibraryPlaces instance = Factory.maybeUnwrapProxy((LibraryPlaces) context.getInstance("Type_factory__o_k_w_c_s_l_c_u_LibraryPlaces__quals__j_e_i_Any_j_e_i_Default"));
        instance.onConcurrentDelete(event);
      }
      public String toString() {
        return "Observer: org.uberfire.ext.editor.commons.client.event.ConcurrentDeleteAcceptedEvent []";
      }
    });
  }

  public LibraryPlaces createInstance(final ContextManager contextManager) {
    final AuthoringWorkbenchDocks _docks_8 = (AuthoringWorkbenchDocks) contextManager.getInstance("Type_factory__o_k_w_c_w_c_d_AuthoringWorkbenchDocks__quals__j_e_i_Any_j_e_i_Default");
    final LibraryBreadcrumbs _libraryBreadcrumbs_17 = (LibraryBreadcrumbs) contextManager.getInstance("Type_factory__o_k_w_c_s_l_c_u_b_LibraryBreadcrumbs__quals__j_e_i_Any_j_e_i_Default");
    final Caller<LibraryService> _libraryService_3 = (Caller) contextManager.getContextualInstance("ContextualProvider_factory__o_j_e_c_c_a_Caller__quals__Universal", new Class[] { LibraryService.class }, new Annotation[] { });
    final Event<ProjectAssetListUpdated> _assetListUpdatedEvent_14 = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { ProjectAssetListUpdated.class }, new Annotation[] { new Routed() {
        public Class annotationType() {
          return Routed.class;
        }
        public String toString() {
          return "@org.kie.workbench.common.screens.library.api.Routed()";
        }
    } });
    final TranslationUtils _translationUtils_11 = (TranslationUtils) contextManager.getInstance("Type_factory__o_k_w_c_s_l_c_u_TranslationUtils__quals__j_e_i_Any_j_e_i_Default");
    final ManagedInstance<ImportRepositoryPopUpPresenter> _importRepositoryPopUpPresenters_13 = (ManagedInstance) contextManager.getContextualInstance("ContextualProvider_factory__o_j_e_i_c_a_ManagedInstance__quals__Universal", new Class[] { ImportRepositoryPopUpPresenter.class }, new Annotation[] { });
    final Caller<KieModuleService> _moduleService_5 = (Caller) contextManager.getContextualInstance("ContextualProvider_factory__o_j_e_c_c_a_Caller__quals__Universal", new Class[] { KieModuleService.class }, new Annotation[] { });
    final PlaceManager _placeManager_6 = (PlaceManagerImpl) contextManager.getInstance("Type_factory__o_u_c_m_PlaceManagerImpl__quals__j_e_i_Any_j_e_i_Default");
    final Caller<VFSService> _vfsService_12 = (Caller) contextManager.getContextualInstance("ContextualProvider_factory__o_j_e_c_c_a_Caller__quals__Universal", new Class[] { VFSService.class }, new Annotation[] { });
    final Event<ImportProjectsSetupEvent> _importProjectsSetupEvent_16 = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { ImportProjectsSetupEvent.class }, new Annotation[] { new Source() {
        public Class annotationType() {
          return Source.class;
        }
        public String toString() {
          return "@org.kie.workbench.common.screens.library.client.screens.importrepository.Source(value=EXTERNAL)";
        }
        public Kind value() {
          return Kind.EXTERNAL;
        }
    } });
    final Event<AssetDetailEvent> _assetDetailEvent_2 = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { AssetDetailEvent.class }, new Annotation[] { });
    final Caller<WorkspaceProjectService> _projectService_4 = (Caller) contextManager.getContextualInstance("ContextualProvider_factory__o_j_e_c_c_a_Caller__quals__Universal", new Class[] { WorkspaceProjectService.class }, new Annotation[] { });
    final WorkspaceProjectContext _projectContext_7 = (WorkspaceProjectContext) contextManager.getInstance("Type_factory__o_g_c_s_p_c_c_WorkspaceProjectContext__quals__j_e_i_Any_j_e_i_Default");
    final Event<NotificationEvent> _notificationEvent_10 = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { NotificationEvent.class }, new Annotation[] { });
    final Event<WorkspaceProjectContextChangeEvent> _projectContextChangeEvent_9 = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { WorkspaceProjectContextChangeEvent.class }, new Annotation[] { });
    final SessionInfo _sessionInfo_18 = (SessionInfo) contextManager.getInstance("Producer_factory__o_u_r_SessionInfo__quals__j_e_i_Any_j_e_i_Default");
    final Caller<RepositoryService> _repositoryService_20 = (Caller) contextManager.getContextualInstance("ContextualProvider_factory__o_j_e_c_c_a_Caller__quals__Universal", new Class[] { RepositoryService.class }, new Annotation[] { });
    final LibraryInternalPreferences _libraryInternalPreferences_19 = (LibraryInternalPreferencesBeanGeneratedImpl) contextManager.getInstance("Type_factory__o_k_w_c_s_l_a_p_LibraryInternalPreferencesBeanGeneratedImpl__quals__j_e_i_Any_j_e_i_Default");
    final TranslationService _ts_1 = (TranslationService) contextManager.getInstance("Provider_factory__o_j_e_u_c_l_s_TranslationService__quals__j_e_i_Any_j_e_i_Default");
    final UberfireBreadcrumbs _breadcrumbs_0 = (UberfireBreadcrumbs) contextManager.getInstance("Type_factory__o_u_e_w_c_c_b_UberfireBreadcrumbs__quals__j_e_i_Any_j_e_i_Default");
    final CloseUnsavedProjectAssetsPopUpPresenter _closeUnsavedProjectAssetsPopUpPresenter_15 = (CloseUnsavedProjectAssetsPopUpPresenter) contextManager.getInstance("Type_factory__o_k_w_c_s_l_c_s_p_c_CloseUnsavedProjectAssetsPopUpPresenter__quals__j_e_i_Any_j_e_i_Default");
    final LibraryPlaces instance = new LibraryPlaces(_breadcrumbs_0, _ts_1, _assetDetailEvent_2, _libraryService_3, _projectService_4, _moduleService_5, _placeManager_6, _projectContext_7, _docks_8, _projectContextChangeEvent_9, _notificationEvent_10, _translationUtils_11, _vfsService_12, _importRepositoryPopUpPresenters_13, _assetListUpdatedEvent_14, _closeUnsavedProjectAssetsPopUpPresenter_15, _importProjectsSetupEvent_16, _libraryBreadcrumbs_17, _sessionInfo_18, _libraryInternalPreferences_19, _repositoryService_20);
    registerDependentScopedReference(instance, _libraryBreadcrumbs_17);
    registerDependentScopedReference(instance, _libraryService_3);
    registerDependentScopedReference(instance, _assetListUpdatedEvent_14);
    registerDependentScopedReference(instance, _importRepositoryPopUpPresenters_13);
    registerDependentScopedReference(instance, _moduleService_5);
    registerDependentScopedReference(instance, _vfsService_12);
    registerDependentScopedReference(instance, _importProjectsSetupEvent_16);
    registerDependentScopedReference(instance, _assetDetailEvent_2);
    registerDependentScopedReference(instance, _projectService_4);
    registerDependentScopedReference(instance, _notificationEvent_10);
    registerDependentScopedReference(instance, _projectContextChangeEvent_9);
    registerDependentScopedReference(instance, _repositoryService_20);
    registerDependentScopedReference(instance, _libraryInternalPreferences_19);
    registerDependentScopedReference(instance, _ts_1);
    registerDependentScopedReference(instance, _closeUnsavedProjectAssetsPopUpPresenter_15);
    setIncompleteInstance(instance);
    setIncompleteInstance(null);
    return instance;
  }

  public void invokePostConstructs(final LibraryPlaces instance) {
    instance.setup();
  }

  public Proxy createProxy(final Context context) {
    final Proxy<LibraryPlaces> proxyImpl = new Type_factory__o_k_w_c_s_l_c_u_LibraryPlaces__quals__j_e_i_Any_j_e_i_DefaultProxyImpl();
    proxyImpl.setProxyContext(context);
    return proxyImpl;
  }

  public native static Map LibraryPlaces_getParameterMap(LibraryPlaces instance) /*-{
    return instance.@org.kie.workbench.common.screens.library.client.util.LibraryPlaces::getParameterMap()();
  }-*/;
}