package org.jboss.errai.marshalling.client.api;

import java.util.List;
import java.util.Set;
import org.drools.workbench.models.guided.dtree.shared.model.GuidedDecisionTree;
import org.drools.workbench.models.guided.dtree.shared.model.nodes.TypeNode;
import org.drools.workbench.models.guided.dtree.shared.model.parser.GuidedDecisionTreeParserError;
import org.jboss.errai.marshalling.client.Marshalling;
import org.jboss.errai.marshalling.client.api.json.EJObject;
import org.jboss.errai.marshalling.client.api.json.EJValue;
import org.jboss.errai.marshalling.client.marshallers.ObjectMarshaller;
import org.kie.soup.project.datamodel.imports.Imports;

public class Marshaller_o_d_w_m_g_d_s_m_GuidedDecisionTree_1_Impl implements GeneratedMarshaller<GuidedDecisionTree> {
  private GuidedDecisionTree[] EMPTY_ARRAY = new GuidedDecisionTree[0];
  private Marshaller<Imports> org_kie_soup_project_datamodel_imports_Imports = null;
  private Marshaller<String> java_lang_String = Marshalling.getMarshaller(String.class);
  private Marshaller java_lang_Object = Marshalling.getMarshaller(Object.class);
  private Marshaller<List> java_util_List = Marshalling.getMarshaller(List.class);
  public GuidedDecisionTree[] getEmptyArray() {
    return EMPTY_ARRAY;
  }

  native static List GuidedDecisionTree_List_errors(GuidedDecisionTree instance) /*-{
    return instance.@org.drools.workbench.models.guided.dtree.shared.model.GuidedDecisionTree::errors;
  }-*/;

  native static void GuidedDecisionTree_List_errors(GuidedDecisionTree instance, List<GuidedDecisionTreeParserError> value) /*-{
    instance.@org.drools.workbench.models.guided.dtree.shared.model.GuidedDecisionTree::errors = value;
  }-*/;

  public GuidedDecisionTree demarshall(EJValue a0, MarshallingSession a1) {
    lazyInit();
    EJObject obj = a0.isObject();
    if (obj == null) {
      return null;
    }
    String objId = obj.get("^ObjectID").isString().stringValue();
    if (a1.hasObject(objId)) {
      return a1.getObject(GuidedDecisionTree.class, objId);
    }
    GuidedDecisionTree entity = new GuidedDecisionTree();
    a1.recordObject(objId, entity);
    final Set<String> keys = obj.keySet();
    for (String key : keys) {
      if (key.equals("^EncodedType") || key.equals("^ObjectID")) {
        continue;
      }
      EJValue objVal = obj.getIfNotNull(key);
      if (objVal == null) {
        continue;
      }
      switch (key) {
        case "imports": entity.setImports(org_kie_soup_project_datamodel_imports_Imports.demarshall(objVal, a1));
        break;
        case "packageName": entity.setPackageName(java_lang_String.demarshall(objVal, a1));
        break;
        case "treeName": entity.setTreeName(java_lang_String.demarshall(objVal, a1));
        break;
        case "root": entity.setRoot((TypeNode) ((ObjectMarshaller) java_lang_Object).demarshall(TypeNode.class, objVal, a1));
        break;
        case "errors": a1.setAssumedElementType("org.drools.workbench.models.guided.dtree.shared.model.parser.GuidedDecisionTreeParserError");
        GuidedDecisionTree_List_errors(entity, java_util_List.demarshall(objVal, a1));
        break;
      }
    }
    return entity;
  }

  public String marshall(GuidedDecisionTree a0, MarshallingSession a1) {
    lazyInit();
    if (a0 == null) {
      return "null";
    }
    final boolean ref = a1.hasObject(a0);
    final String prefix = ((((((((("" + "{\"") + "^EncodedType") + "\":\"") + "org.drools.workbench.models.guided.dtree.shared.model.GuidedDecisionTree") + "\"") + ",\"") + "^ObjectID") + "\":\"") + a1.getObject(a0)) + "\"";
    if (ref) {
      return prefix + "}";
    }
    return prefix + ((((((((((((((((((((("" + ",\"") + "imports") + "\":") + org_kie_soup_project_datamodel_imports_Imports.marshall(a0.getImports(), a1)) + ",\"") + "packageName") + "\":") + java_lang_String.marshall(a0.getPackageName(), a1)) + ",\"") + "treeName") + "\":") + java_lang_String.marshall(a0.getTreeName(), a1)) + ",\"") + "root") + "\":") + java_lang_Object.marshall(a0.getRoot(), a1)) + ",\"") + "errors") + "\":") + java_util_List.marshall(GuidedDecisionTree_List_errors(a0), a1)) + "}");
  }

  private void lazyInit() {
    if (org_kie_soup_project_datamodel_imports_Imports == null) {
      org_kie_soup_project_datamodel_imports_Imports = Marshalling.getMarshaller(Imports.class);
    }
  }
}