package org.jboss.errai.marshalling.client.api;

import java.util.ArrayList;
import java.util.Map;
import java.util.Set;
import org.guvnor.common.services.project.builder.model.BuildMessage;
import org.guvnor.common.services.project.builder.model.BuildResults;
import org.guvnor.common.services.project.model.GAV;
import org.jboss.errai.marshalling.client.Marshalling;
import org.jboss.errai.marshalling.client.api.json.EJObject;
import org.jboss.errai.marshalling.client.api.json.EJValue;
import org.jboss.errai.marshalling.client.marshallers.ObjectMarshaller;

public class Marshaller_o_g_c_s_p_b_m_BuildResults_1_Impl implements GeneratedMarshaller<BuildResults> {
  private BuildResults[] EMPTY_ARRAY = new BuildResults[0];
  private Marshaller java_lang_Object = Marshalling.getMarshaller(Object.class);
  private Marshaller<ArrayList> java_util_ArrayList = null;
  private Marshaller<Map> java_util_Map = Marshalling.getMarshaller(Map.class);
  public BuildResults[] getEmptyArray() {
    return EMPTY_ARRAY;
  }

  native static GAV BuildResults_GAV_gav(BuildResults instance) /*-{
    return instance.@org.guvnor.common.services.project.builder.model.BuildResults::gav;
  }-*/;

  native static void BuildResults_GAV_gav(BuildResults instance, GAV value) /*-{
    instance.@org.guvnor.common.services.project.builder.model.BuildResults::gav = value;
  }-*/;

  native static ArrayList BuildResults_ArrayList_messages(BuildResults instance) /*-{
    return instance.@org.guvnor.common.services.project.builder.model.BuildResults::messages;
  }-*/;

  native static void BuildResults_ArrayList_messages(BuildResults instance, ArrayList<BuildMessage> value) /*-{
    instance.@org.guvnor.common.services.project.builder.model.BuildResults::messages = value;
  }-*/;

  native static Map BuildResults_Map_parameters(BuildResults instance) /*-{
    return instance.@org.guvnor.common.services.project.builder.model.BuildResults::parameters;
  }-*/;

  native static void BuildResults_Map_parameters(BuildResults instance, Map<String, String> value) /*-{
    instance.@org.guvnor.common.services.project.builder.model.BuildResults::parameters = value;
  }-*/;

  public BuildResults demarshall(EJValue a0, MarshallingSession a1) {
    lazyInit();
    EJObject obj = a0.isObject();
    if (obj == null) {
      return null;
    }
    String objId = obj.get("^ObjectID").isString().stringValue();
    if (a1.hasObject(objId)) {
      return a1.getObject(BuildResults.class, objId);
    }
    BuildResults entity = new BuildResults();
    a1.recordObject(objId, entity);
    final Set<String> keys = obj.keySet();
    for (String key : keys) {
      if (key.equals("^EncodedType") || key.equals("^ObjectID")) {
        continue;
      }
      EJValue objVal = obj.getIfNotNull(key);
      if (objVal == null) {
        continue;
      }
      switch (key) {
        case "gav": BuildResults_GAV_gav(entity, (GAV) ((ObjectMarshaller) java_lang_Object).demarshall(GAV.class, objVal, a1));
        break;
        case "messages": a1.setAssumedElementType("org.guvnor.common.services.project.builder.model.BuildMessage");
        BuildResults_ArrayList_messages(entity, java_util_ArrayList.demarshall(objVal, a1));
        break;
        case "parameters": a1.setAssumedMapKeyType("java.lang.String");
        a1.setAssumedMapValueType("java.lang.String");
        BuildResults_Map_parameters(entity, java_util_Map.demarshall(objVal, a1));
        a1.resetAssumedTypes();
        break;
      }
    }
    return entity;
  }

  public String marshall(BuildResults a0, MarshallingSession a1) {
    lazyInit();
    if (a0 == null) {
      return "null";
    }
    final boolean ref = a1.hasObject(a0);
    final String prefix = ((((((((("" + "{\"") + "^EncodedType") + "\":\"") + "org.guvnor.common.services.project.builder.model.BuildResults") + "\"") + ",\"") + "^ObjectID") + "\":\"") + a1.getObject(a0)) + "\"";
    if (ref) {
      return prefix + "}";
    }
    return prefix + ((((((((((((("" + ",\"") + "gav") + "\":") + java_lang_Object.marshall(a0.getGAV(), a1)) + ",\"") + "messages") + "\":") + java_util_ArrayList.marshall(BuildResults_ArrayList_messages(a0), a1)) + ",\"") + "parameters") + "\":") + java_util_Map.marshall(a0.getParameters(), a1)) + "}");
  }

  private void lazyInit() {
    if (java_util_ArrayList == null) {
      java_util_ArrayList = Marshalling.getMarshaller(ArrayList.class);
    }
  }
}