package org.jboss.errai.marshalling.client.api;

import java.util.Set;
import org.guvnor.common.services.project.model.Module;
import org.guvnor.common.services.project.model.WorkspaceProject;
import org.guvnor.structure.organizationalunit.OrganizationalUnit;
import org.guvnor.structure.repositories.Branch;
import org.guvnor.structure.repositories.Repository;
import org.jboss.errai.marshalling.client.Marshalling;
import org.jboss.errai.marshalling.client.api.json.EJObject;
import org.jboss.errai.marshalling.client.api.json.EJValue;
import org.jboss.errai.marshalling.client.marshallers.ObjectMarshaller;

public class Marshaller_o_g_c_s_p_m_WorkspaceProject_1_Impl implements GeneratedMarshaller<WorkspaceProject> {
  private WorkspaceProject[] EMPTY_ARRAY = new WorkspaceProject[0];
  private Marshaller java_lang_Object = Marshalling.getMarshaller(Object.class);
  private Marshaller<Branch> org_guvnor_structure_repositories_Branch = null;
  private Marshaller<Boolean> java_lang_Boolean = Marshalling.getMarshaller(Boolean.class);
  public WorkspaceProject[] getEmptyArray() {
    return EMPTY_ARRAY;
  }

  native static Repository WorkspaceProject_Repository_repository(WorkspaceProject instance) /*-{
    return instance.@org.guvnor.common.services.project.model.WorkspaceProject::repository;
  }-*/;

  native static void WorkspaceProject_Repository_repository(WorkspaceProject instance, Repository value) /*-{
    instance.@org.guvnor.common.services.project.model.WorkspaceProject::repository = value;
  }-*/;

  native static Branch WorkspaceProject_Branch_branch(WorkspaceProject instance) /*-{
    return instance.@org.guvnor.common.services.project.model.WorkspaceProject::branch;
  }-*/;

  native static void WorkspaceProject_Branch_branch(WorkspaceProject instance, Branch value) /*-{
    instance.@org.guvnor.common.services.project.model.WorkspaceProject::branch = value;
  }-*/;

  native static Module WorkspaceProject_Module_mainModule(WorkspaceProject instance) /*-{
    return instance.@org.guvnor.common.services.project.model.WorkspaceProject::mainModule;
  }-*/;

  native static void WorkspaceProject_Module_mainModule(WorkspaceProject instance, Module value) /*-{
    instance.@org.guvnor.common.services.project.model.WorkspaceProject::mainModule = value;
  }-*/;

  native static OrganizationalUnit WorkspaceProject_OrganizationalUnit_organizationalUnit(WorkspaceProject instance) /*-{
    return instance.@org.guvnor.common.services.project.model.WorkspaceProject::organizationalUnit;
  }-*/;

  native static void WorkspaceProject_OrganizationalUnit_organizationalUnit(WorkspaceProject instance, OrganizationalUnit value) /*-{
    instance.@org.guvnor.common.services.project.model.WorkspaceProject::organizationalUnit = value;
  }-*/;

  native static boolean WorkspaceProject_boolean_requiresRefresh(WorkspaceProject instance) /*-{
    return instance.@org.guvnor.common.services.project.model.WorkspaceProject::requiresRefresh;
  }-*/;

  native static void WorkspaceProject_boolean_requiresRefresh(WorkspaceProject instance, boolean value) /*-{
    instance.@org.guvnor.common.services.project.model.WorkspaceProject::requiresRefresh = value;
  }-*/;

  public WorkspaceProject demarshall(EJValue a0, MarshallingSession a1) {
    lazyInit();
    EJObject obj = a0.isObject();
    if (obj == null) {
      return null;
    }
    String objId = obj.get("^ObjectID").isString().stringValue();
    if (a1.hasObject(objId)) {
      return a1.getObject(WorkspaceProject.class, objId);
    }
    WorkspaceProject entity = new WorkspaceProject();
    a1.recordObject(objId, entity);
    final Set<String> keys = obj.keySet();
    for (String key : keys) {
      if (key.equals("^EncodedType") || key.equals("^ObjectID")) {
        continue;
      }
      EJValue objVal = obj.getIfNotNull(key);
      if (objVal == null) {
        continue;
      }
      switch (key) {
        case "repository": WorkspaceProject_Repository_repository(entity, (Repository) ((ObjectMarshaller) java_lang_Object).demarshall(Repository.class, objVal, a1));
        break;
        case "branch": WorkspaceProject_Branch_branch(entity, org_guvnor_structure_repositories_Branch.demarshall(objVal, a1));
        break;
        case "mainModule": WorkspaceProject_Module_mainModule(entity, (Module) ((ObjectMarshaller) java_lang_Object).demarshall(Module.class, objVal, a1));
        break;
        case "organizationalUnit": WorkspaceProject_OrganizationalUnit_organizationalUnit(entity, (OrganizationalUnit) ((ObjectMarshaller) java_lang_Object).demarshall(OrganizationalUnit.class, objVal, a1));
        break;
        case "requiresRefresh": WorkspaceProject_boolean_requiresRefresh(entity, java_lang_Boolean.demarshall(objVal, a1));
        break;
      }
    }
    return entity;
  }

  public String marshall(WorkspaceProject a0, MarshallingSession a1) {
    lazyInit();
    if (a0 == null) {
      return "null";
    }
    final boolean ref = a1.hasObject(a0);
    final String prefix = ((((((((("" + "{\"") + "^EncodedType") + "\":\"") + "org.guvnor.common.services.project.model.WorkspaceProject") + "\"") + ",\"") + "^ObjectID") + "\":\"") + a1.getObject(a0)) + "\"";
    if (ref) {
      return prefix + "}";
    }
    return prefix + ((((((((((((((((((((("" + ",\"") + "repository") + "\":") + java_lang_Object.marshall(a0.getRepository(), a1)) + ",\"") + "branch") + "\":") + org_guvnor_structure_repositories_Branch.marshall(a0.getBranch(), a1)) + ",\"") + "mainModule") + "\":") + java_lang_Object.marshall(a0.getMainModule(), a1)) + ",\"") + "organizationalUnit") + "\":") + java_lang_Object.marshall(a0.getOrganizationalUnit(), a1)) + ",\"") + "requiresRefresh") + "\":") + java_lang_Boolean.marshall(WorkspaceProject_boolean_requiresRefresh(a0), a1)) + "}");
  }

  private void lazyInit() {
    if (org_guvnor_structure_repositories_Branch == null) {
      org_guvnor_structure_repositories_Branch = Marshalling.getMarshaller(Branch.class);
    }
  }
}