package org.jboss.errai.marshalling.client.api;

import com.google.gwt.core.shared.GWT;
import java.util.List;
import java.util.Set;
import org.guvnor.common.services.workingset.client.factconstraints.ConstraintConfiguration;
import org.guvnor.common.services.workingset.client.factconstraints.customform.CustomFormConfiguration;
import org.guvnor.common.services.workingset.client.model.WorkingSetConfigData;
import org.jboss.errai.marshalling.client.Marshalling;
import org.jboss.errai.marshalling.client.api.json.EJObject;
import org.jboss.errai.marshalling.client.api.json.EJValue;
import org.jboss.errai.marshalling.client.marshallers.QualifyingMarshallerWrapper;

public class Marshaller_o_g_c_s_w_c_m_WorkingSetConfigData_1_Impl implements GeneratedMarshaller<WorkingSetConfigData> {
  private WorkingSetConfigData[] EMPTY_ARRAY = new WorkingSetConfigData[0];
  private Marshaller<String> java_lang_String = Marshalling.getMarshaller(String.class);
  private Marshaller<List> java_util_List = Marshalling.getMarshaller(List.class);
  private Marshaller<String[]> arrayOf_java_lang_String_D1 = Marshalling.getMarshaller(String[].class, new DeferredMarshallerCreationCallback<String[]>() {
    public Marshaller<String[]> create(Class type) {
      return new QualifyingMarshallerWrapper((Marshaller) GWT.create(Marshaller_for_arrayOf_java_lang_String_D1.class), String[].class);
    }
  });
  private Marshaller<WorkingSetConfigData[]> arrayOf_org_guvnor_common_services_workingset_client_model_WorkingSetConfigData_D1 = null;
  abstract class Marshaller_for_arrayOf_java_lang_String_D1 implements GeneratedMarshaller { }
  abstract class Marshaller_for_arrayOf_org_guvnor_common_services_workingset_client_model_WorkingSetConfigData_D1 implements GeneratedMarshaller { }
  public WorkingSetConfigData[] getEmptyArray() {
    return EMPTY_ARRAY;
  }

  native static String WorkingSetConfigData_String_name(WorkingSetConfigData instance) /*-{
    return instance.@org.guvnor.common.services.workingset.client.model.WorkingSetConfigData::name;
  }-*/;

  native static void WorkingSetConfigData_String_name(WorkingSetConfigData instance, String value) /*-{
    instance.@org.guvnor.common.services.workingset.client.model.WorkingSetConfigData::name = value;
  }-*/;

  native static String WorkingSetConfigData_String_description(WorkingSetConfigData instance) /*-{
    return instance.@org.guvnor.common.services.workingset.client.model.WorkingSetConfigData::description;
  }-*/;

  native static void WorkingSetConfigData_String_description(WorkingSetConfigData instance, String value) /*-{
    instance.@org.guvnor.common.services.workingset.client.model.WorkingSetConfigData::description = value;
  }-*/;

  native static List WorkingSetConfigData_List_constraints(WorkingSetConfigData instance) /*-{
    return instance.@org.guvnor.common.services.workingset.client.model.WorkingSetConfigData::constraints;
  }-*/;

  native static void WorkingSetConfigData_List_constraints(WorkingSetConfigData instance, List<ConstraintConfiguration> value) /*-{
    instance.@org.guvnor.common.services.workingset.client.model.WorkingSetConfigData::constraints = value;
  }-*/;

  native static List WorkingSetConfigData_List_customForms(WorkingSetConfigData instance) /*-{
    return instance.@org.guvnor.common.services.workingset.client.model.WorkingSetConfigData::customForms;
  }-*/;

  native static void WorkingSetConfigData_List_customForms(WorkingSetConfigData instance, List<CustomFormConfiguration> value) /*-{
    instance.@org.guvnor.common.services.workingset.client.model.WorkingSetConfigData::customForms = value;
  }-*/;

  native static String[] WorkingSetConfigData_String_array_validFacts(WorkingSetConfigData instance) /*-{
    return instance.@org.guvnor.common.services.workingset.client.model.WorkingSetConfigData::validFacts;
  }-*/;

  native static void WorkingSetConfigData_String_array_validFacts(WorkingSetConfigData instance, String[] value) /*-{
    instance.@org.guvnor.common.services.workingset.client.model.WorkingSetConfigData::validFacts = value;
  }-*/;

  native static WorkingSetConfigData[] WorkingSetConfigData_WorkingSetConfigData_array_workingSets(WorkingSetConfigData instance) /*-{
    return instance.@org.guvnor.common.services.workingset.client.model.WorkingSetConfigData::workingSets;
  }-*/;

  native static void WorkingSetConfigData_WorkingSetConfigData_array_workingSets(WorkingSetConfigData instance, WorkingSetConfigData[] value) /*-{
    instance.@org.guvnor.common.services.workingset.client.model.WorkingSetConfigData::workingSets = value;
  }-*/;

  public WorkingSetConfigData demarshall(EJValue a0, MarshallingSession a1) {
    lazyInit();
    EJObject obj = a0.isObject();
    if (obj == null) {
      return null;
    }
    String objId = obj.get("^ObjectID").isString().stringValue();
    if (a1.hasObject(objId)) {
      return a1.getObject(WorkingSetConfigData.class, objId);
    }
    WorkingSetConfigData entity = new WorkingSetConfigData();
    a1.recordObject(objId, entity);
    final Set<String> keys = obj.keySet();
    for (String key : keys) {
      if (key.equals("^EncodedType") || key.equals("^ObjectID")) {
        continue;
      }
      EJValue objVal = obj.getIfNotNull(key);
      if (objVal == null) {
        continue;
      }
      switch (key) {
        case "name": WorkingSetConfigData_String_name(entity, java_lang_String.demarshall(objVal, a1));
        break;
        case "description": WorkingSetConfigData_String_description(entity, java_lang_String.demarshall(objVal, a1));
        break;
        case "constraints": a1.setAssumedElementType("org.guvnor.common.services.workingset.client.factconstraints.ConstraintConfiguration");
        WorkingSetConfigData_List_constraints(entity, java_util_List.demarshall(objVal, a1));
        break;
        case "customForms": a1.setAssumedElementType("org.guvnor.common.services.workingset.client.factconstraints.customform.CustomFormConfiguration");
        WorkingSetConfigData_List_customForms(entity, java_util_List.demarshall(objVal, a1));
        break;
        case "validFacts": WorkingSetConfigData_String_array_validFacts(entity, arrayOf_java_lang_String_D1.demarshall(objVal, a1));
        break;
        case "workingSets": WorkingSetConfigData_WorkingSetConfigData_array_workingSets(entity, arrayOf_org_guvnor_common_services_workingset_client_model_WorkingSetConfigData_D1.demarshall(objVal, a1));
        break;
      }
    }
    return entity;
  }

  public String marshall(WorkingSetConfigData a0, MarshallingSession a1) {
    lazyInit();
    if (a0 == null) {
      return "null";
    }
    final boolean ref = a1.hasObject(a0);
    final String prefix = ((((((((("" + "{\"") + "^EncodedType") + "\":\"") + "org.guvnor.common.services.workingset.client.model.WorkingSetConfigData") + "\"") + ",\"") + "^ObjectID") + "\":\"") + a1.getObject(a0)) + "\"";
    if (ref) {
      return prefix + "}";
    }
    return prefix + ((((((((((((((((((((((((("" + ",\"") + "name") + "\":") + java_lang_String.marshall(a0.getName(), a1)) + ",\"") + "description") + "\":") + java_lang_String.marshall(a0.getDescription(), a1)) + ",\"") + "constraints") + "\":") + java_util_List.marshall(a0.getConstraints(), a1)) + ",\"") + "customForms") + "\":") + java_util_List.marshall(a0.getCustomForms(), a1)) + ",\"") + "validFacts") + "\":") + arrayOf_java_lang_String_D1.marshall(a0.getValidFacts(), a1)) + ",\"") + "workingSets") + "\":") + arrayOf_org_guvnor_common_services_workingset_client_model_WorkingSetConfigData_D1.marshall(a0.getWorkingSets(), a1)) + "}");
  }

  private void lazyInit() {
    if (arrayOf_org_guvnor_common_services_workingset_client_model_WorkingSetConfigData_D1 == null) {
      arrayOf_org_guvnor_common_services_workingset_client_model_WorkingSetConfigData_D1 = Marshalling.getMarshaller(WorkingSetConfigData[].class, new DeferredMarshallerCreationCallback<WorkingSetConfigData[]>() {
        public Marshaller<WorkingSetConfigData[]> create(Class type) {
          return new QualifyingMarshallerWrapper((Marshaller) GWT.create(Marshaller_for_arrayOf_org_guvnor_common_services_workingset_client_model_WorkingSetConfigData_D1.class), WorkingSetConfigData[].class);
        }
      });
    }
  }
}