package org.jboss.errai.marshalling.client.api;

import java.util.List;
import java.util.Set;
import org.guvnor.messageconsole.events.PublishBaseEvent;
import org.guvnor.messageconsole.events.PublishBaseEvent.Place;
import org.guvnor.messageconsole.events.PublishBatchMessagesEvent;
import org.jboss.errai.marshalling.client.Marshalling;
import org.jboss.errai.marshalling.client.api.json.EJObject;
import org.jboss.errai.marshalling.client.api.json.EJValue;

public class Marshaller_o_g_m_e_PublishBatchMessagesEvent_1_Impl implements GeneratedMarshaller<PublishBatchMessagesEvent> {
  private PublishBatchMessagesEvent[] EMPTY_ARRAY = new PublishBatchMessagesEvent[0];
  private Marshaller<Boolean> java_lang_Boolean = Marshalling.getMarshaller(Boolean.class);
  private Marshaller<String> java_lang_String = Marshalling.getMarshaller(String.class);
  private Marshaller<List> java_util_List = Marshalling.getMarshaller(List.class);
  private Marshaller<Place> org_guvnor_messageconsole_events_PublishBaseEvent_erraiD_Place = null;
  public PublishBatchMessagesEvent[] getEmptyArray() {
    return EMPTY_ARRAY;
  }

  public PublishBatchMessagesEvent demarshall(EJValue a0, MarshallingSession a1) {
    lazyInit();
    EJObject obj = a0.isObject();
    if (obj == null) {
      return null;
    }
    String objId = obj.get("^ObjectID").isString().stringValue();
    if (a1.hasObject(objId)) {
      return a1.getObject(PublishBatchMessagesEvent.class, objId);
    }
    PublishBatchMessagesEvent entity = new PublishBatchMessagesEvent();
    a1.recordObject(objId, entity);
    final Set<String> keys = obj.keySet();
    for (String key : keys) {
      if (key.equals("^EncodedType") || key.equals("^ObjectID")) {
        continue;
      }
      EJValue objVal = obj.getIfNotNull(key);
      if (objVal == null) {
        continue;
      }
      switch (key) {
        case "cleanExisting": entity.setCleanExisting(java_lang_Boolean.demarshall(objVal, a1));
        break;
        case "messageType": entity.setMessageType(java_lang_String.demarshall(objVal, a1));
        break;
        case "messagesToUnpublish": a1.setAssumedElementType("org.guvnor.messageconsole.events.SystemMessage");
        entity.setMessagesToUnpublish(java_util_List.demarshall(objVal, a1));
        break;
        case "sessionId": entity.setSessionId(java_lang_String.demarshall(objVal, a1));
        break;
        case "userId": entity.setUserId(java_lang_String.demarshall(objVal, a1));
        break;
        case "place": entity.setPlace(objVal.isObject() != null ? Enum.valueOf(Place.class, objVal.isObject().get("^EnumStringValue").isString().stringValue()) : objVal.isString() != null ? Enum.valueOf(Place.class, objVal.isString().stringValue()) : null);
        break;
        case "messagesToPublish": a1.setAssumedElementType("org.guvnor.messageconsole.events.SystemMessage");
        entity.setMessagesToPublish(java_util_List.demarshall(objVal, a1));
        break;
        case "showSystemConsole": entity.setShowSystemConsole(java_lang_Boolean.demarshall(objVal, a1));
        break;
      }
    }
    return entity;
  }

  native static boolean PublishBatchMessagesEvent_boolean_cleanExisting(PublishBatchMessagesEvent instance) /*-{
    return instance.@org.guvnor.messageconsole.events.PublishBatchMessagesEvent::cleanExisting;
  }-*/;

  native static void PublishBatchMessagesEvent_boolean_cleanExisting(PublishBatchMessagesEvent instance, boolean value) /*-{
    instance.@org.guvnor.messageconsole.events.PublishBatchMessagesEvent::cleanExisting = value;
  }-*/;

  native static boolean PublishBaseEvent_boolean_showSystemConsole(PublishBaseEvent instance) /*-{
    return instance.@org.guvnor.messageconsole.events.PublishBaseEvent::showSystemConsole;
  }-*/;

  native static void PublishBaseEvent_boolean_showSystemConsole(PublishBaseEvent instance, boolean value) /*-{
    instance.@org.guvnor.messageconsole.events.PublishBaseEvent::showSystemConsole = value;
  }-*/;

  public String marshall(PublishBatchMessagesEvent a0, MarshallingSession a1) {
    lazyInit();
    if (a0 == null) {
      return "null";
    }
    final boolean ref = a1.hasObject(a0);
    final String prefix = ((((((((("" + "{\"") + "^EncodedType") + "\":\"") + "org.guvnor.messageconsole.events.PublishBatchMessagesEvent") + "\"") + ",\"") + "^ObjectID") + "\":\"") + a1.getObject(a0)) + "\"";
    if (ref) {
      return prefix + "}";
    }
    return prefix + ((((((((((((((((((((((((((((((((("" + ",\"") + "cleanExisting") + "\":") + java_lang_Boolean.marshall(PublishBatchMessagesEvent_boolean_cleanExisting(a0), a1)) + ",\"") + "messageType") + "\":") + java_lang_String.marshall(a0.getMessageType(), a1)) + ",\"") + "messagesToUnpublish") + "\":") + java_util_List.marshall(a0.getMessagesToUnpublish(), a1)) + ",\"") + "sessionId") + "\":") + java_lang_String.marshall(a0.getSessionId(), a1)) + ",\"") + "userId") + "\":") + java_lang_String.marshall(a0.getUserId(), a1)) + ",\"") + "place") + "\":") + (a0.getPlace() != null ? ((((((("{\"" + "^EncodedType") + "\":\"") + "org.guvnor.messageconsole.events.PublishBaseEvent$Place") + "\",\"") + "^EnumStringValue") + "\":\"") + a0.getPlace().name()) + "\"}" : "null")) + ",\"") + "messagesToPublish") + "\":") + java_util_List.marshall(a0.getMessagesToPublish(), a1)) + ",\"") + "showSystemConsole") + "\":") + java_lang_Boolean.marshall(PublishBaseEvent_boolean_showSystemConsole(a0), a1)) + "}");
  }

  private void lazyInit() {
    if (org_guvnor_messageconsole_events_PublishBaseEvent_erraiD_Place == null) {
      org_guvnor_messageconsole_events_PublishBaseEvent_erraiD_Place = Marshalling.getMarshaller(Place.class);
    }
  }
}