package org.jboss.errai.marshalling.client.api;

import java.util.List;
import java.util.Set;
import org.jboss.errai.marshalling.client.Marshalling;
import org.jboss.errai.marshalling.client.api.json.EJObject;
import org.jboss.errai.marshalling.client.api.json.EJValue;
import org.jboss.errai.marshalling.client.marshallers.ObjectMarshaller;
import org.kie.server.controller.api.model.spec.ContainerSpec;
import org.kie.server.controller.api.model.spec.ServerTemplateKey;
import org.kie.workbench.common.screens.server.management.model.ContainerRuntimeOperation;
import org.kie.workbench.common.screens.server.management.model.ContainerRuntimeState;
import org.kie.workbench.common.screens.server.management.model.ContainerUpdateEvent;

public class Marshaller_o_k_w_c_s_s_m_m_ContainerUpdateEvent_1_Impl implements GeneratedMarshaller<ContainerUpdateEvent> {
  private ContainerUpdateEvent[] EMPTY_ARRAY = new ContainerUpdateEvent[0];
  private Marshaller java_lang_Object = Marshalling.getMarshaller(Object.class);
  private Marshaller<ContainerSpec> org_kie_server_controller_api_model_spec_ContainerSpec = null;
  private Marshaller<List> java_util_List = Marshalling.getMarshaller(List.class);
  private Marshaller<ContainerRuntimeState> org_kie_workbench_common_screens_server_management_model_ContainerRuntimeState = null;
  private Marshaller<ContainerRuntimeOperation> org_kie_workbench_common_screens_server_management_model_ContainerRuntimeOperation = null;
  public ContainerUpdateEvent[] getEmptyArray() {
    return EMPTY_ARRAY;
  }

  public ContainerUpdateEvent demarshall(EJValue a0, MarshallingSession a1) {
    lazyInit();
    EJObject obj = a0.isObject();
    if (obj == null) {
      return null;
    }
    String objId = obj.get("^ObjectID").isString().stringValue();
    if (a1.hasObject(objId)) {
      return a1.getObject(ContainerUpdateEvent.class, objId);
    }
    ContainerUpdateEvent entity = new ContainerUpdateEvent();
    a1.recordObject(objId, entity);
    final Set<String> keys = obj.keySet();
    for (String key : keys) {
      if (key.equals("^EncodedType") || key.equals("^ObjectID")) {
        continue;
      }
      EJValue objVal = obj.getIfNotNull(key);
      if (objVal == null) {
        continue;
      }
      switch (key) {
        case "serverTemplateKey": entity.setServerTemplateKey((ServerTemplateKey) ((ObjectMarshaller) java_lang_Object).demarshall(ServerTemplateKey.class, objVal, a1));
        break;
        case "containerSpec": entity.setContainerSpec(org_kie_server_controller_api_model_spec_ContainerSpec.demarshall(objVal, a1));
        break;
        case "failedServerInstances": a1.setAssumedElementType("org.kie.server.controller.api.model.runtime.ServerInstanceKey");
        entity.setFailedServerInstances(java_util_List.demarshall(objVal, a1));
        break;
        case "containerRuntimeState": entity.setContainerRuntimeState(objVal.isObject() != null ? Enum.valueOf(ContainerRuntimeState.class, objVal.isObject().get("^EnumStringValue").isString().stringValue()) : objVal.isString() != null ? Enum.valueOf(ContainerRuntimeState.class, objVal.isString().stringValue()) : null);
        break;
        case "containerRuntimeOperation": entity.setContainerRuntimeOperation(objVal.isObject() != null ? Enum.valueOf(ContainerRuntimeOperation.class, objVal.isObject().get("^EnumStringValue").isString().stringValue()) : objVal.isString() != null ? Enum.valueOf(ContainerRuntimeOperation.class, objVal.isString().stringValue()) : null);
        break;
      }
    }
    return entity;
  }

  public String marshall(ContainerUpdateEvent a0, MarshallingSession a1) {
    lazyInit();
    if (a0 == null) {
      return "null";
    }
    final boolean ref = a1.hasObject(a0);
    final String prefix = ((((((((("" + "{\"") + "^EncodedType") + "\":\"") + "org.kie.workbench.common.screens.server.management.model.ContainerUpdateEvent") + "\"") + ",\"") + "^ObjectID") + "\":\"") + a1.getObject(a0)) + "\"";
    if (ref) {
      return prefix + "}";
    }
    return prefix + ((((((((((((((((((((("" + ",\"") + "serverTemplateKey") + "\":") + java_lang_Object.marshall(a0.getServerTemplateKey(), a1)) + ",\"") + "containerSpec") + "\":") + org_kie_server_controller_api_model_spec_ContainerSpec.marshall(a0.getContainerSpec(), a1)) + ",\"") + "failedServerInstances") + "\":") + java_util_List.marshall(a0.getFailedServerInstances(), a1)) + ",\"") + "containerRuntimeState") + "\":") + (a0.getContainerRuntimeState() != null ? ((((((("{\"" + "^EncodedType") + "\":\"") + "org.kie.workbench.common.screens.server.management.model.ContainerRuntimeState") + "\",\"") + "^EnumStringValue") + "\":\"") + a0.getContainerRuntimeState().name()) + "\"}" : "null")) + ",\"") + "containerRuntimeOperation") + "\":") + (a0.getContainerRuntimeOperation() != null ? ((((((("{\"" + "^EncodedType") + "\":\"") + "org.kie.workbench.common.screens.server.management.model.ContainerRuntimeOperation") + "\",\"") + "^EnumStringValue") + "\":\"") + a0.getContainerRuntimeOperation().name()) + "\"}" : "null")) + "}");
  }

  private void lazyInit() {
    if (org_kie_server_controller_api_model_spec_ContainerSpec == null) {
      org_kie_server_controller_api_model_spec_ContainerSpec = Marshalling.getMarshaller(ContainerSpec.class);
    }
    if (org_kie_workbench_common_screens_server_management_model_ContainerRuntimeState == null) {
      org_kie_workbench_common_screens_server_management_model_ContainerRuntimeState = Marshalling.getMarshaller(ContainerRuntimeState.class);
    }
    if (org_kie_workbench_common_screens_server_management_model_ContainerRuntimeOperation == null) {
      org_kie_workbench_common_screens_server_management_model_ContainerRuntimeOperation = Marshalling.getMarshaller(ContainerRuntimeOperation.class);
    }
  }
}