package org.jboss.errai.marshalling.client.api;

import java.util.List;
import java.util.Set;
import org.jboss.errai.marshalling.client.Marshalling;
import org.jboss.errai.marshalling.client.api.json.EJObject;
import org.jboss.errai.marshalling.client.api.json.EJValue;
import org.optaplanner.workbench.screens.solver.model.TerminationCompositionStyleModel;
import org.optaplanner.workbench.screens.solver.model.TerminationConfigModel;

public class Marshaller_o_o_w_s_s_m_TerminationConfigModel_1_Impl implements GeneratedMarshaller<TerminationConfigModel> {
  private TerminationConfigModel[] EMPTY_ARRAY = new TerminationConfigModel[0];
  private Marshaller<String> java_lang_String = Marshalling.getMarshaller(String.class);
  private Marshaller<TerminationCompositionStyleModel> org_optaplanner_workbench_screens_solver_model_TerminationCompositionStyleModel = null;
  private Marshaller<Long> java_lang_Long = Marshalling.getMarshaller(Long.class);
  private Marshaller<Boolean> java_lang_Boolean = Marshalling.getMarshaller(Boolean.class);
  private Marshaller<Integer> java_lang_Integer = Marshalling.getMarshaller(Integer.class);
  private Marshaller<List> java_util_List = Marshalling.getMarshaller(List.class);
  public TerminationConfigModel[] getEmptyArray() {
    return EMPTY_ARRAY;
  }

  public TerminationConfigModel demarshall(EJValue a0, MarshallingSession a1) {
    lazyInit();
    EJObject obj = a0.isObject();
    if (obj == null) {
      return null;
    }
    String objId = obj.get("^ObjectID").isString().stringValue();
    if (a1.hasObject(objId)) {
      return a1.getObject(TerminationConfigModel.class, objId);
    }
    TerminationConfigModel entity = new TerminationConfigModel();
    a1.recordObject(objId, entity);
    final Set<String> keys = obj.keySet();
    for (String key : keys) {
      if (key.equals("^EncodedType") || key.equals("^ObjectID")) {
        continue;
      }
      EJValue objVal = obj.getIfNotNull(key);
      if (objVal == null) {
        continue;
      }
      switch (key) {
        case "terminationClass": entity.setTerminationClass(java_lang_String.demarshall(objVal, a1));
        break;
        case "terminationCompositionStyle": entity.setTerminationCompositionStyle(objVal.isObject() != null ? Enum.valueOf(TerminationCompositionStyleModel.class, objVal.isObject().get("^EnumStringValue").isString().stringValue()) : objVal.isString() != null ? Enum.valueOf(TerminationCompositionStyleModel.class, objVal.isString().stringValue()) : null);
        break;
        case "millisecondsSpentLimit": entity.setMillisecondsSpentLimit(java_lang_Long.demarshall(objVal, a1));
        break;
        case "secondsSpentLimit": entity.setSecondsSpentLimit(java_lang_Long.demarshall(objVal, a1));
        break;
        case "minutesSpentLimit": entity.setMinutesSpentLimit(java_lang_Long.demarshall(objVal, a1));
        break;
        case "hoursSpentLimit": entity.setHoursSpentLimit(java_lang_Long.demarshall(objVal, a1));
        break;
        case "daysSpentLimit": entity.setDaysSpentLimit(java_lang_Long.demarshall(objVal, a1));
        break;
        case "unimprovedMillisecondsSpentLimit": entity.setUnimprovedMillisecondsSpentLimit(java_lang_Long.demarshall(objVal, a1));
        break;
        case "unimprovedSecondsSpentLimit": entity.setUnimprovedSecondsSpentLimit(java_lang_Long.demarshall(objVal, a1));
        break;
        case "unimprovedMinutesSpentLimit": entity.setUnimprovedMinutesSpentLimit(java_lang_Long.demarshall(objVal, a1));
        break;
        case "unimprovedHoursSpentLimit": entity.setUnimprovedHoursSpentLimit(java_lang_Long.demarshall(objVal, a1));
        break;
        case "unimprovedDaysSpentLimit": entity.setUnimprovedDaysSpentLimit(java_lang_Long.demarshall(objVal, a1));
        break;
        case "bestScoreLimit": entity.setBestScoreLimit(java_lang_String.demarshall(objVal, a1));
        break;
        case "bestScoreFeasible": entity.setBestScoreFeasible(java_lang_Boolean.demarshall(objVal, a1));
        break;
        case "stepCountLimit": entity.setStepCountLimit(java_lang_Integer.demarshall(objVal, a1));
        break;
        case "unimprovedStepCountLimit": entity.setUnimprovedStepCountLimit(java_lang_Integer.demarshall(objVal, a1));
        break;
        case "scoreCalculationCountLimit": entity.setScoreCalculationCountLimit(java_lang_Long.demarshall(objVal, a1));
        break;
        case "terminationConfigList": a1.setAssumedElementType("org.optaplanner.workbench.screens.solver.model.TerminationConfigModel");
        entity.setTerminationConfigList(java_util_List.demarshall(objVal, a1));
        break;
      }
    }
    return entity;
  }

  public String marshall(TerminationConfigModel a0, MarshallingSession a1) {
    lazyInit();
    if (a0 == null) {
      return "null";
    }
    final boolean ref = a1.hasObject(a0);
    final String prefix = ((((((((("" + "{\"") + "^EncodedType") + "\":\"") + "org.optaplanner.workbench.screens.solver.model.TerminationConfigModel") + "\"") + ",\"") + "^ObjectID") + "\":\"") + a1.getObject(a0)) + "\"";
    if (ref) {
      return prefix + "}";
    }
    return prefix + ((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((((("" + ",\"") + "terminationClass") + "\":") + java_lang_String.marshall(a0.getTerminationClass(), a1)) + ",\"") + "terminationCompositionStyle") + "\":") + (a0.getTerminationCompositionStyle() != null ? ((((((("{\"" + "^EncodedType") + "\":\"") + "org.optaplanner.workbench.screens.solver.model.TerminationCompositionStyleModel") + "\",\"") + "^EnumStringValue") + "\":\"") + a0.getTerminationCompositionStyle().name()) + "\"}" : "null")) + ",\"") + "millisecondsSpentLimit") + "\":") + java_lang_Long.marshall(a0.getMillisecondsSpentLimit(), a1)) + ",\"") + "secondsSpentLimit") + "\":") + java_lang_Long.marshall(a0.getSecondsSpentLimit(), a1)) + ",\"") + "minutesSpentLimit") + "\":") + java_lang_Long.marshall(a0.getMinutesSpentLimit(), a1)) + ",\"") + "hoursSpentLimit") + "\":") + java_lang_Long.marshall(a0.getHoursSpentLimit(), a1)) + ",\"") + "daysSpentLimit") + "\":") + java_lang_Long.marshall(a0.getDaysSpentLimit(), a1)) + ",\"") + "unimprovedMillisecondsSpentLimit") + "\":") + java_lang_Long.marshall(a0.getUnimprovedMillisecondsSpentLimit(), a1)) + ",\"") + "unimprovedSecondsSpentLimit") + "\":") + java_lang_Long.marshall(a0.getUnimprovedSecondsSpentLimit(), a1)) + ",\"") + "unimprovedMinutesSpentLimit") + "\":") + java_lang_Long.marshall(a0.getUnimprovedMinutesSpentLimit(), a1)) + ",\"") + "unimprovedHoursSpentLimit") + "\":") + java_lang_Long.marshall(a0.getUnimprovedHoursSpentLimit(), a1)) + ",\"") + "unimprovedDaysSpentLimit") + "\":") + java_lang_Long.marshall(a0.getUnimprovedDaysSpentLimit(), a1)) + ",\"") + "bestScoreLimit") + "\":") + java_lang_String.marshall(a0.getBestScoreLimit(), a1)) + ",\"") + "bestScoreFeasible") + "\":") + java_lang_Boolean.marshall(a0.getBestScoreFeasible(), a1)) + ",\"") + "stepCountLimit") + "\":") + java_lang_Integer.marshall(a0.getStepCountLimit(), a1)) + ",\"") + "unimprovedStepCountLimit") + "\":") + java_lang_Integer.marshall(a0.getUnimprovedStepCountLimit(), a1)) + ",\"") + "scoreCalculationCountLimit") + "\":") + java_lang_Long.marshall(a0.getScoreCalculationCountLimit(), a1)) + ",\"") + "terminationConfigList") + "\":") + java_util_List.marshall(a0.getTerminationConfigList(), a1)) + "}");
  }

  private void lazyInit() {
    if (org_optaplanner_workbench_screens_solver_model_TerminationCompositionStyleModel == null) {
      org_optaplanner_workbench_screens_solver_model_TerminationCompositionStyleModel = Marshalling.getMarshaller(TerminationCompositionStyleModel.class);
    }
  }
}