package org.jboss.errai.validation.client;

import com.google.gwt.core.client.GWT;
import com.google.gwt.validation.client.impl.GwtBeanDescriptor;
import com.google.gwt.validation.client.impl.GwtSpecificValidator;
import com.google.gwt.validation.client.impl.GwtValidationContext;
import com.google.gwt.validation.client.impl.metadata.ValidationGroupsMetadata;
import java.util.Set;
import java.util.HashSet;
import java.util.Map;
import java.util.HashMap;
import javax.validation.groups.Default;
import javax.validation.ConstraintViolation;
import javax.validation.metadata.BeanDescriptor;

public class ValidatorFactoryImpl_GwtValidatorImpl extends com.google.gwt.validation.client.impl.AbstractGwtValidator implements org.jboss.errai.validation.client.ValidatorFactoryImpl.GwtValidator {
  public ValidatorFactoryImpl_GwtValidatorImpl() {
    super(createValidationGroupsMetadata());
  }
  
  private static ValidationGroupsMetadata createValidationGroupsMetadata() {
    return ValidationGroupsMetadata.builder()
        .addGroup(org.dashbuilder.dataset.validation.groups.DataSetDefProviderTypeGroup.class)
        .addGroup(javax.validation.groups.Default.class)
        .addGroup(org.dashbuilder.dataset.validation.groups.DataSetDefCacheRowsValidation.class)
        .addGroup(org.dashbuilder.dataset.validation.groups.CSVDataSetDefFilePathValidation.class)
        .addGroup(org.dashbuilder.dataset.validation.groups.SQLDataSetDefDbSQLValidation.class)
        .addGroup(org.dashbuilder.dataset.validation.groups.SQLDataSetDefDbTableValidation.class)
        .addGroup(org.dashbuilder.dataset.validation.groups.BeanDataSetDefValidation.class)
        .addGroup(org.dashbuilder.dataset.validation.groups.DataSetDefRefreshIntervalValidation.class)
        .addGroup(org.dashbuilder.dataset.validation.groups.SQLDataSetDefValidation.class)
        .addGroup(org.dashbuilder.dataset.validation.groups.DataSetDefPushSizeValidation.class)
        .addGroup(org.dashbuilder.dataset.validation.groups.CSVDataSetDefValidation.class)
        .addGroup(org.dashbuilder.dataset.validation.groups.ElasticSearchDataSetDefValidation.class)
        .addGroup(org.dashbuilder.dataset.validation.groups.CSVDataSetDefFileURLValidation.class)
        .addGroup(org.dashbuilder.dataset.validation.groups.DataSetDefBasicAttributesGroup.class)
        .build();
  }
  
  public <T> Set<ConstraintViolation<T>> validate(T object, Class<?>... groups) {
    checkNotNull(object, "object");
    checkNotNull(groups, "groups");
    checkGroups(groups);
    if (object instanceof org.dashbuilder.dataset.def.DataColumnDef) {
      GwtValidationContext<T> context = new GwtValidationContext<T>(
          (Class<T>) org.dashbuilder.dataset.def.DataColumnDef.class, 
          object, 
          org.dashbuilder.dataset.def._DataColumnDefValidator.INSTANCE.getConstraints(getValidationGroupsMetadata()), 
          getMessageInterpolator(), 
          getTraversableResolver(), 
          this);
      return org.dashbuilder.dataset.def._DataColumnDefValidator.INSTANCE
          .validate(context, (org.dashbuilder.dataset.def.DataColumnDef) object, groups);
    }
    if (object instanceof org.dashbuilder.dataset.def.CSVDataSetDef) {
      GwtValidationContext<T> context = new GwtValidationContext<T>(
          (Class<T>) org.dashbuilder.dataset.def.CSVDataSetDef.class, 
          object, 
          org.dashbuilder.dataset.def._CSVDataSetDefValidator.INSTANCE.getConstraints(getValidationGroupsMetadata()), 
          getMessageInterpolator(), 
          getTraversableResolver(), 
          this);
      return org.dashbuilder.dataset.def._CSVDataSetDefValidator.INSTANCE
          .validate(context, (org.dashbuilder.dataset.def.CSVDataSetDef) object, groups);
    }
    if (object instanceof org.dashbuilder.dataset.def.ElasticSearchDataSetDef) {
      GwtValidationContext<T> context = new GwtValidationContext<T>(
          (Class<T>) org.dashbuilder.dataset.def.ElasticSearchDataSetDef.class, 
          object, 
          org.dashbuilder.dataset.def._ElasticSearchDataSetDefValidator.INSTANCE.getConstraints(getValidationGroupsMetadata()), 
          getMessageInterpolator(), 
          getTraversableResolver(), 
          this);
      return org.dashbuilder.dataset.def._ElasticSearchDataSetDefValidator.INSTANCE
          .validate(context, (org.dashbuilder.dataset.def.ElasticSearchDataSetDef) object, groups);
    }
    if (object instanceof org.dashbuilder.dataset.def.SQLDataSetDef) {
      GwtValidationContext<T> context = new GwtValidationContext<T>(
          (Class<T>) org.dashbuilder.dataset.def.SQLDataSetDef.class, 
          object, 
          org.dashbuilder.dataset.def._SQLDataSetDefValidator.INSTANCE.getConstraints(getValidationGroupsMetadata()), 
          getMessageInterpolator(), 
          getTraversableResolver(), 
          this);
      return org.dashbuilder.dataset.def._SQLDataSetDefValidator.INSTANCE
          .validate(context, (org.dashbuilder.dataset.def.SQLDataSetDef) object, groups);
    }
    if (object instanceof org.dashbuilder.dataset.def.BeanDataSetDef) {
      GwtValidationContext<T> context = new GwtValidationContext<T>(
          (Class<T>) org.dashbuilder.dataset.def.BeanDataSetDef.class, 
          object, 
          org.dashbuilder.dataset.def._BeanDataSetDefValidator.INSTANCE.getConstraints(getValidationGroupsMetadata()), 
          getMessageInterpolator(), 
          getTraversableResolver(), 
          this);
      return org.dashbuilder.dataset.def._BeanDataSetDefValidator.INSTANCE
          .validate(context, (org.dashbuilder.dataset.def.BeanDataSetDef) object, groups);
    }
    if (object instanceof org.dashbuilder.dataset.def.DataSetDef) {
      GwtValidationContext<T> context = new GwtValidationContext<T>(
          (Class<T>) org.dashbuilder.dataset.def.DataSetDef.class, 
          object, 
          org.dashbuilder.dataset.def._DataSetDefValidator.INSTANCE.getConstraints(getValidationGroupsMetadata()), 
          getMessageInterpolator(), 
          getTraversableResolver(), 
          this);
      return org.dashbuilder.dataset.def._DataSetDefValidator.INSTANCE
          .validate(context, (org.dashbuilder.dataset.def.DataSetDef) object, groups);
    }
    throw new IllegalArgumentException("ValidatorFactoryImpl.GwtValidator can not  validate "+ object.getClass().getName()+ ". "
        + "Valid types are [org.dashbuilder.dataset.def.DataColumnDef, org.dashbuilder.dataset.def.CSVDataSetDef, org.dashbuilder.dataset.def.ElasticSearchDataSetDef, org.dashbuilder.dataset.def.SQLDataSetDef, org.dashbuilder.dataset.def.BeanDataSetDef, org.dashbuilder.dataset.def.DataSetDef]");
  }
  
  public <T> Set<ConstraintViolation<T>> validateProperty(T object,String propertyName, Class<?>... groups) {
    checkNotNull(object, "object");
    checkNotNull(propertyName, "propertyName");
    checkNotNull(groups, "groups");
    checkGroups(groups);
    if (object instanceof org.dashbuilder.dataset.def.DataColumnDef) {
      GwtValidationContext<T> context = new GwtValidationContext<T>(
          (Class<T>) org.dashbuilder.dataset.def.DataColumnDef.class, 
          object, 
          org.dashbuilder.dataset.def._DataColumnDefValidator.INSTANCE.getConstraints(getValidationGroupsMetadata()), 
          getMessageInterpolator(), 
          getTraversableResolver(), 
          this);
      return org.dashbuilder.dataset.def._DataColumnDefValidator.INSTANCE
          .validateProperty(context, (org.dashbuilder.dataset.def.DataColumnDef) object, propertyName, groups);
    }
    if (object instanceof org.dashbuilder.dataset.def.CSVDataSetDef) {
      GwtValidationContext<T> context = new GwtValidationContext<T>(
          (Class<T>) org.dashbuilder.dataset.def.CSVDataSetDef.class, 
          object, 
          org.dashbuilder.dataset.def._CSVDataSetDefValidator.INSTANCE.getConstraints(getValidationGroupsMetadata()), 
          getMessageInterpolator(), 
          getTraversableResolver(), 
          this);
      return org.dashbuilder.dataset.def._CSVDataSetDefValidator.INSTANCE
          .validateProperty(context, (org.dashbuilder.dataset.def.CSVDataSetDef) object, propertyName, groups);
    }
    if (object instanceof org.dashbuilder.dataset.def.ElasticSearchDataSetDef) {
      GwtValidationContext<T> context = new GwtValidationContext<T>(
          (Class<T>) org.dashbuilder.dataset.def.ElasticSearchDataSetDef.class, 
          object, 
          org.dashbuilder.dataset.def._ElasticSearchDataSetDefValidator.INSTANCE.getConstraints(getValidationGroupsMetadata()), 
          getMessageInterpolator(), 
          getTraversableResolver(), 
          this);
      return org.dashbuilder.dataset.def._ElasticSearchDataSetDefValidator.INSTANCE
          .validateProperty(context, (org.dashbuilder.dataset.def.ElasticSearchDataSetDef) object, propertyName, groups);
    }
    if (object instanceof org.dashbuilder.dataset.def.SQLDataSetDef) {
      GwtValidationContext<T> context = new GwtValidationContext<T>(
          (Class<T>) org.dashbuilder.dataset.def.SQLDataSetDef.class, 
          object, 
          org.dashbuilder.dataset.def._SQLDataSetDefValidator.INSTANCE.getConstraints(getValidationGroupsMetadata()), 
          getMessageInterpolator(), 
          getTraversableResolver(), 
          this);
      return org.dashbuilder.dataset.def._SQLDataSetDefValidator.INSTANCE
          .validateProperty(context, (org.dashbuilder.dataset.def.SQLDataSetDef) object, propertyName, groups);
    }
    if (object instanceof org.dashbuilder.dataset.def.BeanDataSetDef) {
      GwtValidationContext<T> context = new GwtValidationContext<T>(
          (Class<T>) org.dashbuilder.dataset.def.BeanDataSetDef.class, 
          object, 
          org.dashbuilder.dataset.def._BeanDataSetDefValidator.INSTANCE.getConstraints(getValidationGroupsMetadata()), 
          getMessageInterpolator(), 
          getTraversableResolver(), 
          this);
      return org.dashbuilder.dataset.def._BeanDataSetDefValidator.INSTANCE
          .validateProperty(context, (org.dashbuilder.dataset.def.BeanDataSetDef) object, propertyName, groups);
    }
    if (object instanceof org.dashbuilder.dataset.def.DataSetDef) {
      GwtValidationContext<T> context = new GwtValidationContext<T>(
          (Class<T>) org.dashbuilder.dataset.def.DataSetDef.class, 
          object, 
          org.dashbuilder.dataset.def._DataSetDefValidator.INSTANCE.getConstraints(getValidationGroupsMetadata()), 
          getMessageInterpolator(), 
          getTraversableResolver(), 
          this);
      return org.dashbuilder.dataset.def._DataSetDefValidator.INSTANCE
          .validateProperty(context, (org.dashbuilder.dataset.def.DataSetDef) object, propertyName, groups);
    }
    throw new IllegalArgumentException("ValidatorFactoryImpl.GwtValidator can not  validate "+ object.getClass().getName()+ ". "
        + "Valid types are [org.dashbuilder.dataset.def.DataColumnDef, org.dashbuilder.dataset.def.CSVDataSetDef, org.dashbuilder.dataset.def.ElasticSearchDataSetDef, org.dashbuilder.dataset.def.SQLDataSetDef, org.dashbuilder.dataset.def.BeanDataSetDef, org.dashbuilder.dataset.def.DataSetDef]");
  }
  
  public <T> Set<ConstraintViolation<T>> validateValue(Class<T> beanType, String propertyName, Object value, Class<?>... groups) {
    checkNotNull(beanType, "beanType");
    checkNotNull(propertyName, "propertyName");
    checkNotNull(groups, "groups");
    checkGroups(groups);
    if (beanType.equals(org.dashbuilder.dataset.def.DataColumnDef.class)) {
      GwtValidationContext<T> context = new GwtValidationContext<T>(
          (Class<T>) org.dashbuilder.dataset.def.DataColumnDef.class, 
          null, 
          org.dashbuilder.dataset.def._DataColumnDefValidator.INSTANCE.getConstraints(getValidationGroupsMetadata()), 
          getMessageInterpolator(), 
          getTraversableResolver(), 
          this);
      return org.dashbuilder.dataset.def._DataColumnDefValidator.INSTANCE
          .validateValue(context, (Class<org.dashbuilder.dataset.def.DataColumnDef>)beanType, propertyName, value, groups);
    }
    if (beanType.equals(org.dashbuilder.dataset.def.CSVDataSetDef.class)) {
      GwtValidationContext<T> context = new GwtValidationContext<T>(
          (Class<T>) org.dashbuilder.dataset.def.CSVDataSetDef.class, 
          null, 
          org.dashbuilder.dataset.def._CSVDataSetDefValidator.INSTANCE.getConstraints(getValidationGroupsMetadata()), 
          getMessageInterpolator(), 
          getTraversableResolver(), 
          this);
      return org.dashbuilder.dataset.def._CSVDataSetDefValidator.INSTANCE
          .validateValue(context, (Class<org.dashbuilder.dataset.def.CSVDataSetDef>)beanType, propertyName, value, groups);
    }
    if (beanType.equals(org.dashbuilder.dataset.def.ElasticSearchDataSetDef.class)) {
      GwtValidationContext<T> context = new GwtValidationContext<T>(
          (Class<T>) org.dashbuilder.dataset.def.ElasticSearchDataSetDef.class, 
          null, 
          org.dashbuilder.dataset.def._ElasticSearchDataSetDefValidator.INSTANCE.getConstraints(getValidationGroupsMetadata()), 
          getMessageInterpolator(), 
          getTraversableResolver(), 
          this);
      return org.dashbuilder.dataset.def._ElasticSearchDataSetDefValidator.INSTANCE
          .validateValue(context, (Class<org.dashbuilder.dataset.def.ElasticSearchDataSetDef>)beanType, propertyName, value, groups);
    }
    if (beanType.equals(org.dashbuilder.dataset.def.SQLDataSetDef.class)) {
      GwtValidationContext<T> context = new GwtValidationContext<T>(
          (Class<T>) org.dashbuilder.dataset.def.SQLDataSetDef.class, 
          null, 
          org.dashbuilder.dataset.def._SQLDataSetDefValidator.INSTANCE.getConstraints(getValidationGroupsMetadata()), 
          getMessageInterpolator(), 
          getTraversableResolver(), 
          this);
      return org.dashbuilder.dataset.def._SQLDataSetDefValidator.INSTANCE
          .validateValue(context, (Class<org.dashbuilder.dataset.def.SQLDataSetDef>)beanType, propertyName, value, groups);
    }
    if (beanType.equals(org.dashbuilder.dataset.def.BeanDataSetDef.class)) {
      GwtValidationContext<T> context = new GwtValidationContext<T>(
          (Class<T>) org.dashbuilder.dataset.def.BeanDataSetDef.class, 
          null, 
          org.dashbuilder.dataset.def._BeanDataSetDefValidator.INSTANCE.getConstraints(getValidationGroupsMetadata()), 
          getMessageInterpolator(), 
          getTraversableResolver(), 
          this);
      return org.dashbuilder.dataset.def._BeanDataSetDefValidator.INSTANCE
          .validateValue(context, (Class<org.dashbuilder.dataset.def.BeanDataSetDef>)beanType, propertyName, value, groups);
    }
    if (beanType.equals(org.dashbuilder.dataset.def.DataSetDef.class)) {
      GwtValidationContext<T> context = new GwtValidationContext<T>(
          (Class<T>) org.dashbuilder.dataset.def.DataSetDef.class, 
          null, 
          org.dashbuilder.dataset.def._DataSetDefValidator.INSTANCE.getConstraints(getValidationGroupsMetadata()), 
          getMessageInterpolator(), 
          getTraversableResolver(), 
          this);
      return org.dashbuilder.dataset.def._DataSetDefValidator.INSTANCE
          .validateValue(context, (Class<org.dashbuilder.dataset.def.DataSetDef>)beanType, propertyName, value, groups);
    }
    throw new IllegalArgumentException("ValidatorFactoryImpl.GwtValidator can not  validate "+ beanType.getName()+ ". "
        + "Valid types are [org.dashbuilder.dataset.def.DataColumnDef, org.dashbuilder.dataset.def.CSVDataSetDef, org.dashbuilder.dataset.def.ElasticSearchDataSetDef, org.dashbuilder.dataset.def.SQLDataSetDef, org.dashbuilder.dataset.def.BeanDataSetDef, org.dashbuilder.dataset.def.DataSetDef]");
  }
  
  public BeanDescriptor getConstraintsForClass(Class<?> clazz) {
    checkNotNull(clazz, "clazz");
    if (clazz.equals(org.dashbuilder.dataset.def.DataColumnDef.class)) {
      return org.dashbuilder.dataset.def._DataColumnDefValidator.INSTANCE.getConstraints(getValidationGroupsMetadata());
    }
    if (clazz.equals(org.dashbuilder.dataset.def.CSVDataSetDef.class)) {
      return org.dashbuilder.dataset.def._CSVDataSetDefValidator.INSTANCE.getConstraints(getValidationGroupsMetadata());
    }
    if (clazz.equals(org.dashbuilder.dataset.def.ElasticSearchDataSetDef.class)) {
      return org.dashbuilder.dataset.def._ElasticSearchDataSetDefValidator.INSTANCE.getConstraints(getValidationGroupsMetadata());
    }
    if (clazz.equals(org.dashbuilder.dataset.def.SQLDataSetDef.class)) {
      return org.dashbuilder.dataset.def._SQLDataSetDefValidator.INSTANCE.getConstraints(getValidationGroupsMetadata());
    }
    if (clazz.equals(org.dashbuilder.dataset.def.BeanDataSetDef.class)) {
      return org.dashbuilder.dataset.def._BeanDataSetDefValidator.INSTANCE.getConstraints(getValidationGroupsMetadata());
    }
    if (clazz.equals(org.dashbuilder.dataset.def.DataSetDef.class)) {
      return org.dashbuilder.dataset.def._DataSetDefValidator.INSTANCE.getConstraints(getValidationGroupsMetadata());
    }
    throw new IllegalArgumentException("ValidatorFactoryImpl.GwtValidator can not  validate "+ clazz.getName()+ ". "
        + "Valid types are [org.dashbuilder.dataset.def.DataColumnDef, org.dashbuilder.dataset.def.CSVDataSetDef, org.dashbuilder.dataset.def.ElasticSearchDataSetDef, org.dashbuilder.dataset.def.SQLDataSetDef, org.dashbuilder.dataset.def.BeanDataSetDef, org.dashbuilder.dataset.def.DataSetDef]");
  }
  
  public <T> Set<ConstraintViolation<T>> validate(GwtValidationContext<T> context,
      Object object, Class<?>... groups) {
    checkNotNull(context, "context");
    checkNotNull(object, "object");
    checkNotNull(groups, "groups");
    checkGroups(groups);
    if (object instanceof org.dashbuilder.dataset.def.SQLDataSetDef) {
      return org.dashbuilder.dataset.def._SQLDataSetDefValidator.INSTANCE
          .validate(context, (org.dashbuilder.dataset.def.SQLDataSetDef) object, groups);
    }
    if (object instanceof org.dashbuilder.dataset.def.DataColumnDef) {
      return org.dashbuilder.dataset.def._DataColumnDefValidator.INSTANCE
          .validate(context, (org.dashbuilder.dataset.def.DataColumnDef) object, groups);
    }
    if (object instanceof org.dashbuilder.dataset.def.ElasticSearchDataSetDef) {
      return org.dashbuilder.dataset.def._ElasticSearchDataSetDefValidator.INSTANCE
          .validate(context, (org.dashbuilder.dataset.def.ElasticSearchDataSetDef) object, groups);
    }
    if (object instanceof org.dashbuilder.dataset.def.BeanDataSetDef) {
      return org.dashbuilder.dataset.def._BeanDataSetDefValidator.INSTANCE
          .validate(context, (org.dashbuilder.dataset.def.BeanDataSetDef) object, groups);
    }
    if (object instanceof org.dashbuilder.dataset.def.CSVDataSetDef) {
      return org.dashbuilder.dataset.def._CSVDataSetDefValidator.INSTANCE
          .validate(context, (org.dashbuilder.dataset.def.CSVDataSetDef) object, groups);
    }
    if (object instanceof org.dashbuilder.dataset.def.DataSetDef) {
      return org.dashbuilder.dataset.def._DataSetDefValidator.INSTANCE
          .validate(context, (org.dashbuilder.dataset.def.DataSetDef) object, groups);
    }
    throw new IllegalArgumentException("ValidatorFactoryImpl.GwtValidator can not  validate "+ object.getClass().getName()+ ". "
        + "Valid types are [org.dashbuilder.dataset.def.DataColumnDef, org.dashbuilder.dataset.def.CSVDataSetDef, org.dashbuilder.dataset.def.ElasticSearchDataSetDef, org.dashbuilder.dataset.def.SQLDataSetDef, org.dashbuilder.dataset.def.BeanDataSetDef, org.dashbuilder.dataset.def.DataSetDef]");
  }
}
