/*
 * Copyright 2017 Red Hat, Inc. and/or its affiliates.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.kie.workbench.common.screens.home.client.widgets.shortcut.subheading;

import javax.inject.Inject;

import org.jboss.errai.common.client.dom.Span;
import org.jboss.errai.ui.client.local.api.IsElement;
import org.jboss.errai.ui.shared.api.annotations.DataField;
import org.jboss.errai.ui.shared.api.annotations.Templated;

@Templated
public class ShortcutSubHeadingTextView implements ShortcutSubHeadingTextPresenter.View,
                                                   IsElement {

    private ShortcutSubHeadingTextPresenter presenter;

    @Inject
    @DataField("text")
    Span text;

    @Override
    public void init(final ShortcutSubHeadingTextPresenter presenter) {
        this.presenter = presenter;
    }

    @Override
    public void setText(final String text) {
        this.text.setTextContent(text);
    }
}
