/*
 * Copyright 2016 Red Hat, Inc. and/or its affiliates.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.kie.workbench.common.screens.library.api.preferences;

import java.lang.RuntimeException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.annotation.Generated;

import org.jboss.errai.common.client.api.annotations.MapsTo;
import org.jboss.errai.common.client.api.annotations.Portable;
import org.uberfire.preferences.shared.annotations.PortablePreference;
import org.uberfire.preferences.shared.bean.BasePreferencePortable;
import org.uberfire.preferences.shared.PropertyFormType;
import org.uberfire.preferences.shared.PropertyValidator;
import org.uberfire.mvp.Command;
import org.uberfire.mvp.ParameterizedCommand;

@Portable( mapSuperTypes = true )
@PortablePreference
@Generated("org.uberfire.ext.preferences.processors.WorkbenchPreferenceProcessor")
/*
* WARNING! This class is generated. Do not modify.
*/
public class LibraryOrganizationalUnitPreferencesPortableGeneratedImpl extends LibraryOrganizationalUnitPreferences implements BasePreferencePortable<LibraryOrganizationalUnitPreferences> {

    public LibraryOrganizationalUnitPreferencesPortableGeneratedImpl() {
    }

    public LibraryOrganizationalUnitPreferencesPortableGeneratedImpl( @MapsTo("name") java.lang.String name, @MapsTo("owner") java.lang.String owner, @MapsTo("groupId") java.lang.String groupId, @MapsTo("aliasInSingular") java.lang.String aliasInSingular, @MapsTo("aliasInPlural") java.lang.String aliasInPlural ) {
        this.name = name;
        this.owner = owner;
        this.groupId = groupId;
        this.aliasInSingular = aliasInSingular;
        this.aliasInPlural = aliasInPlural;
    }

    @Override
    public Class<LibraryOrganizationalUnitPreferences> getPojoClass() {
        return LibraryOrganizationalUnitPreferences.class;
    }

    @Override
    public String identifier() {
        return "LibraryOrganizationalUnitPreferences";
    }

    @Override
    public String[] parents() {
        return new String[] { "" };
    }

    @Override
    public String bundleKey() {
        return "LibraryOrganizationalUnitPreferences.Label";
    }

    @Override
    public void set( String property, Object value ) {
        if ( property.equals( "name" ) ) {
            name = (java.lang.String) value;
        } else
        if ( property.equals( "owner" ) ) {
            owner = (java.lang.String) value;
        } else
        if ( property.equals( "groupId" ) ) {
            groupId = (java.lang.String) value;
        } else
        if ( property.equals( "aliasInSingular" ) ) {
            aliasInSingular = (java.lang.String) value;
        } else
        if ( property.equals( "aliasInPlural" ) ) {
            aliasInPlural = (java.lang.String) value;
        } else
        {
            throw new RuntimeException( "Unknown property: " + property );
        }
    }

    @Override
    public Object get( String property ) {
        if ( property.equals( "name" ) ) {
            return name;
        } else
        if ( property.equals( "owner" ) ) {
            return owner;
        } else
        if ( property.equals( "groupId" ) ) {
            return groupId;
        } else
        if ( property.equals( "aliasInSingular" ) ) {
            return aliasInSingular;
        } else
        if ( property.equals( "aliasInPlural" ) ) {
            return aliasInPlural;
        } else
        {
            throw new RuntimeException( "Unknown property: " + property );
        }
    }

    @Override
    public Map<String, PropertyFormType> getPropertiesTypes() {
        Map<String, PropertyFormType> propertiesTypes = new HashMap<>();

        propertiesTypes.put( "name", PropertyFormType.TEXT);
        propertiesTypes.put( "owner", PropertyFormType.TEXT);
        propertiesTypes.put( "groupId", PropertyFormType.TEXT);
        propertiesTypes.put( "aliasInSingular", PropertyFormType.TEXT);
        propertiesTypes.put( "aliasInPlural", PropertyFormType.TEXT);

        return propertiesTypes;
    }

    @Override
    public Map<String, List<PropertyValidator>> getPropertiesValidators() {
        Map<String, List<PropertyValidator>> validatorsByProperty = new HashMap<>();

        List<PropertyValidator> validatorsName = new ArrayList<>();
        validatorsName.add(new org.uberfire.preferences.shared.impl.validation.NotEmptyValidator());
        validatorsByProperty.put("name", validatorsName);

        List<PropertyValidator> validatorsOwner = new ArrayList<>();
        validatorsOwner.add(new org.uberfire.preferences.shared.impl.validation.NotEmptyValidator());
        validatorsByProperty.put("owner", validatorsOwner);

        List<PropertyValidator> validatorsGroupId = new ArrayList<>();
        validatorsGroupId.add(new org.uberfire.preferences.shared.impl.validation.NotEmptyValidator());
        validatorsGroupId.add(new org.kie.workbench.common.screens.library.api.preferences.GroupIdValidator());
        validatorsByProperty.put("groupId", validatorsGroupId);


        return validatorsByProperty;
    }

    @Override
    public boolean equals( final Object o ) {
        if ( this == o ) {
            return true;
        }
        if ( o == null || getClass() != o.getClass() ) {
            return false;
        }

        final LibraryOrganizationalUnitPreferencesPortableGeneratedImpl that = (LibraryOrganizationalUnitPreferencesPortableGeneratedImpl) o;

        if ( name != null ? !name.equals( that.name ) : that.name != null ) {
            return false;
        }
        if ( owner != null ? !owner.equals( that.owner ) : that.owner != null ) {
            return false;
        }
        if ( groupId != null ? !groupId.equals( that.groupId ) : that.groupId != null ) {
            return false;
        }
        if ( aliasInSingular != null ? !aliasInSingular.equals( that.aliasInSingular ) : that.aliasInSingular != null ) {
            return false;
        }
        if ( aliasInPlural != null ? !aliasInPlural.equals( that.aliasInPlural ) : that.aliasInPlural != null ) {
            return false;
        }

        return true;
    }

    @Override
    public int hashCode() {
        int result = 0;

        result = 31 * result + ( name != null ? name.hashCode() : 0 );
        result = ~~result;
        result = 31 * result + ( owner != null ? owner.hashCode() : 0 );
        result = ~~result;
        result = 31 * result + ( groupId != null ? groupId.hashCode() : 0 );
        result = ~~result;
        result = 31 * result + ( aliasInSingular != null ? aliasInSingular.hashCode() : 0 );
        result = ~~result;
        result = 31 * result + ( aliasInPlural != null ? aliasInPlural.hashCode() : 0 );
        result = ~~result;

        return result;
    }

    @Override
    public boolean isPersistable() {
        return true;
    }
}
