/*
 * Copyright 2016 Red Hat, Inc. and/or its affiliates.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.kie.workbench.common.screens.library.api.preferences;

import java.lang.RuntimeException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.annotation.Generated;

import org.jboss.errai.common.client.api.annotations.MapsTo;
import org.jboss.errai.common.client.api.annotations.Portable;
import org.uberfire.preferences.shared.annotations.PortablePreference;
import org.uberfire.preferences.shared.bean.BasePreferencePortable;
import org.uberfire.preferences.shared.PropertyFormType;
import org.uberfire.preferences.shared.PropertyValidator;
import org.uberfire.mvp.Command;
import org.uberfire.mvp.ParameterizedCommand;

@Portable( mapSuperTypes = true )
@PortablePreference
@Generated("org.uberfire.ext.preferences.processors.WorkbenchPreferenceProcessor")
/*
* WARNING! This class is generated. Do not modify.
*/
public class LibraryPreferencesPortableGeneratedImpl extends LibraryPreferences implements BasePreferencePortable<LibraryPreferences> {

    public LibraryPreferencesPortableGeneratedImpl() {
        this.organizationalUnitPreferences = new org.kie.workbench.common.screens.library.api.preferences.LibraryOrganizationalUnitPreferencesPortableGeneratedImpl();
        this.projectPreferences = new org.kie.workbench.common.screens.library.api.preferences.LibraryProjectPreferencesPortableGeneratedImpl();
        this.gavPreferences = new org.guvnor.common.services.project.preferences.GAVPreferencesPortableGeneratedImpl();
    }

    public LibraryPreferencesPortableGeneratedImpl( @MapsTo("organizationalUnitPreferences") org.kie.workbench.common.screens.library.api.preferences.LibraryOrganizationalUnitPreferences organizationalUnitPreferences, @MapsTo("projectPreferences") org.kie.workbench.common.screens.library.api.preferences.LibraryProjectPreferences projectPreferences, @MapsTo("gavPreferences") org.guvnor.common.services.project.preferences.GAVPreferences gavPreferences ) {
        this.organizationalUnitPreferences = organizationalUnitPreferences;
        this.projectPreferences = projectPreferences;
        this.gavPreferences = gavPreferences;
    }

    @Override
    public Class<LibraryPreferences> getPojoClass() {
        return LibraryPreferences.class;
    }

    @Override
    public String identifier() {
        return "LibraryPreferences";
    }

    @Override
    public String[] parents() {
        return new String[] { "" };
    }

    @Override
    public String bundleKey() {
        return "LibraryPreferences.Label";
    }

    @Override
    public void set( String property, Object value ) {
        {
            throw new RuntimeException( "Unknown property: " + property );
        }
    }

    @Override
    public Object get( String property ) {
        {
            throw new RuntimeException( "Unknown property: " + property );
        }
    }

    @Override
    public Map<String, PropertyFormType> getPropertiesTypes() {
        Map<String, PropertyFormType> propertiesTypes = new HashMap<>();


        return propertiesTypes;
    }

    @Override
    public Map<String, List<PropertyValidator>> getPropertiesValidators() {
        Map<String, List<PropertyValidator>> validatorsByProperty = new HashMap<>();


        return validatorsByProperty;
    }

    @Override
    public boolean equals( final Object o ) {
        if ( this == o ) {
            return true;
        }
        if ( o == null || getClass() != o.getClass() ) {
            return false;
        }

        final LibraryPreferencesPortableGeneratedImpl that = (LibraryPreferencesPortableGeneratedImpl) o;

        if ( organizationalUnitPreferences != null ? !organizationalUnitPreferences.equals( that.organizationalUnitPreferences ) : that.organizationalUnitPreferences != null ) {
            return false;
        }
        if ( projectPreferences != null ? !projectPreferences.equals( that.projectPreferences ) : that.projectPreferences != null ) {
            return false;
        }
        if ( gavPreferences != null ? !gavPreferences.equals( that.gavPreferences ) : that.gavPreferences != null ) {
            return false;
        }

        return true;
    }

    @Override
    public int hashCode() {
        int result = 0;

        result = 31 * result + ( organizationalUnitPreferences != null ? organizationalUnitPreferences.hashCode() : 0 );
        result = ~~result;
        result = 31 * result + ( projectPreferences != null ? projectPreferences.hashCode() : 0 );
        result = ~~result;
        result = 31 * result + ( gavPreferences != null ? gavPreferences.hashCode() : 0 );
        result = ~~result;

        return result;
    }

    @Override
    public boolean isPersistable() {
        return true;
    }
}
