/*
 * Copyright 2016 Red Hat, Inc. and/or its affiliates.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.kie.workbench.common.screens.library.api.preferences;

import java.lang.RuntimeException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.annotation.Generated;

import org.jboss.errai.common.client.api.annotations.MapsTo;
import org.jboss.errai.common.client.api.annotations.Portable;
import org.uberfire.preferences.shared.annotations.PortablePreference;
import org.uberfire.preferences.shared.bean.BasePreferencePortable;
import org.uberfire.preferences.shared.PropertyFormType;
import org.uberfire.preferences.shared.PropertyValidator;
import org.uberfire.mvp.Command;
import org.uberfire.mvp.ParameterizedCommand;

@Portable( mapSuperTypes = true )
@PortablePreference
@Generated("org.uberfire.ext.preferences.processors.WorkbenchPreferenceProcessor")
/*
* WARNING! This class is generated. Do not modify.
*/
public class LibraryProjectPreferencesPortableGeneratedImpl extends LibraryProjectPreferences implements BasePreferencePortable<LibraryProjectPreferences> {

    public LibraryProjectPreferencesPortableGeneratedImpl() {
    }

    public LibraryProjectPreferencesPortableGeneratedImpl( @MapsTo("version") java.lang.String version, @MapsTo("description") java.lang.String description, @MapsTo("branch") java.lang.String branch ) {
        this.version = version;
        this.description = description;
        this.branch = branch;
    }

    @Override
    public Class<LibraryProjectPreferences> getPojoClass() {
        return LibraryProjectPreferences.class;
    }

    @Override
    public String identifier() {
        return "LibraryProjectPreferences";
    }

    @Override
    public String[] parents() {
        return new String[] { "" };
    }

    @Override
    public String bundleKey() {
        return "LibraryProjectPreferences.Label";
    }

    @Override
    public void set( String property, Object value ) {
        if ( property.equals( "version" ) ) {
            version = (java.lang.String) value;
        } else
        if ( property.equals( "description" ) ) {
            description = (java.lang.String) value;
        } else
        if ( property.equals( "branch" ) ) {
            branch = (java.lang.String) value;
        } else
        {
            throw new RuntimeException( "Unknown property: " + property );
        }
    }

    @Override
    public Object get( String property ) {
        if ( property.equals( "version" ) ) {
            return version;
        } else
        if ( property.equals( "description" ) ) {
            return description;
        } else
        if ( property.equals( "branch" ) ) {
            return branch;
        } else
        {
            throw new RuntimeException( "Unknown property: " + property );
        }
    }

    @Override
    public Map<String, PropertyFormType> getPropertiesTypes() {
        Map<String, PropertyFormType> propertiesTypes = new HashMap<>();

        propertiesTypes.put( "version", PropertyFormType.TEXT);
        propertiesTypes.put( "description", PropertyFormType.TEXT);
        propertiesTypes.put( "branch", PropertyFormType.TEXT);

        return propertiesTypes;
    }

    @Override
    public Map<String, List<PropertyValidator>> getPropertiesValidators() {
        Map<String, List<PropertyValidator>> validatorsByProperty = new HashMap<>();

        List<PropertyValidator> validatorsVersion = new ArrayList<>();
        validatorsVersion.add(new org.uberfire.preferences.shared.impl.validation.NotEmptyValidator());
        validatorsVersion.add(new org.kie.workbench.common.screens.library.api.preferences.VersionValidator());
        validatorsByProperty.put("version", validatorsVersion);


        return validatorsByProperty;
    }

    @Override
    public boolean equals( final Object o ) {
        if ( this == o ) {
            return true;
        }
        if ( o == null || getClass() != o.getClass() ) {
            return false;
        }

        final LibraryProjectPreferencesPortableGeneratedImpl that = (LibraryProjectPreferencesPortableGeneratedImpl) o;

        if ( version != null ? !version.equals( that.version ) : that.version != null ) {
            return false;
        }
        if ( description != null ? !description.equals( that.description ) : that.description != null ) {
            return false;
        }
        if ( branch != null ? !branch.equals( that.branch ) : that.branch != null ) {
            return false;
        }

        return true;
    }

    @Override
    public int hashCode() {
        int result = 0;

        result = 31 * result + ( version != null ? version.hashCode() : 0 );
        result = ~~result;
        result = 31 * result + ( description != null ? description.hashCode() : 0 );
        result = ~~result;
        result = 31 * result + ( branch != null ? branch.hashCode() : 0 );
        result = ~~result;

        return result;
    }

    @Override
    public boolean isPersistable() {
        return true;
    }
}
