/*
 * Copyright 2016 Red Hat, Inc. and/or its affiliates.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.kie.workbench.common.screens.server.management.client.empty;

import javax.enterprise.context.Dependent;
import javax.inject.Inject;

import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.user.client.ui.Composite;
import org.gwtbootstrap3.client.ui.Anchor;
import org.gwtbootstrap3.client.ui.Button;
import org.jboss.errai.ui.shared.api.annotations.DataField;
import org.jboss.errai.ui.shared.api.annotations.EventHandler;
import org.jboss.errai.ui.shared.api.annotations.Templated;

@Dependent
@Templated
public class ServerEmptyView extends Composite
        implements ServerEmptyPresenter.View {

    private ServerEmptyPresenter presenter;

    @Inject
    @DataField("empty-add-template")
    Button addTemplate;

    @Inject
    @DataField("new-server-anchor")
    Anchor addTemplateAnchor;

    @Override
    public void init( final ServerEmptyPresenter presenter ) {
        this.presenter = presenter;
    }

    @EventHandler("empty-add-template")
    public void addTemplate( final ClickEvent event ) {
        presenter.addTemplate();
    }

    @EventHandler("new-server-anchor")
    public void addTemplateAnchor( final ClickEvent event ) {
        presenter.addTemplate();
    }

}
