/*
 * Copyright 2015 Red Hat, Inc. and/or its affiliates.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
*/

package org.kie.workbench.common.services.datamodeller.driver.model;

import java.util.ArrayList;
import java.util.List;

public abstract class DriverResult {

    public DriverResult() {
    }

    protected List<DriverError> errors = new ArrayList<DriverError>( );

    public List<DriverError> getErrors() {
        return errors;
    }

    public void addError( DriverError error ) {
        errors.add( error );
    }

    public boolean hasErrors() {
        return errors.size() > 0;
    }

    public DriverResult withErrors( List<DriverError> errors ) {
        this.errors.addAll( errors );
        return this;
    }

}
