package org.jboss.errai.ioc.client;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.ui.FlowPanel;
import com.google.gwt.user.client.ui.HeaderPanel;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.Tree;
import com.google.gwt.view.client.ListDataProvider;
import com.google.web.bindery.event.shared.EventBus;
import elemental2.dom.CustomElementRegistry.DefineOptionsType;
import elemental2.dom.Document.RegisterElementOptionsType;
import elemental2.dom.Document.RegisterOptionsType;
import elemental2.dom.Element.ScrollIntoViewTopType;
import elemental2.dom.File.FilePropertiesType;
import elemental2.dom.HTMLAnchorElement;
import elemental2.dom.HTMLButtonElement;
import elemental2.dom.HTMLDivElement;
import elemental2.dom.HTMLDocument;
import elemental2.dom.HTMLElement;
import elemental2.dom.HTMLElement.AttachShadowOptionsType;
import elemental2.dom.HTMLHeadingElement;
import elemental2.dom.HTMLInputElement;
import elemental2.dom.HTMLLIElement;
import elemental2.dom.HTMLLabelElement;
import elemental2.dom.HTMLOListElement;
import elemental2.dom.HTMLOptionElement;
import elemental2.dom.HTMLSelectElement;
import elemental2.dom.HTMLSlotElement.AssignedNodesOptionsType;
import elemental2.dom.HTMLTableSectionElement;
import elemental2.dom.HTMLTextAreaElement;
import elemental2.dom.HTMLUListElement;
import elemental2.dom.HashChangeEvent.HashChangeEventEventInitDictType;
import elemental2.dom.InputDeviceCapabilities.InputDeviceCapabilitiesOptionsType;
import elemental2.dom.PageTransitionEvent.PageTransitionEventEventInitDictType;
import elemental2.dom.PopStateEvent.PopStateEventEventInitDictType;
import elemental2.dom.RTCConfigurationInterface_.IceServersFieldType;
import elemental2.dom.RTCConfigurationInterface_.UrlsFieldType;
import elemental2.dom.RelatedEvent.RelatedEventEventInitDictType;
import java.util.Collection;
import java.util.List;
import java.util.Map;
import java.util.Set;
import javax.enterprise.event.Event;
import javax.enterprise.inject.Instance;
import javax.validation.Validator;
import org.dashbuilder.client.cms.layout.editor.PerspectiveDragComponent;
import org.dashbuilder.client.cms.layout.editor.PerspectiveDragConfigModal;
import org.dashbuilder.client.cms.layout.editor.PerspectiveDragConfigModalView;
import org.dashbuilder.client.cms.perspective.ContentManagerPerspective;
import org.dashbuilder.client.cms.perspective.ContentManagerPerspectiveActivity;
import org.dashbuilder.client.cms.resources.i18n.ContentManagerI18n;
import org.dashbuilder.client.cms.screen.explorer.NavigationExplorerScreen;
import org.dashbuilder.client.cms.screen.explorer.NavigationExplorerScreenActivity;
import org.dashbuilder.client.cms.screen.explorer.PerspectivesExplorerScreen;
import org.dashbuilder.client.cms.screen.explorer.PerspectivesExplorerScreenActivity;
import org.dashbuilder.client.cms.screen.home.ContentManagerHomeScreen;
import org.dashbuilder.client.cms.screen.home.ContentManagerHomeScreenActivity;
import org.dashbuilder.client.cms.screen.home.ContentManagerHomeView;
import org.dashbuilder.client.cms.widget.NewPerspectivePopUp;
import org.dashbuilder.client.cms.widget.NewPerspectivePopUpView;
import org.dashbuilder.client.cms.widget.PerspectiveWidget;
import org.dashbuilder.client.cms.widget.PerspectiveWidgetView;
import org.dashbuilder.client.cms.widget.PerspectivesExplorer;
import org.dashbuilder.client.cms.widget.PerspectivesExplorerView;
import org.dashbuilder.client.navigation.impl.NavigationManagerImpl;
import org.dashbuilder.client.navigation.layout.editor.NavCarouselDragComponent;
import org.dashbuilder.client.navigation.layout.editor.NavMenuBarDragComponent;
import org.dashbuilder.client.navigation.layout.editor.NavTabListDragComponent;
import org.dashbuilder.client.navigation.layout.editor.NavTilesDragComponent;
import org.dashbuilder.client.navigation.layout.editor.NavTreeDragComponent;
import org.dashbuilder.client.navigation.plugin.PerspectivePluginManager;
import org.dashbuilder.client.navigation.widget.NavCarouselWidget;
import org.dashbuilder.client.navigation.widget.NavCarouselWidgetView;
import org.dashbuilder.client.navigation.widget.NavComponentConfigModal;
import org.dashbuilder.client.navigation.widget.NavComponentConfigModalView;
import org.dashbuilder.client.navigation.widget.NavDropDownWidget;
import org.dashbuilder.client.navigation.widget.NavDropDownWidgetView;
import org.dashbuilder.client.navigation.widget.NavItemTileWidget;
import org.dashbuilder.client.navigation.widget.NavItemTileWidgetView;
import org.dashbuilder.client.navigation.widget.NavMenuBarWidget;
import org.dashbuilder.client.navigation.widget.NavMenuBarWidgetView;
import org.dashbuilder.client.navigation.widget.NavTabListWidget;
import org.dashbuilder.client.navigation.widget.NavTabListWidgetView;
import org.dashbuilder.client.navigation.widget.NavTilesWidget;
import org.dashbuilder.client.navigation.widget.NavTilesWidgetView;
import org.dashbuilder.client.navigation.widget.NavTreeWidget;
import org.dashbuilder.client.navigation.widget.NavTreeWidgetView;
import org.dashbuilder.client.navigation.widget.editor.NavItemDefaultEditor;
import org.dashbuilder.client.navigation.widget.editor.NavItemDefaultEditorView;
import org.dashbuilder.client.navigation.widget.editor.NavRootNodeEditor;
import org.dashbuilder.client.navigation.widget.editor.NavRootNodeEditorView;
import org.dashbuilder.client.navigation.widget.editor.NavTreeEditor;
import org.dashbuilder.client.navigation.widget.editor.NavTreeEditorView;
import org.dashbuilder.client.navigation.widget.editor.TargetPerspectiveEditor;
import org.dashbuilder.client.navigation.widget.editor.TargetPerspectiveEditorView;
import org.dashbuilder.client.widgets.common.ClientRuntimeErrorPopupPresenter;
import org.dashbuilder.client.widgets.common.LoadingBox;
import org.dashbuilder.client.widgets.common.LoadingBoxView;
import org.dashbuilder.client.widgets.dataset.editor.DataSetDefColumnsFilterEditor;
import org.dashbuilder.client.widgets.dataset.editor.DataSetDefColumnsFilterEditorView;
import org.dashbuilder.client.widgets.dataset.editor.DataSetDefFilterEditor;
import org.dashbuilder.client.widgets.dataset.editor.DataSetDefFilterEditorView;
import org.dashbuilder.client.widgets.dataset.editor.DataSetDefPreviewTable;
import org.dashbuilder.client.widgets.dataset.editor.DataSetDefPreviewTableView;
import org.dashbuilder.client.widgets.dataset.editor.DataSetDefProviderTypeEditor;
import org.dashbuilder.client.widgets.dataset.editor.DataSetDefProviderTypeEditorView;
import org.dashbuilder.client.widgets.dataset.editor.DataSetEditorView;
import org.dashbuilder.client.widgets.dataset.editor.attributes.DataSetDefBackendCacheAttributesEditor;
import org.dashbuilder.client.widgets.dataset.editor.attributes.DataSetDefBasicAttributesEditor;
import org.dashbuilder.client.widgets.dataset.editor.attributes.DataSetDefBasicAttributesEditorView;
import org.dashbuilder.client.widgets.dataset.editor.attributes.DataSetDefCacheAttributesEditorViewImpl;
import org.dashbuilder.client.widgets.dataset.editor.attributes.DataSetDefClientCacheAttributesEditor;
import org.dashbuilder.client.widgets.dataset.editor.attributes.DataSetDefRefreshAttributesEditor;
import org.dashbuilder.client.widgets.dataset.editor.attributes.DataSetDefRefreshAttributesEditorView;
import org.dashbuilder.client.widgets.dataset.editor.attributes.DataSetDefRefreshIntervalEditor;
import org.dashbuilder.client.widgets.dataset.editor.attributes.DataSetDefRefreshIntervalEditorView;
import org.dashbuilder.client.widgets.dataset.editor.bean.BeanDataSetDefAttributesEditor;
import org.dashbuilder.client.widgets.dataset.editor.bean.BeanDataSetDefAttributesEditorView;
import org.dashbuilder.client.widgets.dataset.editor.bean.BeanDataSetEditor;
import org.dashbuilder.client.widgets.dataset.editor.column.ColumnListEditor;
import org.dashbuilder.client.widgets.dataset.editor.column.ColumnListEditorView;
import org.dashbuilder.client.widgets.dataset.editor.column.ColumnTypeEditor;
import org.dashbuilder.client.widgets.dataset.editor.column.DataColumnDefEditor;
import org.dashbuilder.client.widgets.dataset.editor.column.DataColumnDefEditorView;
import org.dashbuilder.client.widgets.dataset.editor.column.DataSetDefColumnsEditor;
import org.dashbuilder.client.widgets.dataset.editor.csv.CSVDataSetDefAttributesEditor;
import org.dashbuilder.client.widgets.dataset.editor.csv.CSVDataSetDefAttributesEditorView;
import org.dashbuilder.client.widgets.dataset.editor.csv.CSVDataSetEditor;
import org.dashbuilder.client.widgets.dataset.editor.driver.BeanDataSetDefAttributesDriver;
import org.dashbuilder.client.widgets.dataset.editor.driver.BeanDataSetDefDriver;
import org.dashbuilder.client.widgets.dataset.editor.driver.CSVDataSetDefAttributesDriver;
import org.dashbuilder.client.widgets.dataset.editor.driver.CSVDataSetDefDriver;
import org.dashbuilder.client.widgets.dataset.editor.driver.DataColumnDefDriver;
import org.dashbuilder.client.widgets.dataset.editor.driver.DataSetDefBasicAttributesDriver;
import org.dashbuilder.client.widgets.dataset.editor.driver.DataSetDefProviderTypeDriver;
import org.dashbuilder.client.widgets.dataset.editor.driver.DataSetEditorDriverFactory;
import org.dashbuilder.client.widgets.dataset.editor.driver.ElasticSearchDataSetDefAttributesDriver;
import org.dashbuilder.client.widgets.dataset.editor.driver.ElasticSearchDataSetDefDriver;
import org.dashbuilder.client.widgets.dataset.editor.driver.SQLDataSetDefAttributesDriver;
import org.dashbuilder.client.widgets.dataset.editor.driver.SQLDataSetDefDriver;
import org.dashbuilder.client.widgets.dataset.editor.elasticsearch.ElasticSearchDataSetDefAttributesEditor;
import org.dashbuilder.client.widgets.dataset.editor.elasticsearch.ElasticSearchDataSetDefAttributesEditorView;
import org.dashbuilder.client.widgets.dataset.editor.elasticsearch.ElasticSearchDataSetEditor;
import org.dashbuilder.client.widgets.dataset.editor.sql.SQLDataSetDefAttributesEditor;
import org.dashbuilder.client.widgets.dataset.editor.sql.SQLDataSetDefAttributesEditorView;
import org.dashbuilder.client.widgets.dataset.editor.sql.SQLDataSetEditor;
import org.dashbuilder.client.widgets.dataset.editor.workflow.DataSetEditorWorkflowFactory;
import org.dashbuilder.client.widgets.dataset.editor.workflow.DataSetEditorWorkflowView;
import org.dashbuilder.client.widgets.dataset.editor.workflow.create.BeanDataSetBasicAttributesWorkflow;
import org.dashbuilder.client.widgets.dataset.editor.workflow.create.CSVDataSetBasicAttributesWorkflow;
import org.dashbuilder.client.widgets.dataset.editor.workflow.create.DataSetProviderTypeWorkflow;
import org.dashbuilder.client.widgets.dataset.editor.workflow.create.ElasticSearchDataSetBasicAttributesWorkflow;
import org.dashbuilder.client.widgets.dataset.editor.workflow.create.SQLDataSetBasicAttributesWorkflow;
import org.dashbuilder.client.widgets.dataset.editor.workflow.edit.BeanDataSetEditWorkflow;
import org.dashbuilder.client.widgets.dataset.editor.workflow.edit.CSVDataSetEditWorkflow;
import org.dashbuilder.client.widgets.dataset.editor.workflow.edit.ElasticSearchDataSetEditWorkflow;
import org.dashbuilder.client.widgets.dataset.editor.workflow.edit.SQLDataSetEditWorkflow;
import org.dashbuilder.client.widgets.dataset.explorer.DataSetExplorer;
import org.dashbuilder.client.widgets.dataset.explorer.DataSetExplorerView;
import org.dashbuilder.client.widgets.dataset.explorer.DataSetPanel;
import org.dashbuilder.client.widgets.dataset.explorer.DataSetPanelView;
import org.dashbuilder.client.widgets.dataset.explorer.DataSetSummary;
import org.dashbuilder.client.widgets.dataset.explorer.DataSetSummaryView;
import org.dashbuilder.common.client.backend.PathUrlFactory;
import org.dashbuilder.common.client.editor.ToggleSwitchEditor;
import org.dashbuilder.common.client.editor.ToggleSwitchEditorView;
import org.dashbuilder.common.client.editor.ValueBoxEditor;
import org.dashbuilder.common.client.editor.ValueBoxEditorView;
import org.dashbuilder.common.client.editor.file.FileUploadEditor;
import org.dashbuilder.common.client.editor.file.FileUploadEditorView;
import org.dashbuilder.common.client.editor.list.DropDownEditor;
import org.dashbuilder.common.client.editor.list.DropDownEditorView;
import org.dashbuilder.common.client.editor.list.DropDownImageListEditor;
import org.dashbuilder.common.client.editor.list.DropDownImageListEditorView;
import org.dashbuilder.common.client.editor.list.HorizImageListEditor;
import org.dashbuilder.common.client.editor.list.HorizImageListEditorView;
import org.dashbuilder.common.client.editor.map.MapEditor;
import org.dashbuilder.common.client.editor.map.MapEditorView;
import org.dashbuilder.common.client.widgets.AlertBox;
import org.dashbuilder.common.client.widgets.AlertBoxView;
import org.dashbuilder.common.client.widgets.AlertPanel;
import org.dashbuilder.common.client.widgets.AlertPanelView;
import org.dashbuilder.common.client.widgets.FilterLabel;
import org.dashbuilder.common.client.widgets.FilterLabelSet;
import org.dashbuilder.common.client.widgets.FilterLabelSetView;
import org.dashbuilder.common.client.widgets.FilterLabelView;
import org.dashbuilder.dataset.client.ClientDataSetManager;
import org.dashbuilder.dataset.client.DataSetClientServices;
import org.dashbuilder.dataset.client.engine.ClientChronometer;
import org.dashbuilder.dataset.client.engine.ClientDateFormatterImpl;
import org.dashbuilder.dataset.client.engine.ClientIntervalBuilderDynamicDate;
import org.dashbuilder.dataset.client.engine.ClientIntervalBuilderLocator;
import org.dashbuilder.dataset.client.uuid.ClientUUIDGenerator;
import org.dashbuilder.dataset.editor.client.perspectives.DataSetAuthoringPerspective;
import org.dashbuilder.dataset.editor.client.perspectives.DataSetAuthoringPerspectiveActivity;
import org.dashbuilder.dataset.editor.client.screens.DataSetAuthoringHomePresenter;
import org.dashbuilder.dataset.editor.client.screens.DataSetAuthoringHomePresenterActivity;
import org.dashbuilder.dataset.editor.client.screens.DataSetAuthoringHomeView;
import org.dashbuilder.dataset.editor.client.screens.DataSetDefEditorPresenter;
import org.dashbuilder.dataset.editor.client.screens.DataSetDefEditorPresenterActivity;
import org.dashbuilder.dataset.editor.client.screens.DataSetDefExplorerScreen;
import org.dashbuilder.dataset.editor.client.screens.DataSetDefExplorerScreenActivity;
import org.dashbuilder.dataset.editor.client.screens.DataSetDefScreenViewImpl;
import org.dashbuilder.dataset.editor.client.screens.DataSetDefType;
import org.dashbuilder.dataset.editor.client.screens.DataSetDefWizardScreen;
import org.dashbuilder.dataset.editor.client.screens.DataSetDefWizardScreenActivity;
import org.dashbuilder.dataset.engine.function.AggregateFunctionManagerImpl;
import org.dashbuilder.dataset.engine.group.IntervalBuilderDynamicLabel;
import org.dashbuilder.dataset.engine.group.IntervalBuilderFixedDate;
import org.dashbuilder.displayer.client.ClientSettings;
import org.dashbuilder.displayer.client.DisplayerCoordinator;
import org.dashbuilder.displayer.client.DisplayerLocator;
import org.dashbuilder.displayer.client.DisplayerScreenPresenter;
import org.dashbuilder.displayer.client.DisplayerScreenPresenterActivity;
import org.dashbuilder.displayer.client.PerspectiveCoordinator;
import org.dashbuilder.displayer.client.RendererManager;
import org.dashbuilder.displayer.client.formatter.ValueFormatterRegistry;
import org.dashbuilder.displayer.client.prototypes.DataSetPrototypes;
import org.dashbuilder.displayer.client.prototypes.DisplayerPrototypes;
import org.dashbuilder.displayer.client.widgets.DataSetLookupEditor;
import org.dashbuilder.displayer.client.widgets.DataSetLookupEditorView;
import org.dashbuilder.displayer.client.widgets.DisplayerEditor;
import org.dashbuilder.displayer.client.widgets.DisplayerEditorPopup;
import org.dashbuilder.displayer.client.widgets.DisplayerEditorStatus;
import org.dashbuilder.displayer.client.widgets.DisplayerEditorView;
import org.dashbuilder.displayer.client.widgets.DisplayerError;
import org.dashbuilder.displayer.client.widgets.DisplayerHtmlEditor;
import org.dashbuilder.displayer.client.widgets.DisplayerHtmlEditorView;
import org.dashbuilder.displayer.client.widgets.DisplayerSettingsEditor;
import org.dashbuilder.displayer.client.widgets.DisplayerSettingsEditorView;
import org.dashbuilder.displayer.client.widgets.DisplayerSettingsJSONSourceViewer;
import org.dashbuilder.displayer.client.widgets.DisplayerSubtypeSelector;
import org.dashbuilder.displayer.client.widgets.DisplayerSubtypeSelectorView;
import org.dashbuilder.displayer.client.widgets.DisplayerTypeSelector;
import org.dashbuilder.displayer.client.widgets.DisplayerTypeSelectorView;
import org.dashbuilder.displayer.client.widgets.DisplayerViewer;
import org.dashbuilder.displayer.client.widgets.RendererSelector;
import org.dashbuilder.displayer.client.widgets.RendererSelectorListBoxView;
import org.dashbuilder.displayer.client.widgets.RendererSelectorRadioListView;
import org.dashbuilder.displayer.client.widgets.RendererSelectorTabListView;
import org.dashbuilder.displayer.client.widgets.filter.ColumnFilterEditor;
import org.dashbuilder.displayer.client.widgets.filter.ColumnFilterEditorView;
import org.dashbuilder.displayer.client.widgets.filter.DataSetFilterEditor;
import org.dashbuilder.displayer.client.widgets.filter.DataSetFilterEditorView;
import org.dashbuilder.displayer.client.widgets.filter.DateParameterEditor;
import org.dashbuilder.displayer.client.widgets.filter.DateParameterEditorView;
import org.dashbuilder.displayer.client.widgets.filter.LikeToFunctionEditor;
import org.dashbuilder.displayer.client.widgets.filter.LikeToFunctionEditorView;
import org.dashbuilder.displayer.client.widgets.filter.MultipleNumberParameterEditor;
import org.dashbuilder.displayer.client.widgets.filter.MultipleNumberParameterEditorView;
import org.dashbuilder.displayer.client.widgets.filter.MultipleTextParameterEditor;
import org.dashbuilder.displayer.client.widgets.filter.MultipleTextParameterEditorView;
import org.dashbuilder.displayer.client.widgets.filter.NumberParameterEditor;
import org.dashbuilder.displayer.client.widgets.filter.NumberParameterEditorView;
import org.dashbuilder.displayer.client.widgets.filter.TextParameterEditor;
import org.dashbuilder.displayer.client.widgets.filter.TextParameterEditorView;
import org.dashbuilder.displayer.client.widgets.filter.TimeAmountEditor;
import org.dashbuilder.displayer.client.widgets.filter.TimeAmountEditorView;
import org.dashbuilder.displayer.client.widgets.filter.TimeFrameEditor;
import org.dashbuilder.displayer.client.widgets.filter.TimeFrameEditorView;
import org.dashbuilder.displayer.client.widgets.filter.TimeInstantEditor;
import org.dashbuilder.displayer.client.widgets.filter.TimeInstantEditorView;
import org.dashbuilder.displayer.client.widgets.group.ColumnDetailsEditor;
import org.dashbuilder.displayer.client.widgets.group.ColumnDetailsEditorView;
import org.dashbuilder.displayer.client.widgets.group.ColumnFunctionEditor;
import org.dashbuilder.displayer.client.widgets.group.ColumnFunctionEditorView;
import org.dashbuilder.displayer.client.widgets.group.DataSetGroupDateEditor;
import org.dashbuilder.displayer.client.widgets.group.DataSetGroupDateEditorView;
import org.dashbuilder.displayer.client.widgets.sourcecode.DefaultHtmlValidator;
import org.dashbuilder.displayer.client.widgets.sourcecode.DefaultJsEvaluator;
import org.dashbuilder.displayer.client.widgets.sourcecode.DefaultJsValidator;
import org.dashbuilder.displayer.client.widgets.sourcecode.SourceCodeEditor;
import org.dashbuilder.displayer.client.widgets.sourcecode.SourceCodeEditorView;
import org.dashbuilder.navigation.workbench.NavSecurityController;
import org.dashbuilder.renderer.client.DefaultRenderer;
import org.dashbuilder.renderer.client.metric.MetricDisplayer;
import org.dashbuilder.renderer.client.metric.MetricView;
import org.dashbuilder.renderer.client.selector.SelectorDisplayer;
import org.dashbuilder.renderer.client.selector.SelectorDisplayerView;
import org.dashbuilder.renderer.client.selector.SelectorDropDownDisplayer;
import org.dashbuilder.renderer.client.selector.SelectorDropDownDisplayerView;
import org.dashbuilder.renderer.client.selector.SelectorDropDownItem;
import org.dashbuilder.renderer.client.selector.SelectorDropDownItemView;
import org.dashbuilder.renderer.client.selector.SelectorLabelItem;
import org.dashbuilder.renderer.client.selector.SelectorLabelItemView;
import org.dashbuilder.renderer.client.selector.SelectorLabelSetDisplayer;
import org.dashbuilder.renderer.client.selector.SelectorLabelSetDisplayerView;
import org.dashbuilder.renderer.client.selector.SelectorSliderDisplayer;
import org.dashbuilder.renderer.client.selector.SelectorSliderDisplayerView;
import org.dashbuilder.renderer.client.table.TableDisplayer;
import org.dashbuilder.renderer.client.table.TableDisplayerView;
import org.dashbuilder.renderer.google.client.GoogleAreaChartDisplayer;
import org.dashbuilder.renderer.google.client.GoogleAreaChartDisplayerView;
import org.dashbuilder.renderer.google.client.GoogleBarChartDisplayer;
import org.dashbuilder.renderer.google.client.GoogleBarChartDisplayerView;
import org.dashbuilder.renderer.google.client.GoogleBubbleChartDisplayer;
import org.dashbuilder.renderer.google.client.GoogleBubbleChartDisplayerView;
import org.dashbuilder.renderer.google.client.GoogleLineChartDisplayer;
import org.dashbuilder.renderer.google.client.GoogleLineChartDisplayerView;
import org.dashbuilder.renderer.google.client.GoogleMapDisplayer;
import org.dashbuilder.renderer.google.client.GoogleMapDisplayerView;
import org.dashbuilder.renderer.google.client.GoogleMeterChartDisplayer;
import org.dashbuilder.renderer.google.client.GoogleMeterChartDisplayerView;
import org.dashbuilder.renderer.google.client.GooglePieChartDisplayer;
import org.dashbuilder.renderer.google.client.GooglePieChartDisplayerView;
import org.dashbuilder.renderer.google.client.GoogleRenderer;
import org.dashbuilder.renderer.google.client.GoogleTableDisplayer;
import org.dashbuilder.renderer.google.client.GoogleTableDisplayerView;
import org.dashbuilder.validations.DataSetValidatorProvider;
import org.dashbuilder.validations.dataset.BeanDataSetDefValidator;
import org.dashbuilder.validations.dataset.CSVDataSetDefValidator;
import org.dashbuilder.validations.dataset.ElasticSearchDataSetDefValidator;
import org.dashbuilder.validations.dataset.SQLDataSetDefValidator;
import org.drools.workbench.screens.drltext.client.DRLEditorEntryPoint;
import org.drools.workbench.screens.drltext.client.editor.DRLEditorPresenter;
import org.drools.workbench.screens.drltext.client.editor.DRLEditorPresenterActivity;
import org.drools.workbench.screens.drltext.client.editor.DRLEditorViewImpl;
import org.drools.workbench.screens.drltext.client.handlers.NewDrlTextHandler;
import org.drools.workbench.screens.drltext.client.type.DRLResourceType;
import org.drools.workbench.screens.drltext.client.type.DSLRResourceType;
import org.drools.workbench.screens.drltext.type.DRLResourceTypeDefinition;
import org.drools.workbench.screens.drltext.type.DSLRResourceTypeDefinition;
import org.drools.workbench.screens.dsltext.client.DSLEditorEntryPoint;
import org.drools.workbench.screens.dsltext.client.editor.DSLEditorPresenter;
import org.drools.workbench.screens.dsltext.client.editor.DSLEditorPresenterActivity;
import org.drools.workbench.screens.dsltext.client.editor.DSLEditorViewImpl;
import org.drools.workbench.screens.dsltext.client.handlers.NewDslTextHandler;
import org.drools.workbench.screens.dsltext.client.type.DSLResourceType;
import org.drools.workbench.screens.dsltext.type.DSLResourceTypeDefinition;
import org.drools.workbench.screens.dtablexls.client.DecisionTableXLSEntryPoint;
import org.drools.workbench.screens.dtablexls.client.editor.DecisionTableXLSEditorPresenter;
import org.drools.workbench.screens.dtablexls.client.editor.DecisionTableXLSEditorPresenterActivity;
import org.drools.workbench.screens.dtablexls.client.editor.DecisionTableXLSEditorViewImpl;
import org.drools.workbench.screens.dtablexls.client.handlers.NewDecisionTableXLSHandler;
import org.drools.workbench.screens.dtablexls.client.type.DecisionTableXLSResourceType;
import org.drools.workbench.screens.dtablexls.client.type.DecisionTableXLSXResourceType;
import org.drools.workbench.screens.dtablexls.type.DecisionTableXLSResourceTypeDefinition;
import org.drools.workbench.screens.dtablexls.type.DecisionTableXLSXResourceTypeDefinition;
import org.drools.workbench.screens.enums.client.EnumEditorEntryPoint;
import org.drools.workbench.screens.enums.client.editor.EnumEditorPresenter;
import org.drools.workbench.screens.enums.client.editor.EnumEditorPresenterActivity;
import org.drools.workbench.screens.enums.client.editor.EnumEditorViewImpl;
import org.drools.workbench.screens.enums.client.handlers.NewEnumHandler;
import org.drools.workbench.screens.enums.client.type.EnumResourceType;
import org.drools.workbench.screens.enums.type.EnumResourceTypeDefinition;
import org.drools.workbench.screens.globals.client.GlobalsEditorEntryPoint;
import org.drools.workbench.screens.globals.client.editor.AddGlobalPopup;
import org.drools.workbench.screens.globals.client.editor.AddGlobalPopupViewImpl;
import org.drools.workbench.screens.globals.client.editor.GlobalsEditorPresenter;
import org.drools.workbench.screens.globals.client.editor.GlobalsEditorPresenterActivity;
import org.drools.workbench.screens.globals.client.editor.GlobalsEditorViewImpl;
import org.drools.workbench.screens.globals.client.handlers.NewGlobalHandler;
import org.drools.workbench.screens.globals.client.type.GlobalResourceType;
import org.drools.workbench.screens.globals.type.GlobalResourceTypeDefinition;
import org.drools.workbench.screens.guided.dtable.client.GuidedDecisionTableEditorEntryPoint;
import org.drools.workbench.screens.guided.dtable.client.editor.GuidedDecisionTableEditorPresenter;
import org.drools.workbench.screens.guided.dtable.client.editor.GuidedDecisionTableEditorPresenterActivity;
import org.drools.workbench.screens.guided.dtable.client.editor.GuidedDecisionTableEditorViewImpl;
import org.drools.workbench.screens.guided.dtable.client.editor.GuidedDecisionTableGraphEditorPresenter;
import org.drools.workbench.screens.guided.dtable.client.editor.GuidedDecisionTableGraphEditorPresenterActivity;
import org.drools.workbench.screens.guided.dtable.client.editor.clipboard.impl.DefaultClipboard;
import org.drools.workbench.screens.guided.dtable.client.editor.menu.CellContextMenu;
import org.drools.workbench.screens.guided.dtable.client.editor.menu.CellContextMenuViewImpl;
import org.drools.workbench.screens.guided.dtable.client.editor.menu.EditMenuBuilder;
import org.drools.workbench.screens.guided.dtable.client.editor.menu.InsertMenuBuilder;
import org.drools.workbench.screens.guided.dtable.client.editor.menu.RadarMenuBuilder;
import org.drools.workbench.screens.guided.dtable.client.editor.menu.RadarMenuViewImpl;
import org.drools.workbench.screens.guided.dtable.client.editor.menu.RowContextMenu;
import org.drools.workbench.screens.guided.dtable.client.editor.menu.RowContextMenuViewImpl;
import org.drools.workbench.screens.guided.dtable.client.editor.menu.ViewMenuBuilder;
import org.drools.workbench.screens.guided.dtable.client.editor.page.ColumnsPage;
import org.drools.workbench.screens.guided.dtable.client.editor.page.ColumnsPagePresenter;
import org.drools.workbench.screens.guided.dtable.client.editor.page.ColumnsPageView;
import org.drools.workbench.screens.guided.dtable.client.editor.page.accordion.GuidedDecisionTableAccordion;
import org.drools.workbench.screens.guided.dtable.client.editor.page.accordion.GuidedDecisionTableAccordionItem;
import org.drools.workbench.screens.guided.dtable.client.editor.page.accordion.GuidedDecisionTableAccordionItemView;
import org.drools.workbench.screens.guided.dtable.client.editor.page.accordion.GuidedDecisionTableAccordionView;
import org.drools.workbench.screens.guided.dtable.client.handlers.GuidedDecisionTableOptions;
import org.drools.workbench.screens.guided.dtable.client.handlers.HitPolicySelector;
import org.drools.workbench.screens.guided.dtable.client.handlers.HitPolicySelectorViewImpl;
import org.drools.workbench.screens.guided.dtable.client.handlers.NewGuidedDecisionTableGraphHandler;
import org.drools.workbench.screens.guided.dtable.client.handlers.NewGuidedDecisionTableHandler;
import org.drools.workbench.screens.guided.dtable.client.type.GuidedDTableGraphResourceType;
import org.drools.workbench.screens.guided.dtable.client.type.GuidedDTableResourceType;
import org.drools.workbench.screens.guided.dtable.client.widget.analysis.DecisionTableAnalyzerProvider;
import org.drools.workbench.screens.guided.dtable.client.widget.table.GuidedDecisionTableModellerContextMenuSupport;
import org.drools.workbench.screens.guided.dtable.client.widget.table.GuidedDecisionTableModellerPresenter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.GuidedDecisionTableModellerViewImpl;
import org.drools.workbench.screens.guided.dtable.client.widget.table.GuidedDecisionTablePresenter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.PluginHandler;
import org.drools.workbench.screens.guided.dtable.client.widget.table.columns.control.AttributeColumnConfigRow;
import org.drools.workbench.screens.guided.dtable.client.widget.table.columns.control.AttributeColumnConfigRowView;
import org.drools.workbench.screens.guided.dtable.client.widget.table.columns.control.ColumnManagementView;
import org.drools.workbench.screens.guided.dtable.client.widget.table.columns.control.DeleteColumnManagementAnchorWidget;
import org.drools.workbench.screens.guided.dtable.client.widget.table.lockmanager.GuidedDecisionTableLockManagerImpl;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.cell.impl.GridWidgetCellFactoryImpl;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.ActionInsertFactColumnConverter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.ActionRetractFactColumnConverter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.ActionSetFieldColumnConverter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.ActionWorkItemExecuteColumnConverter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.ActionWorkItemInsertFactColumnConverter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.ActionWorkItemSetFieldColumnConverter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.AttributeColumnConverter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.BRLActionVariableColumnConverter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.BRLConditionVariableColumnConverter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.ConditionColumnConverter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.DescriptionColumnConverter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.GridWidgetColumnFactoryImpl;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.LimitedEntryColumnConverter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.MetaDataColumnConverter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.converters.column.impl.RowNumberColumnConverter;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.ActionColumnSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.ActionInsertFactColumnSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.ActionRetractFactColumnSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.ActionSetFieldColumnSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.ActionWorkItemExecuteColumnSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.ActionWorkItemInsertFactColumnSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.ActionWorkItemSetFieldColumnSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.AttributeColumnSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.BRLActionColumnSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.BRLConditionColumnSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.ConditionColumnSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.LimitedEntryBRLActionColumnSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.LimitedEntryBRLConditionColumnSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.MetaDataColumnSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.ModelSynchronizerImpl;
import org.drools.workbench.screens.guided.dtable.client.widget.table.model.synchronizers.impl.RowSynchronizer;
import org.drools.workbench.screens.guided.dtable.client.widget.table.popovers.ColumnHeaderPopOverImpl;
import org.drools.workbench.screens.guided.dtable.client.widget.table.popovers.PopOverViewImpl;
import org.drools.workbench.screens.guided.dtable.client.widget.table.popovers.definitions.ActionInsertFactCol52DefinitionBuilder;
import org.drools.workbench.screens.guided.dtable.client.widget.table.popovers.definitions.ActionRetractFactCol52DefinitionBuilder;
import org.drools.workbench.screens.guided.dtable.client.widget.table.popovers.definitions.ActionSetFieldCol52DefinitionBuilder;
import org.drools.workbench.screens.guided.dtable.client.widget.table.popovers.definitions.BRLActionColumnDefinitionBuilder;
import org.drools.workbench.screens.guided.dtable.client.widget.table.popovers.definitions.BRLConditionColumnDefinitionBuilder;
import org.drools.workbench.screens.guided.dtable.client.widget.table.popovers.definitions.ColumnDefinitionFactory;
import org.drools.workbench.screens.guided.dtable.client.widget.table.popovers.definitions.ConditionCol52DefinitionBuilder;
import org.drools.workbench.screens.guided.dtable.client.widget.table.popovers.definitions.LimitedEntryActionInsertFactCol52DefinitionBuilder;
import org.drools.workbench.screens.guided.dtable.client.widget.table.popovers.definitions.LimitedEntryActionRetractFactCol52DefinitionBuilder;
import org.drools.workbench.screens.guided.dtable.client.widget.table.popovers.definitions.LimitedEntryActionSetFieldCol52DefinitionBuilder;
import org.drools.workbench.screens.guided.dtable.client.widget.table.popovers.definitions.LimitedEntryConditionCol52DefinitionBuilder;
import org.drools.workbench.screens.guided.dtable.client.widget.table.utilities.EnumLoaderUtilities;
import org.drools.workbench.screens.guided.dtable.client.wizard.NewGuidedDecisionTableWizardHelper;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.NewGuidedDecisionTableColumnWizard;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.pages.AdditionalInfoPage;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.pages.AdditionalInfoPageView;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.pages.AttributeColumnPage;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.pages.AttributeColumnPageView;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.pages.CalculationTypePage;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.pages.CalculationTypePageView;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.pages.FieldPage;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.pages.FieldPageView;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.pages.MetaDataColumnPage;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.pages.MetaDataColumnPageView;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.pages.OperatorPage;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.pages.OperatorPageView;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.pages.PatternPage;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.pages.PatternPageView;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.pages.PatternToDeletePage;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.pages.PatternToDeletePageView;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.pages.RuleModellerPage;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.pages.RuleModellerPageView;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.pages.SummaryPageView;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.pages.ValueOptionsPage;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.pages.ValueOptionsPageView;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.pages.WorkItemPage;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.pages.WorkItemPageView;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.pages.common.DecisionTablePopoverUtils;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.pages.modals.NewPatternPresenter;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.pages.modals.NewPatternView;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.plugins.ActionRetractFactPlugin;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.plugins.ActionSetFactPlugin;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.plugins.ActionWorkItemPlugin;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.plugins.ActionWorkItemSetFieldPlugin;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.plugins.AttributeColumnPlugin;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.plugins.BRLActionColumnPlugin;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.plugins.BRLConditionColumnPlugin;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.plugins.ConditionColumnPlugin;
import org.drools.workbench.screens.guided.dtable.client.wizard.column.plugins.MetaDataColumnPlugin;
import org.drools.workbench.screens.guided.dtable.client.wizard.table.NewGuidedDecisionTableWizard;
import org.drools.workbench.screens.guided.dtable.client.wizard.table.pages.ActionInsertFactFieldsPage;
import org.drools.workbench.screens.guided.dtable.client.wizard.table.pages.ActionInsertFactFieldsPageViewImpl;
import org.drools.workbench.screens.guided.dtable.client.wizard.table.pages.ActionSetFieldsPage;
import org.drools.workbench.screens.guided.dtable.client.wizard.table.pages.ActionSetFieldsPageViewImpl;
import org.drools.workbench.screens.guided.dtable.client.wizard.table.pages.ColumnExpansionPage;
import org.drools.workbench.screens.guided.dtable.client.wizard.table.pages.ColumnExpansionPageViewImpl;
import org.drools.workbench.screens.guided.dtable.client.wizard.table.pages.FactPatternConstraintsPage;
import org.drools.workbench.screens.guided.dtable.client.wizard.table.pages.FactPatternConstraintsPageViewImpl;
import org.drools.workbench.screens.guided.dtable.client.wizard.table.pages.FactPatternsPage;
import org.drools.workbench.screens.guided.dtable.client.wizard.table.pages.FactPatternsPageViewImpl;
import org.drools.workbench.screens.guided.dtable.client.wizard.table.pages.ImportsPage;
import org.drools.workbench.screens.guided.dtable.client.wizard.table.pages.ImportsPageViewImpl;
import org.drools.workbench.screens.guided.dtable.client.wizard.table.pages.SummaryPage;
import org.drools.workbench.screens.guided.dtable.client.wizard.table.pages.SummaryPageViewImpl;
import org.drools.workbench.screens.guided.dtable.client.wizard.table.pages.cells.ActionInsertFactFieldCell;
import org.drools.workbench.screens.guided.dtable.client.wizard.table.pages.cells.ActionInsertFactFieldPatternCell;
import org.drools.workbench.screens.guided.dtable.client.wizard.table.pages.cells.ActionSetFieldCell;
import org.drools.workbench.screens.guided.dtable.client.wizard.table.pages.cells.ActionSetFieldPatternCell;
import org.drools.workbench.screens.guided.dtable.client.wizard.table.pages.cells.ConditionCell;
import org.drools.workbench.screens.guided.dtable.client.wizard.table.pages.cells.ConditionPatternCell;
import org.drools.workbench.screens.guided.dtable.client.wizard.table.pages.cells.DefaultPatternCell;
import org.drools.workbench.screens.guided.dtable.shared.DefaultGuidedDecisionTableLinkManager;
import org.drools.workbench.screens.guided.dtable.type.GuidedDTableGraphResourceTypeDefinition;
import org.drools.workbench.screens.guided.dtable.type.GuidedDTableResourceTypeDefinition;
import org.drools.workbench.screens.guided.dtree.client.editor.GuidedDecisionTreeEditorPresenter;
import org.drools.workbench.screens.guided.dtree.client.editor.GuidedDecisionTreeEditorPresenterActivity;
import org.drools.workbench.screens.guided.dtree.client.editor.GuidedDecisionTreeEditorViewImpl;
import org.drools.workbench.screens.guided.dtree.client.handlers.NewGuidedDecisionTreeHandler;
import org.drools.workbench.screens.guided.dtree.client.type.GuidedDTreeResourceType;
import org.drools.workbench.screens.guided.dtree.client.widget.GuidedDecisionTreeWidget;
import org.drools.workbench.screens.guided.dtree.client.widget.factories.ActionInsertNodeFactory;
import org.drools.workbench.screens.guided.dtree.client.widget.factories.ActionRetractNodeFactory;
import org.drools.workbench.screens.guided.dtree.client.widget.factories.ActionUpdateNodeFactory;
import org.drools.workbench.screens.guided.dtree.client.widget.factories.ConstraintNodeFactory;
import org.drools.workbench.screens.guided.dtree.client.widget.factories.TypeNodeFactory;
import org.drools.workbench.screens.guided.dtree.client.widget.palette.GuidedDecisionTreePalette;
import org.drools.workbench.screens.guided.dtree.client.widget.palette.GuidedDecisionTreeStencilPaletteBuilder;
import org.drools.workbench.screens.guided.dtree.type.GuidedDTreeResourceTypeDefinition;
import org.drools.workbench.screens.guided.rule.client.GuidedRuleEditorEntryPoint;
import org.drools.workbench.screens.guided.rule.client.editor.GuidedRuleEditorPresenter;
import org.drools.workbench.screens.guided.rule.client.editor.GuidedRuleEditorPresenterActivity;
import org.drools.workbench.screens.guided.rule.client.editor.GuidedRuleEditorViewImpl;
import org.drools.workbench.screens.guided.rule.client.handlers.NewGuidedRuleHandler;
import org.drools.workbench.screens.guided.rule.client.type.GuidedRuleDRLResourceType;
import org.drools.workbench.screens.guided.rule.client.type.GuidedRuleDSLRResourceType;
import org.drools.workbench.screens.guided.rule.type.GuidedRuleDRLResourceTypeDefinition;
import org.drools.workbench.screens.guided.rule.type.GuidedRuleDSLRResourceTypeDefinition;
import org.drools.workbench.screens.guided.scorecard.client.editor.GuidedScoreCardEditorPresenter;
import org.drools.workbench.screens.guided.scorecard.client.editor.GuidedScoreCardEditorPresenterActivity;
import org.drools.workbench.screens.guided.scorecard.client.editor.GuidedScoreCardEditorViewImpl;
import org.drools.workbench.screens.guided.scorecard.client.handlers.NewGuidedScoreCardHandler;
import org.drools.workbench.screens.guided.scorecard.client.type.GuidedScoreCardResourceType;
import org.drools.workbench.screens.guided.scorecard.type.GuidedScoreCardResourceTypeDefinition;
import org.drools.workbench.screens.guided.template.client.GuidedRuleTemplateEntryPoint;
import org.drools.workbench.screens.guided.template.client.editor.GuidedRuleTemplateDataViewImpl;
import org.drools.workbench.screens.guided.template.client.editor.GuidedRuleTemplateEditorPresenter;
import org.drools.workbench.screens.guided.template.client.editor.GuidedRuleTemplateEditorPresenterActivity;
import org.drools.workbench.screens.guided.template.client.editor.GuidedRuleTemplateEditorViewImpl;
import org.drools.workbench.screens.guided.template.client.handlers.NewGuidedRuleTemplateHandler;
import org.drools.workbench.screens.guided.template.client.type.GuidedRuleTemplateResourceType;
import org.drools.workbench.screens.guided.template.type.GuidedRuleTemplateResourceTypeDefinition;
import org.drools.workbench.screens.scorecardxls.client.ScoreCardXLSEntryPoint;
import org.drools.workbench.screens.scorecardxls.client.editor.ScoreCardXLSEditorPresenter;
import org.drools.workbench.screens.scorecardxls.client.editor.ScoreCardXLSEditorPresenterActivity;
import org.drools.workbench.screens.scorecardxls.client.editor.ScoreCardXLSEditorViewImpl;
import org.drools.workbench.screens.scorecardxls.client.handlers.NewScoreCardXLSHandler;
import org.drools.workbench.screens.scorecardxls.client.type.ScoreCardXLSResourceType;
import org.drools.workbench.screens.scorecardxls.type.ScoreCardXLSResourceTypeDefinition;
import org.drools.workbench.screens.testscenario.client.FixtureLayout;
import org.drools.workbench.screens.testscenario.client.ScenarioEditorPresenter;
import org.drools.workbench.screens.testscenario.client.ScenarioEditorPresenterActivity;
import org.drools.workbench.screens.testscenario.client.ScenarioEditorViewImpl;
import org.drools.workbench.screens.testscenario.client.ScenarioWidgetComponentCreator;
import org.drools.workbench.screens.testscenario.client.TestScenarioEditorEntryPoint;
import org.drools.workbench.screens.testscenario.client.handlers.NewTestScenarioHandler;
import org.drools.workbench.screens.testscenario.client.page.audit.AuditPage;
import org.drools.workbench.screens.testscenario.client.page.audit.AuditPageViewImpl;
import org.drools.workbench.screens.testscenario.client.page.audit.AuditTable;
import org.drools.workbench.screens.testscenario.client.page.audit.AuditTableItem;
import org.drools.workbench.screens.testscenario.client.page.settings.ConfigWidget;
import org.drools.workbench.screens.testscenario.client.page.settings.ExecutionWidget;
import org.drools.workbench.screens.testscenario.client.page.settings.ScenarioKSessionSelector;
import org.drools.workbench.screens.testscenario.client.page.settings.SettingsPage;
import org.drools.workbench.screens.testscenario.client.page.settings.SettingsPageViewImpl;
import org.drools.workbench.screens.testscenario.client.type.TestScenarioResourceType;
import org.drools.workbench.screens.testscenario.type.TestScenarioResourceTypeDefinition;
import org.drools.workbench.screens.workitems.client.WorkItemsEditorEntryPoint;
import org.drools.workbench.screens.workitems.client.editor.WorkItemsEditorPresenter;
import org.drools.workbench.screens.workitems.client.editor.WorkItemsEditorPresenterActivity;
import org.drools.workbench.screens.workitems.client.editor.WorkItemsEditorViewImpl;
import org.drools.workbench.screens.workitems.client.handlers.NewWorkItemHandler;
import org.drools.workbench.screens.workitems.client.type.WorkItemsResourceType;
import org.drools.workbench.screens.workitems.client.widget.WorkItemDefinitionElementsBrowser;
import org.drools.workbench.screens.workitems.client.widget.WorkItemMetaDataLoader;
import org.drools.workbench.screens.workitems.type.WorkItemsTypeDefinition;
import org.ext.uberfire.social.activities.client.SocialEntryPoint;
import org.ext.uberfire.social.activities.client.user.SocialUserImageProviderImpl;
import org.ext.uberfire.social.activities.client.widgets.relations.SocialRelationsWidget;
import org.ext.uberfire.social.activities.client.widgets.userbox.UserBoxView;
import org.guvnor.common.services.project.categories.Decision;
import org.guvnor.common.services.project.categories.Form;
import org.guvnor.common.services.project.categories.Model;
import org.guvnor.common.services.project.categories.Optimization;
import org.guvnor.common.services.project.categories.Process;
import org.guvnor.common.services.project.client.GAVEditor;
import org.guvnor.common.services.project.client.GAVEditorViewImpl;
import org.guvnor.common.services.project.client.POMEditorPanel;
import org.guvnor.common.services.project.client.POMEditorPanelViewImpl;
import org.guvnor.common.services.project.client.ProjectEntryPoint;
import org.guvnor.common.services.project.client.context.WorkspaceProjectContext;
import org.guvnor.common.services.project.client.preferences.ProjectScopedResolutionStrategySupplier;
import org.guvnor.common.services.project.client.repositories.ConflictingRepositoriesPopup;
import org.guvnor.common.services.project.client.repositories.ConflictingRepositoriesPopupViewImpl;
import org.guvnor.common.services.project.client.security.ProjectController;
import org.guvnor.common.services.project.client.type.POMResourceType;
import org.guvnor.common.services.project.editor.type.POMResourceTypeDefinition;
import org.guvnor.common.services.project.preferences.GAVPreferencesBeanGeneratedImpl;
import org.guvnor.common.services.project.preferences.GeneralPreferencesBeanGeneratedImpl;
import org.guvnor.common.services.workingset.client.WorkingSetManager;
import org.guvnor.m2repo.client.M2RepoEditorEntryPoint;
import org.guvnor.m2repo.client.M2RepoEditorPresenter;
import org.guvnor.m2repo.client.M2RepoEditorPresenterActivity;
import org.guvnor.m2repo.client.editor.MavenRepositoryPagedJarTable;
import org.guvnor.m2repo.client.upload.UploadFormPresenter;
import org.guvnor.m2repo.client.upload.UploadFormViewImpl;
import org.guvnor.m2repo.client.widgets.ArtifactListPresenterImpl;
import org.guvnor.m2repo.client.widgets.ArtifactListViewImpl;
import org.guvnor.m2repo.preferences.ArtifactRepositoryPreferenceBeanGeneratedImpl;
import org.guvnor.messageconsole.client.console.AlertsEntryPoint;
import org.guvnor.messageconsole.client.console.MessageConsoleScreen;
import org.guvnor.messageconsole.client.console.MessageConsoleScreenActivity;
import org.guvnor.messageconsole.client.console.MessageConsoleService;
import org.guvnor.messageconsole.client.console.MessageConsoleViewImpl;
import org.guvnor.messageconsole.client.console.widget.button.AlertsButtonMenuItemBuilder;
import org.guvnor.messageconsole.client.console.widget.button.ViewHideAlertsButtonPresenter;
import org.guvnor.messageconsole.client.console.widget.button.ViewHideAlertsButtonView;
import org.guvnor.structure.client.StructureEntryPoint;
import org.guvnor.structure.client.editors.context.GuvnorStructureContext;
import org.guvnor.structure.client.editors.fileexplorer.FileExplorerPresenter;
import org.guvnor.structure.client.editors.fileexplorer.FileExplorerPresenterActivity;
import org.guvnor.structure.client.editors.fileexplorer.FileExplorerViewImpl;
import org.guvnor.structure.client.editors.repository.RepositoryPreferences;
import org.guvnor.structure.client.editors.repository.clone.CloneRepositoryPresenter;
import org.guvnor.structure.client.editors.repository.clone.CloneRepositoryViewImpl;
import org.guvnor.structure.client.editors.repository.edit.RepositoryEditorPresenter;
import org.guvnor.structure.client.editors.repository.edit.RepositoryEditorPresenterActivity;
import org.guvnor.structure.client.editors.repository.edit.RepositoryEditorView;
import org.guvnor.structure.client.editors.repository.list.RepositoriesPresenter;
import org.guvnor.structure.client.editors.repository.list.RepositoriesPresenterActivity;
import org.guvnor.structure.client.editors.repository.list.RepositoriesViewImpl;
import org.guvnor.structure.client.editors.repository.list.RepositoryItemPresenter;
import org.guvnor.structure.client.editors.repository.list.RepositoryItemViewImpl;
import org.guvnor.structure.client.security.OrganizationalUnitController;
import org.guvnor.structure.client.security.OrganizationalUnitTreeProvider;
import org.guvnor.structure.client.security.RepositoryController;
import org.guvnor.structure.client.security.RepositoryTreeProvider;
import org.gwtbootstrap3.client.ui.CheckBox;
import org.gwtbootstrap3.client.ui.Container;
import org.gwtbootstrap3.client.ui.DropDownMenu;
import org.gwtbootstrap3.client.ui.FieldSet;
import org.gwtbootstrap3.client.ui.HelpBlock;
import org.gwtbootstrap3.client.ui.Icon;
import org.gwtbootstrap3.client.ui.LinkedGroup;
import org.gwtbootstrap3.client.ui.ListBox;
import org.gwtbootstrap3.client.ui.ListGroup;
import org.gwtbootstrap3.client.ui.TextBox;
import org.gwtbootstrap3.client.ui.html.Paragraph;
import org.gwtbootstrap3.extras.datetimepicker.client.ui.DateTimePicker;
import org.gwtbootstrap3.extras.toggleswitch.client.ui.ToggleSwitch;
import org.jboss.errai.bus.client.api.ClientMessageBus;
import org.jboss.errai.bus.client.api.messaging.RequestDispatcher;
import org.jboss.errai.common.client.api.BatchCaller;
import org.jboss.errai.common.client.api.Caller;
import org.jboss.errai.common.client.dom.Anchor;
import org.jboss.errai.common.client.dom.CheckboxInput;
import org.jboss.errai.common.client.dom.Div;
import org.jboss.errai.common.client.dom.Document;
import org.jboss.errai.common.client.dom.Heading;
import org.jboss.errai.common.client.dom.Image;
import org.jboss.errai.common.client.dom.Input;
import org.jboss.errai.common.client.dom.Label;
import org.jboss.errai.common.client.dom.ListItem;
import org.jboss.errai.common.client.dom.NumberInput;
import org.jboss.errai.common.client.dom.OrderedList;
import org.jboss.errai.common.client.dom.RadioInput;
import org.jboss.errai.common.client.dom.Span;
import org.jboss.errai.common.client.dom.TextArea;
import org.jboss.errai.common.client.dom.TextInput;
import org.jboss.errai.common.client.dom.UnorderedList;
import org.jboss.errai.common.client.dom.elemental2.Elemental2DomUtil;
import org.jboss.errai.databinding.client.DataBinderProvider;
import org.jboss.errai.databinding.client.DataBindingModuleBootstrapper;
import org.jboss.errai.databinding.client.ListComponentProvider;
import org.jboss.errai.databinding.client.api.DataBinder;
import org.jboss.errai.databinding.client.components.ListComponent;
import org.jboss.errai.enterprise.client.cdi.CDIEventTypeLookup;
import org.jboss.errai.enterprise.client.cdi.EventProvider;
import org.jboss.errai.enterprise.client.cdi.InstanceProvider;
import org.jboss.errai.enterprise.client.cdi.JsTypeEventObserver;
import org.jboss.errai.enterprise.client.cdi.WindowEventObservers;
import org.jboss.errai.enterprise.client.cdi.api.CDI;
import org.jboss.errai.ioc.client.api.Disposer;
import org.jboss.errai.ioc.client.api.InitBallot;
import org.jboss.errai.ioc.client.api.ManagedInstance;
import org.jboss.errai.ioc.client.api.builtin.CallerProvider;
import org.jboss.errai.ioc.client.api.builtin.DisposerProvider;
import org.jboss.errai.ioc.client.api.builtin.IOCBeanManagerProvider;
import org.jboss.errai.ioc.client.api.builtin.InitBallotProvider;
import org.jboss.errai.ioc.client.api.builtin.ManagedInstanceProvider;
import org.jboss.errai.ioc.client.api.builtin.RootPanelProvider;
import org.jboss.errai.ioc.client.container.ApplicationScopedContext;
import org.jboss.errai.ioc.client.container.Context;
import org.jboss.errai.ioc.client.container.ContextManager;
import org.jboss.errai.ioc.client.container.ContextManagerImpl;
import org.jboss.errai.ioc.client.container.DependentScopeContext;
import org.jboss.errai.ioc.client.container.Factory;
import org.jboss.errai.ioc.client.container.JsTypeProvider;
import org.jboss.errai.ioc.client.container.SyncBeanManager;
import org.jboss.errai.ioc.client.lifecycle.impl.AccessImpl;
import org.jboss.errai.ioc.client.lifecycle.impl.CreationImpl;
import org.jboss.errai.ioc.client.lifecycle.impl.DestructionImpl;
import org.jboss.errai.ioc.client.lifecycle.impl.LifecycleListenerRegistrarImpl;
import org.jboss.errai.ioc.client.lifecycle.impl.StateChangeImpl;
import org.jboss.errai.ioc.support.bus.client.BatchCallerProvider;
import org.jboss.errai.ioc.support.bus.client.MessageBusProvider;
import org.jboss.errai.ioc.support.bus.client.RequestDispatcherProvider;
import org.jboss.errai.ioc.support.bus.client.Sender;
import org.jboss.errai.ioc.support.bus.client.SenderProvider;
import org.jboss.errai.security.client.local.callback.DefaultBusSecurityErrorCallback;
import org.jboss.errai.security.client.local.callback.DefaultRestSecurityErrorCallback;
import org.jboss.errai.security.client.local.context.BasicUserCacheImpl;
import org.jboss.errai.security.client.local.context.SecurityContextImpl;
import org.jboss.errai.security.client.local.context.SecurityContextImpl.SecurityRolesConstraintPage;
import org.jboss.errai.security.client.local.handler.DefaultSecurityExceptionHandler;
import org.jboss.errai.security.client.local.interceptors.AuthenticationServiceInterceptor;
import org.jboss.errai.security.client.local.interceptors.ClientSecurityRoleInterceptor;
import org.jboss.errai.security.client.local.nav.SecurityContextHoldingSingleton;
import org.jboss.errai.security.client.local.roles.ClientRequiredRolesExtractorImpl;
import org.jboss.errai.security.client.local.storage.StorageHandlerProvider;
import org.jboss.errai.security.client.local.storage.UserStorageHandler;
import org.jboss.errai.security.client.local.style.RoleStyleBindingProvider;
import org.jboss.errai.security.shared.api.identity.User;
import org.jboss.errai.ui.client.local.producer.Elemental2HTMLElementProvider;
import org.jboss.errai.ui.client.local.producer.HTMLElementProvider;
import org.jboss.errai.ui.client.local.spi.TranslationService;
import org.jboss.errai.ui.client.local.spi.TranslationServiceProvider;
import org.jboss.errai.ui.client.widget.ListWidget;
import org.jboss.errai.ui.client.widget.ListWidgetProvider;
import org.jboss.errai.ui.client.widget.LocaleListBox;
import org.jboss.errai.ui.client.widget.LocaleSelector;
import org.jboss.errai.ui.nav.client.local.HistoryTokenFactory;
import org.jboss.errai.ui.nav.client.local.Navigation;
import org.jboss.errai.ui.nav.client.local.NavigationPanel;
import org.jboss.errai.ui.nav.client.local.NavigationPanelProvider;
import org.jboss.errai.ui.nav.client.local.PageTransitionProvider;
import org.jboss.errai.ui.nav.client.local.TransitionAnchor;
import org.jboss.errai.ui.nav.client.local.TransitionAnchorFactory;
import org.jboss.errai.ui.nav.client.local.TransitionAnchorFactoryProvider;
import org.jboss.errai.ui.nav.client.local.TransitionAnchorProvider;
import org.jboss.errai.ui.nav.client.local.TransitionTo;
import org.jboss.errai.ui.nav.client.local.TransitionToRole;
import org.jboss.errai.ui.nav.client.local.TransitionToRoleProvider;
import org.jboss.errai.ui.nav.client.local.URLPatternMatcher;
import org.jboss.errai.ui.nav.client.local.URLPatternMatcherProvider;
import org.jboss.errai.ui.nav.client.local.spi.NavigationGraph;
import org.jboss.errai.ui.shared.ServerTemplateProvider;
import org.jboss.errai.validation.client.ValidatorProvider;
import org.kie.workbench.common.screens.contributors.client.perspectives.ContributorsPerspective;
import org.kie.workbench.common.screens.contributors.client.perspectives.ContributorsPerspectiveActivity;
import org.kie.workbench.common.screens.contributors.client.screens.ContributorsScreen;
import org.kie.workbench.common.screens.contributors.client.screens.ContributorsScreenActivity;
import org.kie.workbench.common.screens.contributors.client.screens.ContributorsViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.DataModelerEntryPoint;
import org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenter;
import org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenPresenterActivity;
import org.kie.workbench.common.screens.datamodeller.client.DataModelerScreenViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.command.DataModelChangeNotifier;
import org.kie.workbench.common.screens.datamodeller.client.command.DataModelCommandBuilder;
import org.kie.workbench.common.screens.datamodeller.client.context.DataModelerWorkbenchContext;
import org.kie.workbench.common.screens.datamodeller.client.handlers.DomainHandlerRegistry;
import org.kie.workbench.common.screens.datamodeller.client.handlers.NewJavaFileTextHandler;
import org.kie.workbench.common.screens.datamodeller.client.handlers.advanceddomain.AdvancedDomainHandler;
import org.kie.workbench.common.screens.datamodeller.client.handlers.droolsdomain.DroolsDomainHandler;
import org.kie.workbench.common.screens.datamodeller.client.handlers.jpadomain.JPADomainHandler;
import org.kie.workbench.common.screens.datamodeller.client.handlers.jpadomain.command.JPACommandBuilder;
import org.kie.workbench.common.screens.datamodeller.client.handlers.maindomain.MainDomainHandler;
import org.kie.workbench.common.screens.datamodeller.client.pdescriptor.PersistenceUnitPropertyGrid;
import org.kie.workbench.common.screens.datamodeller.client.pdescriptor.PersistenceUnitPropertyGridViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.pdescriptor.ProjectClassList;
import org.kie.workbench.common.screens.datamodeller.client.pdescriptor.ProjectClassListViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.validation.PersistenceDescriptorValidationMessageTranslator;
import org.kie.workbench.common.screens.datamodeller.client.validation.ValidatorService;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.AdvancedDataObjectEditor;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.AdvancedDataObjectEditorViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.AdvancedDataObjectFieldEditor;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.AdvancedDataObjectFieldEditorViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.AdvancedDomainEditor;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.AdvancedDomainScreen;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.AdvancedDomainScreenActivity;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.AdvancedDomainScreenViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.annotationlisteditor.AdvancedAnnotationListEditor;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.annotationlisteditor.AdvancedAnnotationListEditorViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.annotationlisteditor.item.AnnotationListItem;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.annotationlisteditor.item.AnnotationListItemViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.annotationlisteditor.item.AnnotationValuePairListItem;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.annotationlisteditor.item.AnnotationValuePairListItemViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.annotationwizard.CreateAnnotationWizard;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.annotationwizard.SearchAnnotationPage;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.annotationwizard.SearchAnnotationPageViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.annotationwizard.ValuePairEditorPage;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.annotationwizard.ValuePairEditorPageViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.valuepaireditor.ValuePairEditorPopup;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.valuepaireditor.ValuePairEditorPopupViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.valuepaireditor.ValuePairEditorProvider;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.valuepaireditor.generic.GenericValuePairEditor;
import org.kie.workbench.common.screens.datamodeller.client.widgets.advanceddomain.valuepaireditor.generic.GenericValuePairEditorViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.datasourceselector.DataSourceSelector;
import org.kie.workbench.common.screens.datamodeller.client.widgets.datasourceselector.DataSourceSelectorProducer;
import org.kie.workbench.common.screens.datamodeller.client.widgets.datasourceselector.DefaultDataSourceSelector;
import org.kie.workbench.common.screens.datamodeller.client.widgets.droolsdomain.DroolsDataObjectEditor;
import org.kie.workbench.common.screens.datamodeller.client.widgets.droolsdomain.DroolsDataObjectEditorViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.droolsdomain.DroolsDataObjectFieldEditor;
import org.kie.workbench.common.screens.datamodeller.client.widgets.droolsdomain.DroolsDataObjectFieldEditorViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.droolsdomain.DroolsDomainEditor;
import org.kie.workbench.common.screens.datamodeller.client.widgets.droolsdomain.DroolsDomainScreen;
import org.kie.workbench.common.screens.datamodeller.client.widgets.droolsdomain.DroolsDomainScreenActivity;
import org.kie.workbench.common.screens.datamodeller.client.widgets.droolsdomain.DroolsDomainScreenViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.editor.DataObjectBrowser;
import org.kie.workbench.common.screens.datamodeller.client.widgets.editor.DataObjectBrowserViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.editor.NewFieldPopup;
import org.kie.workbench.common.screens.datamodeller.client.widgets.editor.NewFieldPopupViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.jpadomain.JPADataObjectEditor;
import org.kie.workbench.common.screens.datamodeller.client.widgets.jpadomain.JPADataObjectEditorViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.jpadomain.JPADataObjectFieldEditor;
import org.kie.workbench.common.screens.datamodeller.client.widgets.jpadomain.JPADataObjectFieldEditorViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.jpadomain.JPADomainEditor;
import org.kie.workbench.common.screens.datamodeller.client.widgets.jpadomain.JPADomainScreen;
import org.kie.workbench.common.screens.datamodeller.client.widgets.jpadomain.JPADomainScreenActivity;
import org.kie.workbench.common.screens.datamodeller.client.widgets.jpadomain.JPADomainScreenViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.jpadomain.options.JPANewResourceOptions;
import org.kie.workbench.common.screens.datamodeller.client.widgets.jpadomain.properties.IdGeneratorField;
import org.kie.workbench.common.screens.datamodeller.client.widgets.jpadomain.properties.RelationshipField;
import org.kie.workbench.common.screens.datamodeller.client.widgets.jpadomain.properties.SequenceGeneratorField;
import org.kie.workbench.common.screens.datamodeller.client.widgets.maindomain.MainDataObjectEditor;
import org.kie.workbench.common.screens.datamodeller.client.widgets.maindomain.MainDataObjectEditorViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.maindomain.MainDataObjectFieldEditor;
import org.kie.workbench.common.screens.datamodeller.client.widgets.maindomain.MainDataObjectFieldEditorViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.maindomain.MainDomainEditor;
import org.kie.workbench.common.screens.datamodeller.client.widgets.packageselector.NewPackagePopup;
import org.kie.workbench.common.screens.datamodeller.client.widgets.packageselector.NewPackagePopupViewImpl;
import org.kie.workbench.common.screens.datamodeller.client.widgets.packageselector.PackageSelector;
import org.kie.workbench.common.screens.datamodeller.client.widgets.packageselector.PackageSelectorViewImpl;
import org.kie.workbench.common.screens.defaulteditor.client.editor.GuvnorDefaultEditorPresenter;
import org.kie.workbench.common.screens.defaulteditor.client.editor.GuvnorDefaultEditorPresenterActivity;
import org.kie.workbench.common.screens.defaulteditor.client.editor.GuvnorDefaultEditorViewImpl;
import org.kie.workbench.common.screens.defaulteditor.client.editor.KieMetaDataEditorPresenter;
import org.kie.workbench.common.screens.defaulteditor.client.editor.KieMetaDataEditorPresenterActivity;
import org.kie.workbench.common.screens.defaulteditor.client.editor.KieTextEditorScreenPresenter;
import org.kie.workbench.common.screens.defaulteditor.client.editor.KieTextEditorScreenPresenterActivity;
import org.kie.workbench.common.screens.defaulteditor.client.editor.KieTextEditorViewImpl;
import org.kie.workbench.common.screens.defaulteditor.client.editor.NewFileUploader;
import org.kie.workbench.common.screens.defaulteditor.client.editor.PackageNameWhiteListResourceType;
import org.kie.workbench.common.screens.defaulteditor.client.editor.XmlResourceType;
import org.kie.workbench.common.screens.defaulteditor.service.PackageNameWhiteListResourceTypeDefinition;
import org.kie.workbench.common.screens.defaulteditor.service.XmlResourceTypeDefinition;
import org.kie.workbench.common.screens.examples.client.ExamplesScreenEntryPoint;
import org.kie.workbench.common.screens.examples.client.wizard.ExamplesWizard;
import org.kie.workbench.common.screens.examples.client.wizard.pages.project.FetchRepositoryViewImpl;
import org.kie.workbench.common.screens.examples.client.wizard.pages.project.NoRepositoryURLViewImpl;
import org.kie.workbench.common.screens.examples.client.wizard.pages.project.ProjectItemViewImpl;
import org.kie.workbench.common.screens.examples.client.wizard.pages.project.ProjectPage;
import org.kie.workbench.common.screens.examples.client.wizard.pages.project.ProjectPageViewImpl;
import org.kie.workbench.common.screens.examples.client.wizard.pages.project.TagItemViewImpl;
import org.kie.workbench.common.screens.examples.client.wizard.pages.sourcerepository.SourceRepositoryPage;
import org.kie.workbench.common.screens.examples.client.wizard.pages.sourcerepository.SourceRepositoryPageViewImpl;
import org.kie.workbench.common.screens.explorer.client.ExplorerEntryPoint;
import org.kie.workbench.common.screens.explorer.client.ExplorerMenu;
import org.kie.workbench.common.screens.explorer.client.ExplorerMenuViewImpl;
import org.kie.workbench.common.screens.explorer.client.ExplorerPresenter;
import org.kie.workbench.common.screens.explorer.client.ExplorerPresenterActivity;
import org.kie.workbench.common.screens.explorer.client.ExplorerViewImpl;
import org.kie.workbench.common.screens.explorer.client.ProjectScreenMenuItem;
import org.kie.workbench.common.screens.explorer.client.utils.Classifier;
import org.kie.workbench.common.screens.explorer.client.widgets.ActiveContextItems;
import org.kie.workbench.common.screens.explorer.client.widgets.ActiveContextManager;
import org.kie.workbench.common.screens.explorer.client.widgets.ActiveContextOptions;
import org.kie.workbench.common.screens.explorer.client.widgets.business.BusinessViewPresenter;
import org.kie.workbench.common.screens.explorer.client.widgets.business.BusinessViewWidget;
import org.kie.workbench.common.screens.explorer.client.widgets.navigator.BreadcrumbNavigator;
import org.kie.workbench.common.screens.explorer.client.widgets.navigator.TreeNavigator;
import org.kie.workbench.common.screens.explorer.client.widgets.tagSelector.TagSelector;
import org.kie.workbench.common.screens.explorer.client.widgets.tagSelector.TagSelectorViewImpl;
import org.kie.workbench.common.screens.explorer.client.widgets.technical.TechnicalViewPresenter;
import org.kie.workbench.common.screens.explorer.client.widgets.technical.TechnicalViewWidget;
import org.kie.workbench.common.screens.home.client.HomeEntryPoint;
import org.kie.workbench.common.screens.home.client.perspectives.HomePerspective;
import org.kie.workbench.common.screens.home.client.perspectives.HomePerspectiveActivity;
import org.kie.workbench.common.screens.home.client.widgets.home.HomePresenter;
import org.kie.workbench.common.screens.home.client.widgets.home.HomePresenterActivity;
import org.kie.workbench.common.screens.home.client.widgets.home.HomeView;
import org.kie.workbench.common.screens.home.client.widgets.shortcut.ShortcutPresenter;
import org.kie.workbench.common.screens.home.client.widgets.shortcut.ShortcutView;
import org.kie.workbench.common.screens.home.client.widgets.shortcut.subheading.ShortcutSubHeadingLinkPresenter;
import org.kie.workbench.common.screens.home.client.widgets.shortcut.subheading.ShortcutSubHeadingLinkView;
import org.kie.workbench.common.screens.home.client.widgets.shortcut.subheading.ShortcutSubHeadingTextPresenter;
import org.kie.workbench.common.screens.home.client.widgets.shortcut.subheading.ShortcutSubHeadingTextView;
import org.kie.workbench.common.screens.home.client.widgets.shortcut.utils.ShortcutHelper;
import org.kie.workbench.common.screens.javaeditor.client.editor.JavaEditorPresenter;
import org.kie.workbench.common.screens.javaeditor.client.editor.JavaEditorPresenterActivity;
import org.kie.workbench.common.screens.javaeditor.client.editor.JavaSourceViewImpl;
import org.kie.workbench.common.screens.javaeditor.client.type.JavaResourceType;
import org.kie.workbench.common.screens.javaeditor.client.widget.EditJavaSourceWidget;
import org.kie.workbench.common.screens.javaeditor.client.widget.ViewJavaSourceWidget;
import org.kie.workbench.common.screens.javaeditor.type.JavaResourceTypeDefinition;
import org.kie.workbench.common.screens.library.api.preferences.LibraryInternalPreferencesBeanGeneratedImpl;
import org.kie.workbench.common.screens.library.api.preferences.LibraryOrganizationalUnitPreferencesBeanGeneratedImpl;
import org.kie.workbench.common.screens.library.api.preferences.LibraryPreferencesBeanGeneratedImpl;
import org.kie.workbench.common.screens.library.api.preferences.LibraryProjectPreferencesBeanGeneratedImpl;
import org.kie.workbench.common.screens.library.client.LibraryEntryPoint;
import org.kie.workbench.common.screens.library.client.perspective.LibraryPerspective;
import org.kie.workbench.common.screens.library.client.perspective.LibraryPerspectiveActivity;
import org.kie.workbench.common.screens.library.client.resources.i18n.LibraryConstants;
import org.kie.workbench.common.screens.library.client.screens.AssetList;
import org.kie.workbench.common.screens.library.client.screens.AssetListView;
import org.kie.workbench.common.screens.library.client.screens.EmptyLibraryScreen;
import org.kie.workbench.common.screens.library.client.screens.EmptyLibraryView;
import org.kie.workbench.common.screens.library.client.screens.EmptyState;
import org.kie.workbench.common.screens.library.client.screens.EmptyStateView;
import org.kie.workbench.common.screens.library.client.screens.LibraryScreen;
import org.kie.workbench.common.screens.library.client.screens.LibraryScreenActivity;
import org.kie.workbench.common.screens.library.client.screens.LibraryView;
import org.kie.workbench.common.screens.library.client.screens.OrgUnitsMetricsScreen;
import org.kie.workbench.common.screens.library.client.screens.OrgUnitsMetricsView;
import org.kie.workbench.common.screens.library.client.screens.PopulatedLibraryScreen;
import org.kie.workbench.common.screens.library.client.screens.PopulatedLibraryView;
import org.kie.workbench.common.screens.library.client.screens.assets.AssetQueryService;
import org.kie.workbench.common.screens.library.client.screens.assets.AssetsScreen;
import org.kie.workbench.common.screens.library.client.screens.assets.AssetsView;
import org.kie.workbench.common.screens.library.client.screens.assets.EmptyAssetsScreen;
import org.kie.workbench.common.screens.library.client.screens.assets.EmptyAssetsView;
import org.kie.workbench.common.screens.library.client.screens.assets.InvalidProjectScreen;
import org.kie.workbench.common.screens.library.client.screens.assets.InvalidProjectView;
import org.kie.workbench.common.screens.library.client.screens.assets.PopulatedAssetsScreen;
import org.kie.workbench.common.screens.library.client.screens.assets.PopulatedAssetsView;
import org.kie.workbench.common.screens.library.client.screens.assets.add.AddAssetScreen;
import org.kie.workbench.common.screens.library.client.screens.assets.add.AddAssetScreenActivity;
import org.kie.workbench.common.screens.library.client.screens.assets.add.AddAssetView;
import org.kie.workbench.common.screens.library.client.screens.importrepository.ExamplesImportPresenter;
import org.kie.workbench.common.screens.library.client.screens.importrepository.ExternalImportPresenter;
import org.kie.workbench.common.screens.library.client.screens.importrepository.ImportProjectsScreen;
import org.kie.workbench.common.screens.library.client.screens.importrepository.ImportProjectsScreenActivity;
import org.kie.workbench.common.screens.library.client.screens.importrepository.ImportProjectsView;
import org.kie.workbench.common.screens.library.client.screens.importrepository.ImportRepositoryPopUpPresenter;
import org.kie.workbench.common.screens.library.client.screens.importrepository.ImportRepositoryPopUpView;
import org.kie.workbench.common.screens.library.client.screens.organizationalunit.EmptyOrganizationalUnitsScreen;
import org.kie.workbench.common.screens.library.client.screens.organizationalunit.EmptyOrganizationalUnitsView;
import org.kie.workbench.common.screens.library.client.screens.organizationalunit.OrganizationalUnitsScreen;
import org.kie.workbench.common.screens.library.client.screens.organizationalunit.OrganizationalUnitsScreenActivity;
import org.kie.workbench.common.screens.library.client.screens.organizationalunit.OrganizationalUnitsView;
import org.kie.workbench.common.screens.library.client.screens.organizationalunit.contributors.edit.EditContributorsPopUpPresenter;
import org.kie.workbench.common.screens.library.client.screens.organizationalunit.contributors.edit.EditContributorsPopUpView;
import org.kie.workbench.common.screens.library.client.screens.organizationalunit.contributors.tab.ContributorsListItemPresenter;
import org.kie.workbench.common.screens.library.client.screens.organizationalunit.contributors.tab.ContributorsListItemView;
import org.kie.workbench.common.screens.library.client.screens.organizationalunit.contributors.tab.ContributorsListPresenter;
import org.kie.workbench.common.screens.library.client.screens.organizationalunit.contributors.tab.ContributorsListView;
import org.kie.workbench.common.screens.library.client.screens.organizationalunit.contributors.widget.ContributorsManagementListItemPresenter;
import org.kie.workbench.common.screens.library.client.screens.organizationalunit.contributors.widget.ContributorsManagementListItemView;
import org.kie.workbench.common.screens.library.client.screens.organizationalunit.contributors.widget.ContributorsManagementPresenter;
import org.kie.workbench.common.screens.library.client.screens.organizationalunit.contributors.widget.ContributorsManagementView;
import org.kie.workbench.common.screens.library.client.screens.organizationalunit.delete.DeleteOrganizationalUnitPopUpPresenter;
import org.kie.workbench.common.screens.library.client.screens.organizationalunit.delete.DeleteOrganizationalUnitPopUpView;
import org.kie.workbench.common.screens.library.client.screens.organizationalunit.popup.OrganizationalUnitPopUpPresenter;
import org.kie.workbench.common.screens.library.client.screens.organizationalunit.popup.OrganizationalUnitPopUpView;
import org.kie.workbench.common.screens.library.client.screens.project.AddProjectPopUpPresenter;
import org.kie.workbench.common.screens.library.client.screens.project.AddProjectPopUpView;
import org.kie.workbench.common.screens.library.client.screens.project.ProjectMetricsScreen;
import org.kie.workbench.common.screens.library.client.screens.project.ProjectMetricsView;
import org.kie.workbench.common.screens.library.client.screens.project.ProjectScreen;
import org.kie.workbench.common.screens.library.client.screens.project.ProjectScreenActivity;
import org.kie.workbench.common.screens.library.client.screens.project.ProjectView;
import org.kie.workbench.common.screens.library.client.screens.project.branch.AddBranchPopUpPresenter;
import org.kie.workbench.common.screens.library.client.screens.project.branch.AddBranchPopUpView;
import org.kie.workbench.common.screens.library.client.screens.project.branch.AddBranchPopUpView.BranchOptionView;
import org.kie.workbench.common.screens.library.client.screens.project.branch.delete.DeleteBranchPopUpScreen;
import org.kie.workbench.common.screens.library.client.screens.project.branch.delete.DeleteBranchPopUpView;
import org.kie.workbench.common.screens.library.client.screens.project.close.CloseUnsavedProjectAssetsPopUpListItemPresenter;
import org.kie.workbench.common.screens.library.client.screens.project.close.CloseUnsavedProjectAssetsPopUpListItemView;
import org.kie.workbench.common.screens.library.client.screens.project.close.CloseUnsavedProjectAssetsPopUpPresenter;
import org.kie.workbench.common.screens.library.client.screens.project.close.CloseUnsavedProjectAssetsPopUpView;
import org.kie.workbench.common.screens.library.client.screens.project.delete.DeleteProjectPopUpScreen;
import org.kie.workbench.common.screens.library.client.screens.project.delete.DeleteProjectPopUpView;
import org.kie.workbench.common.screens.library.client.screens.project.rename.RenameProjectPopUpScreen;
import org.kie.workbench.common.screens.library.client.screens.project.rename.RenameProjectPopUpView;
import org.kie.workbench.common.screens.library.client.screens.samples.ImportExamplesProjectsScreen;
import org.kie.workbench.common.screens.library.client.screens.samples.ImportExamplesProjectsScreenActivity;
import org.kie.workbench.common.screens.library.client.settings.SettingsPresenter;
import org.kie.workbench.common.screens.library.client.settings.SettingsSectionsProvider;
import org.kie.workbench.common.screens.library.client.settings.SettingsView;
import org.kie.workbench.common.screens.library.client.settings.generalsettings.GitUrlsPresenter;
import org.kie.workbench.common.screens.library.client.settings.generalsettings.GitUrlsView;
import org.kie.workbench.common.screens.library.client.settings.sections.DefaultSettingsSections;
import org.kie.workbench.common.screens.library.client.settings.sections.SettingsSections;
import org.kie.workbench.common.screens.library.client.settings.sections.dependencies.DependenciesItemPresenter;
import org.kie.workbench.common.screens.library.client.settings.sections.dependencies.DependenciesItemView;
import org.kie.workbench.common.screens.library.client.settings.sections.dependencies.DependenciesPresenter;
import org.kie.workbench.common.screens.library.client.settings.sections.dependencies.DependenciesView;
import org.kie.workbench.common.screens.library.client.settings.sections.externaldataobjects.ExternalDataObjectsItemPresenter;
import org.kie.workbench.common.screens.library.client.settings.sections.externaldataobjects.ExternalDataObjectsItemView;
import org.kie.workbench.common.screens.library.client.settings.sections.externaldataobjects.ExternalDataObjectsPresenter;
import org.kie.workbench.common.screens.library.client.settings.sections.externaldataobjects.ExternalDataObjectsPresenter.ImportsListPresenter;
import org.kie.workbench.common.screens.library.client.settings.sections.externaldataobjects.ExternalDataObjectsView;
import org.kie.workbench.common.screens.library.client.settings.sections.generalsettings.GeneralSettingsPresenter;
import org.kie.workbench.common.screens.library.client.settings.sections.generalsettings.GeneralSettingsView;
import org.kie.workbench.common.screens.library.client.settings.sections.knowledgebases.KnowledgeBasesPresenter;
import org.kie.workbench.common.screens.library.client.settings.sections.knowledgebases.KnowledgeBasesPresenter.KnowledgeBaseListPresenter;
import org.kie.workbench.common.screens.library.client.settings.sections.knowledgebases.KnowledgeBasesView;
import org.kie.workbench.common.screens.library.client.settings.sections.knowledgebases.item.KnowledgeBaseItemPresenter;
import org.kie.workbench.common.screens.library.client.settings.sections.knowledgebases.item.KnowledgeBaseItemPresenter.IncludedKnowledgeBasesListPresenter;
import org.kie.workbench.common.screens.library.client.settings.sections.knowledgebases.item.KnowledgeBaseItemPresenter.PackageListPresenter;
import org.kie.workbench.common.screens.library.client.settings.sections.knowledgebases.item.KnowledgeBaseItemView;
import org.kie.workbench.common.screens.library.client.settings.sections.knowledgebases.item.includedknowledgebases.IncludedKnowledgeBaseItemPresenter;
import org.kie.workbench.common.screens.library.client.settings.sections.knowledgebases.item.includedknowledgebases.IncludedKnowledgeBaseItemView;
import org.kie.workbench.common.screens.library.client.settings.sections.knowledgebases.item.knowledgesessions.KnowledgeSessionListItemPresenter;
import org.kie.workbench.common.screens.library.client.settings.sections.knowledgebases.item.knowledgesessions.KnowledgeSessionListItemPresenter.ListenersListPresenter;
import org.kie.workbench.common.screens.library.client.settings.sections.knowledgebases.item.knowledgesessions.KnowledgeSessionListItemPresenter.WorkItemHandlersListPresenter;
import org.kie.workbench.common.screens.library.client.settings.sections.knowledgebases.item.knowledgesessions.KnowledgeSessionListItemView;
import org.kie.workbench.common.screens.library.client.settings.sections.knowledgebases.item.knowledgesessions.KnowledgeSessionsModal;
import org.kie.workbench.common.screens.library.client.settings.sections.knowledgebases.item.knowledgesessions.KnowledgeSessionsModal.KnowledgeBasesListPresenter;
import org.kie.workbench.common.screens.library.client.settings.sections.knowledgebases.item.knowledgesessions.KnowledgeSessionsModalView;
import org.kie.workbench.common.screens.library.client.settings.sections.knowledgebases.item.knowledgesessions.listener.ListenerListItemPresenter;
import org.kie.workbench.common.screens.library.client.settings.sections.knowledgebases.item.knowledgesessions.listener.ListenerListItemView;
import org.kie.workbench.common.screens.library.client.settings.sections.knowledgebases.item.knowledgesessions.workitemhandler.WorkItemHandlerListItemPresenter;
import org.kie.workbench.common.screens.library.client.settings.sections.knowledgebases.item.knowledgesessions.workitemhandler.WorkItemHandlerListItemView;
import org.kie.workbench.common.screens.library.client.settings.sections.knowledgebases.item.packages.PackageItemPresenter;
import org.kie.workbench.common.screens.library.client.settings.sections.knowledgebases.item.packages.PackageItemView;
import org.kie.workbench.common.screens.library.client.settings.sections.persistence.PersistencePresenter;
import org.kie.workbench.common.screens.library.client.settings.sections.persistence.PersistencePresenter.PersistableDataObjectsListPresenter;
import org.kie.workbench.common.screens.library.client.settings.sections.persistence.PersistencePresenter.PropertiesListPresenter;
import org.kie.workbench.common.screens.library.client.settings.sections.persistence.PersistenceView;
import org.kie.workbench.common.screens.library.client.settings.sections.persistence.persistabledataobjects.PersistableDataObjectsItemPresenter;
import org.kie.workbench.common.screens.library.client.settings.sections.persistence.persistabledataobjects.PersistableDataObjectsItemView;
import org.kie.workbench.common.screens.library.client.settings.sections.persistence.properties.PropertiesItemPresenter;
import org.kie.workbench.common.screens.library.client.settings.sections.persistence.properties.PropertiesItemView;
import org.kie.workbench.common.screens.library.client.settings.sections.validation.ValidationItemPresenter;
import org.kie.workbench.common.screens.library.client.settings.sections.validation.ValidationItemView;
import org.kie.workbench.common.screens.library.client.settings.sections.validation.ValidationPresenter;
import org.kie.workbench.common.screens.library.client.settings.sections.validation.ValidationPresenter.ValidationListPresenter;
import org.kie.workbench.common.screens.library.client.settings.sections.validation.ValidationView;
import org.kie.workbench.common.screens.library.client.settings.util.dropdown.KieDropdownElement;
import org.kie.workbench.common.screens.library.client.settings.util.dropdown.KieDropdownElement.ItemElement;
import org.kie.workbench.common.screens.library.client.settings.util.dropdown.KieDropdownElement.ItemsListPresenter;
import org.kie.workbench.common.screens.library.client.settings.util.dropdown.KieDropdownElementView;
import org.kie.workbench.common.screens.library.client.settings.util.dropdown.KieDropdownElementView.Item;
import org.kie.workbench.common.screens.library.client.settings.util.modal.doublevalue.AddDoubleValueModal;
import org.kie.workbench.common.screens.library.client.settings.util.modal.doublevalue.AddDoubleValueModalView;
import org.kie.workbench.common.screens.library.client.settings.util.modal.single.AddSingleValueModal;
import org.kie.workbench.common.screens.library.client.settings.util.modal.single.AddSingleValueModalView;
import org.kie.workbench.common.screens.library.client.settings.util.sections.MenuItemView;
import org.kie.workbench.common.screens.library.client.settings.util.sections.MenuItemsListPresenter;
import org.kie.workbench.common.screens.library.client.settings.util.sections.SectionManager;
import org.kie.workbench.common.screens.library.client.settings.util.select.KieEnumSelectElement;
import org.kie.workbench.common.screens.library.client.util.CategoryUtils;
import org.kie.workbench.common.screens.library.client.util.LibraryPlaces;
import org.kie.workbench.common.screens.library.client.util.OrgUnitsMetricsFactory;
import org.kie.workbench.common.screens.library.client.util.PomEditor;
import org.kie.workbench.common.screens.library.client.util.PomEditorActivity;
import org.kie.workbench.common.screens.library.client.util.ProjectMetricsFactory;
import org.kie.workbench.common.screens.library.client.util.ResourceHandlerManager;
import org.kie.workbench.common.screens.library.client.util.ResourceUtils;
import org.kie.workbench.common.screens.library.client.util.TranslationUtils;
import org.kie.workbench.common.screens.library.client.util.breadcrumb.LibraryBreadcrumbs;
import org.kie.workbench.common.screens.library.client.util.breadcrumb.ProjectBranchBreadcrumb;
import org.kie.workbench.common.screens.library.client.util.breadcrumb.ProjectBranchBreadcrumbView;
import org.kie.workbench.common.screens.library.client.widgets.common.MenuResourceHandlerWidget;
import org.kie.workbench.common.screens.library.client.widgets.common.TileView;
import org.kie.workbench.common.screens.library.client.widgets.common.TileWidget;
import org.kie.workbench.common.screens.library.client.widgets.common.dropdown.DropdownHeaderWidget;
import org.kie.workbench.common.screens.library.client.widgets.common.dropdown.DropdownSeparatorWidget;
import org.kie.workbench.common.screens.library.client.widgets.example.ExampleProjectView;
import org.kie.workbench.common.screens.library.client.widgets.example.ExampleProjectWidget;
import org.kie.workbench.common.screens.library.client.widgets.example.errors.ExampleProjectErrorPresenter;
import org.kie.workbench.common.screens.library.client.widgets.example.errors.ExampleProjectErrorView;
import org.kie.workbench.common.screens.library.client.widgets.example.errors.ExampleProjectOkPresenter;
import org.kie.workbench.common.screens.library.client.widgets.example.errors.ExampleProjectOkView;
import org.kie.workbench.common.screens.library.client.widgets.library.AddProjectButtonPresenter;
import org.kie.workbench.common.screens.library.client.widgets.library.AddProjectButtonView;
import org.kie.workbench.common.screens.library.client.widgets.project.AssetItemWidget;
import org.kie.workbench.common.screens.library.client.widgets.project.AssetsActionsView;
import org.kie.workbench.common.screens.library.client.widgets.project.AssetsActionsWidget;
import org.kie.workbench.common.screens.library.client.widgets.project.NewAssetHandlerCardView;
import org.kie.workbench.common.screens.library.client.widgets.project.NewAssetHandlerCardWidget;
import org.kie.workbench.common.screens.library.client.widgets.project.NewAssetHandlerWidget;
import org.kie.workbench.common.screens.projecteditor.client.ProjectEditorEntryPoint;
import org.kie.workbench.common.screens.projecteditor.client.build.BuildExecutor;
import org.kie.workbench.common.screens.projecteditor.client.editor.DeploymentScreenPopupViewImpl;
import org.kie.workbench.common.screens.projecteditor.client.forms.dependencies.DependencyListWidget;
import org.kie.workbench.common.screens.projecteditor.client.forms.dependencies.DependencyLoader;
import org.kie.workbench.common.screens.projecteditor.client.forms.dependencies.DependencyLoaderViewImpl;
import org.kie.workbench.common.screens.projecteditor.client.forms.dependencies.DependencySelectorPopup;
import org.kie.workbench.common.screens.projecteditor.client.forms.dependencies.DependencySelectorPopupViewImpl;
import org.kie.workbench.common.screens.projecteditor.client.forms.dependencies.EnhancedDependenciesManager;
import org.kie.workbench.common.screens.projecteditor.client.forms.dependencies.NewDependencyPopup;
import org.kie.workbench.common.screens.projecteditor.client.forms.dependencies.NewDependencyPopupViewImpl;
import org.kie.workbench.common.screens.projecteditor.client.handlers.NewPackageHandler;
import org.kie.workbench.common.screens.projecteditor.client.menu.ProjectMenu;
import org.kie.workbench.common.screens.projecteditor.client.type.KModuleResourceType;
import org.kie.workbench.common.screens.projecteditor.client.util.KiePOMDefaultOptions;
import org.kie.workbench.common.screens.projecteditor.client.validation.ProjectNameValidator;
import org.kie.workbench.common.screens.projecteditor.client.wizard.NewWorkspaceProjectWizard;
import org.kie.workbench.common.screens.projecteditor.client.wizard.POMWizardPage;
import org.kie.workbench.common.screens.projecteditor.client.wizard.POMWizardPageViewImpl;
import org.kie.workbench.common.screens.projecteditor.type.KModuleResourceTypeDefinition;
import org.kie.workbench.common.screens.projectimportsscreen.client.ProjectConfigScreenEntryPoint;
import org.kie.workbench.common.screens.projectimportsscreen.client.forms.ProjectImportsScreenPresenter;
import org.kie.workbench.common.screens.projectimportsscreen.client.forms.ProjectImportsScreenPresenterActivity;
import org.kie.workbench.common.screens.projectimportsscreen.client.forms.ProjectImportsScreenViewImpl;
import org.kie.workbench.common.screens.projectimportsscreen.client.type.ProjectImportsResourceType;
import org.kie.workbench.common.screens.projectimportsscreen.type.ProjectImportsResourceTypeDefinition;
import org.kie.workbench.common.screens.server.management.client.ServerManagementBrowserPresenter;
import org.kie.workbench.common.screens.server.management.client.ServerManagementBrowserPresenterActivity;
import org.kie.workbench.common.screens.server.management.client.ServerManagementBrowserView;
import org.kie.workbench.common.screens.server.management.client.ServerManagementEntryPoint;
import org.kie.workbench.common.screens.server.management.client.ServerManagementPerspective;
import org.kie.workbench.common.screens.server.management.client.ServerManagementPerspectiveActivity;
import org.kie.workbench.common.screens.server.management.client.container.ContainerPresenter;
import org.kie.workbench.common.screens.server.management.client.container.config.process.ContainerProcessConfigPresenter;
import org.kie.workbench.common.screens.server.management.client.container.config.process.ContainerProcessConfigView;
import org.kie.workbench.common.screens.server.management.client.container.config.rules.ContainerRulesConfigPresenter;
import org.kie.workbench.common.screens.server.management.client.container.config.rules.ContainerRulesConfigView;
import org.kie.workbench.common.screens.server.management.client.container.empty.ServerContainerEmptyPresenter;
import org.kie.workbench.common.screens.server.management.client.container.empty.ServerContainerEmptyView;
import org.kie.workbench.common.screens.server.management.client.container.status.ContainerRemoteStatusPresenter;
import org.kie.workbench.common.screens.server.management.client.container.status.ContainerRemoteStatusView;
import org.kie.workbench.common.screens.server.management.client.container.status.card.ContainerCardPresenter;
import org.kie.workbench.common.screens.server.management.client.container.status.card.ContainerCardView;
import org.kie.workbench.common.screens.server.management.client.container.status.empty.ContainerStatusEmptyPresenter;
import org.kie.workbench.common.screens.server.management.client.container.status.empty.ContainerStatusEmptyView;
import org.kie.workbench.common.screens.server.management.client.empty.ServerEmptyPresenter;
import org.kie.workbench.common.screens.server.management.client.empty.ServerEmptyView;
import org.kie.workbench.common.screens.server.management.client.navigation.ServerNavigationPresenter;
import org.kie.workbench.common.screens.server.management.client.navigation.ServerNavigationView;
import org.kie.workbench.common.screens.server.management.client.navigation.template.ServerTemplatePresenter;
import org.kie.workbench.common.screens.server.management.client.navigation.template.ServerTemplateView;
import org.kie.workbench.common.screens.server.management.client.navigation.template.copy.CopyPopupPresenter;
import org.kie.workbench.common.screens.server.management.client.navigation.template.copy.CopyPopupView;
import org.kie.workbench.common.screens.server.management.client.remote.RemotePresenter;
import org.kie.workbench.common.screens.server.management.client.remote.RemoteStatusPresenter;
import org.kie.workbench.common.screens.server.management.client.remote.RemoteStatusView;
import org.kie.workbench.common.screens.server.management.client.remote.RemoteView;
import org.kie.workbench.common.screens.server.management.client.remote.empty.RemoteEmptyPresenter;
import org.kie.workbench.common.screens.server.management.client.remote.empty.RemoteEmptyView;
import org.kie.workbench.common.screens.server.management.client.widget.NumericTextBox;
import org.kie.workbench.common.screens.server.management.client.widget.artifact.ArtifactListWidgetPresenter;
import org.kie.workbench.common.screens.server.management.client.widget.artifact.ArtifactListWidgetView;
import org.kie.workbench.common.screens.server.management.client.widget.card.CardPresenter;
import org.kie.workbench.common.screens.server.management.client.widget.card.CardView;
import org.kie.workbench.common.screens.server.management.client.widget.card.body.BodyPresenter;
import org.kie.workbench.common.screens.server.management.client.widget.card.body.BodyView;
import org.kie.workbench.common.screens.server.management.client.widget.card.body.notification.NotificationPresenter;
import org.kie.workbench.common.screens.server.management.client.widget.card.body.notification.NotificationView;
import org.kie.workbench.common.screens.server.management.client.widget.card.footer.FooterPresenter;
import org.kie.workbench.common.screens.server.management.client.widget.card.footer.FooterView;
import org.kie.workbench.common.screens.server.management.client.widget.card.title.InfoTitlePresenter;
import org.kie.workbench.common.screens.server.management.client.widget.card.title.InfoTitleView;
import org.kie.workbench.common.screens.server.management.client.widget.card.title.LinkTitlePresenter;
import org.kie.workbench.common.screens.server.management.client.widget.card.title.LinkTitleView;
import org.kie.workbench.common.screens.server.management.client.widget.config.process.ProcessConfigPresenter;
import org.kie.workbench.common.screens.server.management.client.widget.config.process.ProcessConfigView;
import org.kie.workbench.common.screens.server.management.client.wizard.NewContainerWizard;
import org.kie.workbench.common.screens.server.management.client.wizard.NewServerTemplateWizard;
import org.kie.workbench.common.screens.server.management.client.wizard.config.process.ProcessConfigPagePresenter;
import org.kie.workbench.common.screens.server.management.client.wizard.container.NewContainerFormPresenter;
import org.kie.workbench.common.screens.server.management.client.wizard.container.NewContainerFormView;
import org.kie.workbench.common.screens.server.management.client.wizard.template.NewTemplatePresenter;
import org.kie.workbench.common.screens.server.management.client.wizard.template.NewTemplateView;
import org.kie.workbench.common.services.refactoring.client.KieWorkbenchCommonRefactoringClientEntryPoint;
import org.kie.workbench.common.services.refactoring.client.usages.ShowAssetUsagesDisplayer;
import org.kie.workbench.common.services.refactoring.client.usages.ShowAssetUsagesDisplayerViewViewImpl;
import org.kie.workbench.common.services.shared.messageconsole.MessageConsoleWhiteListImpl;
import org.kie.workbench.common.services.shared.preferences.config.WorkbenchPreferenceScopeResolutionStrategiesImpl;
import org.kie.workbench.common.services.shared.preferences.config.WorkbenchPreferenceScopeResolutionStrategy;
import org.kie.workbench.common.services.shared.preferences.config.WorkbenchPreferenceScopeTypes;
import org.kie.workbench.common.services.verifier.reporting.client.VerifierEntryPoint;
import org.kie.workbench.common.services.verifier.reporting.client.panel.AnalysisReportScreen;
import org.kie.workbench.common.services.verifier.reporting.client.panel.AnalysisReportScreenActivity;
import org.kie.workbench.common.services.verifier.reporting.client.panel.AnalysisReportScreenViewImpl;
import org.kie.workbench.common.services.verifier.reporting.client.panel.IssuePresenter;
import org.kie.workbench.common.services.verifier.reporting.client.panel.IssuePresenterViewImpl;
import org.kie.workbench.common.widgets.client.KieWorkbenchWidgetsCommonEntryPoint;
import org.kie.workbench.common.widgets.client.datamodel.AsyncPackageDataModelOracleFactory;
import org.kie.workbench.common.widgets.client.datamodel.AsyncPackageDataModelOracleImpl;
import org.kie.workbench.common.widgets.client.discussion.DiscussionWidgetPresenter;
import org.kie.workbench.common.widgets.client.discussion.DiscussionWidgetViewImpl;
import org.kie.workbench.common.widgets.client.handlers.NewResourcePresenter;
import org.kie.workbench.common.widgets.client.handlers.NewResourceViewImpl;
import org.kie.workbench.common.widgets.client.handlers.NewResourcesMenu;
import org.kie.workbench.common.widgets.client.handlers.PackageListBox;
import org.kie.workbench.common.widgets.client.handlers.PackageListBoxViewImpl;
import org.kie.workbench.common.widgets.client.handlers.PathLabel;
import org.kie.workbench.common.widgets.client.handlers.workbench.configuration.ConfigurationComboBoxItemWidget;
import org.kie.workbench.common.widgets.client.handlers.workbench.configuration.LanguageConfigurationHandler;
import org.kie.workbench.common.widgets.client.handlers.workbench.configuration.WorkbenchConfigurationMenu;
import org.kie.workbench.common.widgets.client.handlers.workbench.configuration.WorkbenchConfigurationPresenter;
import org.kie.workbench.common.widgets.client.handlers.workbench.configuration.WorkbenchConfigurationViewImpl;
import org.kie.workbench.common.widgets.client.menu.AboutCommand;
import org.kie.workbench.common.widgets.client.menu.AppLauncherMenuBuilder;
import org.kie.workbench.common.widgets.client.menu.FileMenuBuilderImpl;
import org.kie.workbench.common.widgets.client.menu.RepositoryMenu;
import org.kie.workbench.common.widgets.client.menu.ResetPerspectivesMenuBuilder;
import org.kie.workbench.common.widgets.client.popups.about.AboutPopup;
import org.kie.workbench.common.widgets.client.popups.about.AboutPopupView;
import org.kie.workbench.common.widgets.client.popups.alert.AlertPopupViewImpl;
import org.kie.workbench.common.widgets.client.popups.copy.CopyPopupWithPackageView;
import org.kie.workbench.common.widgets.client.popups.launcher.AppLauncherItemView;
import org.kie.workbench.common.widgets.client.popups.launcher.AppLauncherPresenter;
import org.kie.workbench.common.widgets.client.popups.launcher.AppLauncherView;
import org.kie.workbench.common.widgets.client.popups.list.FormListPopup;
import org.kie.workbench.common.widgets.client.popups.list.FormListPopupViewImpl;
import org.kie.workbench.common.widgets.client.popups.text.TextBoxFormPopup;
import org.kie.workbench.common.widgets.client.popups.text.TextBoxFormPopupViewImpl;
import org.kie.workbench.common.widgets.client.popups.validation.ValidationMessageTranslatorUtils;
import org.kie.workbench.common.widgets.client.popups.validation.ValidationPopup;
import org.kie.workbench.common.widgets.client.popups.validation.ValidationPopupViewImpl;
import org.kie.workbench.common.widgets.client.source.ViewDRLSourceWidget;
import org.kie.workbench.common.widgets.client.source.ViewSourceViewImpl;
import org.kie.workbench.common.widgets.client.widget.BindingTextBox;
import org.kie.workbench.common.widgets.client.widget.KSessionSelector;
import org.kie.workbench.common.widgets.client.widget.KSessionSelectorViewImpl;
import org.kie.workbench.common.widgets.client.widget.KieSelectElement;
import org.kie.workbench.common.widgets.client.widget.KieSelectElement.OptionElement;
import org.kie.workbench.common.widgets.client.widget.KieSelectElement.OptionsListPresenter;
import org.kie.workbench.common.widgets.client.widget.KieSelectElementView;
import org.kie.workbench.common.widgets.client.widget.KieSelectElementView.Option;
import org.kie.workbench.common.widgets.configresource.client.widget.bound.AddImportPopup;
import org.kie.workbench.common.widgets.configresource.client.widget.bound.ImportsWidgetViewImpl;
import org.kie.workbench.common.widgets.configresource.client.widget.unbound.ImportsWidgetPresenter;
import org.kie.workbench.common.widgets.decoratedgrid.client.DecoratedGridEntryPoint;
import org.kie.workbench.common.widgets.metadata.client.KieEditorEntryPoint;
import org.kie.workbench.common.widgets.metadata.client.KieEditorWrapperViewImpl;
import org.kie.workbench.common.widgets.metadata.client.KieMultipleDocumentEditorEntryPoint;
import org.kie.workbench.common.widgets.metadata.client.KieMultipleDocumentEditorWrapperViewImpl;
import org.kie.workbench.common.widgets.metadata.client.OverviewEditorEntryPoint;
import org.kie.workbench.common.widgets.metadata.client.menu.DocumentMenuItemImpl;
import org.kie.workbench.common.widgets.metadata.client.menu.RegisteredDocumentsMenuBuilder;
import org.kie.workbench.common.widgets.metadata.client.menu.RegisteredDocumentsMenuViewImpl;
import org.kie.workbench.common.widgets.metadata.client.popups.SelectDocumentPopup;
import org.kie.workbench.common.widgets.metadata.client.popups.SelectDocumentPopupViewImpl;
import org.kie.workbench.common.widgets.metadata.client.popups.SelectableDocumentImpl;
import org.kie.workbench.common.widgets.metadata.client.validation.AssetUpdateValidator;
import org.kie.workbench.common.widgets.metadata.client.validation.JavaAssetUpdateValidator;
import org.kie.workbench.common.widgets.metadata.client.validation.JavaFileNameValidator;
import org.kie.workbench.common.widgets.metadata.client.widget.ExternalLinkPresenter;
import org.kie.workbench.common.widgets.metadata.client.widget.ExternalLinkViewImpl;
import org.kie.workbench.common.widgets.metadata.client.widget.MetadataWidget;
import org.kie.workbench.common.widgets.metadata.client.widget.OverviewWidgetPresenter;
import org.kie.workbench.common.widgets.metadata.client.widget.OverviewWidgetViewImpl;
import org.kie.workbench.common.widgets.metadata.client.widget.TagWidgetViewImpl;
import org.kie.workbench.common.workbench.client.admin.DefaultAdminPageHelper;
import org.kie.workbench.common.workbench.client.authz.PermissionTreeSetup;
import org.kie.workbench.common.workbench.client.authz.WorkbenchTreeProvider;
import org.kie.workbench.common.workbench.client.configuration.popups.WorkbenchConfigurationPopup;
import org.kie.workbench.common.workbench.client.docks.AuthoringWorkbenchDocks;
import org.kie.workbench.common.workbench.client.docks.impl.DataModellerDocksHandler;
import org.kie.workbench.common.workbench.client.entrypoint.GenericErrorPopup;
import org.kie.workbench.common.workbench.client.error.DefaultWorkbenchErrorCallback;
import org.kie.workbench.common.workbench.client.menu.DefaultWorkbenchFeaturesMenusHelper;
import org.kie.workbench.common.workbench.client.menu.WorkbenchConfigurationMenuBuilder;
import org.kie.workbench.common.workbench.client.menu.custom.AdminCustomMenuBuilder;
import org.kie.workbench.common.workbench.client.menu.custom.AppsCustomMenuBuilder;
import org.kie.workbench.common.workbench.client.menu.custom.HelpCustomMenuBuilder;
import org.kie.workbench.common.workbench.client.test.TestReportingDocksHandler;
import org.kie.workbench.common.workbench.client.test.TestRunnerReportingScreen;
import org.kie.workbench.common.workbench.client.test.TestRunnerReportingScreenActivity;
import org.kie.workbench.common.workbench.client.test.TestRunnerReportingViewImpl;
import org.optaplanner.workbench.client.OptaPlannerWorkbenchEntryPoint;
import org.optaplanner.workbench.client.RepositoryPreferencesProducer;
import org.optaplanner.workbench.client.home.HomeProducer;
import org.optaplanner.workbench.client.navbar.AppNavBar;
import org.optaplanner.workbench.client.navbar.MegaMenuConfig;
import org.optaplanner.workbench.client.perspectives.AdministrationPerspective;
import org.optaplanner.workbench.client.perspectives.AdministrationPerspectiveActivity;
import org.optaplanner.workbench.client.perspectives.M2RepoPerspective;
import org.optaplanner.workbench.client.perspectives.M2RepoPerspectiveActivity;
import org.optaplanner.workbench.screens.domaineditor.client.DomainEditorEntryPoint;
import org.optaplanner.workbench.screens.domaineditor.client.editor.PlannerFieldMetadataProvider;
import org.optaplanner.workbench.screens.domaineditor.client.handlers.planner.PlannerDomainHandler;
import org.optaplanner.workbench.screens.domaineditor.client.validation.PlannerValidationMessageTranslator;
import org.optaplanner.workbench.screens.domaineditor.client.widgets.planner.DataObjectFieldPicker;
import org.optaplanner.workbench.screens.domaineditor.client.widgets.planner.DataObjectFieldPickerItem;
import org.optaplanner.workbench.screens.domaineditor.client.widgets.planner.DataObjectFieldPickerItemLabelViewImpl;
import org.optaplanner.workbench.screens.domaineditor.client.widgets.planner.DataObjectFieldPickerItemViewImpl;
import org.optaplanner.workbench.screens.domaineditor.client.widgets.planner.DataObjectFieldPickerViewImpl;
import org.optaplanner.workbench.screens.domaineditor.client.widgets.planner.PlannerDataObjectEditor;
import org.optaplanner.workbench.screens.domaineditor.client.widgets.planner.PlannerDataObjectEditorViewImpl;
import org.optaplanner.workbench.screens.domaineditor.client.widgets.planner.PlannerDataObjectFieldEditor;
import org.optaplanner.workbench.screens.domaineditor.client.widgets.planner.PlannerDataObjectFieldEditorViewImpl;
import org.optaplanner.workbench.screens.domaineditor.client.widgets.planner.PlannerDomainEditor;
import org.optaplanner.workbench.screens.domaineditor.client.widgets.planner.PlannerDomainScreen;
import org.optaplanner.workbench.screens.domaineditor.client.widgets.planner.PlannerDomainScreenActivity;
import org.optaplanner.workbench.screens.domaineditor.client.widgets.planner.PlannerDomainScreenViewImpl;
import org.optaplanner.workbench.screens.guidedrule.client.plugin.ActionPluginClientService;
import org.optaplanner.workbench.screens.guidedrule.client.plugin.BendableHardConstraintMatchRuleModellerActionPlugin;
import org.optaplanner.workbench.screens.guidedrule.client.plugin.BendableSoftConstraintMatchRuleModellerActionPlugin;
import org.optaplanner.workbench.screens.guidedrule.client.plugin.HardConstraintMatchRuleModellerActionPlugin;
import org.optaplanner.workbench.screens.guidedrule.client.plugin.MediumConstraintMatchRuleModellerActionPlugin;
import org.optaplanner.workbench.screens.guidedrule.client.plugin.MultiConstraintBendableBigDecimalMatchRuleModellerActionPlugin;
import org.optaplanner.workbench.screens.guidedrule.client.plugin.MultiConstraintBendableLongMatchRuleModellerActionPlugin;
import org.optaplanner.workbench.screens.guidedrule.client.plugin.MultiConstraintBendableMatchRuleModellerActionPlugin;
import org.optaplanner.workbench.screens.guidedrule.client.plugin.MultiConstraintHardMediumSoftMatchRuleModellerActionPlugin;
import org.optaplanner.workbench.screens.guidedrule.client.plugin.MultiConstraintHardSoftMatchRuleModellerActionPlugin;
import org.optaplanner.workbench.screens.guidedrule.client.plugin.SimpleConstraintMatchRuleModellerActionPlugin;
import org.optaplanner.workbench.screens.guidedrule.client.plugin.SoftConstraintMatchRuleModellerActionPlugin;
import org.optaplanner.workbench.screens.solver.client.SolverEditorEntryPoint;
import org.optaplanner.workbench.screens.solver.client.editor.ConstructionHeuristicForm;
import org.optaplanner.workbench.screens.solver.client.editor.ConstructionHeuristicFormViewImpl;
import org.optaplanner.workbench.screens.solver.client.editor.LocalSearchForm;
import org.optaplanner.workbench.screens.solver.client.editor.LocalSearchFormViewImpl;
import org.optaplanner.workbench.screens.solver.client.editor.PhaseConfigForm;
import org.optaplanner.workbench.screens.solver.client.editor.PhaseConfigFormViewImpl;
import org.optaplanner.workbench.screens.solver.client.editor.ScoreDirectorFactoryForm;
import org.optaplanner.workbench.screens.solver.client.editor.ScoreDirectorFactoryFormViewImpl;
import org.optaplanner.workbench.screens.solver.client.editor.SolverEditorPresenter;
import org.optaplanner.workbench.screens.solver.client.editor.SolverEditorPresenterActivity;
import org.optaplanner.workbench.screens.solver.client.editor.SolverEditorViewImpl;
import org.optaplanner.workbench.screens.solver.client.editor.TerminationConfigForm;
import org.optaplanner.workbench.screens.solver.client.editor.TerminationConfigFormViewImpl;
import org.optaplanner.workbench.screens.solver.client.editor.TerminationTreeItemContent;
import org.optaplanner.workbench.screens.solver.client.editor.TerminationTreeItemContentViewImpl;
import org.optaplanner.workbench.screens.solver.client.editor.XMLViewerImpl;
import org.optaplanner.workbench.screens.solver.client.handlers.NewSolverHandler;
import org.optaplanner.workbench.screens.solver.client.type.SolverResourceType;
import org.optaplanner.workbench.screens.solver.type.SolverResourceTypeDefinition;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.uberfire.backend.vfs.Path;
import org.uberfire.backend.vfs.impl.ObservablePathImpl;
import org.uberfire.client.DocksEntryPoint;
import org.uberfire.client.JSEntryPoint;
import org.uberfire.client.authz.DefaultWorkbenchController;
import org.uberfire.client.authz.EditorTreeProvider;
import org.uberfire.client.authz.PerspectiveTreeProvider;
import org.uberfire.client.docks.UberfireDocksImpl;
import org.uberfire.client.docks.view.DocksBars;
import org.uberfire.client.docks.view.menu.MenuBuilder;
import org.uberfire.client.editor.JSNativeEditor;
import org.uberfire.client.editor.type.JSNativeClientResourceType;
import org.uberfire.client.exporter.EditorJSExporter;
import org.uberfire.client.exporter.PerspectiveJSExporter;
import org.uberfire.client.exporter.PlaceManagerJSExporter;
import org.uberfire.client.exporter.PluginJSExporter;
import org.uberfire.client.exporter.ResourceTypeDefinitionJSExporter;
import org.uberfire.client.exporter.SplashScreenJSExporter;
import org.uberfire.client.exporter.UberfireJSAPIExporter;
import org.uberfire.client.exporter.VFSJSExporter;
import org.uberfire.client.menu.CustomSplashHelp;
import org.uberfire.client.menu.SplashScreenMenuPresenter;
import org.uberfire.client.menu.WorkbenchViewModeSwitcherMenuBuilder;
import org.uberfire.client.menu.WorkbenchViewModeSwitcherPresenter;
import org.uberfire.client.mvp.Activity;
import org.uberfire.client.mvp.ActivityBeansCache;
import org.uberfire.client.mvp.ActivityBeansInfo;
import org.uberfire.client.mvp.ActivityLifecycleErrorHandler;
import org.uberfire.client.mvp.ActivityManagerImpl;
import org.uberfire.client.mvp.CategoriesManagerCache;
import org.uberfire.client.mvp.ForceUnlockEventObserver;
import org.uberfire.client.mvp.LockDemandDetector;
import org.uberfire.client.mvp.LockManager;
import org.uberfire.client.mvp.LockManagerImpl;
import org.uberfire.client.mvp.LockTarget;
import org.uberfire.client.mvp.LockTarget.TitleProvider;
import org.uberfire.client.mvp.PerspectiveActivity;
import org.uberfire.client.mvp.PerspectiveManagerImpl;
import org.uberfire.client.mvp.PlaceHistoryHandler;
import org.uberfire.client.mvp.PlaceManager;
import org.uberfire.client.mvp.PlaceManagerImpl;
import org.uberfire.client.mvp.PlaceRequestHistoryMapperImpl;
import org.uberfire.client.mvp.PlaceStatus;
import org.uberfire.client.mvp.ResourceTypeManagerCache;
import org.uberfire.client.mvp.WorkbenchActivity;
import org.uberfire.client.perspective.JSNativePerspective;
import org.uberfire.client.plugin.RuntimePluginsServiceProxyClientImpl;
import org.uberfire.client.promise.Promises;
import org.uberfire.client.resources.i18n.PermissionTreeI18NImpl;
import org.uberfire.client.screen.JSNativeScreen;
import org.uberfire.client.splash.JSNativeSplashScreen;
import org.uberfire.client.util.Clipboard;
import org.uberfire.client.views.pfly.HTML5DndSeleniumSupport;
import org.uberfire.client.views.pfly.PatternFlyEntryPoint;
import org.uberfire.client.views.pfly.dnd.CompassWidgetImpl;
import org.uberfire.client.views.pfly.listbar.ListBarWidgetImpl;
import org.uberfire.client.views.pfly.menu.PartContextMenusView;
import org.uberfire.client.views.pfly.menu.SplashScreenMenuView;
import org.uberfire.client.views.pfly.menu.UserMenu;
import org.uberfire.client.views.pfly.menu.UserMenuViewImpl;
import org.uberfire.client.views.pfly.menu.UtilityMenuBarView;
import org.uberfire.client.views.pfly.menu.WorkbenchMenuBarView;
import org.uberfire.client.views.pfly.menu.WorkbenchMenuCompactNavBarView;
import org.uberfire.client.views.pfly.menu.WorkbenchMenuStandardNavBarView;
import org.uberfire.client.views.pfly.menu.WorkbenchViewModeSwitcherView;
import org.uberfire.client.views.pfly.menu.megamenu.WorkbenchMegaMenuView;
import org.uberfire.client.views.pfly.menu.megamenu.contextmenuitem.ChildContextMenuItemView;
import org.uberfire.client.views.pfly.menu.megamenu.contextmenuitem.GroupContextMenuItemView;
import org.uberfire.client.views.pfly.menu.megamenu.menuitem.ChildMenuItemView;
import org.uberfire.client.views.pfly.menu.megamenu.menuitem.GroupMenuItemView;
import org.uberfire.client.views.pfly.menu.megamenu.menuitem.IconMenuItemView;
import org.uberfire.client.views.pfly.modal.Bs3Modal;
import org.uberfire.client.views.pfly.multipage.MultiPageEditorImpl;
import org.uberfire.client.views.pfly.multipage.MultiPageEditorViewImpl;
import org.uberfire.client.views.pfly.multiscreen.MultiScreenMenuBuilder;
import org.uberfire.client.views.pfly.multiscreen.MultiScreenPartWidget;
import org.uberfire.client.views.pfly.multiscreen.MultiScreenView;
import org.uberfire.client.views.pfly.notifications.NotificationPopupsManagerView;
import org.uberfire.client.views.pfly.popup.PopupViewImpl;
import org.uberfire.client.views.pfly.splash.SplashModalFooter;
import org.uberfire.client.views.pfly.splash.SplashViewImpl;
import org.uberfire.client.views.pfly.tab.MultiTabWorkbenchPanelView;
import org.uberfire.client.views.pfly.tab.ResizeTabPanel;
import org.uberfire.client.views.pfly.tab.TabPanelWithDropdowns;
import org.uberfire.client.views.pfly.tab.UberTabPanel;
import org.uberfire.client.views.pfly.toolbar.WorkbenchToolBarView;
import org.uberfire.client.views.pfly.widgets.Button;
import org.uberfire.client.views.pfly.widgets.ConfirmPopup;
import org.uberfire.client.views.pfly.widgets.DateRangePicker;
import org.uberfire.client.views.pfly.widgets.DropdownMenu;
import org.uberfire.client.views.pfly.widgets.DropdownMenuItem;
import org.uberfire.client.views.pfly.widgets.Elemental2Producer;
import org.uberfire.client.views.pfly.widgets.ErrorPopup;
import org.uberfire.client.views.pfly.widgets.ErrorPopupView;
import org.uberfire.client.views.pfly.widgets.FormGroup;
import org.uberfire.client.views.pfly.widgets.FormLabel;
import org.uberfire.client.views.pfly.widgets.FormLabelHelp;
import org.uberfire.client.views.pfly.widgets.HelpIcon;
import org.uberfire.client.views.pfly.widgets.InlineNotification;
import org.uberfire.client.views.pfly.widgets.JQueryProducer.JQuery;
import org.uberfire.client.views.pfly.widgets.KebabMenu;
import org.uberfire.client.views.pfly.widgets.KebabMenuItem;
import org.uberfire.client.views.pfly.widgets.Modal;
import org.uberfire.client.views.pfly.widgets.Select;
import org.uberfire.client.workbench.DefaultBeanFactory;
import org.uberfire.client.workbench.LayoutSelection;
import org.uberfire.client.workbench.PanelManagerImpl;
import org.uberfire.client.workbench.StandaloneEditorPerspective;
import org.uberfire.client.workbench.VFSLockServiceProxyClientImpl;
import org.uberfire.client.workbench.VFSServiceProxyClientImpl;
import org.uberfire.client.workbench.Workbench;
import org.uberfire.client.workbench.WorkbenchLayoutImpl;
import org.uberfire.client.workbench.WorkbenchLayoutInfoImpl;
import org.uberfire.client.workbench.WorkbenchServicesProxyClientImpl;
import org.uberfire.client.workbench.docks.UberfireDocksContainer;
import org.uberfire.client.workbench.panels.impl.AdaptiveWorkbenchPanelPresenter;
import org.uberfire.client.workbench.panels.impl.AdaptiveWorkbenchPanelView;
import org.uberfire.client.workbench.panels.impl.ClosableSimpleWorkbenchPanelPresenter;
import org.uberfire.client.workbench.panels.impl.ClosableSimpleWorkbenchPanelView;
import org.uberfire.client.workbench.panels.impl.LayoutPanelPresenter;
import org.uberfire.client.workbench.panels.impl.LayoutPanelView;
import org.uberfire.client.workbench.panels.impl.MultiListWorkbenchPanelPresenter;
import org.uberfire.client.workbench.panels.impl.MultiListWorkbenchPanelView;
import org.uberfire.client.workbench.panels.impl.MultiScreenWorkbenchPanelPresenter;
import org.uberfire.client.workbench.panels.impl.MultiScreenWorkbenchPanelView;
import org.uberfire.client.workbench.panels.impl.MultiTabWorkbenchPanelPresenter;
import org.uberfire.client.workbench.panels.impl.SimpleDnDWorkbenchPanelPresenter;
import org.uberfire.client.workbench.panels.impl.SimpleDnDWorkbenchPanelView;
import org.uberfire.client.workbench.panels.impl.SimpleWorkbenchPanelPresenter;
import org.uberfire.client.workbench.panels.impl.SimpleWorkbenchPanelView;
import org.uberfire.client.workbench.panels.impl.SplitLayoutPanelPresenter;
import org.uberfire.client.workbench.panels.impl.SplitLayoutPanelView;
import org.uberfire.client.workbench.panels.impl.StaticWorkbenchPanelPresenter;
import org.uberfire.client.workbench.panels.impl.StaticWorkbenchPanelView;
import org.uberfire.client.workbench.panels.impl.TemplatedWorkbenchPanelPresenter;
import org.uberfire.client.workbench.panels.impl.TemplatedWorkbenchPanelView;
import org.uberfire.client.workbench.panels.impl.UnanchoredStaticWorkbenchPanelPresenter;
import org.uberfire.client.workbench.panels.impl.UnanchoredStaticWorkbenchPanelView;
import org.uberfire.client.workbench.panels.support.PartManager;
import org.uberfire.client.workbench.pmgr.nswe.part.WorkbenchPartPresenterDefault;
import org.uberfire.client.workbench.pmgr.nswe.part.WorkbenchPartView;
import org.uberfire.client.workbench.pmgr.unanchored.part.UnanchoredWorkbenchPartPresenter;
import org.uberfire.client.workbench.pmgr.unanchored.part.UnanchoredWorkbenchPartView;
import org.uberfire.client.workbench.type.AnyResourceType;
import org.uberfire.client.workbench.type.ClientResourceType;
import org.uberfire.client.workbench.type.DotResourceType;
import org.uberfire.client.workbench.widgets.dnd.CompassDropController;
import org.uberfire.client.workbench.widgets.dnd.WorkbenchDragAndDropManager;
import org.uberfire.client.workbench.widgets.dnd.WorkbenchPickupDragController;
import org.uberfire.client.workbench.widgets.listbar.ResizeFlowPanel;
import org.uberfire.client.workbench.widgets.menu.PartContextMenusPresenter;
import org.uberfire.client.workbench.widgets.menu.UtilityMenuBarPresenter;
import org.uberfire.client.workbench.widgets.menu.WorkbenchMenuBarPresenter;
import org.uberfire.client.workbench.widgets.menu.WorkbenchMenuBarProducer;
import org.uberfire.client.workbench.widgets.menu.megamenu.WorkbenchMegaMenuPresenter;
import org.uberfire.client.workbench.widgets.menu.megamenu.WorkbenchMegaMenuProducer;
import org.uberfire.client.workbench.widgets.menu.megamenu.contextmenuitem.ChildContextMenuItemPresenter;
import org.uberfire.client.workbench.widgets.menu.megamenu.contextmenuitem.GroupContextMenuItemPresenter;
import org.uberfire.client.workbench.widgets.menu.megamenu.menuitem.ChildMenuItemPresenter;
import org.uberfire.client.workbench.widgets.menu.megamenu.menuitem.GroupMenuItemPresenter;
import org.uberfire.client.workbench.widgets.menu.megamenu.menuitem.IconMenuItemPresenter;
import org.uberfire.client.workbench.widgets.notifications.NotificationManager;
import org.uberfire.client.workbench.widgets.panel.StaticFocusedResizePanel;
import org.uberfire.client.workbench.widgets.toolbar.WorkbenchToolBarPresenter;
import org.uberfire.experimental.client.UberfireExperimentalEntryPoint;
import org.uberfire.experimental.client.disabled.component.DisabledFeatureComponent;
import org.uberfire.experimental.client.disabled.component.DisabledFeatureComponentViewImpl;
import org.uberfire.experimental.client.disabled.screen.DisabledFeatureActivity;
import org.uberfire.experimental.client.editor.ExperimentalFeaturesEditorScreen;
import org.uberfire.experimental.client.editor.ExperimentalFeaturesEditorScreenActivity;
import org.uberfire.experimental.client.editor.ExperimentalFeaturesEditorScreenViewImpl;
import org.uberfire.experimental.client.editor.group.ExperimentalFeaturesGroup;
import org.uberfire.experimental.client.editor.group.ExperimentalFeaturesGroupViewImpl;
import org.uberfire.experimental.client.editor.group.feature.ExperimentalFeatureEditor;
import org.uberfire.experimental.client.editor.group.feature.ExperimentalFeatureEditorViewImpl;
import org.uberfire.experimental.client.perspective.ExperimentalFeaturesPerspective;
import org.uberfire.experimental.client.perspective.ExperimentalFeaturesPerspectiveActivity;
import org.uberfire.experimental.client.service.auth.ExperimentalActivitiesAuthorizationManagerImpl;
import org.uberfire.experimental.client.service.impl.CDIClientFeatureDefRegistry;
import org.uberfire.experimental.client.service.impl.ClientExperimentalFeaturesRegistryServiceImpl;
import org.uberfire.experimental.client.workbench.type.ExperimentalAwareClientTypeRegistryImpl;
import org.uberfire.ext.apps.client.AppsEntryPoint;
import org.uberfire.ext.apps.client.AppsPerspective;
import org.uberfire.ext.apps.client.AppsPerspectiveActivity;
import org.uberfire.ext.apps.client.home.AppsHomePresenter;
import org.uberfire.ext.apps.client.home.AppsHomePresenterActivity;
import org.uberfire.ext.apps.client.home.AppsHomeView;
import org.uberfire.ext.editor.commons.client.BaseEditorEntryPoint;
import org.uberfire.ext.editor.commons.client.file.CopyPopUpViewProducer;
import org.uberfire.ext.editor.commons.client.file.RestoreUtil;
import org.uberfire.ext.editor.commons.client.file.exports.FileExportProducer;
import org.uberfire.ext.editor.commons.client.file.exports.ImageFileExport;
import org.uberfire.ext.editor.commons.client.file.exports.PdfFileExport;
import org.uberfire.ext.editor.commons.client.file.exports.TextFileExport;
import org.uberfire.ext.editor.commons.client.file.exports.jso.FileExportScriptInjector;
import org.uberfire.ext.editor.commons.client.file.exports.svg.SvgFileExport;
import org.uberfire.ext.editor.commons.client.file.popups.CopyPopUpPresenter;
import org.uberfire.ext.editor.commons.client.file.popups.CopyPopUpPresenter.View;
import org.uberfire.ext.editor.commons.client.file.popups.CopyPopUpView;
import org.uberfire.ext.editor.commons.client.file.popups.DeletePopUpPresenter;
import org.uberfire.ext.editor.commons.client.file.popups.DeletePopUpView;
import org.uberfire.ext.editor.commons.client.file.popups.RenamePopUpPresenter;
import org.uberfire.ext.editor.commons.client.file.popups.RenamePopUpView;
import org.uberfire.ext.editor.commons.client.file.popups.RestorePopUpPresenter;
import org.uberfire.ext.editor.commons.client.file.popups.RestorePopUpView;
import org.uberfire.ext.editor.commons.client.file.popups.SavePopUpPresenter;
import org.uberfire.ext.editor.commons.client.file.popups.SavePopUpView;
import org.uberfire.ext.editor.commons.client.file.popups.commons.ToggleCommentPresenter;
import org.uberfire.ext.editor.commons.client.file.popups.commons.ToggleCommentView;
import org.uberfire.ext.editor.commons.client.history.SaveButton;
import org.uberfire.ext.editor.commons.client.history.VersionHistoryPresenter;
import org.uberfire.ext.editor.commons.client.history.VersionHistoryPresenterViewImpl;
import org.uberfire.ext.editor.commons.client.history.VersionMenuDropDownButton;
import org.uberfire.ext.editor.commons.client.history.VersionMenuDropDownButtonViewImpl;
import org.uberfire.ext.editor.commons.client.history.VersionRecordManager;
import org.uberfire.ext.editor.commons.client.htmleditor.HtmlEditor;
import org.uberfire.ext.editor.commons.client.htmleditor.HtmlEditorActivity;
import org.uberfire.ext.editor.commons.client.htmleditor.HtmlEditorLibraryLoader;
import org.uberfire.ext.editor.commons.client.htmleditor.HtmlEditorPresenter;
import org.uberfire.ext.editor.commons.client.htmleditor.HtmlEditorView;
import org.uberfire.ext.editor.commons.client.htmleditor.HtmlResourceType;
import org.uberfire.ext.editor.commons.client.menu.BasicFileMenuBuilderImpl;
import org.uberfire.ext.editor.commons.client.menu.DownloadMenuItem;
import org.uberfire.ext.editor.commons.client.menu.RestoreVersionCommandProvider;
import org.uberfire.ext.editor.commons.client.menu.common.SaveAndRenameCommandBuilder;
import org.uberfire.ext.editor.commons.client.validation.DefaultFileNameValidator;
import org.uberfire.ext.editor.commons.file.exports.FileExportsPreferencesBeanGeneratedImpl;
import org.uberfire.ext.layout.editor.client.LayoutComponentPaletteScreen;
import org.uberfire.ext.layout.editor.client.LayoutEditorEntryPoint;
import org.uberfire.ext.layout.editor.client.LayoutEditorPluginImpl;
import org.uberfire.ext.layout.editor.client.LayoutEditorPresenter;
import org.uberfire.ext.layout.editor.client.LayoutEditorPropertiesScreen;
import org.uberfire.ext.layout.editor.client.LayoutEditorView;
import org.uberfire.ext.layout.editor.client.components.columns.ColumnWithComponents;
import org.uberfire.ext.layout.editor.client.components.columns.ColumnWithComponentsView;
import org.uberfire.ext.layout.editor.client.components.columns.ComponentColumn;
import org.uberfire.ext.layout.editor.client.components.columns.ComponentColumnView;
import org.uberfire.ext.layout.editor.client.components.container.ContainerView;
import org.uberfire.ext.layout.editor.client.components.rows.EmptyDropRow;
import org.uberfire.ext.layout.editor.client.components.rows.EmptyDropRowView;
import org.uberfire.ext.layout.editor.client.components.rows.Row;
import org.uberfire.ext.layout.editor.client.components.rows.RowView;
import org.uberfire.ext.layout.editor.client.generator.BootstrapLayoutGenerator;
import org.uberfire.ext.layout.editor.client.generator.BootstrapLayoutGeneratorDriver;
import org.uberfire.ext.layout.editor.client.infra.DnDManager;
import org.uberfire.ext.layout.editor.client.infra.DragHelperComponentColumn;
import org.uberfire.ext.layout.editor.client.infra.LayoutDragComponentHelper;
import org.uberfire.ext.layout.editor.client.infra.LayoutEditorCssHelper;
import org.uberfire.ext.layout.editor.client.infra.experimental.DisabledExperimentalLayoutComponent;
import org.uberfire.ext.layout.editor.client.widgets.KebabWidget;
import org.uberfire.ext.layout.editor.client.widgets.LayoutComponentPalettePresenter;
import org.uberfire.ext.layout.editor.client.widgets.LayoutComponentPaletteView;
import org.uberfire.ext.layout.editor.client.widgets.LayoutDragComponentGroupPresenter;
import org.uberfire.ext.layout.editor.client.widgets.LayoutDragComponentGroupView;
import org.uberfire.ext.layout.editor.client.widgets.LayoutDragComponentWidget;
import org.uberfire.ext.layout.editor.client.widgets.LayoutEditorPropertiesPresenter;
import org.uberfire.ext.layout.editor.client.widgets.LayoutEditorPropertiesView;
import org.uberfire.ext.layout.editor.client.widgets.LayoutElementPropertiesPresenter;
import org.uberfire.ext.layout.editor.client.widgets.LayoutElementPropertiesView;
import org.uberfire.ext.plugin.client.RuntimePluginsEntryPoint;
import org.uberfire.ext.plugin.client.config.PluginConfigService;
import org.uberfire.ext.plugin.client.editor.DynamicMenuEditorPresenter;
import org.uberfire.ext.plugin.client.editor.DynamicMenuEditorPresenterActivity;
import org.uberfire.ext.plugin.client.editor.DynamicMenuEditorView;
import org.uberfire.ext.plugin.client.editor.EditorPlugInEditorPresenter;
import org.uberfire.ext.plugin.client.editor.EditorPlugInEditorPresenterActivity;
import org.uberfire.ext.plugin.client.editor.EditorPlugInEditorView;
import org.uberfire.ext.plugin.client.editor.ScreenEditorPresenter;
import org.uberfire.ext.plugin.client.editor.ScreenEditorPresenterActivity;
import org.uberfire.ext.plugin.client.editor.ScreenEditorView;
import org.uberfire.ext.plugin.client.editor.SplashEditorPresenter;
import org.uberfire.ext.plugin.client.editor.SplashEditorPresenterActivity;
import org.uberfire.ext.plugin.client.editor.SplashEditorView;
import org.uberfire.ext.plugin.client.explorer.PluginExplorerScreen;
import org.uberfire.ext.plugin.client.explorer.PluginExplorerScreenActivity;
import org.uberfire.ext.plugin.client.info.PluginsInfo;
import org.uberfire.ext.plugin.client.perspective.PlugInAuthoringPerspective;
import org.uberfire.ext.plugin.client.perspective.PlugInAuthoringPerspectiveActivity;
import org.uberfire.ext.plugin.client.perspective.editor.PerspectiveEditorPresenter;
import org.uberfire.ext.plugin.client.perspective.editor.PerspectiveEditorPresenterActivity;
import org.uberfire.ext.plugin.client.perspective.editor.PerspectiveEditorView;
import org.uberfire.ext.plugin.client.perspective.editor.api.PerspectiveEditorCoreGroupProvider;
import org.uberfire.ext.plugin.client.perspective.editor.api.PerspectiveEditorNavGroupProvider;
import org.uberfire.ext.plugin.client.perspective.editor.generator.PerspectiveEditorGenerator;
import org.uberfire.ext.plugin.client.perspective.editor.layout.editor.HTMLLayoutDragComponent;
import org.uberfire.ext.plugin.client.perspective.editor.layout.editor.PerspectiveEditorSettings;
import org.uberfire.ext.plugin.client.perspective.editor.layout.editor.ScreenLayoutDragComponent;
import org.uberfire.ext.plugin.client.perspective.editor.layout.editor.TargetDivDragComponent;
import org.uberfire.ext.plugin.client.perspective.editor.layout.editor.popups.EditHTMLPresenter;
import org.uberfire.ext.plugin.client.perspective.editor.layout.editor.popups.EditHTMLView;
import org.uberfire.ext.plugin.client.plugins.RuntimePluginStartup;
import org.uberfire.ext.plugin.client.resources.i18n.PerspectiveEditorPaletteI18nImpl;
import org.uberfire.ext.plugin.client.security.PluginController;
import org.uberfire.ext.plugin.client.type.DynamicMenuResourceType;
import org.uberfire.ext.plugin.client.type.EditorPluginResourceType;
import org.uberfire.ext.plugin.client.type.PerspectiveLayoutPluginResourceType;
import org.uberfire.ext.plugin.client.type.ScreenPluginResourceType;
import org.uberfire.ext.plugin.client.type.SplashPluginResourceType;
import org.uberfire.ext.plugin.client.validation.PluginNameValidator;
import org.uberfire.ext.plugin.client.widget.media.MediaLibraryWidget;
import org.uberfire.ext.plugin.client.widget.navigator.PluginNavList;
import org.uberfire.ext.plugin.client.widget.plugin.GeneralPluginEditor;
import org.uberfire.ext.plugin.client.widget.popup.NewPluginPopUp;
import org.uberfire.ext.plugin.client.widget.popup.NewPluginPopUpViewImpl;
import org.uberfire.ext.plugin.type.DynamicMenuResourceTypeDefinition;
import org.uberfire.ext.preferences.client.PreferencesEntryPoint;
import org.uberfire.ext.preferences.client.admin.AdminPagePerspective;
import org.uberfire.ext.preferences.client.admin.AdminPagePerspectiveActivity;
import org.uberfire.ext.preferences.client.admin.AdminPagePresenter;
import org.uberfire.ext.preferences.client.admin.AdminPagePresenterActivity;
import org.uberfire.ext.preferences.client.admin.AdminPageView;
import org.uberfire.ext.preferences.client.admin.category.AdminPageCategoryPresenter;
import org.uberfire.ext.preferences.client.admin.category.AdminPageCategoryView;
import org.uberfire.ext.preferences.client.admin.item.AdminPageItemPresenter;
import org.uberfire.ext.preferences.client.admin.item.AdminPageItemView;
import org.uberfire.ext.preferences.client.admin.page.AdminPageImpl;
import org.uberfire.ext.preferences.client.central.PreferencesCentralNavBarScreen;
import org.uberfire.ext.preferences.client.central.PreferencesCentralNavBarScreenActivity;
import org.uberfire.ext.preferences.client.central.PreferencesCentralPerspective;
import org.uberfire.ext.preferences.client.central.PreferencesCentralPerspectiveActivity;
import org.uberfire.ext.preferences.client.central.actions.PreferencesCentralActionsScreen;
import org.uberfire.ext.preferences.client.central.actions.PreferencesCentralActionsScreenActivity;
import org.uberfire.ext.preferences.client.central.actions.PreferencesCentralActionsView;
import org.uberfire.ext.preferences.client.central.form.DefaultPreferenceForm;
import org.uberfire.ext.preferences.client.central.form.DefaultPreferenceFormActivity;
import org.uberfire.ext.preferences.client.central.form.DefaultPreferenceFormView;
import org.uberfire.ext.preferences.client.central.screen.PreferencesRootScreen;
import org.uberfire.ext.preferences.client.central.screen.PreferencesRootScreenActivity;
import org.uberfire.ext.preferences.client.central.screen.PreferencesRootView;
import org.uberfire.ext.preferences.client.central.tree.TreeHierarchyInternalItemPresenter;
import org.uberfire.ext.preferences.client.central.tree.TreeHierarchyInternalItemView;
import org.uberfire.ext.preferences.client.central.tree.TreeHierarchyLeafItemPresenter;
import org.uberfire.ext.preferences.client.central.tree.TreeHierarchyLeafItemView;
import org.uberfire.ext.preferences.client.central.tree.TreeHierarchyStructurePresenter;
import org.uberfire.ext.preferences.client.central.tree.TreeHierarchyStructureView;
import org.uberfire.ext.preferences.client.utils.PreferenceFormBeansInfo;
import org.uberfire.ext.properties.editor.client.PropertyEditorWidget;
import org.uberfire.ext.properties.editor.client.fields.BooleanField;
import org.uberfire.ext.properties.editor.client.fields.ColorField;
import org.uberfire.ext.properties.editor.client.fields.ComboField;
import org.uberfire.ext.properties.editor.client.fields.SecretTextField;
import org.uberfire.ext.properties.editor.client.fields.TextField;
import org.uberfire.ext.security.management.client.ClientSecurityExceptionMessageResolver;
import org.uberfire.ext.security.management.client.ClientUserSystemManager;
import org.uberfire.ext.security.management.client.editor.group.GroupEditorDriver;
import org.uberfire.ext.security.management.client.editor.role.RoleEditorDriver;
import org.uberfire.ext.security.management.client.editor.user.UserEditorDriver;
import org.uberfire.ext.security.management.client.widgets.management.ChangePassword;
import org.uberfire.ext.security.management.client.widgets.management.ChangePasswordView;
import org.uberfire.ext.security.management.client.widgets.management.CreateEntity;
import org.uberfire.ext.security.management.client.widgets.management.CreateEntityView;
import org.uberfire.ext.security.management.client.widgets.management.editor.AssignedEntitiesExplorerView;
import org.uberfire.ext.security.management.client.widgets.management.editor.AssignedEntitiesInlineEditorView;
import org.uberfire.ext.security.management.client.widgets.management.editor.AssignedEntitiesModalEditorView;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.ACLEditor;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.ACLEditorView;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.ACLSettings;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.ACLSettingsView;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.ACLViewer;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.ACLViewerView;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.PriorityDropDown;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.node.LeafPermissionNodeEditor;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.node.LeafPermissionNodeEditorView;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.node.LeafPermissionNodeViewer;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.node.LeafPermissionNodeViewerView;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.node.MultiplePermissionNodeEditor;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.node.MultiplePermissionNodeEditorView;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.node.MultiplePermissionNodeViewer;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.node.MultiplePermissionNodeViewerView;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.node.PermissionExceptionSwitch;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.node.PermissionExceptionSwitchView;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.node.PermissionSwitch;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.node.PermissionSwitchView;
import org.uberfire.ext.security.management.client.widgets.management.editor.acl.node.PermissionWidgetFactory;
import org.uberfire.ext.security.management.client.widgets.management.editor.group.GroupEditor;
import org.uberfire.ext.security.management.client.widgets.management.editor.group.GroupEditorView;
import org.uberfire.ext.security.management.client.widgets.management.editor.group.GroupUsersAssignment;
import org.uberfire.ext.security.management.client.widgets.management.editor.group.workflow.GroupCreationWorkflow;
import org.uberfire.ext.security.management.client.widgets.management.editor.group.workflow.GroupEditorWorkflow;
import org.uberfire.ext.security.management.client.widgets.management.editor.role.RoleEditor;
import org.uberfire.ext.security.management.client.widgets.management.editor.role.RoleEditorView;
import org.uberfire.ext.security.management.client.widgets.management.editor.role.workflow.RoleEditorWorkflow;
import org.uberfire.ext.security.management.client.widgets.management.editor.user.NewUserAttributeEditor;
import org.uberfire.ext.security.management.client.widgets.management.editor.user.NewUserAttributeEditorView;
import org.uberfire.ext.security.management.client.widgets.management.editor.user.UserAssignedGroupsEditor;
import org.uberfire.ext.security.management.client.widgets.management.editor.user.UserAssignedGroupsExplorer;
import org.uberfire.ext.security.management.client.widgets.management.editor.user.UserAssignedRolesEditor;
import org.uberfire.ext.security.management.client.widgets.management.editor.user.UserAssignedRolesExplorer;
import org.uberfire.ext.security.management.client.widgets.management.editor.user.UserAttributesEditor;
import org.uberfire.ext.security.management.client.widgets.management.editor.user.UserAttributesEditorView;
import org.uberfire.ext.security.management.client.widgets.management.editor.user.UserEditor;
import org.uberfire.ext.security.management.client.widgets.management.editor.user.UserEditorView;
import org.uberfire.ext.security.management.client.widgets.management.editor.user.workflow.UserCreationWorkflow;
import org.uberfire.ext.security.management.client.widgets.management.editor.user.workflow.UserEditorWorkflow;
import org.uberfire.ext.security.management.client.widgets.management.editor.workflow.EntityWorkflowViewImpl;
import org.uberfire.ext.security.management.client.widgets.management.explorer.EntitiesExplorerViewImpl;
import org.uberfire.ext.security.management.client.widgets.management.explorer.GroupsExplorer;
import org.uberfire.ext.security.management.client.widgets.management.explorer.RolesExplorer;
import org.uberfire.ext.security.management.client.widgets.management.explorer.UserGroupsExplorer;
import org.uberfire.ext.security.management.client.widgets.management.explorer.UserGroupsExplorerView;
import org.uberfire.ext.security.management.client.widgets.management.explorer.UsersExplorer;
import org.uberfire.ext.security.management.client.widgets.management.list.EntitiesListView;
import org.uberfire.ext.security.management.client.widgets.management.list.GroupsList;
import org.uberfire.ext.security.management.client.widgets.management.list.RolesList;
import org.uberfire.ext.security.management.client.widgets.management.list.UsersList;
import org.uberfire.ext.security.management.client.widgets.popup.ConfirmBox;
import org.uberfire.ext.security.management.client.widgets.popup.ConfirmBoxView;
import org.uberfire.ext.security.management.client.widgets.popup.ErrorBox;
import org.uberfire.ext.security.management.client.widgets.popup.ErrorBoxView;
import org.uberfire.ext.widgets.common.client.CommonsEntryPoint;
import org.uberfire.ext.widgets.common.client.ace.AceEditor;
import org.uberfire.ext.widgets.common.client.breadcrumbs.UberfireBreadcrumbs;
import org.uberfire.ext.widgets.common.client.breadcrumbs.UberfireBreadcrumbsView;
import org.uberfire.ext.widgets.common.client.breadcrumbs.header.UberfireBreadcrumbsContainerImpl;
import org.uberfire.ext.widgets.common.client.breadcrumbs.widget.DefaultBreadcrumbsPresenter;
import org.uberfire.ext.widgets.common.client.breadcrumbs.widget.DefaultBreadcrumbsView;
import org.uberfire.ext.widgets.common.client.common.BusyIndicatorView;
import org.uberfire.ext.widgets.common.client.dropdown.LiveSearchDropDown;
import org.uberfire.ext.widgets.common.client.dropdown.LiveSearchDropDownView;
import org.uberfire.ext.widgets.common.client.dropdown.PerspectiveDropDown;
import org.uberfire.ext.widgets.common.client.dropdown.footer.LiveSearchFooter;
import org.uberfire.ext.widgets.common.client.dropdown.footer.LiveSearchFooterViewImpl;
import org.uberfire.ext.widgets.common.client.dropdown.items.LiveSearchSelectorDropDownItem;
import org.uberfire.ext.widgets.common.client.dropdown.items.LiveSearchSelectorDropDownItemViewImpl;
import org.uberfire.ext.widgets.common.client.dropdown.noItems.NoItemsComponent;
import org.uberfire.ext.widgets.common.client.dropdown.noItems.NoItemsComponentViewImpl;
import org.uberfire.ext.widgets.common.client.menu.MenuItemDividerView;
import org.uberfire.ext.widgets.common.client.menu.MenuItemFactory;
import org.uberfire.ext.widgets.common.client.menu.MenuItemHeaderView;
import org.uberfire.ext.widgets.common.client.menu.MenuItemWithIconView;
import org.uberfire.ext.widgets.common.client.select.SelectComponent;
import org.uberfire.ext.widgets.common.client.select.SelectOptionComponent;
import org.uberfire.ext.widgets.common.client.select.SelectOptionView;
import org.uberfire.ext.widgets.common.client.select.SelectView;
import org.uberfire.ext.widgets.common.client.tables.FilterPagedTable;
import org.uberfire.ext.widgets.common.client.tables.PagedTable;
import org.uberfire.ext.widgets.common.client.tables.SimpleTable;
import org.uberfire.ext.widgets.common.client.tables.popup.NewFilterPopup;
import org.uberfire.ext.widgets.common.client.tables.popup.NewTabFilterPopup;
import org.uberfire.ext.widgets.core.client.CoreEntryPoint;
import org.uberfire.ext.widgets.core.client.editors.defaulteditor.DefaultEditorNewFileUpload;
import org.uberfire.ext.widgets.core.client.editors.defaulteditor.DefaultFileEditorPresenter;
import org.uberfire.ext.widgets.core.client.editors.defaulteditor.DefaultFileEditorPresenterActivity;
import org.uberfire.ext.widgets.core.client.editors.defaulteditor.DefaultFileEditorView;
import org.uberfire.ext.widgets.core.client.editors.metafile.MetaFileEditorPresenter;
import org.uberfire.ext.widgets.core.client.editors.metafile.MetaFileEditorPresenterActivity;
import org.uberfire.ext.widgets.core.client.editors.texteditor.TextEditorView;
import org.uberfire.ext.widgets.core.client.editors.texteditor.TextEditorWorkbenchEditor;
import org.uberfire.ext.widgets.core.client.editors.texteditor.TextEditorWorkbenchEditorActivity;
import org.uberfire.ext.widgets.core.client.editors.texteditor.TextResourceType;
import org.uberfire.ext.widgets.core.client.screens.iframe.IFrameScreenPresenter;
import org.uberfire.ext.widgets.core.client.screens.iframe.IFrameScreenPresenterActivity;
import org.uberfire.ext.widgets.core.client.screens.iframe.IFrameScreenView;
import org.uberfire.ext.widgets.core.client.wizards.WizardPageTitle;
import org.uberfire.ext.widgets.core.client.wizards.WizardViewImpl;
import org.uberfire.ext.widgets.core.client.workbench.widgets.popups.activities.notfound.ActivityNotFoundPresenter;
import org.uberfire.ext.widgets.core.client.workbench.widgets.popups.activities.notfound.ActivityNotFoundPresenterActivity;
import org.uberfire.ext.widgets.core.client.workbench.widgets.popups.activities.notfound.ActivityNotFoundView;
import org.uberfire.ext.widgets.table.client.TableEntryPoint;
import org.uberfire.ext.wires.core.client.actions.ActionsGroup;
import org.uberfire.ext.wires.core.client.actions.ActionsScreen;
import org.uberfire.ext.wires.core.client.actions.ActionsScreenActivity;
import org.uberfire.ext.wires.core.client.actions.StencilActionBuilder;
import org.uberfire.ext.wires.core.client.canvas.WiresCanvas;
import org.uberfire.ext.wires.core.client.factories.ShapeFactoryCache;
import org.uberfire.ext.wires.core.client.layers.LayersGroup;
import org.uberfire.ext.wires.core.client.layers.LayersScreen;
import org.uberfire.ext.wires.core.client.layers.LayersScreenActivity;
import org.uberfire.ext.wires.core.client.layers.StencilLayerBuilder;
import org.uberfire.ext.wires.core.client.palette.ConnectorsGroup;
import org.uberfire.ext.wires.core.client.palette.ContainersGroup;
import org.uberfire.ext.wires.core.client.palette.FixedShapesGroup;
import org.uberfire.ext.wires.core.client.palette.PaletteScreen;
import org.uberfire.ext.wires.core.client.palette.PaletteScreenActivity;
import org.uberfire.ext.wires.core.client.palette.ShapesGroup;
import org.uberfire.ext.wires.core.client.palette.StencilPaletteBuilder;
import org.uberfire.ext.wires.core.client.properties.DoubleValidator;
import org.uberfire.ext.wires.core.client.properties.PropertiesScreen;
import org.uberfire.ext.wires.core.client.properties.PropertiesScreenActivity;
import org.uberfire.ext.wires.core.client.properties.PropertyEditorAdaptorsCache;
import org.uberfire.ext.wires.core.trees.client.canvas.WiresTreesScreen;
import org.uberfire.ext.wires.core.trees.client.canvas.WiresTreesScreenActivity;
import org.uberfire.ext.wires.core.trees.client.layout.WiresTreesDefaultLayout;
import org.uberfire.mvp.Command;
import org.uberfire.mvp.PlaceRequest;
import org.uberfire.mvp.impl.ExternalPathPlaceRequest;
import org.uberfire.preferences.client.scope.ClientUsernameProvider;
import org.uberfire.preferences.client.scope.PreferenceScopeResolutionStrategyIOCProvider;
import org.uberfire.preferences.client.store.PreferenceBeanStoreImpl;
import org.uberfire.preferences.client.store.PreferenceStore;
import org.uberfire.preferences.client.store.PreferenceStoreIOCProvider;
import org.uberfire.preferences.shared.PreferenceScopeResolutionStrategy;
import org.uberfire.preferences.shared.PreferenceScopeTypes;
import org.uberfire.preferences.shared.bean.mock.PortablePreferenceMockBeanGeneratedImpl;
import org.uberfire.preferences.shared.impl.DefaultPreferenceScopeTypes;
import org.uberfire.preferences.shared.impl.PreferenceScopeFactoryImpl;
import org.uberfire.preferences.shared.impl.PreferenceScopeTypesProducer;
import org.uberfire.preferences.shared.impl.PreferenceScopeValidatorImpl;
import org.uberfire.rpc.SessionInfo;
import org.uberfire.security.Resource;
import org.uberfire.security.ResourceAction;
import org.uberfire.security.ResourceType;
import org.uberfire.security.authz.ResourceActionRef;
import org.uberfire.security.authz.RuntimeResource;
import org.uberfire.security.client.SecurityEntryPoint;
import org.uberfire.security.client.authz.AuthorizationManagerHelper;
import org.uberfire.security.client.authz.tree.impl.DefaultPermissionTreeFactory;
import org.uberfire.security.impl.authz.DefaultAuthorizationManager;
import org.uberfire.security.impl.authz.DefaultPermissionManager;
import org.uberfire.security.impl.authz.DefaultPermissionTypeRegistry;
import org.uberfire.ssh.client.SSHClientEntryPoint;
import org.uberfire.ssh.client.editor.SSHKeysEditorPerspective;
import org.uberfire.ssh.client.editor.SSHKeysEditorPerspectiveActivity;
import org.uberfire.ssh.client.editor.SSHKeysEditorScreen;
import org.uberfire.ssh.client.editor.SSHKeysEditorScreenActivity;
import org.uberfire.ssh.client.editor.component.SSHKeysEditor;
import org.uberfire.ssh.client.editor.component.SSHKeysEditorViewImpl;
import org.uberfire.ssh.client.editor.component.creation.NewSSHKeyModal;
import org.uberfire.ssh.client.editor.component.creation.NewSSHKeyModalViewImpl;
import org.uberfire.ssh.client.editor.component.empty.SSHKeysEditorEmptyStateDisplayer;
import org.uberfire.ssh.client.editor.component.empty.SSHKeysEditorEmptyStateDisplayerViewImpl;
import org.uberfire.ssh.client.editor.component.keys.SSHKeysDisplayer;
import org.uberfire.ssh.client.editor.component.keys.SSHKeysDisplayerViewImpl;
import org.uberfire.ssh.client.editor.component.keys.key.SSHKeyEditor;
import org.uberfire.ssh.client.editor.component.keys.key.SSHKeyEditorViewImpl;
import org.uberfire.workbench.category.Others;
import org.uberfire.workbench.category.Undefined;
import org.uberfire.workbench.model.ActivityResourceType;
import org.uberfire.workbench.model.CompassPosition;
import org.uberfire.workbench.model.ContextDefinition;
import org.uberfire.workbench.model.ContextDisplayMode;
import org.uberfire.workbench.model.CustomPanelDefinition;
import org.uberfire.workbench.model.PanelDefinition;
import org.uberfire.workbench.model.PartDefinition;
import org.uberfire.workbench.model.PerspectiveDefinition;
import org.uberfire.workbench.model.Position;
import org.uberfire.workbench.model.impl.PanelDefinitionImpl;
import org.uberfire.workbench.model.menu.HasEnabledStateChangeListeners;
import org.uberfire.workbench.model.menu.MenuCustom;
import org.uberfire.workbench.model.menu.MenuGroup;
import org.uberfire.workbench.model.menu.MenuItem;
import org.uberfire.workbench.model.menu.MenuItemCommand;
import org.uberfire.workbench.model.menu.MenuItemPerspective;
import org.uberfire.workbench.model.menu.MenuItemPlain;
import org.uberfire.workbench.model.menu.MenuPosition;
import org.uberfire.workbench.model.menu.MenuVisitor;
import org.uberfire.workbench.model.menu.Menus;
import org.uberfire.workbench.model.menu.impl.DefaultMenuGroup;
import org.uberfire.workbench.model.menu.impl.DefaultMenus;
import org.uberfire.workbench.model.toolbar.ToolBar;
import org.uberfire.workbench.model.toolbar.ToolBarIcon;
import org.uberfire.workbench.model.toolbar.ToolBarItem;
import org.uberfire.workbench.type.ResourceTypeDefinition;

public class BootstrapperImpl implements Bootstrapper {
  {
    addLookups_0();
    new CDI().initLookupTable(CDIEventTypeLookup.get());
    new DataBindingModuleBootstrapper().run();
  }

  private ContextManager contextManager = new ContextManagerImpl();
  private static final Logger logger = LoggerFactory.getLogger(Bootstrapper.class);
  public abstract class Type_factory__o_g_m_c_c_MessageConsoleScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<MessageConsoleScreen> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_h_GuidedDecisionTableOptions__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDecisionTableOptions> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_GroupsExplorer__quals__j_e_i_Any_j_e_i_Default extends Factory<GroupsExplorer> { }
  public abstract class Type_factory__o_k_w_c_w_c_e_DefaultWorkbenchErrorCallback__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultWorkbenchErrorCallback> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_o_p_OrganizationalUnitPopUpPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<OrganizationalUnitPopUpPresenter> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_CheckboxInput__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<CheckboxInput> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_ActionWorkItemSetFieldPlugin__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionWorkItemSetFieldPlugin> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_ChangePasswordView__quals__j_e_i_Any_j_e_i_Default extends Factory<ChangePasswordView> { }
  public abstract class Type_factory__o_o_w_s_s_c_e_SolverEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<SolverEditorPresenterActivity> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_w_e_e_ExampleProjectOkView__quals__j_e_i_Any_j_e_i_Default extends Factory<ExampleProjectOkView> { }
  public abstract class Type_factory__o_d_d_c_w_DisplayerEditorStatus__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerEditorStatus> { }
  public abstract class Type_factory__o_o_w_s_s_c_e_SolverEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<SolverEditorViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_a_SearchAnnotationPage__quals__j_e_i_Any_j_e_i_Default extends Factory<SearchAnnotationPage> { }
  public abstract class Type_factory__o_d_w_s_t_c_p_a_AuditTable__quals__j_e_i_Any_j_e_i_Default extends Factory<AuditTable> { }
  public abstract class Type_factory__o_d_w_s_g_t_c_e_GuidedRuleTemplateDataViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedRuleTemplateDataViewImpl> { }
  public abstract class ExtensionProvided_factory__o_g_e_t_c_u_ToggleSwitch__quals__j_e_i_Any_j_e_i_Default extends Factory<ToggleSwitch> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_ColumnExpansionPageViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnExpansionPageViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_e_ServerEmptyView__quals__j_e_i_Any_j_e_i_Default extends Factory<ServerEmptyView> { }
  public abstract class ContextualProvider_factory__o_j_e_u_n_c_l_TransitionAnchorFactory__quals__Universal extends Factory<TransitionAnchorFactory> { }
  public abstract class Type_factory__o_d_c_w_d_e_DataSetDefColumnsFilterEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefColumnsFilterEditorView> { }
  public abstract class Type_factory__o_u_c_w_Workbench__quals__j_e_i_Any_j_e_i_Default extends Factory<Workbench> { }
  public abstract class Type_factory__o_d_w_s_w_c_e_WorkItemsEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkItemsEditorViewImpl> { }
  public abstract class Type_factory__o_d_w_s_w_c_e_WorkItemsEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<WorkItemsEditorPresenterActivity> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_w_e_ExampleProjectWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<ExampleProjectWidget> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_r_RoleEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<RoleEditor> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDataObjectEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<AdvancedDataObjectEditor> { }
  public abstract class Type_factory__o_u_c_w_p_i_MultiListWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<MultiListWorkbenchPanelPresenter> { }
  public abstract class JsType_factory__o_u_s_ResourceType__quals__Universal extends Factory<ResourceType> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_l_EntitiesListView__quals__j_e_i_Any_j_e_i_Default extends Factory<EntitiesListView> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_d_EnhancedDependenciesManager__quals__j_e_i_Any_j_e_i_Default extends Factory<EnhancedDependenciesManager> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_u_d_KieDropdownElement_ItemElement__quals__j_e_i_Any_j_e_i_Default extends Factory<ItemElement> { }
  public abstract class Type_factory__o_u_c_m_ActivityBeansInfo__quals__j_e_i_Any_j_e_i_Default extends Factory<ActivityBeansInfo> { }
  public abstract class Type_factory__o_d_c_w_d_e_w_c_SQLDataSetBasicAttributesWorkflow__quals__j_e_i_Any_j_e_i_Default extends Factory<SQLDataSetBasicAttributesWorkflow> { }
  public abstract class Type_factory__o_o_w_s_g_c_p_MediumConstraintMatchRuleModellerActionPlugin__quals__j_e_i_Any_j_e_i_Default extends Factory<MediumConstraintMatchRuleModellerActionPlugin> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_g_GroupEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<GroupEditorView> { }
  public abstract class Type_factory__o_u_c_w_p_u_p_UnanchoredWorkbenchPartView__quals__j_e_i_Any_j_e_i_Default extends Factory<UnanchoredWorkbenchPartView> { }
  public abstract class Type_factory__o_o_w_s_d_c_w_p_DataObjectFieldPickerItemViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DataObjectFieldPickerItemViewImpl> { }
  public abstract class Type_factory__o_u_e_c_d_c_DisabledFeatureComponentViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DisabledFeatureComponentViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_OrgUnitsMetricsScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<OrgUnitsMetricsScreen> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_ColumnExpansionPage__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnExpansionPage> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_TextBox__quals__j_e_i_Any_j_e_i_Default extends Factory<TextBox> { }
  public abstract class Type_factory__o_d_c_c_e_m_MapEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<MapEditorView> { }
  public abstract class Type_factory__o_u_c_v_p_w_Select__quals__j_e_i_Any_j_e_i_Default extends Factory<Select> { }
  public abstract class Type_factory__o_k_w_c_w_c_p_c_CopyPopupWithPackageView__quals__j_e_i_Any_j_e_i_Default extends Factory<CopyPopupWithPackageView> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_n_BreadcrumbNavigator__quals__j_e_i_Any_j_e_i_Default extends Factory<BreadcrumbNavigator> { }
  public abstract class Type_factory__o_u_e_p_c_a_AdminPagePresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<AdminPagePresenterActivity> { }
  public abstract class Type_factory__o_o_w_s_s_c_e_TerminationConfigForm__quals__j_e_i_Any_j_e_i_Default extends Factory<TerminationConfigForm> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_e_GuvnorDefaultEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<GuvnorDefaultEditorViewImpl> { }
  public abstract class JsType_factory__e_d_PopStateEvent_PopStateEventEventInitDictType__quals__Universal extends Factory<PopStateEventEventInitDictType> { }
  public abstract class Type_factory__o_u_c_v_p_w_ErrorPopupView__quals__j_e_i_Any_j_e_i_Default extends Factory<ErrorPopupView> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_n_MultiplePermissionNodeViewerView__quals__j_e_i_Any_j_e_i_Default extends Factory<MultiplePermissionNodeViewerView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_d_ActionSetFieldCol52DefinitionBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionSetFieldCol52DefinitionBuilder> { }
  public abstract class Type_factory__o_d_c_c_l_e_PerspectiveDragConfigModalView__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectiveDragConfigModalView> { }
  public abstract class Type_factory__o_d_w_s_d_c_e_DSLEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DSLEditorViewImpl> { }
  public abstract class Type_factory__o_o_w_s_s_c_e_LocalSearchForm__quals__j_e_i_Any_j_e_i_Default extends Factory<LocalSearchForm> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_d_DroolsDomainScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<DroolsDomainScreenActivity> { }
  public abstract class Type_factory__o_u_e_p_c_e_EditorPlugInEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<EditorPlugInEditorPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_k_KnowledgeBasesPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<KnowledgeBasesPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_a_ValuePairEditorPage__quals__j_e_i_Any_j_e_i_Default extends Factory<ValuePairEditorPage> { }
  public abstract class Type_factory__o_d_w_s_g_s_c_e_GuidedScoreCardEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedScoreCardEditorPresenter> { }
  public abstract class Type_factory__o_g_m_c_c_AlertsEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<AlertsEntryPoint> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_MetaDataColumnPage__quals__j_e_i_Any_j_e_i_Default extends Factory<MetaDataColumnPage> { }
  public abstract class Type_factory__o_k_w_c_w_c_c_w_b_ImportsWidgetViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ImportsWidgetViewImpl> { }
  public abstract class Type_factory__o_d_r_g_c_GoogleTableDisplayerView__quals__j_e_i_Any_j_e_i_Default extends Factory<GoogleTableDisplayerView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_p_a_GuidedDecisionTableAccordionItem__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDecisionTableAccordionItem> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_g_w_GroupEditorWorkflow__quals__j_e_i_Any_j_e_i_Default extends Factory<GroupEditorWorkflow> { }
  public abstract class Type_factory__o_k_w_c_s_d_s_PackageNameWhiteListResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<PackageNameWhiteListResourceTypeDefinition> { }
  public abstract class JsType_factory__o_u_w_m_m_MenuGroup__quals__Universal extends Factory<MenuGroup> { }
  public abstract class Type_factory__o_k_w_c_w_c_m_WorkbenchConfigurationMenuBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchConfigurationMenuBuilder> { }
  public abstract class Type_factory__o_d_r_g_c_GoogleBarChartDisplayer__quals__j_e_i_Any_j_e_i_Default extends Factory<GoogleBarChartDisplayer> { }
  public abstract class Type_factory__o_g_m_c_c_w_b_AlertsButtonMenuItemBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<AlertsButtonMenuItemBuilder> { }
  public abstract class Type_factory__o_d_w_s_g_t_c_t_GuidedRuleTemplateResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedRuleTemplateResourceType> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_Container__quals__j_e_i_Any_j_e_i_Default extends Factory<Container> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_ProjectConfigScreenEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectConfigScreenEntryPoint> { }
  public abstract class Type_factory__o_d_c_n_w_NavTilesWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<NavTilesWidget> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_PriorityDropDown__quals__j_e_i_Any_j_e_i_Default extends Factory<PriorityDropDown> { }
  public abstract class Type_factory__o_d_d_e_c_s_DataSetDefEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<DataSetDefEditorPresenterActivity> { }
  public abstract class ContextualProvider_factory__j_e_e_Event__quals__Universal extends Factory<Event> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_v_ValidationItemPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ValidationItemPresenter> { }
  public abstract class Type_factory__o_g_c_s_p_c_r_ConflictingRepositoriesPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<ConflictingRepositoriesPopup> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_n_PermissionWidgetFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<PermissionWidgetFactory> { }
  public abstract class Type_factory__o_u_e_w_c_c_p_PropertyEditorAdaptorsCache__quals__j_e_i_Any_j_e_i_Default extends Factory<PropertyEditorAdaptorsCache> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_ListBox__quals__j_e_i_Any_j_e_i_Default extends Factory<ListBox> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_u_w_UserCreationWorkflow__quals__j_e_i_Any_j_e_i_Default extends Factory<UserCreationWorkflow> { }
  public abstract class Type_factory__o_g_c_s_p_c_POMEditorPanelViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<POMEditorPanelViewImpl> { }
  public abstract class Type_factory__o_u_w_c_Others__quals__j_e_i_Any_j_e_i_Default extends Factory<Others> { }
  public abstract class Type_factory__o_j_e_c_c_d_e_Elemental2DomUtil__quals__j_e_i_Any_j_e_i_Default extends Factory<Elemental2DomUtil> { }
  public abstract class Type_factory__o_g_s_c_e_c_GuvnorStructureContext__quals__j_e_i_Any_j_e_i_Default extends Factory<GuvnorStructureContext> { }
  public abstract class Type_factory__o_d_d_c_w_DisplayerTypeSelector__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerTypeSelector> { }
  public abstract class Type_factory__o_u_e_e_c_c_h_VersionRecordManager__quals__j_e_i_Any_j_e_i_Default extends Factory<VersionRecordManager> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_a_InvalidProjectScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<InvalidProjectScreen> { }
  public abstract class Type_factory__o_u_c_w_WorkbenchServicesProxyClientImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchServicesProxyClientImpl> { }
  public abstract class Type_factory__o_d_c_c_e_ValueBoxEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<ValueBoxEditorView> { }
  public abstract class Type_factory__o_u_c_w_p_i_StaticWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<StaticWorkbenchPanelPresenter> { }
  public abstract class Type_factory__o_d_d_c_w_f_MultipleNumberParameterEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<MultipleNumberParameterEditorView> { }
  public abstract class Type_factory__o_k_w_c_w_c_h_w_c_ConfigurationComboBoxItemWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<ConfigurationComboBoxItemWidget> { }
  public abstract class Type_factory__o_o_w_s_d_c_w_p_DataObjectFieldPickerItem__quals__j_e_i_Any_j_e_i_Default extends Factory<DataObjectFieldPickerItem> { }
  public abstract class Type_factory__o_u_c_v_p_w_Button__quals__j_e_i_Any_j_e_i_Default extends Factory<Button> { }
  public abstract class Type_factory__o_u_e_w_t_c_TableEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<TableEntryPoint> { }
  public abstract class Type_factory__o_u_e_w_c_c_e_d_DefaultFileEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultFileEditorPresenter> { }
  public abstract class Type_factory__o_d_w_s_g_c_GlobalsEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<GlobalsEditorEntryPoint> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_v_ValuePairEditorProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<ValuePairEditorProvider> { }
  public abstract class ExtensionProvided_factory__o_k_w_c_w_c_c_w_b_AddImportPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<AddImportPopup> { }
  public abstract class JsType_factory__o_u_w_m_t_ToolBarIcon__quals__Universal extends Factory<ToolBarIcon> { }
  public abstract class Type_factory__o_u_e_p_c_p_e_g_PerspectiveEditorGenerator__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectiveEditorGenerator> { }
  public abstract class JsType_factory__o_u_c_m_LockManager__quals__Universal extends Factory<LockManager> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_NumberInput__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<NumberInput> { }
  public abstract class Type_factory__o_d_w_s_s_c_e_ScoreCardXLSEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ScoreCardXLSEditorViewImpl> { }
  public abstract class Provider_factory__o_j_e_c_c_a_BatchCaller__quals__j_e_i_Any_j_e_i_Default extends Factory<BatchCaller> { }
  public abstract class Type_factory__o_k_w_c_s_h_c_w_h_HomeView__quals__j_e_i_Any_j_e_i_Default extends Factory<HomeView> { }
  public abstract class Type_factory__o_u_c_w_p_i_SimpleWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<SimpleWorkbenchPanelPresenter> { }
  public abstract class Type_factory__o_d_r_g_c_GoogleBubbleChartDisplayerView__quals__j_e_i_Any_j_e_i_Default extends Factory<GoogleBubbleChartDisplayerView> { }
  public abstract class Type_factory__o_g_s_c_s_OrganizationalUnitTreeProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<OrganizationalUnitTreeProvider> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_OperatorPageView__quals__j_e_i_Any_j_e_i_Default extends Factory<OperatorPageView> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_b_n_NotificationPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<NotificationPresenter> { }
  public abstract class Type_factory__o_d_c_c_e_l_DropDownImageListEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DropDownImageListEditor> { }
  public abstract class Type_factory__o_u_c_v_p_w_FormLabel__quals__j_e_i_Any_j_e_i_Default extends Factory<FormLabel> { }
  public abstract class Type_factory__o_u_e_w_c_c_e_t_TextEditorWorkbenchEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<TextEditorWorkbenchEditor> { }
  public abstract class Type_factory__o_d_c_c_s_e_NavigationExplorerScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<NavigationExplorerScreen> { }
  public abstract class Type_factory__o_u_e_l_e_c_LayoutComponentPaletteScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<LayoutComponentPaletteScreen> { }
  public abstract class Type_factory__o_k_w_c_s_c_c_s_ContributorsScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<ContributorsScreen> { }
  public abstract class Type_factory__o_d_r_g_c_GooglePieChartDisplayer__quals__j_e_i_Any_j_e_i_Default extends Factory<GooglePieChartDisplayer> { }
  public abstract class Type_factory__o_d_r_c_s_SelectorLabelItemView__quals__j_e_i_Any_j_e_i_Default extends Factory<SelectorLabelItemView> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_u_PomEditorActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<PomEditorActivity> { }
  public abstract class Type_factory__o_u_e_p_c_p_e_l_e_HTMLLayoutDragComponent__quals__j_e_i_Any_j_e_i_Default extends Factory<HTMLLayoutDragComponent> { }
  public abstract class Type_factory__o_d_c_w_d_e_c_DataSetDefColumnsEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefColumnsEditor> { }
  public abstract class Type_factory__o_u_e_w_c_c_c_WiresCanvas__quals__j_e_i_Any_j_e_i_Default extends Factory<WiresCanvas> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_ExamplesWizard__quals__j_e_i_Any_j_e_i_Default extends Factory<ExamplesWizard> { }
  public abstract class Type_factory__o_u_s_i_a_DefaultPermissionManager__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultPermissionManager> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_p_c_CloseUnsavedProjectAssetsPopUpPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<CloseUnsavedProjectAssetsPopUpPresenter> { }
  public abstract class Type_factory__o_u_e_p_e_c_f_BooleanField__quals__j_e_i_Any_j_e_i_Default extends Factory<BooleanField> { }
  public abstract class Type_factory__o_j_e_u_n_c_l_Navigation__quals__j_e_i_Any_j_e_i_Default extends Factory<Navigation> { }
  public abstract class JsType_factory__o_u_w_m_m_MenuPosition__quals__Universal extends Factory<MenuPosition> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_f_ActionInsertNodeFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionInsertNodeFactory> { }
  public abstract class Type_factory__o_d_w_s_s_t_ScoreCardXLSResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset extends Factory<ScoreCardXLSResourceTypeDefinition> { }
  public abstract class Type_factory__o_u_e_w_c_c_w_w_p_a_n_ActivityNotFoundPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ActivityNotFoundPresenterActivity> { }
  public abstract class Type_factory__o_u_c_v_p_m_m_WorkbenchMegaMenuView__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchMegaMenuView> { }
  public abstract class Type_factory__o_u_c_v_p_m_MultiScreenMenuBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<MultiScreenMenuBuilder> { }
  public abstract class Type_factory__o_u_e_w_c_c_s_SelectOptionView__quals__j_e_i_Any_j_e_i_Default extends Factory<SelectOptionView> { }
  public abstract class Producer_factory__o_d_c_w_d_e_d_DataColumnDefDriver__quals__j_e_i_Any_j_e_i_Default extends Factory<DataColumnDefDriver> { }
  public abstract class Type_factory__o_d_c_w_d_e_s_SQLDataSetEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<SQLDataSetEditor> { }
  public abstract class Type_factory__o_u_c_v_p_PatternFlyEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<PatternFlyEntryPoint> { }
  public abstract class Type_factory__o_u_c_v_p_m_WorkbenchMenuStandardNavBarView__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchMenuStandardNavBarView> { }
  public abstract class Type_factory__o_o_w_c_p_AdministrationPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<AdministrationPerspective> { }
  public abstract class Type_factory__o_j_e_s_c_l_c_SecurityContextImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<SecurityContextImpl> { }
  public abstract class Type_factory__o_d_d_c_ClientDataSetManager__quals__j_e_i_Any_j_e_i_Default extends Factory<ClientDataSetManager> { }
  public abstract class Type_factory__o_o_w_s_d_c_DomainEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<DomainEditorEntryPoint> { }
  public abstract class Type_factory__o_d_d_c_w_DisplayerHtmlEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerHtmlEditor> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_u_NewUserAttributeEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<NewUserAttributeEditorView> { }
  public abstract class Type_factory__o_d_d_e_c_s_DataSetDefWizardScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<DataSetDefWizardScreenActivity> { }
  public abstract class Type_factory__o_j_e_u_n_c_l_TransitionToRoleProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<TransitionToRoleProvider> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_ServerManagementPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ServerManagementPerspectiveActivity> { }
  public abstract class Producer_factory__o_d_c_w_d_e_d_BeanDataSetDefDriver__quals__j_e_i_Any_j_e_i_Default extends Factory<BeanDataSetDefDriver> { }
  public abstract class Type_factory__o_d_c_w_d_e_a_DataSetDefRefreshAttributesEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefRefreshAttributesEditorView> { }
  public abstract class Type_factory__o_d_d_c_w_f_TimeInstantEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<TimeInstantEditorView> { }
  public abstract class Producer_factory__o_d_c_w_d_e_d_ElasticSearchDataSetDefAttributesDriver__quals__j_e_i_Any_j_e_i_Default extends Factory<ElasticSearchDataSetDefAttributesDriver> { }
  public abstract class Type_factory__o_k_w_c_s_h_c_p_HomePerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<HomePerspective> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_m_EditMenuBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<EditMenuBuilder> { }
  public abstract class Type_factory__o_g_s_c_e_r_l_RepositoriesPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoriesPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_j_JPADataObjectFieldEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<JPADataObjectFieldEditor> { }
  public abstract class Type_factory__o_d_c_n_w_NavTabListWidgetView__quals__j_e_i_Any_j_e_i_Default extends Factory<NavTabListWidgetView> { }
  public abstract class Type_factory__o_k_w_c_s_l_a_p_LibraryInternalPreferencesBeanGeneratedImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<LibraryInternalPreferencesBeanGeneratedImpl> { }
  public abstract class Type_factory__o_g_m_c_e_MavenRepositoryPagedJarTable__quals__j_e_i_Any_j_e_i_Default extends Factory<MavenRepositoryPagedJarTable> { }
  public abstract class Type_factory__o_d_w_s_s_c_e_ScoreCardXLSEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ScoreCardXLSEditorPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_u_m_s_AddSingleValueModalView__quals__j_e_i_Any_j_e_i_Default extends Factory<AddSingleValueModalView> { }
  public abstract class Type_factory__o_d_c_c_l_e_PerspectiveDragComponent__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectiveDragComponent> { }
  public abstract class Type_factory__o_u_e_w_c_c_m_MenuItemHeaderView__quals__j_e_i_Any_o_u_e_w_c_c_m_MenuItemHeader extends Factory<MenuItemHeaderView> { }
  public abstract class Type_factory__o_u_c_w_DefaultBeanFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultBeanFactory> { }
  public abstract class Type_factory__o_d_c_w_c_LoadingBoxView__quals__j_e_i_Any_j_e_i_Default extends Factory<LoadingBoxView> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_PopulatedLibraryView__quals__j_e_i_Any_j_e_i_Default extends Factory<PopulatedLibraryView> { }
  public abstract class Type_factory__o_d_d_c_w_g_ColumnDetailsEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnDetailsEditor> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_p_SelectDocumentPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<SelectDocumentPopup> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_g_w_GroupCreationWorkflow__quals__j_e_i_Any_j_e_i_Default extends Factory<GroupCreationWorkflow> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_n_PermissionExceptionSwitchView__quals__j_e_i_Any_j_e_i_Default extends Factory<PermissionExceptionSwitchView> { }
  public abstract class Type_factory__o_u_e_w_c_c_p_PropertiesScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<PropertiesScreenActivity> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_d_LimitedEntryActionRetractFactCol52DefinitionBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<LimitedEntryActionRetractFactCol52DefinitionBuilder> { }
  public abstract class Type_factory__o_o_w_s_g_c_p_HardConstraintMatchRuleModellerActionPlugin__quals__j_e_i_Any_j_e_i_Default extends Factory<HardConstraintMatchRuleModellerActionPlugin> { }
  public abstract class Type_factory__o_u_s_c_e_c_e_SSHKeysEditorEmptyStateDisplayer__quals__j_e_i_Any_j_e_i_Default extends Factory<SSHKeysEditorEmptyStateDisplayer> { }
  public abstract class Type_factory__o_d_w_s_d_c_t_DecisionTableXLSResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<DecisionTableXLSResourceType> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_AssignedEntitiesExplorerView__quals__j_e_i_Any_j_e_i_Default extends Factory<AssignedEntitiesExplorerView> { }
  public abstract class Type_factory__o_o_w_s_g_c_p_BendableHardConstraintMatchRuleModellerActionPlugin__quals__j_e_i_Any_j_e_i_Default extends Factory<BendableHardConstraintMatchRuleModellerActionPlugin> { }
  public abstract class Type_factory__o_g_c_s_p_c_s_ProjectController__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectController> { }
  public abstract class Type_factory__o_d_w_s_s_c_e_ScoreCardXLSEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<ScoreCardXLSEditorPresenterActivity> { }
  public abstract class Type_factory__o_k_w_c_w_c_h_PathLabel__quals__j_e_i_Any_j_e_i_Default extends Factory<PathLabel> { }
  public abstract class Type_factory__o_u_c_w_p_s_PartManager__quals__j_e_i_Any_j_e_i_Default extends Factory<PartManager> { }
  public abstract class Type_factory__o_u_w_c_Undefined__quals__j_e_i_Any_j_e_i_Default extends Factory<Undefined> { }
  public abstract class Type_factory__o_d_c_n_l_e_NavMenuBarDragComponent__quals__j_e_i_Any_j_e_i_Default extends Factory<NavMenuBarDragComponent> { }
  public abstract class Type_factory__o_d_c_w_d_e_a_DataSetDefRefreshIntervalEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefRefreshIntervalEditorView> { }
  public abstract class Type_factory__o_d_w_s_g_d_s_DefaultGuidedDecisionTableLinkManager__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultGuidedDecisionTableLinkManager> { }
  public abstract class Type_factory__o_d_d_e_c_s_DataSetAuthoringHomeView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetAuthoringHomeView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_m_RowContextMenuViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<RowContextMenuViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_p_p_PersistableDataObjectsItemPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<PersistableDataObjectsItemPresenter> { }
  public abstract class ContextualProvider_factory__o_j_e_u_n_c_l_TransitionTo__quals__Universal extends Factory<TransitionTo> { }
  public abstract class Type_factory__o_d_c_n_w_e_NavItemDefaultEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<NavItemDefaultEditor> { }
  public abstract class Type_factory__o_g_m_c_c_MessageConsoleScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<MessageConsoleScreenActivity> { }
  public abstract class Type_factory__o_d_r_g_c_GoogleBubbleChartDisplayer__quals__j_e_i_Any_j_e_i_Default extends Factory<GoogleBubbleChartDisplayer> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_a_PopulatedAssetsScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<PopulatedAssetsScreen> { }
  public abstract class Type_factory__o_g_s_c_e_r_e_RepositoryEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryEditorPresenter> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_w_ExternalLinkViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ExternalLinkViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_c_c_DeleteColumnManagementAnchorWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<DeleteColumnManagementAnchorWidget> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_m_NewPatternView__quals__j_e_i_Any_j_e_i_Default extends Factory<NewPatternView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_SummaryPageView__quals__j_e_i_Any_j_e_i_Default extends Factory<SummaryPageView> { }
  public abstract class Type_factory__o_g_s_c_StructureEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<StructureEntryPoint> { }
  public abstract class Type_factory__o_u_e_c_s_i_CDIClientFeatureDefRegistry__quals__j_e_i_Any_j_e_i_Default extends Factory<CDIClientFeatureDefRegistry> { }
  public abstract class Type_factory__o_d_w_s_e_c_e_EnumEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<EnumEditorViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_p_a_GuidedDecisionTableAccordion__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDecisionTableAccordion> { }
  public abstract class Type_factory__o_u_e_e_c_c_h_HtmlEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<HtmlEditor> { }
  public abstract class Type_factory__o_u_c_w_VFSLockServiceProxyClientImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<VFSLockServiceProxyClientImpl> { }
  public abstract class Type_factory__o_k_w_c_w_c_w_KSessionSelectorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<KSessionSelectorViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_o_d_DeleteOrganizationalUnitPopUpView__quals__j_e_i_Any_j_e_i_Default extends Factory<DeleteOrganizationalUnitPopUpView> { }
  public abstract class Type_factory__o_d_r_c_s_SelectorDropDownItemView__quals__j_e_i_Any_j_e_i_Default extends Factory<SelectorDropDownItemView> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_r_RemoteStatusPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<RemoteStatusPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDomainScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<AdvancedDomainScreen> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_ProjectImportsScreenPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<ProjectImportsScreenPresenterActivity> { }
  public abstract class Type_factory__o_k_w_c_w_c_p_l_AppLauncherView__quals__j_e_i_Any_j_e_i_Default extends Factory<AppLauncherView> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_o_c_t_ContributorsListView__quals__j_e_i_Any_j_e_i_Default extends Factory<ContributorsListView> { }
  public abstract class Type_factory__o_k_w_c_w_c_KieWorkbenchWidgetsCommonEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<KieWorkbenchWidgetsCommonEntryPoint> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_k_i_KnowledgeBaseItemPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<KnowledgeBaseItemPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_a_EmptyAssetsView__quals__j_e_i_Any_j_e_i_Default extends Factory<EmptyAssetsView> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_k_i_k_l_ListenerListItemPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ListenerListItemPresenter> { }
  public abstract class Type_factory__o_u_e_p_c_e_PluginExplorerScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<PluginExplorerScreen> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_a_a_AddAssetScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<AddAssetScreen> { }
  public abstract class Type_factory__o_u_c_v_p_m_PartContextMenusView__quals__j_e_i_Any_j_e_i_Default extends Factory<PartContextMenusView> { }
  public abstract class Type_factory__o_u_c_v_p_t_ResizeTabPanel__quals__j_e_i_Any_o_u_c_v_p_t_Resize extends Factory<ResizeTabPanel> { }
  public abstract class Type_factory__o_d_c_c_w_FilterLabelSet__quals__j_e_i_Any_j_e_i_Default extends Factory<FilterLabelSet> { }
  public abstract class Type_factory__o_o_w_c_p_M2RepoPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<M2RepoPerspectiveActivity> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_t_GuidedDTableResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDTableResourceType> { }
  public abstract class Type_factory__o_d_c_w_d_e_DataSetExplorerView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetExplorerView> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_p_NewPackagePopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<NewPackagePopupViewImpl> { }
  public abstract class Type_factory__o_d_w_s_s_c_t_ScoreCardXLSResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<ScoreCardXLSResourceType> { }
  public abstract class Type_factory__o_k_w_c_w_c_c_w_u_ImportsWidgetViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<org.kie.workbench.common.widgets.configresource.client.widget.unbound.ImportsWidgetViewImpl> { }
  public abstract class JsType_factory__o_u_w_m_PartDefinition__quals__Universal extends Factory<PartDefinition> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_NewContainerFormView__quals__j_e_i_Any_j_e_i_Default extends Factory<NewContainerFormView> { }
  public abstract class Type_factory__o_d_c_w_d_e_c_ColumnTypeEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnTypeEditor> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_p_c_CloseUnsavedProjectAssetsPopUpListItemView__quals__j_e_i_Any_j_e_i_Default extends Factory<CloseUnsavedProjectAssetsPopUpListItemView> { }
  public abstract class Type_factory__o_u_c_w_p_i_UnanchoredStaticWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<UnanchoredStaticWorkbenchPanelPresenter> { }
  public abstract class Type_factory__o_u_e_p_c_c_f_DefaultPreferenceForm__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultPreferenceForm> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_UnorderedList__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<UnorderedList> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_AttributeColumnConverter__quals__j_e_i_Any_j_e_i_Default extends Factory<AttributeColumnConverter> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_l_GroupsList__quals__j_e_i_Any_j_e_i_Default extends Factory<GroupsList> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_p_ProjectMetricsScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectMetricsScreen> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_o_OrganizationalUnitsView__quals__j_e_i_Any_j_e_i_Default extends Factory<OrganizationalUnitsView> { }
  public abstract class Type_factory__o_u_e_p_c_t_PerspectiveLayoutPluginResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectiveLayoutPluginResourceType> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_p_PersistenceView__quals__j_e_i_Any_j_e_i_Default extends Factory<PersistenceView> { }
  public abstract class Type_factory__o_d_r_c_s_SelectorDropDownDisplayer__quals__j_e_i_Any_j_e_i_Default extends Factory<SelectorDropDownDisplayer> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_a_EmptyAssetsScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<EmptyAssetsScreen> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_i_ImportProjectsScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ImportProjectsScreenActivity> { }
  public abstract class ExtensionProvided_factory__o_k_w_c_w_c_c_w_u_AddImportPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<org.kie.workbench.common.widgets.configresource.client.widget.unbound.AddImportPopup> { }
  public abstract class Type_factory__o_u_c_v_p_HTML5DndSeleniumSupport__quals__j_e_i_Any_j_e_i_Default extends Factory<HTML5DndSeleniumSupport> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_HelpBlock__quals__j_e_i_Any_j_e_i_Default extends Factory<HelpBlock> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_u_ResourceHandlerManager__quals__j_e_i_Any_j_e_i_Default extends Factory<ResourceHandlerManager> { }
  public abstract class Type_factory__o_d_d_c_w_f_TimeInstantEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<TimeInstantEditor> { }
  public abstract class Type_factory__o_o_w_s_s_c_e_ConstructionHeuristicForm__quals__j_e_i_Any_j_e_i_Default extends Factory<ConstructionHeuristicForm> { }
  public abstract class Type_factory__o_d_d_c_w_f_NumberParameterEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<NumberParameterEditor> { }
  public abstract class Type_factory__o_u_e_w_c_c_d_i_LiveSearchSelectorDropDownItemViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<LiveSearchSelectorDropDownItemViewImpl> { }
  public abstract class Type_factory__o_d_d_e_c_s_DataSetAuthoringHomePresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<DataSetAuthoringHomePresenterActivity> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_AttributeColumnPage__quals__j_e_i_Any_j_e_i_Default extends Factory<AttributeColumnPage> { }
  public abstract class Type_factory__o_u_e_s_m_c_e_g_GroupEditorDriver__quals__j_e_i_Any_j_e_i_Default extends Factory<GroupEditorDriver> { }
  public abstract class Type_factory__o_d_w_s_d_c_e_DRLEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DRLEditorPresenter> { }
  public abstract class Type_factory__o_g_c_s_p_c_GAVEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<GAVEditor> { }
  public abstract class Type_factory__o_k_w_c_w_c_m_AppLauncherMenuBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<AppLauncherMenuBuilder> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_p_NewPackagePopup__quals__j_e_i_Any_j_e_i_Default extends Factory<NewPackagePopup> { }
  public abstract class Type_factory__o_o_w_s_g_c_p_MultiConstraintBendableMatchRuleModellerActionPlugin__quals__j_e_i_Any_j_e_i_Default extends Factory<MultiConstraintBendableMatchRuleModellerActionPlugin> { }
  public abstract class Type_factory__o_u_e_p_c_e_SplashEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<SplashEditorView> { }
  public abstract class Type_factory__o_u_c_v_p_m_WorkbenchViewModeSwitcherView__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchViewModeSwitcherView> { }
  public abstract class Type_factory__o_u_c_a_PerspectiveTreeProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectiveTreeProvider> { }
  public abstract class Type_factory__o_u_c_w_w_m_PartContextMenusPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<PartContextMenusPresenter> { }
  public abstract class Type_factory__o_d_r_c_s_SelectorLabelSetDisplayer__quals__j_e_i_Any_j_e_i_Default extends Factory<SelectorLabelSetDisplayer> { }
  public abstract class Type_factory__o_d_w_s_w_c_h_NewWorkItemHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewWorkItemHandler> { }
  public abstract class Type_factory__o_d_c_n_w_e_TargetPerspectiveEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<TargetPerspectiveEditor> { }
  public abstract class Type_factory__o_d_w_s_g_c_e_AddGlobalPopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<AddGlobalPopupViewImpl> { }
  public abstract class Type_factory__o_d_d_c_w_g_DataSetGroupDateEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetGroupDateEditor> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_KieEditorWrapperViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<KieEditorWrapperViewImpl> { }
  public abstract class Type_factory__o_u_e_w_c_c_b_UberfireBreadcrumbsView__quals__j_e_i_Any_j_e_i_Default extends Factory<UberfireBreadcrumbsView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_NewGuidedDecisionTableColumnWizard__quals__j_e_i_Any_j_e_i_Default extends Factory<NewGuidedDecisionTableColumnWizard> { }
  public abstract class Type_factory__o_u_s_c_e_c_SSHKeysEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<SSHKeysEditor> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_FieldPage__quals__j_e_i_Any_j_e_i_Default extends Factory<FieldPage> { }
  public abstract class Type_factory__o_d_w_s_g_d_t_GuidedDTreeResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset extends Factory<GuidedDTreeResourceTypeDefinition> { }
  public abstract class Type_factory__o_d_d_c_w_g_ColumnDetailsEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnDetailsEditorView> { }
  public abstract class Type_factory__o_u_e_w_c_c_p_FixedShapesGroup__quals__j_e_i_Any_j_e_i_Default extends Factory<FixedShapesGroup> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_ACLEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<ACLEditor> { }
  public abstract class Type_factory__o_u_e_p_c_t_ScreenPluginResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<ScreenPluginResourceType> { }
  public abstract class Type_factory__o_u_e_l_e_c_g_BootstrapLayoutGenerator__quals__j_e_i_Any_j_e_i_Default extends Factory<BootstrapLayoutGenerator> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_d_NewDependencyPopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<NewDependencyPopupViewImpl> { }
  public abstract class Type_factory__o_d_c_c_w_FilterLabel__quals__j_e_i_Any_j_e_i_Default extends Factory<FilterLabel> { }
  public abstract class Type_factory__o_u_e_p_c_v_PluginNameValidator__quals__j_e_i_Any_j_e_i_Default extends Factory<PluginNameValidator> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_u_d_KieDropdownElementView__quals__j_e_i_Any_j_e_i_Default extends Factory<KieDropdownElementView> { }
  public abstract class Type_factory__o_k_w_c_w_c_h_NewResourceViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<NewResourceViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_h_c_w_s_ShortcutPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ShortcutPresenter> { }
  public abstract class Type_factory__o_k_w_c_w_c_p_l_AppLauncherItemView__quals__j_e_i_Any_j_e_i_Default extends Factory<AppLauncherItemView> { }
  public abstract class Type_factory__o_k_w_c_s_h_c_w_s_u_ShortcutHelper__quals__j_e_i_Any_j_e_i_Default extends Factory<ShortcutHelper> { }
  public abstract class Type_factory__o_u_c_v_p_w_FormGroup__quals__j_e_i_Any_j_e_i_Default extends Factory<FormGroup> { }
  public abstract class Type_factory__o_u_e_p_c_c_s_PreferencesRootScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<PreferencesRootScreen> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_d_DependencyLoader__quals__j_e_i_Any_j_e_i_Default extends Factory<DependencyLoader> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_p_b_d_DeleteBranchPopUpScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<DeleteBranchPopUpScreen> { }
  public abstract class Type_factory__o_u_e_p_c_c_t_TreeHierarchyStructureView__quals__j_e_i_Any_j_e_i_Default extends Factory<TreeHierarchyStructureView> { }
  public abstract class Type_factory__o_j_e_s_c_l_c_DefaultRestSecurityErrorCallback__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultRestSecurityErrorCallback> { }
  public abstract class Type_factory__o_d_w_s_g_s_c_h_NewGuidedScoreCardHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewGuidedScoreCardHandler> { }
  public abstract class Type_factory__o_u_c_v_p_t_MultiTabWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<MultiTabWorkbenchPanelView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_ActionSetFactPlugin__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionSetFactPlugin> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_m_RegisteredDocumentsMenuBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<RegisteredDocumentsMenuBuilder> { }
  public abstract class Type_factory__o_d_w_s_d_c_DSLEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<DSLEditorEntryPoint> { }
  public abstract class Type_factory__o_o_w_s_d_c_w_p_PlannerDataObjectEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PlannerDataObjectEditorViewImpl> { }
  public abstract class Type_factory__o_d_w_s_t_c_ScenarioEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ScenarioEditorViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_r_e_RemoteEmptyPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<RemoteEmptyPresenter> { }
  public abstract class Type_factory__o_d_r_g_c_GoogleRenderer__quals__j_e_i_Any_j_e_i_Default extends Factory<GoogleRenderer> { }
  public abstract class Type_factory__o_j_e_u_n_c_l_HistoryTokenFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<HistoryTokenFactory> { }
  public abstract class Type_factory__o_u_e_c_e_g_f_ExperimentalFeatureEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<ExperimentalFeatureEditor> { }
  public abstract class Type_factory__o_k_w_c_w_c_c_p_WorkbenchConfigurationPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchConfigurationPopup> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_c_DataModelChangeNotifier__quals__j_e_i_Any_j_e_i_Default extends Factory<DataModelChangeNotifier> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_CardPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<CardPresenter> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_g_GroupUsersAssignment__quals__j_e_i_Any_j_e_i_Default extends Factory<GroupUsersAssignment> { }
  public abstract class Type_factory__o_j_e_i_c_a_b_InitBallotProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<InitBallotProvider> { }
  public abstract class Type_factory__o_o_w_s_d_c_w_p_PlannerDataObjectFieldEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<PlannerDataObjectFieldEditor> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_p_ProcessConfigView__quals__j_e_i_Any_j_e_i_Default extends Factory<ProcessConfigView> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_p_PersistenceUnitPropertyGridViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PersistenceUnitPropertyGridViewImpl> { }
  public abstract class Type_factory__o_d_d_e_c_s_DataSetDefEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefEditorPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_b_n_NotificationView__quals__j_e_i_Any_j_e_i_Default extends Factory<NotificationView> { }
  public abstract class Producer_factory__o_d_c_w_d_e_d_CSVDataSetDefDriver__quals__j_e_i_Any_j_e_i_Default extends Factory<CSVDataSetDefDriver> { }
  public abstract class Type_factory__o_j_e_u_c_w_LocaleListBox__quals__j_e_i_Any_j_e_i_Default extends Factory<LocaleListBox> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_p_c_CloseUnsavedProjectAssetsPopUpView__quals__j_e_i_Any_j_e_i_Default extends Factory<CloseUnsavedProjectAssetsPopUpView> { }
  public abstract class Type_factory__o_u_e_p_c_e_SplashEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<SplashEditorPresenterActivity> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_FormLabel__quals__j_e_i_Any_j_e_i_Default extends Factory<org.gwtbootstrap3.client.ui.FormLabel> { }
  public abstract class Type_factory__o_u_e_w_c_c_d_LiveSearchDropDownView__quals__j_e_i_Any_j_e_i_Default extends Factory<LiveSearchDropDownView> { }
  public abstract class Type_factory__o_u_c_w_w_m_UtilityMenuBarPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<UtilityMenuBarPresenter> { }
  public abstract class Type_factory__o_u_e_p_e_c_f_TextField__quals__j_e_i_Any_j_e_i_Default extends Factory<TextField> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_WorkItemPageView__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkItemPageView> { }
  public abstract class Type_factory__o_u_e_p_c_p_e_l_e_TargetDivDragComponent__quals__j_e_i_Any_j_e_i_Default extends Factory<TargetDivDragComponent> { }
  public abstract class JsType_factory__o_u_m_PlaceRequest__quals__Universal extends Factory<PlaceRequest> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_i_ImportRepositoryPopUpView__quals__j_e_i_Any_j_e_i_Default extends Factory<ImportRepositoryPopUpView> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_ProjectEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectEditorEntryPoint> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_ServerManagementEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<ServerManagementEntryPoint> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_DataModelerScreenPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DataModelerScreenPresenter> { }
  public abstract class Type_factory__o_d_c_n_w_NavItemTileWidgetView__quals__j_e_i_Any_j_e_i_Default extends Factory<NavItemTileWidgetView> { }
  public abstract class Type_factory__o_u_e_w_c_c_a_StencilActionBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<StencilActionBuilder> { }
  public abstract class Type_factory__o_u_s_c_e_SSHKeysEditorScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<SSHKeysEditorScreen> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_n_TreeNavigator__quals__j_e_i_Any_j_e_i_Default extends Factory<TreeNavigator> { }
  public abstract class Type_factory__o_o_w_s_s_c_e_PhaseConfigForm__quals__j_e_i_Any_j_e_i_Default extends Factory<PhaseConfigForm> { }
  public abstract class Type_factory__o_u_e_e_c_c_f_p_DeletePopUpPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DeletePopUpPresenter> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_d_LimitedEntryActionInsertFactCol52DefinitionBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<LimitedEntryActionInsertFactCol52DefinitionBuilder> { }
  public abstract class Type_factory__o_d_v_d_ElasticSearchDataSetDefValidator__quals__j_e_i_Any_j_e_i_Default extends Factory<ElasticSearchDataSetDefValidator> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_u_NewUserAttributeEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<NewUserAttributeEditor> { }
  public abstract class Type_factory__o_o_w_s_s_c_e_LocalSearchFormViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<LocalSearchFormViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_j_JPADomainScreenViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<JPADomainScreenViewImpl> { }
  public abstract class Type_factory__o_u_c_w_p_i_MultiListWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<MultiListWorkbenchPanelView> { }
  public abstract class Type_factory__o_u_e_l_e_c_c_c_ColumnWithComponentsView__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnWithComponentsView> { }
  public abstract class Type_factory__o_d_d_e_g_IntervalBuilderFixedDate__quals__j_e_i_Any_j_e_i_Default extends Factory<IntervalBuilderFixedDate> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_m_NewPatternPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<NewPatternPresenter> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_u_w_UserEditorWorkflow__quals__j_e_i_Any_j_e_i_Default extends Factory<UserEditorWorkflow> { }
  public abstract class Type_factory__o_u_c_m_LockDemandDetector__quals__j_e_i_Any_j_e_i_Default extends Factory<LockDemandDetector> { }
  public abstract class Type_factory__o_u_e_p_e_c_f_ColorField__quals__j_e_i_Any_j_e_i_Default extends Factory<ColorField> { }
  public abstract class Type_factory__o_u_e_w_c_c_p_PaletteScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<PaletteScreenActivity> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_d_DroolsDataObjectEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DroolsDataObjectEditorViewImpl> { }
  public abstract class Type_factory__o_d_d_c_w_RendererSelectorRadioListView__quals__j_e_i_Any_j_e_i_Default extends Factory<RendererSelectorRadioListView> { }
  public abstract class ExtensionProvided_factory__o_u_c_v_p_w_FormLabelHelp__quals__j_e_i_Any_j_e_i_Default extends Factory<FormLabelHelp> { }
  public abstract class Type_factory__o_u_e_w_c_c_CommonsEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<CommonsEntryPoint> { }
  public abstract class Type_factory__o_d_d_c_w_f_TimeAmountEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<TimeAmountEditorView> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_w_c_d_DropdownHeaderWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<DropdownHeaderWidget> { }
  public abstract class Type_factory__o_d_d_e_c_s_DataSetDefType__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefType> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_PopulatedLibraryScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<PopulatedLibraryScreen> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_c_c_r_ContainerRulesConfigPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ContainerRulesConfigPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_n_ServerNavigationView__quals__j_e_i_Any_j_e_i_Default extends Factory<ServerNavigationView> { }
  public abstract class Type_factory__o_u_c_w_p_i_SimpleWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<SimpleWorkbenchPanelView> { }
  public abstract class Type_factory__o_d_w_s_g_t_c_e_GuidedRuleTemplateEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedRuleTemplateEditorPresenter> { }
  public abstract class Type_factory__o_d_w_s_t_c_p_s_SettingsPage__quals__j_e_i_Any_j_e_i_Default extends Factory<SettingsPage> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_DescriptionColumnConverter__quals__j_e_i_Any_j_e_i_Default extends Factory<DescriptionColumnConverter> { }
  public abstract class Type_factory__o_d_r_c_s_SelectorDropDownDisplayerView__quals__j_e_i_Any_j_e_i_Default extends Factory<SelectorDropDownDisplayerView> { }
  public abstract class ContextualProvider_factory__e_d_HTMLElement__quals__Universal extends Factory<HTMLElement> { }
  public abstract class Type_factory__o_u_p_s_i_PreferenceScopeFactoryImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PreferenceScopeFactoryImpl> { }
  public abstract class Type_factory__o_u_s_c_e_c_k_k_SSHKeyEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<SSHKeyEditorViewImpl> { }
  public abstract class Type_factory__o_d_c_c_p_ContentManagerPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ContentManagerPerspectiveActivity> { }
  public abstract class Type_factory__o_d_d_c_w_DisplayerError__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerError> { }
  public abstract class Type_factory__o_d_d_c_w_f_DateParameterEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DateParameterEditorView> { }
  public abstract class Type_factory__o_o_w_s_g_c_p_ActionPluginClientService__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionPluginClientService> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_k_i_k_KnowledgeSessionsModal__quals__j_e_i_Any_j_e_i_Default extends Factory<KnowledgeSessionsModal> { }
  public abstract class Type_factory__o_d_c_c_s_e_PerspectivesExplorerScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<PerspectivesExplorerScreenActivity> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_w_EntityWorkflowViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<EntityWorkflowViewImpl> { }
  public abstract class JsType_factory__o_u_w_m_m_MenuItem__quals__Universal extends Factory<MenuItem> { }
  public abstract class Type_factory__o_d_c_w_c_ClientRuntimeErrorPopupPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ClientRuntimeErrorPopupPresenter> { }
  public abstract class Type_factory__o_d_c_n_w_e_TargetPerspectiveEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<TargetPerspectiveEditorView> { }
  public abstract class Type_factory__o_o_w_s_g_c_p_BendableSoftConstraintMatchRuleModellerActionPlugin__quals__j_e_i_Any_j_e_i_Default extends Factory<BendableSoftConstraintMatchRuleModellerActionPlugin> { }
  public abstract class ContextualProvider_factory__j_e_i_Instance__quals__Universal extends Factory<Instance> { }
  public abstract class ExtensionProvided_factory__c_g_g_u_c_u_HeaderPanel__quals__j_e_i_Any_j_e_i_Default extends Factory<HeaderPanel> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_o_c_t_ContributorsListPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ContributorsListPresenter> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_v_AssetUpdateValidator__quals__j_e_i_Any_j_e_i_Default extends Factory<AssetUpdateValidator> { }
  public abstract class Producer_factory__o_d_c_w_d_e_d_ElasticSearchDataSetDefDriver__quals__j_e_i_Any_j_e_i_Default extends Factory<ElasticSearchDataSetDefDriver> { }
  public abstract class Producer_factory__c_g_w_b_e_s_EventBus__quals__j_e_i_Any_j_e_i_Default extends Factory<EventBus> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_w_c_MenuResourceHandlerWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<MenuResourceHandlerWidget> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_o_c_e_EditContributorsPopUpPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<EditContributorsPopUpPresenter> { }
  public abstract class Type_factory__o_u_e_p_c_e_ScreenEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<ScreenEditorView> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_c_DataModelCommandBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<DataModelCommandBuilder> { }
  public abstract class Type_factory__o_g_c_s_p_c_POMEditorPanel__quals__j_e_i_Any_j_e_i_Default extends Factory<POMEditorPanel> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_k_KnowledgeBasesView__quals__j_e_i_Any_j_e_i_Default extends Factory<KnowledgeBasesView> { }
  public abstract class Type_factory__o_u_c_v_p_m_MultiPageEditorViewImpl__quals__j_e_i_Any_o_u_c_w_w_m_Multiple extends Factory<MultiPageEditorViewImpl> { }
  public abstract class Type_factory__o_d_r_c_t_TableDisplayer__quals__j_e_i_Any_j_e_i_Default extends Factory<TableDisplayer> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_n_MultiplePermissionNodeEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<MultiplePermissionNodeEditorView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_AttributeColumnPageView__quals__j_e_i_Any_j_e_i_Default extends Factory<AttributeColumnPageView> { }
  public abstract class Type_factory__o_g_s_c_s_RepositoryController__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryController> { }
  public abstract class Producer_factory__o_u_c_w_w_m_m_WorkbenchMegaMenuPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchMegaMenuPresenter> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_a_DecisionTableAnalyzerProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<DecisionTableAnalyzerProvider> { }
  public abstract class Type_factory__o_d_d_c_PerspectiveCoordinator__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectiveCoordinator> { }
  public abstract class Type_factory__o_d_r_g_c_GoogleAreaChartDisplayerView__quals__j_e_i_Any_j_e_i_Default extends Factory<GoogleAreaChartDisplayerView> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_c_s_e_ContainerStatusEmptyPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ContainerStatusEmptyPresenter> { }
  public abstract class Type_factory__o_j_e_i_c_a_b_CallerProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<CallerProvider> { }
  public abstract class Type_factory__o_u_c_r_i_PermissionTreeI18NImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PermissionTreeI18NImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_MetaDataColumnPageView__quals__j_e_i_Any_j_e_i_Default extends Factory<MetaDataColumnPageView> { }
  public abstract class Type_factory__o_d_d_c_w_DisplayerSettingsEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerSettingsEditor> { }
  public abstract class JsType_factory__e_d_HTMLElement_AttachShadowOptionsType__quals__Universal extends Factory<AttachShadowOptionsType> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_e_KieMetaDataEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<KieMetaDataEditorPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_t_ProjectImportsResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectImportsResourceType> { }
  public abstract class Type_factory__o_d_w_s_g_t_t_GuidedRuleTemplateResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset extends Factory<GuidedRuleTemplateResourceTypeDefinition> { }
  public abstract class Type_factory__o_d_d_c_w_f_MultipleTextParameterEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<MultipleTextParameterEditor> { }
  public abstract class Type_factory__o_u_c_v_p_w_DropdownMenu__quals__j_e_i_Any_j_e_i_Default extends Factory<DropdownMenu> { }
  public abstract class ExtensionProvided_factory__c_g_g_u_c_u_ListBox__quals__j_e_i_Any_j_e_i_Default extends Factory<com.google.gwt.user.client.ui.ListBox> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_Span__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<Span> { }
  public abstract class ExtensionProvided_factory__e_d_HTMLInputElement__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<HTMLInputElement> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_ActionWorkItemSetFieldColumnConverter__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionWorkItemSetFieldColumnConverter> { }
  public abstract class Type_factory__o_u_c_p_RuntimePluginsServiceProxyClientImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<RuntimePluginsServiceProxyClientImpl> { }
  public abstract class Type_factory__o_u_b_v_i_ObservablePathImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ObservablePathImpl> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDomainEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<AdvancedDomainEditor> { }
  public abstract class Type_factory__o_d_w_s_d_c_e_DecisionTableXLSEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<DecisionTableXLSEditorPresenterActivity> { }
  public abstract class Type_factory__o_k_w_c_s_p_t_ProjectImportsResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectImportsResourceTypeDefinition> { }
  public abstract class Type_factory__o_d_c_n_w_e_NavTreeEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<NavTreeEditor> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_m_DocumentMenuItemImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DocumentMenuItemImpl> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_a_CreateAnnotationWizard__quals__j_e_i_Any_j_e_i_Default extends Factory<CreateAnnotationWizard> { }
  public abstract class Type_factory__o_u_e_p_c_p_PlugInAuthoringPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<PlugInAuthoringPerspective> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_w_p_NewAssetHandlerCardView__quals__j_e_i_Any_j_e_i_Default extends Factory<NewAssetHandlerCardView> { }
  public abstract class Type_factory__o_k_w_c_s_p_t_KModuleResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<KModuleResourceTypeDefinition> { }
  public abstract class Type_factory__o_d_c_c_e_m_MapEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<MapEditor> { }
  public abstract class Type_factory__o_d_w_s_t_c_p_s_SettingsPageViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<SettingsPageViewImpl> { }
  public abstract class Type_factory__o_u_c_v_p_t_UberTabPanel__quals__j_e_i_Any_j_e_i_Default extends Factory<UberTabPanel> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_t_LinkTitlePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<LinkTitlePresenter> { }
  public abstract class Type_factory__o_d_r_g_c_GoogleMeterChartDisplayer__quals__j_e_i_Any_j_e_i_Default extends Factory<GoogleMeterChartDisplayer> { }
  public abstract class ExtensionProvided_factory__e_d_HTMLButtonElement__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<HTMLButtonElement> { }
  public abstract class Type_factory__o_g_s_c_e_f_FileExplorerViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<FileExplorerViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_k_i_p_PackageItemPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<PackageItemPresenter> { }
  public abstract class Type_factory__o_d_c_n_w_NavComponentConfigModal__quals__j_e_i_Any_j_e_i_Default extends Factory<NavComponentConfigModal> { }
  public abstract class Type_factory__o_d_c_n_i_NavigationManagerImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<NavigationManagerImpl> { }
  public abstract class Type_factory__o_u_e_p_c_e_EditorPlugInEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<EditorPlugInEditorPresenterActivity> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_h_DomainHandlerRegistry__quals__j_e_i_Any_j_e_i_Default extends Factory<DomainHandlerRegistry> { }
  public abstract class Type_factory__o_u_s_c_SecurityEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<SecurityEntryPoint> { }
  public abstract class Type_factory__o_u_c_s_JSNativeSplashScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<JSNativeSplashScreen> { }
  public abstract class Producer_factory__o_d_c_w_d_e_d_BeanDataSetDefAttributesDriver__quals__j_e_i_Any_j_e_i_Default extends Factory<BeanDataSetDefAttributesDriver> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_i_ExamplesImportPresenter__quals__j_e_i_Any_o_k_w_c_s_l_c_s_i_Source extends Factory<ExamplesImportPresenter> { }
  public abstract class Type_factory__o_o_w_c_n_MegaMenuConfig__quals__j_e_i_Any_j_e_i_Default extends Factory<MegaMenuConfig> { }
  public abstract class Type_factory__o_d_d_c_DataSetClientServices__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetClientServices> { }
  public abstract class Type_factory__c_g_g_v_c_ListDataProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<ListDataProvider> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_CalculationTypePage__quals__j_e_i_Any_j_e_i_Default extends Factory<CalculationTypePage> { }
  public abstract class Type_factory__o_u_e_l_e_c_w_LayoutComponentPaletteView__quals__j_e_i_Any_j_e_i_Default extends Factory<LayoutComponentPaletteView> { }
  public abstract class Type_factory__o_j_e_s_c_l_c_SecurityContextImpl_SecurityRolesConstraintPage__quals__j_e_i_Any_j_e_i_Default extends Factory<SecurityRolesConstraintPage> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_OrgUnitsMetricsView__quals__j_e_i_Any_j_e_i_Default extends Factory<OrgUnitsMetricsView> { }
  public abstract class Type_factory__o_g_s_c_a_TreeNavigator__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<org.guvnor.structure.client.advnavigator.TreeNavigator> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_UsersExplorer__quals__j_e_i_Any_j_e_i_Default extends Factory<UsersExplorer> { }
  public abstract class Type_factory__o_j_e_d_c_ListComponentProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<ListComponentProvider> { }
  public abstract class Type_factory__o_u_e_p_c_a_AdminPagePerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<AdminPagePerspectiveActivity> { }
  public abstract class JsType_factory__o_u_w_m_m_MenuItemPerspective__quals__Universal extends Factory<MenuItemPerspective> { }
  public abstract class Type_factory__o_u_e_p_c_p_e_PerspectiveEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectiveEditorView> { }
  public abstract class Type_factory__o_u_e_w_c_c_b_UberfireBreadcrumbs__quals__j_e_i_Any_j_e_i_Default extends Factory<UberfireBreadcrumbs> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_e_ServerEmptyPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ServerEmptyPresenter> { }
  public abstract class Type_factory__o_d_w_s_t_c_ScenarioEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<ScenarioEditorPresenterActivity> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_ConditionColumnPlugin__quals__j_e_i_Any_j_e_i_Default extends Factory<ConditionColumnPlugin> { }
  public abstract class Type_factory__o_d_c_c_s_h_ContentManagerHomeScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ContentManagerHomeScreenActivity> { }
  public abstract class Type_factory__o_d_d_e_c_s_DataSetDefWizardScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefWizardScreen> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_BRLActionVariableColumnConverter__quals__j_e_i_Any_j_e_i_Default extends Factory<BRLActionVariableColumnConverter> { }
  public abstract class Type_factory__o_u_s_i_a_DefaultPermissionTypeRegistry__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultPermissionTypeRegistry> { }
  public abstract class JsType_factory__o_j_e_e_c_c_JsTypeEventObserver__quals__Universal extends Factory<JsTypeEventObserver> { }
  public abstract class Type_factory__o_d_d_c_e_ClientDateFormatterImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ClientDateFormatterImpl> { }
  public abstract class Type_factory__o_u_e_e_c_c_h_HtmlEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<HtmlEditorPresenter> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_d_LimitedEntryActionSetFieldCol52DefinitionBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<LimitedEntryActionSetFieldCol52DefinitionBuilder> { }
  public abstract class Type_factory__o_u_c_e_PluginJSExporter__quals__j_e_i_Any_j_e_i_Default extends Factory<PluginJSExporter> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_LimitedEntryBRLConditionColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default extends Factory<LimitedEntryBRLConditionColumnSynchronizer> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_SummaryPage__quals__j_e_i_Any_j_e_i_Default extends Factory<SummaryPage> { }
  public abstract class Type_factory__o_d_d_c_w_f_TimeFrameEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<TimeFrameEditor> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_p_p_PropertiesItemPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<PropertiesItemPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_EmptyStateView__quals__j_e_i_Any_j_e_i_Default extends Factory<EmptyStateView> { }
  public abstract class Type_factory__o_d_c_w_d_e_w_DataSetEditorWorkflowFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetEditorWorkflowFactory> { }
  public abstract class Producer_factory__o_j_e_u_n_c_l_URLPatternMatcher__quals__j_e_i_Any_j_e_i_Default extends Factory<URLPatternMatcher> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_FactPatternsPageViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<FactPatternsPageViewImpl> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_h_Paragraph__quals__j_e_i_Any_j_e_i_Default extends Factory<Paragraph> { }
  public abstract class Type_factory__o_u_c_d_UberfireDocksImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<UberfireDocksImpl> { }
  public abstract class Type_factory__o_u_e_e_c_c_h_HtmlEditorActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<HtmlEditorActivity> { }
  public abstract class Type_factory__o_d_c_w_d_e_DataSetDefFilterEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefFilterEditor> { }
  public abstract class Type_factory__o_u_c_w_p_i_SimpleDnDWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<SimpleDnDWorkbenchPanelPresenter> { }
  public abstract class Type_factory__o_u_p_c_s_PreferenceStoreIOCProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<PreferenceStoreIOCProvider> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_k_i_i_IncludedKnowledgeBaseItemView__quals__j_e_i_Any_j_e_i_Default extends Factory<IncludedKnowledgeBaseItemView> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_SettingsPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<SettingsPresenter> { }
  public abstract class Type_factory__o_d_r_g_c_GoogleLineChartDisplayerView__quals__j_e_i_Any_j_e_i_Default extends Factory<GoogleLineChartDisplayerView> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_d_DependenciesPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DependenciesPresenter> { }
  public abstract class Type_factory__o_d_c_c_e_f_FileUploadEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<FileUploadEditor> { }
  public abstract class Type_factory__o_u_e_w_c_c_d_LiveSearchDropDown__quals__j_e_i_Any_j_e_i_Default extends Factory<LiveSearchDropDown> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_w_e_e_ExampleProjectOkPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ExampleProjectOkPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_p_ProjectScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectScreen> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_c_e_ServerContainerEmptyView__quals__j_e_i_Any_j_e_i_Default extends Factory<ServerContainerEmptyView> { }
  public abstract class Producer_factory__o_u_e_e_c_c_f_e_TextFileExport__quals__j_e_i_Any_j_e_i_Default extends Factory<TextFileExport> { }
  public abstract class Type_factory__o_d_w_s_d_c_t_DRLResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<DRLResourceType> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_GuidedDecisionTableModellerViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDecisionTableModellerViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_ExplorerViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ExplorerViewImpl> { }
  public abstract class Type_factory__o_u_e_l_e_c_w_LayoutDragComponentGroupPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<LayoutDragComponentGroupPresenter> { }
  public abstract class Type_factory__o_j_e_v_c_ValidatorProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<ValidatorProvider> { }
  public abstract class ExtensionProvided_factory__o_g_e_d_c_u_DateTimePicker__quals__j_e_i_Any_j_e_i_Default extends Factory<DateTimePicker> { }
  public abstract class Type_factory__o_u_c_w_p_i_MultiTabWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<MultiTabWorkbenchPanelPresenter> { }
  public abstract class Type_factory__o_k_w_c_w_c_m_c_AdminCustomMenuBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<AdminCustomMenuBuilder> { }
  public abstract class JsType_factory__o_u_w_m_CustomPanelDefinition__quals__Universal extends Factory<CustomPanelDefinition> { }
  public abstract class JsType_factory__o_u_b_v_Path__quals__Universal extends Factory<Path> { }
  public abstract class Type_factory__o_d_w_s_d_t_DSLRResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset extends Factory<DSLRResourceTypeDefinition> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_e_KieMetaDataEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<KieMetaDataEditorPresenterActivity> { }
  public abstract class Type_factory__o_k_w_c_s_r_c_u_ShowAssetUsagesDisplayerViewViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ShowAssetUsagesDisplayerViewViewImpl> { }
  public abstract class Type_factory__o_k_w_c_w_c_d_AsyncPackageDataModelOracleFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<AsyncPackageDataModelOracleFactory> { }
  public abstract class Type_factory__o_u_c_v_p_w_Elemental2Producer__quals__j_e_i_Any_j_e_i_Default extends Factory<Elemental2Producer> { }
  public abstract class Type_factory__o_d_d_c_DisplayerScreenPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<DisplayerScreenPresenterActivity> { }
  public abstract class ContextualProvider_factory__o_j_e_i_c_a_Disposer__quals__Universal extends Factory<Disposer> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_p_ErrorBox__quals__j_e_i_Any_j_e_i_Default extends Factory<ErrorBox> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_v_g_GenericValuePairEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<GenericValuePairEditorViewImpl> { }
  public abstract class ContextualProvider_factory__o_j_e_d_c_c_ListComponent__quals__Universal extends Factory<ListComponent> { }
  public abstract class JsType_factory__e_d_InputDeviceCapabilities_InputDeviceCapabilitiesOptionsType__quals__Universal extends Factory<InputDeviceCapabilitiesOptionsType> { }
  public abstract class Type_factory__o_u_c_w_p_i_SplitLayoutPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<SplitLayoutPanelView> { }
  public abstract class Type_factory__o_u_e_e_c_c_m_BasicFileMenuBuilderImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<BasicFileMenuBuilderImpl> { }
  public abstract class ExtensionProvided_factory__e_d_HTMLHeadingElement__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<HTMLHeadingElement> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_v_ValuePairEditorPopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ValuePairEditorPopupViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_m_MainDataObjectFieldEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<MainDataObjectFieldEditorViewImpl> { }
  public abstract class Type_factory__o_u_e_w_c_c_w_w_p_a_n_ActivityNotFoundView__quals__j_e_i_Any_j_e_i_Default extends Factory<ActivityNotFoundView> { }
  public abstract class JsType_factory__o_u_w_m_m_HasEnabledStateChangeListeners__quals__Universal extends Factory<HasEnabledStateChangeListeners> { }
  public abstract class Type_factory__o_d_c_w_d_e_e_ElasticSearchDataSetEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<ElasticSearchDataSetEditor> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_w_c_d_DropdownSeparatorWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<DropdownSeparatorWidget> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_u_CategoryUtils__quals__j_e_i_Any_j_e_i_Default extends Factory<CategoryUtils> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_p_a_GuidedDecisionTableAccordionView__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDecisionTableAccordionView> { }
  public abstract class Type_factory__o_u_c_m_PlaceHistoryHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<PlaceHistoryHandler> { }
  public abstract class Type_factory__o_g_c_s_p_c_Form__quals__j_e_i_Any_j_e_i_Default extends Factory<Form> { }
  public abstract class ExtensionProvided_factory__o_k_w_c_s_s_m_c_w_NumericTextBox__quals__j_e_i_Any_j_e_i_Default extends Factory<NumericTextBox> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_Select__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<org.jboss.errai.common.client.dom.Select> { }
  public abstract class Type_factory__o_k_w_c_w_c_w_KieSelectElement_OptionElement__quals__j_e_i_Any_j_e_i_Default extends Factory<OptionElement> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_g_GeneralSettingsPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<GeneralSettingsPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_k_i_p_PackageItemView__quals__j_e_i_Any_j_e_i_Default extends Factory<PackageItemView> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_ImportExamplesProjectsScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ImportExamplesProjectsScreenActivity> { }
  public abstract class Type_factory__o_u_c_e_t_JSNativeClientResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<JSNativeClientResourceType> { }
  public abstract class Type_factory__o_u_e_l_e_c_c_c_ComponentColumn__quals__j_e_i_Any_j_e_i_Default extends Factory<ComponentColumn> { }
  public abstract class ContextualProvider_factory__o_j_e_u_n_c_l_TransitionToRole__quals__Universal extends Factory<TransitionToRole> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_PatternToDeletePage__quals__j_e_i_Any_j_e_i_Default extends Factory<PatternToDeletePage> { }
  public abstract class Type_factory__o_k_w_c_s_c_c_s_ContributorsViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ContributorsViewImpl> { }
  public abstract class Type_factory__o_d_w_s_t_c_p_s_ConfigWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<ConfigWidget> { }
  public abstract class Type_factory__o_d_c_c_s_e_PerspectivesExplorerScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectivesExplorerScreen> { }
  public abstract class Type_factory__o_d_w_s_g_d_t_GuidedDTableResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset extends Factory<GuidedDTableResourceTypeDefinition> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_MetaDataColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default extends Factory<MetaDataColumnSynchronizer> { }
  public abstract class Producer_factory__o_j_e_c_c_d_Document__quals__j_e_i_Any_j_e_i_Default extends Factory<Document> { }
  public abstract class Producer_factory__o_d_c_w_d_e_d_DataSetDefBasicAttributesDriver__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefBasicAttributesDriver> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_AssignedEntitiesInlineEditorView__quals__j_e_i_Any_o_u_e_s_m_c_w_m_e_AssignedEntitiesInlineEditor extends Factory<AssignedEntitiesInlineEditorView> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_p_p_PropertiesItemView__quals__j_e_i_Any_j_e_i_Default extends Factory<PropertiesItemView> { }
  public abstract class Type_factory__o_u_e_c_s_a_ExperimentalActivitiesAuthorizationManagerImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ExperimentalActivitiesAuthorizationManagerImpl> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_NewContainerFormPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<NewContainerFormPresenter> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_LimitedEntryBRLActionColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default extends Factory<LimitedEntryBRLActionColumnSynchronizer> { }
  public abstract class ExtensionProvided_factory__c_g_g_u_c_u_Button__quals__j_e_i_Any_j_e_i_Default extends Factory<com.google.gwt.user.client.ui.Button> { }
  public abstract class Type_factory__o_u_e_l_e_c_i_DragHelperComponentColumn__quals__j_e_i_Any_j_e_i_Default extends Factory<DragHelperComponentColumn> { }
  public abstract class Type_factory__o_k_w_c_w_c_p_a_AlertPopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<AlertPopupViewImpl> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_Anchor__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<Anchor> { }
  public abstract class Type_factory__o_u_e_p_e_c_PropertyEditorWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<PropertyEditorWidget> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_o_c_t_ContributorsListItemView__quals__j_e_i_Any_j_e_i_Default extends Factory<ContributorsListItemView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_LimitedEntryColumnConverter__quals__j_e_i_Any_j_e_i_Default extends Factory<LimitedEntryColumnConverter> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_BRLActionColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default extends Factory<BRLActionColumnSynchronizer> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ModelSynchronizerImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ModelSynchronizerImpl> { }
  public abstract class Type_factory__o_u_e_p_c_c_t_TreeHierarchyLeafItemPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<TreeHierarchyLeafItemPresenter> { }
  public abstract class Type_factory__o_u_c_v_p_m_UserMenuViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<UserMenuViewImpl> { }
  public abstract class Type_factory__o_d_c_c_r_i_ContentManagerI18n__quals__j_e_i_Any_j_e_i_Default extends Factory<ContentManagerI18n> { }
  public abstract class JsType_factory__o_u_c_m_PlaceStatus__quals__Universal extends Factory<PlaceStatus> { }
  public abstract class Type_factory__o_d_w_s_d_c_h_NewDslTextHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewDslTextHandler> { }
  public abstract class Type_factory__o_d_r_g_c_GoogleAreaChartDisplayer__quals__j_e_i_Any_j_e_i_Default extends Factory<GoogleAreaChartDisplayer> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_AssignedEntitiesModalEditorView__quals__j_e_i_Any_o_u_e_s_m_c_w_m_e_AssignedEntitiesModalEditor extends Factory<AssignedEntitiesModalEditorView> { }
  public abstract class Type_factory__o_d_d_c_w_s_SourceCodeEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<SourceCodeEditor> { }
  public abstract class Type_factory__o_d_c_n_w_e_NavItemDefaultEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<NavItemDefaultEditorView> { }
  public abstract class Type_factory__o_d_r_g_c_GoogleLineChartDisplayer__quals__j_e_i_Any_j_e_i_Default extends Factory<GoogleLineChartDisplayer> { }
  public abstract class ExtensionProvided_factory__o_u_c_v_p_w_HelpIcon__quals__j_e_i_Any_j_e_i_Default extends Factory<HelpIcon> { }
  public abstract class JsType_factory__o_u_s_Resource__quals__Universal extends Factory<Resource> { }
  public abstract class Type_factory__o_u_e_p_c_c_PreferencesCentralNavBarScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<PreferencesCentralNavBarScreenActivity> { }
  public abstract class Type_factory__o_u_c_w_p_i_LayoutPanelPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<LayoutPanelPresenter> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_GuidedDecisionTreeWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDecisionTreeWidget> { }
  public abstract class Type_factory__o_u_c_v_p_w_Modal__quals__j_e_i_Any_j_e_i_Default extends Factory<Modal> { }
  public abstract class Type_factory__o_u_c_a_DefaultWorkbenchController__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultWorkbenchController> { }
  public abstract class ExtensionProvided_factory__o_s_Logger__quals__Universal_2 extends Factory<Logger> { }
  public abstract class ExtensionProvided_factory__o_s_Logger__quals__Universal_1 extends Factory<Logger> { }
  public abstract class ExtensionProvided_factory__o_s_Logger__quals__Universal_4 extends Factory<Logger> { }
  public abstract class ExtensionProvided_factory__o_s_Logger__quals__Universal_3 extends Factory<Logger> { }
  public abstract class ExtensionProvided_factory__o_s_Logger__quals__Universal_6 extends Factory<Logger> { }
  public abstract class ExtensionProvided_factory__o_s_Logger__quals__Universal_5 extends Factory<Logger> { }
  public abstract class ExtensionProvided_factory__o_s_Logger__quals__Universal_8 extends Factory<Logger> { }
  public abstract class ExtensionProvided_factory__o_s_Logger__quals__Universal_7 extends Factory<Logger> { }
  public abstract class ExtensionProvided_factory__o_s_Logger__quals__Universal_9 extends Factory<Logger> { }
  public abstract class Type_factory__o_d_d_e_c_p_DataSetAuthoringPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetAuthoringPerspective> { }
  public abstract class JsType_factory__o_u_w_m_m_MenuItemPlain__quals__Universal extends Factory<MenuItemPlain> { }
  public abstract class Type_factory__o_d_c_n_w_NavTreeWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<NavTreeWidget> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_n_MultiplePermissionNodeEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<MultiplePermissionNodeEditor> { }
  public abstract class Type_factory__o_d_c_c_w_FilterLabelView__quals__j_e_i_Any_j_e_i_Default extends Factory<FilterLabelView> { }
  public abstract class Type_factory__o_u_e_p_c_a_i_AdminPageItemView__quals__j_e_i_Any_j_e_i_Default extends Factory<AdminPageItemView> { }
  public abstract class Type_factory__o_u_e_e_c_c_f_p_RestorePopUpPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<RestorePopUpPresenter> { }
  public abstract class Type_factory__o_d_c_c_w_FilterLabelSetView__quals__j_e_i_Any_j_e_i_Default extends Factory<FilterLabelSetView> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_n_ServerNavigationPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ServerNavigationPresenter> { }
  public abstract class Producer_factory__o_u_e_e_c_c_f_e_s_SvgFileExport__quals__j_e_i_Any_j_e_i_Default extends Factory<SvgFileExport> { }
  public abstract class ExtensionProvided_factory__o_s_Logger__quals__Universal extends Factory<Logger> { }
  public abstract class Type_factory__o_u_e_c_s_i_ClientExperimentalFeaturesRegistryServiceImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ClientExperimentalFeaturesRegistryServiceImpl> { }
  public abstract class Type_factory__o_u_c_m_PlaceRequestHistoryMapperImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PlaceRequestHistoryMapperImpl> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_LinkedGroup__quals__j_e_i_Any_j_e_i_Default extends Factory<LinkedGroup> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_u_EnumLoaderUtilities__quals__j_e_i_Any_j_e_i_Default extends Factory<EnumLoaderUtilities> { }
  public abstract class JsType_factory__o_u_w_m_i_PanelDefinitionImpl__quals__Universal extends Factory<PanelDefinitionImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_m_RowContextMenu__quals__j_e_i_Any_j_e_i_Default extends Factory<RowContextMenu> { }
  public abstract class Producer_factory__o_u_c_v_p_w_JQueryProducer_JQuery__quals__j_e_i_Any_j_e_i_Default extends Factory<JQuery> { }
  public abstract class Type_factory__o_k_w_c_s_h_c_w_s_s_ShortcutSubHeadingLinkPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ShortcutSubHeadingLinkPresenter> { }
  public abstract class Type_factory__o_j_e_u_c_w_ListWidgetProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<ListWidgetProvider> { }
  public abstract class Type_factory__o_u_e_w_c_c_s_i_IFrameScreenView__quals__j_e_i_Any_j_e_i_Default extends Factory<IFrameScreenView> { }
  public abstract class Type_factory__o_u_e_w_c_c_p_StencilPaletteBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<StencilPaletteBuilder> { }
  public abstract class Type_factory__o_u_e_l_e_c_w_LayoutDragComponentWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<LayoutDragComponentWidget> { }
  public abstract class Type_factory__o_u_e_w_c_c_s_i_IFrameScreenPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<IFrameScreenPresenterActivity> { }
  public abstract class Type_factory__o_u_e_w_c_c_p_DoubleValidator__quals__j_e_i_Any_j_e_i_Default extends Factory<DoubleValidator> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_AdditionalInfoPageView__quals__j_e_i_Any_j_e_i_Default extends Factory<AdditionalInfoPageView> { }
  public abstract class Type_factory__o_u_c_v_p_m_Bs3Modal__quals__j_e_i_Any_j_e_i_Default extends Factory<Bs3Modal> { }
  public abstract class Type_factory__o_u_e_e_c_c_f_RestoreUtil__quals__j_e_i_Any_j_e_i_Default extends Factory<RestoreUtil> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_p_d_DeleteProjectPopUpScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<DeleteProjectPopUpScreen> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_u_b_LibraryBreadcrumbs__quals__j_e_i_Any_j_e_i_Default extends Factory<LibraryBreadcrumbs> { }
  public abstract class Type_factory__o_d_d_c_w_g_ColumnFunctionEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnFunctionEditorView> { }
  public abstract class Type_factory__o_k_w_c_s_c_c_s_ContributorsScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ContributorsScreenActivity> { }
  public abstract class Type_factory__o_u_e_l_e_c_c_c_ContainerView__quals__j_e_i_Any_j_e_i_Default extends Factory<ContainerView> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_h_j_c_JPACommandBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<JPACommandBuilder> { }
  public abstract class Type_factory__o_d_w_s_d_c_e_DecisionTableXLSEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DecisionTableXLSEditorPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_a_SearchAnnotationPageViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<SearchAnnotationPageViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_SettingsSectionsProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<SettingsSectionsProvider> { }
  public abstract class Type_factory__o_d_c_c_e_l_HorizImageListEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<HorizImageListEditorView> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_Label__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<Label> { }
  public abstract class Provider_factory__j_v_Validator__quals__j_e_i_Any_j_e_i_Default extends Factory<Validator> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_KieEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<KieEditorEntryPoint> { }
  public abstract class Type_factory__o_u_c_w_LayoutSelection__quals__j_e_i_Any_j_e_i_Default extends Factory<LayoutSelection> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_c_ContainerView__quals__j_e_i_Any_j_e_i_Default extends Factory<org.kie.workbench.common.screens.server.management.client.container.ContainerView> { }
  public abstract class ExtensionProvided_factory__e_d_HTMLUListElement__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<HTMLUListElement> { }
  public abstract class Type_factory__o_d_d_c_w_DisplayerEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerEditor> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_u_TranslationUtils__quals__j_e_i_Any_j_e_i_Default extends Factory<TranslationUtils> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_v_ValidationPresenter_ValidationListPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ValidationListPresenter> { }
  public abstract class Type_factory__o_u_e_w_c_c_CoreEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<CoreEntryPoint> { }
  public abstract class Type_factory__o_u_e_s_m_c_ClientSecurityExceptionMessageResolver__quals__j_e_i_Any_j_e_i_Default extends Factory<ClientSecurityExceptionMessageResolver> { }
  public abstract class Type_factory__o_u_e_p_e_c_f_SecretTextField__quals__j_e_i_Any_j_e_i_Default extends Factory<SecretTextField> { }
  public abstract class Type_factory__o_u_e_e_c_c_h_VersionMenuDropDownButtonViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<VersionMenuDropDownButtonViewImpl> { }
  public abstract class Type_factory__o_u_e_e_c_c_h_VersionHistoryPresenterViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<VersionHistoryPresenterViewImpl> { }
  public abstract class Type_factory__o_d_c_w_d_e_DataSetDefFilterEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefFilterEditorView> { }
  public abstract class Type_factory__o_j_e_i_c_a_b_IOCBeanManagerProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<IOCBeanManagerProvider> { }
  public abstract class ExtensionProvided_factory__o_u_c_w_w_l_ResizeFlowPanel__quals__j_e_i_Any_j_e_i_Default extends Factory<ResizeFlowPanel> { }
  public abstract class Type_factory__o_u_c_v_p_w_KebabMenu__quals__j_e_i_Any_j_e_i_Default extends Factory<KebabMenu> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_p_ErrorBoxView__quals__j_e_i_Any_j_e_i_Default extends Factory<ErrorBoxView> { }
  public abstract class Type_factory__o_u_e_p_c_c_a_PreferencesCentralActionsScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<PreferencesCentralActionsScreen> { }
  public abstract class Type_factory__o_u_c_e_JSNativeEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<JSNativeEditor> { }
  public abstract class Producer_factory__o_k_w_c_s_d_c_w_d_DataSourceSelector__quals__j_e_i_Any_o_u_a_Customizable extends Factory<DataSourceSelector> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_p_AddProjectPopUpView__quals__j_e_i_Any_j_e_i_Default extends Factory<AddProjectPopUpView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_BRLConditionColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default extends Factory<BRLConditionColumnSynchronizer> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_e_KieTextEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<KieTextEditorViewImpl> { }
  public abstract class Type_factory__o_o_w_c_OptaPlannerWorkbenchEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<OptaPlannerWorkbenchEntryPoint> { }
  public abstract class Type_factory__o_k_w_c_s_h_c_p_HomePerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<HomePerspectiveActivity> { }
  public abstract class Type_factory__o_d_r_g_c_GoogleTableDisplayer__quals__j_e_i_Any_j_e_i_Default extends Factory<GoogleTableDisplayer> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_o_OrganizationalUnitsScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<OrganizationalUnitsScreen> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_h_NewPackageHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewPackageHandler> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_p_ProcessConfigPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ProcessConfigPresenter> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_GuidedDecisionTableEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDecisionTableEditorViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_MessageConsoleWhiteListImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<MessageConsoleWhiteListImpl> { }
  public abstract class Type_factory__o_u_c_m_ActivityLifecycleErrorHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<ActivityLifecycleErrorHandler> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_TextInput__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<TextInput> { }
  public abstract class Type_factory__o_u_e_e_c_c_h_HtmlResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<HtmlResourceType> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_j_JPADataObjectEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<JPADataObjectEditor> { }
  public abstract class Type_factory__o_j_e_i_s_b_c_RequestDispatcherProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<RequestDispatcherProvider> { }
  public abstract class Type_factory__o_d_c_w_d_e_w_DataSetEditorWorkflowView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetEditorWorkflowView> { }
  public abstract class Type_factory__o_u_e_p_e_c_f_ComboField__quals__j_e_i_Any_j_e_i_Default extends Factory<ComboField> { }
  public abstract class Type_factory__o_u_s_c_a_t_i_DefaultPermissionTreeFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultPermissionTreeFactory> { }
  public abstract class JsType_factory__o_u_s_a_RuntimeResource__quals__Universal extends Factory<RuntimeResource> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_d_DefaultDataSourceSelector__quals__j_e_i_Any_o_u_a_FallbackImplementation extends Factory<DefaultDataSourceSelector> { }
  public abstract class Type_factory__o_u_c_m_ActivityBeansCache__quals__j_e_i_Any_j_e_i_Default extends Factory<ActivityBeansCache> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_u_KiePOMDefaultOptions__quals__j_e_i_Any_j_e_i_Default extends Factory<KiePOMDefaultOptions> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_n_t_c_CopyPopupView__quals__j_e_i_Any_j_e_i_Default extends Factory<CopyPopupView> { }
  public abstract class Type_factory__o_u_c_w_w_m_m_m_ChildMenuItemPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ChildMenuItemPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_u_m_s_AddSingleValueModal__quals__j_e_i_Any_j_e_i_Default extends Factory<AddSingleValueModal> { }
  public abstract class Type_factory__o_d_c_w_d_e_c_DataColumnDefEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataColumnDefEditorView> { }
  public abstract class ExtensionProvided_factory__o_u_e_w_c_c_e_d_DefaultEditorNewFileUpload__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultEditorNewFileUpload> { }
  public abstract class Type_factory__o_d_w_s_g_s_c_t_GuidedScoreCardResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedScoreCardResourceType> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_a_a_AddAssetView__quals__j_e_i_Any_j_e_i_Default extends Factory<AddAssetView> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_t_KModuleResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<KModuleResourceType> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_OverviewEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<OverviewEditorEntryPoint> { }
  public abstract class Type_factory__o_u_e_p_c_w_p_NewPluginPopUpViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<NewPluginPopUpViewImpl> { }
  public abstract class Type_factory__o_k_w_c_w_c_c_w_u_ImportsWidgetPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ImportsWidgetPresenter> { }
  public abstract class Type_factory__o_d_w_s_g_t_c_h_NewGuidedRuleTemplateHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewGuidedRuleTemplateHandler> { }
  public abstract class Type_factory__o_j_e_i_s_b_c_MessageBusProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<MessageBusProvider> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_i_ImportProjectsScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<ImportProjectsScreen> { }
  public abstract class Type_factory__o_u_c_v_p_m_MultiPageEditorImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<MultiPageEditorImpl> { }
  public abstract class Type_factory__o_k_w_c_s_h_c_w_s_s_ShortcutSubHeadingTextView__quals__j_e_i_Any_j_e_i_Default extends Factory<ShortcutSubHeadingTextView> { }
  public abstract class Type_factory__o_j_e_i_s_b_c_SenderProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<SenderProvider> { }
  public abstract class Type_factory__o_u_e_e_c_c_f_p_RenamePopUpPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<RenamePopUpPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_p_p_ProjectPageViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectPageViewImpl> { }
  public abstract class Type_factory__o_u_e_l_e_c_i_LayoutDragComponentHelper__quals__j_e_i_Any_j_e_i_Default extends Factory<LayoutDragComponentHelper> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_t_InfoTitleView__quals__j_e_i_Any_j_e_i_Default extends Factory<InfoTitleView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_SummaryPageViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<SummaryPageViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_t_GuidedDTreeResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDTreeResourceType> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_g_GeneralSettingsView__quals__j_e_i_Any_j_e_i_Default extends Factory<GeneralSettingsView> { }
  public abstract class Type_factory__o_u_c_w_w_m_m_m_GroupMenuItemPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<GroupMenuItemPresenter> { }
  public abstract class Type_factory__o_u_e_c_e_ExperimentalFeaturesEditorScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<ExperimentalFeaturesEditorScreen> { }
  public abstract class Type_factory__o_d_w_s_e_t_EnumResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset extends Factory<EnumResourceTypeDefinition> { }
  public abstract class Type_factory__o_u_e_l_e_c_LayoutEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<LayoutEditorView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_RuleModellerPage__quals__j_e_i_Any_j_e_i_Default extends Factory<RuleModellerPage> { }
  public abstract class Type_factory__o_u_c_p_Promises__quals__j_e_i_Any_j_e_i_Default extends Factory<Promises> { }
  public abstract class Type_factory__o_u_c_v_p_l_ListBarWidgetImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ListBarWidgetImpl> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_a_ValuePairEditorPageViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ValuePairEditorPageViewImpl> { }
  public abstract class Type_factory__o_u_c_m_WorkbenchViewModeSwitcherPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchViewModeSwitcherPresenter> { }
  public abstract class Type_factory__o_g_c_s_p_c_t_POMResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<POMResourceType> { }
  public abstract class Type_factory__o_d_w_s_d_c_e_DRLEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<DRLEditorPresenterActivity> { }
  public abstract class Type_factory__o_d_d_e_c_s_DataSetAuthoringHomePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetAuthoringHomePresenter> { }
  public abstract class Type_factory__o_u_e_e_c_c_h_HtmlEditorLibraryLoader__quals__j_e_i_Any_j_e_i_Default extends Factory<HtmlEditorLibraryLoader> { }
  public abstract class Type_factory__o_j_e_u_c_l_p_Elemental2HTMLElementProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<Elemental2HTMLElementProvider> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_h_Span__quals__j_e_i_Any_j_e_i_Default extends Factory<org.gwtbootstrap3.client.ui.html.Span> { }
  public abstract class Type_factory__o_d_c_c_e_l_DropDownEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DropDownEditorView> { }
  public abstract class Producer_factory__o_d_c_w_d_e_d_SQLDataSetDefAttributesDriver__quals__j_e_i_Any_j_e_i_Default extends Factory<SQLDataSetDefAttributesDriver> { }
  public abstract class Type_factory__o_d_d_c_w_f_DataSetFilterEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetFilterEditorView> { }
  public abstract class Type_factory__o_u_e_a_c_h_AppsHomePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<AppsHomePresenter> { }
  public abstract class Type_factory__o_d_c_n_w_NavCarouselWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<NavCarouselWidget> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_o_p_OrganizationalUnitPopUpView__quals__j_e_i_Any_j_e_i_Default extends Factory<OrganizationalUnitPopUpView> { }
  public abstract class Type_factory__o_u_e_p_c_c_a_PreferencesCentralActionsScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<PreferencesCentralActionsScreenActivity> { }
  public abstract class Type_factory__o_u_e_w_c_c_t_FilterPagedTable__quals__j_e_i_Any_j_e_i_Default extends Factory<FilterPagedTable> { }
  public abstract class Type_factory__o_o_w_s_s_c_t_SolverResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<SolverResourceType> { }
  public abstract class Type_factory__o_u_c_v_p_m_UtilityMenuBarView__quals__j_e_i_Any_j_e_i_Default extends Factory<UtilityMenuBarView> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_h_a_AdvancedDomainHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<AdvancedDomainHandler> { }
  public abstract class Type_factory__o_u_e_l_e_c_g_BootstrapLayoutGeneratorDriver__quals__j_e_i_Any_j_e_i_Default extends Factory<BootstrapLayoutGeneratorDriver> { }
  public abstract class Type_factory__o_d_d_c_w_DataSetLookupEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetLookupEditor> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_r_RemotePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<RemotePresenter> { }
  public abstract class ContextualProvider_factory__o_j_e_u_c_w_ListWidget__quals__Universal extends Factory<ListWidget> { }
  public abstract class Type_factory__o_u_e_w_c_c_d_f_LiveSearchFooterViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<LiveSearchFooterViewImpl> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_u_UserEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<UserEditorView> { }
  public abstract class Type_factory__o_g_m_c_u_UploadFormPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<UploadFormPresenter> { }
  public abstract class Type_factory__o_d_c_c_w_AlertPanelView__quals__j_e_i_Any_j_e_i_Default extends Factory<AlertPanelView> { }
  public abstract class Type_factory__o_g_m_c_M2RepoEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<M2RepoEditorPresenter> { }
  public abstract class Type_factory__o_d_w_s_g_s_c_e_GuidedScoreCardEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedScoreCardEditorViewImpl> { }
  public abstract class Type_factory__o_u_e_l_e_c_w_LayoutElementPropertiesPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<LayoutElementPropertiesPresenter> { }
  public abstract class Type_factory__o_u_e_w_c_c_d_i_LiveSearchSelectorDropDownItem__quals__j_e_i_Any_j_e_i_Default extends Factory<LiveSearchSelectorDropDownItem> { }
  public abstract class Type_factory__o_d_w_s_d_t_DecisionTableXLSResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset extends Factory<DecisionTableXLSResourceTypeDefinition> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_p_SelectDocumentPopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<SelectDocumentPopupViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_w_p_NewAssetHandlerWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<NewAssetHandlerWidget> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_n_LeafPermissionNodeViewerView__quals__j_e_i_Any_j_e_i_Default extends Factory<LeafPermissionNodeViewerView> { }
  public abstract class Type_factory__o_d_c_w_d_e_c_CSVDataSetDefAttributesEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<CSVDataSetDefAttributesEditorView> { }
  public abstract class Type_factory__o_u_c_w_p_i_SplitLayoutPanelPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<SplitLayoutPanelPresenter> { }
  public abstract class Type_factory__o_u_c_w_w_m_m_c_GroupContextMenuItemPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<GroupContextMenuItemPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_a_AdvancedAnnotationListEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<AdvancedAnnotationListEditor> { }
  public abstract class Type_factory__o_u_e_w_c_c_e_d_DefaultFileEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultFileEditorView> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_d_DroolsDomainEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DroolsDomainEditor> { }
  public abstract class Type_factory__o_d_c_w_d_e_e_ElasticSearchDataSetDefAttributesEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<ElasticSearchDataSetDefAttributesEditor> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_k_i_k_w_WorkItemHandlerListItemView__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkItemHandlerListItemView> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_e_KieTextEditorScreenPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<KieTextEditorScreenPresenter> { }
  public abstract class JsType_factory__o_u_w_m_m_MenuCustom__quals__Universal extends Factory<MenuCustom> { }
  public abstract class JsType_factory__o_j_e_e_c_c_WindowEventObservers__quals__Universal extends Factory<WindowEventObservers> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_n_LeafPermissionNodeViewer__quals__j_e_i_Any_j_e_i_Default extends Factory<LeafPermissionNodeViewer> { }
  public abstract class JsType_factory__e_d_PageTransitionEvent_PageTransitionEventEventInitDictType__quals__Universal extends Factory<PageTransitionEventEventInitDictType> { }
  public abstract class Type_factory__o_u_c_w_w_d_WorkbenchPickupDragController__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchPickupDragController> { }
  public abstract class Type_factory__o_d_c_c_e_l_DropDownImageListEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DropDownImageListEditorView> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_b_BuildExecutor__quals__j_e_i_Any_j_e_i_Default extends Factory<BuildExecutor> { }
  public abstract class Type_factory__o_u_e_a_c_AppsPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<AppsPerspectiveActivity> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_o_c_w_ContributorsManagementListItemView__quals__j_e_i_Any_j_e_i_Default extends Factory<ContributorsManagementListItemView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_BRLActionColumnPlugin__quals__j_e_i_Any_j_e_i_Default extends Factory<BRLActionColumnPlugin> { }
  public abstract class Type_factory__o_d_c_w_d_e_DataSetDefProviderTypeEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefProviderTypeEditor> { }
  public abstract class Type_factory__o_u_e_w_c_c_e_t_TextResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<TextResourceType> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_p_b_AddBranchPopUpView__quals__j_e_i_Any_j_e_i_Default extends Factory<AddBranchPopUpView> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_ExplorerPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ExplorerPresenter> { }
  public abstract class Type_factory__o_k_w_c_w_c_c_w_b_ImportsWidgetPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<org.kie.workbench.common.widgets.configresource.client.widget.bound.ImportsWidgetPresenter> { }
  public abstract class Type_factory__o_d_r_c_s_SelectorLabelItem__quals__j_e_i_Any_j_e_i_Default extends Factory<SelectorLabelItem> { }
  public abstract class Type_factory__o_u_c_v_p_w_DropdownMenuItem__quals__j_e_i_Any_j_e_i_Default extends Factory<DropdownMenuItem> { }
  public abstract class Type_factory__o_d_d_c_w_DataSetLookupEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetLookupEditorView> { }
  public abstract class Type_factory__o_k_w_c_s_h_c_w_s_s_ShortcutSubHeadingLinkView__quals__j_e_i_Any_j_e_i_Default extends Factory<ShortcutSubHeadingLinkView> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_h_d_DroolsDomainHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<DroolsDomainHandler> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_o_c_t_ContributorsListItemPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ContributorsListItemPresenter> { }
  public abstract class Type_factory__o_g_c_s_p_p_GeneralPreferencesBeanGeneratedImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<GeneralPreferencesBeanGeneratedImpl> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_o_EmptyOrganizationalUnitsView__quals__j_e_i_Any_j_e_i_Default extends Factory<EmptyOrganizationalUnitsView> { }
  public abstract class Type_factory__o_o_w_s_s_c_e_ScoreDirectorFactoryFormViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ScoreDirectorFactoryFormViewImpl> { }
  public abstract class Type_factory__o_d_r_c_s_SelectorDisplayer__quals__j_e_i_Any_j_e_i_Default extends Factory<SelectorDisplayer> { }
  public abstract class Type_factory__o_k_w_c_s_j_c_e_JavaSourceViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<JavaSourceViewImpl> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_g_GroupEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<GroupEditor> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_AssetList__quals__j_e_i_Any_j_e_i_Default extends Factory<AssetList> { }
  public abstract class Type_factory__o_u_e_p_c_c_t_TreeHierarchyLeafItemView__quals__j_e_i_Any_j_e_i_Default extends Factory<TreeHierarchyLeafItemView> { }
  public abstract class Type_factory__o_u_c_w_w_m_m_WorkbenchMegaMenuProducer__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchMegaMenuProducer> { }
  public abstract class Type_factory__o_u_e_p_c_w_p_NewPluginPopUp__quals__j_e_i_Any_j_e_i_Default extends Factory<NewPluginPopUp> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_RowNumberColumnConverter__quals__j_e_i_Any_j_e_i_Default extends Factory<RowNumberColumnConverter> { }
  public abstract class Type_factory__o_u_e_p_c_p_e_PerspectiveEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<PerspectiveEditorPresenterActivity> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_k_i_KnowledgeBaseItemPresenter_PackageListPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<PackageListPresenter> { }
  public abstract class Type_factory__o_u_c_m_CategoriesManagerCache__quals__j_e_i_Any_j_e_i_Default extends Factory<CategoriesManagerCache> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_Div__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<Div> { }
  public abstract class Type_factory__o_u_c_m_ResourceTypeManagerCache__quals__j_e_i_Any_j_e_i_Default extends Factory<ResourceTypeManagerCache> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_ExplorerEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<ExplorerEntryPoint> { }
  public abstract class JsType_factory__j_u_Collection__quals__Universal extends Factory<Collection> { }
  public abstract class JsType_factory__o_u_w_t_ResourceTypeDefinition__quals__Universal extends Factory<ResourceTypeDefinition> { }
  public abstract class Type_factory__o_k_w_c_w_c_m_FileMenuBuilderImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<FileMenuBuilderImpl> { }
  public abstract class Type_factory__o_k_w_c_s_j_c_e_JavaEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<JavaEditorPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_j_p_RelationshipField__quals__j_e_i_Any_j_e_i_Default extends Factory<RelationshipField> { }
  public abstract class Type_factory__o_d_c_w_d_e_w_e_ElasticSearchDataSetEditWorkflow__quals__j_e_i_Any_j_e_i_Default extends Factory<ElasticSearchDataSetEditWorkflow> { }
  public abstract class Type_factory__o_d_c_w_d_e_DataSetDefColumnsFilterEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefColumnsFilterEditor> { }
  public abstract class Type_factory__o_g_c_s_p_c_Model__quals__j_e_i_Any_j_e_i_Default extends Factory<Model> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_w_OverviewWidgetPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<OverviewWidgetPresenter> { }
  public abstract class Type_factory__o_d_d_c_e_ClientIntervalBuilderDynamicDate__quals__j_e_i_Any_j_e_i_Default extends Factory<ClientIntervalBuilderDynamicDate> { }
  public abstract class Type_factory__o_d_c_n_w_NavTabListWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<NavTabListWidget> { }
  public abstract class Type_factory__o_o_w_s_d_c_e_PlannerFieldMetadataProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<PlannerFieldMetadataProvider> { }
  public abstract class Type_factory__o_u_c_JSEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<JSEntryPoint> { }
  public abstract class Type_factory__o_u_e_p_c_a_AdminPagePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<AdminPagePresenter> { }
  public abstract class Type_factory__o_d_w_s_g_c_h_NewGlobalHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewGlobalHandler> { }
  public abstract class Type_factory__o_k_w_c_s_c_c_p_ContributorsPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ContributorsPerspectiveActivity> { }
  public abstract class Producer_factory__o_j_e_s_s_a_i_User__quals__j_e_i_Any_j_e_i_Default extends Factory<User> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_p_s_SourceRepositoryPage__quals__j_e_i_Any_j_e_i_Default extends Factory<SourceRepositoryPage> { }
  public abstract class Type_factory__o_j_e_d_c_DataBinderProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<DataBinderProvider> { }
  public abstract class Type_factory__o_j_e_u_n_c_l_PageTransitionProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<PageTransitionProvider> { }
  public abstract class Type_factory__o_u_c_w_p_n_p_WorkbenchPartPresenterDefault__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchPartPresenterDefault> { }
  public abstract class Type_factory__o_u_e_e_c_c_f_p_SavePopUpView__quals__j_e_i_Any_j_e_i_Default extends Factory<SavePopUpView> { }
  public abstract class Type_factory__o_u_e_a_c_AppsPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<AppsPerspective> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_j_JPADataObjectFieldEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<JPADataObjectFieldEditorViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_c_ActionSetFieldPatternCell__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionSetFieldPatternCell> { }
  public abstract class JsType_factory__o_u_w_m_t_ToolBarItem__quals__Universal extends Factory<ToolBarItem> { }
  public abstract class Type_factory__o_u_c_v_p_m_WorkbenchMenuCompactNavBarView__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchMenuCompactNavBarView> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_u_d_KieDropdownElement__quals__j_e_i_Any_j_e_i_Default extends Factory<KieDropdownElement> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_d_BRLActionColumnDefinitionBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<BRLActionColumnDefinitionBuilder> { }
  public abstract class Type_factory__o_d_w_s_t_c_p_a_AuditPageViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<AuditPageViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_p_a_GuidedDecisionTableAccordionItemView__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDecisionTableAccordionItemView> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_n_t_ServerTemplateView__quals__j_e_i_Any_j_e_i_Default extends Factory<ServerTemplateView> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_t_TechnicalViewWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<TechnicalViewWidget> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_k_i_k_KnowledgeSessionListItemPresenter_ListenersListPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ListenersListPresenter> { }
  public abstract class Type_factory__o_u_s_c_e_SSHKeysEditorScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<SSHKeysEditorScreenActivity> { }
  public abstract class Type_factory__o_d_d_c_p_DisplayerPrototypes__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerPrototypes> { }
  public abstract class ExtensionProvided_factory__e_d_HTMLLabelElement__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<HTMLLabelElement> { }
  public abstract class Type_factory__o_d_n_w_NavSecurityController__quals__j_e_i_Any_j_e_i_Default extends Factory<NavSecurityController> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_p_p_ProjectPage__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectPage> { }
  public abstract class Type_factory__o_u_c_v_p_p_PopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PopupViewImpl> { }
  public abstract class Type_factory__o_u_c_v_p_w_ConfirmPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<ConfirmPopup> { }
  public abstract class Type_factory__o_d_w_s_g_t_c_GuidedRuleTemplateEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedRuleTemplateEntryPoint> { }
  public abstract class Type_factory__o_j_e_e_c_c_JsTypeEventObserver__quals__j_e_i_Any_j_e_i_Default extends Factory<JsTypeEventObserver> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_FactPatternConstraintsPageViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<FactPatternConstraintsPageViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_u_m_d_AddDoubleValueModalView__quals__j_e_i_Any_j_e_i_Default extends Factory<AddDoubleValueModalView> { }
  public abstract class Type_factory__o_u_e_l_e_c_c_c_ColumnWithComponents__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnWithComponents> { }
  public abstract class Type_factory__o_u_e_c_d_c_DisabledFeatureComponent__quals__j_e_i_Any_j_e_i_Default extends Factory<DisabledFeatureComponent> { }
  public abstract class JsType_factory__o_u_c_m_LockTarget__quals__Universal extends Factory<LockTarget> { }
  public abstract class Type_factory__o_d_w_s_e_c_EnumEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<EnumEditorEntryPoint> { }
  public abstract class JsType_factory__e_d_CustomElementRegistry_DefineOptionsType__quals__Universal extends Factory<DefineOptionsType> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_ProjectScreenMenuItem__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectScreenMenuItem> { }
  public abstract class Type_factory__o_u_e_l_e_c_i_LayoutEditorCssHelper__quals__j_e_i_Any_j_e_i_Default extends Factory<LayoutEditorCssHelper> { }
  public abstract class Type_factory__o_u_e_w_c_c_d_n_NoItemsComponent__quals__j_e_i_Any_j_e_i_Default extends Factory<NoItemsComponent> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_e_DataObjectBrowser__quals__j_e_i_Any_j_e_i_Default extends Factory<DataObjectBrowser> { }
  public abstract class Type_factory__o_u_s_c_e_c_e_SSHKeysEditorEmptyStateDisplayerViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<SSHKeysEditorEmptyStateDisplayerViewImpl> { }
  public abstract class JsType_factory__o_u_w_m_PanelDefinition__quals__Universal extends Factory<PanelDefinition> { }
  public abstract class Type_factory__o_d_c_n_l_e_NavTilesDragComponent__quals__j_e_i_Any_j_e_i_Default extends Factory<NavTilesDragComponent> { }
  public abstract class Type_factory__o_u_e_e_c_c_f_CopyPopUpViewProducer__quals__j_e_i_Any_j_e_i_Default extends Factory<CopyPopUpViewProducer> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_t_NewTemplateView__quals__j_e_i_Any_j_e_i_Default extends Factory<NewTemplateView> { }
  public abstract class Type_factory__o_d_d_e_c_s_DataSetDefScreenViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefScreenViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_c_ActionInsertFactFieldCell__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionInsertFactFieldCell> { }
  public abstract class Type_factory__o_u_e_p_c_RuntimePluginsEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<RuntimePluginsEntryPoint> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_Heading__quals__j_e_i_Any_j_e_i_Default_j_i_Named_2 extends Factory<Heading> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_Heading__quals__j_e_i_Any_j_e_i_Default_j_i_Named_1 extends Factory<Heading> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_Heading__quals__j_e_i_Any_j_e_i_Default_j_i_Named_3 extends Factory<Heading> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_h_NewGuidedDecisionTableGraphHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewGuidedDecisionTableGraphHandler> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_BRLConditionColumnPlugin__quals__j_e_i_Any_j_e_i_Default extends Factory<BRLConditionColumnPlugin> { }
  public abstract class Type_factory__o_k_w_c_w_c_h_w_c_WorkbenchConfigurationMenu__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchConfigurationMenu> { }
  public abstract class Type_factory__o_j_e_e_c_c_WindowEventObservers__quals__j_e_i_Any_j_e_i_Default extends Factory<WindowEventObservers> { }
  public abstract class Type_factory__o_u_e_w_c_c_c_BusyIndicatorView__quals__j_e_i_Any_j_e_i_Default extends Factory<BusyIndicatorView> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_p_p_FetchRepositoryViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<FetchRepositoryViewImpl> { }
  public abstract class Type_factory__o_u_e_w_c_c_m_MenuItemDividerView__quals__j_e_i_Any_o_u_e_w_c_c_m_MenuItemDivider extends Factory<MenuItemDividerView> { }
  public abstract class Type_factory__o_o_w_s_g_c_p_SoftConstraintMatchRuleModellerActionPlugin__quals__j_e_i_Any_j_e_i_Default extends Factory<SoftConstraintMatchRuleModellerActionPlugin> { }
  public abstract class Type_factory__o_d_d_c_w_DisplayerSettingsJSONSourceViewer__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerSettingsJSONSourceViewer> { }
  public abstract class Type_factory__o_d_c_w_d_e_c_CSVDataSetEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<CSVDataSetEditor> { }
  public abstract class Type_factory__o_j_e_u_n_c_l_NavigationPanelProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<NavigationPanelProvider> { }
  public abstract class JsType_factory__o_j_e_i_c_JsArray__quals__Universal extends Factory<JsArray> { }
  public abstract class Type_factory__o_o_w_c_p_AdministrationPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<AdministrationPerspectiveActivity> { }
  public abstract class Type_factory__o_d_d_c_w_f_DataSetFilterEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetFilterEditor> { }
  public abstract class Type_factory__o_u_e_c_p_ExperimentalFeaturesPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<ExperimentalFeaturesPerspective> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_DefaultSettingsSections__quals__j_e_i_Any_o_u_a_FallbackImplementation extends Factory<DefaultSettingsSections> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_v_ValidatorService__quals__j_e_i_Any_j_e_i_Default extends Factory<ValidatorService> { }
  public abstract class Type_factory__o_k_w_c_w_c_m_AboutCommand__quals__j_e_i_Any_j_e_i_Default extends Factory<AboutCommand> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_r_RemoteView__quals__j_e_i_Any_j_e_i_Default extends Factory<RemoteView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_ActionRetractFactColumnConverter__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionRetractFactColumnConverter> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_g_GitUrlsView__quals__j_e_i_Any_j_e_i_Default extends Factory<GitUrlsView> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_KieMultipleDocumentEditorWrapperViewImpl__quals__j_e_i_Any_o_k_w_c_w_m_c_KieMultipleDocumentEditorQualifier extends Factory<KieMultipleDocumentEditorWrapperViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_e_KieTextEditorScreenPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<KieTextEditorScreenPresenterActivity> { }
  public abstract class Type_factory__o_u_e_e_c_c_h_VersionMenuDropDownButton__quals__j_e_i_Any_j_e_i_Default extends Factory<VersionMenuDropDownButton> { }
  public abstract class Producer_factory__o_k_w_c_s_l_c_s_s_SettingsSections__quals__j_e_i_Any_o_u_a_Customizable extends Factory<SettingsSections> { }
  public abstract class Type_factory__o_g_c_s_p_c_GAVEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<GAVEditorViewImpl> { }
  public abstract class Type_factory__o_k_w_c_w_c_a_PermissionTreeSetup__quals__j_e_i_Any_j_e_i_Default extends Factory<PermissionTreeSetup> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_KieMultipleDocumentEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<KieMultipleDocumentEditorEntryPoint> { }
  public abstract class Type_factory__o_d_c_w_d_e_a_DataSetDefBasicAttributesEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefBasicAttributesEditor> { }
  public abstract class Type_factory__o_u_c_w_p_i_TemplatedWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<TemplatedWorkbenchPanelPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_u_m_d_AddDoubleValueModal__quals__j_e_i_Any_j_e_i_Default extends Factory<AddDoubleValueModal> { }
  public abstract class Type_factory__o_k_w_c_w_c_p_t_TextBoxFormPopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<TextBoxFormPopupViewImpl> { }
  public abstract class Type_factory__o_j_e_i_c_l_i_StateChangeImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<StateChangeImpl> { }
  public abstract class Provider_factory__o_j_e_b_c_a_m_RequestDispatcher__quals__j_e_i_Any_j_e_i_Default extends Factory<RequestDispatcher> { }
  public abstract class Type_factory__o_u_s_c_SSHClientEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<SSHClientEntryPoint> { }
  public abstract class Type_factory__o_g_m_c_u_UploadFormViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<UploadFormViewImpl> { }
  public abstract class Type_factory__o_d_r_c_m_MetricDisplayer__quals__j_e_i_Any_j_e_i_Default extends Factory<MetricDisplayer> { }
  public abstract class Type_factory__o_u_e_p_c_u_PreferenceFormBeansInfo__quals__j_e_i_Any_j_e_i_Default extends Factory<PreferenceFormBeansInfo> { }
  public abstract class Type_factory__o_u_e_l_e_c_w_KebabWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<KebabWidget> { }
  public abstract class Type_factory__o_u_c_v_p_w_ErrorPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<ErrorPopup> { }
  public abstract class Type_factory__o_d_w_s_t_t_TestScenarioResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset extends Factory<TestScenarioResourceTypeDefinition> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_p_ProjectClassListViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectClassListViewImpl> { }
  public abstract class Type_factory__o_j_e_u_c_l_s_TranslationServiceProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<TranslationServiceProvider> { }
  public abstract class Type_factory__o_e_u_s_a_c_u_SocialUserImageProviderImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<SocialUserImageProviderImpl> { }
  public abstract class Type_factory__o_u_p_c_s_ClientUsernameProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<ClientUsernameProvider> { }
  public abstract class Type_factory__o_u_c_e_VFSJSExporter__quals__j_e_i_Any_j_e_i_Default extends Factory<VFSJSExporter> { }
  public abstract class Type_factory__o_d_d_c_w_g_ColumnFunctionEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnFunctionEditor> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_w_l_AddProjectButtonView__quals__j_e_i_Any_j_e_i_Default extends Factory<AddProjectButtonView> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_c_c_r_ContainerRulesConfigView__quals__j_e_i_Any_j_e_i_Default extends Factory<ContainerRulesConfigView> { }
  public abstract class Type_factory__o_d_c_n_w_e_NavRootNodeEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<NavRootNodeEditor> { }
  public abstract class Type_factory__o_u_c_w_p_i_AdaptiveWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<AdaptiveWorkbenchPanelPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_p_d_DeleteProjectPopUpView__quals__j_e_i_Any_j_e_i_Default extends Factory<DeleteProjectPopUpView> { }
  public abstract class Type_factory__o_k_w_c_w_c_w_KieSelectElementView__quals__j_e_i_Any_j_e_i_Default extends Factory<KieSelectElementView> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_a_InvalidProjectView__quals__j_e_i_Any_j_e_i_Default extends Factory<InvalidProjectView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_c_ActionInsertFactFieldPatternCell__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionInsertFactFieldPatternCell> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDataObjectFieldEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<AdvancedDataObjectFieldEditor> { }
  public abstract class ExtensionProvided_factory__o_g_e_s_c_u_Select__quals__j_e_i_Any_j_e_i_Default extends Factory<org.gwtbootstrap3.extras.select.client.ui.Select> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_n_PermissionExceptionSwitch__quals__j_e_i_Any_j_e_i_Default extends Factory<PermissionExceptionSwitch> { }
  public abstract class Type_factory__o_u_e_p_c_c_PluginConfigService__quals__j_e_i_Any_j_e_i_Default extends Factory<PluginConfigService> { }
  public abstract class Type_factory__o_g_s_c_e_f_FileExplorerPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<FileExplorerPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_c_c_p_ContributorsPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<ContributorsPerspective> { }
  public abstract class Type_factory__o_d_w_s_g_t_c_e_GuidedRuleTemplateEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedRuleTemplateEditorViewImpl> { }
  public abstract class JsType_factory__o_u_c_w_t_ClientResourceType__quals__Universal extends Factory<ClientResourceType> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_w_p_NewAssetHandlerCardWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<NewAssetHandlerCardWidget> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_e_ExternalDataObjectsPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ExternalDataObjectsPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_m_MainDataObjectFieldEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<MainDataObjectFieldEditor> { }
  public abstract class Type_factory__o_d_r_c_s_SelectorSliderDisplayerView__quals__j_e_i_Any_j_e_i_Default extends Factory<SelectorSliderDisplayerView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_MetaDataColumnConverter__quals__j_e_i_Any_j_e_i_Default extends Factory<MetaDataColumnConverter> { }
  public abstract class JsType_factory__o_u_w_m_ActivityResourceType__quals__Universal extends Factory<ActivityResourceType> { }
  public abstract class Type_factory__o_u_c_w_p_u_p_UnanchoredWorkbenchPartPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<UnanchoredWorkbenchPartPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_Div__quals__j_e_i_Any_j_e_i_Default extends Factory<org.kie.workbench.common.screens.server.management.client.widget.Div> { }
  public abstract class Type_factory__o_d_d_c_w_f_MultipleNumberParameterEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<MultipleNumberParameterEditor> { }
  public abstract class Type_factory__o_d_c_c_e_f_FileUploadEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<FileUploadEditorView> { }
  public abstract class Type_factory__o_e_u_s_a_c_w_r_SocialRelationsWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<SocialRelationsWidget> { }
  public abstract class Type_factory__o_d_w_s_g_t_c_e_GuidedRuleTemplateEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<GuidedRuleTemplateEditorPresenterActivity> { }
  public abstract class Producer_factory__o_j_e_i_c_c_SyncBeanManager__quals__j_e_i_Any_j_e_i_Default extends Factory<SyncBeanManager> { }
  public abstract class Type_factory__o_u_e_l_e_c_c_r_Row__quals__j_e_i_Any_j_e_i_Default extends Factory<Row> { }
  public abstract class Type_factory__o_k_w_c_w_c_h_PackageListBoxViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PackageListBoxViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_w_e_e_ExampleProjectErrorView__quals__j_e_i_Any_j_e_i_Default extends Factory<ExampleProjectErrorView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_GuidedDecisionTableEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDecisionTableEditorEntryPoint> { }
  public abstract class Type_factory__o_d_d_e_c_p_DataSetAuthoringPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<DataSetAuthoringPerspectiveActivity> { }
  public abstract class Type_factory__o_u_e_w_c_c_w_WizardViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<WizardViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_EmptyLibraryScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<EmptyLibraryScreen> { }
  public abstract class ExtensionProvided_factory__o_u_c_w_w_p_StaticFocusedResizePanel__quals__j_e_i_Any_j_e_i_Default extends Factory<StaticFocusedResizePanel> { }
  public abstract class Type_factory__o_u_c_w_p_n_p_WorkbenchPartView__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchPartView> { }
  public abstract class Type_factory__o_k_w_c_w_c_w_KieSelectElement_OptionsListPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<OptionsListPresenter> { }
  public abstract class Type_factory__o_u_c_w_w_m_m_c_ChildContextMenuItemPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ChildContextMenuItemPresenter> { }
  public abstract class Provider_factory__o_j_e_u_c_l_s_TranslationService__quals__j_e_i_Any_j_e_i_Default extends Factory<TranslationService> { }
  public abstract class Type_factory__o_u_c_v_p_m_m_m_IconMenuItemView__quals__j_e_i_Any_j_e_i_Default extends Factory<IconMenuItemView> { }
  public abstract class Type_factory__o_u_c_w_d_UberfireDocksContainer__quals__j_e_i_Any_j_e_i_Default extends Factory<UberfireDocksContainer> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_a_i_AnnotationValuePairListItem__quals__j_e_i_Any_j_e_i_Default extends Factory<AnnotationValuePairListItem> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_ACLViewer__quals__j_e_i_Any_j_e_i_Default extends Factory<ACLViewer> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_a_ArtifactListWidgetView__quals__j_e_i_Any_j_e_i_Default extends Factory<ArtifactListWidgetView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_d_ActionInsertFactCol52DefinitionBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionInsertFactCol52DefinitionBuilder> { }
  public abstract class ExtensionProvided_factory__c_g_g_u_c_u_TextBox__quals__j_e_i_Any_j_e_i_Default extends Factory<com.google.gwt.user.client.ui.TextBox> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_w_MetadataWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<MetadataWidget> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_u_ResourceUtils__quals__j_e_i_Any_j_e_i_Default extends Factory<ResourceUtils> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_e_DataObjectBrowserViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DataObjectBrowserViewImpl> { }
  public abstract class Provider_factory__o_j_e_u_n_c_l_NavigationPanel__quals__j_e_i_Any_j_e_i_Default extends Factory<NavigationPanel> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_MetaDataColumnPlugin__quals__j_e_i_Any_j_e_i_Default extends Factory<MetaDataColumnPlugin> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_c_DefaultPatternCell__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultPatternCell> { }
  public abstract class Type_factory__o_u_e_l_e_c_c_c_ComponentColumnView__quals__j_e_i_Any_j_e_i_Default extends Factory<ComponentColumnView> { }
  public abstract class Type_factory__o_k_w_c_w_c_p_a_AboutPopupView__quals__j_e_i_Any_j_e_i_Default extends Factory<AboutPopupView> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_u_s_KieEnumSelectElement__quals__j_e_i_Any_j_e_i_Default extends Factory<KieEnumSelectElement> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_u_UserAttributesEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<UserAttributesEditorView> { }
  public abstract class ContextualProvider_factory__o_j_e_c_c_a_Caller__quals__Universal extends Factory<Caller> { }
  public abstract class Producer_factory__o_j_e_b_c_a_ClientMessageBus__quals__j_e_i_Any_j_e_i_Default extends Factory<ClientMessageBus> { }
  public abstract class Type_factory__o_u_e_e_c_c_m_DownloadMenuItem__quals__j_e_i_Any_j_e_i_Default extends Factory<DownloadMenuItem> { }
  public abstract class Type_factory__o_d_c_w_d_e_DataSetDefProviderTypeEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefProviderTypeEditorView> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_FieldSet__quals__j_e_i_Any_j_e_i_Default extends Factory<FieldSet> { }
  public abstract class JsType_factory__o_u_s_ResourceAction__quals__Universal extends Factory<ResourceAction> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_c_ActionSetFieldCell__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionSetFieldCell> { }
  public abstract class Type_factory__o_u_c_w_VFSServiceProxyClientImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<VFSServiceProxyClientImpl> { }
  public abstract class Type_factory__o_u_e_l_e_c_LayoutEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<LayoutEditorEntryPoint> { }
  public abstract class Type_factory__o_d_c_n_w_e_NavTreeEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<NavTreeEditorView> { }
  public abstract class Type_factory__o_d_c_w_d_e_c_CSVDataSetDefAttributesEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<CSVDataSetDefAttributesEditor> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_p_b_AddBranchPopUpView_BranchOptionView__quals__j_e_i_Any_j_e_i_Default extends Factory<BranchOptionView> { }
  public abstract class Type_factory__o_o_w_s_d_c_w_p_DataObjectFieldPickerViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DataObjectFieldPickerViewImpl> { }
  public abstract class Type_factory__o_d_v_d_CSVDataSetDefValidator__quals__j_e_i_Any_j_e_i_Default extends Factory<CSVDataSetDefValidator> { }
  public abstract class JsType_factory__o_u_s_a_ResourceActionRef__quals__Universal extends Factory<ResourceActionRef> { }
  public abstract class Type_factory__o_g_c_s_p_c_Optimization__quals__j_e_i_Any_j_e_i_Default extends Factory<Optimization> { }
  public abstract class Type_factory__o_d_d_e_g_IntervalBuilderDynamicLabel__quals__j_e_i_Any_j_e_i_Default extends Factory<IntervalBuilderDynamicLabel> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_o_c_e_EditContributorsPopUpView__quals__j_e_i_Any_j_e_i_Default extends Factory<EditContributorsPopUpView> { }
  public abstract class JsType_factory__e_d_HTMLSlotElement_AssignedNodesOptionsType__quals__Universal extends Factory<AssignedNodesOptionsType> { }
  public abstract class Type_factory__o_u_e_w_c_c_m_MenuItemWithIconView__quals__j_e_i_Any_o_u_e_w_c_c_m_MenuItemWithIcon extends Factory<MenuItemWithIconView> { }
  public abstract class Type_factory__o_d_c_n_w_NavMenuBarWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<NavMenuBarWidget> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_Row__quals__j_e_i_Any_j_e_i_Default extends Factory<org.gwtbootstrap3.client.ui.Row> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_h_NewGuidedDecisionTreeHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewGuidedDecisionTreeHandler> { }
  public abstract class Type_factory__o_u_e_w_c_t_c_c_WiresTreesScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<WiresTreesScreenActivity> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_ACLEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<ACLEditorView> { }
  public abstract class JsType_factory__e_d_RTCConfigurationInterface_UrlsFieldType__quals__Universal extends Factory<UrlsFieldType> { }
  public abstract class Type_factory__o_u_e_p_c_a_c_AdminPageCategoryPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<AdminPageCategoryPresenter> { }
  public abstract class Type_factory__o_u_e_c_UberfireExperimentalEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<UberfireExperimentalEntryPoint> { }
  public abstract class Type_factory__o_j_e_s_c_l_h_DefaultSecurityExceptionHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultSecurityExceptionHandler> { }
  public abstract class Type_factory__o_k_w_c_w_c_w_KieSelectElementView_Option__quals__j_e_i_Any_j_e_i_Default extends Factory<Option> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_e_ExternalDataObjectsItemView__quals__j_e_i_Any_j_e_i_Default extends Factory<ExternalDataObjectsItemView> { }
  public abstract class Producer_factory__o_u_p_s_PreferenceScopeTypes__quals__j_e_i_Any_o_u_a_Customizable extends Factory<PreferenceScopeTypes> { }
  public abstract class Type_factory__o_u_e_l_e_c_w_LayoutDragComponentGroupView__quals__j_e_i_Any_j_e_i_Default extends Factory<LayoutDragComponentGroupView> { }
  public abstract class Type_factory__o_d_c_c_e_ToggleSwitchEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<ToggleSwitchEditorView> { }
  public abstract class Type_factory__o_u_w_m_i_PanelDefinitionImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PanelDefinitionImpl> { }
  public abstract class Type_factory__o_u_e_e_c_f_e_FileExportsPreferencesBeanGeneratedImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<FileExportsPreferencesBeanGeneratedImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_RuleModellerPageView__quals__j_e_i_Any_j_e_i_Default extends Factory<RuleModellerPageView> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_SettingsView__quals__j_e_i_Any_j_e_i_Default extends Factory<SettingsView> { }
  public abstract class Type_factory__o_d_c_w_d_e_DataSetSummaryView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetSummaryView> { }
  public abstract class Type_factory__o_d_w_s_g_d_t_GuidedDTableGraphResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset extends Factory<GuidedDTableGraphResourceTypeDefinition> { }
  public abstract class Type_factory__o_u_s_c_e_c_SSHKeysEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<SSHKeysEditorViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_u_s_MenuItemView__quals__j_e_i_Any_j_e_i_Default extends Factory<MenuItemView> { }
  public abstract class Type_factory__o_d_c_n_w_NavCarouselWidgetView__quals__j_e_i_Any_j_e_i_Default extends Factory<NavCarouselWidgetView> { }
  public abstract class Type_factory__o_u_e_p_c_c_t_TreeHierarchyInternalItemView__quals__j_e_i_Any_j_e_i_Default extends Factory<TreeHierarchyInternalItemView> { }
  public abstract class Type_factory__o_u_c_v_p_m_MultiScreenView__quals__j_e_i_Any_j_e_i_Default extends Factory<MultiScreenView> { }
  public abstract class Type_factory__o_d_w_s_e_c_h_NewEnumHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewEnumHandler> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_UserGroupsExplorer__quals__j_e_i_Any_j_e_i_Default extends Factory<UserGroupsExplorer> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_ActiveContextOptions__quals__j_e_i_Any_j_e_i_Default extends Factory<ActiveContextOptions> { }
  public abstract class Type_factory__o_g_m_c_w_ArtifactListViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ArtifactListViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_p_b_AddBranchPopUpPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<AddBranchPopUpPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_e_ExternalDataObjectsItemPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ExternalDataObjectsItemPresenter> { }
  public abstract class Type_factory__o_u_e_c_e_g_f_ExperimentalFeatureEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ExperimentalFeatureEditorViewImpl> { }
  public abstract class Type_factory__o_u_c_w_p_i_AdaptiveWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<AdaptiveWorkbenchPanelView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_GuidedDecisionTablePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDecisionTablePresenter> { }
  public abstract class Type_factory__o_o_w_s_d_c_w_p_PlannerDomainScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<PlannerDomainScreenActivity> { }
  public abstract class Type_factory__o_k_w_c_s_j_t_JavaResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset extends Factory<JavaResourceTypeDefinition> { }
  public abstract class Type_factory__o_d_d_e_c_s_DataSetDefExplorerScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefExplorerScreen> { }
  public abstract class Type_factory__o_u_c_w_w_d_WorkbenchDragAndDropManager__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchDragAndDropManager> { }
  public abstract class Type_factory__o_u_e_l_e_c_LayoutEditorPropertiesScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<LayoutEditorPropertiesScreen> { }
  public abstract class Type_factory__o_g_c_s_p_e_t_POMResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<POMResourceTypeDefinition> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_m_MainDomainEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<MainDomainEditor> { }
  public abstract class Type_factory__o_u_c_m_LockManagerImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<LockManagerImpl> { }
  public abstract class Type_factory__o_u_e_w_c_c_s_SelectComponent__quals__j_e_i_Any_j_e_i_Default extends Factory<SelectComponent> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_p_p_NoRepositoryURLViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<NoRepositoryURLViewImpl> { }
  public abstract class Type_factory__o_u_c_m_PerspectiveManagerImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectiveManagerImpl> { }
  public abstract class Type_factory__o_d_c_c_p_ContentManagerPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<ContentManagerPerspective> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_ValueOptionsPage__quals__j_e_i_Any_j_e_i_Default extends Factory<ValueOptionsPage> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_c_i_DefaultClipboard__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultClipboard> { }
  public abstract class Type_factory__o_k_w_c_w_c_t_TestRunnerReportingScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<TestRunnerReportingScreen> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_ServerManagementPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<ServerManagementPerspective> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_a_i_AnnotationListItem__quals__j_e_i_Any_j_e_i_Default extends Factory<AnnotationListItem> { }
  public abstract class Type_factory__o_g_c_s_w_c_WorkingSetManager__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkingSetManager> { }
  public abstract class Type_factory__o_j_e_s_c_l_i_ClientSecurityRoleInterceptor__quals__j_e_i_Any_j_e_i_Default extends Factory<ClientSecurityRoleInterceptor> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_Option__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<org.jboss.errai.common.client.dom.Option> { }
  public abstract class Type_factory__o_u_c_w_StandaloneEditorPerspective__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<StandaloneEditorPerspective> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_d_DependenciesItemPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DependenciesItemPresenter> { }
  public abstract class Type_factory__o_u_e_e_c_c_f_p_CopyPopUpView__quals__j_e_i_Any_o_u_a_FallbackImplementation extends Factory<CopyPopUpView> { }
  public abstract class ContextualProvider_factory__o_j_e_i_c_a_InitBallot__quals__Universal extends Factory<InitBallot> { }
  public abstract class Type_factory__o_d_v_d_BeanDataSetDefValidator__quals__j_e_i_Any_j_e_i_Default extends Factory<BeanDataSetDefValidator> { }
  public abstract class Type_factory__o_d_v_DataSetValidatorProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetValidatorProvider> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_p_ColumnsPage__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnsPage> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_w_c_TileWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<TileWidget> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_b_BusinessViewWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<BusinessViewWidget> { }
  public abstract class Type_factory__o_d_c_c_e_ToggleSwitchEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<ToggleSwitchEditor> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_b_BodyView__quals__j_e_i_Any_j_e_i_Default extends Factory<BodyView> { }
  public abstract class Type_factory__o_d_c_c_w_PerspectivesExplorerView__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectivesExplorerView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_GuidedDecisionTreeEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDecisionTreeEditorPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_ExplorerMenuViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ExplorerMenuViewImpl> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_Input__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<Input> { }
  public abstract class JsType_factory__e_d_File_FilePropertiesType__quals__Universal extends Factory<FilePropertiesType> { }
  public abstract class Type_factory__o_d_c_w_d_e_w_c_DataSetProviderTypeWorkflow__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetProviderTypeWorkflow> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_d_ConditionCol52DefinitionBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<ConditionCol52DefinitionBuilder> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_EmptyState__quals__j_e_i_Any_j_e_i_Default extends Factory<EmptyState> { }
  public abstract class Type_factory__o_u_c_u_Clipboard__quals__j_e_i_Any_j_e_i_Default extends Factory<Clipboard> { }
  public abstract class Type_factory__o_d_d_c_u_ClientUUIDGenerator__quals__j_e_i_Any_j_e_i_Default extends Factory<ClientUUIDGenerator> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_c_s_e_ContainerStatusEmptyView__quals__j_e_i_Any_j_e_i_Default extends Factory<ContainerStatusEmptyView> { }
  public abstract class Type_factory__o_u_e_s_m_c_ClientUserSystemManager__quals__j_e_i_Any_j_e_i_Default extends Factory<ClientUserSystemManager> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_r_e_RemoteEmptyView__quals__j_e_i_Any_j_e_i_Default extends Factory<RemoteEmptyView> { }
  public abstract class Type_factory__o_u_e_a_c_h_AppsHomePresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<AppsHomePresenterActivity> { }
  public abstract class Type_factory__o_u_c_v_p_t_TabPanelWithDropdowns__quals__j_e_i_Any_j_e_i_Default extends Factory<TabPanelWithDropdowns> { }
  public abstract class Type_factory__o_u_e_l_e_c_c_r_RowView__quals__j_e_i_Any_j_e_i_Default extends Factory<RowView> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDomainScreenViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<AdvancedDomainScreenViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_v_r_c_p_IssuePresenterViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<IssuePresenterViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_ProjectImportsScreenPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectImportsScreenPresenter> { }
  public abstract class Type_factory__o_u_c_e_UberfireJSAPIExporter__quals__j_e_i_Any_j_e_i_Default extends Factory<UberfireJSAPIExporter> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_ProjectImportsScreenViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectImportsScreenViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_CalculationTypePageView__quals__j_e_i_Any_j_e_i_Default extends Factory<CalculationTypePageView> { }
  public abstract class Type_factory__o_d_c_c_w_NewPerspectivePopUp__quals__j_e_i_Any_j_e_i_Default extends Factory<NewPerspectivePopUp> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_u_UserAssignedGroupsExplorer__quals__j_e_i_Any_j_e_i_Default extends Factory<UserAssignedGroupsExplorer> { }
  public abstract class JsType_factory__e_d_Document_RegisterOptionsType__quals__Universal extends Factory<RegisterOptionsType> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_p_ProjectMetricsView__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectMetricsView> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_p_PackageSelectorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PackageSelectorViewImpl> { }
  public abstract class Type_factory__o_d_c_w_d_e_DataSetExplorer__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetExplorer> { }
  public abstract class Type_factory__o_k_w_c_w_c_h_w_c_LanguageConfigurationHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<LanguageConfigurationHandler> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_k_i_k_KnowledgeSessionsModal_KnowledgeBasesListPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<KnowledgeBasesListPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_ServerManagementBrowserPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ServerManagementBrowserPresenterActivity> { }
  public abstract class Type_factory__o_u_e_p_c_a_p_AdminPageImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<AdminPageImpl> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_i_ImportRepositoryPopUpPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ImportRepositoryPopUpPresenter> { }
  public abstract class ExtensionProvided_factory__o_k_w_c_s_j_c_w_EditJavaSourceWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<EditJavaSourceWidget> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_f_ActionRetractNodeFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionRetractNodeFactory> { }
  public abstract class ContextualProvider_factory__o_j_e_u_n_c_l_TransitionAnchor__quals__Universal extends Factory<TransitionAnchor> { }
  public abstract class Type_factory__o_d_c_w_d_e_a_DataSetDefRefreshAttributesEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefRefreshAttributesEditor> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ActionWorkItemExecuteColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionWorkItemExecuteColumnSynchronizer> { }
  public abstract class Type_factory__o_o_w_s_s_c_e_XMLViewerImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<XMLViewerImpl> { }
  public abstract class Type_factory__o_u_e_p_c_a_AdminPagePerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<AdminPagePerspective> { }
  public abstract class Type_factory__o_u_e_l_e_c_c_c_Container__quals__j_e_i_Any_j_e_i_Default extends Factory<org.uberfire.ext.layout.editor.client.components.container.Container> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_o_EmptyOrganizationalUnitsScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<EmptyOrganizationalUnitsScreen> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_GuidedDecisionTableModellerPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDecisionTableModellerPresenter> { }
  public abstract class Type_factory__o_u_c_w_w_m_m_m_IconMenuItemPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<IconMenuItemPresenter> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_GuidedDecisionTableEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDecisionTableEditorPresenter> { }
  public abstract class Type_factory__o_d_c_c_s_h_ContentManagerHomeScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<ContentManagerHomeScreen> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_d_DroolsDataObjectFieldEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DroolsDataObjectFieldEditor> { }
  public abstract class Type_factory__o_d_c_w_d_e_a_DataSetDefClientCacheAttributesEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefClientCacheAttributesEditor> { }
  public abstract class Type_factory__o_u_e_l_e_c_c_r_EmptyDropRowView__quals__j_e_i_Any_j_e_i_Default extends Factory<EmptyDropRowView> { }
  public abstract class Type_factory__o_u_c_DocksEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<DocksEntryPoint> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_f_TypeNodeFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<TypeNodeFactory> { }
  public abstract class Type_factory__o_u_e_p_c_e_DynamicMenuEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DynamicMenuEditorView> { }
  public abstract class Type_factory__o_u_e_c_e_ExperimentalFeaturesEditorScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ExperimentalFeaturesEditorScreenActivity> { }
  public abstract class Type_factory__o_j_e_i_s_b_c_BatchCallerProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<BatchCallerProvider> { }
  public abstract class Type_factory__o_g_s_c_e_r_e_RepositoryEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryEditorView> { }
  public abstract class Producer_factory__o_u_e_e_c_c_f_e_ImageFileExport__quals__j_e_i_Any_j_e_i_Default extends Factory<ImageFileExport> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_ActiveContextManager__quals__j_e_i_Any_j_e_i_Default extends Factory<ActiveContextManager> { }
  public abstract class Type_factory__o_k_w_c_w_c_m_c_AppsCustomMenuBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<AppsCustomMenuBuilder> { }
  public abstract class JsType_factory__j_u_Set__quals__Universal extends Factory<Set> { }
  public abstract class Type_factory__o_u_e_p_c_i_PluginsInfo__quals__j_e_i_Any_j_e_i_Default extends Factory<PluginsInfo> { }
  public abstract class Producer_factory__e_d_HTMLDocument__quals__j_e_i_Any_j_e_i_Default extends Factory<HTMLDocument> { }
  public abstract class Type_factory__o_o_w_s_d_c_w_p_PlannerDataObjectFieldEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PlannerDataObjectFieldEditorViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_v_r_c_p_AnalysisReportScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<AnalysisReportScreenActivity> { }
  public abstract class Type_factory__o_d_c_w_d_e_DataSetDefPreviewTableView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefPreviewTableView> { }
  public abstract class Type_factory__o_u_e_w_c_c_w_WizardPageTitle__quals__j_e_i_Any_j_e_i_Default extends Factory<WizardPageTitle> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_k_i_i_IncludedKnowledgeBaseItemPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<IncludedKnowledgeBaseItemPresenter> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_v_JavaAssetUpdateValidator__quals__j_e_i_Any_j_e_i_Default extends Factory<JavaAssetUpdateValidator> { }
  public abstract class Type_factory__o_g_m_c_M2RepoEditorPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<M2RepoEditorPresenterActivity> { }
  public abstract class Type_factory__o_u_e_e_c_c_h_SaveButton__quals__j_e_i_Any_j_e_i_Default extends Factory<SaveButton> { }
  public abstract class Type_factory__o_k_w_c_w_c_p_l_FormListPopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<FormListPopupViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_v_g_GenericValuePairEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<GenericValuePairEditor> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_p_PersistencePresenter_PersistableDataObjectsListPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<PersistableDataObjectsListPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_f_FooterView__quals__j_e_i_Any_j_e_i_Default extends Factory<FooterView> { }
  public abstract class Type_factory__o_u_e_c_d_s_DisabledFeatureActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<DisabledFeatureActivity> { }
  public abstract class Type_factory__o_d_r_c_s_SelectorDisplayerView__quals__j_e_i_Any_j_e_i_Default extends Factory<SelectorDisplayerView> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_p_b_d_DeleteBranchPopUpView__quals__j_e_i_Any_j_e_i_Default extends Factory<DeleteBranchPopUpView> { }
  public abstract class Type_factory__o_k_w_c_w_c_p_l_FormListPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<FormListPopup> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_j_o_JPANewResourceOptions__quals__j_e_i_Any_j_e_i_Default extends Factory<JPANewResourceOptions> { }
  public abstract class Type_factory__o_d_d_c_e_ClientIntervalBuilderLocator__quals__j_e_i_Any_j_e_i_Default extends Factory<ClientIntervalBuilderLocator> { }
  public abstract class Type_factory__o_u_e_w_c_c_w_w_p_a_n_ActivityNotFoundPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ActivityNotFoundPresenter> { }
  public abstract class Type_factory__o_j_e_i_c_l_i_AccessImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<AccessImpl> { }
  public abstract class Type_factory__o_u_e_p_c_e_PluginExplorerScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<PluginExplorerScreenActivity> { }
  public abstract class Type_factory__o_d_w_s_t_c_FixtureLayout__quals__j_e_i_Any_j_e_i_Default extends Factory<FixtureLayout> { }
  public abstract class Type_factory__o_k_w_c_s_v_r_c_p_IssuePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<IssuePresenter> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_f_ConstraintNodeFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<ConstraintNodeFactory> { }
  public abstract class Type_factory__o_u_c_v_p_t_WorkbenchToolBarView__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchToolBarView> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_m_RegisteredDocumentsMenuViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<RegisteredDocumentsMenuViewImpl> { }
  public abstract class ExtensionProvided_factory__e_d_HTMLOptionElement__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<HTMLOptionElement> { }
  public abstract class Type_factory__o_d_c_w_d_e_b_BeanDataSetDefAttributesEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<BeanDataSetDefAttributesEditorView> { }
  public abstract class Type_factory__o_d_v_d_SQLDataSetDefValidator__quals__j_e_i_Any_j_e_i_Default extends Factory<SQLDataSetDefValidator> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_j_p_IdGeneratorField__quals__j_e_i_Any_j_e_i_Default extends Factory<IdGeneratorField> { }
  public abstract class Type_factory__o_d_w_s_d_c_e_DSLEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DSLEditorPresenter> { }
  public abstract class Type_factory__o_k_w_c_w_c_d_AsyncPackageDataModelOracleImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<AsyncPackageDataModelOracleImpl> { }
  public abstract class Type_factory__o_u_e_w_c_c_t_PagedTable__quals__j_e_i_Any_j_e_i_Default extends Factory<PagedTable> { }
  public abstract class Type_factory__o_d_d_c_w_DisplayerSettingsEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerSettingsEditorView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ActionRetractFactColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionRetractFactColumnSynchronizer> { }
  public abstract class Type_factory__o_u_e_w_c_c_a_ActionsScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ActionsScreenActivity> { }
  public abstract class Type_factory__o_k_w_c_w_c_p_v_ValidationPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<ValidationPopup> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_ActionInsertFactFieldsPage__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionInsertFactFieldsPage> { }
  public abstract class Type_factory__o_o_w_c_RepositoryPreferencesProducer__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryPreferencesProducer> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_t_TechnicalViewPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<TechnicalViewPresenter> { }
  public abstract class Type_factory__o_u_c_v_p_n_ActivityNotFoundView__quals__j_e_i_Any_j_e_i_Default extends Factory<org.uberfire.client.views.pfly.notfound.ActivityNotFoundView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_d_ColumnDefinitionFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnDefinitionFactory> { }
  public abstract class JsType_factory__e_d_Document_RegisterElementOptionsType__quals__Universal extends Factory<RegisterElementOptionsType> { }
  public abstract class Type_factory__o_u_c_v_p_w_KebabMenuItem__quals__j_e_i_Any_j_e_i_Default extends Factory<KebabMenuItem> { }
  public abstract class Type_factory__o_u_c_e_SplashScreenJSExporter__quals__j_e_i_Any_j_e_i_Default extends Factory<SplashScreenJSExporter> { }
  public abstract class Type_factory__o_u_e_w_c_c_f_ShapeFactoryCache__quals__j_e_i_Any_j_e_i_Default extends Factory<ShapeFactoryCache> { }
  public abstract class JsType_factory__j_u_Map__quals__Universal extends Factory<Map> { }
  public abstract class Type_factory__o_d_c_c_e_l_HorizImageListEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<HorizImageListEditor> { }
  public abstract class Type_factory__o_d_c_w_d_e_DataSetPanelView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetPanelView> { }
  public abstract class Type_factory__o_u_e_e_c_c_f_p_c_ToggleCommentView__quals__j_e_i_Any_j_e_i_Default extends Factory<ToggleCommentView> { }
  public abstract class Type_factory__o_u_c_v_p_s_SplashModalFooter__quals__j_e_i_Any_j_e_i_Default extends Factory<SplashModalFooter> { }
  public abstract class Type_factory__o_k_w_c_s_j_c_e_JavaEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<JavaEditorPresenterActivity> { }
  public abstract class Type_factory__o_u_e_w_c_c_e_d_DefaultFileEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<DefaultFileEditorPresenterActivity> { }
  public abstract class Type_factory__o_g_m_c_M2RepoEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<M2RepoEditorEntryPoint> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_u_d_KieDropdownElement_ItemsListPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ItemsListPresenter> { }
  public abstract class Type_factory__o_d_c_w_c_LoadingBox__quals__j_e_i_Any_j_e_i_Default extends Factory<LoadingBox> { }
  public abstract class Type_factory__o_k_w_c_w_c_h_NewResourcePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<NewResourcePresenter> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_Paragraph__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<org.jboss.errai.common.client.dom.Paragraph> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ActionWorkItemSetFieldColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionWorkItemSetFieldColumnSynchronizer> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_b_BodyPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<BodyPresenter> { }
  public abstract class JsType_factory__o_u_w_m_m_MenuItemCommand__quals__Universal extends Factory<MenuItemCommand> { }
  public abstract class Type_factory__o_u_e_p_c_t_DynamicMenuResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<DynamicMenuResourceType> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_Anchor__quals__j_e_i_Any_j_e_i_Default extends Factory<org.gwtbootstrap3.client.ui.Anchor> { }
  public abstract class Type_factory__o_d_r_c_t_TableDisplayerView__quals__j_e_i_Any_j_e_i_Default extends Factory<TableDisplayerView> { }
  public abstract class JsType_factory__e_d_HashChangeEvent_HashChangeEventEventInitDictType__quals__Universal extends Factory<HashChangeEventEventInitDictType> { }
  public abstract class Type_factory__o_k_w_c_w_c_d_AuthoringWorkbenchDocks__quals__j_e_i_Any_j_e_i_Default extends Factory<AuthoringWorkbenchDocks> { }
  public abstract class Type_factory__o_k_w_c_s_r_c_u_ShowAssetUsagesDisplayer__quals__j_e_i_Any_j_e_i_Default extends Factory<ShowAssetUsagesDisplayer> { }
  public abstract class Type_factory__o_u_e_s_m_c_e_u_UserEditorDriver__quals__j_e_i_Any_j_e_i_Default extends Factory<UserEditorDriver> { }
  public abstract class Type_factory__o_d_w_s_d_c_t_DecisionTableXLSXResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<DecisionTableXLSXResourceType> { }
  public abstract class Type_factory__o_d_w_s_w_c_w_WorkItemMetaDataLoader__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkItemMetaDataLoader> { }
  public abstract class Type_factory__o_u_c_a_EditorTreeProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<EditorTreeProvider> { }
  public abstract class Provider_factory__c_g_g_u_c_u_RootPanel__quals__j_e_i_Any_j_e_i_Default extends Factory<RootPanel> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_h_m_MainDomainHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<MainDomainHandler> { }
  public abstract class Type_factory__o_u_p_s_i_PreferenceScopeTypesProducer__quals__j_e_i_Any_j_e_i_Default extends Factory<PreferenceScopeTypesProducer> { }
  public abstract class Type_factory__o_d_w_s_w_t_WorkItemsTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset extends Factory<WorkItemsTypeDefinition> { }
  public abstract class Type_factory__o_d_c_n_w_NavTilesWidgetView__quals__j_e_i_Any_j_e_i_Default extends Factory<NavTilesWidgetView> { }
  public abstract class Type_factory__o_u_e_w_c_c_a_ActionsGroup__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionsGroup> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_w_p_AssetsActionsWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<AssetsActionsWidget> { }
  public abstract class Type_factory__o_u_c_w_p_i_StaticWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<StaticWorkbenchPanelView> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_b_BusinessViewPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<BusinessViewPresenter> { }
  public abstract class Type_factory__o_g_s_c_s_OrganizationalUnitController__quals__j_e_i_Any_j_e_i_Default extends Factory<OrganizationalUnitController> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ConditionColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default extends Factory<ConditionColumnSynchronizer> { }
  public abstract class Type_factory__o_d_c_c_s_e_NavigationExplorerScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<NavigationExplorerScreenActivity> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_j_JPADataObjectEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<JPADataObjectEditorViewImpl> { }
  public abstract class Type_factory__o_d_c_c_w_PerspectiveWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectiveWidget> { }
  public abstract class Type_factory__o_u_c_w_p_i_MultiScreenWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<MultiScreenWorkbenchPanelPresenter> { }
  public abstract class Producer_factory__o_u_c_w_w_m_WorkbenchMenuBarPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchMenuBarPresenter> { }
  public abstract class JsType_factory__o_u_w_m_t_ToolBar__quals__Universal extends Factory<ToolBar> { }
  public abstract class Type_factory__o_g_c_s_p_p_GAVPreferencesBeanGeneratedImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<GAVPreferencesBeanGeneratedImpl> { }
  public abstract class Type_factory__o_d_c_n_l_e_NavTreeDragComponent__quals__j_e_i_Any_j_e_i_Default extends Factory<NavTreeDragComponent> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_k_i_KnowledgeBaseItemPresenter_IncludedKnowledgeBasesListPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<IncludedKnowledgeBasesListPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_ActiveContextItems__quals__j_e_i_Any_j_e_i_Default extends Factory<ActiveContextItems> { }
  public abstract class Type_factory__o_u_s_c_e_c_k_k_SSHKeyEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<SSHKeyEditor> { }
  public abstract class Type_factory__o_d_w_s_t_c_p_a_AuditTableItem__quals__j_e_i_Any_j_e_i_Default extends Factory<AuditTableItem> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_NewGuidedDecisionTableWizardHelper__quals__j_e_i_Any_j_e_i_Default extends Factory<NewGuidedDecisionTableWizardHelper> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_f_FooterPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<FooterPresenter> { }
  public abstract class Type_factory__o_u_c_v_p_m_SplashScreenMenuView__quals__j_e_i_Any_j_e_i_Default extends Factory<SplashScreenMenuView> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_p_LibraryPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<LibraryPerspectiveActivity> { }
  public abstract class Type_factory__o_j_e_i_c_l_i_DestructionImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DestructionImpl> { }
  public abstract class Type_factory__o_d_w_s_d_c_e_DRLEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DRLEditorViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_j_JPADomainScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<JPADomainScreen> { }
  public abstract class ExtensionProvided_factory__e_d_HTMLHeadingElement__quals__j_e_i_Any_j_e_i_Default_j_i_Named_1 extends Factory<HTMLHeadingElement> { }
  public abstract class Type_factory__o_u_e_e_c_c_h_HtmlEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<HtmlEditorView> { }
  public abstract class Type_factory__o_u_c_w_w_d_CompassDropController__quals__j_e_i_Any_j_e_i_Default extends Factory<CompassDropController> { }
  public abstract class Type_factory__o_o_w_s_s_c_e_ConstructionHeuristicFormViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ConstructionHeuristicFormViewImpl> { }
  public abstract class Type_factory__o_d_c_w_d_e_DataSetPanel__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetPanel> { }
  public abstract class Type_factory__o_d_r_c_s_SelectorLabelSetDisplayerView__quals__j_e_i_Any_j_e_i_Default extends Factory<SelectorLabelSetDisplayerView> { }
  public abstract class Type_factory__o_g_c_s_p_c_c_WorkspaceProjectContext__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkspaceProjectContext> { }
  public abstract class Type_factory__o_u_e_p_c_c_PreferencesCentralNavBarScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<PreferencesCentralNavBarScreen> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_OperatorPage__quals__j_e_i_Any_j_e_i_Default extends Factory<OperatorPage> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_c_e_ServerContainerEmptyPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ServerContainerEmptyPresenter> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_UserGroupsExplorerView__quals__j_e_i_Any_j_e_i_Default extends Factory<UserGroupsExplorerView> { }
  public abstract class Type_factory__o_k_w_c_w_c_p_l_AppLauncherPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<AppLauncherPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_u_LibraryPlaces__quals__j_e_i_Any_j_e_i_Default extends Factory<LibraryPlaces> { }
  public abstract class Type_factory__o_d_c_w_d_e_b_BeanDataSetDefAttributesEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<BeanDataSetDefAttributesEditor> { }
  public abstract class Type_factory__o_d_w_s_g_t_GlobalResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset extends Factory<GlobalResourceTypeDefinition> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_l_UsersList__quals__j_e_i_Any_j_e_i_Default extends Factory<UsersList> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_c_ConditionPatternCell__quals__j_e_i_Any_j_e_i_Default extends Factory<ConditionPatternCell> { }
  public abstract class Type_factory__o_u_c_v_p_m_m_c_ChildContextMenuItemView__quals__j_e_i_Any_j_e_i_Default extends Factory<ChildContextMenuItemView> { }
  public abstract class Type_factory__o_k_w_c_w_c_p_a_AboutPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<AboutPopup> { }
  public abstract class ExtensionProvided_factory__o_k_w_c_w_c_w_BindingTextBox__quals__j_e_i_Any_j_e_i_Default extends Factory<BindingTextBox> { }
  public abstract class Type_factory__o_j_e_s_c_l_r_ClientRequiredRolesExtractorImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ClientRequiredRolesExtractorImpl> { }
  public abstract class Type_factory__o_d_d_c_w_f_ColumnFilterEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnFilterEditor> { }
  public abstract class Type_factory__o_d_c_w_d_e_w_c_BeanDataSetBasicAttributesWorkflow__quals__j_e_i_Any_j_e_i_Default extends Factory<BeanDataSetBasicAttributesWorkflow> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_p_AddProjectPopUpPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<AddProjectPopUpPresenter> { }
  public abstract class Type_factory__o_d_d_c_f_ValueFormatterRegistry__quals__j_e_i_Any_j_e_i_Default extends Factory<ValueFormatterRegistry> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_d_DependencySelectorPopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DependencySelectorPopupViewImpl> { }
  public abstract class JsType_factory__e_d_RTCConfigurationInterface_IceServersFieldType__quals__Universal extends Factory<IceServersFieldType> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_u_b_ProjectBranchBreadcrumbView__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectBranchBreadcrumbView> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_LibraryScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<LibraryScreenActivity> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_d_BRLConditionColumnDefinitionBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<BRLConditionColumnDefinitionBuilder> { }
  public abstract class Type_factory__o_u_e_w_c_c_m_MenuItemFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<MenuItemFactory> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_m_CellContextMenuViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<CellContextMenuViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_k_i_k_KnowledgeSessionsModalView__quals__j_e_i_Any_j_e_i_Default extends Factory<KnowledgeSessionsModalView> { }
  public abstract class Type_factory__o_d_c_w_d_e_a_DataSetDefBackendCacheAttributesEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefBackendCacheAttributesEditor> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_c_DataModelerWorkbenchContext__quals__j_e_i_Any_j_e_i_Default extends Factory<DataModelerWorkbenchContext> { }
  public abstract class Type_factory__o_d_c_c_w_PerspectiveWidgetView__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectiveWidgetView> { }
  public abstract class Type_factory__o_u_e_e_c_c_f_p_RestorePopUpView__quals__j_e_i_Any_j_e_i_Default extends Factory<RestorePopUpView> { }
  public abstract class JsType_factory__o_u_m_Command__quals__Universal extends Factory<Command> { }
  public abstract class Type_factory__o_g_s_c_e_f_FileExplorerPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<FileExplorerPresenterActivity> { }
  public abstract class Type_factory__o_u_e_p_c_PreferencesEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<PreferencesEntryPoint> { }
  public abstract class Type_factory__o_u_e_w_c_c_e_m_MetaFileEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<MetaFileEditorPresenterActivity> { }
  public abstract class Type_factory__o_d_d_c_w_RendererSelectorTabListView__quals__j_e_i_Any_j_e_i_Default extends Factory<RendererSelectorTabListView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_c_c_ColumnManagementView__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnManagementView> { }
  public abstract class Type_factory__o_u_e_p_c_a_AdminPageView__quals__j_e_i_Any_j_e_i_Default extends Factory<AdminPageView> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_w_e_ExampleProjectView__quals__j_e_i_Any_j_e_i_Default extends Factory<ExampleProjectView> { }
  public abstract class Type_factory__o_d_d_c_w_DisplayerViewer__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerViewer> { }
  public abstract class Type_factory__o_g_m_c_w_ArtifactListPresenterImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ArtifactListPresenterImpl> { }
  public abstract class Type_factory__o_g_s_c_e_r_l_RepositoriesViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoriesViewImpl> { }
  public abstract class Type_factory__o_d_c_c_w_AlertBoxView__quals__j_e_i_Any_j_e_i_Default extends Factory<AlertBoxView> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_p_c_CloseUnsavedProjectAssetsPopUpListItemPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<CloseUnsavedProjectAssetsPopUpListItemPresenter> { }
  public abstract class Type_factory__o_d_w_s_t_c_p_s_ScenarioKSessionSelector__quals__j_e_i_Any_j_e_i_Default extends Factory<ScenarioKSessionSelector> { }
  public abstract class Type_factory__o_g_m_c_c_MessageConsoleViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<MessageConsoleViewImpl> { }
  public abstract class Type_factory__o_o_w_s_d_c_h_p_PlannerDomainHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<PlannerDomainHandler> { }
  public abstract class Type_factory__o_d_r_c_DefaultRenderer__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultRenderer> { }
  public abstract class Type_factory__o_k_w_c_w_c_d_DiscussionWidgetViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DiscussionWidgetViewImpl> { }
  public abstract class Type_factory__o_d_w_s_t_c_TestScenarioEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<TestScenarioEditorEntryPoint> { }
  public abstract class Type_factory__o_k_w_c_w_c_m_ResetPerspectivesMenuBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<ResetPerspectivesMenuBuilder> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_p_ColumnsPagePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnsPagePresenter> { }
  public abstract class Type_factory__o_u_c_w_w_n_ActivityNotFoundPresenter__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<org.uberfire.client.workbench.widgets.notfound.ActivityNotFoundPresenter> { }
  public abstract class Type_factory__o_d_c_c_w_NewPerspectivePopUpView__quals__j_e_i_Any_j_e_i_Default extends Factory<NewPerspectivePopUpView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ActionSetFieldColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionSetFieldColumnSynchronizer> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_d_DependencySelectorPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<DependencySelectorPopup> { }
  public abstract class Type_factory__o_d_w_s_e_c_e_EnumEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<EnumEditorPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_NewServerTemplateWizard__quals__j_e_i_Any_j_e_i_Default extends Factory<NewServerTemplateWizard> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_j_JPADomainEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<JPADomainEditor> { }
  public abstract class Type_factory__o_o_w_s_g_c_p_MultiConstraintBendableLongMatchRuleModellerActionPlugin__quals__j_e_i_Any_j_e_i_Default extends Factory<MultiConstraintBendableLongMatchRuleModellerActionPlugin> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDomainScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<AdvancedDomainScreenActivity> { }
  public abstract class Type_factory__o_d_d_c_w_DisplayerTypeSelectorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerTypeSelectorView> { }
  public abstract class Type_factory__o_u_c_w_p_i_ClosableSimpleWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ClosableSimpleWorkbenchPanelPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_DataModelerScreenViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DataModelerScreenViewImpl> { }
  public abstract class ExtensionProvided_factory__e_d_HTMLDivElement__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<HTMLDivElement> { }
  public abstract class Type_factory__o_j_e_s_c_l_s_RoleStyleBindingProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<RoleStyleBindingProvider> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_ACLSettingsView__quals__j_e_i_Any_j_e_i_Default extends Factory<ACLSettingsView> { }
  public abstract class Type_factory__o_u_e_w_c_c_b_h_UberfireBreadcrumbsContainerImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<UberfireBreadcrumbsContainerImpl> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_p_LibraryPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<LibraryPerspective> { }
  public abstract class Type_factory__o_d_c_n_w_NavTreeWidgetView__quals__j_e_i_Any_j_e_i_Default extends Factory<NavTreeWidgetView> { }
  public abstract class Type_factory__o_d_w_s_e_c_t_EnumResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<EnumResourceType> { }
  public abstract class JsType_factory__o_j_e_i_c_c_JsTypeProvider__quals__Universal extends Factory<JsTypeProvider> { }
  public abstract class Type_factory__o_u_c_w_p_i_SimpleDnDWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default extends Factory<SimpleDnDWorkbenchPanelView> { }
  public abstract class Type_factory__o_d_c_w_d_e_w_e_BeanDataSetEditWorkflow__quals__j_e_i_Any_j_e_i_Default extends Factory<BeanDataSetEditWorkflow> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_e_DeploymentScreenPopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DeploymentScreenPopupViewImpl> { }
  public abstract class Type_factory__o_u_e_w_c_c_d_f_LiveSearchFooter__quals__j_e_i_Any_j_e_i_Default extends Factory<LiveSearchFooter> { }
  public abstract class Type_factory__o_o_w_s_s_c_SolverEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<SolverEditorEntryPoint> { }
  public abstract class ExtensionProvided_factory__e_d_HTMLTextAreaElement__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<HTMLTextAreaElement> { }
  public abstract class Type_factory__o_u_c_v_p_m_WorkbenchMenuBarView__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchMenuBarView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ActionColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionColumnSynchronizer> { }
  public abstract class Type_factory__o_j_e_e_c_c_EventProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<EventProvider> { }
  public abstract class Type_factory__o_k_w_c_s_s_p_c_WorkbenchPreferenceScopeResolutionStrategiesImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchPreferenceScopeResolutionStrategiesImpl> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_DataModelerScreenPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<DataModelerScreenPresenterActivity> { }
  public abstract class Type_factory__o_o_w_s_d_c_w_p_PlannerDataObjectEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<PlannerDataObjectEditor> { }
  public abstract class Type_factory__o_u_e_l_e_c_w_LayoutComponentPalettePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<LayoutComponentPalettePresenter> { }
  public abstract class Type_factory__o_d_w_s_d_c_e_DSLEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<DSLEditorPresenterActivity> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_GuidedDecisionTreeEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<GuidedDecisionTreeEditorPresenterActivity> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_e_PackageNameWhiteListResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<PackageNameWhiteListResourceType> { }
  public abstract class Type_factory__o_d_d_c_w_f_MultipleTextParameterEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<MultipleTextParameterEditorView> { }
  public abstract class Type_factory__o_u_c_e_PlaceManagerJSExporter__quals__j_e_i_Any_j_e_i_Default extends Factory<PlaceManagerJSExporter> { }
  public abstract class Type_factory__o_u_s_c_e_c_k_SSHKeysDisplayerViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<SSHKeysDisplayerViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_RowSynchronizer__quals__j_e_i_Any_j_e_i_Default extends Factory<RowSynchronizer> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_r_RoleEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<RoleEditorView> { }
  public abstract class Type_factory__o_u_e_p_c_p_e_a_PerspectiveEditorCoreGroupProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectiveEditorCoreGroupProvider> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_Heading__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<Heading> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_GuidedDecisionTableEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<GuidedDecisionTableEditorPresenterActivity> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_k_i_k_KnowledgeSessionListItemPresenter_WorkItemHandlersListPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkItemHandlersListPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_k_i_k_l_ListenerListItemView__quals__j_e_i_Any_j_e_i_Default extends Factory<ListenerListItemView> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_u_UserEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<UserEditor> { }
  public abstract class Type_factory__o_d_w_s_g_r_t_GuidedRuleDSLRResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset extends Factory<GuidedRuleDSLRResourceTypeDefinition> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_AssetListView__quals__j_e_i_Any_j_e_i_Default extends Factory<AssetListView> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_t_TagSelectorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<TagSelectorViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_GuidedDecisionTableModellerContextMenuSupport__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDecisionTableModellerContextMenuSupport> { }
  public abstract class Type_factory__o_u_e_w_c_c_a_ActionsScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionsScreen> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_a_PopulatedAssetsView__quals__j_e_i_Any_j_e_i_Default extends Factory<PopulatedAssetsView> { }
  public abstract class Type_factory__o_u_c_v_p_m_m_m_GroupMenuItemView__quals__j_e_i_Any_j_e_i_Default extends Factory<GroupMenuItemView> { }
  public abstract class Type_factory__o_k_w_c_s_l_a_p_LibraryPreferencesBeanGeneratedImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<LibraryPreferencesBeanGeneratedImpl> { }
  public abstract class Type_factory__o_d_c_w_d_e_c_ColumnListEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnListEditorView> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_v_ValidationItemView__quals__j_e_i_Any_j_e_i_Default extends Factory<ValidationItemView> { }
  public abstract class Type_factory__o_u_e_p_c_e_SplashEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<SplashEditorPresenter> { }
  public abstract class Type_factory__o_d_w_s_d_c_t_DSLResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<DSLResourceType> { }
  public abstract class Type_factory__o_u_c_w_p_i_ClosableSimpleWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ClosableSimpleWorkbenchPanelView> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_v_ValidationPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ValidationPresenter> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ActionInsertFactColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionInsertFactColumnSynchronizer> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_o_OrganizationalUnitsScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<OrganizationalUnitsScreenActivity> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_p_LoadingBox__quals__j_e_i_Any_j_e_i_Default extends Factory<org.uberfire.ext.security.management.client.widgets.popup.LoadingBox> { }
  public abstract class Type_factory__o_d_r_g_c_GoogleMapDisplayerView__quals__j_e_i_Any_j_e_i_Default extends Factory<GoogleMapDisplayerView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_PatternToDeletePageView__quals__j_e_i_Any_j_e_i_Default extends Factory<PatternToDeletePageView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_PluginHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<PluginHandler> { }
  public abstract class Type_factory__o_k_w_c_w_c_h_w_c_WorkbenchConfigurationViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchConfigurationViewImpl> { }
  public abstract class ContextualProvider_factory__o_u_p_c_s_PreferenceStore__quals__Universal extends Factory<PreferenceStore> { }
  public abstract class Type_factory__o_u_e_p_c_e_DynamicMenuEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<DynamicMenuEditorPresenterActivity> { }
  public abstract class Type_factory__o_e_u_s_a_c_SocialEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<SocialEntryPoint> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_h_NewJavaFileTextHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewJavaFileTextHandler> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_d_DependenciesItemView__quals__j_e_i_Any_j_e_i_Default extends Factory<DependenciesItemView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_t_GuidedDTableGraphResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDTableGraphResourceType> { }
  public abstract class ExtensionProvided_factory__e_d_HTMLOListElement__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<HTMLOListElement> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_m_CellContextMenu__quals__j_e_i_Any_j_e_i_Default extends Factory<CellContextMenu> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_PatternPage__quals__j_e_i_Any_j_e_i_Default extends Factory<PatternPage> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_p_p_ProjectItemViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectItemViewImpl> { }
  public abstract class Type_factory__o_d_c_w_d_e_w_c_ElasticSearchDataSetBasicAttributesWorkflow__quals__j_e_i_Any_j_e_i_Default extends Factory<ElasticSearchDataSetBasicAttributesWorkflow> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_ImportsPage__quals__j_e_i_Any_j_e_i_Default extends Factory<ImportsPage> { }
  public abstract class Type_factory__o_u_e_p_c_a_i_AdminPageItemPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<AdminPageItemPresenter> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_c_ConditionCell__quals__j_e_i_Any_j_e_i_Default extends Factory<ConditionCell> { }
  public abstract class Type_factory__o_d_w_s_g_r_c_t_GuidedRuleDSLRResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedRuleDSLRResourceType> { }
  public abstract class JsType_factory__o_u_c_m_Activity__quals__Universal extends Factory<Activity> { }
  public abstract class Type_factory__o_o_w_s_d_c_w_p_PlannerDomainEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<PlannerDomainEditor> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_m_InsertMenuBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<InsertMenuBuilder> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_LibraryScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<LibraryScreen> { }
  public abstract class Type_factory__o_j_e_u_c_w_LocaleSelector__quals__j_e_i_Any_j_e_i_Default extends Factory<LocaleSelector> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_FactPatternConstraintsPage__quals__j_e_i_Any_j_e_i_Default extends Factory<FactPatternConstraintsPage> { }
  public abstract class Type_factory__o_o_w_s_d_c_w_p_DataObjectFieldPicker__quals__j_e_i_Any_j_e_i_Default extends Factory<DataObjectFieldPicker> { }
  public abstract class Type_factory__o_d_w_s_d_c_h_NewDecisionTableXLSHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewDecisionTableXLSHandler> { }
  public abstract class Type_factory__o_d_w_s_g_r_c_GuidedRuleEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedRuleEditorEntryPoint> { }
  public abstract class Type_factory__o_j_e_i_c_l_i_CreationImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<CreationImpl> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_w_POMWizardPageViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<POMWizardPageViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_ActionInsertFactColumnConverter__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionInsertFactColumnConverter> { }
  public abstract class Type_factory__o_u_p_s_i_DefaultPreferenceScopeTypes__quals__j_e_i_Any_o_u_a_FallbackImplementation extends Factory<DefaultPreferenceScopeTypes> { }
  public abstract class JsType_factory__o_u_w_m_ContextDefinition__quals__Universal extends Factory<ContextDefinition> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_d_DroolsDomainScreenViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DroolsDomainScreenViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_r_c_e_GuidedRuleEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<GuidedRuleEditorPresenterActivity> { }
  public abstract class Type_factory__o_k_w_c_s_h_c_w_h_HomePresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<HomePresenterActivity> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_p_PersistenceUnitPropertyGrid__quals__j_e_i_Any_j_e_i_Default extends Factory<PersistenceUnitPropertyGrid> { }
  public abstract class Type_factory__o_u_e_l_e_c_LayoutEditorPluginImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<LayoutEditorPluginImpl> { }
  public abstract class Type_factory__o_g_s_c_e_r_c_CloneRepositoryViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<CloneRepositoryViewImpl> { }
  public abstract class Type_factory__o_u_c_v_p_s_SplashViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<SplashViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_a_i_AnnotationValuePairListItemViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<AnnotationValuePairListItemViewImpl> { }
  public abstract class JsType_factory__o_u_c_m_PerspectiveActivity__quals__Universal extends Factory<PerspectiveActivity> { }
  public abstract class Type_factory__o_u_e_c_e_g_ExperimentalFeaturesGroup__quals__j_e_i_Any_j_e_i_Default extends Factory<ExperimentalFeaturesGroup> { }
  public abstract class Type_factory__o_u_c_w_WorkbenchLayoutImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchLayoutImpl> { }
  public abstract class Type_factory__o_k_w_c_w_d_c_DecoratedGridEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<DecoratedGridEntryPoint> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_t_TagSelector__quals__j_e_i_Any_j_e_i_Default extends Factory<TagSelector> { }
  public abstract class Type_factory__o_d_d_e_c_s_DataSetDefExplorerScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<DataSetDefExplorerScreenActivity> { }
  public abstract class Type_factory__o_k_w_c_w_c_h_PackageListBox__quals__j_e_i_Any_j_e_i_Default extends Factory<PackageListBox> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_v_ValidationView__quals__j_e_i_Any_j_e_i_Default extends Factory<ValidationView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_p_GuidedDecisionTreeStencilPaletteBuilder__quals__j_e_i_Any_o_d_w_s_g_d_c_w_p_GuidedDecisionTree extends Factory<GuidedDecisionTreeStencilPaletteBuilder> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_u_d_KieDropdownElementView_Item__quals__j_e_i_Any_j_e_i_Default extends Factory<Item> { }
  public abstract class Type_factory__o_d_d_c_p_DataSetPrototypes__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetPrototypes> { }
  public abstract class Type_factory__o_d_d_c_w_s_DefaultHtmlValidator__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultHtmlValidator> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_d_DependencyLoaderViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DependencyLoaderViewImpl> { }
  public abstract class Type_factory__o_u_e_e_c_c_f_p_SavePopUpPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<SavePopUpPresenter> { }
  public abstract class Type_factory__o_u_c_v_p_m_m_m_ChildMenuItemView__quals__j_e_i_Any_j_e_i_Default extends Factory<ChildMenuItemView> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_c_s_c_ContainerCardPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ContainerCardPresenter> { }
  public abstract class JsType_factory__o_u_w_m_m_i_DefaultMenuGroup__quals__Universal extends Factory<DefaultMenuGroup> { }
  public abstract class Type_factory__o_u_c_v_p_m_MultiScreenPartWidget__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<MultiScreenPartWidget> { }
  public abstract class Type_factory__o_j_e_i_c_l_i_LifecycleListenerRegistrarImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<LifecycleListenerRegistrarImpl> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_a_a_AddAssetScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<AddAssetScreenActivity> { }
  public abstract class Type_factory__o_u_e_e_c_c_f_p_RenamePopUpView__quals__j_e_i_Any_j_e_i_Default extends Factory<RenamePopUpView> { }
  public abstract class Type_factory__o_u_e_c_e_ExperimentalFeaturesEditorScreenViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ExperimentalFeaturesEditorScreenViewImpl> { }
  public abstract class Type_factory__o_d_d_c_w_g_DataSetGroupDateEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetGroupDateEditorView> { }
  public abstract class Type_factory__o_d_d_c_w_DisplayerSubtypeSelectorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerSubtypeSelectorView> { }
  public abstract class Type_factory__o_u_e_p_c_c_f_DefaultPreferenceFormView__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultPreferenceFormView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_GridWidgetCellFactoryImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<GridWidgetCellFactoryImpl> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_EntitiesExplorerViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<EntitiesExplorerViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_p_PersistencePresenter_PropertiesListPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<PropertiesListPresenter> { }
  public abstract class ContextualProvider_factory__o_j_e_c_c_d_HTMLElement__quals__Universal extends Factory<org.jboss.errai.common.client.dom.HTMLElement> { }
  public abstract class Type_factory__o_u_e_w_c_c_b_w_DefaultBreadcrumbsView__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultBreadcrumbsView> { }
  public abstract class Type_factory__o_u_e_p_c_c_PreferencesCentralPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<PreferencesCentralPerspectiveActivity> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_m_MainDataObjectEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<MainDataObjectEditorViewImpl> { }
  public abstract class Type_factory__o_u_e_a_c_AppsEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<AppsEntryPoint> { }
  public abstract class Type_factory__o_g_s_c_e_r_e_RepositoryEditorPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<RepositoryEditorPresenterActivity> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_a_ArtifactListWidgetPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ArtifactListWidgetPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_p_r_RenameProjectPopUpView__quals__j_e_i_Any_j_e_i_Default extends Factory<RenameProjectPopUpView> { }
  public abstract class Type_factory__o_d_d_c_ClientSettings__quals__j_e_i_Any_j_e_i_Default extends Factory<ClientSettings> { }
  public abstract class Type_factory__o_u_e_e_c_c_h_VersionHistoryPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<VersionHistoryPresenter> { }
  public abstract class Type_factory__o_u_p_s_b_m_PortablePreferenceMockBeanGeneratedImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PortablePreferenceMockBeanGeneratedImpl> { }
  public abstract class Type_factory__o_d_c_w_d_e_DataSetEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetEditorView> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_v_JavaFileNameValidator__quals__j_e_i_Any_j_e_i_Default extends Factory<JavaFileNameValidator> { }
  public abstract class Type_factory__o_k_w_c_w_c_d_i_DataModellerDocksHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<DataModellerDocksHandler> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_ConditionColumnConverter__quals__j_e_i_Any_j_e_i_Default extends Factory<ConditionColumnConverter> { }
  public abstract class Type_factory__o_d_d_c_w_s_DefaultJsEvaluator__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultJsEvaluator> { }
  public abstract class Type_factory__o_u_c_v_p_m_ErrorPopupView__quals__j_e_i_Any_j_e_i_Default extends Factory<org.uberfire.client.views.pfly.modal.ErrorPopupView> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_u_Classifier__quals__j_e_i_Any_j_e_i_Default extends Factory<Classifier> { }
  public abstract class Type_factory__o_d_d_c_w_DisplayerSubtypeSelector__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerSubtypeSelector> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_RolesExplorer__quals__j_e_i_Any_j_e_i_Default extends Factory<RolesExplorer> { }
  public abstract class Type_factory__o_d_d_c_DisplayerLocator__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerLocator> { }
  public abstract class Type_factory__o_j_e_s_c_l_s_StorageHandlerProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<StorageHandlerProvider> { }
  public abstract class Type_factory__o_d_d_c_w_f_LikeToFunctionEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<LikeToFunctionEditorView> { }
  public abstract class Type_factory__o_u_c_w_t_AnyResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<AnyResourceType> { }
  public abstract class Type_factory__o_u_c_w_w_n_NotificationManager__quals__j_e_i_Any_j_e_i_Default extends Factory<NotificationManager> { }
  public abstract class Type_factory__o_u_e_p_c_a_c_AdminPageCategoryView__quals__j_e_i_Any_j_e_i_Default extends Factory<AdminPageCategoryView> { }
  public abstract class Type_factory__o_u_e_w_c_c_l_StencilLayerBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<StencilLayerBuilder> { }
  public abstract class Type_factory__o_u_e_w_c_c_b_w_DefaultBreadcrumbsPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultBreadcrumbsPresenter> { }
  public abstract class Type_factory__o_u_e_e_c_c_m_RestoreVersionCommandProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<RestoreVersionCommandProvider> { }
  public abstract class Type_factory__o_d_r_g_c_GoogleMapDisplayer__quals__j_e_i_Any_j_e_i_Default extends Factory<GoogleMapDisplayer> { }
  public abstract class Type_factory__o_k_w_c_w_c_m_DefaultWorkbenchFeaturesMenusHelper__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultWorkbenchFeaturesMenusHelper> { }
  public abstract class Type_factory__o_o_w_s_d_c_w_p_PlannerDomainScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<PlannerDomainScreen> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_n_MultiplePermissionNodeViewer__quals__j_e_i_Any_j_e_i_Default extends Factory<MultiplePermissionNodeViewer> { }
  public abstract class Type_factory__o_u_e_l_e_c_LayoutEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<LayoutEditorPresenter> { }
  public abstract class Type_factory__o_u_e_e_c_c_f_p_c_ToggleCommentPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ToggleCommentPresenter> { }
  public abstract class Type_factory__o_k_w_c_w_c_t_TestRunnerReportingViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<TestRunnerReportingViewImpl> { }
  public abstract class Type_factory__o_d_c_w_d_e_c_ColumnListEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnListEditor> { }
  public abstract class Type_factory__o_d_d_c_w_DisplayerHtmlEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerHtmlEditorView> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_u_OrgUnitsMetricsFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<OrgUnitsMetricsFactory> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_d_ActionRetractFactCol52DefinitionBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionRetractFactCol52DefinitionBuilder> { }
  public abstract class Type_factory__o_u_e_p_c_p_e_a_PerspectiveEditorNavGroupProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectiveEditorNavGroupProvider> { }
  public abstract class Type_factory__o_u_c_w_t_DotResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<DotResourceType> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_p_p_PersistableDataObjectsItemView__quals__j_e_i_Any_j_e_i_Default extends Factory<PersistableDataObjectsItemView> { }
  public abstract class Type_factory__o_k_w_c_w_c_p_t_TextBoxFormPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<TextBoxFormPopup> { }
  public abstract class ExtensionProvided_factory__e_d_HTMLAnchorElement__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<HTMLAnchorElement> { }
  public abstract class Type_factory__o_d_w_s_t_c_h_NewTestScenarioHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewTestScenarioHandler> { }
  public abstract class Type_factory__o_d_d_e_f_AggregateFunctionManagerImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<AggregateFunctionManagerImpl> { }
  public abstract class Provider_factory__o_j_e_s_c_l_s_UserStorageHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<UserStorageHandler> { }
  public abstract class Type_factory__o_d_c_c_w_PerspectivesExplorer__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectivesExplorer> { }
  public abstract class Type_factory__o_o_w_s_d_c_w_p_PlannerDomainScreenViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PlannerDomainScreenViewImpl> { }
  public abstract class ContextualProvider_factory__o_j_e_i_c_a_ManagedInstance__quals__Universal extends Factory<ManagedInstance> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_p_LoadingBoxView__quals__j_e_i_Any_j_e_i_Default extends Factory<org.uberfire.ext.security.management.client.widgets.popup.LoadingBoxView> { }
  public abstract class JsType_factory__o_u_w_m_m_Menus__quals__Universal extends Factory<Menus> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_ActionSetFieldColumnConverter__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionSetFieldColumnConverter> { }
  public abstract class Type_factory__o_u_c_p_JSNativePerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<JSNativePerspective> { }
  public abstract class Type_factory__o_u_p_s_i_PreferenceScopeValidatorImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PreferenceScopeValidatorImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_GuidedDecisionTableGraphEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<GuidedDecisionTableGraphEditorPresenterActivity> { }
  public abstract class Type_factory__o_g_s_c_e_r_l_RepositoriesPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<RepositoriesPresenterActivity> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_n_PermissionSwitch__quals__j_e_i_Any_j_e_i_Default extends Factory<PermissionSwitch> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_u_UserAssignedGroupsEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<UserAssignedGroupsEditor> { }
  public abstract class Type_factory__o_d_c_w_d_e_a_DataSetDefRefreshIntervalEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefRefreshIntervalEditor> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_GuidedDecisionTreeEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDecisionTreeEditorViewImpl> { }
  public abstract class ContextualProvider_factory__o_u_p_s_PreferenceScopeResolutionStrategy__quals__Universal extends Factory<PreferenceScopeResolutionStrategy> { }
  public abstract class Type_factory__o_u_e_e_c_c_f_p_DeletePopUpView__quals__j_e_i_Any_j_e_i_Default extends Factory<DeletePopUpView> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_DropDownMenu__quals__j_e_i_Any_j_e_i_Default extends Factory<DropDownMenu> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_c_s_ContainerRemoteStatusView__quals__j_e_i_Any_j_e_i_Default extends Factory<ContainerRemoteStatusView> { }
  public abstract class Type_factory__o_u_e_c_w_t_ExperimentalAwareClientTypeRegistryImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ExperimentalAwareClientTypeRegistryImpl> { }
  public abstract class Type_factory__o_d_c_w_d_e_a_DataSetDefBasicAttributesEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefBasicAttributesEditorView> { }
  public abstract class Type_factory__o_d_d_c_w_f_TextParameterEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<TextParameterEditorView> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_w_NewWorkspaceProjectWizard__quals__j_e_i_Any_j_e_i_Default extends Factory<NewWorkspaceProjectWizard> { }
  public abstract class Type_factory__o_o_w_s_g_c_p_SimpleConstraintMatchRuleModellerActionPlugin__quals__j_e_i_Any_j_e_i_Default extends Factory<SimpleConstraintMatchRuleModellerActionPlugin> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_GuidedDecisionTableGraphEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDecisionTableGraphEditorPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_d_NewDependencyPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<NewDependencyPopup> { }
  public abstract class Type_factory__o_u_c_s_JSNativeScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<JSNativeScreen> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_ServerManagementBrowserView__quals__j_e_i_Any_j_e_i_Default extends Factory<ServerManagementBrowserView> { }
  public abstract class Type_factory__o_k_w_c_s_h_c_w_s_s_ShortcutSubHeadingTextPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ShortcutSubHeadingTextPresenter> { }
  public abstract class Type_factory__o_u_e_p_c_c_s_PreferencesRootView__quals__j_e_i_Any_j_e_i_Default extends Factory<PreferencesRootView> { }
  public abstract class ContextualProvider_factory__o_j_e_d_c_a_DataBinder__quals__Universal extends Factory<DataBinder> { }
  public abstract class Type_factory__o_u_e_w_c_c_t_p_NewTabFilterPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<NewTabFilterPopup> { }
  public abstract class Type_factory__o_d_w_s_t_c_p_a_AuditPage__quals__j_e_i_Any_j_e_i_Default extends Factory<AuditPage> { }
  public abstract class ExtensionProvided_factory__e_d_HTMLTableSectionElement__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<HTMLTableSectionElement> { }
  public abstract class Type_factory__o_d_w_s_g_s_t_GuidedScoreCardResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset extends Factory<GuidedScoreCardResourceTypeDefinition> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_ActionWorkItemInsertFactColumnConverter__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionWorkItemInsertFactColumnConverter> { }
  public abstract class Type_factory__o_g_s_c_e_r_l_RepositoryItemViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryItemViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_r_c_e_GuidedRuleEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedRuleEditorPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_w_p_AssetsActionsView__quals__j_e_i_Any_j_e_i_Default extends Factory<AssetsActionsView> { }
  public abstract class Type_factory__o_u_c_w_w_m_WorkbenchMenuBarProducer__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchMenuBarProducer> { }
  public abstract class Type_factory__o_u_e_p_c_e_DynamicMenuEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DynamicMenuEditorPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_v_r_c_p_AnalysisReportScreenViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<AnalysisReportScreenViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_w_l_AddProjectButtonPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<AddProjectButtonPresenter> { }
  public abstract class Type_factory__o_o_w_s_s_c_h_NewSolverHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewSolverHandler> { }
  public abstract class Type_factory__o_d_w_s_w_c_w_WorkItemDefinitionElementsBrowser__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkItemDefinitionElementsBrowser> { }
  public abstract class Type_factory__o_d_d_c_w_DisplayerEditorPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerEditorPopup> { }
  public abstract class Type_factory__o_j_e_i_c_a_b_RootPanelProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<RootPanelProvider> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDataObjectFieldEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<AdvancedDataObjectFieldEditorViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_DataModelerEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<DataModelerEntryPoint> { }
  public abstract class Type_factory__o_d_w_s_e_c_e_EnumEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<EnumEditorPresenterActivity> { }
  public abstract class Producer_factory__o_j_e_u_n_c_l_s_NavigationGraph__quals__j_e_i_Any_j_e_i_Default extends Factory<NavigationGraph> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_d_DependenciesView__quals__j_e_i_Any_j_e_i_Default extends Factory<DependenciesView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_p_GuidedDecisionTreePalette__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedDecisionTreePalette> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_c_ContainerPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ContainerPresenter> { }
  public abstract class Type_factory__o_u_e_w_c_c_e_t_TextEditorWorkbenchEditorActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<TextEditorWorkbenchEditorActivity> { }
  public abstract class Type_factory__o_u_e_p_c_e_ScreenEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<ScreenEditorPresenterActivity> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_p_p_TagItemViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<TagItemViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_ActionSetFieldsPage__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionSetFieldsPage> { }
  public abstract class Type_factory__o_u_e_w_c_c_e_m_MetaFileEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<MetaFileEditorPresenter> { }
  public abstract class Type_factory__o_o_w_s_g_c_GuidedRuleEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<org.optaplanner.workbench.screens.guidedrule.client.GuidedRuleEditorEntryPoint> { }
  public abstract class Type_factory__o_d_d_c_w_f_DateParameterEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DateParameterEditor> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_v_ProjectNameValidator__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectNameValidator> { }
  public abstract class Type_factory__o_u_e_p_c_r_i_PerspectiveEditorPaletteI18nImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectiveEditorPaletteI18nImpl> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_ImportExamplesProjectsScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<ImportExamplesProjectsScreen> { }
  public abstract class Type_factory__o_j_e_u_n_c_l_URLPatternMatcherProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<URLPatternMatcherProvider> { }
  public abstract class Type_factory__o_d_c_n_p_PerspectivePluginManager__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectivePluginManager> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_u_s_SectionManager__quals__j_e_i_Any_j_e_i_Default extends Factory<SectionManager> { }
  public abstract class Type_factory__o_o_w_s_d_c_v_PlannerValidationMessageTranslator__quals__j_e_i_Any_j_e_i_Default extends Factory<PlannerValidationMessageTranslator> { }
  public abstract class Type_factory__o_d_d_c_DisplayerCoordinator__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerCoordinator> { }
  public abstract class Type_factory__o_k_w_c_w_c_p_v_ValidationMessageTranslatorUtils__quals__j_e_i_Any_j_e_i_Default extends Factory<ValidationMessageTranslatorUtils> { }
  public abstract class Type_factory__o_d_d_c_w_f_TextParameterEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<TextParameterEditor> { }
  public abstract class Type_factory__o_u_e_w_c_c_p_ShapesGroup__quals__j_e_i_Any_j_e_i_Default extends Factory<ShapesGroup> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_p_ProcessConfigPagePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ProcessConfigPagePresenter> { }
  public abstract class Type_factory__o_d_w_s_t_c_t_TestScenarioResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<TestScenarioResourceType> { }
  public abstract class Type_factory__o_d_c_c_b_PathUrlFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<PathUrlFactory> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_ActionWorkItemExecuteColumnConverter__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionWorkItemExecuteColumnConverter> { }
  public abstract class Type_factory__o_d_r_c_m_MetricView__quals__j_e_i_Any_j_e_i_Default extends Factory<MetricView> { }
  public abstract class Type_factory__o_d_c_n_w_NavItemTileWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<NavItemTileWidget> { }
  public abstract class Type_factory__o_u_e_p_c_p_RuntimePluginStartup__quals__j_e_i_Any_j_e_i_Default extends Factory<RuntimePluginStartup> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_m_RadarMenuBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<RadarMenuBuilder> { }
  public abstract class Type_factory__o_u_e_p_c_s_PluginController__quals__j_e_i_Any_j_e_i_Default extends Factory<PluginController> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_r_w_RoleEditorWorkflow__quals__j_e_i_Any_j_e_i_Default extends Factory<RoleEditorWorkflow> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_ServerManagementBrowserPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ServerManagementBrowserPresenter> { }
  public abstract class Type_factory__o_g_s_c_e_r_l_RepositoryItemPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryItemPresenter> { }
  public abstract class JsType_factory__o_u_w_m_ContextDisplayMode__quals__Universal extends Factory<ContextDisplayMode> { }
  public abstract class Type_factory__o_d_c_n_l_e_NavCarouselDragComponent__quals__j_e_i_Any_j_e_i_Default extends Factory<NavCarouselDragComponent> { }
  public abstract class Type_factory__o_d_w_s_t_c_ScenarioWidgetComponentCreator__quals__j_e_i_Any_j_e_i_Default extends Factory<ScenarioWidgetComponentCreator> { }
  public abstract class Type_factory__o_d_w_s_d_c_t_DSLRResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<DSLRResourceType> { }
  public abstract class Type_factory__o_u_c_w_WorkbenchLayoutInfoImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchLayoutInfoImpl> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_e_NewFileUploader__quals__j_e_i_Any_j_e_i_Default extends Factory<NewFileUploader> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_ActionRetractFactPlugin__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionRetractFactPlugin> { }
  public abstract class Type_factory__o_u_e_w_c_t_c_l_WiresTreesDefaultLayout__quals__j_e_i_Any_j_e_i_Default extends Factory<WiresTreesDefaultLayout> { }
  public abstract class JsType_factory__o_u_w_m_PerspectiveDefinition__quals__Universal extends Factory<PerspectiveDefinition> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_ActionInsertFactFieldsPageViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionInsertFactFieldsPageViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_t_InfoTitlePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<InfoTitlePresenter> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_ACLViewerView__quals__j_e_i_Any_j_e_i_Default extends Factory<ACLViewerView> { }
  public abstract class Type_factory__o_d_c_w_d_e_w_e_CSVDataSetEditWorkflow__quals__j_e_i_Any_j_e_i_Default extends Factory<CSVDataSetEditWorkflow> { }
  public abstract class Type_factory__o_j_e_u_s_ServerTemplateProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<ServerTemplateProvider> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_Button__quals__j_e_i_Any_j_e_i_Default extends Factory<org.gwtbootstrap3.client.ui.Button> { }
  public abstract class ExtensionProvided_factory__e_d_HTMLSelectElement__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<HTMLSelectElement> { }
  public abstract class Type_factory__o_d_w_s_g_c_t_GlobalResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<GlobalResourceType> { }
  public abstract class Producer_factory__o_d_c_w_d_e_d_CSVDataSetDefAttributesDriver__quals__j_e_i_Any_j_e_i_Default extends Factory<CSVDataSetDefAttributesDriver> { }
  public abstract class Type_factory__o_u_c_m_PlaceManagerImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PlaceManagerImpl> { }
  public abstract class Type_factory__o_u_c_m_CustomSplashHelp__quals__j_e_i_Any_j_e_i_Default extends Factory<CustomSplashHelp> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_n_LeafPermissionNodeEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<LeafPermissionNodeEditorView> { }
  public abstract class Type_factory__o_g_s_c_e_r_c_CloneRepositoryPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<CloneRepositoryPresenter> { }
  public abstract class Type_factory__o_k_w_c_w_c_h_w_c_WorkbenchConfigurationPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchConfigurationPresenter> { }
  public abstract class Type_factory__o_u_e_w_c_t_c_c_WiresTreesScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<WiresTreesScreen> { }
  public abstract class Type_factory__o_o_w_s_d_c_w_p_DataObjectFieldPickerItemLabelViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DataObjectFieldPickerItemLabelViewImpl> { }
  public abstract class Type_factory__o_u_s_i_a_DefaultAuthorizationManager__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultAuthorizationManager> { }
  public abstract class Type_factory__o_u_s_c_e_c_k_SSHKeysDisplayer__quals__j_e_i_Any_j_e_i_Default extends Factory<SSHKeysDisplayer> { }
  public abstract class Type_factory__o_u_e_p_c_p_PlugInAuthoringPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<PlugInAuthoringPerspectiveActivity> { }
  public abstract class Type_factory__o_d_w_s_w_c_WorkItemsEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkItemsEditorEntryPoint> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_k_i_k_KnowledgeSessionListItemPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<KnowledgeSessionListItemPresenter> { }
  public abstract class Type_factory__o_d_w_s_w_c_t_WorkItemsResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkItemsResourceType> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_PatternPageView__quals__j_e_i_Any_j_e_i_Default extends Factory<PatternPageView> { }
  public abstract class Type_factory__o_u_e_w_c_c_s_SelectView__quals__j_e_i_Any_j_e_i_Default extends Factory<SelectView> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_p_ProjectScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ProjectScreenActivity> { }
  public abstract class Type_factory__o_u_e_p_c_e_ScreenEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ScreenEditorPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_o_c_w_ContributorsManagementPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ContributorsManagementPresenter> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_BRLConditionVariableColumnConverter__quals__j_e_i_Any_j_e_i_Default extends Factory<BRLConditionVariableColumnConverter> { }
  public abstract class ExtensionProvided_factory__o_k_w_c_w_c_s_ViewDRLSourceWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<ViewDRLSourceWidget> { }
  public abstract class Type_factory__o_d_w_s_g_c_e_GlobalsEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<GlobalsEditorPresenter> { }
  public abstract class Type_factory__o_d_c_c_w_AlertPanel__quals__j_e_i_Any_j_e_i_Default extends Factory<AlertPanel> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_ActionWorkItemPlugin__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionWorkItemPlugin> { }
  public abstract class JsType_factory__o_u_c_m_WorkbenchActivity__quals__Universal extends Factory<WorkbenchActivity> { }
  public abstract class Type_factory__o_j_e_u_n_c_l_TransitionAnchorFactoryProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<TransitionAnchorFactoryProvider> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_CreateEntity__quals__j_e_i_Any_j_e_i_Default extends Factory<CreateEntity> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_ChangePassword__quals__j_e_i_Any_j_e_i_Default extends Factory<ChangePassword> { }
  public abstract class Type_factory__o_k_w_c_w_c_a_WorkbenchTreeProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchTreeProvider> { }
  public abstract class Type_factory__o_g_m_c_c_MessageConsoleService__quals__j_e_i_Any_j_e_i_Default extends Factory<MessageConsoleService> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_ListGroup__quals__j_e_i_Any_j_e_i_Default extends Factory<ListGroup> { }
  public abstract class Type_factory__o_u_c_m_WorkbenchViewModeSwitcherMenuBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchViewModeSwitcherMenuBuilder> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_l_GuidedDecisionTableLockManagerImpl__quals__j_e_i_Any_o_d_w_s_g_d_c_GuidedDecisionTable extends Factory<GuidedDecisionTableLockManagerImpl> { }
  public abstract class Type_factory__o_u_c_w_p_i_UnanchoredStaticWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<UnanchoredStaticWorkbenchPanelView> { }
  public abstract class Type_factory__o_u_e_l_e_c_i_DnDManager__quals__j_e_i_Any_j_e_i_Default extends Factory<DnDManager> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_r_RemoteStatusView__quals__j_e_i_Any_j_e_i_Default extends Factory<RemoteStatusView> { }
  public abstract class Type_factory__o_k_w_c_s_h_c_w_h_HomePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<HomePresenter> { }
  public abstract class Type_factory__o_u_e_w_c_c_p_PropertiesScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<PropertiesScreen> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_u_UserAttributesEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<UserAttributesEditor> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_j_p_SequenceGeneratorField__quals__j_e_i_Any_j_e_i_Default extends Factory<SequenceGeneratorField> { }
  public abstract class ExtensionProvided_factory__e_d_HTMLLIElement__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<HTMLLIElement> { }
  public abstract class Type_factory__o_d_c_w_d_e_w_e_SQLDataSetEditWorkflow__quals__j_e_i_Any_j_e_i_Default extends Factory<SQLDataSetEditWorkflow> { }
  public abstract class Type_factory__o_k_w_c_w_c_m_c_HelpCustomMenuBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<HelpCustomMenuBuilder> { }
  public abstract class Type_factory__o_u_c_v_p_w_InlineNotification__quals__j_e_i_Any_j_e_i_Default extends Factory<InlineNotification> { }
  public abstract class Type_factory__o_g_c_s_p_c_Process__quals__j_e_i_Any_j_e_i_Default extends Factory<Process> { }
  public abstract class JsType_factory__e_d_Element_ScrollIntoViewTopType__quals__Universal extends Factory<ScrollIntoViewTopType> { }
  public abstract class Type_factory__o_d_d_c_w_DisplayerEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerEditorView> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_u_PomEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<PomEditor> { }
  public abstract class Type_factory__o_u_s_c_e_c_c_NewSSHKeyModal__quals__j_e_i_Any_j_e_i_Default extends Factory<NewSSHKeyModal> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_AttributeColumnPlugin__quals__j_e_i_Any_j_e_i_Default extends Factory<AttributeColumnPlugin> { }
  public abstract class Type_factory__o_d_d_c_w_s_SourceCodeEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<SourceCodeEditorView> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_d_DataSourceSelectorProducer__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSourceSelectorProducer> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_ExamplesScreenEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<ExamplesScreenEntryPoint> { }
  public abstract class Type_factory__o_g_c_s_p_c_p_ProjectScopedResolutionStrategySupplier__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectScopedResolutionStrategySupplier> { }
  public abstract class Type_factory__o_e_u_s_a_c_w_u_UserBoxView__quals__j_e_i_Any_j_e_i_Default extends Factory<UserBoxView> { }
  public abstract class Type_factory__o_u_c_d_v_DocksBars__quals__j_e_i_Any_j_e_i_Default extends Factory<DocksBars> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_d_DroolsDomainScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<DroolsDomainScreen> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_OrderedList__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<OrderedList> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_FieldPageView__quals__j_e_i_Any_j_e_i_Default extends Factory<FieldPageView> { }
  public abstract class Type_factory__o_j_e_i_c_a_b_DisposerProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<DisposerProvider> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_AdditionalInfoPage__quals__j_e_i_Any_j_e_i_Default extends Factory<AdditionalInfoPage> { }
  public abstract class Type_factory__o_o_w_s_s_c_e_TerminationTreeItemContent__quals__j_e_i_Any_j_e_i_Default extends Factory<TerminationTreeItemContent> { }
  public abstract class Type_factory__o_d_d_c_w_RendererSelector__quals__j_e_i_Any_j_e_i_Default extends Factory<RendererSelector> { }
  public abstract class Type_factory__o_u_e_w_c_c_l_LayersScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<LayersScreenActivity> { }
  public abstract class Type_factory__o_u_e_p_t_DynamicMenuResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<DynamicMenuResourceTypeDefinition> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_u_s_MenuItem__quals__j_e_i_Any_j_e_i_Default extends Factory<org.kie.workbench.common.screens.library.client.settings.util.sections.MenuItem> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_k_i_k_KnowledgeSessionListItemView__quals__j_e_i_Any_j_e_i_Default extends Factory<KnowledgeSessionListItemView> { }
  public abstract class Producer_factory__o_u_e_e_c_c_f_e_PdfFileExport__quals__j_e_i_Any_j_e_i_Default extends Factory<PdfFileExport> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_Icon__quals__j_e_i_Any_j_e_i_Default extends Factory<Icon> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_u_b_ProjectBranchBreadcrumb__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectBranchBreadcrumb> { }
  public abstract class Type_factory__o_d_d_c_e_ClientChronometer__quals__j_e_i_Any_j_e_i_Default extends Factory<ClientChronometer> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_AttributeColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default extends Factory<AttributeColumnSynchronizer> { }
  public abstract class Type_factory__o_u_e_a_c_h_AppsHomeView__quals__j_e_i_Any_j_e_i_Default extends Factory<AppsHomeView> { }
  public abstract class Type_factory__o_u_e_l_e_c_c_r_EmptyDropRow__quals__j_e_i_Any_j_e_i_Default extends Factory<EmptyDropRow> { }
  public abstract class Type_factory__o_j_e_i_c_a_b_ManagedInstanceProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<ManagedInstanceProvider> { }
  public abstract class Type_factory__o_d_c_w_d_e_w_c_CSVDataSetBasicAttributesWorkflow__quals__j_e_i_Any_j_e_i_Default extends Factory<CSVDataSetBasicAttributesWorkflow> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_f_ActionUpdateNodeFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionUpdateNodeFactory> { }
  public abstract class Type_factory__o_g_c_s_p_c_ProjectEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectEntryPoint> { }
  public abstract class Type_factory__o_u_e_w_c_c_p_ConnectorsGroup__quals__j_e_i_Any_j_e_i_Default extends Factory<ConnectorsGroup> { }
  public abstract class Type_factory__o_u_e_p_c_p_e_l_e_p_EditHTMLView__quals__j_e_i_Any_j_e_i_Default extends Factory<EditHTMLView> { }
  public abstract class JsType_factory__j_u_List__quals__Universal extends Factory<List> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_Image__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<Image> { }
  public abstract class Type_factory__o_d_c_w_d_e_s_SQLDataSetDefAttributesEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<SQLDataSetDefAttributesEditor> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_FactPatternsPage__quals__j_e_i_Any_j_e_i_Default extends Factory<FactPatternsPage> { }
  public abstract class Type_factory__o_d_c_w_d_e_DataSetSummary__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetSummary> { }
  public abstract class Type_factory__o_j_e_s_c_l_i_AuthenticationServiceInterceptor__quals__j_e_i_Any_j_e_i_Default extends Factory<AuthenticationServiceInterceptor> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_SummaryPage__quals__j_e_i_Any_j_e_i_Default extends Factory<org.drools.workbench.screens.guided.dtable.client.wizard.column.pages.SummaryPage> { }
  public abstract class Type_factory__o_u_e_p_c_c_t_TreeHierarchyStructurePresenter__quals__j_e_i_Any_o_u_e_p_c_c_t_TreeView extends Factory<TreeHierarchyStructurePresenter> { }
  public abstract class Type_factory__o_u_p_c_s_PreferenceBeanStoreImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PreferenceBeanStoreImpl> { }
  public abstract class Type_factory__o_d_c_n_w_e_NavRootNodeEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<NavRootNodeEditorView> { }
  public abstract class Type_factory__o_u_e_p_c_p_e_l_e_ScreenLayoutDragComponent__quals__j_e_i_Any_j_e_i_Default extends Factory<ScreenLayoutDragComponent> { }
  public abstract class Type_factory__o_j_e_u_c_l_p_HTMLElementProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<HTMLElementProvider> { }
  public abstract class Type_factory__o_o_w_s_s_c_e_PhaseConfigFormViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PhaseConfigFormViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_h_NewGuidedDecisionTableHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewGuidedDecisionTableHandler> { }
  public abstract class Type_factory__o_d_c_n_l_e_NavTabListDragComponent__quals__j_e_i_Any_j_e_i_Default extends Factory<NavTabListDragComponent> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_l_RolesList__quals__j_e_i_Any_j_e_i_Default extends Factory<RolesList> { }
  public abstract class JsType_factory__o_u_w_m_m_i_DefaultMenus__quals__Universal extends Factory<DefaultMenus> { }
  public abstract class Type_factory__o_u_e_e_c_c_v_DefaultFileNameValidator__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultFileNameValidator> { }
  public abstract class Producer_factory__o_d_c_w_d_e_d_DataSetDefProviderTypeDriver__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefProviderTypeDriver> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_g_GitUrlsPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<GitUrlsPresenter> { }
  public abstract class Type_factory__o_u_c_d_v_m_MenuBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<MenuBuilder> { }
  public abstract class Type_factory__o_o_w_s_g_c_p_MultiConstraintHardMediumSoftMatchRuleModellerActionPlugin__quals__j_e_i_Any_j_e_i_Default extends Factory<MultiConstraintHardMediumSoftMatchRuleModellerActionPlugin> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_u_ProjectMetricsFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectMetricsFactory> { }
  public abstract class Type_factory__o_k_w_c_w_c_s_ViewSourceViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ViewSourceViewImpl> { }
  public abstract class Producer_factory__o_d_c_w_d_e_d_SQLDataSetDefDriver__quals__j_e_i_Any_j_e_i_Default extends Factory<SQLDataSetDefDriver> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_v_ValuePairEditorPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<ValuePairEditorPopup> { }
  public abstract class Producer_factory__o_u_e_e_c_c_f_p_CopyPopUpPresenter_View__quals__j_e_i_Any_o_u_e_e_c_c_f_Customizable extends Factory<View> { }
  public abstract class Type_factory__o_k_w_c_s_l_a_p_LibraryProjectPreferencesBeanGeneratedImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<LibraryProjectPreferencesBeanGeneratedImpl> { }
  public abstract class Type_factory__o_k_w_c_w_c_a_DefaultAdminPageHelper__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultAdminPageHelper> { }
  public abstract class Type_factory__o_u_e_w_c_c_t_p_NewFilterPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<NewFilterPopup> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_o_d_DeleteOrganizationalUnitPopUpPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DeleteOrganizationalUnitPopUpPresenter> { }
  public abstract class Type_factory__o_o_w_c_n_AppNavBar__quals__j_e_i_Any_j_e_i_Default extends Factory<AppNavBar> { }
  public abstract class Type_factory__o_k_w_c_s_h_c_w_s_ShortcutView__quals__j_e_i_Any_j_e_i_Default extends Factory<ShortcutView> { }
  public abstract class Type_factory__o_o_w_s_s_t_SolverResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset extends Factory<SolverResourceTypeDefinition> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_ImportsPageViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ImportsPageViewImpl> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_p_ConfirmBoxView__quals__j_e_i_Any_j_e_i_Default extends Factory<ConfirmBoxView> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_k_i_KnowledgeBaseItemView__quals__j_e_i_Any_j_e_i_Default extends Factory<KnowledgeBaseItemView> { }
  public abstract class Type_factory__o_d_r_g_c_GooglePieChartDisplayerView__quals__j_e_i_Any_j_e_i_Default extends Factory<GooglePieChartDisplayerView> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_ListItem__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ListItem> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_d_DroolsDataObjectFieldEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DroolsDataObjectFieldEditorViewImpl> { }
  public abstract class Type_factory__o_u_s_c_e_SSHKeysEditorPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<SSHKeysEditorPerspectiveActivity> { }
  public abstract class Type_factory__o_d_w_s_d_t_DSLResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset extends Factory<DSLResourceTypeDefinition> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_j_JPADomainScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<JPADomainScreenActivity> { }
  public abstract class Producer_factory__o_u_r_SessionInfo__quals__j_e_i_Any_j_e_i_Default extends Factory<SessionInfo> { }
  public abstract class Type_factory__o_u_e_w_c_c_d_n_NoItemsComponentViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<NoItemsComponentViewImpl> { }
  public abstract class Type_factory__o_u_e_l_e_c_i_e_DisabledExperimentalLayoutComponent__quals__j_e_i_Any_j_e_i_Default extends Factory<DisabledExperimentalLayoutComponent> { }
  public abstract class Type_factory__o_u_e_w_c_c_p_PaletteScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<PaletteScreen> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_c_c_p_ContainerProcessConfigView__quals__j_e_i_Any_j_e_i_Default extends Factory<ContainerProcessConfigView> { }
  public abstract class Type_factory__o_d_w_s_s_c_h_NewScoreCardXLSHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewScoreCardXLSHandler> { }
  public abstract class Type_factory__o_k_w_c_s_s_p_c_WorkbenchPreferenceScopeTypes__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchPreferenceScopeTypes> { }
  public abstract class Type_factory__o_u_e_e_c_c_m_c_SaveAndRenameCommandBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<SaveAndRenameCommandBuilder> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_a_AssetQueryService__quals__j_e_i_Any_j_e_i_Default extends Factory<AssetQueryService> { }
  public abstract class Type_factory__o_u_e_c_e_g_ExperimentalFeaturesGroupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ExperimentalFeaturesGroupViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_LibraryView__quals__j_e_i_Any_j_e_i_Default extends Factory<LibraryView> { }
  public abstract class ExtensionProvided_factory__o_s_Logger__quals__Universal_11 extends Factory<Logger> { }
  public abstract class ExtensionProvided_factory__o_s_Logger__quals__Universal_10 extends Factory<Logger> { }
  public abstract class Type_factory__o_u_e_p_c_c_f_DefaultPreferenceFormActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<DefaultPreferenceFormActivity> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_w_p_AssetItemWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<AssetItemWidget> { }
  public abstract class Type_factory__o_d_w_s_g_c_e_GlobalsEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<GlobalsEditorViewImpl> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_w_TagWidgetViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<TagWidgetViewImpl> { }
  public abstract class Type_factory__o_o_w_s_s_c_e_ScoreDirectorFactoryForm__quals__j_e_i_Any_j_e_i_Default extends Factory<ScoreDirectorFactoryForm> { }
  public abstract class Type_factory__o_d_w_s_t_c_p_s_ExecutionWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<ExecutionWidget> { }
  public abstract class JsType_factory__o_u_m_i_ExternalPathPlaceRequest__quals__Universal extends Factory<ExternalPathPlaceRequest> { }
  public abstract class ExtensionProvided_factory__o_s_Logger__quals__Universal_14 extends Factory<Logger> { }
  public abstract class ExtensionProvided_factory__o_s_Logger__quals__Universal_13 extends Factory<Logger> { }
  public abstract class ExtensionProvided_factory__o_s_Logger__quals__Universal_12 extends Factory<Logger> { }
  public abstract class Type_factory__o_d_c_w_d_e_c_DataColumnDefEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DataColumnDefEditor> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_a_AdvancedAnnotationListEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<AdvancedAnnotationListEditorViewImpl> { }
  public abstract class Type_factory__o_j_e_e_c_c_InstanceProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<InstanceProvider> { }
  public abstract class Type_factory__o_d_c_c_w_AlertBox__quals__j_e_i_Any_j_e_i_Default extends Factory<AlertBox> { }
  public abstract class Type_factory__o_k_w_c_w_c_w_KSessionSelector__quals__j_e_i_Any_j_e_i_Default extends Factory<KSessionSelector> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_e_ExternalDataObjectsView__quals__j_e_i_Any_j_e_i_Default extends Factory<ExternalDataObjectsView> { }
  public abstract class Type_factory__o_u_c_w_p_i_MultiScreenWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<MultiScreenWorkbenchPanelView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_c_c_AttributeColumnConfigRowView__quals__j_e_i_Any_j_e_i_Default extends Factory<AttributeColumnConfigRowView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_m_RadarMenuViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<RadarMenuViewImpl> { }
  public abstract class Type_factory__o_u_c_v_p_n_NotificationPopupsManagerView__quals__j_e_i_Any_j_e_i_Default extends Factory<NotificationPopupsManagerView> { }
  public abstract class Type_factory__o_u_e_e_c_c_f_p_CopyPopUpPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<CopyPopUpPresenter> { }
  public abstract class Type_factory__o_u_c_v_p_w_DateRangePicker__quals__j_e_i_Any_j_e_i_Default extends Factory<DateRangePicker> { }
  public abstract class Type_factory__o_g_m_c_c_w_b_ViewHideAlertsButtonPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ViewHideAlertsButtonPresenter> { }
  public abstract class Type_factory__o_d_w_s_s_c_ScoreCardXLSEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<ScoreCardXLSEntryPoint> { }
  public abstract class Type_factory__o_g_m_c_c_w_b_ViewHideAlertsButtonView__quals__j_e_i_Any_j_e_i_Default extends Factory<ViewHideAlertsButtonView> { }
  public abstract class Type_factory__o_d_w_s_g_c_e_AddGlobalPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<AddGlobalPopup> { }
  public abstract class Type_factory__o_d_d_c_w_f_ColumnFilterEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnFilterEditorView> { }
  public abstract class Type_factory__o_k_w_c_w_c_d_DiscussionWidgetPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DiscussionWidgetPresenter> { }
  public abstract class JsType_factory__e_d_RelatedEvent_RelatedEventEventInitDictType__quals__Universal extends Factory<RelatedEventEventInitDictType> { }
  public abstract class Type_factory__o_u_c_m_ForceUnlockEventObserver__quals__j_e_i_Any_j_e_i_Default extends Factory<ForceUnlockEventObserver> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_k_KnowledgeBasesPresenter_KnowledgeBaseListPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<KnowledgeBaseListPresenter> { }
  public abstract class ExtensionProvided_factory__c_g_g_u_c_u_Tree__quals__j_e_i_Any_j_e_i_Default extends Factory<Tree> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_r_c_ContainerCardPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<org.kie.workbench.common.screens.server.management.client.remote.card.ContainerCardPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_k_i_k_w_WorkItemHandlerListItemPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkItemHandlerListItemPresenter> { }
  public abstract class Type_factory__o_u_c_w_PanelManagerImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PanelManagerImpl> { }
  public abstract class Type_factory__o_u_e_p_c_t_SplashPluginResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<SplashPluginResourceType> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_c_s_c_ContainerCardView__quals__j_e_i_Any_j_e_i_Default extends Factory<ContainerCardView> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_p_SelectableDocumentImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<SelectableDocumentImpl> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_NewContainerWizard__quals__j_e_i_Any_j_e_i_Default extends Factory<NewContainerWizard> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_t_NewTemplatePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<NewTemplatePresenter> { }
  public abstract class Type_factory__o_u_e_w_c_c_s_SelectOptionComponent__quals__j_e_i_Any_j_e_i_Default extends Factory<SelectOptionComponent> { }
  public abstract class Type_factory__o_d_w_s_g_r_c_h_NewGuidedRuleHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewGuidedRuleHandler> { }
  public abstract class ExtensionProvided_factory__o_g_c_u_CheckBox__quals__j_e_i_Any_j_e_i_Default extends Factory<CheckBox> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_PopOverViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<PopOverViewImpl> { }
  public abstract class ContextualProvider_factory__o_j_e_i_s_b_c_Sender__quals__Universal extends Factory<Sender> { }
  public abstract class Type_factory__o_u_e_p_c_w_n_PluginNavList__quals__j_e_i_Any_j_e_i_Default extends Factory<PluginNavList> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_p_r_RenameProjectPopUpScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<RenameProjectPopUpScreen> { }
  public abstract class Type_factory__o_u_e_w_c_c_l_LayersScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<LayersScreen> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_n_LeafPermissionNodeEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<LeafPermissionNodeEditor> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_w_p_s_SourceRepositoryPageViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<SourceRepositoryPageViewImpl> { }
  public abstract class Type_factory__o_d_w_s_d_c_DecisionTableXLSEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<DecisionTableXLSEntryPoint> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_p_ProjectView__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectView> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_p_ProjectClassList__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectClassList> { }
  public abstract class Type_factory__o_u_c_m_SplashScreenMenuPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<SplashScreenMenuPresenter> { }
  public abstract class ExtensionProvided_factory__c_g_g_u_c_u_FlowPanel__quals__j_e_i_Any_j_e_i_Default extends Factory<FlowPanel> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_a_i_AnnotationListItemViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<AnnotationListItemViewImpl> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_i_ExternalImportPresenter__quals__j_e_i_Any_o_k_w_c_s_l_c_s_i_Source extends Factory<ExternalImportPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_a_AssetsView__quals__j_e_i_Any_j_e_i_Default extends Factory<AssetsView> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_ACLSettings__quals__j_e_i_Any_j_e_i_Default extends Factory<ACLSettings> { }
  public abstract class Type_factory__o_o_w_s_s_c_e_TerminationConfigFormViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<TerminationConfigFormViewImpl> { }
  public abstract class Type_factory__o_u_e_e_c_c_f_e_j_FileExportScriptInjector__quals__j_e_i_Any_j_e_i_Default extends Factory<FileExportScriptInjector> { }
  public abstract class Type_factory__o_d_c_c_e_ValueBoxEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<ValueBoxEditor> { }
  public abstract class Type_factory__o_o_w_c_p_M2RepoPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<M2RepoPerspective> { }
  public abstract class ExtensionProvided_factory__o_k_w_c_s_j_c_w_ViewJavaSourceWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<ViewJavaSourceWidget> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_e_NewFieldPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<NewFieldPopup> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_c_DecisionTablePopoverUtils__quals__j_e_i_Any_j_e_i_Default extends Factory<DecisionTablePopoverUtils> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_i_ImportProjectsView__quals__j_e_i_Any_j_e_i_Default extends Factory<ImportProjectsView> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_e_XmlResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<XmlResourceType> { }
  public abstract class Type_factory__o_d_w_s_g_s_c_e_GuidedScoreCardEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<GuidedScoreCardEditorPresenterActivity> { }
  public abstract class Type_factory__o_d_c_c_l_e_PerspectiveDragConfigModal__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectiveDragConfigModal> { }
  public abstract class Type_factory__o_d_w_s_g_r_c_e_GuidedRuleEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedRuleEditorViewImpl> { }
  public abstract class Type_factory__o_u_e_w_c_c_l_LayersGroup__quals__j_e_i_Any_j_e_i_Default extends Factory<LayersGroup> { }
  public abstract class Type_factory__o_u_e_w_c_c_e_t_TextEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<TextEditorView> { }
  public abstract class Type_factory__o_d_d_c_w_f_TimeFrameEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<TimeFrameEditorView> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_TextArea__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<TextArea> { }
  public abstract class Type_factory__o_d_d_c_DisplayerScreenPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<DisplayerScreenPresenter> { }
  public abstract class Type_factory__o_g_m_p_ArtifactRepositoryPreferenceBeanGeneratedImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ArtifactRepositoryPreferenceBeanGeneratedImpl> { }
  public abstract class Type_factory__o_d_c_w_d_e_s_SQLDataSetDefAttributesEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<SQLDataSetDefAttributesEditorView> { }
  public abstract class Type_factory__o_k_w_c_s_d_s_XmlResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default extends Factory<XmlResourceTypeDefinition> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_p_PersistencePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<PersistencePresenter> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_e_GuvnorDefaultEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<GuvnorDefaultEditorPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_EmptyLibraryView__quals__j_e_i_Any_j_e_i_Default extends Factory<EmptyLibraryView> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_u_s_MenuItemsListPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<MenuItemsListPresenter> { }
  public abstract class Type_factory__o_k_w_c_w_c_w_KieSelectElement__quals__j_e_i_Any_j_e_i_Default extends Factory<KieSelectElement> { }
  public abstract class Type_factory__o_u_c_w_p_i_TemplatedWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<TemplatedWorkbenchPanelView> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_CardView__quals__j_e_i_Any_j_e_i_Default extends Factory<CardView> { }
  public abstract class Type_factory__o_d_w_s_d_t_DRLResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset extends Factory<DRLResourceTypeDefinition> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_h_HitPolicySelectorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<HitPolicySelectorViewImpl> { }
  public abstract class Type_factory__o_u_s_c_a_AuthorizationManagerHelper__quals__j_e_i_Any_j_e_i_Default extends Factory<AuthorizationManagerHelper> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_r_i_LibraryConstants__quals__j_e_i_Any_j_e_i_Default extends Factory<LibraryConstants> { }
  public abstract class Type_factory__o_k_w_c_s_h_c_HomeEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<HomeEntryPoint> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_m_ProjectMenu__quals__j_e_i_Any_j_e_i_Default extends Factory<ProjectMenu> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_n_t_ServerTemplatePresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ServerTemplatePresenter> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_w_c_TileView__quals__j_e_i_Any_j_e_i_Default extends Factory<TileView> { }
  public abstract class JsType_factory__o_u_c_m_PlaceManager__quals__Universal extends Factory<PlaceManager> { }
  public abstract class Type_factory__o_d_d_c_w_s_DefaultJsValidator__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultJsValidator> { }
  public abstract class Type_factory__o_d_w_s_d_t_DecisionTableXLSXResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset extends Factory<DecisionTableXLSXResourceTypeDefinition> { }
  public abstract class Type_factory__o_d_c_n_w_NavDropDownWidgetView__quals__j_e_i_Any_j_e_i_Default extends Factory<NavDropDownWidgetView> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_d_DroolsDataObjectEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DroolsDataObjectEditor> { }
  public abstract class Type_factory__o_j_e_u_n_c_l_TransitionAnchorProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<TransitionAnchorProvider> { }
  public abstract class Type_factory__o_u_c_v_p_m_UserMenu__quals__j_e_i_Any_j_e_i_Default extends Factory<UserMenu> { }
  public abstract class Type_factory__o_u_c_v_p_d_CompassWidgetImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<CompassWidgetImpl> { }
  public abstract class Type_factory__o_d_r_g_c_GoogleBarChartDisplayerView__quals__j_e_i_Any_j_e_i_Default extends Factory<GoogleBarChartDisplayerView> { }
  public abstract class Type_factory__o_k_w_c_s_r_c_KieWorkbenchCommonRefactoringClientEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<KieWorkbenchCommonRefactoringClientEntryPoint> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_LibraryEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<LibraryEntryPoint> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_u_UserAssignedRolesEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<UserAssignedRolesEditor> { }
  public abstract class Type_factory__o_k_w_c_s_v_r_c_VerifierEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<VerifierEntryPoint> { }
  public abstract class Type_factory__o_d_c_n_w_NavComponentConfigModalView__quals__j_e_i_Any_j_e_i_Default extends Factory<NavComponentConfigModalView> { }
  public abstract class Type_factory__o_u_e_p_c_p_e_PerspectiveEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectiveEditorPresenter> { }
  public abstract class Type_factory__o_u_e_p_c_w_p_GeneralPluginEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<GeneralPluginEditor> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_ColumnHeaderPopOverImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnHeaderPopOverImpl> { }
  public abstract class Type_factory__o_k_w_c_w_c_m_RepositoryMenu__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryMenu> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_CreateEntityView__quals__j_e_i_Any_j_e_i_Default extends Factory<CreateEntityView> { }
  public abstract class Type_factory__o_k_w_c_s_j_c_t_JavaResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<JavaResourceType> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ActionWorkItemInsertFactColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionWorkItemInsertFactColumnSynchronizer> { }
  public abstract class Type_factory__o_u_c_w_w_t_WorkbenchToolBarPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchToolBarPresenter> { }
  public abstract class Type_factory__o_k_w_c_w_c_t_TestReportingDocksHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<TestReportingDocksHandler> { }
  public abstract class Type_factory__o_u_e_e_c_c_BaseEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<BaseEditorEntryPoint> { }
  public abstract class Type_factory__o_u_e_p_c_t_EditorPluginResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<EditorPluginResourceType> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_v_PersistenceDescriptorValidationMessageTranslator__quals__j_e_i_Any_j_e_i_Default extends Factory<PersistenceDescriptorValidationMessageTranslator> { }
  public abstract class Type_factory__o_o_w_s_g_c_p_MultiConstraintHardSoftMatchRuleModellerActionPlugin__quals__j_e_i_Any_j_e_i_Default extends Factory<MultiConstraintHardSoftMatchRuleModellerActionPlugin> { }
  public abstract class Type_factory__o_d_d_c_w_RendererSelectorListBoxView__quals__j_e_i_Any_j_e_i_Default extends Factory<RendererSelectorListBoxView> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDataObjectEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<AdvancedDataObjectEditorViewImpl> { }
  public abstract class Type_factory__o_u_e_e_c_c_f_e_FileExportProducer__quals__j_e_i_Any_j_e_i_Default extends Factory<FileExportProducer> { }
  public abstract class JsType_factory__o_u_w_m_Position__quals__Universal extends Factory<Position> { }
  public abstract class Type_factory__o_u_e_p_c_e_EditorPlugInEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<EditorPlugInEditorView> { }
  public abstract class Type_factory__o_u_s_c_e_c_c_NewSSHKeyModalViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<NewSSHKeyModalViewImpl> { }
  public abstract class Type_factory__o_u_e_p_c_c_s_PreferencesRootScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<PreferencesRootScreenActivity> { }
  public abstract class Type_factory__o_k_w_c_s_l_a_p_LibraryOrganizationalUnitPreferencesBeanGeneratedImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<LibraryOrganizationalUnitPreferencesBeanGeneratedImpl> { }
  public abstract class Type_factory__o_k_w_c_s_v_r_c_p_AnalysisReportScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<AnalysisReportScreen> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_ExplorerMenu__quals__j_e_i_Any_j_e_i_Default extends Factory<ExplorerMenu> { }
  public abstract class Type_factory__o_j_e_s_c_l_c_BasicUserCacheImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<BasicUserCacheImpl> { }
  public abstract class Type_factory__o_d_w_s_d_c_e_DecisionTableXLSEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DecisionTableXLSEditorViewImpl> { }
  public abstract class Type_factory__o_u_e_p_c_w_m_MediaLibraryWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<MediaLibraryWidget> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_m_ViewMenuBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<ViewMenuBuilder> { }
  public abstract class Type_factory__o_u_c_e_EditorJSExporter__quals__j_e_i_Any_j_e_i_Default extends Factory<EditorJSExporter> { }
  public abstract class Type_factory__o_d_w_s_g_r_c_t_GuidedRuleDRLResourceType__quals__j_e_i_Any_j_e_i_Default extends Factory<GuidedRuleDRLResourceType> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_o_c_w_ContributorsManagementListItemPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ContributorsManagementListItemPresenter> { }
  public abstract class JsType_factory__o_u_c_m_LockTarget_TitleProvider__quals__Universal extends Factory<TitleProvider> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_WorkItemPage__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkItemPage> { }
  public abstract class Producer_factory__o_g_s_c_e_r_RepositoryPreferences__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryPreferences> { }
  public abstract class Type_factory__o_u_e_w_c_c_t_SimpleTable__quals__j_e_i_Any_j_e_i_Default extends Factory<SimpleTable> { }
  public abstract class Type_factory__o_u_e_p_c_c_t_TreeHierarchyInternalItemPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<TreeHierarchyInternalItemPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_w_POMWizardPage__quals__j_e_i_Any_j_e_i_Default extends Factory<POMWizardPage> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_h_HitPolicySelector__quals__j_e_i_Any_j_e_i_Default extends Factory<HitPolicySelector> { }
  public abstract class ExtensionProvided_factory__c_g_g_u_c_u_Label__quals__j_e_i_Any_j_e_i_Default extends Factory<com.google.gwt.user.client.ui.Label> { }
  public abstract class Type_factory__o_d_d_c_RendererManager__quals__j_e_i_Any_j_e_i_Default extends Factory<RendererManager> { }
  public abstract class Type_factory__o_j_e_s_c_l_n_SecurityContextHoldingSingleton__quals__j_e_i_Any_j_e_i_Default extends Factory<SecurityContextHoldingSingleton> { }
  public abstract class Type_factory__o_u_e_l_e_c_w_LayoutEditorPropertiesView__quals__j_e_i_Any_j_e_i_Default extends Factory<LayoutEditorPropertiesView> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_u_UserAssignedRolesExplorer__quals__j_e_i_Any_j_e_i_Default extends Factory<UserAssignedRolesExplorer> { }
  public abstract class Type_factory__o_d_r_c_s_SelectorSliderDisplayer__quals__j_e_i_Any_j_e_i_Default extends Factory<SelectorSliderDisplayer> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_c_s_ContainerRemoteStatusPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ContainerRemoteStatusPresenter> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_p_ConfirmBox__quals__j_e_i_Any_j_e_i_Default extends Factory<ConfirmBox> { }
  public abstract class JsType_factory__o_u_w_m_CompassPosition__quals__Universal extends Factory<CompassPosition> { }
  public abstract class Type_factory__o_o_w_s_s_c_e_TerminationTreeItemContentViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<TerminationTreeItemContentViewImpl> { }
  public abstract class Type_factory__o_u_e_c_p_ExperimentalFeaturesPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ExperimentalFeaturesPerspectiveActivity> { }
  public abstract class Type_factory__o_u_c_m_ActivityManagerImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ActivityManagerImpl> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_e_NewFieldPopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<NewFieldPopupViewImpl> { }
  public abstract class Type_factory__o_d_w_s_g_c_e_GlobalsEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<GlobalsEditorPresenterActivity> { }
  public abstract class ExtensionProvided_factory__c_g_g_u_c_u_CheckBox__quals__j_e_i_Any_j_e_i_Default extends Factory<com.google.gwt.user.client.ui.CheckBox> { }
  public abstract class Type_factory__o_u_e_s_m_c_e_r_RoleEditorDriver__quals__j_e_i_Any_j_e_i_Default extends Factory<RoleEditorDriver> { }
  public abstract class Type_factory__o_u_e_s_m_c_w_m_e_a_n_PermissionSwitchView__quals__j_e_i_Any_j_e_i_Default extends Factory<PermissionSwitchView> { }
  public abstract class Type_factory__o_o_w_s_s_c_e_SolverEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<SolverEditorPresenter> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_w_OverviewWidgetViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<OverviewWidgetViewImpl> { }
  public abstract class JsType_factory__o_u_w_m_m_MenuVisitor__quals__Universal extends Factory<MenuVisitor> { }
  public abstract class Type_factory__o_d_c_w_d_e_e_ElasticSearchDataSetDefAttributesEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<ElasticSearchDataSetDefAttributesEditorView> { }
  public abstract class Type_factory__o_d_c_w_d_e_d_DataSetEditorDriverFactory__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetEditorDriverFactory> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_c_c_p_ContainerProcessConfigPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ContainerProcessConfigPresenter> { }
  public abstract class Type_factory__o_d_c_n_w_NavDropDownWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<NavDropDownWidget> { }
  public abstract class Type_factory__o_u_p_c_s_PreferenceScopeResolutionStrategyIOCProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<PreferenceScopeResolutionStrategyIOCProvider> { }
  public abstract class Type_factory__o_u_c_e_PerspectiveJSExporter__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectiveJSExporter> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_s_e_ExternalDataObjectsPresenter_ImportsListPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ImportsListPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_p_PackageSelector__quals__j_e_i_Any_j_e_i_Default extends Factory<PackageSelector> { }
  public abstract class Type_factory__o_d_w_s_g_r_t_GuidedRuleDRLResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset extends Factory<GuidedRuleDRLResourceTypeDefinition> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_a_AssetsScreen__quals__j_e_i_Any_j_e_i_Default extends Factory<AssetsScreen> { }
  public abstract class Type_factory__o_d_c_w_d_e_b_BeanDataSetEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<BeanDataSetEditor> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_d_LimitedEntryConditionCol52DefinitionBuilder__quals__j_e_i_Any_j_e_i_Default extends Factory<LimitedEntryConditionCol52DefinitionBuilder> { }
  public abstract class Type_factory__o_d_w_s_w_c_e_WorkItemsEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkItemsEditorPresenter> { }
  public abstract class Type_factory__o_d_w_s_d_c_DRLEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default extends Factory<DRLEditorEntryPoint> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_NewGuidedDecisionTableWizard__quals__j_e_i_Any_j_e_i_Default extends Factory<NewGuidedDecisionTableWizard> { }
  public abstract class Type_factory__o_k_w_c_w_c_p_v_ValidationPopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ValidationPopupViewImpl> { }
  public abstract class Type_factory__o_d_c_n_w_NavMenuBarWidgetView__quals__j_e_i_Any_j_e_i_Default extends Factory<NavMenuBarWidgetView> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_w_m_MainDataObjectEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<MainDataObjectEditor> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_e_p_ColumnsPageView__quals__j_e_i_Any_j_e_i_Default extends Factory<ColumnsPageView> { }
  public abstract class Type_factory__o_u_e_p_c_p_e_l_e_p_EditHTMLPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<EditHTMLPresenter> { }
  public abstract class Type_factory__o_d_c_c_e_l_DropDownEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<DropDownEditor> { }
  public abstract class ExtensionProvided_factory__o_u_e_w_c_c_a_AceEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<AceEditor> { }
  public abstract class Type_factory__o_k_w_c_s_s_p_c_WorkbenchPreferenceScopeResolutionStrategy__quals__j_e_i_Any_j_e_i_Default extends Factory<WorkbenchPreferenceScopeResolutionStrategy> { }
  public abstract class Type_factory__o_d_r_c_s_SelectorDropDownItem__quals__j_e_i_Any_j_e_i_Default extends Factory<SelectorDropDownItem> { }
  public abstract class Type_factory__o_u_e_w_c_c_d_PerspectiveDropDown__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectiveDropDown> { }
  public abstract class Type_factory__o_d_c_w_d_e_DataSetDefPreviewTable__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefPreviewTable> { }
  public abstract class Type_factory__o_k_w_c_w_c_h_NewResourcesMenu__quals__j_e_i_Any_j_e_i_Default extends Factory<NewResourcesMenu> { }
  public abstract class Type_factory__o_d_c_c_s_h_ContentManagerHomeView__quals__j_e_i_Any_j_e_i_Default extends Factory<ContentManagerHomeView> { }
  public abstract class Type_factory__o_d_r_g_c_GoogleMeterChartDisplayerView__quals__j_e_i_Any_j_e_i_Default extends Factory<GoogleMeterChartDisplayerView> { }
  public abstract class Type_factory__o_o_w_s_g_c_p_MultiConstraintBendableBigDecimalMatchRuleModellerActionPlugin__quals__j_e_i_Any_j_e_i_Default extends Factory<MultiConstraintBendableBigDecimalMatchRuleModellerActionPlugin> { }
  public abstract class Type_factory__o_k_w_c_w_c_t_TestRunnerReportingScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<TestRunnerReportingScreenActivity> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_c_c_AttributeColumnConfigRow__quals__j_e_i_Any_j_e_i_Default extends Factory<AttributeColumnConfigRow> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_n_t_c_CopyPopupPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<CopyPopupPresenter> { }
  public abstract class Type_factory__o_j_e_s_c_l_c_DefaultBusSecurityErrorCallback__quals__j_e_i_Any_j_e_i_Default extends Factory<DefaultBusSecurityErrorCallback> { }
  public abstract class Type_factory__o_k_w_c_w_c_e_GenericErrorPopup__quals__j_e_i_Any_j_e_i_Default extends Factory<GenericErrorPopup> { }
  public abstract class Type_factory__o_d_c_w_d_e_a_DataSetDefCacheAttributesEditorViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<DataSetDefCacheAttributesEditorViewImpl> { }
  public abstract class Type_factory__o_u_e_p_c_c_a_PreferencesCentralActionsView__quals__j_e_i_Any_j_e_i_Default extends Factory<PreferencesCentralActionsView> { }
  public abstract class Type_factory__o_k_w_c_s_s_m_c_w_c_t_LinkTitleView__quals__j_e_i_Any_j_e_i_Default extends Factory<LinkTitleView> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_s_o_c_w_ContributorsManagementView__quals__j_e_i_Any_j_e_i_Default extends Factory<ContributorsManagementView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_c_p_ValueOptionsPageView__quals__j_e_i_Any_j_e_i_Default extends Factory<ValueOptionsPageView> { }
  public abstract class Type_factory__o_u_e_p_c_c_PreferencesCentralPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<PreferencesCentralPerspective> { }
  public abstract class Type_factory__o_g_c_s_p_c_r_ConflictingRepositoriesPopupViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ConflictingRepositoriesPopupViewImpl> { }
  public abstract class Type_factory__o_u_e_w_c_c_p_ContainersGroup__quals__j_e_i_Any_j_e_i_Default extends Factory<ContainersGroup> { }
  public abstract class Type_factory__o_k_w_c_s_l_c_w_e_e_ExampleProjectErrorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ExampleProjectErrorPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_h_j_JPADomainHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<JPADomainHandler> { }
  public abstract class Type_factory__o_d_w_s_t_c_ScenarioEditorPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ScenarioEditorPresenter> { }
  public abstract class Type_factory__o_k_w_c_s_p_c_f_d_DependencyListWidget__quals__j_e_i_Any_j_e_i_Default extends Factory<DependencyListWidget> { }
  public abstract class Type_factory__o_k_w_c_s_e_c_ExplorerPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<ExplorerPresenterActivity> { }
  public abstract class Type_factory__o_g_s_c_s_RepositoryTreeProvider__quals__j_e_i_Any_j_e_i_Default extends Factory<RepositoryTreeProvider> { }
  public abstract class Type_factory__o_g_c_s_p_c_Decision__quals__j_e_i_Any_j_e_i_Default extends Factory<Decision> { }
  public abstract class Type_factory__o_u_c_v_p_m_m_c_GroupContextMenuItemView__quals__j_e_i_Any_j_e_i_Default extends Factory<GroupContextMenuItemView> { }
  public abstract class Type_factory__o_o_w_c_h_HomeProducer__quals__j_e_i_Any_j_e_i_Default extends Factory<HomeProducer> { }
  public abstract class Type_factory__o_u_e_w_c_c_s_i_IFrameScreenPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<IFrameScreenPresenter> { }
  public abstract class Type_factory__o_d_d_c_w_f_LikeToFunctionEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<LikeToFunctionEditor> { }
  public abstract class Type_factory__o_u_e_l_e_c_w_LayoutEditorPropertiesPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<LayoutEditorPropertiesPresenter> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_Button__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<org.jboss.errai.common.client.dom.Button> { }
  public abstract class Type_factory__o_u_s_c_e_SSHKeysEditorPerspective__quals__j_e_i_Any_j_e_i_Default extends Factory<SSHKeysEditorPerspective> { }
  public abstract class Type_factory__o_u_e_l_e_c_w_LayoutElementPropertiesView__quals__j_e_i_Any_j_e_i_Default extends Factory<LayoutElementPropertiesView> { }
  public abstract class Type_factory__o_u_c_e_ResourceTypeDefinitionJSExporter__quals__j_e_i_Any_j_e_i_Default extends Factory<ResourceTypeDefinitionJSExporter> { }
  public abstract class Type_factory__o_d_d_c_w_f_NumberParameterEditorView__quals__j_e_i_Any_j_e_i_Default extends Factory<NumberParameterEditorView> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_GridWidgetColumnFactoryImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<GridWidgetColumnFactoryImpl> { }
  public abstract class Type_factory__o_d_w_s_g_d_c_w_t_p_ActionSetFieldsPageViewImpl__quals__j_e_i_Any_j_e_i_Default extends Factory<ActionSetFieldsPageViewImpl> { }
  public abstract class Type_factory__o_d_w_s_d_c_h_NewDrlTextHandler__quals__j_e_i_Any_j_e_i_Default extends Factory<NewDrlTextHandler> { }
  public abstract class Type_factory__o_k_w_c_w_m_c_w_ExternalLinkPresenter__quals__j_e_i_Any_j_e_i_Default extends Factory<ExternalLinkPresenter> { }
  public abstract class Type_factory__o_u_e_p_c_p_e_l_e_PerspectiveEditorSettings__quals__j_e_i_Any_j_e_i_Default extends Factory<PerspectiveEditorSettings> { }
  public abstract class Type_factory__o_d_d_c_w_f_TimeAmountEditor__quals__j_e_i_Any_j_e_i_Default extends Factory<TimeAmountEditor> { }
  public abstract class Type_factory__o_k_w_c_s_d_c_e_GuvnorDefaultEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority extends Factory<GuvnorDefaultEditorPresenterActivity> { }
  public abstract class ExtensionProvided_factory__o_j_e_c_c_d_RadioInput__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<RadioInput> { }
  public abstract class Type_factory__o_u_c_w_p_i_LayoutPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named extends Factory<LayoutPanelView> { }
  private static void addLookups_0() {
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.datamodeller.events.DataModelerValueChangeEvent", "org.kie.workbench.common.screens.datamodeller.events.DataModelerEvent");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldDeletedEvent", "org.kie.workbench.common.screens.datamodeller.events.DataModelerEvent");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldChangeEvent", "org.kie.workbench.common.screens.datamodeller.events.DataModelerValueChangeEvent");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.datamodeller.events.DataObjectChangeEvent", "org.kie.workbench.common.screens.datamodeller.events.DataModelerValueChangeEvent");
    CDIEventTypeLookup.get().addLookup("org.kie.workbench.common.screens.datamodeller.events.DataModelStatusChangeEvent", "org.kie.workbench.common.screens.datamodeller.events.DataModelerValueChangeEvent");
  }

  private void registerFactories0(final Context org_jboss_errai_ioc_client_container_ApplicationScopedContext_context, final Context org_jboss_errai_ioc_client_container_DependentScopeContext_context) {
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<MessageConsoleScreen>) GWT.create(Type_factory__o_g_m_c_c_MessageConsoleScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTableOptions>) GWT.create(Type_factory__o_d_w_s_g_d_c_h_GuidedDecisionTableOptions__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GroupsExplorer>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_GroupsExplorer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DefaultWorkbenchErrorCallback>) GWT.create(Type_factory__o_k_w_c_w_c_e_DefaultWorkbenchErrorCallback__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<OrganizationalUnitPopUpPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_o_p_OrganizationalUnitPopUpPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CheckboxInput>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_CheckboxInput__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionWorkItemSetFieldPlugin>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_ActionWorkItemSetFieldPlugin__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ChangePasswordView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_ChangePasswordView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SolverEditorPresenterActivity>) GWT.create(Type_factory__o_o_w_s_s_c_e_SolverEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExampleProjectOkView>) GWT.create(Type_factory__o_k_w_c_s_l_c_w_e_e_ExampleProjectOkView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DisplayerEditorStatus>) GWT.create(Type_factory__o_d_d_c_w_DisplayerEditorStatus__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SolverEditorViewImpl>) GWT.create(Type_factory__o_o_w_s_s_c_e_SolverEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SearchAnnotationPage>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_a_SearchAnnotationPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AuditTable>) GWT.create(Type_factory__o_d_w_s_t_c_p_a_AuditTable__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedRuleTemplateDataViewImpl>) GWT.create(Type_factory__o_d_w_s_g_t_c_e_GuidedRuleTemplateDataViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ToggleSwitch>) GWT.create(ExtensionProvided_factory__o_g_e_t_c_u_ToggleSwitch__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnExpansionPageViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_ColumnExpansionPageViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ServerEmptyView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_e_ServerEmptyView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TransitionAnchorFactory>) GWT.create(ContextualProvider_factory__o_j_e_u_n_c_l_TransitionAnchorFactory__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefColumnsFilterEditorView>) GWT.create(Type_factory__o_d_c_w_d_e_DataSetDefColumnsFilterEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<Workbench>) GWT.create(Type_factory__o_u_c_w_Workbench__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkItemsEditorViewImpl>) GWT.create(Type_factory__o_d_w_s_w_c_e_WorkItemsEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkItemsEditorPresenterActivity>) GWT.create(Type_factory__o_d_w_s_w_c_e_WorkItemsEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExampleProjectWidget>) GWT.create(Type_factory__o_k_w_c_s_l_c_w_e_ExampleProjectWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RoleEditor>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_r_RoleEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdvancedDataObjectEditor>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDataObjectEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultiListWorkbenchPanelPresenter>) GWT.create(Type_factory__o_u_c_w_p_i_MultiListWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ResourceType>) GWT.create(JsType_factory__o_u_s_ResourceType__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EntitiesListView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_l_EntitiesListView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EnhancedDependenciesManager>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_d_EnhancedDependenciesManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ItemElement>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_u_d_KieDropdownElement_ItemElement__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ActivityBeansInfo>) GWT.create(Type_factory__o_u_c_m_ActivityBeansInfo__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SQLDataSetBasicAttributesWorkflow>) GWT.create(Type_factory__o_d_c_w_d_e_w_c_SQLDataSetBasicAttributesWorkflow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<MediumConstraintMatchRuleModellerActionPlugin>) GWT.create(Type_factory__o_o_w_s_g_c_p_MediumConstraintMatchRuleModellerActionPlugin__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GroupEditorView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_g_GroupEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UnanchoredWorkbenchPartView>) GWT.create(Type_factory__o_u_c_w_p_u_p_UnanchoredWorkbenchPartView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataObjectFieldPickerItemViewImpl>) GWT.create(Type_factory__o_o_w_s_d_c_w_p_DataObjectFieldPickerItemViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisabledFeatureComponentViewImpl>) GWT.create(Type_factory__o_u_e_c_d_c_DisabledFeatureComponentViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<OrgUnitsMetricsScreen>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_OrgUnitsMetricsScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnExpansionPage>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_ColumnExpansionPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TextBox>) GWT.create(ExtensionProvided_factory__o_g_c_u_TextBox__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MapEditorView>) GWT.create(Type_factory__o_d_c_c_e_m_MapEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Select>) GWT.create(Type_factory__o_u_c_v_p_w_Select__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CopyPopupWithPackageView>) GWT.create(Type_factory__o_k_w_c_w_c_p_c_CopyPopupWithPackageView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BreadcrumbNavigator>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_n_BreadcrumbNavigator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdminPagePresenterActivity>) GWT.create(Type_factory__o_u_e_p_c_a_AdminPagePresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TerminationConfigForm>) GWT.create(Type_factory__o_o_w_s_s_c_e_TerminationConfigForm__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuvnorDefaultEditorViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_e_GuvnorDefaultEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PopStateEventEventInitDictType>) GWT.create(JsType_factory__e_d_PopStateEvent_PopStateEventEventInitDictType__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ErrorPopupView>) GWT.create(Type_factory__o_u_c_v_p_w_ErrorPopupView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultiplePermissionNodeViewerView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_n_MultiplePermissionNodeViewerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionSetFieldCol52DefinitionBuilder>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_d_ActionSetFieldCol52DefinitionBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PerspectiveDragConfigModalView>) GWT.create(Type_factory__o_d_c_c_l_e_PerspectiveDragConfigModalView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DSLEditorViewImpl>) GWT.create(Type_factory__o_d_w_s_d_c_e_DSLEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LocalSearchForm>) GWT.create(Type_factory__o_o_w_s_s_c_e_LocalSearchForm__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DroolsDomainScreenActivity>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_d_DroolsDomainScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EditorPlugInEditorPresenter>) GWT.create(Type_factory__o_u_e_p_c_e_EditorPlugInEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KnowledgeBasesPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_k_KnowledgeBasesPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ValuePairEditorPage>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_a_ValuePairEditorPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedScoreCardEditorPresenter>) GWT.create(Type_factory__o_d_w_s_g_s_c_e_GuidedScoreCardEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AlertsEntryPoint>) GWT.create(Type_factory__o_g_m_c_c_AlertsEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MetaDataColumnPage>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_MetaDataColumnPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ImportsWidgetViewImpl>) GWT.create(Type_factory__o_k_w_c_w_c_c_w_b_ImportsWidgetViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GoogleTableDisplayerView>) GWT.create(Type_factory__o_d_r_g_c_GoogleTableDisplayerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTableAccordionItem>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_p_a_GuidedDecisionTableAccordionItem__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GroupEditorWorkflow>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_g_w_GroupEditorWorkflow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PackageNameWhiteListResourceTypeDefinition>) GWT.create(Type_factory__o_k_w_c_s_d_s_PackageNameWhiteListResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MenuGroup>) GWT.create(JsType_factory__o_u_w_m_m_MenuGroup__quals__Universal.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkbenchConfigurationMenuBuilder>) GWT.create(Type_factory__o_k_w_c_w_c_m_WorkbenchConfigurationMenuBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GoogleBarChartDisplayer>) GWT.create(Type_factory__o_d_r_g_c_GoogleBarChartDisplayer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AlertsButtonMenuItemBuilder>) GWT.create(Type_factory__o_g_m_c_c_w_b_AlertsButtonMenuItemBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedRuleTemplateResourceType>) GWT.create(Type_factory__o_d_w_s_g_t_c_t_GuidedRuleTemplateResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Container>) GWT.create(ExtensionProvided_factory__o_g_c_u_Container__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ProjectConfigScreenEntryPoint>) GWT.create(Type_factory__o_k_w_c_s_p_c_ProjectConfigScreenEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NavTilesWidget>) GWT.create(Type_factory__o_d_c_n_w_NavTilesWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PriorityDropDown>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_PriorityDropDown__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefEditorPresenterActivity>) GWT.create(Type_factory__o_d_d_e_c_s_DataSetDefEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Event>) GWT.create(ContextualProvider_factory__j_e_e_Event__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ValidationItemPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_v_ValidationItemPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ConflictingRepositoriesPopup>) GWT.create(Type_factory__o_g_c_s_p_c_r_ConflictingRepositoriesPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PermissionWidgetFactory>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_n_PermissionWidgetFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PropertyEditorAdaptorsCache>) GWT.create(Type_factory__o_u_e_w_c_c_p_PropertyEditorAdaptorsCache__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ListBox>) GWT.create(ExtensionProvided_factory__o_g_c_u_ListBox__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserCreationWorkflow>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_u_w_UserCreationWorkflow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<POMEditorPanelViewImpl>) GWT.create(Type_factory__o_g_c_s_p_c_POMEditorPanelViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<Others>) GWT.create(Type_factory__o_u_w_c_Others__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Elemental2DomUtil>) GWT.create(Type_factory__o_j_e_c_c_d_e_Elemental2DomUtil__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuvnorStructureContext>) GWT.create(Type_factory__o_g_s_c_e_c_GuvnorStructureContext__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerTypeSelector>) GWT.create(Type_factory__o_d_d_c_w_DisplayerTypeSelector__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<VersionRecordManager>) GWT.create(Type_factory__o_u_e_e_c_c_h_VersionRecordManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<InvalidProjectScreen>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_a_InvalidProjectScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkbenchServicesProxyClientImpl>) GWT.create(Type_factory__o_u_c_w_WorkbenchServicesProxyClientImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ValueBoxEditorView>) GWT.create(Type_factory__o_d_c_c_e_ValueBoxEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<StaticWorkbenchPanelPresenter>) GWT.create(Type_factory__o_u_c_w_p_i_StaticWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultipleNumberParameterEditorView>) GWT.create(Type_factory__o_d_d_c_w_f_MultipleNumberParameterEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ConfigurationComboBoxItemWidget>) GWT.create(Type_factory__o_k_w_c_w_c_h_w_c_ConfigurationComboBoxItemWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataObjectFieldPickerItem>) GWT.create(Type_factory__o_o_w_s_d_c_w_p_DataObjectFieldPickerItem__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Button>) GWT.create(Type_factory__o_u_c_v_p_w_Button__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<TableEntryPoint>) GWT.create(Type_factory__o_u_e_w_t_c_TableEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DefaultFileEditorPresenter>) GWT.create(Type_factory__o_u_e_w_c_c_e_d_DefaultFileEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GlobalsEditorEntryPoint>) GWT.create(Type_factory__o_d_w_s_g_c_GlobalsEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ValuePairEditorProvider>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_v_ValuePairEditorProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AddImportPopup>) GWT.create(ExtensionProvided_factory__o_k_w_c_w_c_c_w_b_AddImportPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ToolBarIcon>) GWT.create(JsType_factory__o_u_w_m_t_ToolBarIcon__quals__Universal.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PerspectiveEditorGenerator>) GWT.create(Type_factory__o_u_e_p_c_p_e_g_PerspectiveEditorGenerator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LockManager>) GWT.create(JsType_factory__o_u_c_m_LockManager__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NumberInput>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_NumberInput__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ScoreCardXLSEditorViewImpl>) GWT.create(Type_factory__o_d_w_s_s_c_e_ScoreCardXLSEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BatchCaller>) GWT.create(Provider_factory__o_j_e_c_c_a_BatchCaller__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HomeView>) GWT.create(Type_factory__o_k_w_c_s_h_c_w_h_HomeView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SimpleWorkbenchPanelPresenter>) GWT.create(Type_factory__o_u_c_w_p_i_SimpleWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GoogleBubbleChartDisplayerView>) GWT.create(Type_factory__o_d_r_g_c_GoogleBubbleChartDisplayerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<OrganizationalUnitTreeProvider>) GWT.create(Type_factory__o_g_s_c_s_OrganizationalUnitTreeProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<OperatorPageView>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_OperatorPageView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NotificationPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_b_n_NotificationPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DropDownImageListEditor>) GWT.create(Type_factory__o_d_c_c_e_l_DropDownImageListEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FormLabel>) GWT.create(Type_factory__o_u_c_v_p_w_FormLabel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TextEditorWorkbenchEditor>) GWT.create(Type_factory__o_u_e_w_c_c_e_t_TextEditorWorkbenchEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NavigationExplorerScreen>) GWT.create(Type_factory__o_d_c_c_s_e_NavigationExplorerScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<LayoutComponentPaletteScreen>) GWT.create(Type_factory__o_u_e_l_e_c_LayoutComponentPaletteScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContributorsScreen>) GWT.create(Type_factory__o_k_w_c_s_c_c_s_ContributorsScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GooglePieChartDisplayer>) GWT.create(Type_factory__o_d_r_g_c_GooglePieChartDisplayer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SelectorLabelItemView>) GWT.create(Type_factory__o_d_r_c_s_SelectorLabelItemView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PomEditorActivity>) GWT.create(Type_factory__o_k_w_c_s_l_c_u_PomEditorActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HTMLLayoutDragComponent>) GWT.create(Type_factory__o_u_e_p_c_p_e_l_e_HTMLLayoutDragComponent__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefColumnsEditor>) GWT.create(Type_factory__o_d_c_w_d_e_c_DataSetDefColumnsEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WiresCanvas>) GWT.create(Type_factory__o_u_e_w_c_c_c_WiresCanvas__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExamplesWizard>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_ExamplesWizard__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DefaultPermissionManager>) GWT.create(Type_factory__o_u_s_i_a_DefaultPermissionManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CloseUnsavedProjectAssetsPopUpPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_p_c_CloseUnsavedProjectAssetsPopUpPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BooleanField>) GWT.create(Type_factory__o_u_e_p_e_c_f_BooleanField__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<Navigation>) GWT.create(Type_factory__o_j_e_u_n_c_l_Navigation__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MenuPosition>) GWT.create(JsType_factory__o_u_w_m_m_MenuPosition__quals__Universal.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ActionInsertNodeFactory>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_f_ActionInsertNodeFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ScoreCardXLSResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_s_t_ScoreCardXLSResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActivityNotFoundPresenterActivity>) GWT.create(Type_factory__o_u_e_w_c_c_w_w_p_a_n_ActivityNotFoundPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkbenchMegaMenuView>) GWT.create(Type_factory__o_u_c_v_p_m_m_WorkbenchMegaMenuView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultiScreenMenuBuilder>) GWT.create(Type_factory__o_u_c_v_p_m_MultiScreenMenuBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SelectOptionView>) GWT.create(Type_factory__o_u_e_w_c_c_s_SelectOptionView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataColumnDefDriver>) GWT.create(Producer_factory__o_d_c_w_d_e_d_DataColumnDefDriver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SQLDataSetEditor>) GWT.create(Type_factory__o_d_c_w_d_e_s_SQLDataSetEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PatternFlyEntryPoint>) GWT.create(Type_factory__o_u_c_v_p_PatternFlyEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkbenchMenuStandardNavBarView>) GWT.create(Type_factory__o_u_c_v_p_m_WorkbenchMenuStandardNavBarView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AdministrationPerspective>) GWT.create(Type_factory__o_o_w_c_p_AdministrationPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SecurityContextImpl>) GWT.create(Type_factory__o_j_e_s_c_l_c_SecurityContextImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ClientDataSetManager>) GWT.create(Type_factory__o_d_d_c_ClientDataSetManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DomainEditorEntryPoint>) GWT.create(Type_factory__o_o_w_s_d_c_DomainEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerHtmlEditor>) GWT.create(Type_factory__o_d_d_c_w_DisplayerHtmlEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewUserAttributeEditorView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_u_NewUserAttributeEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefWizardScreenActivity>) GWT.create(Type_factory__o_d_d_e_c_s_DataSetDefWizardScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<TransitionToRoleProvider>) GWT.create(Type_factory__o_j_e_u_n_c_l_TransitionToRoleProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ServerManagementPerspectiveActivity>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_ServerManagementPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BeanDataSetDefDriver>) GWT.create(Producer_factory__o_d_c_w_d_e_d_BeanDataSetDefDriver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefRefreshAttributesEditorView>) GWT.create(Type_factory__o_d_c_w_d_e_a_DataSetDefRefreshAttributesEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TimeInstantEditorView>) GWT.create(Type_factory__o_d_d_c_w_f_TimeInstantEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ElasticSearchDataSetDefAttributesDriver>) GWT.create(Producer_factory__o_d_c_w_d_e_d_ElasticSearchDataSetDefAttributesDriver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<HomePerspective>) GWT.create(Type_factory__o_k_w_c_s_h_c_p_HomePerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EditMenuBuilder>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_m_EditMenuBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoriesPresenter>) GWT.create(Type_factory__o_g_s_c_e_r_l_RepositoriesPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JPADataObjectFieldEditor>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_j_JPADataObjectFieldEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NavTabListWidgetView>) GWT.create(Type_factory__o_d_c_n_w_NavTabListWidgetView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LibraryInternalPreferencesBeanGeneratedImpl>) GWT.create(Type_factory__o_k_w_c_s_l_a_p_LibraryInternalPreferencesBeanGeneratedImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MavenRepositoryPagedJarTable>) GWT.create(Type_factory__o_g_m_c_e_MavenRepositoryPagedJarTable__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ScoreCardXLSEditorPresenter>) GWT.create(Type_factory__o_d_w_s_s_c_e_ScoreCardXLSEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AddSingleValueModalView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_u_m_s_AddSingleValueModalView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PerspectiveDragComponent>) GWT.create(Type_factory__o_d_c_c_l_e_PerspectiveDragComponent__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MenuItemHeaderView>) GWT.create(Type_factory__o_u_e_w_c_c_m_MenuItemHeaderView__quals__j_e_i_Any_o_u_e_w_c_c_m_MenuItemHeader.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DefaultBeanFactory>) GWT.create(Type_factory__o_u_c_w_DefaultBeanFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LoadingBoxView>) GWT.create(Type_factory__o_d_c_w_c_LoadingBoxView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PopulatedLibraryView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_PopulatedLibraryView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnDetailsEditor>) GWT.create(Type_factory__o_d_d_c_w_g_ColumnDetailsEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SelectDocumentPopup>) GWT.create(Type_factory__o_k_w_c_w_m_c_p_SelectDocumentPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GroupCreationWorkflow>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_g_w_GroupCreationWorkflow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PermissionExceptionSwitchView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_n_PermissionExceptionSwitchView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PropertiesScreenActivity>) GWT.create(Type_factory__o_u_e_w_c_c_p_PropertiesScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LimitedEntryActionRetractFactCol52DefinitionBuilder>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_d_LimitedEntryActionRetractFactCol52DefinitionBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<HardConstraintMatchRuleModellerActionPlugin>) GWT.create(Type_factory__o_o_w_s_g_c_p_HardConstraintMatchRuleModellerActionPlugin__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SSHKeysEditorEmptyStateDisplayer>) GWT.create(Type_factory__o_u_s_c_e_c_e_SSHKeysEditorEmptyStateDisplayer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DecisionTableXLSResourceType>) GWT.create(Type_factory__o_d_w_s_d_c_t_DecisionTableXLSResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AssignedEntitiesExplorerView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_AssignedEntitiesExplorerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<BendableHardConstraintMatchRuleModellerActionPlugin>) GWT.create(Type_factory__o_o_w_s_g_c_p_BendableHardConstraintMatchRuleModellerActionPlugin__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ProjectController>) GWT.create(Type_factory__o_g_c_s_p_c_s_ProjectController__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ScoreCardXLSEditorPresenterActivity>) GWT.create(Type_factory__o_d_w_s_s_c_e_ScoreCardXLSEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PathLabel>) GWT.create(Type_factory__o_k_w_c_w_c_h_PathLabel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PartManager>) GWT.create(Type_factory__o_u_c_w_p_s_PartManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<Undefined>) GWT.create(Type_factory__o_u_w_c_Undefined__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NavMenuBarDragComponent>) GWT.create(Type_factory__o_d_c_n_l_e_NavMenuBarDragComponent__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefRefreshIntervalEditorView>) GWT.create(Type_factory__o_d_c_w_d_e_a_DataSetDefRefreshIntervalEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DefaultGuidedDecisionTableLinkManager>) GWT.create(Type_factory__o_d_w_s_g_d_s_DefaultGuidedDecisionTableLinkManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetAuthoringHomeView>) GWT.create(Type_factory__o_d_d_e_c_s_DataSetAuthoringHomeView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RowContextMenuViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_m_RowContextMenuViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PersistableDataObjectsItemPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_p_p_PersistableDataObjectsItemPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TransitionTo>) GWT.create(ContextualProvider_factory__o_j_e_u_n_c_l_TransitionTo__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NavItemDefaultEditor>) GWT.create(Type_factory__o_d_c_n_w_e_NavItemDefaultEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MessageConsoleScreenActivity>) GWT.create(Type_factory__o_g_m_c_c_MessageConsoleScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GoogleBubbleChartDisplayer>) GWT.create(Type_factory__o_d_r_g_c_GoogleBubbleChartDisplayer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PopulatedAssetsScreen>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_a_PopulatedAssetsScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoryEditorPresenter>) GWT.create(Type_factory__o_g_s_c_e_r_e_RepositoryEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExternalLinkViewImpl>) GWT.create(Type_factory__o_k_w_c_w_m_c_w_ExternalLinkViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DeleteColumnManagementAnchorWidget>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_c_c_DeleteColumnManagementAnchorWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewPatternView>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_m_NewPatternView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SummaryPageView>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_SummaryPageView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<StructureEntryPoint>) GWT.create(Type_factory__o_g_s_c_StructureEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<CDIClientFeatureDefRegistry>) GWT.create(Type_factory__o_u_e_c_s_i_CDIClientFeatureDefRegistry__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EnumEditorViewImpl>) GWT.create(Type_factory__o_d_w_s_e_c_e_EnumEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTableAccordion>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_p_a_GuidedDecisionTableAccordion__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HtmlEditor>) GWT.create(Type_factory__o_u_e_e_c_c_h_HtmlEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<VFSLockServiceProxyClientImpl>) GWT.create(Type_factory__o_u_c_w_VFSLockServiceProxyClientImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KSessionSelectorViewImpl>) GWT.create(Type_factory__o_k_w_c_w_c_w_KSessionSelectorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DeleteOrganizationalUnitPopUpView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_o_d_DeleteOrganizationalUnitPopUpView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SelectorDropDownItemView>) GWT.create(Type_factory__o_d_r_c_s_SelectorDropDownItemView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RemoteStatusPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_r_RemoteStatusPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AdvancedDomainScreen>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDomainScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProjectImportsScreenPresenterActivity>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_ProjectImportsScreenPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AppLauncherView>) GWT.create(Type_factory__o_k_w_c_w_c_p_l_AppLauncherView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContributorsListView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_o_c_t_ContributorsListView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<KieWorkbenchWidgetsCommonEntryPoint>) GWT.create(Type_factory__o_k_w_c_w_c_KieWorkbenchWidgetsCommonEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KnowledgeBaseItemPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_k_i_KnowledgeBaseItemPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EmptyAssetsView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_a_EmptyAssetsView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ListenerListItemPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_k_i_k_l_ListenerListItemPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PluginExplorerScreen>) GWT.create(Type_factory__o_u_e_p_c_e_PluginExplorerScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AddAssetScreen>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_a_a_AddAssetScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PartContextMenusView>) GWT.create(Type_factory__o_u_c_v_p_m_PartContextMenusView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ResizeTabPanel>) GWT.create(Type_factory__o_u_c_v_p_t_ResizeTabPanel__quals__j_e_i_Any_o_u_c_v_p_t_Resize.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FilterLabelSet>) GWT.create(Type_factory__o_d_c_c_w_FilterLabelSet__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<M2RepoPerspectiveActivity>) GWT.create(Type_factory__o_o_w_c_p_M2RepoPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedDTableResourceType>) GWT.create(Type_factory__o_d_w_s_g_d_c_t_GuidedDTableResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetExplorerView>) GWT.create(Type_factory__o_d_c_w_d_e_DataSetExplorerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewPackagePopupViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_p_NewPackagePopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ScoreCardXLSResourceType>) GWT.create(Type_factory__o_d_w_s_s_c_t_ScoreCardXLSResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.kie.workbench.common.widgets.configresource.client.widget.unbound.ImportsWidgetViewImpl>) GWT.create(Type_factory__o_k_w_c_w_c_c_w_u_ImportsWidgetViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PartDefinition>) GWT.create(JsType_factory__o_u_w_m_PartDefinition__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewContainerFormView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_NewContainerFormView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnTypeEditor>) GWT.create(Type_factory__o_d_c_w_d_e_c_ColumnTypeEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CloseUnsavedProjectAssetsPopUpListItemView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_p_c_CloseUnsavedProjectAssetsPopUpListItemView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UnanchoredStaticWorkbenchPanelPresenter>) GWT.create(Type_factory__o_u_c_w_p_i_UnanchoredStaticWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DefaultPreferenceForm>) GWT.create(Type_factory__o_u_e_p_c_c_f_DefaultPreferenceForm__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UnorderedList>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_UnorderedList__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AttributeColumnConverter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_AttributeColumnConverter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GroupsList>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_l_GroupsList__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProjectMetricsScreen>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_p_ProjectMetricsScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<OrganizationalUnitsView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_o_OrganizationalUnitsView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PerspectiveLayoutPluginResourceType>) GWT.create(Type_factory__o_u_e_p_c_t_PerspectiveLayoutPluginResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PersistenceView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_p_PersistenceView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SelectorDropDownDisplayer>) GWT.create(Type_factory__o_d_r_c_s_SelectorDropDownDisplayer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EmptyAssetsScreen>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_a_EmptyAssetsScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ImportProjectsScreenActivity>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_i_ImportProjectsScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.kie.workbench.common.widgets.configresource.client.widget.unbound.AddImportPopup>) GWT.create(ExtensionProvided_factory__o_k_w_c_w_c_c_w_u_AddImportPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<HTML5DndSeleniumSupport>) GWT.create(Type_factory__o_u_c_v_p_HTML5DndSeleniumSupport__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HelpBlock>) GWT.create(ExtensionProvided_factory__o_g_c_u_HelpBlock__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ResourceHandlerManager>) GWT.create(Type_factory__o_k_w_c_s_l_c_u_ResourceHandlerManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TimeInstantEditor>) GWT.create(Type_factory__o_d_d_c_w_f_TimeInstantEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ConstructionHeuristicForm>) GWT.create(Type_factory__o_o_w_s_s_c_e_ConstructionHeuristicForm__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NumberParameterEditor>) GWT.create(Type_factory__o_d_d_c_w_f_NumberParameterEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LiveSearchSelectorDropDownItemViewImpl>) GWT.create(Type_factory__o_u_e_w_c_c_d_i_LiveSearchSelectorDropDownItemViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetAuthoringHomePresenterActivity>) GWT.create(Type_factory__o_d_d_e_c_s_DataSetAuthoringHomePresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AttributeColumnPage>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_AttributeColumnPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GroupEditorDriver>) GWT.create(Type_factory__o_u_e_s_m_c_e_g_GroupEditorDriver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DRLEditorPresenter>) GWT.create(Type_factory__o_d_w_s_d_c_e_DRLEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GAVEditor>) GWT.create(Type_factory__o_g_c_s_p_c_GAVEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AppLauncherMenuBuilder>) GWT.create(Type_factory__o_k_w_c_w_c_m_AppLauncherMenuBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewPackagePopup>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_p_NewPackagePopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<MultiConstraintBendableMatchRuleModellerActionPlugin>) GWT.create(Type_factory__o_o_w_s_g_c_p_MultiConstraintBendableMatchRuleModellerActionPlugin__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SplashEditorView>) GWT.create(Type_factory__o_u_e_p_c_e_SplashEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkbenchViewModeSwitcherView>) GWT.create(Type_factory__o_u_c_v_p_m_WorkbenchViewModeSwitcherView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PerspectiveTreeProvider>) GWT.create(Type_factory__o_u_c_a_PerspectiveTreeProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PartContextMenusPresenter>) GWT.create(Type_factory__o_u_c_w_w_m_PartContextMenusPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SelectorLabelSetDisplayer>) GWT.create(Type_factory__o_d_r_c_s_SelectorLabelSetDisplayer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewWorkItemHandler>) GWT.create(Type_factory__o_d_w_s_w_c_h_NewWorkItemHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TargetPerspectiveEditor>) GWT.create(Type_factory__o_d_c_n_w_e_TargetPerspectiveEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AddGlobalPopupViewImpl>) GWT.create(Type_factory__o_d_w_s_g_c_e_AddGlobalPopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetGroupDateEditor>) GWT.create(Type_factory__o_d_d_c_w_g_DataSetGroupDateEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KieEditorWrapperViewImpl>) GWT.create(Type_factory__o_k_w_c_w_m_c_KieEditorWrapperViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UberfireBreadcrumbsView>) GWT.create(Type_factory__o_u_e_w_c_c_b_UberfireBreadcrumbsView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewGuidedDecisionTableColumnWizard>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_NewGuidedDecisionTableColumnWizard__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SSHKeysEditor>) GWT.create(Type_factory__o_u_s_c_e_c_SSHKeysEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FieldPage>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_FieldPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedDTreeResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_g_d_t_GuidedDTreeResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnDetailsEditorView>) GWT.create(Type_factory__o_d_d_c_w_g_ColumnDetailsEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FixedShapesGroup>) GWT.create(Type_factory__o_u_e_w_c_c_p_FixedShapesGroup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ACLEditor>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_ACLEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ScreenPluginResourceType>) GWT.create(Type_factory__o_u_e_p_c_t_ScreenPluginResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BootstrapLayoutGenerator>) GWT.create(Type_factory__o_u_e_l_e_c_g_BootstrapLayoutGenerator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewDependencyPopupViewImpl>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_d_NewDependencyPopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FilterLabel>) GWT.create(Type_factory__o_d_c_c_w_FilterLabel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PluginNameValidator>) GWT.create(Type_factory__o_u_e_p_c_v_PluginNameValidator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KieDropdownElementView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_u_d_KieDropdownElementView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewResourceViewImpl>) GWT.create(Type_factory__o_k_w_c_w_c_h_NewResourceViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ShortcutPresenter>) GWT.create(Type_factory__o_k_w_c_s_h_c_w_s_ShortcutPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AppLauncherItemView>) GWT.create(Type_factory__o_k_w_c_w_c_p_l_AppLauncherItemView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ShortcutHelper>) GWT.create(Type_factory__o_k_w_c_s_h_c_w_s_u_ShortcutHelper__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FormGroup>) GWT.create(Type_factory__o_u_c_v_p_w_FormGroup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PreferencesRootScreen>) GWT.create(Type_factory__o_u_e_p_c_c_s_PreferencesRootScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DependencyLoader>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_d_DependencyLoader__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DeleteBranchPopUpScreen>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_p_b_d_DeleteBranchPopUpScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TreeHierarchyStructureView>) GWT.create(Type_factory__o_u_e_p_c_c_t_TreeHierarchyStructureView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DefaultRestSecurityErrorCallback>) GWT.create(Type_factory__o_j_e_s_c_l_c_DefaultRestSecurityErrorCallback__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewGuidedScoreCardHandler>) GWT.create(Type_factory__o_d_w_s_g_s_c_h_NewGuidedScoreCardHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultiTabWorkbenchPanelView>) GWT.create(Type_factory__o_u_c_v_p_t_MultiTabWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionSetFactPlugin>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_ActionSetFactPlugin__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RegisteredDocumentsMenuBuilder>) GWT.create(Type_factory__o_k_w_c_w_m_c_m_RegisteredDocumentsMenuBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DSLEditorEntryPoint>) GWT.create(Type_factory__o_d_w_s_d_c_DSLEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PlannerDataObjectEditorViewImpl>) GWT.create(Type_factory__o_o_w_s_d_c_w_p_PlannerDataObjectEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ScenarioEditorViewImpl>) GWT.create(Type_factory__o_d_w_s_t_c_ScenarioEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RemoteEmptyPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_r_e_RemoteEmptyPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GoogleRenderer>) GWT.create(Type_factory__o_d_r_g_c_GoogleRenderer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<HistoryTokenFactory>) GWT.create(Type_factory__o_j_e_u_n_c_l_HistoryTokenFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExperimentalFeatureEditor>) GWT.create(Type_factory__o_u_e_c_e_g_f_ExperimentalFeatureEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkbenchConfigurationPopup>) GWT.create(Type_factory__o_k_w_c_w_c_c_p_WorkbenchConfigurationPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DataModelChangeNotifier>) GWT.create(Type_factory__o_k_w_c_s_d_c_c_DataModelChangeNotifier__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CardPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_CardPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GroupUsersAssignment>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_g_GroupUsersAssignment__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<InitBallotProvider>) GWT.create(Type_factory__o_j_e_i_c_a_b_InitBallotProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PlannerDataObjectFieldEditor>) GWT.create(Type_factory__o_o_w_s_d_c_w_p_PlannerDataObjectFieldEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProcessConfigView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_p_ProcessConfigView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PersistenceUnitPropertyGridViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_p_PersistenceUnitPropertyGridViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefEditorPresenter>) GWT.create(Type_factory__o_d_d_e_c_s_DataSetDefEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NotificationView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_b_n_NotificationView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CSVDataSetDefDriver>) GWT.create(Producer_factory__o_d_c_w_d_e_d_CSVDataSetDefDriver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LocaleListBox>) GWT.create(Type_factory__o_j_e_u_c_w_LocaleListBox__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CloseUnsavedProjectAssetsPopUpView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_p_c_CloseUnsavedProjectAssetsPopUpView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SplashEditorPresenterActivity>) GWT.create(Type_factory__o_u_e_p_c_e_SplashEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.gwtbootstrap3.client.ui.FormLabel>) GWT.create(ExtensionProvided_factory__o_g_c_u_FormLabel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LiveSearchDropDownView>) GWT.create(Type_factory__o_u_e_w_c_c_d_LiveSearchDropDownView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<UtilityMenuBarPresenter>) GWT.create(Type_factory__o_u_c_w_w_m_UtilityMenuBarPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TextField>) GWT.create(Type_factory__o_u_e_p_e_c_f_TextField__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkItemPageView>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_WorkItemPageView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<TargetDivDragComponent>) GWT.create(Type_factory__o_u_e_p_c_p_e_l_e_TargetDivDragComponent__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PlaceRequest>) GWT.create(JsType_factory__o_u_m_PlaceRequest__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ImportRepositoryPopUpView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_i_ImportRepositoryPopUpView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ProjectEditorEntryPoint>) GWT.create(Type_factory__o_k_w_c_s_p_c_ProjectEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ServerManagementEntryPoint>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_ServerManagementEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataModelerScreenPresenter>) GWT.create(Type_factory__o_k_w_c_s_d_c_DataModelerScreenPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NavItemTileWidgetView>) GWT.create(Type_factory__o_d_c_n_w_NavItemTileWidgetView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<StencilActionBuilder>) GWT.create(Type_factory__o_u_e_w_c_c_a_StencilActionBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SSHKeysEditorScreen>) GWT.create(Type_factory__o_u_s_c_e_SSHKeysEditorScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TreeNavigator>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_n_TreeNavigator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PhaseConfigForm>) GWT.create(Type_factory__o_o_w_s_s_c_e_PhaseConfigForm__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DeletePopUpPresenter>) GWT.create(Type_factory__o_u_e_e_c_c_f_p_DeletePopUpPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LimitedEntryActionInsertFactCol52DefinitionBuilder>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_d_LimitedEntryActionInsertFactCol52DefinitionBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ElasticSearchDataSetDefValidator>) GWT.create(Type_factory__o_d_v_d_ElasticSearchDataSetDefValidator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewUserAttributeEditor>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_u_NewUserAttributeEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LocalSearchFormViewImpl>) GWT.create(Type_factory__o_o_w_s_s_c_e_LocalSearchFormViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JPADomainScreenViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_j_JPADomainScreenViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultiListWorkbenchPanelView>) GWT.create(Type_factory__o_u_c_w_p_i_MultiListWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnWithComponentsView>) GWT.create(Type_factory__o_u_e_l_e_c_c_c_ColumnWithComponentsView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<IntervalBuilderFixedDate>) GWT.create(Type_factory__o_d_d_e_g_IntervalBuilderFixedDate__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewPatternPresenter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_m_NewPatternPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserEditorWorkflow>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_u_w_UserEditorWorkflow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LockDemandDetector>) GWT.create(Type_factory__o_u_c_m_LockDemandDetector__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColorField>) GWT.create(Type_factory__o_u_e_p_e_c_f_ColorField__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PaletteScreenActivity>) GWT.create(Type_factory__o_u_e_w_c_c_p_PaletteScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DroolsDataObjectEditorViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_d_DroolsDataObjectEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RendererSelectorRadioListView>) GWT.create(Type_factory__o_d_d_c_w_RendererSelectorRadioListView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FormLabelHelp>) GWT.create(ExtensionProvided_factory__o_u_c_v_p_w_FormLabelHelp__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<CommonsEntryPoint>) GWT.create(Type_factory__o_u_e_w_c_c_CommonsEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TimeAmountEditorView>) GWT.create(Type_factory__o_d_d_c_w_f_TimeAmountEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DropdownHeaderWidget>) GWT.create(Type_factory__o_k_w_c_s_l_c_w_c_d_DropdownHeaderWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DataSetDefType>) GWT.create(Type_factory__o_d_d_e_c_s_DataSetDefType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PopulatedLibraryScreen>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_PopulatedLibraryScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContainerRulesConfigPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_c_c_r_ContainerRulesConfigPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ServerNavigationView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_n_ServerNavigationView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SimpleWorkbenchPanelView>) GWT.create(Type_factory__o_u_c_w_p_i_SimpleWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedRuleTemplateEditorPresenter>) GWT.create(Type_factory__o_d_w_s_g_t_c_e_GuidedRuleTemplateEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SettingsPage>) GWT.create(Type_factory__o_d_w_s_t_c_p_s_SettingsPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DescriptionColumnConverter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_DescriptionColumnConverter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SelectorDropDownDisplayerView>) GWT.create(Type_factory__o_d_r_c_s_SelectorDropDownDisplayerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HTMLElement>) GWT.create(ContextualProvider_factory__e_d_HTMLElement__quals__Universal.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PreferenceScopeFactoryImpl>) GWT.create(Type_factory__o_u_p_s_i_PreferenceScopeFactoryImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SSHKeyEditorViewImpl>) GWT.create(Type_factory__o_u_s_c_e_c_k_k_SSHKeyEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContentManagerPerspectiveActivity>) GWT.create(Type_factory__o_d_c_c_p_ContentManagerPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerError>) GWT.create(Type_factory__o_d_d_c_w_DisplayerError__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DateParameterEditorView>) GWT.create(Type_factory__o_d_d_c_w_f_DateParameterEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ActionPluginClientService>) GWT.create(Type_factory__o_o_w_s_g_c_p_ActionPluginClientService__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KnowledgeSessionsModal>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_k_i_k_KnowledgeSessionsModal__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PerspectivesExplorerScreenActivity>) GWT.create(Type_factory__o_d_c_c_s_e_PerspectivesExplorerScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EntityWorkflowViewImpl>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_w_EntityWorkflowViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MenuItem>) GWT.create(JsType_factory__o_u_w_m_m_MenuItem__quals__Universal.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ClientRuntimeErrorPopupPresenter>) GWT.create(Type_factory__o_d_c_w_c_ClientRuntimeErrorPopupPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TargetPerspectiveEditorView>) GWT.create(Type_factory__o_d_c_n_w_e_TargetPerspectiveEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<BendableSoftConstraintMatchRuleModellerActionPlugin>) GWT.create(Type_factory__o_o_w_s_g_c_p_BendableSoftConstraintMatchRuleModellerActionPlugin__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Instance>) GWT.create(ContextualProvider_factory__j_e_i_Instance__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HeaderPanel>) GWT.create(ExtensionProvided_factory__c_g_g_u_c_u_HeaderPanel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContributorsListPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_o_c_t_ContributorsListPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AssetUpdateValidator>) GWT.create(Type_factory__o_k_w_c_w_m_c_v_AssetUpdateValidator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ElasticSearchDataSetDefDriver>) GWT.create(Producer_factory__o_d_c_w_d_e_d_ElasticSearchDataSetDefDriver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<EventBus>) GWT.create(Producer_factory__c_g_w_b_e_s_EventBus__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MenuResourceHandlerWidget>) GWT.create(Type_factory__o_k_w_c_s_l_c_w_c_MenuResourceHandlerWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EditContributorsPopUpPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_o_c_e_EditContributorsPopUpPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ScreenEditorView>) GWT.create(Type_factory__o_u_e_p_c_e_ScreenEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DataModelCommandBuilder>) GWT.create(Type_factory__o_k_w_c_s_d_c_c_DataModelCommandBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<POMEditorPanel>) GWT.create(Type_factory__o_g_c_s_p_c_POMEditorPanel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KnowledgeBasesView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_k_KnowledgeBasesView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultiPageEditorViewImpl>) GWT.create(Type_factory__o_u_c_v_p_m_MultiPageEditorViewImpl__quals__j_e_i_Any_o_u_c_w_w_m_Multiple.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TableDisplayer>) GWT.create(Type_factory__o_d_r_c_t_TableDisplayer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultiplePermissionNodeEditorView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_n_MultiplePermissionNodeEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AttributeColumnPageView>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_AttributeColumnPageView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<RepositoryController>) GWT.create(Type_factory__o_g_s_c_s_RepositoryController__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkbenchMegaMenuPresenter>) GWT.create(Producer_factory__o_u_c_w_w_m_m_WorkbenchMegaMenuPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DecisionTableAnalyzerProvider>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_a_DecisionTableAnalyzerProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PerspectiveCoordinator>) GWT.create(Type_factory__o_d_d_c_PerspectiveCoordinator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GoogleAreaChartDisplayerView>) GWT.create(Type_factory__o_d_r_g_c_GoogleAreaChartDisplayerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContainerStatusEmptyPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_c_s_e_ContainerStatusEmptyPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<CallerProvider>) GWT.create(Type_factory__o_j_e_i_c_a_b_CallerProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PermissionTreeI18NImpl>) GWT.create(Type_factory__o_u_c_r_i_PermissionTreeI18NImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MetaDataColumnPageView>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_MetaDataColumnPageView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerSettingsEditor>) GWT.create(Type_factory__o_d_d_c_w_DisplayerSettingsEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AttachShadowOptionsType>) GWT.create(JsType_factory__e_d_HTMLElement_AttachShadowOptionsType__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KieMetaDataEditorPresenter>) GWT.create(Type_factory__o_k_w_c_s_d_c_e_KieMetaDataEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ProjectImportsResourceType>) GWT.create(Type_factory__o_k_w_c_s_p_c_t_ProjectImportsResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedRuleTemplateResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_g_t_t_GuidedRuleTemplateResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultipleTextParameterEditor>) GWT.create(Type_factory__o_d_d_c_w_f_MultipleTextParameterEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DropdownMenu>) GWT.create(Type_factory__o_u_c_v_p_w_DropdownMenu__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<com.google.gwt.user.client.ui.ListBox>) GWT.create(ExtensionProvided_factory__c_g_g_u_c_u_ListBox__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Span>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_Span__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HTMLInputElement>) GWT.create(ExtensionProvided_factory__e_d_HTMLInputElement__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionWorkItemSetFieldColumnConverter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_ActionWorkItemSetFieldColumnConverter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RuntimePluginsServiceProxyClientImpl>) GWT.create(Type_factory__o_u_c_p_RuntimePluginsServiceProxyClientImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ObservablePathImpl>) GWT.create(Type_factory__o_u_b_v_i_ObservablePathImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AdvancedDomainEditor>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDomainEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DecisionTableXLSEditorPresenterActivity>) GWT.create(Type_factory__o_d_w_s_d_c_e_DecisionTableXLSEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ProjectImportsResourceTypeDefinition>) GWT.create(Type_factory__o_k_w_c_s_p_t_ProjectImportsResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NavTreeEditor>) GWT.create(Type_factory__o_d_c_n_w_e_NavTreeEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DocumentMenuItemImpl>) GWT.create(Type_factory__o_k_w_c_w_m_c_m_DocumentMenuItemImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CreateAnnotationWizard>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_a_CreateAnnotationWizard__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PlugInAuthoringPerspective>) GWT.create(Type_factory__o_u_e_p_c_p_PlugInAuthoringPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewAssetHandlerCardView>) GWT.create(Type_factory__o_k_w_c_s_l_c_w_p_NewAssetHandlerCardView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<KModuleResourceTypeDefinition>) GWT.create(Type_factory__o_k_w_c_s_p_t_KModuleResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MapEditor>) GWT.create(Type_factory__o_d_c_c_e_m_MapEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SettingsPageViewImpl>) GWT.create(Type_factory__o_d_w_s_t_c_p_s_SettingsPageViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UberTabPanel>) GWT.create(Type_factory__o_u_c_v_p_t_UberTabPanel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LinkTitlePresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_t_LinkTitlePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GoogleMeterChartDisplayer>) GWT.create(Type_factory__o_d_r_g_c_GoogleMeterChartDisplayer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HTMLButtonElement>) GWT.create(ExtensionProvided_factory__e_d_HTMLButtonElement__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FileExplorerViewImpl>) GWT.create(Type_factory__o_g_s_c_e_f_FileExplorerViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PackageItemPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_k_i_p_PackageItemPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NavComponentConfigModal>) GWT.create(Type_factory__o_d_c_n_w_NavComponentConfigModal__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NavigationManagerImpl>) GWT.create(Type_factory__o_d_c_n_i_NavigationManagerImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EditorPlugInEditorPresenterActivity>) GWT.create(Type_factory__o_u_e_p_c_e_EditorPlugInEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DomainHandlerRegistry>) GWT.create(Type_factory__o_k_w_c_s_d_c_h_DomainHandlerRegistry__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SecurityEntryPoint>) GWT.create(Type_factory__o_u_s_c_SecurityEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JSNativeSplashScreen>) GWT.create(Type_factory__o_u_c_s_JSNativeSplashScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BeanDataSetDefAttributesDriver>) GWT.create(Producer_factory__o_d_c_w_d_e_d_BeanDataSetDefAttributesDriver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExamplesImportPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_i_ExamplesImportPresenter__quals__j_e_i_Any_o_k_w_c_s_l_c_s_i_Source.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<MegaMenuConfig>) GWT.create(Type_factory__o_o_w_c_n_MegaMenuConfig__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DataSetClientServices>) GWT.create(Type_factory__o_d_d_c_DataSetClientServices__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ListDataProvider>) GWT.create(Type_factory__c_g_g_v_c_ListDataProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CalculationTypePage>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_CalculationTypePage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LayoutComponentPaletteView>) GWT.create(Type_factory__o_u_e_l_e_c_w_LayoutComponentPaletteView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SecurityRolesConstraintPage>) GWT.create(Type_factory__o_j_e_s_c_l_c_SecurityContextImpl_SecurityRolesConstraintPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<OrgUnitsMetricsView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_OrgUnitsMetricsView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.guvnor.structure.client.advnavigator.TreeNavigator>) GWT.create(Type_factory__o_g_s_c_a_TreeNavigator__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UsersExplorer>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_UsersExplorer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ListComponentProvider>) GWT.create(Type_factory__o_j_e_d_c_ListComponentProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdminPagePerspectiveActivity>) GWT.create(Type_factory__o_u_e_p_c_a_AdminPagePerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MenuItemPerspective>) GWT.create(JsType_factory__o_u_w_m_m_MenuItemPerspective__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PerspectiveEditorView>) GWT.create(Type_factory__o_u_e_p_c_p_e_PerspectiveEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<UberfireBreadcrumbs>) GWT.create(Type_factory__o_u_e_w_c_c_b_UberfireBreadcrumbs__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ServerEmptyPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_e_ServerEmptyPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ScenarioEditorPresenterActivity>) GWT.create(Type_factory__o_d_w_s_t_c_ScenarioEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ConditionColumnPlugin>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_ConditionColumnPlugin__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContentManagerHomeScreenActivity>) GWT.create(Type_factory__o_d_c_c_s_h_ContentManagerHomeScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefWizardScreen>) GWT.create(Type_factory__o_d_d_e_c_s_DataSetDefWizardScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BRLActionVariableColumnConverter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_BRLActionVariableColumnConverter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DefaultPermissionTypeRegistry>) GWT.create(Type_factory__o_u_s_i_a_DefaultPermissionTypeRegistry__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JsTypeEventObserver>) GWT.create(JsType_factory__o_j_e_e_c_c_JsTypeEventObserver__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ClientDateFormatterImpl>) GWT.create(Type_factory__o_d_d_c_e_ClientDateFormatterImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HtmlEditorPresenter>) GWT.create(Type_factory__o_u_e_e_c_c_h_HtmlEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LimitedEntryActionSetFieldCol52DefinitionBuilder>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_d_LimitedEntryActionSetFieldCol52DefinitionBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PluginJSExporter>) GWT.create(Type_factory__o_u_c_e_PluginJSExporter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LimitedEntryBRLConditionColumnSynchronizer>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_LimitedEntryBRLConditionColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SummaryPage>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_SummaryPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TimeFrameEditor>) GWT.create(Type_factory__o_d_d_c_w_f_TimeFrameEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PropertiesItemPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_p_p_PropertiesItemPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EmptyStateView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_EmptyStateView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetEditorWorkflowFactory>) GWT.create(Type_factory__o_d_c_w_d_e_w_DataSetEditorWorkflowFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<URLPatternMatcher>) GWT.create(Producer_factory__o_j_e_u_n_c_l_URLPatternMatcher__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FactPatternsPageViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_FactPatternsPageViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Paragraph>) GWT.create(ExtensionProvided_factory__o_g_c_u_h_Paragraph__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<UberfireDocksImpl>) GWT.create(Type_factory__o_u_c_d_UberfireDocksImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HtmlEditorActivity>) GWT.create(Type_factory__o_u_e_e_c_c_h_HtmlEditorActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefFilterEditor>) GWT.create(Type_factory__o_d_c_w_d_e_DataSetDefFilterEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SimpleDnDWorkbenchPanelPresenter>) GWT.create(Type_factory__o_u_c_w_p_i_SimpleDnDWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PreferenceStoreIOCProvider>) GWT.create(Type_factory__o_u_p_c_s_PreferenceStoreIOCProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<IncludedKnowledgeBaseItemView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_k_i_i_IncludedKnowledgeBaseItemView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SettingsPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_SettingsPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GoogleLineChartDisplayerView>) GWT.create(Type_factory__o_d_r_g_c_GoogleLineChartDisplayerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DependenciesPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_d_DependenciesPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FileUploadEditor>) GWT.create(Type_factory__o_d_c_c_e_f_FileUploadEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LiveSearchDropDown>) GWT.create(Type_factory__o_u_e_w_c_c_d_LiveSearchDropDown__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExampleProjectOkPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_w_e_e_ExampleProjectOkPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProjectScreen>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_p_ProjectScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ServerContainerEmptyView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_c_e_ServerContainerEmptyView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TextFileExport>) GWT.create(Producer_factory__o_u_e_e_c_c_f_e_TextFileExport__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DRLResourceType>) GWT.create(Type_factory__o_d_w_s_d_c_t_DRLResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTableModellerViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_GuidedDecisionTableModellerViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ExplorerViewImpl>) GWT.create(Type_factory__o_k_w_c_s_e_c_ExplorerViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LayoutDragComponentGroupPresenter>) GWT.create(Type_factory__o_u_e_l_e_c_w_LayoutDragComponentGroupPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ValidatorProvider>) GWT.create(Type_factory__o_j_e_v_c_ValidatorProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DateTimePicker>) GWT.create(ExtensionProvided_factory__o_g_e_d_c_u_DateTimePicker__quals__j_e_i_Any_j_e_i_Default.class));
  }

  private void registerFactories1(final Context org_jboss_errai_ioc_client_container_ApplicationScopedContext_context, final Context org_jboss_errai_ioc_client_container_DependentScopeContext_context) {
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultiTabWorkbenchPanelPresenter>) GWT.create(Type_factory__o_u_c_w_p_i_MultiTabWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AdminCustomMenuBuilder>) GWT.create(Type_factory__o_k_w_c_w_c_m_c_AdminCustomMenuBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CustomPanelDefinition>) GWT.create(JsType_factory__o_u_w_m_CustomPanelDefinition__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Path>) GWT.create(JsType_factory__o_u_b_v_Path__quals__Universal.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DSLRResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_d_t_DSLRResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KieMetaDataEditorPresenterActivity>) GWT.create(Type_factory__o_k_w_c_s_d_c_e_KieMetaDataEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ShowAssetUsagesDisplayerViewViewImpl>) GWT.create(Type_factory__o_k_w_c_s_r_c_u_ShowAssetUsagesDisplayerViewViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AsyncPackageDataModelOracleFactory>) GWT.create(Type_factory__o_k_w_c_w_c_d_AsyncPackageDataModelOracleFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<Elemental2Producer>) GWT.create(Type_factory__o_u_c_v_p_w_Elemental2Producer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerScreenPresenterActivity>) GWT.create(Type_factory__o_d_d_c_DisplayerScreenPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Disposer>) GWT.create(ContextualProvider_factory__o_j_e_i_c_a_Disposer__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ErrorBox>) GWT.create(Type_factory__o_u_e_s_m_c_w_p_ErrorBox__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GenericValuePairEditorViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_v_g_GenericValuePairEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ListComponent>) GWT.create(ContextualProvider_factory__o_j_e_d_c_c_ListComponent__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<InputDeviceCapabilitiesOptionsType>) GWT.create(JsType_factory__e_d_InputDeviceCapabilities_InputDeviceCapabilitiesOptionsType__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SplitLayoutPanelView>) GWT.create(Type_factory__o_u_c_w_p_i_SplitLayoutPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BasicFileMenuBuilderImpl>) GWT.create(Type_factory__o_u_e_e_c_c_m_BasicFileMenuBuilderImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HTMLHeadingElement>) GWT.create(ExtensionProvided_factory__e_d_HTMLHeadingElement__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ValuePairEditorPopupViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_v_ValuePairEditorPopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MainDataObjectFieldEditorViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_m_MainDataObjectFieldEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActivityNotFoundView>) GWT.create(Type_factory__o_u_e_w_c_c_w_w_p_a_n_ActivityNotFoundView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HasEnabledStateChangeListeners>) GWT.create(JsType_factory__o_u_w_m_m_HasEnabledStateChangeListeners__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ElasticSearchDataSetEditor>) GWT.create(Type_factory__o_d_c_w_d_e_e_ElasticSearchDataSetEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DropdownSeparatorWidget>) GWT.create(Type_factory__o_k_w_c_s_l_c_w_c_d_DropdownSeparatorWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<CategoryUtils>) GWT.create(Type_factory__o_k_w_c_s_l_c_u_CategoryUtils__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTableAccordionView>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_p_a_GuidedDecisionTableAccordionView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PlaceHistoryHandler>) GWT.create(Type_factory__o_u_c_m_PlaceHistoryHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<Form>) GWT.create(Type_factory__o_g_c_s_p_c_Form__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NumericTextBox>) GWT.create(ExtensionProvided_factory__o_k_w_c_s_s_m_c_w_NumericTextBox__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.jboss.errai.common.client.dom.Select>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_Select__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<OptionElement>) GWT.create(Type_factory__o_k_w_c_w_c_w_KieSelectElement_OptionElement__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GeneralSettingsPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_g_GeneralSettingsPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PackageItemView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_k_i_p_PackageItemView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ImportExamplesProjectsScreenActivity>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_ImportExamplesProjectsScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JSNativeClientResourceType>) GWT.create(Type_factory__o_u_c_e_t_JSNativeClientResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ComponentColumn>) GWT.create(Type_factory__o_u_e_l_e_c_c_c_ComponentColumn__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TransitionToRole>) GWT.create(ContextualProvider_factory__o_j_e_u_n_c_l_TransitionToRole__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PatternToDeletePage>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_PatternToDeletePage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContributorsViewImpl>) GWT.create(Type_factory__o_k_w_c_s_c_c_s_ContributorsViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ConfigWidget>) GWT.create(Type_factory__o_d_w_s_t_c_p_s_ConfigWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PerspectivesExplorerScreen>) GWT.create(Type_factory__o_d_c_c_s_e_PerspectivesExplorerScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedDTableResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_g_d_t_GuidedDTableResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MetaDataColumnSynchronizer>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_MetaDataColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Document>) GWT.create(Producer_factory__o_j_e_c_c_d_Document__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefBasicAttributesDriver>) GWT.create(Producer_factory__o_d_c_w_d_e_d_DataSetDefBasicAttributesDriver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AssignedEntitiesInlineEditorView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_AssignedEntitiesInlineEditorView__quals__j_e_i_Any_o_u_e_s_m_c_w_m_e_AssignedEntitiesInlineEditor.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PropertiesItemView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_p_p_PropertiesItemView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ExperimentalActivitiesAuthorizationManagerImpl>) GWT.create(Type_factory__o_u_e_c_s_a_ExperimentalActivitiesAuthorizationManagerImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewContainerFormPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_NewContainerFormPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LimitedEntryBRLActionColumnSynchronizer>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_LimitedEntryBRLActionColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<com.google.gwt.user.client.ui.Button>) GWT.create(ExtensionProvided_factory__c_g_g_u_c_u_Button__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DragHelperComponentColumn>) GWT.create(Type_factory__o_u_e_l_e_c_i_DragHelperComponentColumn__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AlertPopupViewImpl>) GWT.create(Type_factory__o_k_w_c_w_c_p_a_AlertPopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Anchor>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_Anchor__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PropertyEditorWidget>) GWT.create(Type_factory__o_u_e_p_e_c_PropertyEditorWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContributorsListItemView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_o_c_t_ContributorsListItemView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LimitedEntryColumnConverter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_LimitedEntryColumnConverter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BRLActionColumnSynchronizer>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_BRLActionColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ModelSynchronizerImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ModelSynchronizerImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TreeHierarchyLeafItemPresenter>) GWT.create(Type_factory__o_u_e_p_c_c_t_TreeHierarchyLeafItemPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserMenuViewImpl>) GWT.create(Type_factory__o_u_c_v_p_m_UserMenuViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ContentManagerI18n>) GWT.create(Type_factory__o_d_c_c_r_i_ContentManagerI18n__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PlaceStatus>) GWT.create(JsType_factory__o_u_c_m_PlaceStatus__quals__Universal.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewDslTextHandler>) GWT.create(Type_factory__o_d_w_s_d_c_h_NewDslTextHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GoogleAreaChartDisplayer>) GWT.create(Type_factory__o_d_r_g_c_GoogleAreaChartDisplayer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AssignedEntitiesModalEditorView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_AssignedEntitiesModalEditorView__quals__j_e_i_Any_o_u_e_s_m_c_w_m_e_AssignedEntitiesModalEditor.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SourceCodeEditor>) GWT.create(Type_factory__o_d_d_c_w_s_SourceCodeEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NavItemDefaultEditorView>) GWT.create(Type_factory__o_d_c_n_w_e_NavItemDefaultEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GoogleLineChartDisplayer>) GWT.create(Type_factory__o_d_r_g_c_GoogleLineChartDisplayer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HelpIcon>) GWT.create(ExtensionProvided_factory__o_u_c_v_p_w_HelpIcon__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Resource>) GWT.create(JsType_factory__o_u_s_Resource__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PreferencesCentralNavBarScreenActivity>) GWT.create(Type_factory__o_u_e_p_c_c_PreferencesCentralNavBarScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LayoutPanelPresenter>) GWT.create(Type_factory__o_u_c_w_p_i_LayoutPanelPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTreeWidget>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_GuidedDecisionTreeWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Modal>) GWT.create(Type_factory__o_u_c_v_p_w_Modal__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DefaultWorkbenchController>) GWT.create(Type_factory__o_u_c_a_DefaultWorkbenchController__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Logger>) GWT.create(ExtensionProvided_factory__o_s_Logger__quals__Universal_2.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Logger>) GWT.create(ExtensionProvided_factory__o_s_Logger__quals__Universal_1.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Logger>) GWT.create(ExtensionProvided_factory__o_s_Logger__quals__Universal_4.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Logger>) GWT.create(ExtensionProvided_factory__o_s_Logger__quals__Universal_3.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Logger>) GWT.create(ExtensionProvided_factory__o_s_Logger__quals__Universal_6.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Logger>) GWT.create(ExtensionProvided_factory__o_s_Logger__quals__Universal_5.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Logger>) GWT.create(ExtensionProvided_factory__o_s_Logger__quals__Universal_8.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Logger>) GWT.create(ExtensionProvided_factory__o_s_Logger__quals__Universal_7.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Logger>) GWT.create(ExtensionProvided_factory__o_s_Logger__quals__Universal_9.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DataSetAuthoringPerspective>) GWT.create(Type_factory__o_d_d_e_c_p_DataSetAuthoringPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MenuItemPlain>) GWT.create(JsType_factory__o_u_w_m_m_MenuItemPlain__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NavTreeWidget>) GWT.create(Type_factory__o_d_c_n_w_NavTreeWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultiplePermissionNodeEditor>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_n_MultiplePermissionNodeEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FilterLabelView>) GWT.create(Type_factory__o_d_c_c_w_FilterLabelView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdminPageItemView>) GWT.create(Type_factory__o_u_e_p_c_a_i_AdminPageItemView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RestorePopUpPresenter>) GWT.create(Type_factory__o_u_e_e_c_c_f_p_RestorePopUpPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FilterLabelSetView>) GWT.create(Type_factory__o_d_c_c_w_FilterLabelSetView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ServerNavigationPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_n_ServerNavigationPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SvgFileExport>) GWT.create(Producer_factory__o_u_e_e_c_c_f_e_s_SvgFileExport__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Logger>) GWT.create(ExtensionProvided_factory__o_s_Logger__quals__Universal.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ClientExperimentalFeaturesRegistryServiceImpl>) GWT.create(Type_factory__o_u_e_c_s_i_ClientExperimentalFeaturesRegistryServiceImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PlaceRequestHistoryMapperImpl>) GWT.create(Type_factory__o_u_c_m_PlaceRequestHistoryMapperImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LinkedGroup>) GWT.create(ExtensionProvided_factory__o_g_c_u_LinkedGroup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EnumLoaderUtilities>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_u_EnumLoaderUtilities__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PanelDefinitionImpl>) GWT.create(JsType_factory__o_u_w_m_i_PanelDefinitionImpl__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RowContextMenu>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_m_RowContextMenu__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JQuery>) GWT.create(Producer_factory__o_u_c_v_p_w_JQueryProducer_JQuery__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ShortcutSubHeadingLinkPresenter>) GWT.create(Type_factory__o_k_w_c_s_h_c_w_s_s_ShortcutSubHeadingLinkPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ListWidgetProvider>) GWT.create(Type_factory__o_j_e_u_c_w_ListWidgetProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<IFrameScreenView>) GWT.create(Type_factory__o_u_e_w_c_c_s_i_IFrameScreenView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<StencilPaletteBuilder>) GWT.create(Type_factory__o_u_e_w_c_c_p_StencilPaletteBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LayoutDragComponentWidget>) GWT.create(Type_factory__o_u_e_l_e_c_w_LayoutDragComponentWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<IFrameScreenPresenterActivity>) GWT.create(Type_factory__o_u_e_w_c_c_s_i_IFrameScreenPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DoubleValidator>) GWT.create(Type_factory__o_u_e_w_c_c_p_DoubleValidator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdditionalInfoPageView>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_AdditionalInfoPageView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Bs3Modal>) GWT.create(Type_factory__o_u_c_v_p_m_Bs3Modal__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RestoreUtil>) GWT.create(Type_factory__o_u_e_e_c_c_f_RestoreUtil__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DeleteProjectPopUpScreen>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_p_d_DeleteProjectPopUpScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LibraryBreadcrumbs>) GWT.create(Type_factory__o_k_w_c_s_l_c_u_b_LibraryBreadcrumbs__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnFunctionEditorView>) GWT.create(Type_factory__o_d_d_c_w_g_ColumnFunctionEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContributorsScreenActivity>) GWT.create(Type_factory__o_k_w_c_s_c_c_s_ContributorsScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContainerView>) GWT.create(Type_factory__o_u_e_l_e_c_c_c_ContainerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<JPACommandBuilder>) GWT.create(Type_factory__o_k_w_c_s_d_c_h_j_c_JPACommandBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DecisionTableXLSEditorPresenter>) GWT.create(Type_factory__o_d_w_s_d_c_e_DecisionTableXLSEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SearchAnnotationPageViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_a_SearchAnnotationPageViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SettingsSectionsProvider>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_SettingsSectionsProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HorizImageListEditorView>) GWT.create(Type_factory__o_d_c_c_e_l_HorizImageListEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Label>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_Label__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Validator>) GWT.create(Provider_factory__j_v_Validator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<KieEditorEntryPoint>) GWT.create(Type_factory__o_k_w_c_w_m_c_KieEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<LayoutSelection>) GWT.create(Type_factory__o_u_c_w_LayoutSelection__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.kie.workbench.common.screens.server.management.client.container.ContainerView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_c_ContainerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HTMLUListElement>) GWT.create(ExtensionProvided_factory__e_d_HTMLUListElement__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerEditor>) GWT.create(Type_factory__o_d_d_c_w_DisplayerEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<TranslationUtils>) GWT.create(Type_factory__o_k_w_c_s_l_c_u_TranslationUtils__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ValidationListPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_v_ValidationPresenter_ValidationListPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<CoreEntryPoint>) GWT.create(Type_factory__o_u_e_w_c_c_CoreEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ClientSecurityExceptionMessageResolver>) GWT.create(Type_factory__o_u_e_s_m_c_ClientSecurityExceptionMessageResolver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SecretTextField>) GWT.create(Type_factory__o_u_e_p_e_c_f_SecretTextField__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<VersionMenuDropDownButtonViewImpl>) GWT.create(Type_factory__o_u_e_e_c_c_h_VersionMenuDropDownButtonViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<VersionHistoryPresenterViewImpl>) GWT.create(Type_factory__o_u_e_e_c_c_h_VersionHistoryPresenterViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefFilterEditorView>) GWT.create(Type_factory__o_d_c_w_d_e_DataSetDefFilterEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<IOCBeanManagerProvider>) GWT.create(Type_factory__o_j_e_i_c_a_b_IOCBeanManagerProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ResizeFlowPanel>) GWT.create(ExtensionProvided_factory__o_u_c_w_w_l_ResizeFlowPanel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KebabMenu>) GWT.create(Type_factory__o_u_c_v_p_w_KebabMenu__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ErrorBoxView>) GWT.create(Type_factory__o_u_e_s_m_c_w_p_ErrorBoxView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PreferencesCentralActionsScreen>) GWT.create(Type_factory__o_u_e_p_c_c_a_PreferencesCentralActionsScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JSNativeEditor>) GWT.create(Type_factory__o_u_c_e_JSNativeEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSourceSelector>) GWT.create(Producer_factory__o_k_w_c_s_d_c_w_d_DataSourceSelector__quals__j_e_i_Any_o_u_a_Customizable.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AddProjectPopUpView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_p_AddProjectPopUpView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BRLConditionColumnSynchronizer>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_BRLConditionColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KieTextEditorViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_e_KieTextEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<OptaPlannerWorkbenchEntryPoint>) GWT.create(Type_factory__o_o_w_c_OptaPlannerWorkbenchEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HomePerspectiveActivity>) GWT.create(Type_factory__o_k_w_c_s_h_c_p_HomePerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GoogleTableDisplayer>) GWT.create(Type_factory__o_d_r_g_c_GoogleTableDisplayer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<OrganizationalUnitsScreen>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_o_OrganizationalUnitsScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewPackageHandler>) GWT.create(Type_factory__o_k_w_c_s_p_c_h_NewPackageHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProcessConfigPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_p_ProcessConfigPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTableEditorViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_GuidedDecisionTableEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<MessageConsoleWhiteListImpl>) GWT.create(Type_factory__o_k_w_c_s_s_m_MessageConsoleWhiteListImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ActivityLifecycleErrorHandler>) GWT.create(Type_factory__o_u_c_m_ActivityLifecycleErrorHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TextInput>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_TextInput__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<HtmlResourceType>) GWT.create(Type_factory__o_u_e_e_c_c_h_HtmlResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JPADataObjectEditor>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_j_JPADataObjectEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<RequestDispatcherProvider>) GWT.create(Type_factory__o_j_e_i_s_b_c_RequestDispatcherProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetEditorWorkflowView>) GWT.create(Type_factory__o_d_c_w_d_e_w_DataSetEditorWorkflowView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ComboField>) GWT.create(Type_factory__o_u_e_p_e_c_f_ComboField__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DefaultPermissionTreeFactory>) GWT.create(Type_factory__o_u_s_c_a_t_i_DefaultPermissionTreeFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RuntimeResource>) GWT.create(JsType_factory__o_u_s_a_RuntimeResource__quals__Universal.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DefaultDataSourceSelector>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_d_DefaultDataSourceSelector__quals__j_e_i_Any_o_u_a_FallbackImplementation.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ActivityBeansCache>) GWT.create(Type_factory__o_u_c_m_ActivityBeansCache__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<KiePOMDefaultOptions>) GWT.create(Type_factory__o_k_w_c_s_p_c_u_KiePOMDefaultOptions__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CopyPopupView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_n_t_c_CopyPopupView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ChildMenuItemPresenter>) GWT.create(Type_factory__o_u_c_w_w_m_m_m_ChildMenuItemPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AddSingleValueModal>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_u_m_s_AddSingleValueModal__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataColumnDefEditorView>) GWT.create(Type_factory__o_d_c_w_d_e_c_DataColumnDefEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DefaultEditorNewFileUpload>) GWT.create(ExtensionProvided_factory__o_u_e_w_c_c_e_d_DefaultEditorNewFileUpload__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedScoreCardResourceType>) GWT.create(Type_factory__o_d_w_s_g_s_c_t_GuidedScoreCardResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AddAssetView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_a_a_AddAssetView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<KModuleResourceType>) GWT.create(Type_factory__o_k_w_c_s_p_c_t_KModuleResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<OverviewEditorEntryPoint>) GWT.create(Type_factory__o_k_w_c_w_m_c_OverviewEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewPluginPopUpViewImpl>) GWT.create(Type_factory__o_u_e_p_c_w_p_NewPluginPopUpViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ImportsWidgetPresenter>) GWT.create(Type_factory__o_k_w_c_w_c_c_w_u_ImportsWidgetPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewGuidedRuleTemplateHandler>) GWT.create(Type_factory__o_d_w_s_g_t_c_h_NewGuidedRuleTemplateHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<MessageBusProvider>) GWT.create(Type_factory__o_j_e_i_s_b_c_MessageBusProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ImportProjectsScreen>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_i_ImportProjectsScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultiPageEditorImpl>) GWT.create(Type_factory__o_u_c_v_p_m_MultiPageEditorImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ShortcutSubHeadingTextView>) GWT.create(Type_factory__o_k_w_c_s_h_c_w_s_s_ShortcutSubHeadingTextView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SenderProvider>) GWT.create(Type_factory__o_j_e_i_s_b_c_SenderProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RenamePopUpPresenter>) GWT.create(Type_factory__o_u_e_e_c_c_f_p_RenamePopUpPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProjectPageViewImpl>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_p_p_ProjectPageViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LayoutDragComponentHelper>) GWT.create(Type_factory__o_u_e_l_e_c_i_LayoutDragComponentHelper__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<InfoTitleView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_t_InfoTitleView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SummaryPageViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_SummaryPageViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedDTreeResourceType>) GWT.create(Type_factory__o_d_w_s_g_d_c_t_GuidedDTreeResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GeneralSettingsView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_g_GeneralSettingsView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GroupMenuItemPresenter>) GWT.create(Type_factory__o_u_c_w_w_m_m_m_GroupMenuItemPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ExperimentalFeaturesEditorScreen>) GWT.create(Type_factory__o_u_e_c_e_ExperimentalFeaturesEditorScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<EnumResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_e_t_EnumResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LayoutEditorView>) GWT.create(Type_factory__o_u_e_l_e_c_LayoutEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RuleModellerPage>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_RuleModellerPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Promises>) GWT.create(Type_factory__o_u_c_p_Promises__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ListBarWidgetImpl>) GWT.create(Type_factory__o_u_c_v_p_l_ListBarWidgetImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ValuePairEditorPageViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_a_ValuePairEditorPageViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkbenchViewModeSwitcherPresenter>) GWT.create(Type_factory__o_u_c_m_WorkbenchViewModeSwitcherPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<POMResourceType>) GWT.create(Type_factory__o_g_c_s_p_c_t_POMResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DRLEditorPresenterActivity>) GWT.create(Type_factory__o_d_w_s_d_c_e_DRLEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetAuthoringHomePresenter>) GWT.create(Type_factory__o_d_d_e_c_s_DataSetAuthoringHomePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<HtmlEditorLibraryLoader>) GWT.create(Type_factory__o_u_e_e_c_c_h_HtmlEditorLibraryLoader__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Elemental2HTMLElementProvider>) GWT.create(Type_factory__o_j_e_u_c_l_p_Elemental2HTMLElementProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.gwtbootstrap3.client.ui.html.Span>) GWT.create(ExtensionProvided_factory__o_g_c_u_h_Span__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DropDownEditorView>) GWT.create(Type_factory__o_d_c_c_e_l_DropDownEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SQLDataSetDefAttributesDriver>) GWT.create(Producer_factory__o_d_c_w_d_e_d_SQLDataSetDefAttributesDriver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetFilterEditorView>) GWT.create(Type_factory__o_d_d_c_w_f_DataSetFilterEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AppsHomePresenter>) GWT.create(Type_factory__o_u_e_a_c_h_AppsHomePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NavCarouselWidget>) GWT.create(Type_factory__o_d_c_n_w_NavCarouselWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<OrganizationalUnitPopUpView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_o_p_OrganizationalUnitPopUpView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PreferencesCentralActionsScreenActivity>) GWT.create(Type_factory__o_u_e_p_c_c_a_PreferencesCentralActionsScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FilterPagedTable>) GWT.create(Type_factory__o_u_e_w_c_c_t_FilterPagedTable__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SolverResourceType>) GWT.create(Type_factory__o_o_w_s_s_c_t_SolverResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<UtilityMenuBarView>) GWT.create(Type_factory__o_u_c_v_p_m_UtilityMenuBarView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AdvancedDomainHandler>) GWT.create(Type_factory__o_k_w_c_s_d_c_h_a_AdvancedDomainHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BootstrapLayoutGeneratorDriver>) GWT.create(Type_factory__o_u_e_l_e_c_g_BootstrapLayoutGeneratorDriver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetLookupEditor>) GWT.create(Type_factory__o_d_d_c_w_DataSetLookupEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RemotePresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_r_RemotePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ListWidget>) GWT.create(ContextualProvider_factory__o_j_e_u_c_w_ListWidget__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LiveSearchFooterViewImpl>) GWT.create(Type_factory__o_u_e_w_c_c_d_f_LiveSearchFooterViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserEditorView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_u_UserEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UploadFormPresenter>) GWT.create(Type_factory__o_g_m_c_u_UploadFormPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AlertPanelView>) GWT.create(Type_factory__o_d_c_c_w_AlertPanelView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<M2RepoEditorPresenter>) GWT.create(Type_factory__o_g_m_c_M2RepoEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedScoreCardEditorViewImpl>) GWT.create(Type_factory__o_d_w_s_g_s_c_e_GuidedScoreCardEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<LayoutElementPropertiesPresenter>) GWT.create(Type_factory__o_u_e_l_e_c_w_LayoutElementPropertiesPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LiveSearchSelectorDropDownItem>) GWT.create(Type_factory__o_u_e_w_c_c_d_i_LiveSearchSelectorDropDownItem__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DecisionTableXLSResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_d_t_DecisionTableXLSResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SelectDocumentPopupViewImpl>) GWT.create(Type_factory__o_k_w_c_w_m_c_p_SelectDocumentPopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewAssetHandlerWidget>) GWT.create(Type_factory__o_k_w_c_s_l_c_w_p_NewAssetHandlerWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LeafPermissionNodeViewerView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_n_LeafPermissionNodeViewerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CSVDataSetDefAttributesEditorView>) GWT.create(Type_factory__o_d_c_w_d_e_c_CSVDataSetDefAttributesEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SplitLayoutPanelPresenter>) GWT.create(Type_factory__o_u_c_w_p_i_SplitLayoutPanelPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GroupContextMenuItemPresenter>) GWT.create(Type_factory__o_u_c_w_w_m_m_c_GroupContextMenuItemPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdvancedAnnotationListEditor>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_a_AdvancedAnnotationListEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DefaultFileEditorView>) GWT.create(Type_factory__o_u_e_w_c_c_e_d_DefaultFileEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DroolsDomainEditor>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_d_DroolsDomainEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ElasticSearchDataSetDefAttributesEditor>) GWT.create(Type_factory__o_d_c_w_d_e_e_ElasticSearchDataSetDefAttributesEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkItemHandlerListItemView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_k_i_k_w_WorkItemHandlerListItemView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KieTextEditorScreenPresenter>) GWT.create(Type_factory__o_k_w_c_s_d_c_e_KieTextEditorScreenPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MenuCustom>) GWT.create(JsType_factory__o_u_w_m_m_MenuCustom__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WindowEventObservers>) GWT.create(JsType_factory__o_j_e_e_c_c_WindowEventObservers__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LeafPermissionNodeViewer>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_n_LeafPermissionNodeViewer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PageTransitionEventEventInitDictType>) GWT.create(JsType_factory__e_d_PageTransitionEvent_PageTransitionEventEventInitDictType__quals__Universal.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkbenchPickupDragController>) GWT.create(Type_factory__o_u_c_w_w_d_WorkbenchPickupDragController__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DropDownImageListEditorView>) GWT.create(Type_factory__o_d_c_c_e_l_DropDownImageListEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BuildExecutor>) GWT.create(Type_factory__o_k_w_c_s_p_c_b_BuildExecutor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AppsPerspectiveActivity>) GWT.create(Type_factory__o_u_e_a_c_AppsPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContributorsManagementListItemView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_o_c_w_ContributorsManagementListItemView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BRLActionColumnPlugin>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_BRLActionColumnPlugin__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefProviderTypeEditor>) GWT.create(Type_factory__o_d_c_w_d_e_DataSetDefProviderTypeEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<TextResourceType>) GWT.create(Type_factory__o_u_e_w_c_c_e_t_TextResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AddBranchPopUpView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_p_b_AddBranchPopUpView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExplorerPresenter>) GWT.create(Type_factory__o_k_w_c_s_e_c_ExplorerPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.kie.workbench.common.widgets.configresource.client.widget.bound.ImportsWidgetPresenter>) GWT.create(Type_factory__o_k_w_c_w_c_c_w_b_ImportsWidgetPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SelectorLabelItem>) GWT.create(Type_factory__o_d_r_c_s_SelectorLabelItem__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DropdownMenuItem>) GWT.create(Type_factory__o_u_c_v_p_w_DropdownMenuItem__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetLookupEditorView>) GWT.create(Type_factory__o_d_d_c_w_DataSetLookupEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ShortcutSubHeadingLinkView>) GWT.create(Type_factory__o_k_w_c_s_h_c_w_s_s_ShortcutSubHeadingLinkView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DroolsDomainHandler>) GWT.create(Type_factory__o_k_w_c_s_d_c_h_d_DroolsDomainHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContributorsListItemPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_o_c_t_ContributorsListItemPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GeneralPreferencesBeanGeneratedImpl>) GWT.create(Type_factory__o_g_c_s_p_p_GeneralPreferencesBeanGeneratedImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EmptyOrganizationalUnitsView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_o_EmptyOrganizationalUnitsView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ScoreDirectorFactoryFormViewImpl>) GWT.create(Type_factory__o_o_w_s_s_c_e_ScoreDirectorFactoryFormViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SelectorDisplayer>) GWT.create(Type_factory__o_d_r_c_s_SelectorDisplayer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JavaSourceViewImpl>) GWT.create(Type_factory__o_k_w_c_s_j_c_e_JavaSourceViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GroupEditor>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_g_GroupEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AssetList>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_AssetList__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TreeHierarchyLeafItemView>) GWT.create(Type_factory__o_u_e_p_c_c_t_TreeHierarchyLeafItemView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkbenchMegaMenuProducer>) GWT.create(Type_factory__o_u_c_w_w_m_m_WorkbenchMegaMenuProducer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewPluginPopUp>) GWT.create(Type_factory__o_u_e_p_c_w_p_NewPluginPopUp__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RowNumberColumnConverter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_RowNumberColumnConverter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PerspectiveEditorPresenterActivity>) GWT.create(Type_factory__o_u_e_p_c_p_e_PerspectiveEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PackageListPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_k_i_KnowledgeBaseItemPresenter_PackageListPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<CategoriesManagerCache>) GWT.create(Type_factory__o_u_c_m_CategoriesManagerCache__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Div>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_Div__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ResourceTypeManagerCache>) GWT.create(Type_factory__o_u_c_m_ResourceTypeManagerCache__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ExplorerEntryPoint>) GWT.create(Type_factory__o_k_w_c_s_e_c_ExplorerEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Collection>) GWT.create(JsType_factory__j_u_Collection__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ResourceTypeDefinition>) GWT.create(JsType_factory__o_u_w_t_ResourceTypeDefinition__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FileMenuBuilderImpl>) GWT.create(Type_factory__o_k_w_c_w_c_m_FileMenuBuilderImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JavaEditorPresenter>) GWT.create(Type_factory__o_k_w_c_s_j_c_e_JavaEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RelationshipField>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_j_p_RelationshipField__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ElasticSearchDataSetEditWorkflow>) GWT.create(Type_factory__o_d_c_w_d_e_w_e_ElasticSearchDataSetEditWorkflow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefColumnsFilterEditor>) GWT.create(Type_factory__o_d_c_w_d_e_DataSetDefColumnsFilterEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<Model>) GWT.create(Type_factory__o_g_c_s_p_c_Model__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<OverviewWidgetPresenter>) GWT.create(Type_factory__o_k_w_c_w_m_c_w_OverviewWidgetPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ClientIntervalBuilderDynamicDate>) GWT.create(Type_factory__o_d_d_c_e_ClientIntervalBuilderDynamicDate__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NavTabListWidget>) GWT.create(Type_factory__o_d_c_n_w_NavTabListWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PlannerFieldMetadataProvider>) GWT.create(Type_factory__o_o_w_s_d_c_e_PlannerFieldMetadataProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<JSEntryPoint>) GWT.create(Type_factory__o_u_c_JSEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdminPagePresenter>) GWT.create(Type_factory__o_u_e_p_c_a_AdminPagePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewGlobalHandler>) GWT.create(Type_factory__o_d_w_s_g_c_h_NewGlobalHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContributorsPerspectiveActivity>) GWT.create(Type_factory__o_k_w_c_s_c_c_p_ContributorsPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<User>) GWT.create(Producer_factory__o_j_e_s_s_a_i_User__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SourceRepositoryPage>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_p_s_SourceRepositoryPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DataBinderProvider>) GWT.create(Type_factory__o_j_e_d_c_DataBinderProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PageTransitionProvider>) GWT.create(Type_factory__o_j_e_u_n_c_l_PageTransitionProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkbenchPartPresenterDefault>) GWT.create(Type_factory__o_u_c_w_p_n_p_WorkbenchPartPresenterDefault__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SavePopUpView>) GWT.create(Type_factory__o_u_e_e_c_c_f_p_SavePopUpView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AppsPerspective>) GWT.create(Type_factory__o_u_e_a_c_AppsPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JPADataObjectFieldEditorViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_j_JPADataObjectFieldEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionSetFieldPatternCell>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_c_ActionSetFieldPatternCell__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ToolBarItem>) GWT.create(JsType_factory__o_u_w_m_t_ToolBarItem__quals__Universal.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkbenchMenuCompactNavBarView>) GWT.create(Type_factory__o_u_c_v_p_m_WorkbenchMenuCompactNavBarView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KieDropdownElement>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_u_d_KieDropdownElement__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BRLActionColumnDefinitionBuilder>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_d_BRLActionColumnDefinitionBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AuditPageViewImpl>) GWT.create(Type_factory__o_d_w_s_t_c_p_a_AuditPageViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTableAccordionItemView>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_p_a_GuidedDecisionTableAccordionItemView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ServerTemplateView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_n_t_ServerTemplateView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<TechnicalViewWidget>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_t_TechnicalViewWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ListenersListPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_k_i_k_KnowledgeSessionListItemPresenter_ListenersListPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SSHKeysEditorScreenActivity>) GWT.create(Type_factory__o_u_s_c_e_SSHKeysEditorScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DisplayerPrototypes>) GWT.create(Type_factory__o_d_d_c_p_DisplayerPrototypes__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HTMLLabelElement>) GWT.create(ExtensionProvided_factory__e_d_HTMLLabelElement__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NavSecurityController>) GWT.create(Type_factory__o_d_n_w_NavSecurityController__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProjectPage>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_p_p_ProjectPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PopupViewImpl>) GWT.create(Type_factory__o_u_c_v_p_p_PopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ConfirmPopup>) GWT.create(Type_factory__o_u_c_v_p_w_ConfirmPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedRuleTemplateEntryPoint>) GWT.create(Type_factory__o_d_w_s_g_t_c_GuidedRuleTemplateEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JsTypeEventObserver>) GWT.create(Type_factory__o_j_e_e_c_c_JsTypeEventObserver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FactPatternConstraintsPageViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_FactPatternConstraintsPageViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AddDoubleValueModalView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_u_m_d_AddDoubleValueModalView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnWithComponents>) GWT.create(Type_factory__o_u_e_l_e_c_c_c_ColumnWithComponents__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisabledFeatureComponent>) GWT.create(Type_factory__o_u_e_c_d_c_DisabledFeatureComponent__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LockTarget>) GWT.create(JsType_factory__o_u_c_m_LockTarget__quals__Universal.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<EnumEditorEntryPoint>) GWT.create(Type_factory__o_d_w_s_e_c_EnumEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DefineOptionsType>) GWT.create(JsType_factory__e_d_CustomElementRegistry_DefineOptionsType__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProjectScreenMenuItem>) GWT.create(Type_factory__o_k_w_c_s_e_c_ProjectScreenMenuItem__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<LayoutEditorCssHelper>) GWT.create(Type_factory__o_u_e_l_e_c_i_LayoutEditorCssHelper__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NoItemsComponent>) GWT.create(Type_factory__o_u_e_w_c_c_d_n_NoItemsComponent__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataObjectBrowser>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_e_DataObjectBrowser__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SSHKeysEditorEmptyStateDisplayerViewImpl>) GWT.create(Type_factory__o_u_s_c_e_c_e_SSHKeysEditorEmptyStateDisplayerViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PanelDefinition>) GWT.create(JsType_factory__o_u_w_m_PanelDefinition__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NavTilesDragComponent>) GWT.create(Type_factory__o_d_c_n_l_e_NavTilesDragComponent__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CopyPopUpViewProducer>) GWT.create(Type_factory__o_u_e_e_c_c_f_CopyPopUpViewProducer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewTemplateView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_t_NewTemplateView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefScreenViewImpl>) GWT.create(Type_factory__o_d_d_e_c_s_DataSetDefScreenViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionInsertFactFieldCell>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_c_ActionInsertFactFieldCell__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<RuntimePluginsEntryPoint>) GWT.create(Type_factory__o_u_e_p_c_RuntimePluginsEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Heading>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_Heading__quals__j_e_i_Any_j_e_i_Default_j_i_Named_2.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Heading>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_Heading__quals__j_e_i_Any_j_e_i_Default_j_i_Named_1.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Heading>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_Heading__quals__j_e_i_Any_j_e_i_Default_j_i_Named_3.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewGuidedDecisionTableGraphHandler>) GWT.create(Type_factory__o_d_w_s_g_d_c_h_NewGuidedDecisionTableGraphHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BRLConditionColumnPlugin>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_BRLConditionColumnPlugin__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkbenchConfigurationMenu>) GWT.create(Type_factory__o_k_w_c_w_c_h_w_c_WorkbenchConfigurationMenu__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WindowEventObservers>) GWT.create(Type_factory__o_j_e_e_c_c_WindowEventObservers__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BusyIndicatorView>) GWT.create(Type_factory__o_u_e_w_c_c_c_BusyIndicatorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FetchRepositoryViewImpl>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_p_p_FetchRepositoryViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MenuItemDividerView>) GWT.create(Type_factory__o_u_e_w_c_c_m_MenuItemDividerView__quals__j_e_i_Any_o_u_e_w_c_c_m_MenuItemDivider.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SoftConstraintMatchRuleModellerActionPlugin>) GWT.create(Type_factory__o_o_w_s_g_c_p_SoftConstraintMatchRuleModellerActionPlugin__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerSettingsJSONSourceViewer>) GWT.create(Type_factory__o_d_d_c_w_DisplayerSettingsJSONSourceViewer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CSVDataSetEditor>) GWT.create(Type_factory__o_d_c_w_d_e_c_CSVDataSetEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NavigationPanelProvider>) GWT.create(Type_factory__o_j_e_u_n_c_l_NavigationPanelProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JsArray>) GWT.create(JsType_factory__o_j_e_i_c_JsArray__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdministrationPerspectiveActivity>) GWT.create(Type_factory__o_o_w_c_p_AdministrationPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetFilterEditor>) GWT.create(Type_factory__o_d_d_c_w_f_DataSetFilterEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ExperimentalFeaturesPerspective>) GWT.create(Type_factory__o_u_e_c_p_ExperimentalFeaturesPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DefaultSettingsSections>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_DefaultSettingsSections__quals__j_e_i_Any_o_u_a_FallbackImplementation.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ValidatorService>) GWT.create(Type_factory__o_k_w_c_s_d_c_v_ValidatorService__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AboutCommand>) GWT.create(Type_factory__o_k_w_c_w_c_m_AboutCommand__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RemoteView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_r_RemoteView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionRetractFactColumnConverter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_ActionRetractFactColumnConverter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GitUrlsView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_g_GitUrlsView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KieMultipleDocumentEditorWrapperViewImpl>) GWT.create(Type_factory__o_k_w_c_w_m_c_KieMultipleDocumentEditorWrapperViewImpl__quals__j_e_i_Any_o_k_w_c_w_m_c_KieMultipleDocumentEditorQualifier.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KieTextEditorScreenPresenterActivity>) GWT.create(Type_factory__o_k_w_c_s_d_c_e_KieTextEditorScreenPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<VersionMenuDropDownButton>) GWT.create(Type_factory__o_u_e_e_c_c_h_VersionMenuDropDownButton__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SettingsSections>) GWT.create(Producer_factory__o_k_w_c_s_l_c_s_s_SettingsSections__quals__j_e_i_Any_o_u_a_Customizable.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GAVEditorViewImpl>) GWT.create(Type_factory__o_g_c_s_p_c_GAVEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PermissionTreeSetup>) GWT.create(Type_factory__o_k_w_c_w_c_a_PermissionTreeSetup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<KieMultipleDocumentEditorEntryPoint>) GWT.create(Type_factory__o_k_w_c_w_m_c_KieMultipleDocumentEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefBasicAttributesEditor>) GWT.create(Type_factory__o_d_c_w_d_e_a_DataSetDefBasicAttributesEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TemplatedWorkbenchPanelPresenter>) GWT.create(Type_factory__o_u_c_w_p_i_TemplatedWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AddDoubleValueModal>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_u_m_d_AddDoubleValueModal__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TextBoxFormPopupViewImpl>) GWT.create(Type_factory__o_k_w_c_w_c_p_t_TextBoxFormPopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<StateChangeImpl>) GWT.create(Type_factory__o_j_e_i_c_l_i_StateChangeImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RequestDispatcher>) GWT.create(Provider_factory__o_j_e_b_c_a_m_RequestDispatcher__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SSHClientEntryPoint>) GWT.create(Type_factory__o_u_s_c_SSHClientEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UploadFormViewImpl>) GWT.create(Type_factory__o_g_m_c_u_UploadFormViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MetricDisplayer>) GWT.create(Type_factory__o_d_r_c_m_MetricDisplayer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PreferenceFormBeansInfo>) GWT.create(Type_factory__o_u_e_p_c_u_PreferenceFormBeansInfo__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KebabWidget>) GWT.create(Type_factory__o_u_e_l_e_c_w_KebabWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ErrorPopup>) GWT.create(Type_factory__o_u_c_v_p_w_ErrorPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<TestScenarioResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_t_t_TestScenarioResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProjectClassListViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_p_ProjectClassListViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<TranslationServiceProvider>) GWT.create(Type_factory__o_j_e_u_c_l_s_TranslationServiceProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SocialUserImageProviderImpl>) GWT.create(Type_factory__o_e_u_s_a_c_u_SocialUserImageProviderImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ClientUsernameProvider>) GWT.create(Type_factory__o_u_p_c_s_ClientUsernameProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<VFSJSExporter>) GWT.create(Type_factory__o_u_c_e_VFSJSExporter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnFunctionEditor>) GWT.create(Type_factory__o_d_d_c_w_g_ColumnFunctionEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AddProjectButtonView>) GWT.create(Type_factory__o_k_w_c_s_l_c_w_l_AddProjectButtonView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContainerRulesConfigView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_c_c_r_ContainerRulesConfigView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NavRootNodeEditor>) GWT.create(Type_factory__o_d_c_n_w_e_NavRootNodeEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdaptiveWorkbenchPanelPresenter>) GWT.create(Type_factory__o_u_c_w_p_i_AdaptiveWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DeleteProjectPopUpView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_p_d_DeleteProjectPopUpView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KieSelectElementView>) GWT.create(Type_factory__o_k_w_c_w_c_w_KieSelectElementView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<InvalidProjectView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_a_InvalidProjectView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionInsertFactFieldPatternCell>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_c_ActionInsertFactFieldPatternCell__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdvancedDataObjectFieldEditor>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDataObjectFieldEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.gwtbootstrap3.extras.select.client.ui.Select>) GWT.create(ExtensionProvided_factory__o_g_e_s_c_u_Select__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PermissionExceptionSwitch>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_n_PermissionExceptionSwitch__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PluginConfigService>) GWT.create(Type_factory__o_u_e_p_c_c_PluginConfigService__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FileExplorerPresenter>) GWT.create(Type_factory__o_g_s_c_e_f_FileExplorerPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContributorsPerspective>) GWT.create(Type_factory__o_k_w_c_s_c_c_p_ContributorsPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedRuleTemplateEditorViewImpl>) GWT.create(Type_factory__o_d_w_s_g_t_c_e_GuidedRuleTemplateEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ClientResourceType>) GWT.create(JsType_factory__o_u_c_w_t_ClientResourceType__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewAssetHandlerCardWidget>) GWT.create(Type_factory__o_k_w_c_s_l_c_w_p_NewAssetHandlerCardWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExternalDataObjectsPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_e_ExternalDataObjectsPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MainDataObjectFieldEditor>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_m_MainDataObjectFieldEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SelectorSliderDisplayerView>) GWT.create(Type_factory__o_d_r_c_s_SelectorSliderDisplayerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MetaDataColumnConverter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_MetaDataColumnConverter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActivityResourceType>) GWT.create(JsType_factory__o_u_w_m_ActivityResourceType__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UnanchoredWorkbenchPartPresenter>) GWT.create(Type_factory__o_u_c_w_p_u_p_UnanchoredWorkbenchPartPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.kie.workbench.common.screens.server.management.client.widget.Div>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_Div__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultipleNumberParameterEditor>) GWT.create(Type_factory__o_d_d_c_w_f_MultipleNumberParameterEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FileUploadEditorView>) GWT.create(Type_factory__o_d_c_c_e_f_FileUploadEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SocialRelationsWidget>) GWT.create(Type_factory__o_e_u_s_a_c_w_r_SocialRelationsWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedRuleTemplateEditorPresenterActivity>) GWT.create(Type_factory__o_d_w_s_g_t_c_e_GuidedRuleTemplateEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SyncBeanManager>) GWT.create(Producer_factory__o_j_e_i_c_c_SyncBeanManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Row>) GWT.create(Type_factory__o_u_e_l_e_c_c_r_Row__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PackageListBoxViewImpl>) GWT.create(Type_factory__o_k_w_c_w_c_h_PackageListBoxViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExampleProjectErrorView>) GWT.create(Type_factory__o_k_w_c_s_l_c_w_e_e_ExampleProjectErrorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedDecisionTableEditorEntryPoint>) GWT.create(Type_factory__o_d_w_s_g_d_c_GuidedDecisionTableEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetAuthoringPerspectiveActivity>) GWT.create(Type_factory__o_d_d_e_c_p_DataSetAuthoringPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WizardViewImpl>) GWT.create(Type_factory__o_u_e_w_c_c_w_WizardViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EmptyLibraryScreen>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_EmptyLibraryScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<StaticFocusedResizePanel>) GWT.create(ExtensionProvided_factory__o_u_c_w_w_p_StaticFocusedResizePanel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkbenchPartView>) GWT.create(Type_factory__o_u_c_w_p_n_p_WorkbenchPartView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<OptionsListPresenter>) GWT.create(Type_factory__o_k_w_c_w_c_w_KieSelectElement_OptionsListPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ChildContextMenuItemPresenter>) GWT.create(Type_factory__o_u_c_w_w_m_m_c_ChildContextMenuItemPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TranslationService>) GWT.create(Provider_factory__o_j_e_u_c_l_s_TranslationService__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<IconMenuItemView>) GWT.create(Type_factory__o_u_c_v_p_m_m_m_IconMenuItemView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<UberfireDocksContainer>) GWT.create(Type_factory__o_u_c_w_d_UberfireDocksContainer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AnnotationValuePairListItem>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_a_i_AnnotationValuePairListItem__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ACLViewer>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_ACLViewer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ArtifactListWidgetView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_a_ArtifactListWidgetView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionInsertFactCol52DefinitionBuilder>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_d_ActionInsertFactCol52DefinitionBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<com.google.gwt.user.client.ui.TextBox>) GWT.create(ExtensionProvided_factory__c_g_g_u_c_u_TextBox__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MetadataWidget>) GWT.create(Type_factory__o_k_w_c_w_m_c_w_MetadataWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ResourceUtils>) GWT.create(Type_factory__o_k_w_c_s_l_c_u_ResourceUtils__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataObjectBrowserViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_e_DataObjectBrowserViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NavigationPanel>) GWT.create(Provider_factory__o_j_e_u_n_c_l_NavigationPanel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MetaDataColumnPlugin>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_MetaDataColumnPlugin__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DefaultPatternCell>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_c_DefaultPatternCell__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ComponentColumnView>) GWT.create(Type_factory__o_u_e_l_e_c_c_c_ComponentColumnView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AboutPopupView>) GWT.create(Type_factory__o_k_w_c_w_c_p_a_AboutPopupView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KieEnumSelectElement>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_u_s_KieEnumSelectElement__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserAttributesEditorView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_u_UserAttributesEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Caller>) GWT.create(ContextualProvider_factory__o_j_e_c_c_a_Caller__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ClientMessageBus>) GWT.create(Producer_factory__o_j_e_b_c_a_ClientMessageBus__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DownloadMenuItem>) GWT.create(Type_factory__o_u_e_e_c_c_m_DownloadMenuItem__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefProviderTypeEditorView>) GWT.create(Type_factory__o_d_c_w_d_e_DataSetDefProviderTypeEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FieldSet>) GWT.create(ExtensionProvided_factory__o_g_c_u_FieldSet__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ResourceAction>) GWT.create(JsType_factory__o_u_s_ResourceAction__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionSetFieldCell>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_c_ActionSetFieldCell__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<VFSServiceProxyClientImpl>) GWT.create(Type_factory__o_u_c_w_VFSServiceProxyClientImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<LayoutEditorEntryPoint>) GWT.create(Type_factory__o_u_e_l_e_c_LayoutEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NavTreeEditorView>) GWT.create(Type_factory__o_d_c_n_w_e_NavTreeEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CSVDataSetDefAttributesEditor>) GWT.create(Type_factory__o_d_c_w_d_e_c_CSVDataSetDefAttributesEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BranchOptionView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_p_b_AddBranchPopUpView_BranchOptionView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataObjectFieldPickerViewImpl>) GWT.create(Type_factory__o_o_w_s_d_c_w_p_DataObjectFieldPickerViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CSVDataSetDefValidator>) GWT.create(Type_factory__o_d_v_d_CSVDataSetDefValidator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ResourceActionRef>) GWT.create(JsType_factory__o_u_s_a_ResourceActionRef__quals__Universal.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<Optimization>) GWT.create(Type_factory__o_g_c_s_p_c_Optimization__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<IntervalBuilderDynamicLabel>) GWT.create(Type_factory__o_d_d_e_g_IntervalBuilderDynamicLabel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EditContributorsPopUpView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_o_c_e_EditContributorsPopUpView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AssignedNodesOptionsType>) GWT.create(JsType_factory__e_d_HTMLSlotElement_AssignedNodesOptionsType__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MenuItemWithIconView>) GWT.create(Type_factory__o_u_e_w_c_c_m_MenuItemWithIconView__quals__j_e_i_Any_o_u_e_w_c_c_m_MenuItemWithIcon.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NavMenuBarWidget>) GWT.create(Type_factory__o_d_c_n_w_NavMenuBarWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.gwtbootstrap3.client.ui.Row>) GWT.create(ExtensionProvided_factory__o_g_c_u_Row__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewGuidedDecisionTreeHandler>) GWT.create(Type_factory__o_d_w_s_g_d_c_h_NewGuidedDecisionTreeHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WiresTreesScreenActivity>) GWT.create(Type_factory__o_u_e_w_c_t_c_c_WiresTreesScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ACLEditorView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_ACLEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UrlsFieldType>) GWT.create(JsType_factory__e_d_RTCConfigurationInterface_UrlsFieldType__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdminPageCategoryPresenter>) GWT.create(Type_factory__o_u_e_p_c_a_c_AdminPageCategoryPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<UberfireExperimentalEntryPoint>) GWT.create(Type_factory__o_u_e_c_UberfireExperimentalEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DefaultSecurityExceptionHandler>) GWT.create(Type_factory__o_j_e_s_c_l_h_DefaultSecurityExceptionHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Option>) GWT.create(Type_factory__o_k_w_c_w_c_w_KieSelectElementView_Option__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExternalDataObjectsItemView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_e_ExternalDataObjectsItemView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PreferenceScopeTypes>) GWT.create(Producer_factory__o_u_p_s_PreferenceScopeTypes__quals__j_e_i_Any_o_u_a_Customizable.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LayoutDragComponentGroupView>) GWT.create(Type_factory__o_u_e_l_e_c_w_LayoutDragComponentGroupView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ToggleSwitchEditorView>) GWT.create(Type_factory__o_d_c_c_e_ToggleSwitchEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PanelDefinitionImpl>) GWT.create(Type_factory__o_u_w_m_i_PanelDefinitionImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FileExportsPreferencesBeanGeneratedImpl>) GWT.create(Type_factory__o_u_e_e_c_f_e_FileExportsPreferencesBeanGeneratedImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RuleModellerPageView>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_RuleModellerPageView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SettingsView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_SettingsView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetSummaryView>) GWT.create(Type_factory__o_d_c_w_d_e_DataSetSummaryView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedDTableGraphResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_g_d_t_GuidedDTableGraphResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SSHKeysEditorViewImpl>) GWT.create(Type_factory__o_u_s_c_e_c_SSHKeysEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MenuItemView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_u_s_MenuItemView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NavCarouselWidgetView>) GWT.create(Type_factory__o_d_c_n_w_NavCarouselWidgetView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TreeHierarchyInternalItemView>) GWT.create(Type_factory__o_u_e_p_c_c_t_TreeHierarchyInternalItemView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultiScreenView>) GWT.create(Type_factory__o_u_c_v_p_m_MultiScreenView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewEnumHandler>) GWT.create(Type_factory__o_d_w_s_e_c_h_NewEnumHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserGroupsExplorer>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_UserGroupsExplorer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ActiveContextOptions>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_ActiveContextOptions__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ArtifactListViewImpl>) GWT.create(Type_factory__o_g_m_c_w_ArtifactListViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
  }

  private void registerFactories2(final Context org_jboss_errai_ioc_client_container_ApplicationScopedContext_context, final Context org_jboss_errai_ioc_client_container_DependentScopeContext_context) {
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AddBranchPopUpPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_p_b_AddBranchPopUpPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExternalDataObjectsItemPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_e_ExternalDataObjectsItemPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExperimentalFeatureEditorViewImpl>) GWT.create(Type_factory__o_u_e_c_e_g_f_ExperimentalFeatureEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdaptiveWorkbenchPanelView>) GWT.create(Type_factory__o_u_c_w_p_i_AdaptiveWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTablePresenter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_GuidedDecisionTablePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PlannerDomainScreenActivity>) GWT.create(Type_factory__o_o_w_s_d_c_w_p_PlannerDomainScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<JavaResourceTypeDefinition>) GWT.create(Type_factory__o_k_w_c_s_j_t_JavaResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefExplorerScreen>) GWT.create(Type_factory__o_d_d_e_c_s_DataSetDefExplorerScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkbenchDragAndDropManager>) GWT.create(Type_factory__o_u_c_w_w_d_WorkbenchDragAndDropManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<LayoutEditorPropertiesScreen>) GWT.create(Type_factory__o_u_e_l_e_c_LayoutEditorPropertiesScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<POMResourceTypeDefinition>) GWT.create(Type_factory__o_g_c_s_p_e_t_POMResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MainDomainEditor>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_m_MainDomainEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LockManagerImpl>) GWT.create(Type_factory__o_u_c_m_LockManagerImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SelectComponent>) GWT.create(Type_factory__o_u_e_w_c_c_s_SelectComponent__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NoRepositoryURLViewImpl>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_p_p_NoRepositoryURLViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PerspectiveManagerImpl>) GWT.create(Type_factory__o_u_c_m_PerspectiveManagerImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ContentManagerPerspective>) GWT.create(Type_factory__o_d_c_c_p_ContentManagerPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ValueOptionsPage>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_ValueOptionsPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DefaultClipboard>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_c_i_DefaultClipboard__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<TestRunnerReportingScreen>) GWT.create(Type_factory__o_k_w_c_w_c_t_TestRunnerReportingScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ServerManagementPerspective>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_ServerManagementPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AnnotationListItem>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_a_i_AnnotationListItem__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkingSetManager>) GWT.create(Type_factory__o_g_c_s_w_c_WorkingSetManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ClientSecurityRoleInterceptor>) GWT.create(Type_factory__o_j_e_s_c_l_i_ClientSecurityRoleInterceptor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.jboss.errai.common.client.dom.Option>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_Option__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<StandaloneEditorPerspective>) GWT.create(Type_factory__o_u_c_w_StandaloneEditorPerspective__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DependenciesItemPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_d_DependenciesItemPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CopyPopUpView>) GWT.create(Type_factory__o_u_e_e_c_c_f_p_CopyPopUpView__quals__j_e_i_Any_o_u_a_FallbackImplementation.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<InitBallot>) GWT.create(ContextualProvider_factory__o_j_e_i_c_a_InitBallot__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BeanDataSetDefValidator>) GWT.create(Type_factory__o_d_v_d_BeanDataSetDefValidator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DataSetValidatorProvider>) GWT.create(Type_factory__o_d_v_DataSetValidatorProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnsPage>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_p_ColumnsPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TileWidget>) GWT.create(Type_factory__o_k_w_c_s_l_c_w_c_TileWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<BusinessViewWidget>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_b_BusinessViewWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ToggleSwitchEditor>) GWT.create(Type_factory__o_d_c_c_e_ToggleSwitchEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BodyView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_b_BodyView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PerspectivesExplorerView>) GWT.create(Type_factory__o_d_c_c_w_PerspectivesExplorerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTreeEditorPresenter>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_GuidedDecisionTreeEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExplorerMenuViewImpl>) GWT.create(Type_factory__o_k_w_c_s_e_c_ExplorerMenuViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Input>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_Input__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FilePropertiesType>) GWT.create(JsType_factory__e_d_File_FilePropertiesType__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetProviderTypeWorkflow>) GWT.create(Type_factory__o_d_c_w_d_e_w_c_DataSetProviderTypeWorkflow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ConditionCol52DefinitionBuilder>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_d_ConditionCol52DefinitionBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EmptyState>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_EmptyState__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Clipboard>) GWT.create(Type_factory__o_u_c_u_Clipboard__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ClientUUIDGenerator>) GWT.create(Type_factory__o_d_d_c_u_ClientUUIDGenerator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContainerStatusEmptyView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_c_s_e_ContainerStatusEmptyView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ClientUserSystemManager>) GWT.create(Type_factory__o_u_e_s_m_c_ClientUserSystemManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RemoteEmptyView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_r_e_RemoteEmptyView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AppsHomePresenterActivity>) GWT.create(Type_factory__o_u_e_a_c_h_AppsHomePresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TabPanelWithDropdowns>) GWT.create(Type_factory__o_u_c_v_p_t_TabPanelWithDropdowns__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RowView>) GWT.create(Type_factory__o_u_e_l_e_c_c_r_RowView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdvancedDomainScreenViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDomainScreenViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<IssuePresenterViewImpl>) GWT.create(Type_factory__o_k_w_c_s_v_r_c_p_IssuePresenterViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProjectImportsScreenPresenter>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_ProjectImportsScreenPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<UberfireJSAPIExporter>) GWT.create(Type_factory__o_u_c_e_UberfireJSAPIExporter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProjectImportsScreenViewImpl>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_ProjectImportsScreenViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CalculationTypePageView>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_CalculationTypePageView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewPerspectivePopUp>) GWT.create(Type_factory__o_d_c_c_w_NewPerspectivePopUp__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserAssignedGroupsExplorer>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_u_UserAssignedGroupsExplorer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RegisterOptionsType>) GWT.create(JsType_factory__e_d_Document_RegisterOptionsType__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProjectMetricsView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_p_ProjectMetricsView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PackageSelectorViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_p_PackageSelectorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetExplorer>) GWT.create(Type_factory__o_d_c_w_d_e_DataSetExplorer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<LanguageConfigurationHandler>) GWT.create(Type_factory__o_k_w_c_w_c_h_w_c_LanguageConfigurationHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KnowledgeBasesListPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_k_i_k_KnowledgeSessionsModal_KnowledgeBasesListPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ServerManagementBrowserPresenterActivity>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_ServerManagementBrowserPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AdminPageImpl>) GWT.create(Type_factory__o_u_e_p_c_a_p_AdminPageImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ImportRepositoryPopUpPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_i_ImportRepositoryPopUpPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EditJavaSourceWidget>) GWT.create(ExtensionProvided_factory__o_k_w_c_s_j_c_w_EditJavaSourceWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ActionRetractNodeFactory>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_f_ActionRetractNodeFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TransitionAnchor>) GWT.create(ContextualProvider_factory__o_j_e_u_n_c_l_TransitionAnchor__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefRefreshAttributesEditor>) GWT.create(Type_factory__o_d_c_w_d_e_a_DataSetDefRefreshAttributesEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionWorkItemExecuteColumnSynchronizer>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ActionWorkItemExecuteColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<XMLViewerImpl>) GWT.create(Type_factory__o_o_w_s_s_c_e_XMLViewerImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AdminPagePerspective>) GWT.create(Type_factory__o_u_e_p_c_a_AdminPagePerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.uberfire.ext.layout.editor.client.components.container.Container>) GWT.create(Type_factory__o_u_e_l_e_c_c_c_Container__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EmptyOrganizationalUnitsScreen>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_o_EmptyOrganizationalUnitsScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTableModellerPresenter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_GuidedDecisionTableModellerPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<IconMenuItemPresenter>) GWT.create(Type_factory__o_u_c_w_w_m_m_m_IconMenuItemPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTableEditorPresenter>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_GuidedDecisionTableEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContentManagerHomeScreen>) GWT.create(Type_factory__o_d_c_c_s_h_ContentManagerHomeScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DroolsDataObjectFieldEditor>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_d_DroolsDataObjectFieldEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefClientCacheAttributesEditor>) GWT.create(Type_factory__o_d_c_w_d_e_a_DataSetDefClientCacheAttributesEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EmptyDropRowView>) GWT.create(Type_factory__o_u_e_l_e_c_c_r_EmptyDropRowView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DocksEntryPoint>) GWT.create(Type_factory__o_u_c_DocksEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<TypeNodeFactory>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_f_TypeNodeFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DynamicMenuEditorView>) GWT.create(Type_factory__o_u_e_p_c_e_DynamicMenuEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExperimentalFeaturesEditorScreenActivity>) GWT.create(Type_factory__o_u_e_c_e_ExperimentalFeaturesEditorScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<BatchCallerProvider>) GWT.create(Type_factory__o_j_e_i_s_b_c_BatchCallerProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoryEditorView>) GWT.create(Type_factory__o_g_s_c_e_r_e_RepositoryEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ImageFileExport>) GWT.create(Producer_factory__o_u_e_e_c_c_f_e_ImageFileExport__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActiveContextManager>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_ActiveContextManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AppsCustomMenuBuilder>) GWT.create(Type_factory__o_k_w_c_w_c_m_c_AppsCustomMenuBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Set>) GWT.create(JsType_factory__j_u_Set__quals__Universal.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PluginsInfo>) GWT.create(Type_factory__o_u_e_p_c_i_PluginsInfo__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HTMLDocument>) GWT.create(Producer_factory__e_d_HTMLDocument__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PlannerDataObjectFieldEditorViewImpl>) GWT.create(Type_factory__o_o_w_s_d_c_w_p_PlannerDataObjectFieldEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AnalysisReportScreenActivity>) GWT.create(Type_factory__o_k_w_c_s_v_r_c_p_AnalysisReportScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefPreviewTableView>) GWT.create(Type_factory__o_d_c_w_d_e_DataSetDefPreviewTableView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WizardPageTitle>) GWT.create(Type_factory__o_u_e_w_c_c_w_WizardPageTitle__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<IncludedKnowledgeBaseItemPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_k_i_i_IncludedKnowledgeBaseItemPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JavaAssetUpdateValidator>) GWT.create(Type_factory__o_k_w_c_w_m_c_v_JavaAssetUpdateValidator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<M2RepoEditorPresenterActivity>) GWT.create(Type_factory__o_g_m_c_M2RepoEditorPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SaveButton>) GWT.create(Type_factory__o_u_e_e_c_c_h_SaveButton__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FormListPopupViewImpl>) GWT.create(Type_factory__o_k_w_c_w_c_p_l_FormListPopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GenericValuePairEditor>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_v_g_GenericValuePairEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PersistableDataObjectsListPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_p_PersistencePresenter_PersistableDataObjectsListPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FooterView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_f_FooterView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisabledFeatureActivity>) GWT.create(Type_factory__o_u_e_c_d_s_DisabledFeatureActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SelectorDisplayerView>) GWT.create(Type_factory__o_d_r_c_s_SelectorDisplayerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DeleteBranchPopUpView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_p_b_d_DeleteBranchPopUpView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FormListPopup>) GWT.create(Type_factory__o_k_w_c_w_c_p_l_FormListPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JPANewResourceOptions>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_j_o_JPANewResourceOptions__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ClientIntervalBuilderLocator>) GWT.create(Type_factory__o_d_d_c_e_ClientIntervalBuilderLocator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ActivityNotFoundPresenter>) GWT.create(Type_factory__o_u_e_w_c_c_w_w_p_a_n_ActivityNotFoundPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AccessImpl>) GWT.create(Type_factory__o_j_e_i_c_l_i_AccessImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PluginExplorerScreenActivity>) GWT.create(Type_factory__o_u_e_p_c_e_PluginExplorerScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FixtureLayout>) GWT.create(Type_factory__o_d_w_s_t_c_FixtureLayout__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<IssuePresenter>) GWT.create(Type_factory__o_k_w_c_s_v_r_c_p_IssuePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ConstraintNodeFactory>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_f_ConstraintNodeFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkbenchToolBarView>) GWT.create(Type_factory__o_u_c_v_p_t_WorkbenchToolBarView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RegisteredDocumentsMenuViewImpl>) GWT.create(Type_factory__o_k_w_c_w_m_c_m_RegisteredDocumentsMenuViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HTMLOptionElement>) GWT.create(ExtensionProvided_factory__e_d_HTMLOptionElement__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BeanDataSetDefAttributesEditorView>) GWT.create(Type_factory__o_d_c_w_d_e_b_BeanDataSetDefAttributesEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SQLDataSetDefValidator>) GWT.create(Type_factory__o_d_v_d_SQLDataSetDefValidator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<IdGeneratorField>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_j_p_IdGeneratorField__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DSLEditorPresenter>) GWT.create(Type_factory__o_d_w_s_d_c_e_DSLEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AsyncPackageDataModelOracleImpl>) GWT.create(Type_factory__o_k_w_c_w_c_d_AsyncPackageDataModelOracleImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PagedTable>) GWT.create(Type_factory__o_u_e_w_c_c_t_PagedTable__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerSettingsEditorView>) GWT.create(Type_factory__o_d_d_c_w_DisplayerSettingsEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionRetractFactColumnSynchronizer>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ActionRetractFactColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionsScreenActivity>) GWT.create(Type_factory__o_u_e_w_c_c_a_ActionsScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ValidationPopup>) GWT.create(Type_factory__o_k_w_c_w_c_p_v_ValidationPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionInsertFactFieldsPage>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_ActionInsertFactFieldsPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<RepositoryPreferencesProducer>) GWT.create(Type_factory__o_o_w_c_RepositoryPreferencesProducer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<TechnicalViewPresenter>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_t_TechnicalViewPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.uberfire.client.views.pfly.notfound.ActivityNotFoundView>) GWT.create(Type_factory__o_u_c_v_p_n_ActivityNotFoundView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnDefinitionFactory>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_d_ColumnDefinitionFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RegisterElementOptionsType>) GWT.create(JsType_factory__e_d_Document_RegisterElementOptionsType__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KebabMenuItem>) GWT.create(Type_factory__o_u_c_v_p_w_KebabMenuItem__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SplashScreenJSExporter>) GWT.create(Type_factory__o_u_c_e_SplashScreenJSExporter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ShapeFactoryCache>) GWT.create(Type_factory__o_u_e_w_c_c_f_ShapeFactoryCache__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Map>) GWT.create(JsType_factory__j_u_Map__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HorizImageListEditor>) GWT.create(Type_factory__o_d_c_c_e_l_HorizImageListEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetPanelView>) GWT.create(Type_factory__o_d_c_w_d_e_DataSetPanelView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ToggleCommentView>) GWT.create(Type_factory__o_u_e_e_c_c_f_p_c_ToggleCommentView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SplashModalFooter>) GWT.create(Type_factory__o_u_c_v_p_s_SplashModalFooter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JavaEditorPresenterActivity>) GWT.create(Type_factory__o_k_w_c_s_j_c_e_JavaEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DefaultFileEditorPresenterActivity>) GWT.create(Type_factory__o_u_e_w_c_c_e_d_DefaultFileEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<M2RepoEditorEntryPoint>) GWT.create(Type_factory__o_g_m_c_M2RepoEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ItemsListPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_u_d_KieDropdownElement_ItemsListPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<LoadingBox>) GWT.create(Type_factory__o_d_c_w_c_LoadingBox__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewResourcePresenter>) GWT.create(Type_factory__o_k_w_c_w_c_h_NewResourcePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.jboss.errai.common.client.dom.Paragraph>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_Paragraph__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionWorkItemSetFieldColumnSynchronizer>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ActionWorkItemSetFieldColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BodyPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_b_BodyPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MenuItemCommand>) GWT.create(JsType_factory__o_u_w_m_m_MenuItemCommand__quals__Universal.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DynamicMenuResourceType>) GWT.create(Type_factory__o_u_e_p_c_t_DynamicMenuResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.gwtbootstrap3.client.ui.Anchor>) GWT.create(ExtensionProvided_factory__o_g_c_u_Anchor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TableDisplayerView>) GWT.create(Type_factory__o_d_r_c_t_TableDisplayerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HashChangeEventEventInitDictType>) GWT.create(JsType_factory__e_d_HashChangeEvent_HashChangeEventEventInitDictType__quals__Universal.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AuthoringWorkbenchDocks>) GWT.create(Type_factory__o_k_w_c_w_c_d_AuthoringWorkbenchDocks__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ShowAssetUsagesDisplayer>) GWT.create(Type_factory__o_k_w_c_s_r_c_u_ShowAssetUsagesDisplayer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserEditorDriver>) GWT.create(Type_factory__o_u_e_s_m_c_e_u_UserEditorDriver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DecisionTableXLSXResourceType>) GWT.create(Type_factory__o_d_w_s_d_c_t_DecisionTableXLSXResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkItemMetaDataLoader>) GWT.create(Type_factory__o_d_w_s_w_c_w_WorkItemMetaDataLoader__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<EditorTreeProvider>) GWT.create(Type_factory__o_u_c_a_EditorTreeProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RootPanel>) GWT.create(Provider_factory__c_g_g_u_c_u_RootPanel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<MainDomainHandler>) GWT.create(Type_factory__o_k_w_c_s_d_c_h_m_MainDomainHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PreferenceScopeTypesProducer>) GWT.create(Type_factory__o_u_p_s_i_PreferenceScopeTypesProducer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkItemsTypeDefinition>) GWT.create(Type_factory__o_d_w_s_w_t_WorkItemsTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NavTilesWidgetView>) GWT.create(Type_factory__o_d_c_n_w_NavTilesWidgetView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionsGroup>) GWT.create(Type_factory__o_u_e_w_c_c_a_ActionsGroup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AssetsActionsWidget>) GWT.create(Type_factory__o_k_w_c_s_l_c_w_p_AssetsActionsWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<StaticWorkbenchPanelView>) GWT.create(Type_factory__o_u_c_w_p_i_StaticWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<BusinessViewPresenter>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_b_BusinessViewPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<OrganizationalUnitController>) GWT.create(Type_factory__o_g_s_c_s_OrganizationalUnitController__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ConditionColumnSynchronizer>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ConditionColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NavigationExplorerScreenActivity>) GWT.create(Type_factory__o_d_c_c_s_e_NavigationExplorerScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JPADataObjectEditorViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_j_JPADataObjectEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PerspectiveWidget>) GWT.create(Type_factory__o_d_c_c_w_PerspectiveWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultiScreenWorkbenchPanelPresenter>) GWT.create(Type_factory__o_u_c_w_p_i_MultiScreenWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkbenchMenuBarPresenter>) GWT.create(Producer_factory__o_u_c_w_w_m_WorkbenchMenuBarPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ToolBar>) GWT.create(JsType_factory__o_u_w_m_t_ToolBar__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GAVPreferencesBeanGeneratedImpl>) GWT.create(Type_factory__o_g_c_s_p_p_GAVPreferencesBeanGeneratedImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NavTreeDragComponent>) GWT.create(Type_factory__o_d_c_n_l_e_NavTreeDragComponent__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<IncludedKnowledgeBasesListPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_k_i_KnowledgeBaseItemPresenter_IncludedKnowledgeBasesListPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ActiveContextItems>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_ActiveContextItems__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SSHKeyEditor>) GWT.create(Type_factory__o_u_s_c_e_c_k_k_SSHKeyEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AuditTableItem>) GWT.create(Type_factory__o_d_w_s_t_c_p_a_AuditTableItem__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewGuidedDecisionTableWizardHelper>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_NewGuidedDecisionTableWizardHelper__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FooterPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_f_FooterPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SplashScreenMenuView>) GWT.create(Type_factory__o_u_c_v_p_m_SplashScreenMenuView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LibraryPerspectiveActivity>) GWT.create(Type_factory__o_k_w_c_s_l_c_p_LibraryPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DestructionImpl>) GWT.create(Type_factory__o_j_e_i_c_l_i_DestructionImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DRLEditorViewImpl>) GWT.create(Type_factory__o_d_w_s_d_c_e_DRLEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<JPADomainScreen>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_j_JPADomainScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HTMLHeadingElement>) GWT.create(ExtensionProvided_factory__e_d_HTMLHeadingElement__quals__j_e_i_Any_j_e_i_Default_j_i_Named_1.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HtmlEditorView>) GWT.create(Type_factory__o_u_e_e_c_c_h_HtmlEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CompassDropController>) GWT.create(Type_factory__o_u_c_w_w_d_CompassDropController__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ConstructionHeuristicFormViewImpl>) GWT.create(Type_factory__o_o_w_s_s_c_e_ConstructionHeuristicFormViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetPanel>) GWT.create(Type_factory__o_d_c_w_d_e_DataSetPanel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SelectorLabelSetDisplayerView>) GWT.create(Type_factory__o_d_r_c_s_SelectorLabelSetDisplayerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkspaceProjectContext>) GWT.create(Type_factory__o_g_c_s_p_c_c_WorkspaceProjectContext__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PreferencesCentralNavBarScreen>) GWT.create(Type_factory__o_u_e_p_c_c_PreferencesCentralNavBarScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<OperatorPage>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_OperatorPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ServerContainerEmptyPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_c_e_ServerContainerEmptyPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserGroupsExplorerView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_UserGroupsExplorerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AppLauncherPresenter>) GWT.create(Type_factory__o_k_w_c_w_c_p_l_AppLauncherPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<LibraryPlaces>) GWT.create(Type_factory__o_k_w_c_s_l_c_u_LibraryPlaces__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BeanDataSetDefAttributesEditor>) GWT.create(Type_factory__o_d_c_w_d_e_b_BeanDataSetDefAttributesEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GlobalResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_g_t_GlobalResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UsersList>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_l_UsersList__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ConditionPatternCell>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_c_ConditionPatternCell__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ChildContextMenuItemView>) GWT.create(Type_factory__o_u_c_v_p_m_m_c_ChildContextMenuItemView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AboutPopup>) GWT.create(Type_factory__o_k_w_c_w_c_p_a_AboutPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BindingTextBox>) GWT.create(ExtensionProvided_factory__o_k_w_c_w_c_w_BindingTextBox__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ClientRequiredRolesExtractorImpl>) GWT.create(Type_factory__o_j_e_s_c_l_r_ClientRequiredRolesExtractorImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnFilterEditor>) GWT.create(Type_factory__o_d_d_c_w_f_ColumnFilterEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BeanDataSetBasicAttributesWorkflow>) GWT.create(Type_factory__o_d_c_w_d_e_w_c_BeanDataSetBasicAttributesWorkflow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AddProjectPopUpPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_p_AddProjectPopUpPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ValueFormatterRegistry>) GWT.create(Type_factory__o_d_d_c_f_ValueFormatterRegistry__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DependencySelectorPopupViewImpl>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_d_DependencySelectorPopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<IceServersFieldType>) GWT.create(JsType_factory__e_d_RTCConfigurationInterface_IceServersFieldType__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProjectBranchBreadcrumbView>) GWT.create(Type_factory__o_k_w_c_s_l_c_u_b_ProjectBranchBreadcrumbView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LibraryScreenActivity>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_LibraryScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BRLConditionColumnDefinitionBuilder>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_d_BRLConditionColumnDefinitionBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<MenuItemFactory>) GWT.create(Type_factory__o_u_e_w_c_c_m_MenuItemFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CellContextMenuViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_m_CellContextMenuViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KnowledgeSessionsModalView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_k_i_k_KnowledgeSessionsModalView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefBackendCacheAttributesEditor>) GWT.create(Type_factory__o_d_c_w_d_e_a_DataSetDefBackendCacheAttributesEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DataModelerWorkbenchContext>) GWT.create(Type_factory__o_k_w_c_s_d_c_c_DataModelerWorkbenchContext__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PerspectiveWidgetView>) GWT.create(Type_factory__o_d_c_c_w_PerspectiveWidgetView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RestorePopUpView>) GWT.create(Type_factory__o_u_e_e_c_c_f_p_RestorePopUpView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Command>) GWT.create(JsType_factory__o_u_m_Command__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FileExplorerPresenterActivity>) GWT.create(Type_factory__o_g_s_c_e_f_FileExplorerPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PreferencesEntryPoint>) GWT.create(Type_factory__o_u_e_p_c_PreferencesEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MetaFileEditorPresenterActivity>) GWT.create(Type_factory__o_u_e_w_c_c_e_m_MetaFileEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RendererSelectorTabListView>) GWT.create(Type_factory__o_d_d_c_w_RendererSelectorTabListView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnManagementView>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_c_c_ColumnManagementView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdminPageView>) GWT.create(Type_factory__o_u_e_p_c_a_AdminPageView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExampleProjectView>) GWT.create(Type_factory__o_k_w_c_s_l_c_w_e_ExampleProjectView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerViewer>) GWT.create(Type_factory__o_d_d_c_w_DisplayerViewer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ArtifactListPresenterImpl>) GWT.create(Type_factory__o_g_m_c_w_ArtifactListPresenterImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoriesViewImpl>) GWT.create(Type_factory__o_g_s_c_e_r_l_RepositoriesViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AlertBoxView>) GWT.create(Type_factory__o_d_c_c_w_AlertBoxView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CloseUnsavedProjectAssetsPopUpListItemPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_p_c_CloseUnsavedProjectAssetsPopUpListItemPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ScenarioKSessionSelector>) GWT.create(Type_factory__o_d_w_s_t_c_p_s_ScenarioKSessionSelector__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<MessageConsoleViewImpl>) GWT.create(Type_factory__o_g_m_c_c_MessageConsoleViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PlannerDomainHandler>) GWT.create(Type_factory__o_o_w_s_d_c_h_p_PlannerDomainHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DefaultRenderer>) GWT.create(Type_factory__o_d_r_c_DefaultRenderer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DiscussionWidgetViewImpl>) GWT.create(Type_factory__o_k_w_c_w_c_d_DiscussionWidgetViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<TestScenarioEditorEntryPoint>) GWT.create(Type_factory__o_d_w_s_t_c_TestScenarioEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ResetPerspectivesMenuBuilder>) GWT.create(Type_factory__o_k_w_c_w_c_m_ResetPerspectivesMenuBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnsPagePresenter>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_p_ColumnsPagePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<org.uberfire.client.workbench.widgets.notfound.ActivityNotFoundPresenter>) GWT.create(Type_factory__o_u_c_w_w_n_ActivityNotFoundPresenter__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewPerspectivePopUpView>) GWT.create(Type_factory__o_d_c_c_w_NewPerspectivePopUpView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionSetFieldColumnSynchronizer>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ActionSetFieldColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DependencySelectorPopup>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_d_DependencySelectorPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EnumEditorPresenter>) GWT.create(Type_factory__o_d_w_s_e_c_e_EnumEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewServerTemplateWizard>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_NewServerTemplateWizard__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<JPADomainEditor>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_j_JPADomainEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<MultiConstraintBendableLongMatchRuleModellerActionPlugin>) GWT.create(Type_factory__o_o_w_s_g_c_p_MultiConstraintBendableLongMatchRuleModellerActionPlugin__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdvancedDomainScreenActivity>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDomainScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerTypeSelectorView>) GWT.create(Type_factory__o_d_d_c_w_DisplayerTypeSelectorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ClosableSimpleWorkbenchPanelPresenter>) GWT.create(Type_factory__o_u_c_w_p_i_ClosableSimpleWorkbenchPanelPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataModelerScreenViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_DataModelerScreenViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HTMLDivElement>) GWT.create(ExtensionProvided_factory__e_d_HTMLDivElement__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<RoleStyleBindingProvider>) GWT.create(Type_factory__o_j_e_s_c_l_s_RoleStyleBindingProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ACLSettingsView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_ACLSettingsView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<UberfireBreadcrumbsContainerImpl>) GWT.create(Type_factory__o_u_e_w_c_c_b_h_UberfireBreadcrumbsContainerImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<LibraryPerspective>) GWT.create(Type_factory__o_k_w_c_s_l_c_p_LibraryPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NavTreeWidgetView>) GWT.create(Type_factory__o_d_c_n_w_NavTreeWidgetView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<EnumResourceType>) GWT.create(Type_factory__o_d_w_s_e_c_t_EnumResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JsTypeProvider>) GWT.create(JsType_factory__o_j_e_i_c_c_JsTypeProvider__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SimpleDnDWorkbenchPanelView>) GWT.create(Type_factory__o_u_c_w_p_i_SimpleDnDWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BeanDataSetEditWorkflow>) GWT.create(Type_factory__o_d_c_w_d_e_w_e_BeanDataSetEditWorkflow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DeploymentScreenPopupViewImpl>) GWT.create(Type_factory__o_k_w_c_s_p_c_e_DeploymentScreenPopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LiveSearchFooter>) GWT.create(Type_factory__o_u_e_w_c_c_d_f_LiveSearchFooter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SolverEditorEntryPoint>) GWT.create(Type_factory__o_o_w_s_s_c_SolverEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HTMLTextAreaElement>) GWT.create(ExtensionProvided_factory__e_d_HTMLTextAreaElement__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkbenchMenuBarView>) GWT.create(Type_factory__o_u_c_v_p_m_WorkbenchMenuBarView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionColumnSynchronizer>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ActionColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<EventProvider>) GWT.create(Type_factory__o_j_e_e_c_c_EventProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkbenchPreferenceScopeResolutionStrategiesImpl>) GWT.create(Type_factory__o_k_w_c_s_s_p_c_WorkbenchPreferenceScopeResolutionStrategiesImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataModelerScreenPresenterActivity>) GWT.create(Type_factory__o_k_w_c_s_d_c_DataModelerScreenPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PlannerDataObjectEditor>) GWT.create(Type_factory__o_o_w_s_d_c_w_p_PlannerDataObjectEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<LayoutComponentPalettePresenter>) GWT.create(Type_factory__o_u_e_l_e_c_w_LayoutComponentPalettePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DSLEditorPresenterActivity>) GWT.create(Type_factory__o_d_w_s_d_c_e_DSLEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTreeEditorPresenterActivity>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_GuidedDecisionTreeEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PackageNameWhiteListResourceType>) GWT.create(Type_factory__o_k_w_c_s_d_c_e_PackageNameWhiteListResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultipleTextParameterEditorView>) GWT.create(Type_factory__o_d_d_c_w_f_MultipleTextParameterEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PlaceManagerJSExporter>) GWT.create(Type_factory__o_u_c_e_PlaceManagerJSExporter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SSHKeysDisplayerViewImpl>) GWT.create(Type_factory__o_u_s_c_e_c_k_SSHKeysDisplayerViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RowSynchronizer>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_RowSynchronizer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RoleEditorView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_r_RoleEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PerspectiveEditorCoreGroupProvider>) GWT.create(Type_factory__o_u_e_p_c_p_e_a_PerspectiveEditorCoreGroupProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Heading>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_Heading__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTableEditorPresenterActivity>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_GuidedDecisionTableEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkItemHandlersListPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_k_i_k_KnowledgeSessionListItemPresenter_WorkItemHandlersListPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ListenerListItemView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_k_i_k_l_ListenerListItemView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserEditor>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_u_UserEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedRuleDSLRResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_g_r_t_GuidedRuleDSLRResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AssetListView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_AssetListView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TagSelectorViewImpl>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_t_TagSelectorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTableModellerContextMenuSupport>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_GuidedDecisionTableModellerContextMenuSupport__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionsScreen>) GWT.create(Type_factory__o_u_e_w_c_c_a_ActionsScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PopulatedAssetsView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_a_PopulatedAssetsView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GroupMenuItemView>) GWT.create(Type_factory__o_u_c_v_p_m_m_m_GroupMenuItemView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LibraryPreferencesBeanGeneratedImpl>) GWT.create(Type_factory__o_k_w_c_s_l_a_p_LibraryPreferencesBeanGeneratedImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnListEditorView>) GWT.create(Type_factory__o_d_c_w_d_e_c_ColumnListEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ValidationItemView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_v_ValidationItemView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SplashEditorPresenter>) GWT.create(Type_factory__o_u_e_p_c_e_SplashEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DSLResourceType>) GWT.create(Type_factory__o_d_w_s_d_c_t_DSLResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ClosableSimpleWorkbenchPanelView>) GWT.create(Type_factory__o_u_c_w_p_i_ClosableSimpleWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ValidationPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_v_ValidationPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionInsertFactColumnSynchronizer>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ActionInsertFactColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<OrganizationalUnitsScreenActivity>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_o_OrganizationalUnitsScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.uberfire.ext.security.management.client.widgets.popup.LoadingBox>) GWT.create(Type_factory__o_u_e_s_m_c_w_p_LoadingBox__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GoogleMapDisplayerView>) GWT.create(Type_factory__o_d_r_g_c_GoogleMapDisplayerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PatternToDeletePageView>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_PatternToDeletePageView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PluginHandler>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_PluginHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkbenchConfigurationViewImpl>) GWT.create(Type_factory__o_k_w_c_w_c_h_w_c_WorkbenchConfigurationViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PreferenceStore>) GWT.create(ContextualProvider_factory__o_u_p_c_s_PreferenceStore__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DynamicMenuEditorPresenterActivity>) GWT.create(Type_factory__o_u_e_p_c_e_DynamicMenuEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SocialEntryPoint>) GWT.create(Type_factory__o_e_u_s_a_c_SocialEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewJavaFileTextHandler>) GWT.create(Type_factory__o_k_w_c_s_d_c_h_NewJavaFileTextHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DependenciesItemView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_d_DependenciesItemView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedDTableGraphResourceType>) GWT.create(Type_factory__o_d_w_s_g_d_c_t_GuidedDTableGraphResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HTMLOListElement>) GWT.create(ExtensionProvided_factory__e_d_HTMLOListElement__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CellContextMenu>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_m_CellContextMenu__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PatternPage>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_PatternPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProjectItemViewImpl>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_p_p_ProjectItemViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ElasticSearchDataSetBasicAttributesWorkflow>) GWT.create(Type_factory__o_d_c_w_d_e_w_c_ElasticSearchDataSetBasicAttributesWorkflow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ImportsPage>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_ImportsPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdminPageItemPresenter>) GWT.create(Type_factory__o_u_e_p_c_a_i_AdminPageItemPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ConditionCell>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_c_ConditionCell__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedRuleDSLRResourceType>) GWT.create(Type_factory__o_d_w_s_g_r_c_t_GuidedRuleDSLRResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Activity>) GWT.create(JsType_factory__o_u_c_m_Activity__quals__Universal.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PlannerDomainEditor>) GWT.create(Type_factory__o_o_w_s_d_c_w_p_PlannerDomainEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<InsertMenuBuilder>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_m_InsertMenuBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LibraryScreen>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_LibraryScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<LocaleSelector>) GWT.create(Type_factory__o_j_e_u_c_w_LocaleSelector__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FactPatternConstraintsPage>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_FactPatternConstraintsPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataObjectFieldPicker>) GWT.create(Type_factory__o_o_w_s_d_c_w_p_DataObjectFieldPicker__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewDecisionTableXLSHandler>) GWT.create(Type_factory__o_d_w_s_d_c_h_NewDecisionTableXLSHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedRuleEditorEntryPoint>) GWT.create(Type_factory__o_d_w_s_g_r_c_GuidedRuleEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CreationImpl>) GWT.create(Type_factory__o_j_e_i_c_l_i_CreationImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<POMWizardPageViewImpl>) GWT.create(Type_factory__o_k_w_c_s_p_c_w_POMWizardPageViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionInsertFactColumnConverter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_ActionInsertFactColumnConverter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DefaultPreferenceScopeTypes>) GWT.create(Type_factory__o_u_p_s_i_DefaultPreferenceScopeTypes__quals__j_e_i_Any_o_u_a_FallbackImplementation.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContextDefinition>) GWT.create(JsType_factory__o_u_w_m_ContextDefinition__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DroolsDomainScreenViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_d_DroolsDomainScreenViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedRuleEditorPresenterActivity>) GWT.create(Type_factory__o_d_w_s_g_r_c_e_GuidedRuleEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HomePresenterActivity>) GWT.create(Type_factory__o_k_w_c_s_h_c_w_h_HomePresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PersistenceUnitPropertyGrid>) GWT.create(Type_factory__o_k_w_c_s_d_c_p_PersistenceUnitPropertyGrid__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LayoutEditorPluginImpl>) GWT.create(Type_factory__o_u_e_l_e_c_LayoutEditorPluginImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CloneRepositoryViewImpl>) GWT.create(Type_factory__o_g_s_c_e_r_c_CloneRepositoryViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SplashViewImpl>) GWT.create(Type_factory__o_u_c_v_p_s_SplashViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AnnotationValuePairListItemViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_a_i_AnnotationValuePairListItemViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PerspectiveActivity>) GWT.create(JsType_factory__o_u_c_m_PerspectiveActivity__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExperimentalFeaturesGroup>) GWT.create(Type_factory__o_u_e_c_e_g_ExperimentalFeaturesGroup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkbenchLayoutImpl>) GWT.create(Type_factory__o_u_c_w_WorkbenchLayoutImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DecoratedGridEntryPoint>) GWT.create(Type_factory__o_k_w_c_w_d_c_DecoratedGridEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TagSelector>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_t_TagSelector__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefExplorerScreenActivity>) GWT.create(Type_factory__o_d_d_e_c_s_DataSetDefExplorerScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PackageListBox>) GWT.create(Type_factory__o_k_w_c_w_c_h_PackageListBox__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ValidationView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_v_ValidationView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedDecisionTreeStencilPaletteBuilder>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_p_GuidedDecisionTreeStencilPaletteBuilder__quals__j_e_i_Any_o_d_w_s_g_d_c_w_p_GuidedDecisionTree.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Item>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_u_d_KieDropdownElementView_Item__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DataSetPrototypes>) GWT.create(Type_factory__o_d_d_c_p_DataSetPrototypes__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DefaultHtmlValidator>) GWT.create(Type_factory__o_d_d_c_w_s_DefaultHtmlValidator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DependencyLoaderViewImpl>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_d_DependencyLoaderViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SavePopUpPresenter>) GWT.create(Type_factory__o_u_e_e_c_c_f_p_SavePopUpPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ChildMenuItemView>) GWT.create(Type_factory__o_u_c_v_p_m_m_m_ChildMenuItemView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContainerCardPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_c_s_c_ContainerCardPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DefaultMenuGroup>) GWT.create(JsType_factory__o_u_w_m_m_i_DefaultMenuGroup__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultiScreenPartWidget>) GWT.create(Type_factory__o_u_c_v_p_m_MultiScreenPartWidget__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<LifecycleListenerRegistrarImpl>) GWT.create(Type_factory__o_j_e_i_c_l_i_LifecycleListenerRegistrarImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AddAssetScreenActivity>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_a_a_AddAssetScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RenamePopUpView>) GWT.create(Type_factory__o_u_e_e_c_c_f_p_RenamePopUpView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExperimentalFeaturesEditorScreenViewImpl>) GWT.create(Type_factory__o_u_e_c_e_ExperimentalFeaturesEditorScreenViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetGroupDateEditorView>) GWT.create(Type_factory__o_d_d_c_w_g_DataSetGroupDateEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerSubtypeSelectorView>) GWT.create(Type_factory__o_d_d_c_w_DisplayerSubtypeSelectorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DefaultPreferenceFormView>) GWT.create(Type_factory__o_u_e_p_c_c_f_DefaultPreferenceFormView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GridWidgetCellFactoryImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_GridWidgetCellFactoryImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EntitiesExplorerViewImpl>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_EntitiesExplorerViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PropertiesListPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_p_PersistencePresenter_PropertiesListPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.jboss.errai.common.client.dom.HTMLElement>) GWT.create(ContextualProvider_factory__o_j_e_c_c_d_HTMLElement__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DefaultBreadcrumbsView>) GWT.create(Type_factory__o_u_e_w_c_c_b_w_DefaultBreadcrumbsView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PreferencesCentralPerspectiveActivity>) GWT.create(Type_factory__o_u_e_p_c_c_PreferencesCentralPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MainDataObjectEditorViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_m_MainDataObjectEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AppsEntryPoint>) GWT.create(Type_factory__o_u_e_a_c_AppsEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoryEditorPresenterActivity>) GWT.create(Type_factory__o_g_s_c_e_r_e_RepositoryEditorPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ArtifactListWidgetPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_a_ArtifactListWidgetPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RenameProjectPopUpView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_p_r_RenameProjectPopUpView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ClientSettings>) GWT.create(Type_factory__o_d_d_c_ClientSettings__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<VersionHistoryPresenter>) GWT.create(Type_factory__o_u_e_e_c_c_h_VersionHistoryPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PortablePreferenceMockBeanGeneratedImpl>) GWT.create(Type_factory__o_u_p_s_b_m_PortablePreferenceMockBeanGeneratedImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetEditorView>) GWT.create(Type_factory__o_d_c_w_d_e_DataSetEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<JavaFileNameValidator>) GWT.create(Type_factory__o_k_w_c_w_m_c_v_JavaFileNameValidator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataModellerDocksHandler>) GWT.create(Type_factory__o_k_w_c_w_c_d_i_DataModellerDocksHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ConditionColumnConverter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_ConditionColumnConverter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DefaultJsEvaluator>) GWT.create(Type_factory__o_d_d_c_w_s_DefaultJsEvaluator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.uberfire.client.views.pfly.modal.ErrorPopupView>) GWT.create(Type_factory__o_u_c_v_p_m_ErrorPopupView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<Classifier>) GWT.create(Type_factory__o_k_w_c_s_e_c_u_Classifier__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerSubtypeSelector>) GWT.create(Type_factory__o_d_d_c_w_DisplayerSubtypeSelector__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RolesExplorer>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_RolesExplorer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DisplayerLocator>) GWT.create(Type_factory__o_d_d_c_DisplayerLocator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<StorageHandlerProvider>) GWT.create(Type_factory__o_j_e_s_c_l_s_StorageHandlerProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LikeToFunctionEditorView>) GWT.create(Type_factory__o_d_d_c_w_f_LikeToFunctionEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AnyResourceType>) GWT.create(Type_factory__o_u_c_w_t_AnyResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NotificationManager>) GWT.create(Type_factory__o_u_c_w_w_n_NotificationManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdminPageCategoryView>) GWT.create(Type_factory__o_u_e_p_c_a_c_AdminPageCategoryView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<StencilLayerBuilder>) GWT.create(Type_factory__o_u_e_w_c_c_l_StencilLayerBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DefaultBreadcrumbsPresenter>) GWT.create(Type_factory__o_u_e_w_c_c_b_w_DefaultBreadcrumbsPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RestoreVersionCommandProvider>) GWT.create(Type_factory__o_u_e_e_c_c_m_RestoreVersionCommandProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GoogleMapDisplayer>) GWT.create(Type_factory__o_d_r_g_c_GoogleMapDisplayer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DefaultWorkbenchFeaturesMenusHelper>) GWT.create(Type_factory__o_k_w_c_w_c_m_DefaultWorkbenchFeaturesMenusHelper__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PlannerDomainScreen>) GWT.create(Type_factory__o_o_w_s_d_c_w_p_PlannerDomainScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultiplePermissionNodeViewer>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_n_MultiplePermissionNodeViewer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LayoutEditorPresenter>) GWT.create(Type_factory__o_u_e_l_e_c_LayoutEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ToggleCommentPresenter>) GWT.create(Type_factory__o_u_e_e_c_c_f_p_c_ToggleCommentPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TestRunnerReportingViewImpl>) GWT.create(Type_factory__o_k_w_c_w_c_t_TestRunnerReportingViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnListEditor>) GWT.create(Type_factory__o_d_c_w_d_e_c_ColumnListEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerHtmlEditorView>) GWT.create(Type_factory__o_d_d_c_w_DisplayerHtmlEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<OrgUnitsMetricsFactory>) GWT.create(Type_factory__o_k_w_c_s_l_c_u_OrgUnitsMetricsFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionRetractFactCol52DefinitionBuilder>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_d_ActionRetractFactCol52DefinitionBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PerspectiveEditorNavGroupProvider>) GWT.create(Type_factory__o_u_e_p_c_p_e_a_PerspectiveEditorNavGroupProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DotResourceType>) GWT.create(Type_factory__o_u_c_w_t_DotResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PersistableDataObjectsItemView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_p_p_PersistableDataObjectsItemView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TextBoxFormPopup>) GWT.create(Type_factory__o_k_w_c_w_c_p_t_TextBoxFormPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HTMLAnchorElement>) GWT.create(ExtensionProvided_factory__e_d_HTMLAnchorElement__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewTestScenarioHandler>) GWT.create(Type_factory__o_d_w_s_t_c_h_NewTestScenarioHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AggregateFunctionManagerImpl>) GWT.create(Type_factory__o_d_d_e_f_AggregateFunctionManagerImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserStorageHandler>) GWT.create(Provider_factory__o_j_e_s_c_l_s_UserStorageHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PerspectivesExplorer>) GWT.create(Type_factory__o_d_c_c_w_PerspectivesExplorer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PlannerDomainScreenViewImpl>) GWT.create(Type_factory__o_o_w_s_d_c_w_p_PlannerDomainScreenViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ManagedInstance>) GWT.create(ContextualProvider_factory__o_j_e_i_c_a_ManagedInstance__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.uberfire.ext.security.management.client.widgets.popup.LoadingBoxView>) GWT.create(Type_factory__o_u_e_s_m_c_w_p_LoadingBoxView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Menus>) GWT.create(JsType_factory__o_u_w_m_m_Menus__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionSetFieldColumnConverter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_ActionSetFieldColumnConverter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JSNativePerspective>) GWT.create(Type_factory__o_u_c_p_JSNativePerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PreferenceScopeValidatorImpl>) GWT.create(Type_factory__o_u_p_s_i_PreferenceScopeValidatorImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTableGraphEditorPresenterActivity>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_GuidedDecisionTableGraphEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoriesPresenterActivity>) GWT.create(Type_factory__o_g_s_c_e_r_l_RepositoriesPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PermissionSwitch>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_n_PermissionSwitch__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserAssignedGroupsEditor>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_u_UserAssignedGroupsEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefRefreshIntervalEditor>) GWT.create(Type_factory__o_d_c_w_d_e_a_DataSetDefRefreshIntervalEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTreeEditorViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_GuidedDecisionTreeEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PreferenceScopeResolutionStrategy>) GWT.create(ContextualProvider_factory__o_u_p_s_PreferenceScopeResolutionStrategy__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DeletePopUpView>) GWT.create(Type_factory__o_u_e_e_c_c_f_p_DeletePopUpView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DropDownMenu>) GWT.create(ExtensionProvided_factory__o_g_c_u_DropDownMenu__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContainerRemoteStatusView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_c_s_ContainerRemoteStatusView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ExperimentalAwareClientTypeRegistryImpl>) GWT.create(Type_factory__o_u_e_c_w_t_ExperimentalAwareClientTypeRegistryImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefBasicAttributesEditorView>) GWT.create(Type_factory__o_d_c_w_d_e_a_DataSetDefBasicAttributesEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TextParameterEditorView>) GWT.create(Type_factory__o_d_d_c_w_f_TextParameterEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewWorkspaceProjectWizard>) GWT.create(Type_factory__o_k_w_c_s_p_c_w_NewWorkspaceProjectWizard__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SimpleConstraintMatchRuleModellerActionPlugin>) GWT.create(Type_factory__o_o_w_s_g_c_p_SimpleConstraintMatchRuleModellerActionPlugin__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTableGraphEditorPresenter>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_GuidedDecisionTableGraphEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewDependencyPopup>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_d_NewDependencyPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JSNativeScreen>) GWT.create(Type_factory__o_u_c_s_JSNativeScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ServerManagementBrowserView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_ServerManagementBrowserView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ShortcutSubHeadingTextPresenter>) GWT.create(Type_factory__o_k_w_c_s_h_c_w_s_s_ShortcutSubHeadingTextPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PreferencesRootView>) GWT.create(Type_factory__o_u_e_p_c_c_s_PreferencesRootView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataBinder>) GWT.create(ContextualProvider_factory__o_j_e_d_c_a_DataBinder__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewTabFilterPopup>) GWT.create(Type_factory__o_u_e_w_c_c_t_p_NewTabFilterPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AuditPage>) GWT.create(Type_factory__o_d_w_s_t_c_p_a_AuditPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HTMLTableSectionElement>) GWT.create(ExtensionProvided_factory__e_d_HTMLTableSectionElement__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedScoreCardResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_g_s_t_GuidedScoreCardResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionWorkItemInsertFactColumnConverter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_ActionWorkItemInsertFactColumnConverter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoryItemViewImpl>) GWT.create(Type_factory__o_g_s_c_e_r_l_RepositoryItemViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedRuleEditorPresenter>) GWT.create(Type_factory__o_d_w_s_g_r_c_e_GuidedRuleEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AssetsActionsView>) GWT.create(Type_factory__o_k_w_c_s_l_c_w_p_AssetsActionsView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkbenchMenuBarProducer>) GWT.create(Type_factory__o_u_c_w_w_m_WorkbenchMenuBarProducer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DynamicMenuEditorPresenter>) GWT.create(Type_factory__o_u_e_p_c_e_DynamicMenuEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AnalysisReportScreenViewImpl>) GWT.create(Type_factory__o_k_w_c_s_v_r_c_p_AnalysisReportScreenViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AddProjectButtonPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_w_l_AddProjectButtonPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewSolverHandler>) GWT.create(Type_factory__o_o_w_s_s_c_h_NewSolverHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkItemDefinitionElementsBrowser>) GWT.create(Type_factory__o_d_w_s_w_c_w_WorkItemDefinitionElementsBrowser__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerEditorPopup>) GWT.create(Type_factory__o_d_d_c_w_DisplayerEditorPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<RootPanelProvider>) GWT.create(Type_factory__o_j_e_i_c_a_b_RootPanelProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdvancedDataObjectFieldEditorViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDataObjectFieldEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DataModelerEntryPoint>) GWT.create(Type_factory__o_k_w_c_s_d_c_DataModelerEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EnumEditorPresenterActivity>) GWT.create(Type_factory__o_d_w_s_e_c_e_EnumEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NavigationGraph>) GWT.create(Producer_factory__o_j_e_u_n_c_l_s_NavigationGraph__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DependenciesView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_d_DependenciesView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTreePalette>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_p_GuidedDecisionTreePalette__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContainerPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_c_ContainerPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TextEditorWorkbenchEditorActivity>) GWT.create(Type_factory__o_u_e_w_c_c_e_t_TextEditorWorkbenchEditorActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ScreenEditorPresenterActivity>) GWT.create(Type_factory__o_u_e_p_c_e_ScreenEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TagItemViewImpl>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_p_p_TagItemViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionSetFieldsPage>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_ActionSetFieldsPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MetaFileEditorPresenter>) GWT.create(Type_factory__o_u_e_w_c_c_e_m_MetaFileEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<org.optaplanner.workbench.screens.guidedrule.client.GuidedRuleEditorEntryPoint>) GWT.create(Type_factory__o_o_w_s_g_c_GuidedRuleEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DateParameterEditor>) GWT.create(Type_factory__o_d_d_c_w_f_DateParameterEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ProjectNameValidator>) GWT.create(Type_factory__o_k_w_c_s_p_c_v_ProjectNameValidator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PerspectiveEditorPaletteI18nImpl>) GWT.create(Type_factory__o_u_e_p_c_r_i_PerspectiveEditorPaletteI18nImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ImportExamplesProjectsScreen>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_ImportExamplesProjectsScreen__quals__j_e_i_Any_j_e_i_Default.class));
  }

  private void registerFactories3(final Context org_jboss_errai_ioc_client_container_ApplicationScopedContext_context, final Context org_jboss_errai_ioc_client_container_DependentScopeContext_context) {
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<URLPatternMatcherProvider>) GWT.create(Type_factory__o_j_e_u_n_c_l_URLPatternMatcherProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PerspectivePluginManager>) GWT.create(Type_factory__o_d_c_n_p_PerspectivePluginManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SectionManager>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_u_s_SectionManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PlannerValidationMessageTranslator>) GWT.create(Type_factory__o_o_w_s_d_c_v_PlannerValidationMessageTranslator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerCoordinator>) GWT.create(Type_factory__o_d_d_c_DisplayerCoordinator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ValidationMessageTranslatorUtils>) GWT.create(Type_factory__o_k_w_c_w_c_p_v_ValidationMessageTranslatorUtils__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TextParameterEditor>) GWT.create(Type_factory__o_d_d_c_w_f_TextParameterEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ShapesGroup>) GWT.create(Type_factory__o_u_e_w_c_c_p_ShapesGroup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProcessConfigPagePresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_p_ProcessConfigPagePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<TestScenarioResourceType>) GWT.create(Type_factory__o_d_w_s_t_c_t_TestScenarioResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PathUrlFactory>) GWT.create(Type_factory__o_d_c_c_b_PathUrlFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionWorkItemExecuteColumnConverter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_ActionWorkItemExecuteColumnConverter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MetricView>) GWT.create(Type_factory__o_d_r_c_m_MetricView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NavItemTileWidget>) GWT.create(Type_factory__o_d_c_n_w_NavItemTileWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<RuntimePluginStartup>) GWT.create(Type_factory__o_u_e_p_c_p_RuntimePluginStartup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RadarMenuBuilder>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_m_RadarMenuBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PluginController>) GWT.create(Type_factory__o_u_e_p_c_s_PluginController__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RoleEditorWorkflow>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_r_w_RoleEditorWorkflow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ServerManagementBrowserPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_ServerManagementBrowserPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoryItemPresenter>) GWT.create(Type_factory__o_g_s_c_e_r_l_RepositoryItemPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContextDisplayMode>) GWT.create(JsType_factory__o_u_w_m_ContextDisplayMode__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NavCarouselDragComponent>) GWT.create(Type_factory__o_d_c_n_l_e_NavCarouselDragComponent__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ScenarioWidgetComponentCreator>) GWT.create(Type_factory__o_d_w_s_t_c_ScenarioWidgetComponentCreator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DSLRResourceType>) GWT.create(Type_factory__o_d_w_s_d_c_t_DSLRResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkbenchLayoutInfoImpl>) GWT.create(Type_factory__o_u_c_w_WorkbenchLayoutInfoImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewFileUploader>) GWT.create(Type_factory__o_k_w_c_s_d_c_e_NewFileUploader__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionRetractFactPlugin>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_ActionRetractFactPlugin__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WiresTreesDefaultLayout>) GWT.create(Type_factory__o_u_e_w_c_t_c_l_WiresTreesDefaultLayout__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PerspectiveDefinition>) GWT.create(JsType_factory__o_u_w_m_PerspectiveDefinition__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionInsertFactFieldsPageViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_ActionInsertFactFieldsPageViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<InfoTitlePresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_t_InfoTitlePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ACLViewerView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_ACLViewerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CSVDataSetEditWorkflow>) GWT.create(Type_factory__o_d_c_w_d_e_w_e_CSVDataSetEditWorkflow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ServerTemplateProvider>) GWT.create(Type_factory__o_j_e_u_s_ServerTemplateProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.gwtbootstrap3.client.ui.Button>) GWT.create(ExtensionProvided_factory__o_g_c_u_Button__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HTMLSelectElement>) GWT.create(ExtensionProvided_factory__e_d_HTMLSelectElement__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GlobalResourceType>) GWT.create(Type_factory__o_d_w_s_g_c_t_GlobalResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CSVDataSetDefAttributesDriver>) GWT.create(Producer_factory__o_d_c_w_d_e_d_CSVDataSetDefAttributesDriver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PlaceManagerImpl>) GWT.create(Type_factory__o_u_c_m_PlaceManagerImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<CustomSplashHelp>) GWT.create(Type_factory__o_u_c_m_CustomSplashHelp__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LeafPermissionNodeEditorView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_n_LeafPermissionNodeEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CloneRepositoryPresenter>) GWT.create(Type_factory__o_g_s_c_e_r_c_CloneRepositoryPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkbenchConfigurationPresenter>) GWT.create(Type_factory__o_k_w_c_w_c_h_w_c_WorkbenchConfigurationPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WiresTreesScreen>) GWT.create(Type_factory__o_u_e_w_c_t_c_c_WiresTreesScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataObjectFieldPickerItemLabelViewImpl>) GWT.create(Type_factory__o_o_w_s_d_c_w_p_DataObjectFieldPickerItemLabelViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DefaultAuthorizationManager>) GWT.create(Type_factory__o_u_s_i_a_DefaultAuthorizationManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SSHKeysDisplayer>) GWT.create(Type_factory__o_u_s_c_e_c_k_SSHKeysDisplayer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PlugInAuthoringPerspectiveActivity>) GWT.create(Type_factory__o_u_e_p_c_p_PlugInAuthoringPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkItemsEditorEntryPoint>) GWT.create(Type_factory__o_d_w_s_w_c_WorkItemsEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KnowledgeSessionListItemPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_k_i_k_KnowledgeSessionListItemPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkItemsResourceType>) GWT.create(Type_factory__o_d_w_s_w_c_t_WorkItemsResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PatternPageView>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_PatternPageView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SelectView>) GWT.create(Type_factory__o_u_e_w_c_c_s_SelectView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProjectScreenActivity>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_p_ProjectScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ScreenEditorPresenter>) GWT.create(Type_factory__o_u_e_p_c_e_ScreenEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContributorsManagementPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_o_c_w_ContributorsManagementPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BRLConditionVariableColumnConverter>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_BRLConditionVariableColumnConverter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ViewDRLSourceWidget>) GWT.create(ExtensionProvided_factory__o_k_w_c_w_c_s_ViewDRLSourceWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GlobalsEditorPresenter>) GWT.create(Type_factory__o_d_w_s_g_c_e_GlobalsEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AlertPanel>) GWT.create(Type_factory__o_d_c_c_w_AlertPanel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionWorkItemPlugin>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_ActionWorkItemPlugin__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkbenchActivity>) GWT.create(JsType_factory__o_u_c_m_WorkbenchActivity__quals__Universal.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<TransitionAnchorFactoryProvider>) GWT.create(Type_factory__o_j_e_u_n_c_l_TransitionAnchorFactoryProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CreateEntity>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_CreateEntity__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ChangePassword>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_ChangePassword__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkbenchTreeProvider>) GWT.create(Type_factory__o_k_w_c_w_c_a_WorkbenchTreeProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<MessageConsoleService>) GWT.create(Type_factory__o_g_m_c_c_MessageConsoleService__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ListGroup>) GWT.create(ExtensionProvided_factory__o_g_c_u_ListGroup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkbenchViewModeSwitcherMenuBuilder>) GWT.create(Type_factory__o_u_c_m_WorkbenchViewModeSwitcherMenuBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedDecisionTableLockManagerImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_l_GuidedDecisionTableLockManagerImpl__quals__j_e_i_Any_o_d_w_s_g_d_c_GuidedDecisionTable.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UnanchoredStaticWorkbenchPanelView>) GWT.create(Type_factory__o_u_c_w_p_i_UnanchoredStaticWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DnDManager>) GWT.create(Type_factory__o_u_e_l_e_c_i_DnDManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RemoteStatusView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_r_RemoteStatusView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HomePresenter>) GWT.create(Type_factory__o_k_w_c_s_h_c_w_h_HomePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PropertiesScreen>) GWT.create(Type_factory__o_u_e_w_c_c_p_PropertiesScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserAttributesEditor>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_u_UserAttributesEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SequenceGeneratorField>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_j_p_SequenceGeneratorField__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HTMLLIElement>) GWT.create(ExtensionProvided_factory__e_d_HTMLLIElement__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SQLDataSetEditWorkflow>) GWT.create(Type_factory__o_d_c_w_d_e_w_e_SQLDataSetEditWorkflow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<HelpCustomMenuBuilder>) GWT.create(Type_factory__o_k_w_c_w_c_m_c_HelpCustomMenuBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<InlineNotification>) GWT.create(Type_factory__o_u_c_v_p_w_InlineNotification__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<Process>) GWT.create(Type_factory__o_g_c_s_p_c_Process__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ScrollIntoViewTopType>) GWT.create(JsType_factory__e_d_Element_ScrollIntoViewTopType__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerEditorView>) GWT.create(Type_factory__o_d_d_c_w_DisplayerEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PomEditor>) GWT.create(Type_factory__o_k_w_c_s_l_c_u_PomEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewSSHKeyModal>) GWT.create(Type_factory__o_u_s_c_e_c_c_NewSSHKeyModal__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AttributeColumnPlugin>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_AttributeColumnPlugin__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SourceCodeEditorView>) GWT.create(Type_factory__o_d_d_c_w_s_SourceCodeEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DataSourceSelectorProducer>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_d_DataSourceSelectorProducer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ExamplesScreenEntryPoint>) GWT.create(Type_factory__o_k_w_c_s_e_c_ExamplesScreenEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ProjectScopedResolutionStrategySupplier>) GWT.create(Type_factory__o_g_c_s_p_c_p_ProjectScopedResolutionStrategySupplier__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserBoxView>) GWT.create(Type_factory__o_e_u_s_a_c_w_u_UserBoxView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DocksBars>) GWT.create(Type_factory__o_u_c_d_v_DocksBars__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DroolsDomainScreen>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_d_DroolsDomainScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<OrderedList>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_OrderedList__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FieldPageView>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_FieldPageView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DisposerProvider>) GWT.create(Type_factory__o_j_e_i_c_a_b_DisposerProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdditionalInfoPage>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_AdditionalInfoPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TerminationTreeItemContent>) GWT.create(Type_factory__o_o_w_s_s_c_e_TerminationTreeItemContent__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RendererSelector>) GWT.create(Type_factory__o_d_d_c_w_RendererSelector__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LayersScreenActivity>) GWT.create(Type_factory__o_u_e_w_c_c_l_LayersScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DynamicMenuResourceTypeDefinition>) GWT.create(Type_factory__o_u_e_p_t_DynamicMenuResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.kie.workbench.common.screens.library.client.settings.util.sections.MenuItem>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_u_s_MenuItem__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KnowledgeSessionListItemView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_k_i_k_KnowledgeSessionListItemView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PdfFileExport>) GWT.create(Producer_factory__o_u_e_e_c_c_f_e_PdfFileExport__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Icon>) GWT.create(ExtensionProvided_factory__o_g_c_u_Icon__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProjectBranchBreadcrumb>) GWT.create(Type_factory__o_k_w_c_s_l_c_u_b_ProjectBranchBreadcrumb__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ClientChronometer>) GWT.create(Type_factory__o_d_d_c_e_ClientChronometer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AttributeColumnSynchronizer>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_AttributeColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AppsHomeView>) GWT.create(Type_factory__o_u_e_a_c_h_AppsHomeView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EmptyDropRow>) GWT.create(Type_factory__o_u_e_l_e_c_c_r_EmptyDropRow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ManagedInstanceProvider>) GWT.create(Type_factory__o_j_e_i_c_a_b_ManagedInstanceProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CSVDataSetBasicAttributesWorkflow>) GWT.create(Type_factory__o_d_c_w_d_e_w_c_CSVDataSetBasicAttributesWorkflow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ActionUpdateNodeFactory>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_f_ActionUpdateNodeFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ProjectEntryPoint>) GWT.create(Type_factory__o_g_c_s_p_c_ProjectEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ConnectorsGroup>) GWT.create(Type_factory__o_u_e_w_c_c_p_ConnectorsGroup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EditHTMLView>) GWT.create(Type_factory__o_u_e_p_c_p_e_l_e_p_EditHTMLView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<List>) GWT.create(JsType_factory__j_u_List__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Image>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_Image__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SQLDataSetDefAttributesEditor>) GWT.create(Type_factory__o_d_c_w_d_e_s_SQLDataSetDefAttributesEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FactPatternsPage>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_FactPatternsPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetSummary>) GWT.create(Type_factory__o_d_c_w_d_e_DataSetSummary__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AuthenticationServiceInterceptor>) GWT.create(Type_factory__o_j_e_s_c_l_i_AuthenticationServiceInterceptor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.drools.workbench.screens.guided.dtable.client.wizard.column.pages.SummaryPage>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_SummaryPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TreeHierarchyStructurePresenter>) GWT.create(Type_factory__o_u_e_p_c_c_t_TreeHierarchyStructurePresenter__quals__j_e_i_Any_o_u_e_p_c_c_t_TreeView.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PreferenceBeanStoreImpl>) GWT.create(Type_factory__o_u_p_c_s_PreferenceBeanStoreImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NavRootNodeEditorView>) GWT.create(Type_factory__o_d_c_n_w_e_NavRootNodeEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ScreenLayoutDragComponent>) GWT.create(Type_factory__o_u_e_p_c_p_e_l_e_ScreenLayoutDragComponent__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HTMLElementProvider>) GWT.create(Type_factory__o_j_e_u_c_l_p_HTMLElementProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PhaseConfigFormViewImpl>) GWT.create(Type_factory__o_o_w_s_s_c_e_PhaseConfigFormViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewGuidedDecisionTableHandler>) GWT.create(Type_factory__o_d_w_s_g_d_c_h_NewGuidedDecisionTableHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NavTabListDragComponent>) GWT.create(Type_factory__o_d_c_n_l_e_NavTabListDragComponent__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RolesList>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_l_RolesList__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DefaultMenus>) GWT.create(JsType_factory__o_u_w_m_m_i_DefaultMenus__quals__Universal.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DefaultFileNameValidator>) GWT.create(Type_factory__o_u_e_e_c_c_v_DefaultFileNameValidator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefProviderTypeDriver>) GWT.create(Producer_factory__o_d_c_w_d_e_d_DataSetDefProviderTypeDriver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GitUrlsPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_g_GitUrlsPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<MenuBuilder>) GWT.create(Type_factory__o_u_c_d_v_m_MenuBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<MultiConstraintHardMediumSoftMatchRuleModellerActionPlugin>) GWT.create(Type_factory__o_o_w_s_g_c_p_MultiConstraintHardMediumSoftMatchRuleModellerActionPlugin__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ProjectMetricsFactory>) GWT.create(Type_factory__o_k_w_c_s_l_c_u_ProjectMetricsFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ViewSourceViewImpl>) GWT.create(Type_factory__o_k_w_c_w_c_s_ViewSourceViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SQLDataSetDefDriver>) GWT.create(Producer_factory__o_d_c_w_d_e_d_SQLDataSetDefDriver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ValuePairEditorPopup>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_v_ValuePairEditorPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<View>) GWT.create(Producer_factory__o_u_e_e_c_c_f_p_CopyPopUpPresenter_View__quals__j_e_i_Any_o_u_e_e_c_c_f_Customizable.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LibraryProjectPreferencesBeanGeneratedImpl>) GWT.create(Type_factory__o_k_w_c_s_l_a_p_LibraryProjectPreferencesBeanGeneratedImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DefaultAdminPageHelper>) GWT.create(Type_factory__o_k_w_c_w_c_a_DefaultAdminPageHelper__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewFilterPopup>) GWT.create(Type_factory__o_u_e_w_c_c_t_p_NewFilterPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DeleteOrganizationalUnitPopUpPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_o_d_DeleteOrganizationalUnitPopUpPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AppNavBar>) GWT.create(Type_factory__o_o_w_c_n_AppNavBar__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ShortcutView>) GWT.create(Type_factory__o_k_w_c_s_h_c_w_s_ShortcutView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SolverResourceTypeDefinition>) GWT.create(Type_factory__o_o_w_s_s_t_SolverResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ImportsPageViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_ImportsPageViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ConfirmBoxView>) GWT.create(Type_factory__o_u_e_s_m_c_w_p_ConfirmBoxView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KnowledgeBaseItemView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_k_i_KnowledgeBaseItemView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GooglePieChartDisplayerView>) GWT.create(Type_factory__o_d_r_g_c_GooglePieChartDisplayerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ListItem>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_ListItem__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DroolsDataObjectFieldEditorViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_d_DroolsDataObjectFieldEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SSHKeysEditorPerspectiveActivity>) GWT.create(Type_factory__o_u_s_c_e_SSHKeysEditorPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DSLResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_d_t_DSLResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<JPADomainScreenActivity>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_j_JPADomainScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SessionInfo>) GWT.create(Producer_factory__o_u_r_SessionInfo__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NoItemsComponentViewImpl>) GWT.create(Type_factory__o_u_e_w_c_c_d_n_NoItemsComponentViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisabledExperimentalLayoutComponent>) GWT.create(Type_factory__o_u_e_l_e_c_i_e_DisabledExperimentalLayoutComponent__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PaletteScreen>) GWT.create(Type_factory__o_u_e_w_c_c_p_PaletteScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContainerProcessConfigView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_c_c_p_ContainerProcessConfigView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewScoreCardXLSHandler>) GWT.create(Type_factory__o_d_w_s_s_c_h_NewScoreCardXLSHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkbenchPreferenceScopeTypes>) GWT.create(Type_factory__o_k_w_c_s_s_p_c_WorkbenchPreferenceScopeTypes__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SaveAndRenameCommandBuilder>) GWT.create(Type_factory__o_u_e_e_c_c_m_c_SaveAndRenameCommandBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AssetQueryService>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_a_AssetQueryService__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExperimentalFeaturesGroupViewImpl>) GWT.create(Type_factory__o_u_e_c_e_g_ExperimentalFeaturesGroupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LibraryView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_LibraryView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Logger>) GWT.create(ExtensionProvided_factory__o_s_Logger__quals__Universal_11.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Logger>) GWT.create(ExtensionProvided_factory__o_s_Logger__quals__Universal_10.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DefaultPreferenceFormActivity>) GWT.create(Type_factory__o_u_e_p_c_c_f_DefaultPreferenceFormActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AssetItemWidget>) GWT.create(Type_factory__o_k_w_c_s_l_c_w_p_AssetItemWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GlobalsEditorViewImpl>) GWT.create(Type_factory__o_d_w_s_g_c_e_GlobalsEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TagWidgetViewImpl>) GWT.create(Type_factory__o_k_w_c_w_m_c_w_TagWidgetViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ScoreDirectorFactoryForm>) GWT.create(Type_factory__o_o_w_s_s_c_e_ScoreDirectorFactoryForm__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExecutionWidget>) GWT.create(Type_factory__o_d_w_s_t_c_p_s_ExecutionWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExternalPathPlaceRequest>) GWT.create(JsType_factory__o_u_m_i_ExternalPathPlaceRequest__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Logger>) GWT.create(ExtensionProvided_factory__o_s_Logger__quals__Universal_14.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Logger>) GWT.create(ExtensionProvided_factory__o_s_Logger__quals__Universal_13.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Logger>) GWT.create(ExtensionProvided_factory__o_s_Logger__quals__Universal_12.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataColumnDefEditor>) GWT.create(Type_factory__o_d_c_w_d_e_c_DataColumnDefEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdvancedAnnotationListEditorViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_a_AdvancedAnnotationListEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<InstanceProvider>) GWT.create(Type_factory__o_j_e_e_c_c_InstanceProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AlertBox>) GWT.create(Type_factory__o_d_c_c_w_AlertBox__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KSessionSelector>) GWT.create(Type_factory__o_k_w_c_w_c_w_KSessionSelector__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExternalDataObjectsView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_e_ExternalDataObjectsView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MultiScreenWorkbenchPanelView>) GWT.create(Type_factory__o_u_c_w_p_i_MultiScreenWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AttributeColumnConfigRowView>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_c_c_AttributeColumnConfigRowView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RadarMenuViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_m_RadarMenuViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NotificationPopupsManagerView>) GWT.create(Type_factory__o_u_c_v_p_n_NotificationPopupsManagerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CopyPopUpPresenter>) GWT.create(Type_factory__o_u_e_e_c_c_f_p_CopyPopUpPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DateRangePicker>) GWT.create(Type_factory__o_u_c_v_p_w_DateRangePicker__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ViewHideAlertsButtonPresenter>) GWT.create(Type_factory__o_g_m_c_c_w_b_ViewHideAlertsButtonPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ScoreCardXLSEntryPoint>) GWT.create(Type_factory__o_d_w_s_s_c_ScoreCardXLSEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ViewHideAlertsButtonView>) GWT.create(Type_factory__o_g_m_c_c_w_b_ViewHideAlertsButtonView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AddGlobalPopup>) GWT.create(Type_factory__o_d_w_s_g_c_e_AddGlobalPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnFilterEditorView>) GWT.create(Type_factory__o_d_d_c_w_f_ColumnFilterEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DiscussionWidgetPresenter>) GWT.create(Type_factory__o_k_w_c_w_c_d_DiscussionWidgetPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RelatedEventEventInitDictType>) GWT.create(JsType_factory__e_d_RelatedEvent_RelatedEventEventInitDictType__quals__Universal.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ForceUnlockEventObserver>) GWT.create(Type_factory__o_u_c_m_ForceUnlockEventObserver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KnowledgeBaseListPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_k_KnowledgeBasesPresenter_KnowledgeBaseListPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Tree>) GWT.create(ExtensionProvided_factory__c_g_g_u_c_u_Tree__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.kie.workbench.common.screens.server.management.client.remote.card.ContainerCardPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_r_c_ContainerCardPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkItemHandlerListItemPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_k_i_k_w_WorkItemHandlerListItemPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PanelManagerImpl>) GWT.create(Type_factory__o_u_c_w_PanelManagerImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SplashPluginResourceType>) GWT.create(Type_factory__o_u_e_p_c_t_SplashPluginResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContainerCardView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_c_s_c_ContainerCardView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SelectableDocumentImpl>) GWT.create(Type_factory__o_k_w_c_w_m_c_p_SelectableDocumentImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewContainerWizard>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_NewContainerWizard__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewTemplatePresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_t_NewTemplatePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SelectOptionComponent>) GWT.create(Type_factory__o_u_e_w_c_c_s_SelectOptionComponent__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewGuidedRuleHandler>) GWT.create(Type_factory__o_d_w_s_g_r_c_h_NewGuidedRuleHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CheckBox>) GWT.create(ExtensionProvided_factory__o_g_c_u_CheckBox__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PopOverViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_PopOverViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Sender>) GWT.create(ContextualProvider_factory__o_j_e_i_s_b_c_Sender__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PluginNavList>) GWT.create(Type_factory__o_u_e_p_c_w_n_PluginNavList__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RenameProjectPopUpScreen>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_p_r_RenameProjectPopUpScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LayersScreen>) GWT.create(Type_factory__o_u_e_w_c_c_l_LayersScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LeafPermissionNodeEditor>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_n_LeafPermissionNodeEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SourceRepositoryPageViewImpl>) GWT.create(Type_factory__o_k_w_c_s_e_c_w_p_s_SourceRepositoryPageViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DecisionTableXLSEntryPoint>) GWT.create(Type_factory__o_d_w_s_d_c_DecisionTableXLSEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProjectView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_p_ProjectView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ProjectClassList>) GWT.create(Type_factory__o_k_w_c_s_d_c_p_ProjectClassList__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SplashScreenMenuPresenter>) GWT.create(Type_factory__o_u_c_m_SplashScreenMenuPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<FlowPanel>) GWT.create(ExtensionProvided_factory__c_g_g_u_c_u_FlowPanel__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AnnotationListItemViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_a_i_AnnotationListItemViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExternalImportPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_i_ExternalImportPresenter__quals__j_e_i_Any_o_k_w_c_s_l_c_s_i_Source.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AssetsView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_a_AssetsView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ACLSettings>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_ACLSettings__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TerminationConfigFormViewImpl>) GWT.create(Type_factory__o_o_w_s_s_c_e_TerminationConfigFormViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<FileExportScriptInjector>) GWT.create(Type_factory__o_u_e_e_c_c_f_e_j_FileExportScriptInjector__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ValueBoxEditor>) GWT.create(Type_factory__o_d_c_c_e_ValueBoxEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<M2RepoPerspective>) GWT.create(Type_factory__o_o_w_c_p_M2RepoPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ViewJavaSourceWidget>) GWT.create(ExtensionProvided_factory__o_k_w_c_s_j_c_w_ViewJavaSourceWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewFieldPopup>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_e_NewFieldPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DecisionTablePopoverUtils>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_c_DecisionTablePopoverUtils__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ImportProjectsView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_i_ImportProjectsView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<XmlResourceType>) GWT.create(Type_factory__o_k_w_c_s_d_c_e_XmlResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedScoreCardEditorPresenterActivity>) GWT.create(Type_factory__o_d_w_s_g_s_c_e_GuidedScoreCardEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PerspectiveDragConfigModal>) GWT.create(Type_factory__o_d_c_c_l_e_PerspectiveDragConfigModal__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuidedRuleEditorViewImpl>) GWT.create(Type_factory__o_d_w_s_g_r_c_e_GuidedRuleEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LayersGroup>) GWT.create(Type_factory__o_u_e_w_c_c_l_LayersGroup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TextEditorView>) GWT.create(Type_factory__o_u_e_w_c_c_e_t_TextEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TimeFrameEditorView>) GWT.create(Type_factory__o_d_d_c_w_f_TimeFrameEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TextArea>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_TextArea__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DisplayerScreenPresenter>) GWT.create(Type_factory__o_d_d_c_DisplayerScreenPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ArtifactRepositoryPreferenceBeanGeneratedImpl>) GWT.create(Type_factory__o_g_m_p_ArtifactRepositoryPreferenceBeanGeneratedImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SQLDataSetDefAttributesEditorView>) GWT.create(Type_factory__o_d_c_w_d_e_s_SQLDataSetDefAttributesEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<XmlResourceTypeDefinition>) GWT.create(Type_factory__o_k_w_c_s_d_s_XmlResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PersistencePresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_p_PersistencePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuvnorDefaultEditorPresenter>) GWT.create(Type_factory__o_k_w_c_s_d_c_e_GuvnorDefaultEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EmptyLibraryView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_EmptyLibraryView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MenuItemsListPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_u_s_MenuItemsListPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<KieSelectElement>) GWT.create(Type_factory__o_k_w_c_w_c_w_KieSelectElement__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TemplatedWorkbenchPanelView>) GWT.create(Type_factory__o_u_c_w_p_i_TemplatedWorkbenchPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CardView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_CardView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DRLResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_d_t_DRLResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HitPolicySelectorViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_h_HitPolicySelectorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AuthorizationManagerHelper>) GWT.create(Type_factory__o_u_s_c_a_AuthorizationManagerHelper__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LibraryConstants>) GWT.create(Type_factory__o_k_w_c_s_l_c_r_i_LibraryConstants__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<HomeEntryPoint>) GWT.create(Type_factory__o_k_w_c_s_h_c_HomeEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ProjectMenu>) GWT.create(Type_factory__o_k_w_c_s_p_c_m_ProjectMenu__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ServerTemplatePresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_n_t_ServerTemplatePresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TileView>) GWT.create(Type_factory__o_k_w_c_s_l_c_w_c_TileView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PlaceManager>) GWT.create(JsType_factory__o_u_c_m_PlaceManager__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DefaultJsValidator>) GWT.create(Type_factory__o_d_d_c_w_s_DefaultJsValidator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DecisionTableXLSXResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_d_t_DecisionTableXLSXResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NavDropDownWidgetView>) GWT.create(Type_factory__o_d_c_n_w_NavDropDownWidgetView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DroolsDataObjectEditor>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_d_DroolsDataObjectEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<TransitionAnchorProvider>) GWT.create(Type_factory__o_j_e_u_n_c_l_TransitionAnchorProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserMenu>) GWT.create(Type_factory__o_u_c_v_p_m_UserMenu__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<CompassWidgetImpl>) GWT.create(Type_factory__o_u_c_v_p_d_CompassWidgetImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GoogleBarChartDisplayerView>) GWT.create(Type_factory__o_d_r_g_c_GoogleBarChartDisplayerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<KieWorkbenchCommonRefactoringClientEntryPoint>) GWT.create(Type_factory__o_k_w_c_s_r_c_KieWorkbenchCommonRefactoringClientEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<LibraryEntryPoint>) GWT.create(Type_factory__o_k_w_c_s_l_c_LibraryEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserAssignedRolesEditor>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_u_UserAssignedRolesEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<VerifierEntryPoint>) GWT.create(Type_factory__o_k_w_c_s_v_r_c_VerifierEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NavComponentConfigModalView>) GWT.create(Type_factory__o_d_c_n_w_NavComponentConfigModalView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PerspectiveEditorPresenter>) GWT.create(Type_factory__o_u_e_p_c_p_e_PerspectiveEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GeneralPluginEditor>) GWT.create(Type_factory__o_u_e_p_c_w_p_GeneralPluginEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ColumnHeaderPopOverImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_ColumnHeaderPopOverImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<RepositoryMenu>) GWT.create(Type_factory__o_k_w_c_w_c_m_RepositoryMenu__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CreateEntityView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_CreateEntityView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<JavaResourceType>) GWT.create(Type_factory__o_k_w_c_s_j_c_t_JavaResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionWorkItemInsertFactColumnSynchronizer>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_s_i_ActionWorkItemInsertFactColumnSynchronizer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<WorkbenchToolBarPresenter>) GWT.create(Type_factory__o_u_c_w_w_t_WorkbenchToolBarPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<TestReportingDocksHandler>) GWT.create(Type_factory__o_k_w_c_w_c_t_TestReportingDocksHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<BaseEditorEntryPoint>) GWT.create(Type_factory__o_u_e_e_c_c_BaseEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<EditorPluginResourceType>) GWT.create(Type_factory__o_u_e_p_c_t_EditorPluginResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PersistenceDescriptorValidationMessageTranslator>) GWT.create(Type_factory__o_k_w_c_s_d_c_v_PersistenceDescriptorValidationMessageTranslator__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<MultiConstraintHardSoftMatchRuleModellerActionPlugin>) GWT.create(Type_factory__o_o_w_s_g_c_p_MultiConstraintHardSoftMatchRuleModellerActionPlugin__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RendererSelectorListBoxView>) GWT.create(Type_factory__o_d_d_c_w_RendererSelectorListBoxView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AdvancedDataObjectEditorViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_a_AdvancedDataObjectEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<FileExportProducer>) GWT.create(Type_factory__o_u_e_e_c_c_f_e_FileExportProducer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<Position>) GWT.create(JsType_factory__o_u_w_m_Position__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EditorPlugInEditorView>) GWT.create(Type_factory__o_u_e_p_c_e_EditorPlugInEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewSSHKeyModalViewImpl>) GWT.create(Type_factory__o_u_s_c_e_c_c_NewSSHKeyModalViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PreferencesRootScreenActivity>) GWT.create(Type_factory__o_u_e_p_c_c_s_PreferencesRootScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LibraryOrganizationalUnitPreferencesBeanGeneratedImpl>) GWT.create(Type_factory__o_k_w_c_s_l_a_p_LibraryOrganizationalUnitPreferencesBeanGeneratedImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<AnalysisReportScreen>) GWT.create(Type_factory__o_k_w_c_s_v_r_c_p_AnalysisReportScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExplorerMenu>) GWT.create(Type_factory__o_k_w_c_s_e_c_ExplorerMenu__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<BasicUserCacheImpl>) GWT.create(Type_factory__o_j_e_s_c_l_c_BasicUserCacheImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DecisionTableXLSEditorViewImpl>) GWT.create(Type_factory__o_d_w_s_d_c_e_DecisionTableXLSEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MediaLibraryWidget>) GWT.create(Type_factory__o_u_e_p_c_w_m_MediaLibraryWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ViewMenuBuilder>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_m_ViewMenuBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<EditorJSExporter>) GWT.create(Type_factory__o_u_c_e_EditorJSExporter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedRuleDRLResourceType>) GWT.create(Type_factory__o_d_w_s_g_r_c_t_GuidedRuleDRLResourceType__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContributorsManagementListItemPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_o_c_w_ContributorsManagementListItemPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TitleProvider>) GWT.create(JsType_factory__o_u_c_m_LockTarget_TitleProvider__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkItemPage>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_WorkItemPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RepositoryPreferences>) GWT.create(Producer_factory__o_g_s_c_e_r_RepositoryPreferences__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SimpleTable>) GWT.create(Type_factory__o_u_e_w_c_c_t_SimpleTable__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TreeHierarchyInternalItemPresenter>) GWT.create(Type_factory__o_u_e_p_c_c_t_TreeHierarchyInternalItemPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<POMWizardPage>) GWT.create(Type_factory__o_k_w_c_s_p_c_w_POMWizardPage__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<HitPolicySelector>) GWT.create(Type_factory__o_d_w_s_g_d_c_h_HitPolicySelector__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<com.google.gwt.user.client.ui.Label>) GWT.create(ExtensionProvided_factory__c_g_g_u_c_u_Label__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<RendererManager>) GWT.create(Type_factory__o_d_d_c_RendererManager__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SecurityContextHoldingSingleton>) GWT.create(Type_factory__o_j_e_s_c_l_n_SecurityContextHoldingSingleton__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LayoutEditorPropertiesView>) GWT.create(Type_factory__o_u_e_l_e_c_w_LayoutEditorPropertiesView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<UserAssignedRolesExplorer>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_u_UserAssignedRolesExplorer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SelectorSliderDisplayer>) GWT.create(Type_factory__o_d_r_c_s_SelectorSliderDisplayer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContainerRemoteStatusPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_c_s_ContainerRemoteStatusPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ConfirmBox>) GWT.create(Type_factory__o_u_e_s_m_c_w_p_ConfirmBox__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<CompassPosition>) GWT.create(JsType_factory__o_u_w_m_CompassPosition__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TerminationTreeItemContentViewImpl>) GWT.create(Type_factory__o_o_w_s_s_c_e_TerminationTreeItemContentViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExperimentalFeaturesPerspectiveActivity>) GWT.create(Type_factory__o_u_e_c_p_ExperimentalFeaturesPerspectiveActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ActivityManagerImpl>) GWT.create(Type_factory__o_u_c_m_ActivityManagerImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewFieldPopupViewImpl>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_e_NewFieldPopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GlobalsEditorPresenterActivity>) GWT.create(Type_factory__o_d_w_s_g_c_e_GlobalsEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<com.google.gwt.user.client.ui.CheckBox>) GWT.create(ExtensionProvided_factory__c_g_g_u_c_u_CheckBox__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RoleEditorDriver>) GWT.create(Type_factory__o_u_e_s_m_c_e_r_RoleEditorDriver__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PermissionSwitchView>) GWT.create(Type_factory__o_u_e_s_m_c_w_m_e_a_n_PermissionSwitchView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SolverEditorPresenter>) GWT.create(Type_factory__o_o_w_s_s_c_e_SolverEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<OverviewWidgetViewImpl>) GWT.create(Type_factory__o_k_w_c_w_m_c_w_OverviewWidgetViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MenuVisitor>) GWT.create(JsType_factory__o_u_w_m_m_MenuVisitor__quals__Universal.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ElasticSearchDataSetDefAttributesEditorView>) GWT.create(Type_factory__o_d_c_w_d_e_e_ElasticSearchDataSetDefAttributesEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DataSetEditorDriverFactory>) GWT.create(Type_factory__o_d_c_w_d_e_d_DataSetEditorDriverFactory__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContainerProcessConfigPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_c_c_p_ContainerProcessConfigPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NavDropDownWidget>) GWT.create(Type_factory__o_d_c_n_w_NavDropDownWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PreferenceScopeResolutionStrategyIOCProvider>) GWT.create(Type_factory__o_u_p_c_s_PreferenceScopeResolutionStrategyIOCProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PerspectiveJSExporter>) GWT.create(Type_factory__o_u_c_e_PerspectiveJSExporter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ImportsListPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_s_e_ExternalDataObjectsPresenter_ImportsListPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PackageSelector>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_p_PackageSelector__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GuidedRuleDRLResourceTypeDefinition>) GWT.create(Type_factory__o_d_w_s_g_r_t_GuidedRuleDRLResourceTypeDefinition__quals__j_e_i_Any_j_e_i_Default_o_u_w_a_VisibleAsset.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AssetsScreen>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_a_AssetsScreen__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<BeanDataSetEditor>) GWT.create(Type_factory__o_d_c_w_d_e_b_BeanDataSetEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LimitedEntryConditionCol52DefinitionBuilder>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_d_LimitedEntryConditionCol52DefinitionBuilder__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkItemsEditorPresenter>) GWT.create(Type_factory__o_d_w_s_w_c_e_WorkItemsEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DRLEditorEntryPoint>) GWT.create(Type_factory__o_d_w_s_d_c_DRLEditorEntryPoint__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NewGuidedDecisionTableWizard>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_NewGuidedDecisionTableWizard__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ValidationPopupViewImpl>) GWT.create(Type_factory__o_k_w_c_w_c_p_v_ValidationPopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NavMenuBarWidgetView>) GWT.create(Type_factory__o_d_c_n_w_NavMenuBarWidgetView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<MainDataObjectEditor>) GWT.create(Type_factory__o_k_w_c_s_d_c_w_m_MainDataObjectEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ColumnsPageView>) GWT.create(Type_factory__o_d_w_s_g_d_c_e_p_ColumnsPageView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<EditHTMLPresenter>) GWT.create(Type_factory__o_u_e_p_c_p_e_l_e_p_EditHTMLPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DropDownEditor>) GWT.create(Type_factory__o_d_c_c_e_l_DropDownEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AceEditor>) GWT.create(ExtensionProvided_factory__o_u_e_w_c_c_a_AceEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<WorkbenchPreferenceScopeResolutionStrategy>) GWT.create(Type_factory__o_k_w_c_s_s_p_c_WorkbenchPreferenceScopeResolutionStrategy__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<SelectorDropDownItem>) GWT.create(Type_factory__o_d_r_c_s_SelectorDropDownItem__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PerspectiveDropDown>) GWT.create(Type_factory__o_u_e_w_c_c_d_PerspectiveDropDown__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefPreviewTable>) GWT.create(Type_factory__o_d_c_w_d_e_DataSetDefPreviewTable__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewResourcesMenu>) GWT.create(Type_factory__o_k_w_c_w_c_h_NewResourcesMenu__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContentManagerHomeView>) GWT.create(Type_factory__o_d_c_c_s_h_ContentManagerHomeView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GoogleMeterChartDisplayerView>) GWT.create(Type_factory__o_d_r_g_c_GoogleMeterChartDisplayerView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<MultiConstraintBendableBigDecimalMatchRuleModellerActionPlugin>) GWT.create(Type_factory__o_o_w_s_g_c_p_MultiConstraintBendableBigDecimalMatchRuleModellerActionPlugin__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TestRunnerReportingScreenActivity>) GWT.create(Type_factory__o_k_w_c_w_c_t_TestRunnerReportingScreenActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<AttributeColumnConfigRow>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_c_c_AttributeColumnConfigRow__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<CopyPopupPresenter>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_n_t_c_CopyPopupPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<DefaultBusSecurityErrorCallback>) GWT.create(Type_factory__o_j_e_s_c_l_c_DefaultBusSecurityErrorCallback__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<GenericErrorPopup>) GWT.create(Type_factory__o_k_w_c_w_c_e_GenericErrorPopup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DataSetDefCacheAttributesEditorViewImpl>) GWT.create(Type_factory__o_d_c_w_d_e_a_DataSetDefCacheAttributesEditorViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<PreferencesCentralActionsView>) GWT.create(Type_factory__o_u_e_p_c_c_a_PreferencesCentralActionsView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LinkTitleView>) GWT.create(Type_factory__o_k_w_c_s_s_m_c_w_c_t_LinkTitleView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContributorsManagementView>) GWT.create(Type_factory__o_k_w_c_s_l_c_s_o_c_w_ContributorsManagementView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ValueOptionsPageView>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_c_p_ValueOptionsPageView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PreferencesCentralPerspective>) GWT.create(Type_factory__o_u_e_p_c_c_PreferencesCentralPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ConflictingRepositoriesPopupViewImpl>) GWT.create(Type_factory__o_g_c_s_p_c_r_ConflictingRepositoriesPopupViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ContainersGroup>) GWT.create(Type_factory__o_u_e_w_c_c_p_ContainersGroup__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExampleProjectErrorPresenter>) GWT.create(Type_factory__o_k_w_c_s_l_c_w_e_e_ExampleProjectErrorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<JPADomainHandler>) GWT.create(Type_factory__o_k_w_c_s_d_c_h_j_JPADomainHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ScenarioEditorPresenter>) GWT.create(Type_factory__o_d_w_s_t_c_ScenarioEditorPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<DependencyListWidget>) GWT.create(Type_factory__o_k_w_c_s_p_c_f_d_DependencyListWidget__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExplorerPresenterActivity>) GWT.create(Type_factory__o_k_w_c_s_e_c_ExplorerPresenterActivity__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<RepositoryTreeProvider>) GWT.create(Type_factory__o_g_s_c_s_RepositoryTreeProvider__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<Decision>) GWT.create(Type_factory__o_g_c_s_p_c_Decision__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GroupContextMenuItemView>) GWT.create(Type_factory__o_u_c_v_p_m_m_c_GroupContextMenuItemView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<HomeProducer>) GWT.create(Type_factory__o_o_w_c_h_HomeProducer__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<IFrameScreenPresenter>) GWT.create(Type_factory__o_u_e_w_c_c_s_i_IFrameScreenPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LikeToFunctionEditor>) GWT.create(Type_factory__o_d_d_c_w_f_LikeToFunctionEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<LayoutEditorPropertiesPresenter>) GWT.create(Type_factory__o_u_e_l_e_c_w_LayoutEditorPropertiesPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<org.jboss.errai.common.client.dom.Button>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_Button__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<SSHKeysEditorPerspective>) GWT.create(Type_factory__o_u_s_c_e_SSHKeysEditorPerspective__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LayoutElementPropertiesView>) GWT.create(Type_factory__o_u_e_l_e_c_w_LayoutElementPropertiesView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<ResourceTypeDefinitionJSExporter>) GWT.create(Type_factory__o_u_c_e_ResourceTypeDefinitionJSExporter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<NumberParameterEditorView>) GWT.create(Type_factory__o_d_d_c_w_f_NumberParameterEditorView__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GridWidgetColumnFactoryImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_m_c_c_i_GridWidgetColumnFactoryImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ActionSetFieldsPageViewImpl>) GWT.create(Type_factory__o_d_w_s_g_d_c_w_t_p_ActionSetFieldsPageViewImpl__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<NewDrlTextHandler>) GWT.create(Type_factory__o_d_w_s_d_c_h_NewDrlTextHandler__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<ExternalLinkPresenter>) GWT.create(Type_factory__o_k_w_c_w_m_c_w_ExternalLinkPresenter__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_ApplicationScopedContext_context.registerFactory((Factory<PerspectiveEditorSettings>) GWT.create(Type_factory__o_u_e_p_c_p_e_l_e_PerspectiveEditorSettings__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<TimeAmountEditor>) GWT.create(Type_factory__o_d_d_c_w_f_TimeAmountEditor__quals__j_e_i_Any_j_e_i_Default.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<GuvnorDefaultEditorPresenterActivity>) GWT.create(Type_factory__o_k_w_c_s_d_c_e_GuvnorDefaultEditorPresenterActivity__quals__j_e_i_Any_j_i_Named_o_u_c_w_a_AssociatedResources_o_u_c_w_a_Priority.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<RadioInput>) GWT.create(ExtensionProvided_factory__o_j_e_c_c_d_RadioInput__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
    org_jboss_errai_ioc_client_container_DependentScopeContext_context.registerFactory((Factory<LayoutPanelView>) GWT.create(Type_factory__o_u_c_w_p_i_LayoutPanelView__quals__j_e_i_Any_j_e_i_Default_j_i_Named.class));
  }

  private void registerFactories(final Context org_jboss_errai_ioc_client_container_ApplicationScopedContext_context, final Context org_jboss_errai_ioc_client_container_DependentScopeContext_context) {
    registerFactories0(org_jboss_errai_ioc_client_container_ApplicationScopedContext_context, org_jboss_errai_ioc_client_container_DependentScopeContext_context);
    registerFactories1(org_jboss_errai_ioc_client_container_ApplicationScopedContext_context, org_jboss_errai_ioc_client_container_DependentScopeContext_context);
    registerFactories2(org_jboss_errai_ioc_client_container_ApplicationScopedContext_context, org_jboss_errai_ioc_client_container_DependentScopeContext_context);
    registerFactories3(org_jboss_errai_ioc_client_container_ApplicationScopedContext_context, org_jboss_errai_ioc_client_container_DependentScopeContext_context);
  }

  // The main IOC bootstrap method.
  public ContextManager bootstrapContainer() {
    final Context org_jboss_errai_ioc_client_container_ApplicationScopedContext_context = new ApplicationScopedContext();
    final Context org_jboss_errai_ioc_client_container_DependentScopeContext_context = new DependentScopeContext();
    logger.debug("Registering factories with contexts.");
    long start = System.currentTimeMillis();
    registerFactories(org_jboss_errai_ioc_client_container_ApplicationScopedContext_context, org_jboss_errai_ioc_client_container_DependentScopeContext_context);
    logger.debug("Registered 1907 factories in {}ms", System.currentTimeMillis() - start);
    logger.debug("Adding contexts to context manager...");
    start = System.currentTimeMillis();
    contextManager.addContext(org_jboss_errai_ioc_client_container_ApplicationScopedContext_context);
    contextManager.addContext(org_jboss_errai_ioc_client_container_DependentScopeContext_context);
    logger.debug("Added 2 contexts in {}ms", System.currentTimeMillis() - start);
    logger.debug("Calling finishInit on ContextManager");
    start = System.currentTimeMillis();
    contextManager.finishInit();
    logger.debug("ContextManager#finishInit ran in {}ms", System.currentTimeMillis() - start);
    return contextManager;
  }
}