package org.jboss.errai.marshalling.client.api;

import com.google.gwt.core.shared.GWT;
import java.util.AbstractMap;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.SortedMap;
import java.util.TreeMap;
import javax.enterprise.context.Dependent;
import org.jboss.errai.marshalling.client.marshallers.BigDecimalMarshaller;
import org.jboss.errai.marshalling.client.marshallers.BigIntegerMarshaller;
import org.jboss.errai.marshalling.client.marshallers.BooleanMarshaller;
import org.jboss.errai.marshalling.client.marshallers.ByteMarshaller;
import org.jboss.errai.marshalling.client.marshallers.CharacterMarshaller;
import org.jboss.errai.marshalling.client.marshallers.ClientClassMarshaller;
import org.jboss.errai.marshalling.client.marshallers.DateMarshaller;
import org.jboss.errai.marshalling.client.marshallers.DoubleMarshaller;
import org.jboss.errai.marshalling.client.marshallers.FloatMarshaller;
import org.jboss.errai.marshalling.client.marshallers.IntegerMarshaller;
import org.jboss.errai.marshalling.client.marshallers.LinkedHashSetMarshaller;
import org.jboss.errai.marshalling.client.marshallers.LinkedListMarshaller;
import org.jboss.errai.marshalling.client.marshallers.LinkedMapMarshaller;
import org.jboss.errai.marshalling.client.marshallers.ListMarshaller;
import org.jboss.errai.marshalling.client.marshallers.LongMarshaller;
import org.jboss.errai.marshalling.client.marshallers.MapMarshaller;
import org.jboss.errai.marshalling.client.marshallers.ObjectMarshaller;
import org.jboss.errai.marshalling.client.marshallers.OptionalMarshaller;
import org.jboss.errai.marshalling.client.marshallers.PriorityQueueMarshaller;
import org.jboss.errai.marshalling.client.marshallers.QualifyingMarshallerWrapper;
import org.jboss.errai.marshalling.client.marshallers.QueueMarshaller;
import org.jboss.errai.marshalling.client.marshallers.SQLDateMarshaller;
import org.jboss.errai.marshalling.client.marshallers.SetMarshaller;
import org.jboss.errai.marshalling.client.marshallers.ShortMarshaller;
import org.jboss.errai.marshalling.client.marshallers.SortedMapMarshaller;
import org.jboss.errai.marshalling.client.marshallers.SortedSetMarshaller;
import org.jboss.errai.marshalling.client.marshallers.StringBufferMarshaller;
import org.jboss.errai.marshalling.client.marshallers.StringBuilderMarshaller;
import org.jboss.errai.marshalling.client.marshallers.StringMarshaller;
import org.jboss.errai.marshalling.client.marshallers.TimeMarshaller;
import org.jboss.errai.marshalling.client.marshallers.TimestampMarshaller;
import org.uberfire.rpc.impl.SessionInfoMarshalller;
@Dependent public class MarshallerFactoryImpl implements MarshallerFactory {
  private Map<String, Marshaller> marshallers = new HashMap<String, Marshaller>();
  abstract class Marshaller_for_org_optaplanner_core_api_score_buildin_bendablebigdecimal_BendableBigDecimalScore implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_core_api_score_buildin_hardmediumsoftbigdecimal_HardMediumSoftBigDecimalScore implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_core_api_score_buildin_simplebigdecimal_SimpleBigDecimalScore implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_core_api_score_buildin_hardsoftbigdecimal_HardSoftBigDecimalScore implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_core_api_score_buildin_hardsoftdouble_HardSoftDoubleScore implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_core_api_score_buildin_simpledouble_SimpleDoubleScore implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_core_api_score_buildin_hardmediumsoftlong_HardMediumSoftLongScore implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_core_api_score_buildin_bendable_BendableScore implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_core_api_score_buildin_simple_SimpleScore implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_Throwable implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_ArithmeticException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_io_IOException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_IllegalArgumentException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_util_EmptyStackException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_ArrayStoreException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_ClassCastException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_util_ConcurrentModificationException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_IndexOutOfBoundsException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_NegativeArraySizeException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_NullPointerException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_StringIndexOutOfBoundsException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_UnsupportedOperationException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_AssertionError implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_RuntimeException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_core_api_score_buildin_hardmediumsoft_HardMediumSoftScore implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_core_api_score_buildin_simplelong_SimpleLongScore implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jboss_errai_security_shared_exception_SecurityException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jboss_errai_security_shared_exception_UnauthenticatedException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jboss_errai_security_shared_exception_UnauthorizedException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jboss_errai_security_shared_exception_AuthenticationException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_StackTraceElement implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_core_api_score_buildin_hardsoft_HardSoftScore implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_core_api_score_buildin_bendablelong_BendableLongScore implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_core_api_score_buildin_hardsoftlong_HardSoftLongScore implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_ModuleRepositories implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionInsertFactCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_guided_dtable_model_GuidedDecisionTableEditorGraphModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_ObjectPropertyImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_services_verifier_plugin_client_api_Initialize implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_Module implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_event_MediaAdded implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_preferences_shared_bean_PreferenceRootElement implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataprovider_BeanProviderType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_explorer_model_URIStructureExplorerModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_query_RefactoringMapPageRow implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_ChangeType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_oracle_DSLActionSentence implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_library_api_index_LibraryValueRepositoryRootIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_event_NewPluginRegistered implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_model_Notification_erraiD_State implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_verifier_api_reporting_MultipleValuesForOneActionIssue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_spec_ContainerSpecList implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_mvp_impl_ForcedPlaceRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_ext_uberfire_social_activities_model_DefaultTypes implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_organizationalunit_RepoRemovedFromOrganizationalUnitEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_experimental_service_backend_impl_ExperimentalFeaturesSessionImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceRenamedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_guided_dtable_model_GuidedDecisionTableEditorContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataModelerEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_kmodule_ConsoleLogger implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_DSLSentence implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionRetractFact implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jboss_errai_security_shared_exception_FailedAuthenticationException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_persistence_CachingType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_experimental_service_editor_EditableExperimentalFeature implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_persistence_PersistenceUnitModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_ActionWorkItemInsertFactColumnDetails implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_exception_EntityNotFoundException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_events_DataSetStaleEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_layout_editor_api_editor_LayoutTemplate implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_services_shared_preferences_GridPreferencesStore implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_ElementType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceChangeType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_kmodule_ListenerModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableBooleanParameterDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_impl_SearchResponseImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_security_authz_AuthorizationResult implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_navigation_impl_NavTreeImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_security_impl_authz_DefaultAuthorizationPolicy implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_ParameterImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_EnvironmentParameters implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionVariable implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_events_DataSetPushOkEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_services_verifier_plugin_client_api_FactTypes_erraiD_Field implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_BigIntegerValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_navigation_layout_LayoutRecursionIssue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jboss_errai_security_shared_exception_AlreadyLoggedInException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_builder_model_IncrementalBuildResults implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_AnnotationParseRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_services_verifier_plugin_client_api_RemoveRule implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_backend_plugin_RuntimePlugin implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_exception_PluginAlreadyExists implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_verifier_api_Status implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_security_ProjectResourceType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_ShortValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_examples_model_ExamplesModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_DTColumnConfig52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_preferences_shared_impl_validation_ValidationResult implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_ImportImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_backend_vfs_impl_LockInfo implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValuePartIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_enums_model_EnumModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_ext_uberfire_social_activities_events_SocialUserUnFollowedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_FloatValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_ResourceIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_DataObjectImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_def_DataColumnDef implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_service_impact_DeleteOperationRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_SingleFieldConstraintEBLeftSide implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_UnsupportedIActionParserMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_verifier_api_reporting_ImpossibleMatchIssue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_services_verifier_plugin_client_api_DeleteColumns implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_impl_UserManagerSettingsImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_FileAlreadyExistsException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_LongValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_Plugin implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionUpdateField implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_messageconsole_events_SystemMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_guided_rule_model_GuidedEditorContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_events_NewPackageEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataModelSaved implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_workitems_model_WorkItemDefinitionElements implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_events_ServerTemplateUpdated implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_persistence_TransactionType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodel_model_PackageDataModelOracleBaselinePayload implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_BRLConditionVariableColumn implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_nodes_impl_ActionUpdateNodeImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_AnnotationSourceResponse implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_library_api_index_LibraryValueFileExtensionIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_examples_model_ExampleProjectError implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_scorecard_shared_ScoreCardModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_DynamicMenuItem implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_properties_editor_model_validators_TextValidator implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_api_model_Message implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_RuleAttribute implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_persistence_PersistenceDescriptorEditorContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodel_model_PackageDataModelOracleIncrementalPayload implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_spec_ServerTemplateList implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jboss_errai_security_shared_api_RoleImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_screens_domaineditor_validation_ScoreHolderGlobalToBeRemovedMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_testscenario_model_TestScenarioResult implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableFloatParameterDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_builder_events_InvalidateDMOPackageCacheEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_api_exception_KieServicesHttpException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_preferences_shared_impl_PreferenceScopedValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_navigation_impl_NavItemImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceOpenedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_m2repo_model_JarListPageRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_filter_CoreFunctionFilter implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_VerifyRuleFired implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_scorecard_shared_Attribute implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_discussion_CommentAddedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_impl_GroupManagerSettingsImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_navigation_layout_LayoutTemplateContext implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_conversion_ConversionResult implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_event_PluginSaved implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_organizationalunit_OrganizationalUnitEventBase implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_BooleanValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_dtablexls_service_DecisionTableXLSContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_library_api_LibraryInfo implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_ModuleNameIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_backend_vfs_impl_DirectoryStreamImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionMethodParameter implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_CompositeFactPattern implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_UberfireJSAPIReadyEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_paging_PageRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_PackageNameIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_CallFieldValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_builder_model_BuildMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionWorkItemInsertFactCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionWorkItemCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_model_impl_PanelDefinitionImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataprovider_StaticProviderType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_RelationshipIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_server_management_model_RuntimeStrategy implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_projecteditor_model_ProjectScreenModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jboss_errai_security_shared_api_identity_UserImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_ActionInsertFactColumnDetails implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_backend_EditDataSetDef implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_POM implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_impl_GitMetadataImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_library_api_index_LibraryFileExtensionIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_def_SQLDataSetDef implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_WorkItemColumnParameterValueDiffImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_LimitedEntryConditionColumnDetails implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_ext_uberfire_social_activities_model_PagedSocialQuery implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionMethodParameterDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_persistence_PersistenceDescriptorModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_messageconsole_events_PublishBaseEvent_erraiD_Place implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_soup_project_datamodel_imports_Imports implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_VerifyField implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_services_verifier_plugin_client_api_MakeRule implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_exception_RealmManagementNotAuthorizedException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_apps_api_Directory implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_InsertRowAuditLogEntry implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_nodes_impl_ActionRetractNodeImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_RepositoryNotFoundException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_AnnotationDefinitionResponse implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_soup_project_datamodel_oracle_DataType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_scorecardxls_service_ScoreCardXLSContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataModelerValueChangeEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_group_DateIntervalType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_editor_commons_version_impl_PortableVersionRecord implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionFieldFunction implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jboss_errai_security_shared_api_GroupImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_PropertyTypeImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_server_management_model_MergeMode implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_Build implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_ext_uberfire_social_activities_model_SocialUser implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_services_shared_preferences_GridColumnPreference implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_UnsupportedFieldConstraintParserMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_event_PluginDeleted implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_screens_domaineditor_validation_ScoreHolderGlobalToBeDefinedManuallyMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_RowNumberCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableObjectParameterDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_JavaClassImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectRenamedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_ClosedWatchServiceException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_UpdateColumnAuditLogEntry implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_editor_commons_file_exports_PdfExportPreferences_erraiD_Unit implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_exception_UserAlreadyExistsException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionFormLine implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_sort_DataSetSort implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_navigator_NavigatorContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_spec_ContainerSpecKey implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_DriverError implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_DataTypeNotFoundParserMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_Fact implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_events_NewProjectEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_Dependency implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_LimitedEntryConditionCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_experimental_service_security_GlobalExperimentalFeatureResourceType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_template_shared_TemplateModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_date_Month implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_editor_commons_file_exports_FileExportsPreferencesPortableGeneratedImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_ext_uberfire_social_activities_model_SocialFileSelectedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_spec_ServerConfig implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_ReferencedPartIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_PluginContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_date_Quarter implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionInsertFact implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ConnectiveConstraint implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_DataTypeConversionErrorParserMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_runtime_ServerInstanceKeyList implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_FileSystemAlreadyExistsException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_models_datamodel_rule_ActionMultiConstraintBendableMatch implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionCollectionIndex implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_oracle_DSLConditionSentence implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_SingleScenarioResult implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_BRLRuleModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_DoubleValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_ObjectSource implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_query_RefactoringRuleNamePageRow implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_security_RepositoryResourceType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_BigDecimalValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_dependencies_TransitiveEnhancedDependency implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_library_api_sync_ClusterLibraryEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_soup_project_datamodel_oracle_DropDownData implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_experimental_service_registry_impl_ExperimentalFeatureImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_project_ProjectImportsContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_exception_InvalidEntityIdentifierException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_explorer_service_Option implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_examples_model_ExamplesMetaData implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_screens_domaineditor_validation_PlanningSolutionToBeDuplicatedMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_AnnotationParseResponse implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_runtime_ContainerKey implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_screens_solver_model_TerminationConfigOption implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_CEPWindow implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_EnumValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_nodes_impl_ActionFieldValueImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_preferences_GeneralPreferencesPortableGeneratedImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataprovider_SQLProviderType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_impl_PullRequestImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_models_datamodel_rule_ActionBendableHardConstraintMatch implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_FromCompositeFactPattern implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_Visibility implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_preferences_shared_PropertyFormOptions implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_impl_SettingsImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionSetField implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_model_impl_ContextDefinitionImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_service_ResourceType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_services_shared_preferences_UserWorkbenchPreferences implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_MethodImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_defaulteditor_service_DefaultEditorContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_visitors_RuleModelVisitor implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_services_verifier_plugin_client_api_NewColumn implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_layout_editor_api_editor_LayoutColumn implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_screens_solver_model_ConstructionHeuristicPhaseConfigModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionGlobalCollectionAdd implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_FactData implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionField implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_NoSuchFileException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectFieldSelectedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_events_DataSetPushingEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_factmodel_model_FactMetaModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_InvalidRootParserMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_factmodel_model_FieldMetaModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_model_impl_SplashScreenFilterImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_shared_metadata_model_Metadata implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_RepositoryExternalUpdateEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_editor_commons_file_exports_PdfExportPreferences_erraiD_Orientation implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_InterpolationVariable implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_RuleMetadata implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_navigation_layout_LayoutNavigationRefType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_imports_Import implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_NotLinkException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_kmodule_EventProcessingOption implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_guided_dtree_model_GuidedDecisionTreeEditorContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_soup_project_datamodel_oracle_OperatorsOracle implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_core_config_heuristic_selector_value_ValueSorterManner implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_persistence_ValidationMode implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValueSharedPartIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataprovider_ELSProviderType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_builder_model_BuildResults implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_ModelDriverResult implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_kmodule_AssertBehaviorOption implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_impl_DefaultPublicURI implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_core_config_constructionheuristic_ConstructionHeuristicType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_services_verifier_plugin_client_Coordinate implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_paging_PageResponse implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_ProviderNotFoundException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_preferences_GAVPreferencesPortableGeneratedImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_sort_ColumnSort implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_library_api_AssetQueryResult implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_group_DataSetGroup implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_shared_test_TestResultMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_project_KieModule implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_models_datamodel_rule_ActionBendableSoftConstraintMatch implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_PatternSyntaxException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_runtime_Container implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_library_api_preferences_LibraryPreferencesPortableGeneratedImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionInsertLogicalFact implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_StringValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_query_RefactoringPageRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_ExecutionTrace implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_guided_scorecard_model_ScoreCardModelContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_ByteValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_RetractFact implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_library_api_ProjectAssetsQuery implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_IOException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectFieldDeletedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_verifier_api_reporting_ValueForActionIsSetTwiceIssue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_testscenario_model_TestScenarioModelContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_verifier_api_reporting_CheckType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_ScenarioRunResult implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_screens_solver_model_LocalSearchPhaseConfigModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_filter_DataSetFilter implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_adaptors_ConditionCol52FieldConstraintAdaptor implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_security_impl_authz_DefaultPermissionCollection implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_RepositoryEnvironmentConfiguration implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_dependencies_NormalEnhancedDependency implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_mvp_impl_DefaultPlaceRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_sort_SortedList implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_events_DataSetDefRemovedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_explorer_model_FolderListing implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_security_impl_authz_DotNamedPermission implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_exception_NoImplementationAvailableException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_adaptors_ActionInsertFactCol52ActionInsertFactAdaptor implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_GenerationResult implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_persistence_Property implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_events_NewModuleEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_WorkspaceProject implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_navigation_impl_NavGroupImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_NewRepositoryEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodel_model_LazyModelField implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_PluginType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_ModelFactoryImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_PropertyTypeFactoryImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_enums_model_EnumModelContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_NewBranchEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_group_GroupStrategy implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_adaptors_ActionInsertFactCol52ActionInsertLogicalFactAdaptor implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_spec_ServerTemplateKeyList implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_DTCellValue52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_verifier_api_client_api_WebWorkerLogMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_Capability implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_LimitedEntryActionInsertFactColumnDetails implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_properties_editor_model_validators_ColorValidator implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_AccessDeniedException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_server_management_model_ContainerUpdateEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_screens_solver_model_SolverModelContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_api_model_ReleaseId implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_workitems_model_WorkItemsModelContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_TypeInfoResult implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_library_api_preferences_LibraryInternalPreferencesPortableGeneratedImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_BaseSingleFieldConstraint implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_library_api_OrganizationalUnitRepositoryInfo implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataprovider_CSVProviderType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_displayer_ColumnSettings implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_DataModelerError implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionExecuteWorkItem implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_AtomicMoveNotSupportedException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_BRLActionVariableColumn implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_backend_vfs_PathFactory_erraiD_PathImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ConditionCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_soup_project_datamodel_oracle_MethodInfo implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_ColumnType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_preferences_shared_bean_mock_PortablePreferenceMockPortableGeneratedImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_services_shared_preferences_MultiGridPreferencesStore implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_shared_message_Level implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_RepositoryUpdatedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_persistence_PersistableDataObject implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_soup_project_datamodel_oracle_Annotation implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_services_verifier_plugin_client_api_FactTypes_erraiD_FactType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_backend_vfs_impl_ObservablePathImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableListParameterDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_Framework implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_nodes_impl_ActionInsertNodeImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_group_GroupFunction implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_exception_UnsupportedServiceCapabilityException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_ModuleRootPathIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_DriverRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableEnumParameterDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_PullRequestStatus implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_exception_DataSetLookupException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_CompositeFieldConstraint implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_projecteditor_model_InvalidPomException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_services_shared_preferences_GridGlobalPreferences implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_filter_LogicalExprFilter implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_spec_ProcessConfig implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_util_NamingUtils implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionSetFieldCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceUpdatedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_organizationalunit_impl_OrganizationalUnitImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_NotDirectoryException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_kmodule_QualifierModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_models_datamodel_rule_ActionMultiConstraintBendableLongMatch implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_CapabilityStatus implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_EditorModelContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_FromEntryPointFactPattern implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_properties_editor_model_PropertyEditorFieldInfo implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_verifier_api_reporting_RedundantConditionsIssue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_DeleteColumnAuditLogEntry implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_models_datamodel_rule_ActionMultiConstraintHardMediumSoftMatch implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_source_SourceGenerationFailedException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_library_api_index_LibraryValueFileNameIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_ext_uberfire_social_activities_model_SocialActivitiesEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_model_impl_PartDefinitionImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionInsertFactFieldsPattern implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_BRLConditionColumn implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_AttributeColumnDetails implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_services_shared_preferences_UserPreference implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionFieldVariable implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_model_ContextDisplayMode implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_ActionWorkItemSetFieldColumnDetails implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_social_ModuleEventType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_event_PluginUnregistered implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_library_api_AssetInfo implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_DecisionTableAuditEvents implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_service_DeploymentMode implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_guided_dtable_model_GuidedDecisionTableEditorGraphModel_erraiD_GuidedDecisionTableGraphEntry implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_events_DataSetDefRegisteredEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_globals_model_GlobalsEditorContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_models_datamodel_rule_ActionHardConstraintMatch implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_library_api_ProjectAssetListUpdated implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_PluginAddedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_spec_ServerTemplate implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_FactAssignmentField implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_organizationalunit_NewOrganizationalUnitEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_events_DataSetDefModifiedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_examples_model_ExampleOrganizationalUnit implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_mvp_impl_PathPlaceRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_RuntimePlugin implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_explorer_service_ProjectExplorerContentQuery implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_screens_domaineditor_validation_ScoreHolderGlobalTypeNotRecognizedMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_LayoutEditorModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_RepositoryInfo implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_VerifyFact implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_GuidedDecisionTree implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_Language implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_soup_project_datamodel_oracle_DataType_erraiD_DataTypes implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_spec_RuleConfig implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_events_DataSetModifiedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_core_config_heuristic_selector_entity_EntitySorterManner implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_experimental_service_definition_ExperimentalFeatureDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_library_api_index_LibraryFileNameIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_navigator_DataContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_RepositoryRemovedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_explorer_service_ActiveOptions implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_builder_events_InvalidateDMOModuleCacheEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_BuilderResultLine implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_m2repo_model_JarListPageRow implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_nodes_impl_ConstraintNodeImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionRetractFactCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_GuidedDecisionTable52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_workingset_client_model_WorkingSetConfigData implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_RepositoryEnvironmentConfigurations implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_service_PartType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_FromCollectCompositeFactPattern implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValuePackageNameIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_drltext_model_DrlModelContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_MetadataCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_WorkItemHandlerModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_scorecard_shared_Characteristic implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_CallFixtureMap implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_CallMethod implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_globals_model_Global implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_preferences_shared_impl_DefaultPreferenceScopeResolver implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_Plugin implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_models_datamodel_rule_ActionSimpleConstraintMatch implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceUpdated implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_events_ServerTemplateDeleted implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_verifier_api_reporting_ValueForFactFieldIsSetTwiceIssue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_factmodel_model_AnnotationMetaModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionCallMethod implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_UnsupportedFieldNatureTypeParserMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_soup_project_datamodel_oracle_ModelField implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_events_ServerInstanceDisconnected implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_FixtureList implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_shared_metadata_model_DiscussionRecord implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_backend_vfs_FileSystemFactory_erraiD_FileSystemImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_spec_ContainerSpec implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_api_model_Severity implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionWorkItemFieldValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_kmodule_FileLogger implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_verifier_api_reporting_SingleHitLostIssue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_models_datamodel_rule_ActionMultiConstraintHardSoftMatch implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_query_RefactoringPathPageRow implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectDeletedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_organizationalunit_RepoAddedToOrganizationalUnitEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_date_TimeAmount implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_shared_validation_model_ValidationMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_explorer_model_FolderItemType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_api_exception_KieServicesException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_models_datamodel_rule_ActionMultiConstraintBendableBigDecimalMatch implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_services_verifier_plugin_client_api_RequestStatus implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_conversion_ConversionMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_DefaultParserMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_preferences_shared_bean_PreferenceHierarchyElement implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_displayer_DisplayerSettings implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_conversion_ConversionMessageType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_FieldData implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jboss_errai_common_client_PageRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_models_datamodel_rule_ActionSoftConstraintMatch implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_CollectionFieldData implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_LimitedEntryBRLConditionColumn implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_AttributeCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_whitelist_WhiteList implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_experimental_service_registry_impl_ExperimentalFeaturesRegistryImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_editor_commons_file_exports_PdfExportPreferences_erraiD_Format implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectSelectedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_UnsupportedIPatternParserMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_ActionSetFieldColumnDetails implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_explorer_model_ProjectExplorerContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_impl_DataColumnImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_impl_UserAttributeImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_screens_guidedrule_model_BendableScoreLevelsWrapper implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectFieldChangeEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_examples_model_Credentials implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_LimitedEntryBRLActionColumn implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_ModuleRepositories_erraiD_ModuleRepository implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_DSLVariableValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_DataModelImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_messageconsole_events_PublishBatchMessagesEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_service_PackageAlreadyExistsException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_UnsupportedFieldConstraintTypeParserMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_query_RefactoringStringPageRow implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_FieldPlaceHolder implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_model_Notification implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_FullFileNameIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_backend_events_AuthorizationPolicySavedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_MavenRepository implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_MavenRepositorySource implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionMethod implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_GuidedDecisionTreeParserError implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_PluginReloadedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_group_Interval implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_preferences_config_WorkbenchPreferenceScopeResolver implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_apps_api_DirectoryBreadcrumb implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_core_config_localsearch_LocalSearchType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceRenamed implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_explorer_model_FolderItemOperation implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_AnnotationSourceRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_workingset_client_model_WorkingSetSettings implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_DynamicMenu implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_PluginSimpleContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_FixturesMap implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_screens_guidedrule_model_ScoreInformation implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_spec_ContainerConfig implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_Branch implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_soup_project_datamodel_oracle_ModelField_erraiD_FIELD_erraiU_CLASS_erraiU_TYPE implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_auditlog_AuditLog implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_FreeFormLine implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_screens_solver_model_ScoreDirectorFactoryConfigModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_ProjectImports implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_DecisionTableAuditLogFilter implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_RuleModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_displayer_impl_TableDisplayerSettingsBuilderImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_models_datamodel_rule_ActionMediumConstraintMatch implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_events_DeleteModuleEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_service_RelationshipType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_JavaEnumImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_LimitedEntryActionSetFieldCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_service_impact_RefactorOperationRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_DescriptionCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_def_ElasticSearchDataSetDef implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_screens_solver_model_TerminationConfigModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_kmodule_KSessionModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_guided_dtable_model_GuidedDecisionTableEditorGraphContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_services_verifier_plugin_client_api_HeaderMetaData implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_PluginUpdatedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_GAV implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceDeletedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_FactPattern implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableIntegerParameterDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_verifier_api_client_api_WebWorkerException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_events_ModuleUpdatedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_events_ServerInstanceDeleted implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_model_CompassPosition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectCreatedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_MavenRepositoryMetadata implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableStringParameterDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_model_NamedPosition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_exception_UserNotFoundException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_AnnotationRetention implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_BindingNotFoundParserMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_group_ColumnGroup implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_kmodule_ListenerModel_erraiD_Kind implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_events_ServerInstanceConnected implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_impl_RoleManagerSettingsImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_service_ServiceException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_query_RefactoringRuleNamePageRow_erraiD_RuleName implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValueModuleRootPathIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_MetadataColumnDetails implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_conversion_ConversionAsset implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_spec_ServerTemplateKey implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_group_AggregateFunctionType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_layout_editor_api_editor_LayoutComponent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_AnnotationValuePairDefinitionImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionText implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_filter_CoreFunctionType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_service_impact_QueryOperationRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_event_PluginAdded implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValueResourceIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionGlobalVariable implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_FileSystemNotFoundException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_RepositoryEnvironmentUpdatedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_FromAccumulateCompositeFactPattern implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_screens_domaineditor_model_ObjectPropertyPathImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_examples_model_ExampleRepository implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_explorer_model_FolderItem implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_ActionWorkItemColumnDetails implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_navigation_layout_LayoutNavigationRef implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_ColumnDetails implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_AnnotationDefinitionImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_Package implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_soup_project_datamodel_imports_Import implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataModelStatusChangeEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ssh_service_shared_editor_PortableSSHPublicKey implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_screens_solver_model_ConstructionHeuristicTypeModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_runtime_ContainerList implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_LimitedEntryActionSetFieldColumnDetails implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_shared_metadata_model_Overview implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_library_api_preferences_LibraryOrganizationalUnitPreferencesPortableGeneratedImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_server_management_model_ContainerSpecData implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValueModuleNameIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_DirectoryNotEmptyException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_date_TimeFrame implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_security_OrgUnitResourceType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionCollection implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_JavaTypeInfoImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_experimental_service_events_PortableExperimentalFeatureModifiedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_CodeType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_nodes_impl_TypeNodeImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableWorkDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_kmodule_SingleValueItemObjectModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_runtime_ServerInstance implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_ConditionColumnDetails implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_events_RuleConfigUpdated implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_preferences_shared_impl_PreferenceScopeImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceAdded implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_backend_vfs_impl_LockResult implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_layout_editor_api_editor_LayoutTemplate_erraiD_Style implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_context_WorkspaceProjectContextChangeEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_factmodel_model_FactModels implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_InvalidPathException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_LimitedEntryActionInsertFactCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_RepositoryAlreadyExistsException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_def_DataSetDef implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_kmodule_KModuleModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_def_BeanDataSetDef implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_impl_DataSetBuilderImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_verifier_api_reporting_Issue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_TypeImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_SharedPartIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_auditlog_DefaultAuditLogFilter implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_m2repo_preferences_ArtifactRepositoryPreferencePortableGeneratedImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_globals_model_GlobalsModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_spaces_Space implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_kmodule_KBaseModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_visitors_CopyExpressionVisitor implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_BRLActionColumn implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_organizationalunit_UpdatedOrganizationalUnitEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_organizationalunit_RemoveOrganizationalUnitEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionFieldValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_verifier_api_reporting_Issues implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_shared_exceptions_GenericPortableException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_PartIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectChangeEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_Media implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_DeleteRowAuditLogEntry implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_services_verifier_plugin_client_api_ModelMetaData implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataprovider_DefaultProviderType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_ext_uberfire_social_activities_model_SocialPaged_erraiD_Direction implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_JavaInterfaceImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_screens_domaineditor_validation_ScoreHolderGlobalTypeToBeChangedMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_Pattern52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataModelReload implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceAddedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_validation_PersistenceDescriptorValidationMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_soup_project_datamodel_oracle_ModelField_erraiD_FIELD_erraiU_ORIGIN implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_LimitedEntryActionRetractFactCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_IntegerValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_def_SQLDataSourceDef implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_impl_DataSetMetadataImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceCopiedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_properties_editor_model_validators_LongValidator implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_screens_domaineditor_validation_ScoreHolderGlobalFileToBeRemovedMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_def_StaticDataSetDef implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValuePartReferenceIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_screens_solver_model_TerminationCompositionStyleModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_event_PluginRenamed implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_examples_model_ImportProject implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_editor_commons_readonly_ReadOnlyPathPlaceRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_impl_git_GitRepository implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_DateValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionWorkItemSetFieldCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_date_DayOfWeek implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_runtime_ServerInstanceKey implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_DSLComplexVariableValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_screens_domaineditor_validation_PlanningScoreToBeDeletedMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_DataSetLookup implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceDeleted implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_impl_DataSetImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_Dependencies implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_optaplanner_workbench_screens_solver_model_SolverConfigModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_spec_Capability implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_messageconsole_events_UnpublishMessagesEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_api_model_KieContainerStatus implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_SingleFieldConstraint implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceCopied implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_soup_project_datamodel_oracle_TypeSource implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_exception_SecurityManagementException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionUnboundFact implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_projecteditor_model_GitUrl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_social_OrganizationalUnitEventType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_navigation_impl_NavDividerImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_guided_template_model_GuidedTemplateEditorContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_services_verifier_plugin_client_api_Update implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_AmbiguousRootParserMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_impl_DataSetLookupBuilderImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_JavaTypeKind implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_FileSystemException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_shared_test_Failure implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_ext_uberfire_social_activities_model_SocialPaged implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceBatchChangesEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_filter_LogicalExprType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValueRelationshipIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_ext_uberfire_social_activities_model_SocialActivitiesEvent_erraiD_LINK_erraiU_TYPE implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_editor_commons_file_exports_PdfExportPreferences implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValueFullFileNameIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_model_impl_PerspectiveDefinitionImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_service_GAVAlreadyExistsException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_exception_GroupNotFoundException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_library_api_preferences_LibraryProjectPreferencesPortableGeneratedImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_adaptors_Pattern52FactPatternAdaptor implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_service_impact_AbstractOperationRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_dependencies_EnhancedDependencies implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_event_MediaDeleted implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_AnnotationSource implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_preferences_shared_impl_exception_InvalidPreferenceScopeException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_messageconsole_events_PublishMessagesEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_properties_editor_model_PropertyEditorCategory implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_screens_dsltext_model_DSLTextEditorContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_controller_api_model_events_ServerInstanceUpdated implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_AnnotationImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionCol52 implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_ext_uberfire_social_activities_events_SocialUserFollowedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_Activity implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_layout_editor_api_editor_LayoutRow implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_ActivateRuleFlowGroup implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_exception_OperationFailedException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_impl_SearchRequestImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_kmodule_ClockTypeOption implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectFieldCreatedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_navigation_layout_LayoutTemplateInfo implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_BaseColumnFieldDiffImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_services_verifier_plugin_client_api_FactTypes implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_def_CSVDataSetDef implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_PullRequestAlreadyExistsException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_InsertColumnAuditLogEntry implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_soup_project_datamodel_oracle_FieldAccessorsAndMutators implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_library_api_index_LibraryRepositoryRootIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_DriverResponse implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_ReferenceIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_AnnotationDefinitionRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_preferences_shared_impl_PreferenceScopeResolutionStrategyInfo implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_config_SystemRepositoryChangedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_security_impl_authz_DefaultAuthorizationEntry implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_date_TimeInstant implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValueReferenceIndexTerm implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_verifier_api_reporting_Severity implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_testscenarios_shared_Scenario implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_editor_commons_file_exports_FileExportsPreferences implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_preferences_GeneralPreferences implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_preferences_GAVPreferences implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_library_api_preferences_LibraryPreferences implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_library_api_preferences_LibraryInternalPreferences implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_preferences_shared_bean_mock_PortablePreferenceMock implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_library_api_preferences_LibraryOrganizationalUnitPreferences implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_m2repo_preferences_ArtifactRepositoryPreference implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_library_api_preferences_LibraryProjectPreferences implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValueIndexTerm_erraiD_TermSearchType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_services_shared_preferences_UserPreferencesType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_backend_plugin_PluginProcessor_erraiD_PluginProcessorType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_refactoring_service_impact_OperationType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_navigation_NavItem_erraiD_Type implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_sort_SortOrder implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_library_api_AssetQueryResult_erraiD_ResultType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_server_management_model_ContainerRuntimeState implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_screens_server_management_model_ContainerRuntimeOperation implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_properties_editor_model_PropertyEditorType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_server_api_model_KieScannerStatus implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_GuidedDecisionTable52_erraiD_TableFormat implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_GuidedDecisionTable52_erraiD_HitPolicy implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_NotificationEvent_erraiD_NotificationType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodeller_core_AnnotationValuePairDefinition_erraiD_ValuePairType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_shared_kmodule_DeclarativeAgendaOption implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_services_verifier_plugin_client_builders_ModelMetaDataEnhancer_erraiD_PatternType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_dashbuilder_dataset_date_TimeInstant_erraiD_TimeMode implements GeneratedMarshaller { }
  public MarshallerFactoryImpl() {
    final ObjectMarshaller java_lang_Object = new ObjectMarshaller();
    marshallers.put("java.lang.Object", java_lang_Object);
    final BigDecimalMarshaller java_math_BigDecimal = new BigDecimalMarshaller();
    marshallers.put("java.math.BigDecimal", java_math_BigDecimal);
    final QualifyingMarshallerWrapper<Map> java_util_Map = new QualifyingMarshallerWrapper(new MapMarshaller(), MapMarshaller.class);
    marshallers.put("java.util.Map", java_util_Map);
    marshallers.put("java.util.AbstractMap", java_util_Map);
    marshallers.put("java.util.HashMap", java_util_Map);
    marshallers.put("java.util.Collections$SynchronizedMap", java_util_Map);
    marshallers.put("java.util.Collections$EmptyMap", java_util_Map);
    marshallers.put("java.util.Collections$UnmodifiableMap", java_util_Map);
    marshallers.put("java.util.Collections$SingletonMap", java_util_Map);
    final QualifyingMarshallerWrapper<AbstractMap> java_util_AbstractMap = new QualifyingMarshallerWrapper(new MapMarshaller(), MapMarshaller.class);
    marshallers.put("java.util.AbstractMap", java_util_AbstractMap);
    final QualifyingMarshallerWrapper<HashMap> java_util_HashMap = new QualifyingMarshallerWrapper(new MapMarshaller(), MapMarshaller.class);
    marshallers.put("java.util.HashMap", java_util_HashMap);
    final BooleanMarshaller java_lang_Boolean = new BooleanMarshaller();
    marshallers.put("java.lang.Boolean", java_lang_Boolean);
    final DateMarshaller java_util_Date = new DateMarshaller();
    marshallers.put("java.util.Date", java_util_Date);
    final FloatMarshaller java_lang_Float = new FloatMarshaller();
    marshallers.put("java.lang.Float", java_lang_Float);
    final ByteMarshaller java_lang_Byte = new ByteMarshaller();
    marshallers.put("java.lang.Byte", java_lang_Byte);
    final QualifyingMarshallerWrapper<SortedMap> java_util_SortedMap = new QualifyingMarshallerWrapper(new SortedMapMarshaller(), SortedMapMarshaller.class);
    marshallers.put("java.util.SortedMap", java_util_SortedMap);
    marshallers.put("java.util.TreeMap", java_util_SortedMap);
    marshallers.put("java.util.Collections$SynchronizedSortedMap", java_util_SortedMap);
    marshallers.put("java.util.Collections$UnmodifiableSortedMap", java_util_SortedMap);
    final QualifyingMarshallerWrapper<TreeMap> java_util_TreeMap = new QualifyingMarshallerWrapper(new SortedMapMarshaller(), SortedMapMarshaller.class);
    marshallers.put("java.util.TreeMap", java_util_TreeMap);
    final QualifyingMarshallerWrapper<LinkedHashMap> java_util_LinkedHashMap = new QualifyingMarshallerWrapper(new LinkedMapMarshaller(), LinkedMapMarshaller.class);
    marshallers.put("java.util.LinkedHashMap", java_util_LinkedHashMap);
    final BigIntegerMarshaller java_math_BigInteger = new BigIntegerMarshaller();
    marshallers.put("java.math.BigInteger", java_math_BigInteger);
    final DoubleMarshaller java_lang_Double = new DoubleMarshaller();
    marshallers.put("java.lang.Double", java_lang_Double);
    final SQLDateMarshaller java_sql_Date = new SQLDateMarshaller();
    marshallers.put("java.sql.Date", java_sql_Date);
    final StringMarshaller java_lang_String = new StringMarshaller();
    marshallers.put("java.lang.String", java_lang_String);
    final SessionInfoMarshalller org_uberfire_rpc_SessionInfo = new SessionInfoMarshalller();
    marshallers.put("org.uberfire.rpc.SessionInfo", org_uberfire_rpc_SessionInfo);
    final LinkedHashSetMarshaller java_util_LinkedHashSet = new LinkedHashSetMarshaller();
    marshallers.put("java.util.LinkedHashSet", java_util_LinkedHashSet);
    final StringBuilderMarshaller java_lang_StringBuilder = new StringBuilderMarshaller();
    marshallers.put("java.lang.StringBuilder", java_lang_StringBuilder);
    final IntegerMarshaller java_lang_Integer = new IntegerMarshaller();
    marshallers.put("java.lang.Integer", java_lang_Integer);
    final TimestampMarshaller java_sql_Timestamp = new TimestampMarshaller();
    marshallers.put("java.sql.Timestamp", java_sql_Timestamp);
    final SetMarshaller java_util_Set = new SetMarshaller();
    marshallers.put("java.util.Set", java_util_Set);
    marshallers.put("java.util.AbstractSet", java_util_Set);
    marshallers.put("java.util.HashSet", java_util_Set);
    marshallers.put("java.util.Collections$SynchronizedSet", java_util_Set);
    marshallers.put("java.util.Collections$UnmodifiableSet", java_util_Set);
    marshallers.put("java.util.Collections$SingletonSet", java_util_Set);
    marshallers.put("java.util.Collections$EmptySet", java_util_Set);
    final SetMarshaller java_util_AbstractSet = new SetMarshaller();
    marshallers.put("java.util.AbstractSet", java_util_AbstractSet);
    final SetMarshaller java_util_HashSet = new SetMarshaller();
    marshallers.put("java.util.HashSet", java_util_HashSet);
    final LinkedListMarshaller java_util_LinkedList = new LinkedListMarshaller();
    marshallers.put("java.util.LinkedList", java_util_LinkedList);
    final LongMarshaller java_lang_Long = new LongMarshaller();
    marshallers.put("java.lang.Long", java_lang_Long);
    final ClientClassMarshaller java_lang_Class = new ClientClassMarshaller();
    marshallers.put("java.lang.Class", java_lang_Class);
    final ListMarshaller java_util_List = new ListMarshaller();
    marshallers.put("java.util.List", java_util_List);
    marshallers.put("java.util.AbstractList", java_util_List);
    marshallers.put("java.util.ArrayList", java_util_List);
    marshallers.put("java.util.Vector", java_util_List);
    marshallers.put("java.util.Stack", java_util_List);
    marshallers.put("java.util.Collections$SynchronizedRandomAccessList", java_util_List);
    marshallers.put("java.util.Collections$SynchronizedList", java_util_List);
    marshallers.put("java.util.Collections$SingletonList", java_util_List);
    marshallers.put("java.util.Collections$EmptyList", java_util_List);
    marshallers.put("java.util.Collections$UnmodifiableRandomAccessList", java_util_List);
    marshallers.put("java.util.Collections$UnmodifiableList", java_util_List);
    marshallers.put("java.util.Arrays$ArrayList", java_util_List);
    final ListMarshaller java_util_AbstractList = new ListMarshaller();
    marshallers.put("java.util.AbstractList", java_util_AbstractList);
    final ListMarshaller java_util_ArrayList = new ListMarshaller();
    marshallers.put("java.util.ArrayList", java_util_ArrayList);
    final ListMarshaller java_util_Vector = new ListMarshaller();
    marshallers.put("java.util.Vector", java_util_Vector);
    final ListMarshaller java_util_Stack = new ListMarshaller();
    marshallers.put("java.util.Stack", java_util_Stack);
    final QueueMarshaller java_util_Queue = new QueueMarshaller();
    marshallers.put("java.util.Queue", java_util_Queue);
    marshallers.put("java.util.AbstractQueue", java_util_Queue);
    final QueueMarshaller java_util_AbstractQueue = new QueueMarshaller();
    marshallers.put("java.util.AbstractQueue", java_util_AbstractQueue);
    final ShortMarshaller java_lang_Short = new ShortMarshaller();
    marshallers.put("java.lang.Short", java_lang_Short);
    final OptionalMarshaller java_util_Optional = new OptionalMarshaller();
    marshallers.put("java.util.Optional", java_util_Optional);
    final CharacterMarshaller java_lang_Character = new CharacterMarshaller();
    marshallers.put("java.lang.Character", java_lang_Character);
    final StringBufferMarshaller java_lang_StringBuffer = new StringBufferMarshaller();
    marshallers.put("java.lang.StringBuffer", java_lang_StringBuffer);
    final TimeMarshaller java_sql_Time = new TimeMarshaller();
    marshallers.put("java.sql.Time", java_sql_Time);
    final SortedSetMarshaller java_util_SortedSet = new SortedSetMarshaller();
    marshallers.put("java.util.SortedSet", java_util_SortedSet);
    marshallers.put("java.util.TreeSet", java_util_SortedSet);
    marshallers.put("java.util.Collections$UnmodifiableSortedSet", java_util_SortedSet);
    marshallers.put("java.util.Collections$SynchronizedSortedSet", java_util_SortedSet);
    final SortedSetMarshaller java_util_TreeSet = new SortedSetMarshaller();
    marshallers.put("java.util.TreeSet", java_util_TreeSet);
    final PriorityQueueMarshaller java_util_PriorityQueue = new PriorityQueueMarshaller();
    marshallers.put("java.util.PriorityQueue", java_util_PriorityQueue);
  }

  private boolean putMarshaller(String fqcn, Marshaller m) {
    marshallers.put(fqcn, m);
    return true;
  }

  private boolean loadMarshaller0(String a0) {
    switch (a0) {
      case "org.optaplanner.core.api.score.buildin.bendablebigdecimal.BendableBigDecimalScore": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_core_api_score_buildin_bendablebigdecimal_BendableBigDecimalScore.class));
      case "org.optaplanner.core.api.score.buildin.hardmediumsoftbigdecimal.HardMediumSoftBigDecimalScore": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_core_api_score_buildin_hardmediumsoftbigdecimal_HardMediumSoftBigDecimalScore.class));
      case "org.optaplanner.core.api.score.buildin.simplebigdecimal.SimpleBigDecimalScore": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_core_api_score_buildin_simplebigdecimal_SimpleBigDecimalScore.class));
      case "org.optaplanner.core.api.score.buildin.hardsoftbigdecimal.HardSoftBigDecimalScore": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_core_api_score_buildin_hardsoftbigdecimal_HardSoftBigDecimalScore.class));
      case "org.optaplanner.core.api.score.buildin.hardsoftdouble.HardSoftDoubleScore": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_core_api_score_buildin_hardsoftdouble_HardSoftDoubleScore.class));
      case "org.optaplanner.core.api.score.buildin.simpledouble.SimpleDoubleScore": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_core_api_score_buildin_simpledouble_SimpleDoubleScore.class));
      case "org.optaplanner.core.api.score.buildin.hardmediumsoftlong.HardMediumSoftLongScore": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_core_api_score_buildin_hardmediumsoftlong_HardMediumSoftLongScore.class));
      case "org.optaplanner.core.api.score.buildin.bendable.BendableScore": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_core_api_score_buildin_bendable_BendableScore.class));
      case "org.optaplanner.core.api.score.buildin.simple.SimpleScore": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_core_api_score_buildin_simple_SimpleScore.class));
      case "java.lang.Throwable": return putMarshaller(a0, GWT.create(Marshaller_for_java_lang_Throwable.class));
      case "java.lang.ArithmeticException": return putMarshaller(a0, GWT.create(Marshaller_for_java_lang_ArithmeticException.class));
      case "java.io.IOException": return putMarshaller(a0, GWT.create(Marshaller_for_java_io_IOException.class));
      case "java.lang.IllegalArgumentException": return putMarshaller(a0, GWT.create(Marshaller_for_java_lang_IllegalArgumentException.class));
      case "java.util.EmptyStackException": return putMarshaller(a0, GWT.create(Marshaller_for_java_util_EmptyStackException.class));
      case "java.lang.ArrayStoreException": return putMarshaller(a0, GWT.create(Marshaller_for_java_lang_ArrayStoreException.class));
      case "java.lang.ClassCastException": return putMarshaller(a0, GWT.create(Marshaller_for_java_lang_ClassCastException.class));
      case "java.util.ConcurrentModificationException": return putMarshaller(a0, GWT.create(Marshaller_for_java_util_ConcurrentModificationException.class));
      case "java.lang.IndexOutOfBoundsException": return putMarshaller(a0, GWT.create(Marshaller_for_java_lang_IndexOutOfBoundsException.class));
      case "java.lang.NegativeArraySizeException": return putMarshaller(a0, GWT.create(Marshaller_for_java_lang_NegativeArraySizeException.class));
      case "java.lang.NullPointerException": return putMarshaller(a0, GWT.create(Marshaller_for_java_lang_NullPointerException.class));
      case "java.lang.StringIndexOutOfBoundsException": return putMarshaller(a0, GWT.create(Marshaller_for_java_lang_StringIndexOutOfBoundsException.class));
      case "java.lang.UnsupportedOperationException": return putMarshaller(a0, GWT.create(Marshaller_for_java_lang_UnsupportedOperationException.class));
      case "java.lang.AssertionError": return putMarshaller(a0, GWT.create(Marshaller_for_java_lang_AssertionError.class));
      case "java.lang.RuntimeException": return putMarshaller(a0, GWT.create(Marshaller_for_java_lang_RuntimeException.class));
      case "org.optaplanner.core.api.score.buildin.hardmediumsoft.HardMediumSoftScore": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_core_api_score_buildin_hardmediumsoft_HardMediumSoftScore.class));
      case "org.optaplanner.core.api.score.buildin.simplelong.SimpleLongScore": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_core_api_score_buildin_simplelong_SimpleLongScore.class));
      case "org.jboss.errai.security.shared.exception.SecurityException": return putMarshaller(a0, GWT.create(Marshaller_for_org_jboss_errai_security_shared_exception_SecurityException.class));
      case "org.jboss.errai.security.shared.exception.UnauthenticatedException": return putMarshaller(a0, GWT.create(Marshaller_for_org_jboss_errai_security_shared_exception_UnauthenticatedException.class));
      case "org.jboss.errai.security.shared.exception.UnauthorizedException": return putMarshaller(a0, GWT.create(Marshaller_for_org_jboss_errai_security_shared_exception_UnauthorizedException.class));
      case "org.jboss.errai.security.shared.exception.AuthenticationException": return putMarshaller(a0, GWT.create(Marshaller_for_org_jboss_errai_security_shared_exception_AuthenticationException.class));
      case "java.lang.StackTraceElement": return putMarshaller(a0, GWT.create(Marshaller_for_java_lang_StackTraceElement.class));
      case "org.optaplanner.core.api.score.buildin.hardsoft.HardSoftScore": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_core_api_score_buildin_hardsoft_HardSoftScore.class));
      case "org.optaplanner.core.api.score.buildin.bendablelong.BendableLongScore": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_core_api_score_buildin_bendablelong_BendableLongScore.class));
      case "org.optaplanner.core.api.score.buildin.hardsoftlong.HardSoftLongScore": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_core_api_score_buildin_hardsoftlong_HardSoftLongScore.class));
      case "org.guvnor.common.services.project.model.ModuleRepositories": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_ModuleRepositories.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.ActionInsertFactCol52": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionInsertFactCol52.class));
      case "org.drools.workbench.screens.guided.dtable.model.GuidedDecisionTableEditorGraphModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_screens_guided_dtable_model_GuidedDecisionTableEditorGraphModel.class));
      case "org.kie.workbench.common.services.datamodeller.core.impl.ObjectPropertyImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_ObjectPropertyImpl.class));
      case "org.drools.workbench.services.verifier.plugin.client.api.Initialize": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_services_verifier_plugin_client_api_Initialize.class));
      case "org.guvnor.common.services.project.model.Module": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_Module.class));
      case "org.uberfire.ext.plugin.event.MediaAdded": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_event_MediaAdded.class));
      case "org.uberfire.preferences.shared.bean.PreferenceRootElement": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_preferences_shared_bean_PreferenceRootElement.class));
      case "org.dashbuilder.dataprovider.BeanProviderType": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataprovider_BeanProviderType.class));
      case "org.kie.workbench.common.screens.explorer.model.URIStructureExplorerModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_explorer_model_URIStructureExplorerModel.class));
      case "org.kie.workbench.common.services.refactoring.model.query.RefactoringMapPageRow": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_query_RefactoringMapPageRow.class));
      case "org.kie.workbench.common.screens.datamodeller.events.ChangeType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_ChangeType.class));
      case "org.drools.workbench.models.datamodel.oracle.DSLActionSentence": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_oracle_DSLActionSentence.class));
      case "org.kie.workbench.common.screens.library.api.index.LibraryValueRepositoryRootIndexTerm": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_library_api_index_LibraryValueRepositoryRootIndexTerm.class));
      case "org.uberfire.ext.plugin.event.NewPluginRegistered": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_event_NewPluginRegistered.class));
      case "org.uberfire.workbench.model.Notification$State": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_model_Notification_erraiD_State.class));
      case "org.drools.verifier.api.reporting.MultipleValuesForOneActionIssue": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_verifier_api_reporting_MultipleValuesForOneActionIssue.class));
      case "org.kie.server.controller.api.model.spec.ContainerSpecList": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_controller_api_model_spec_ContainerSpecList.class));
      case "org.uberfire.mvp.impl.ForcedPlaceRequest": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_mvp_impl_ForcedPlaceRequest.class));
      case "org.ext.uberfire.social.activities.model.DefaultTypes": return putMarshaller(a0, GWT.create(Marshaller_for_org_ext_uberfire_social_activities_model_DefaultTypes.class));
      case "org.guvnor.structure.organizationalunit.RepoRemovedFromOrganizationalUnitEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_organizationalunit_RepoRemovedFromOrganizationalUnitEvent.class));
      case "org.uberfire.experimental.service.backend.impl.ExperimentalFeaturesSessionImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_experimental_service_backend_impl_ExperimentalFeaturesSessionImpl.class));
      case "org.uberfire.workbench.events.ResourceRenamedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceRenamedEvent.class));
      case "org.drools.workbench.screens.guided.dtable.model.GuidedDecisionTableEditorContent": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_screens_guided_dtable_model_GuidedDecisionTableEditorContent.class));
      case "org.kie.workbench.common.screens.datamodeller.events.DataModelerEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataModelerEvent.class));
      case "org.kie.workbench.common.services.shared.kmodule.ConsoleLogger": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_kmodule_ConsoleLogger.class));
      case "org.drools.workbench.models.datamodel.rule.DSLSentence": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_DSLSentence.class));
      case "org.drools.workbench.models.datamodel.rule.ActionRetractFact": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionRetractFact.class));
      case "org.jboss.errai.security.shared.exception.FailedAuthenticationException": return putMarshaller(a0, GWT.create(Marshaller_for_org_jboss_errai_security_shared_exception_FailedAuthenticationException.class));
      case "org.kie.workbench.common.screens.datamodeller.model.persistence.CachingType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_persistence_CachingType.class));
      case "org.uberfire.experimental.service.editor.EditableExperimentalFeature": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_experimental_service_editor_EditableExperimentalFeature.class));
      case "org.kie.workbench.common.screens.datamodeller.model.persistence.PersistenceUnitModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_persistence_PersistenceUnitModel.class));
      case "org.drools.workbench.models.guided.dtable.shared.auditlog.ActionWorkItemInsertFactColumnDetails": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_ActionWorkItemInsertFactColumnDetails.class));
      case "org.uberfire.ext.security.management.api.exception.EntityNotFoundException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_exception_EntityNotFoundException.class));
      case "org.dashbuilder.dataset.events.DataSetStaleEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_events_DataSetStaleEvent.class));
      case "org.uberfire.ext.layout.editor.api.editor.LayoutTemplate": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_layout_editor_api_editor_LayoutTemplate.class));
      case "org.uberfire.ext.services.shared.preferences.GridPreferencesStore": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_services_shared_preferences_GridPreferencesStore.class));
      case "org.kie.workbench.common.services.datamodeller.core.ElementType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_ElementType.class));
      case "org.uberfire.workbench.events.ResourceChangeType": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceChangeType.class));
      case "org.kie.workbench.common.services.shared.kmodule.ListenerModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_kmodule_ListenerModel.class));
      case "org.drools.workbench.models.datamodel.workitems.PortableBooleanParameterDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableBooleanParameterDefinition.class));
      case "org.uberfire.ext.security.management.impl.SearchResponseImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_impl_SearchResponseImpl.class));
      case "org.uberfire.security.authz.AuthorizationResult": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_security_authz_AuthorizationResult.class));
      case "org.dashbuilder.navigation.impl.NavTreeImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_navigation_impl_NavTreeImpl.class));
      case "org.uberfire.security.impl.authz.DefaultAuthorizationPolicy": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_security_impl_authz_DefaultAuthorizationPolicy.class));
      case "org.kie.workbench.common.services.datamodeller.core.impl.ParameterImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_ParameterImpl.class));
      case "org.guvnor.structure.repositories.EnvironmentParameters": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_EnvironmentParameters.class));
      case "org.drools.workbench.models.datamodel.rule.ExpressionVariable": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionVariable.class));
      case "org.dashbuilder.dataset.events.DataSetPushOkEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_events_DataSetPushOkEvent.class));
      case "org.drools.workbench.services.verifier.plugin.client.api.FactTypes$Field": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_services_verifier_plugin_client_api_FactTypes_erraiD_Field.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.values.impl.BigIntegerValue": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_BigIntegerValue.class));
      case "org.dashbuilder.navigation.layout.LayoutRecursionIssue": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_navigation_layout_LayoutRecursionIssue.class));
      case "org.jboss.errai.security.shared.exception.AlreadyLoggedInException": return putMarshaller(a0, GWT.create(Marshaller_for_org_jboss_errai_security_shared_exception_AlreadyLoggedInException.class));
      case "org.guvnor.common.services.project.builder.model.IncrementalBuildResults": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_builder_model_IncrementalBuildResults.class));
      case "org.kie.workbench.common.services.datamodeller.driver.model.AnnotationParseRequest": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_AnnotationParseRequest.class));
      case "org.drools.workbench.services.verifier.plugin.client.api.RemoveRule": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_services_verifier_plugin_client_api_RemoveRule.class));
      case "org.uberfire.backend.plugin.RuntimePlugin": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_backend_plugin_RuntimePlugin.class));
      case "org.uberfire.ext.plugin.exception.PluginAlreadyExists": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_exception_PluginAlreadyExists.class));
      case "org.drools.verifier.api.Status": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_verifier_api_Status.class));
      case "org.guvnor.common.services.project.security.ProjectResourceType": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_security_ProjectResourceType.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.values.impl.ShortValue": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_ShortValue.class));
      case "org.kie.workbench.common.screens.examples.model.ExamplesModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_examples_model_ExamplesModel.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.DTColumnConfig52": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_DTColumnConfig52.class));
      case "org.uberfire.preferences.shared.impl.validation.ValidationResult": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_preferences_shared_impl_validation_ValidationResult.class));
      case "org.kie.workbench.common.services.datamodeller.core.impl.ImportImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_ImportImpl.class));
      case "org.uberfire.backend.vfs.impl.LockInfo": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_backend_vfs_impl_LockInfo.class));
      case "org.kie.workbench.common.services.refactoring.model.index.terms.valueterms.ValuePartIndexTerm": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValuePartIndexTerm.class));
      case "org.drools.workbench.screens.enums.model.EnumModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_screens_enums_model_EnumModel.class));
      case "org.ext.uberfire.social.activities.events.SocialUserUnFollowedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_ext_uberfire_social_activities_events_SocialUserUnFollowedEvent.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.values.impl.FloatValue": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_FloatValue.class));
      case "org.kie.workbench.common.services.refactoring.model.index.terms.ResourceIndexTerm": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_ResourceIndexTerm.class));
      case "org.kie.workbench.common.services.datamodeller.core.impl.DataObjectImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_DataObjectImpl.class));
      case "org.dashbuilder.dataset.def.DataColumnDef": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_def_DataColumnDef.class));
      case "org.kie.workbench.common.services.refactoring.service.impact.DeleteOperationRequest": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_service_impact_DeleteOperationRequest.class));
      case "org.drools.workbench.models.datamodel.rule.SingleFieldConstraintEBLeftSide": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_SingleFieldConstraintEBLeftSide.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.parser.messages.UnsupportedIActionParserMessage": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_UnsupportedIActionParserMessage.class));
      case "org.drools.verifier.api.reporting.ImpossibleMatchIssue": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_verifier_api_reporting_ImpossibleMatchIssue.class));
      case "org.drools.workbench.services.verifier.plugin.client.api.DeleteColumns": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_services_verifier_plugin_client_api_DeleteColumns.class));
      case "org.uberfire.ext.security.management.impl.UserManagerSettingsImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_impl_UserManagerSettingsImpl.class));
      case "org.uberfire.java.nio.file.FileAlreadyExistsException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_java_nio_file_FileAlreadyExistsException.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.values.impl.LongValue": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_LongValue.class));
      case "org.uberfire.ext.plugin.model.Plugin": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_Plugin.class));
      case "org.drools.workbench.models.datamodel.rule.ActionUpdateField": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionUpdateField.class));
      case "org.guvnor.messageconsole.events.SystemMessage": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_messageconsole_events_SystemMessage.class));
      case "org.drools.workbench.screens.guided.rule.model.GuidedEditorContent": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_screens_guided_rule_model_GuidedEditorContent.class));
      case "org.guvnor.common.services.project.events.NewPackageEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_events_NewPackageEvent.class));
      case "org.kie.workbench.common.screens.datamodeller.events.DataModelSaved": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataModelSaved.class));
      case "org.drools.workbench.screens.workitems.model.WorkItemDefinitionElements": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_screens_workitems_model_WorkItemDefinitionElements.class));
      case "org.kie.server.controller.api.model.events.ServerTemplateUpdated": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_controller_api_model_events_ServerTemplateUpdated.class));
      case "org.kie.workbench.common.screens.datamodeller.model.persistence.TransactionType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_persistence_TransactionType.class));
      case "org.kie.workbench.common.services.datamodel.model.PackageDataModelOracleBaselinePayload": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodel_model_PackageDataModelOracleBaselinePayload.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.BRLConditionVariableColumn": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_BRLConditionVariableColumn.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.nodes.impl.ActionUpdateNodeImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_nodes_impl_ActionUpdateNodeImpl.class));
      case "org.kie.workbench.common.services.datamodeller.driver.model.AnnotationSourceResponse": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_AnnotationSourceResponse.class));
      case "org.kie.workbench.common.screens.library.api.index.LibraryValueFileExtensionIndexTerm": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_library_api_index_LibraryValueFileExtensionIndexTerm.class));
      case "org.kie.workbench.common.screens.examples.model.ExampleProjectError": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_examples_model_ExampleProjectError.class));
      case "org.drools.workbench.models.guided.scorecard.shared.ScoreCardModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_scorecard_shared_ScoreCardModel.class));
      case "org.uberfire.ext.plugin.model.DynamicMenuItem": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_DynamicMenuItem.class));
      case "org.uberfire.ext.properties.editor.model.validators.TextValidator": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_properties_editor_model_validators_TextValidator.class));
      case "org.kie.server.api.model.Message": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_api_model_Message.class));
      case "org.drools.workbench.models.datamodel.rule.RuleAttribute": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_RuleAttribute.class));
      case "org.kie.workbench.common.screens.datamodeller.model.persistence.PersistenceDescriptorEditorContent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_persistence_PersistenceDescriptorEditorContent.class));
      case "org.kie.workbench.common.services.datamodel.model.PackageDataModelOracleIncrementalPayload": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodel_model_PackageDataModelOracleIncrementalPayload.class));
      case "org.kie.server.controller.api.model.spec.ServerTemplateList": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_controller_api_model_spec_ServerTemplateList.class));
      case "org.jboss.errai.security.shared.api.RoleImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_jboss_errai_security_shared_api_RoleImpl.class));
      case "org.optaplanner.workbench.screens.domaineditor.validation.ScoreHolderGlobalToBeRemovedMessage": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_workbench_screens_domaineditor_validation_ScoreHolderGlobalToBeRemovedMessage.class));
      case "org.drools.workbench.screens.testscenario.model.TestScenarioResult": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_screens_testscenario_model_TestScenarioResult.class));
      case "org.drools.workbench.models.datamodel.workitems.PortableFloatParameterDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableFloatParameterDefinition.class));
      case "org.guvnor.common.services.project.builder.events.InvalidateDMOPackageCacheEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_builder_events_InvalidateDMOPackageCacheEvent.class));
      case "org.kie.server.api.exception.KieServicesHttpException": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_api_exception_KieServicesHttpException.class));
      case "org.uberfire.preferences.shared.impl.PreferenceScopedValue": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_preferences_shared_impl_PreferenceScopedValue.class));
      case "org.dashbuilder.navigation.impl.NavItemImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_navigation_impl_NavItemImpl.class));
      case "org.uberfire.workbench.events.ResourceOpenedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceOpenedEvent.class));
      case "org.guvnor.m2repo.model.JarListPageRequest": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_m2repo_model_JarListPageRequest.class));
      case "org.dashbuilder.dataset.filter.CoreFunctionFilter": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_filter_CoreFunctionFilter.class));
      case "org.drools.workbench.models.testscenarios.shared.VerifyRuleFired": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_VerifyRuleFired.class));
      case "org.drools.workbench.models.guided.scorecard.shared.Attribute": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_scorecard_shared_Attribute.class));
      case "org.kie.workbench.common.services.shared.discussion.CommentAddedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_discussion_CommentAddedEvent.class));
      case "org.uberfire.ext.security.management.impl.GroupManagerSettingsImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_impl_GroupManagerSettingsImpl.class));
      case "org.dashbuilder.navigation.layout.LayoutTemplateContext": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_navigation_layout_LayoutTemplateContext.class));
      case "org.drools.workbench.models.guided.dtable.shared.conversion.ConversionResult": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_conversion_ConversionResult.class));
      case "org.uberfire.ext.plugin.event.PluginSaved": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_event_PluginSaved.class));
      case "org.guvnor.structure.organizationalunit.OrganizationalUnitEventBase": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_organizationalunit_OrganizationalUnitEventBase.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.values.impl.BooleanValue": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_BooleanValue.class));
      case "org.drools.workbench.screens.dtablexls.service.DecisionTableXLSContent": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_screens_dtablexls_service_DecisionTableXLSContent.class));
      case "org.kie.workbench.common.screens.library.api.LibraryInfo": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_library_api_LibraryInfo.class));
      case "org.kie.workbench.common.services.refactoring.model.index.terms.ModuleNameIndexTerm": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_ModuleNameIndexTerm.class));
      case "org.uberfire.backend.vfs.impl.DirectoryStreamImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_backend_vfs_impl_DirectoryStreamImpl.class));
      case "org.drools.workbench.models.datamodel.rule.ExpressionMethodParameter": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionMethodParameter.class));
      case "org.drools.workbench.models.datamodel.rule.CompositeFactPattern": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_CompositeFactPattern.class));
      case "org.uberfire.workbench.events.UberfireJSAPIReadyEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_UberfireJSAPIReadyEvent.class));
      case "org.uberfire.paging.PageRequest": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_paging_PageRequest.class));
      case "org.kie.workbench.common.services.refactoring.model.index.terms.PackageNameIndexTerm": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_PackageNameIndexTerm.class));
      case "org.drools.workbench.models.testscenarios.shared.CallFieldValue": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_CallFieldValue.class));
      case "org.guvnor.common.services.project.builder.model.BuildMessage": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_builder_model_BuildMessage.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.ActionWorkItemInsertFactCol52": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionWorkItemInsertFactCol52.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.ActionWorkItemCol52": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionWorkItemCol52.class));
      case "org.uberfire.workbench.model.impl.PanelDefinitionImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_model_impl_PanelDefinitionImpl.class));
      case "org.dashbuilder.dataprovider.StaticProviderType": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataprovider_StaticProviderType.class));
      case "org.kie.workbench.common.services.refactoring.model.index.terms.RelationshipIndexTerm": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_RelationshipIndexTerm.class));
      case "org.kie.workbench.common.screens.server.management.model.RuntimeStrategy": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_server_management_model_RuntimeStrategy.class));
      case "org.kie.workbench.common.screens.projecteditor.model.ProjectScreenModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_projecteditor_model_ProjectScreenModel.class));
      case "org.jboss.errai.security.shared.api.identity.UserImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_jboss_errai_security_shared_api_identity_UserImpl.class));
      case "org.drools.workbench.models.guided.dtable.shared.auditlog.ActionInsertFactColumnDetails": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_ActionInsertFactColumnDetails.class));
      case "org.dashbuilder.dataset.backend.EditDataSetDef": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_backend_EditDataSetDef.class));
      case "org.guvnor.common.services.project.model.POM": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_POM.class));
      case "org.guvnor.structure.repositories.impl.GitMetadataImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_impl_GitMetadataImpl.class));
      case "org.kie.workbench.common.screens.library.api.index.LibraryFileExtensionIndexTerm": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_library_api_index_LibraryFileExtensionIndexTerm.class));
      case "org.dashbuilder.dataset.def.SQLDataSetDef": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_def_SQLDataSetDef.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.WorkItemColumnParameterValueDiffImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_WorkItemColumnParameterValueDiffImpl.class));
      case "org.drools.workbench.models.guided.dtable.shared.auditlog.LimitedEntryConditionColumnDetails": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_LimitedEntryConditionColumnDetails.class));
      case "org.ext.uberfire.social.activities.model.PagedSocialQuery": return putMarshaller(a0, GWT.create(Marshaller_for_org_ext_uberfire_social_activities_model_PagedSocialQuery.class));
      case "org.drools.workbench.models.datamodel.rule.ExpressionMethodParameterDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionMethodParameterDefinition.class));
      case "org.kie.workbench.common.screens.datamodeller.model.persistence.PersistenceDescriptorModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_persistence_PersistenceDescriptorModel.class));
      case "org.guvnor.messageconsole.events.PublishBaseEvent$Place": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_messageconsole_events_PublishBaseEvent_erraiD_Place.class));
      case "org.kie.soup.project.datamodel.imports.Imports": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_soup_project_datamodel_imports_Imports.class));
      case "org.drools.workbench.models.testscenarios.shared.VerifyField": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_VerifyField.class));
      case "org.drools.workbench.services.verifier.plugin.client.api.MakeRule": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_services_verifier_plugin_client_api_MakeRule.class));
      case "org.uberfire.ext.security.management.api.exception.RealmManagementNotAuthorizedException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_exception_RealmManagementNotAuthorizedException.class));
      case "org.uberfire.ext.apps.api.Directory": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_apps_api_Directory.class));
      case "org.drools.workbench.models.guided.dtable.shared.auditlog.InsertRowAuditLogEntry": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_InsertRowAuditLogEntry.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.nodes.impl.ActionRetractNodeImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_nodes_impl_ActionRetractNodeImpl.class));
      case "org.guvnor.structure.repositories.RepositoryNotFoundException": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_RepositoryNotFoundException.class));
      case "org.kie.workbench.common.services.datamodeller.driver.model.AnnotationDefinitionResponse": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_AnnotationDefinitionResponse.class));
      case "org.kie.soup.project.datamodel.oracle.DataType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_soup_project_datamodel_oracle_DataType.class));
      case "org.drools.workbench.screens.scorecardxls.service.ScoreCardXLSContent": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_screens_scorecardxls_service_ScoreCardXLSContent.class));
      case "org.kie.workbench.common.screens.datamodeller.events.DataModelerValueChangeEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataModelerValueChangeEvent.class));
      case "org.dashbuilder.dataset.group.DateIntervalType": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_group_DateIntervalType.class));
      case "org.uberfire.ext.editor.commons.version.impl.PortableVersionRecord": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_editor_commons_version_impl_PortableVersionRecord.class));
      case "org.drools.workbench.models.datamodel.rule.ActionFieldFunction": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionFieldFunction.class));
      case "org.jboss.errai.security.shared.api.GroupImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_jboss_errai_security_shared_api_GroupImpl.class));
      case "org.kie.workbench.common.services.datamodeller.core.impl.PropertyTypeImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_PropertyTypeImpl.class));
      case "org.kie.workbench.common.screens.server.management.model.MergeMode": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_server_management_model_MergeMode.class));
      case "org.guvnor.common.services.project.model.Build": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_Build.class));
      case "org.ext.uberfire.social.activities.model.SocialUser": return putMarshaller(a0, GWT.create(Marshaller_for_org_ext_uberfire_social_activities_model_SocialUser.class));
      case "org.uberfire.ext.services.shared.preferences.GridColumnPreference": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_services_shared_preferences_GridColumnPreference.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.parser.messages.UnsupportedFieldConstraintParserMessage": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_UnsupportedFieldConstraintParserMessage.class));
      case "org.uberfire.ext.plugin.event.PluginDeleted": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_event_PluginDeleted.class));
      case "org.optaplanner.workbench.screens.domaineditor.validation.ScoreHolderGlobalToBeDefinedManuallyMessage": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_workbench_screens_domaineditor_validation_ScoreHolderGlobalToBeDefinedManuallyMessage.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.RowNumberCol52": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_RowNumberCol52.class));
      case "org.drools.workbench.models.datamodel.workitems.PortableObjectParameterDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableObjectParameterDefinition.class));
      case "org.kie.workbench.common.services.datamodeller.core.impl.JavaClassImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_JavaClassImpl.class));
      case "org.kie.workbench.common.screens.datamodeller.events.DataObjectRenamedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectRenamedEvent.class));
      case "org.uberfire.java.nio.file.ClosedWatchServiceException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_java_nio_file_ClosedWatchServiceException.class));
      case "org.drools.workbench.models.guided.dtable.shared.auditlog.UpdateColumnAuditLogEntry": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_UpdateColumnAuditLogEntry.class));
      case "org.uberfire.ext.editor.commons.file.exports.PdfExportPreferences$Unit": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_editor_commons_file_exports_PdfExportPreferences_erraiD_Unit.class));
      case "org.uberfire.ext.security.management.api.exception.UserAlreadyExistsException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_exception_UserAlreadyExistsException.class));
      case "org.drools.workbench.models.datamodel.rule.ExpressionFormLine": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionFormLine.class));
      case "org.dashbuilder.dataset.sort.DataSetSort": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_sort_DataSetSort.class));
      case "org.guvnor.structure.navigator.NavigatorContent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_navigator_NavigatorContent.class));
      case "org.kie.server.controller.api.model.spec.ContainerSpecKey": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_controller_api_model_spec_ContainerSpecKey.class));
      case "org.kie.workbench.common.services.datamodeller.driver.model.DriverError": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_DriverError.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.parser.messages.DataTypeNotFoundParserMessage": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_DataTypeNotFoundParserMessage.class));
      case "org.drools.workbench.models.testscenarios.shared.Fact": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_Fact.class));
      case "org.guvnor.common.services.project.events.NewProjectEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_events_NewProjectEvent.class));
      case "org.guvnor.common.services.project.model.Dependency": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_Dependency.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.LimitedEntryConditionCol52": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_LimitedEntryConditionCol52.class));
      case "org.uberfire.experimental.service.security.GlobalExperimentalFeatureResourceType": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_experimental_service_security_GlobalExperimentalFeatureResourceType.class));
      case "org.drools.workbench.models.guided.template.shared.TemplateModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_template_shared_TemplateModel.class));
      case "org.dashbuilder.dataset.date.Month": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_date_Month.class));
      case "org.uberfire.ext.editor.commons.file.exports.FileExportsPreferencesPortableGeneratedImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_editor_commons_file_exports_FileExportsPreferencesPortableGeneratedImpl.class));
      case "org.ext.uberfire.social.activities.model.SocialFileSelectedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_ext_uberfire_social_activities_model_SocialFileSelectedEvent.class));
      case "org.kie.server.controller.api.model.spec.ServerConfig": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_controller_api_model_spec_ServerConfig.class));
      case "org.kie.workbench.common.services.refactoring.model.index.terms.ReferencedPartIndexTerm": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_ReferencedPartIndexTerm.class));
      case "org.uberfire.ext.plugin.model.PluginContent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_PluginContent.class));
      case "org.dashbuilder.dataset.date.Quarter": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_date_Quarter.class));
      case "org.drools.workbench.models.datamodel.rule.ActionInsertFact": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionInsertFact.class));
      case "org.drools.workbench.models.datamodel.rule.ConnectiveConstraint": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ConnectiveConstraint.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.parser.messages.DataTypeConversionErrorParserMessage": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_DataTypeConversionErrorParserMessage.class));
      case "org.kie.server.controller.api.model.runtime.ServerInstanceKeyList": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_controller_api_model_runtime_ServerInstanceKeyList.class));
      case "org.uberfire.java.nio.file.FileSystemAlreadyExistsException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_java_nio_file_FileSystemAlreadyExistsException.class));
      case "org.optaplanner.workbench.models.datamodel.rule.ActionMultiConstraintBendableMatch": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_workbench_models_datamodel_rule_ActionMultiConstraintBendableMatch.class));
      case "org.drools.workbench.models.datamodel.rule.ExpressionCollectionIndex": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionCollectionIndex.class));
      case "org.drools.workbench.models.datamodel.oracle.DSLConditionSentence": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_oracle_DSLConditionSentence.class));
      case "org.drools.workbench.models.testscenarios.shared.SingleScenarioResult": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_SingleScenarioResult.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.BRLRuleModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_BRLRuleModel.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.values.impl.DoubleValue": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_DoubleValue.class));
      case "org.kie.workbench.common.services.datamodeller.core.ObjectSource": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_ObjectSource.class));
      case "org.kie.workbench.common.services.refactoring.model.query.RefactoringRuleNamePageRow": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_query_RefactoringRuleNamePageRow.class));
      case "org.guvnor.structure.security.RepositoryResourceType": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_security_RepositoryResourceType.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.values.impl.BigDecimalValue": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_BigDecimalValue.class));
      case "org.kie.workbench.common.services.shared.dependencies.TransitiveEnhancedDependency": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_dependencies_TransitiveEnhancedDependency.class));
      case "org.kie.workbench.common.screens.library.api.sync.ClusterLibraryEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_library_api_sync_ClusterLibraryEvent.class));
      case "org.kie.soup.project.datamodel.oracle.DropDownData": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_soup_project_datamodel_oracle_DropDownData.class));
      case "org.uberfire.experimental.service.registry.impl.ExperimentalFeatureImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_experimental_service_registry_impl_ExperimentalFeatureImpl.class));
      case "org.kie.workbench.common.services.shared.project.ProjectImportsContent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_project_ProjectImportsContent.class));
      case "org.uberfire.ext.security.management.api.exception.InvalidEntityIdentifierException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_exception_InvalidEntityIdentifierException.class));
      case "org.kie.workbench.common.screens.explorer.service.Option": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_explorer_service_Option.class));
      case "org.kie.workbench.common.screens.examples.model.ExamplesMetaData": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_examples_model_ExamplesMetaData.class));
      case "org.optaplanner.workbench.screens.domaineditor.validation.PlanningSolutionToBeDuplicatedMessage": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_workbench_screens_domaineditor_validation_PlanningSolutionToBeDuplicatedMessage.class));
      case "org.kie.workbench.common.services.datamodeller.driver.model.AnnotationParseResponse": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_AnnotationParseResponse.class));
      case "org.kie.server.controller.api.model.runtime.ContainerKey": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_controller_api_model_runtime_ContainerKey.class));
      case "org.optaplanner.workbench.screens.solver.model.TerminationConfigOption": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_workbench_screens_solver_model_TerminationConfigOption.class));
      case "org.drools.workbench.models.datamodel.rule.CEPWindow": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_CEPWindow.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.values.impl.EnumValue": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_EnumValue.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.nodes.impl.ActionFieldValueImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_nodes_impl_ActionFieldValueImpl.class));
      case "org.guvnor.common.services.project.preferences.GeneralPreferencesPortableGeneratedImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_preferences_GeneralPreferencesPortableGeneratedImpl.class));
      case "org.dashbuilder.dataprovider.SQLProviderType": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataprovider_SQLProviderType.class));
      case "org.guvnor.structure.repositories.impl.PullRequestImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_impl_PullRequestImpl.class));
      case "org.optaplanner.workbench.models.datamodel.rule.ActionBendableHardConstraintMatch": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_workbench_models_datamodel_rule_ActionBendableHardConstraintMatch.class));
      case "org.drools.workbench.models.datamodel.rule.FromCompositeFactPattern": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_FromCompositeFactPattern.class));
      case "org.kie.workbench.common.services.datamodeller.core.Visibility": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_Visibility.class));
      case "org.uberfire.preferences.shared.PropertyFormOptions": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_preferences_shared_PropertyFormOptions.class));
      case "org.uberfire.ext.security.management.impl.SettingsImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_impl_SettingsImpl.class));
      case "org.drools.workbench.models.datamodel.rule.ActionSetField": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionSetField.class));
      case "org.uberfire.workbench.model.impl.ContextDefinitionImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_model_impl_ContextDefinitionImpl.class));
      case "org.kie.workbench.common.services.refactoring.service.ResourceType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_service_ResourceType.class));
      case "org.uberfire.ext.services.shared.preferences.UserWorkbenchPreferences": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_services_shared_preferences_UserWorkbenchPreferences.class));
      case "org.kie.workbench.common.services.datamodeller.core.impl.MethodImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_MethodImpl.class));
      case "org.kie.workbench.common.screens.defaulteditor.service.DefaultEditorContent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_defaulteditor_service_DefaultEditorContent.class));
      case "org.drools.workbench.models.datamodel.rule.visitors.RuleModelVisitor": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_visitors_RuleModelVisitor.class));
      case "org.drools.workbench.services.verifier.plugin.client.api.NewColumn": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_services_verifier_plugin_client_api_NewColumn.class));
      case "org.uberfire.ext.layout.editor.api.editor.LayoutColumn": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_layout_editor_api_editor_LayoutColumn.class));
      case "org.optaplanner.workbench.screens.solver.model.ConstructionHeuristicPhaseConfigModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_workbench_screens_solver_model_ConstructionHeuristicPhaseConfigModel.class));
      case "org.drools.workbench.models.datamodel.rule.ActionGlobalCollectionAdd": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionGlobalCollectionAdd.class));
      case "org.drools.workbench.models.testscenarios.shared.FactData": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_FactData.class));
      case "org.drools.workbench.models.datamodel.rule.ExpressionField": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionField.class));
      case "org.uberfire.java.nio.file.NoSuchFileException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_java_nio_file_NoSuchFileException.class));
      case "org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldSelectedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectFieldSelectedEvent.class));
      case "org.dashbuilder.dataset.events.DataSetPushingEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_events_DataSetPushingEvent.class));
      case "org.drools.workbench.screens.factmodel.model.FactMetaModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_screens_factmodel_model_FactMetaModel.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.parser.messages.InvalidRootParserMessage": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_InvalidRootParserMessage.class));
      case "org.drools.workbench.screens.factmodel.model.FieldMetaModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_screens_factmodel_model_FieldMetaModel.class));
      case "org.uberfire.workbench.model.impl.SplashScreenFilterImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_model_impl_SplashScreenFilterImpl.class));
      case "org.guvnor.common.services.shared.metadata.model.Metadata": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_shared_metadata_model_Metadata.class));
      case "org.guvnor.structure.repositories.RepositoryExternalUpdateEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_RepositoryExternalUpdateEvent.class));
      case "org.uberfire.ext.editor.commons.file.exports.PdfExportPreferences$Orientation": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_editor_commons_file_exports_PdfExportPreferences_erraiD_Orientation.class));
      case "org.drools.workbench.models.datamodel.rule.InterpolationVariable": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_InterpolationVariable.class));
      case "org.drools.workbench.models.datamodel.rule.RuleMetadata": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_RuleMetadata.class));
      case "org.dashbuilder.navigation.layout.LayoutNavigationRefType": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_navigation_layout_LayoutNavigationRefType.class));
      case "org.drools.workbench.models.datamodel.imports.Import": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_imports_Import.class));
      case "org.uberfire.java.nio.file.NotLinkException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_java_nio_file_NotLinkException.class));
      case "org.kie.workbench.common.services.shared.kmodule.EventProcessingOption": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_kmodule_EventProcessingOption.class));
      case "org.drools.workbench.screens.guided.dtree.model.GuidedDecisionTreeEditorContent": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_screens_guided_dtree_model_GuidedDecisionTreeEditorContent.class));
      case "org.kie.soup.project.datamodel.oracle.OperatorsOracle": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_soup_project_datamodel_oracle_OperatorsOracle.class));
      case "org.optaplanner.core.config.heuristic.selector.value.ValueSorterManner": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_core_config_heuristic_selector_value_ValueSorterManner.class));
      case "org.kie.workbench.common.screens.datamodeller.model.persistence.ValidationMode": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_persistence_ValidationMode.class));
      case "org.kie.workbench.common.services.refactoring.model.index.terms.valueterms.ValueSharedPartIndexTerm": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValueSharedPartIndexTerm.class));
      case "org.dashbuilder.dataprovider.ELSProviderType": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataprovider_ELSProviderType.class));
      case "org.guvnor.common.services.project.builder.model.BuildResults": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_builder_model_BuildResults.class));
      case "org.kie.workbench.common.services.datamodeller.driver.model.ModelDriverResult": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_ModelDriverResult.class));
      case "org.kie.workbench.common.services.shared.kmodule.AssertBehaviorOption": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_kmodule_AssertBehaviorOption.class));
      case "org.guvnor.structure.repositories.impl.DefaultPublicURI": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_impl_DefaultPublicURI.class));
      case "org.optaplanner.core.config.constructionheuristic.ConstructionHeuristicType": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_core_config_constructionheuristic_ConstructionHeuristicType.class));
      case "org.drools.workbench.services.verifier.plugin.client.Coordinate": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_services_verifier_plugin_client_Coordinate.class));
      case "org.uberfire.paging.PageResponse": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_paging_PageResponse.class));
      case "org.uberfire.java.nio.file.ProviderNotFoundException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_java_nio_file_ProviderNotFoundException.class));
      case "org.guvnor.common.services.project.preferences.GAVPreferencesPortableGeneratedImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_preferences_GAVPreferencesPortableGeneratedImpl.class));
      case "org.dashbuilder.dataset.sort.ColumnSort": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_sort_ColumnSort.class));
      case "org.kie.workbench.common.screens.library.api.AssetQueryResult": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_library_api_AssetQueryResult.class));
      case "org.dashbuilder.dataset.group.DataSetGroup": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_group_DataSetGroup.class));
      case "org.guvnor.common.services.shared.test.TestResultMessage": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_shared_test_TestResultMessage.class));
      case "org.kie.workbench.common.services.shared.project.KieModule": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_project_KieModule.class));
      case "org.optaplanner.workbench.models.datamodel.rule.ActionBendableSoftConstraintMatch": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_workbench_models_datamodel_rule_ActionBendableSoftConstraintMatch.class));
      case "org.uberfire.java.nio.file.PatternSyntaxException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_java_nio_file_PatternSyntaxException.class));
      case "org.kie.server.controller.api.model.runtime.Container": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_controller_api_model_runtime_Container.class));
      case "org.kie.workbench.common.screens.library.api.preferences.LibraryPreferencesPortableGeneratedImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_library_api_preferences_LibraryPreferencesPortableGeneratedImpl.class));
      case "org.drools.workbench.models.datamodel.rule.ActionInsertLogicalFact": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionInsertLogicalFact.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.values.impl.StringValue": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_StringValue.class));
      case "org.kie.workbench.common.services.refactoring.model.query.RefactoringPageRequest": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_query_RefactoringPageRequest.class));
      case "org.drools.workbench.models.testscenarios.shared.ExecutionTrace": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_ExecutionTrace.class));
      case "org.drools.workbench.screens.guided.scorecard.model.ScoreCardModelContent": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_screens_guided_scorecard_model_ScoreCardModelContent.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.values.impl.ByteValue": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_ByteValue.class));
      case "org.drools.workbench.models.testscenarios.shared.RetractFact": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_RetractFact.class));
      case "org.kie.workbench.common.screens.library.api.ProjectAssetsQuery": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_library_api_ProjectAssetsQuery.class));
      case "org.uberfire.java.nio.IOException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_java_nio_IOException.class));
      case "org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldDeletedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectFieldDeletedEvent.class));
      case "org.drools.verifier.api.reporting.ValueForActionIsSetTwiceIssue": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_verifier_api_reporting_ValueForActionIsSetTwiceIssue.class));
      case "org.drools.workbench.screens.testscenario.model.TestScenarioModelContent": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_screens_testscenario_model_TestScenarioModelContent.class));
      case "org.drools.verifier.api.reporting.CheckType": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_verifier_api_reporting_CheckType.class));
      case "org.drools.workbench.models.testscenarios.shared.ScenarioRunResult": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_ScenarioRunResult.class));
      case "org.optaplanner.workbench.screens.solver.model.LocalSearchPhaseConfigModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_workbench_screens_solver_model_LocalSearchPhaseConfigModel.class));
      case "org.dashbuilder.dataset.filter.DataSetFilter": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_filter_DataSetFilter.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.adaptors.ConditionCol52FieldConstraintAdaptor": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_adaptors_ConditionCol52FieldConstraintAdaptor.class));
      case "org.uberfire.security.impl.authz.DefaultPermissionCollection": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_security_impl_authz_DefaultPermissionCollection.class));
      case "org.guvnor.structure.repositories.RepositoryEnvironmentConfiguration": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_RepositoryEnvironmentConfiguration.class));
      case "org.kie.workbench.common.services.shared.dependencies.NormalEnhancedDependency": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_dependencies_NormalEnhancedDependency.class));
      case "org.uberfire.mvp.impl.DefaultPlaceRequest": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_mvp_impl_DefaultPlaceRequest.class));
      case "org.dashbuilder.dataset.sort.SortedList": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_sort_SortedList.class));
      case "org.dashbuilder.dataset.events.DataSetDefRemovedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_events_DataSetDefRemovedEvent.class));
      case "org.kie.workbench.common.screens.explorer.model.FolderListing": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_explorer_model_FolderListing.class));
      case "org.uberfire.security.impl.authz.DotNamedPermission": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_security_impl_authz_DotNamedPermission.class));
      case "org.uberfire.ext.security.management.api.exception.NoImplementationAvailableException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_exception_NoImplementationAvailableException.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.adaptors.ActionInsertFactCol52ActionInsertFactAdaptor": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_adaptors_ActionInsertFactCol52ActionInsertFactAdaptor.class));
      case "org.kie.workbench.common.screens.datamodeller.model.GenerationResult": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_GenerationResult.class));
      case "org.kie.workbench.common.screens.datamodeller.model.persistence.Property": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_persistence_Property.class));
      case "org.guvnor.common.services.project.events.NewModuleEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_events_NewModuleEvent.class));
      case "org.guvnor.common.services.project.model.WorkspaceProject": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_WorkspaceProject.class));
      case "org.dashbuilder.navigation.impl.NavGroupImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_navigation_impl_NavGroupImpl.class));
      case "org.guvnor.structure.repositories.NewRepositoryEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_NewRepositoryEvent.class));
      case "org.kie.workbench.common.services.datamodel.model.LazyModelField": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodel_model_LazyModelField.class));
      case "org.uberfire.ext.plugin.model.PluginType": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_PluginType.class));
      case "org.kie.workbench.common.services.datamodeller.core.impl.ModelFactoryImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_ModelFactoryImpl.class));
      case "org.kie.workbench.common.services.datamodeller.core.impl.PropertyTypeFactoryImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_PropertyTypeFactoryImpl.class));
      case "org.drools.workbench.screens.enums.model.EnumModelContent": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_screens_enums_model_EnumModelContent.class));
      case "org.guvnor.structure.repositories.NewBranchEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_NewBranchEvent.class));
      case "org.dashbuilder.dataset.group.GroupStrategy": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_group_GroupStrategy.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.adaptors.ActionInsertFactCol52ActionInsertLogicalFactAdaptor": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_adaptors_ActionInsertFactCol52ActionInsertLogicalFactAdaptor.class));
      case "org.kie.server.controller.api.model.spec.ServerTemplateKeyList": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_controller_api_model_spec_ServerTemplateKeyList.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.DTCellValue52": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_DTCellValue52.class));
      case "org.kie.workbench.common.services.verifier.api.client.api.WebWorkerLogMessage": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_verifier_api_client_api_WebWorkerLogMessage.class));
      case "org.uberfire.ext.security.management.api.Capability": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_Capability.class));
      case "org.drools.workbench.models.guided.dtable.shared.auditlog.LimitedEntryActionInsertFactColumnDetails": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_LimitedEntryActionInsertFactColumnDetails.class));
      case "org.uberfire.ext.properties.editor.model.validators.ColorValidator": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_properties_editor_model_validators_ColorValidator.class));
      case "org.uberfire.java.nio.file.AccessDeniedException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_java_nio_file_AccessDeniedException.class));
      case "org.kie.workbench.common.screens.server.management.model.ContainerUpdateEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_server_management_model_ContainerUpdateEvent.class));
      case "org.optaplanner.workbench.screens.solver.model.SolverModelContent": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_workbench_screens_solver_model_SolverModelContent.class));
      case "org.kie.server.api.model.ReleaseId": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_api_model_ReleaseId.class));
      case "org.drools.workbench.screens.workitems.model.WorkItemsModelContent": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_screens_workitems_model_WorkItemsModelContent.class));
      case "org.kie.workbench.common.screens.datamodeller.model.TypeInfoResult": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_TypeInfoResult.class));
      case "org.kie.workbench.common.screens.library.api.preferences.LibraryInternalPreferencesPortableGeneratedImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_library_api_preferences_LibraryInternalPreferencesPortableGeneratedImpl.class));
      case "org.drools.workbench.models.datamodel.rule.BaseSingleFieldConstraint": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_BaseSingleFieldConstraint.class));
      case "org.kie.workbench.common.screens.library.api.OrganizationalUnitRepositoryInfo": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_library_api_OrganizationalUnitRepositoryInfo.class));
      case "org.dashbuilder.dataprovider.CSVProviderType": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataprovider_CSVProviderType.class));
      case "org.dashbuilder.displayer.ColumnSettings": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_displayer_ColumnSettings.class));
      case "org.kie.workbench.common.screens.datamodeller.model.DataModelerError": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_DataModelerError.class));
      case "org.drools.workbench.models.datamodel.rule.ActionExecuteWorkItem": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionExecuteWorkItem.class));
      case "org.uberfire.java.nio.file.AtomicMoveNotSupportedException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_java_nio_file_AtomicMoveNotSupportedException.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.BRLActionVariableColumn": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_BRLActionVariableColumn.class));
      case "org.uberfire.backend.vfs.PathFactory$PathImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_backend_vfs_PathFactory_erraiD_PathImpl.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.ConditionCol52": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ConditionCol52.class));
      case "org.kie.soup.project.datamodel.oracle.MethodInfo": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_soup_project_datamodel_oracle_MethodInfo.class));
      case "org.dashbuilder.dataset.ColumnType": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_ColumnType.class));
      case "org.uberfire.preferences.shared.bean.mock.PortablePreferenceMockPortableGeneratedImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_preferences_shared_bean_mock_PortablePreferenceMockPortableGeneratedImpl.class));
      case "org.uberfire.ext.services.shared.preferences.MultiGridPreferencesStore": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_services_shared_preferences_MultiGridPreferencesStore.class));
      case "org.guvnor.common.services.shared.message.Level": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_shared_message_Level.class));
      case "org.guvnor.structure.repositories.RepositoryUpdatedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_RepositoryUpdatedEvent.class));
      case "org.kie.workbench.common.screens.datamodeller.model.persistence.PersistableDataObject": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_persistence_PersistableDataObject.class));
      case "org.kie.soup.project.datamodel.oracle.Annotation": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_soup_project_datamodel_oracle_Annotation.class));
      case "org.drools.workbench.services.verifier.plugin.client.api.FactTypes$FactType": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_services_verifier_plugin_client_api_FactTypes_erraiD_FactType.class));
      case "org.uberfire.backend.vfs.impl.ObservablePathImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_backend_vfs_impl_ObservablePathImpl.class));
      case "org.drools.workbench.models.datamodel.workitems.PortableListParameterDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableListParameterDefinition.class));
      case "org.uberfire.ext.plugin.model.Framework": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_Framework.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.nodes.impl.ActionInsertNodeImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_nodes_impl_ActionInsertNodeImpl.class));
      case "org.dashbuilder.dataset.group.GroupFunction": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_group_GroupFunction.class));
      case "org.uberfire.ext.security.management.api.exception.UnsupportedServiceCapabilityException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_exception_UnsupportedServiceCapabilityException.class));
      case "org.kie.workbench.common.services.refactoring.model.index.terms.ModuleRootPathIndexTerm": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_ModuleRootPathIndexTerm.class));
      case "org.kie.workbench.common.services.datamodeller.driver.model.DriverRequest": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_DriverRequest.class));
      case "org.drools.workbench.models.datamodel.workitems.PortableEnumParameterDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableEnumParameterDefinition.class));
      case "org.guvnor.structure.repositories.PullRequestStatus": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_PullRequestStatus.class));
      case "org.dashbuilder.dataset.exception.DataSetLookupException": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_exception_DataSetLookupException.class));
      case "org.drools.workbench.models.datamodel.rule.CompositeFieldConstraint": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_CompositeFieldConstraint.class));
      case "org.kie.workbench.common.screens.projecteditor.model.InvalidPomException": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_projecteditor_model_InvalidPomException.class));
      case "org.uberfire.ext.services.shared.preferences.GridGlobalPreferences": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_services_shared_preferences_GridGlobalPreferences.class));
      case "org.dashbuilder.dataset.filter.LogicalExprFilter": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_filter_LogicalExprFilter.class));
      case "org.kie.server.controller.api.model.spec.ProcessConfig": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_controller_api_model_spec_ProcessConfig.class));
      case "org.kie.workbench.common.services.datamodeller.util.NamingUtils": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_util_NamingUtils.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.ActionSetFieldCol52": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionSetFieldCol52.class));
      case "org.uberfire.workbench.events.ResourceUpdatedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceUpdatedEvent.class));
      case "org.guvnor.structure.organizationalunit.impl.OrganizationalUnitImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_organizationalunit_impl_OrganizationalUnitImpl.class));
      case "org.uberfire.java.nio.file.NotDirectoryException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_java_nio_file_NotDirectoryException.class));
      case "org.kie.workbench.common.services.shared.kmodule.QualifierModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_kmodule_QualifierModel.class));
      case "org.optaplanner.workbench.models.datamodel.rule.ActionMultiConstraintBendableLongMatch": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_workbench_models_datamodel_rule_ActionMultiConstraintBendableLongMatch.class));
      case "org.uberfire.ext.security.management.api.CapabilityStatus": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_CapabilityStatus.class));
      case "org.kie.workbench.common.screens.datamodeller.model.EditorModelContent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_model_EditorModelContent.class));
      case "org.drools.workbench.models.datamodel.rule.FromEntryPointFactPattern": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_FromEntryPointFactPattern.class));
      case "org.uberfire.ext.properties.editor.model.PropertyEditorFieldInfo": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_properties_editor_model_PropertyEditorFieldInfo.class));
      case "org.drools.verifier.api.reporting.RedundantConditionsIssue": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_verifier_api_reporting_RedundantConditionsIssue.class));
      case "org.drools.workbench.models.guided.dtable.shared.auditlog.DeleteColumnAuditLogEntry": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_DeleteColumnAuditLogEntry.class));
      case "org.optaplanner.workbench.models.datamodel.rule.ActionMultiConstraintHardMediumSoftMatch": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_workbench_models_datamodel_rule_ActionMultiConstraintHardMediumSoftMatch.class));
      case "org.kie.workbench.common.services.shared.source.SourceGenerationFailedException": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_source_SourceGenerationFailedException.class));
      case "org.kie.workbench.common.screens.library.api.index.LibraryValueFileNameIndexTerm": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_library_api_index_LibraryValueFileNameIndexTerm.class));
      case "org.ext.uberfire.social.activities.model.SocialActivitiesEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_ext_uberfire_social_activities_model_SocialActivitiesEvent.class));
      case "org.uberfire.workbench.model.impl.PartDefinitionImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_model_impl_PartDefinitionImpl.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.ActionInsertFactFieldsPattern": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionInsertFactFieldsPattern.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.BRLConditionColumn": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_BRLConditionColumn.class));
      case "org.drools.workbench.models.guided.dtable.shared.auditlog.AttributeColumnDetails": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_AttributeColumnDetails.class));
      case "org.uberfire.ext.services.shared.preferences.UserPreference": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_services_shared_preferences_UserPreference.class));
      case "org.drools.workbench.models.datamodel.rule.ExpressionFieldVariable": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionFieldVariable.class));
      case "org.uberfire.workbench.model.ContextDisplayMode": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_model_ContextDisplayMode.class));
      case "org.drools.workbench.models.guided.dtable.shared.auditlog.ActionWorkItemSetFieldColumnDetails": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_ActionWorkItemSetFieldColumnDetails.class));
      case "org.guvnor.common.services.project.social.ModuleEventType": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_social_ModuleEventType.class));
      case "org.uberfire.ext.plugin.event.PluginUnregistered": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_event_PluginUnregistered.class));
      case "org.kie.workbench.common.screens.library.api.AssetInfo": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_library_api_AssetInfo.class));
      case "org.drools.workbench.models.guided.dtable.shared.auditlog.DecisionTableAuditEvents": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_DecisionTableAuditEvents.class));
      case "org.guvnor.common.services.project.service.DeploymentMode": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_service_DeploymentMode.class));
      case "org.drools.workbench.screens.guided.dtable.model.GuidedDecisionTableEditorGraphModel$GuidedDecisionTableGraphEntry": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_screens_guided_dtable_model_GuidedDecisionTableEditorGraphModel_erraiD_GuidedDecisionTableGraphEntry.class));
      case "org.dashbuilder.dataset.events.DataSetDefRegisteredEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_events_DataSetDefRegisteredEvent.class));
      case "org.drools.workbench.screens.globals.model.GlobalsEditorContent": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_screens_globals_model_GlobalsEditorContent.class));
      case "org.optaplanner.workbench.models.datamodel.rule.ActionHardConstraintMatch": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_workbench_models_datamodel_rule_ActionHardConstraintMatch.class));
      case "org.kie.workbench.common.screens.library.api.ProjectAssetListUpdated": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_library_api_ProjectAssetListUpdated.class));
      case "org.uberfire.workbench.events.PluginAddedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_PluginAddedEvent.class));
      case "org.kie.server.controller.api.model.spec.ServerTemplate": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_controller_api_model_spec_ServerTemplate.class));
      case "org.drools.workbench.models.testscenarios.shared.FactAssignmentField": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_FactAssignmentField.class));
      case "org.guvnor.structure.organizationalunit.NewOrganizationalUnitEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_organizationalunit_NewOrganizationalUnitEvent.class));
      case "org.dashbuilder.dataset.events.DataSetDefModifiedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_events_DataSetDefModifiedEvent.class));
      case "org.kie.workbench.common.screens.examples.model.ExampleOrganizationalUnit": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_examples_model_ExampleOrganizationalUnit.class));
      case "org.uberfire.mvp.impl.PathPlaceRequest": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_mvp_impl_PathPlaceRequest.class));
      case "org.uberfire.ext.plugin.model.RuntimePlugin": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_RuntimePlugin.class));
      case "org.kie.workbench.common.screens.explorer.service.ProjectExplorerContentQuery": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_explorer_service_ProjectExplorerContentQuery.class));
      case "org.optaplanner.workbench.screens.domaineditor.validation.ScoreHolderGlobalTypeNotRecognizedMessage": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_workbench_screens_domaineditor_validation_ScoreHolderGlobalTypeNotRecognizedMessage.class));
      case "org.uberfire.ext.plugin.model.LayoutEditorModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_LayoutEditorModel.class));
      case "org.guvnor.structure.repositories.RepositoryInfo": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_RepositoryInfo.class));
      case "org.drools.workbench.models.testscenarios.shared.VerifyFact": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_VerifyFact.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.GuidedDecisionTree": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_GuidedDecisionTree.class));
      case "org.uberfire.ext.plugin.model.Language": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_Language.class));
      case "org.kie.soup.project.datamodel.oracle.DataType$DataTypes": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_soup_project_datamodel_oracle_DataType_erraiD_DataTypes.class));
      case "org.kie.server.controller.api.model.spec.RuleConfig": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_controller_api_model_spec_RuleConfig.class));
      case "org.dashbuilder.dataset.events.DataSetModifiedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_events_DataSetModifiedEvent.class));
      case "org.optaplanner.core.config.heuristic.selector.entity.EntitySorterManner": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_core_config_heuristic_selector_entity_EntitySorterManner.class));
      case "org.uberfire.experimental.service.definition.ExperimentalFeatureDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_experimental_service_definition_ExperimentalFeatureDefinition.class));
      case "org.kie.workbench.common.screens.library.api.index.LibraryFileNameIndexTerm": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_library_api_index_LibraryFileNameIndexTerm.class));
      case "org.guvnor.structure.navigator.DataContent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_navigator_DataContent.class));
      case "org.guvnor.structure.repositories.RepositoryRemovedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_RepositoryRemovedEvent.class));
      case "org.kie.workbench.common.screens.explorer.service.ActiveOptions": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_explorer_service_ActiveOptions.class));
      case "org.guvnor.common.services.project.builder.events.InvalidateDMOModuleCacheEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_builder_events_InvalidateDMOModuleCacheEvent.class));
      case "org.drools.workbench.models.testscenarios.shared.BuilderResultLine": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_BuilderResultLine.class));
      case "org.guvnor.m2repo.model.JarListPageRow": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_m2repo_model_JarListPageRow.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.nodes.impl.ConstraintNodeImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_nodes_impl_ConstraintNodeImpl.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.ActionRetractFactCol52": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionRetractFactCol52.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.GuidedDecisionTable52": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_GuidedDecisionTable52.class));
      case "org.guvnor.common.services.workingset.client.model.WorkingSetConfigData": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_workingset_client_model_WorkingSetConfigData.class));
      case "org.guvnor.structure.repositories.RepositoryEnvironmentConfigurations": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_RepositoryEnvironmentConfigurations.class));
      case "org.kie.workbench.common.services.refactoring.service.PartType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_service_PartType.class));
      case "org.drools.workbench.models.datamodel.rule.FromCollectCompositeFactPattern": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_FromCollectCompositeFactPattern.class));
      case "org.kie.workbench.common.services.refactoring.model.index.terms.valueterms.ValuePackageNameIndexTerm": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValuePackageNameIndexTerm.class));
      case "org.drools.workbench.screens.drltext.model.DrlModelContent": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_screens_drltext_model_DrlModelContent.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.MetadataCol52": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_MetadataCol52.class));
      case "org.guvnor.common.services.project.model.WorkItemHandlerModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_WorkItemHandlerModel.class));
      case "org.drools.workbench.models.guided.scorecard.shared.Characteristic": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_scorecard_shared_Characteristic.class));
      case "org.drools.workbench.models.testscenarios.shared.CallFixtureMap": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_CallFixtureMap.class));
      case "org.drools.workbench.models.testscenarios.shared.CallMethod": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_CallMethod.class));
      case "org.drools.workbench.screens.globals.model.Global": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_screens_globals_model_Global.class));
      case "org.uberfire.preferences.shared.impl.DefaultPreferenceScopeResolver": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_preferences_shared_impl_DefaultPreferenceScopeResolver.class));
      case "org.guvnor.common.services.project.model.Plugin": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_Plugin.class));
      case "org.optaplanner.workbench.models.datamodel.rule.ActionSimpleConstraintMatch": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_workbench_models_datamodel_rule_ActionSimpleConstraintMatch.class));
      default: return false;
    }
  }

  private boolean loadMarshaller1(String a0) {
    switch (a0) {
      case "org.uberfire.workbench.events.ResourceUpdated": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceUpdated.class));
      case "org.kie.server.controller.api.model.events.ServerTemplateDeleted": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_controller_api_model_events_ServerTemplateDeleted.class));
      case "org.drools.verifier.api.reporting.ValueForFactFieldIsSetTwiceIssue": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_verifier_api_reporting_ValueForFactFieldIsSetTwiceIssue.class));
      case "org.drools.workbench.screens.factmodel.model.AnnotationMetaModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_screens_factmodel_model_AnnotationMetaModel.class));
      case "org.drools.workbench.models.datamodel.rule.ActionCallMethod": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionCallMethod.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.parser.messages.UnsupportedFieldNatureTypeParserMessage": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_UnsupportedFieldNatureTypeParserMessage.class));
      case "org.kie.soup.project.datamodel.oracle.ModelField": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_soup_project_datamodel_oracle_ModelField.class));
      case "org.kie.server.controller.api.model.events.ServerInstanceDisconnected": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_controller_api_model_events_ServerInstanceDisconnected.class));
      case "org.drools.workbench.models.testscenarios.shared.FixtureList": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_FixtureList.class));
      case "org.guvnor.common.services.shared.metadata.model.DiscussionRecord": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_shared_metadata_model_DiscussionRecord.class));
      case "org.uberfire.backend.vfs.FileSystemFactory$FileSystemImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_backend_vfs_FileSystemFactory_erraiD_FileSystemImpl.class));
      case "org.kie.server.controller.api.model.spec.ContainerSpec": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_controller_api_model_spec_ContainerSpec.class));
      case "org.kie.server.api.model.Severity": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_api_model_Severity.class));
      case "org.drools.workbench.models.datamodel.rule.ActionWorkItemFieldValue": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionWorkItemFieldValue.class));
      case "org.kie.workbench.common.services.shared.kmodule.FileLogger": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_kmodule_FileLogger.class));
      case "org.drools.verifier.api.reporting.SingleHitLostIssue": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_verifier_api_reporting_SingleHitLostIssue.class));
      case "org.optaplanner.workbench.models.datamodel.rule.ActionMultiConstraintHardSoftMatch": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_workbench_models_datamodel_rule_ActionMultiConstraintHardSoftMatch.class));
      case "org.kie.workbench.common.services.refactoring.model.query.RefactoringPathPageRow": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_query_RefactoringPathPageRow.class));
      case "org.kie.workbench.common.screens.datamodeller.events.DataObjectDeletedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectDeletedEvent.class));
      case "org.guvnor.structure.organizationalunit.RepoAddedToOrganizationalUnitEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_organizationalunit_RepoAddedToOrganizationalUnitEvent.class));
      case "org.dashbuilder.dataset.date.TimeAmount": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_date_TimeAmount.class));
      case "org.guvnor.common.services.shared.validation.model.ValidationMessage": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_shared_validation_model_ValidationMessage.class));
      case "org.kie.workbench.common.screens.explorer.model.FolderItemType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_explorer_model_FolderItemType.class));
      case "org.kie.server.api.exception.KieServicesException": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_api_exception_KieServicesException.class));
      case "org.optaplanner.workbench.models.datamodel.rule.ActionMultiConstraintBendableBigDecimalMatch": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_workbench_models_datamodel_rule_ActionMultiConstraintBendableBigDecimalMatch.class));
      case "org.drools.workbench.services.verifier.plugin.client.api.RequestStatus": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_services_verifier_plugin_client_api_RequestStatus.class));
      case "org.drools.workbench.models.guided.dtable.shared.conversion.ConversionMessage": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_conversion_ConversionMessage.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.parser.messages.DefaultParserMessage": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_DefaultParserMessage.class));
      case "org.uberfire.preferences.shared.bean.PreferenceHierarchyElement": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_preferences_shared_bean_PreferenceHierarchyElement.class));
      case "org.dashbuilder.displayer.DisplayerSettings": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_displayer_DisplayerSettings.class));
      case "org.drools.workbench.models.guided.dtable.shared.conversion.ConversionMessageType": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_conversion_ConversionMessageType.class));
      case "org.drools.workbench.models.testscenarios.shared.FieldData": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_FieldData.class));
      case "org.jboss.errai.common.client.PageRequest": return putMarshaller(a0, GWT.create(Marshaller_for_org_jboss_errai_common_client_PageRequest.class));
      case "org.optaplanner.workbench.models.datamodel.rule.ActionSoftConstraintMatch": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_workbench_models_datamodel_rule_ActionSoftConstraintMatch.class));
      case "org.drools.workbench.models.testscenarios.shared.CollectionFieldData": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_CollectionFieldData.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.LimitedEntryBRLConditionColumn": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_LimitedEntryBRLConditionColumn.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.AttributeCol52": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_AttributeCol52.class));
      case "org.kie.workbench.common.services.shared.whitelist.WhiteList": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_whitelist_WhiteList.class));
      case "org.uberfire.experimental.service.registry.impl.ExperimentalFeaturesRegistryImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_experimental_service_registry_impl_ExperimentalFeaturesRegistryImpl.class));
      case "org.uberfire.ext.editor.commons.file.exports.PdfExportPreferences$Format": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_editor_commons_file_exports_PdfExportPreferences_erraiD_Format.class));
      case "org.kie.workbench.common.screens.datamodeller.events.DataObjectSelectedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectSelectedEvent.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.parser.messages.UnsupportedIPatternParserMessage": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_UnsupportedIPatternParserMessage.class));
      case "org.drools.workbench.models.guided.dtable.shared.auditlog.ActionSetFieldColumnDetails": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_ActionSetFieldColumnDetails.class));
      case "org.kie.workbench.common.screens.explorer.model.ProjectExplorerContent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_explorer_model_ProjectExplorerContent.class));
      case "org.dashbuilder.dataset.impl.DataColumnImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_impl_DataColumnImpl.class));
      case "org.uberfire.ext.security.management.impl.UserAttributeImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_impl_UserAttributeImpl.class));
      case "org.optaplanner.workbench.screens.guidedrule.model.BendableScoreLevelsWrapper": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_workbench_screens_guidedrule_model_BendableScoreLevelsWrapper.class));
      case "org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldChangeEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectFieldChangeEvent.class));
      case "org.kie.workbench.common.screens.examples.model.Credentials": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_examples_model_Credentials.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.LimitedEntryBRLActionColumn": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_LimitedEntryBRLActionColumn.class));
      case "org.guvnor.common.services.project.model.ModuleRepositories$ModuleRepository": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_ModuleRepositories_erraiD_ModuleRepository.class));
      case "org.drools.workbench.models.datamodel.rule.DSLVariableValue": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_DSLVariableValue.class));
      case "org.kie.workbench.common.services.datamodeller.core.impl.DataModelImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_DataModelImpl.class));
      case "org.guvnor.messageconsole.events.PublishBatchMessagesEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_messageconsole_events_PublishBatchMessagesEvent.class));
      case "org.guvnor.common.services.project.service.PackageAlreadyExistsException": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_service_PackageAlreadyExistsException.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.parser.messages.UnsupportedFieldConstraintTypeParserMessage": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_UnsupportedFieldConstraintTypeParserMessage.class));
      case "org.kie.workbench.common.services.refactoring.model.query.RefactoringStringPageRow": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_query_RefactoringStringPageRow.class));
      case "org.drools.workbench.models.testscenarios.shared.FieldPlaceHolder": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_FieldPlaceHolder.class));
      case "org.uberfire.workbench.model.Notification": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_model_Notification.class));
      case "org.kie.workbench.common.services.refactoring.model.index.terms.FullFileNameIndexTerm": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_FullFileNameIndexTerm.class));
      case "org.uberfire.backend.events.AuthorizationPolicySavedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_backend_events_AuthorizationPolicySavedEvent.class));
      case "org.guvnor.common.services.project.model.MavenRepository": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_MavenRepository.class));
      case "org.guvnor.common.services.project.model.MavenRepositorySource": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_MavenRepositorySource.class));
      case "org.drools.workbench.models.datamodel.rule.ExpressionMethod": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionMethod.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.parser.GuidedDecisionTreeParserError": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_GuidedDecisionTreeParserError.class));
      case "org.uberfire.workbench.events.PluginReloadedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_PluginReloadedEvent.class));
      case "org.dashbuilder.dataset.group.Interval": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_group_Interval.class));
      case "org.kie.workbench.common.services.shared.preferences.config.WorkbenchPreferenceScopeResolver": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_preferences_config_WorkbenchPreferenceScopeResolver.class));
      case "org.uberfire.ext.apps.api.DirectoryBreadcrumb": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_apps_api_DirectoryBreadcrumb.class));
      case "org.optaplanner.core.config.localsearch.LocalSearchType": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_core_config_localsearch_LocalSearchType.class));
      case "org.uberfire.workbench.events.ResourceRenamed": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceRenamed.class));
      case "org.kie.workbench.common.screens.explorer.model.FolderItemOperation": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_explorer_model_FolderItemOperation.class));
      case "org.kie.workbench.common.services.datamodeller.driver.model.AnnotationSourceRequest": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_AnnotationSourceRequest.class));
      case "org.guvnor.common.services.workingset.client.model.WorkingSetSettings": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_workingset_client_model_WorkingSetSettings.class));
      case "org.uberfire.ext.plugin.model.DynamicMenu": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_DynamicMenu.class));
      case "org.uberfire.ext.plugin.model.PluginSimpleContent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_PluginSimpleContent.class));
      case "org.drools.workbench.models.testscenarios.shared.FixturesMap": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_FixturesMap.class));
      case "org.optaplanner.workbench.screens.guidedrule.model.ScoreInformation": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_workbench_screens_guidedrule_model_ScoreInformation.class));
      case "org.kie.server.controller.api.model.spec.ContainerConfig": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_controller_api_model_spec_ContainerConfig.class));
      case "org.guvnor.structure.repositories.Branch": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_Branch.class));
      case "org.kie.soup.project.datamodel.oracle.ModelField$FIELD_CLASS_TYPE": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_soup_project_datamodel_oracle_ModelField_erraiD_FIELD_erraiU_CLASS_erraiU_TYPE.class));
      case "org.drools.workbench.models.datamodel.auditlog.AuditLog": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_auditlog_AuditLog.class));
      case "org.drools.workbench.models.datamodel.rule.FreeFormLine": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_FreeFormLine.class));
      case "org.optaplanner.workbench.screens.solver.model.ScoreDirectorFactoryConfigModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_workbench_screens_solver_model_ScoreDirectorFactoryConfigModel.class));
      case "org.guvnor.common.services.project.model.ProjectImports": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_ProjectImports.class));
      case "org.drools.workbench.models.guided.dtable.shared.auditlog.DecisionTableAuditLogFilter": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_DecisionTableAuditLogFilter.class));
      case "org.drools.workbench.models.datamodel.rule.RuleModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_RuleModel.class));
      case "org.dashbuilder.displayer.impl.TableDisplayerSettingsBuilderImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_displayer_impl_TableDisplayerSettingsBuilderImpl.class));
      case "org.optaplanner.workbench.models.datamodel.rule.ActionMediumConstraintMatch": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_workbench_models_datamodel_rule_ActionMediumConstraintMatch.class));
      case "org.guvnor.common.services.project.events.DeleteModuleEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_events_DeleteModuleEvent.class));
      case "org.kie.workbench.common.services.refactoring.service.RelationshipType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_service_RelationshipType.class));
      case "org.kie.workbench.common.services.datamodeller.core.impl.JavaEnumImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_JavaEnumImpl.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.LimitedEntryActionSetFieldCol52": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_LimitedEntryActionSetFieldCol52.class));
      case "org.kie.workbench.common.services.refactoring.service.impact.RefactorOperationRequest": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_service_impact_RefactorOperationRequest.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.DescriptionCol52": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_DescriptionCol52.class));
      case "org.dashbuilder.dataset.def.ElasticSearchDataSetDef": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_def_ElasticSearchDataSetDef.class));
      case "org.optaplanner.workbench.screens.solver.model.TerminationConfigModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_workbench_screens_solver_model_TerminationConfigModel.class));
      case "org.kie.workbench.common.services.shared.kmodule.KSessionModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_kmodule_KSessionModel.class));
      case "org.drools.workbench.screens.guided.dtable.model.GuidedDecisionTableEditorGraphContent": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_screens_guided_dtable_model_GuidedDecisionTableEditorGraphContent.class));
      case "org.drools.workbench.services.verifier.plugin.client.api.HeaderMetaData": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_services_verifier_plugin_client_api_HeaderMetaData.class));
      case "org.uberfire.workbench.events.PluginUpdatedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_PluginUpdatedEvent.class));
      case "org.guvnor.common.services.project.model.GAV": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_GAV.class));
      case "org.uberfire.workbench.events.ResourceDeletedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceDeletedEvent.class));
      case "org.drools.workbench.models.datamodel.rule.FactPattern": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_FactPattern.class));
      case "org.drools.workbench.models.datamodel.workitems.PortableIntegerParameterDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableIntegerParameterDefinition.class));
      case "org.kie.workbench.common.services.verifier.api.client.api.WebWorkerException": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_verifier_api_client_api_WebWorkerException.class));
      case "org.guvnor.common.services.project.events.ModuleUpdatedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_events_ModuleUpdatedEvent.class));
      case "org.kie.server.controller.api.model.events.ServerInstanceDeleted": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_controller_api_model_events_ServerInstanceDeleted.class));
      case "org.uberfire.workbench.model.CompassPosition": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_model_CompassPosition.class));
      case "org.kie.workbench.common.screens.datamodeller.events.DataObjectCreatedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectCreatedEvent.class));
      case "org.guvnor.common.services.project.model.MavenRepositoryMetadata": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_MavenRepositoryMetadata.class));
      case "org.drools.workbench.models.datamodel.workitems.PortableStringParameterDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableStringParameterDefinition.class));
      case "org.uberfire.workbench.model.NamedPosition": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_model_NamedPosition.class));
      case "org.uberfire.ext.security.management.api.exception.UserNotFoundException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_exception_UserNotFoundException.class));
      case "org.kie.workbench.common.services.datamodeller.core.AnnotationRetention": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_AnnotationRetention.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.parser.messages.BindingNotFoundParserMessage": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_BindingNotFoundParserMessage.class));
      case "org.dashbuilder.dataset.group.ColumnGroup": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_group_ColumnGroup.class));
      case "org.kie.workbench.common.services.shared.kmodule.ListenerModel$Kind": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_kmodule_ListenerModel_erraiD_Kind.class));
      case "org.kie.server.controller.api.model.events.ServerInstanceConnected": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_controller_api_model_events_ServerInstanceConnected.class));
      case "org.uberfire.ext.security.management.impl.RoleManagerSettingsImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_impl_RoleManagerSettingsImpl.class));
      case "org.kie.workbench.common.screens.datamodeller.service.ServiceException": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_service_ServiceException.class));
      case "org.kie.workbench.common.services.refactoring.model.query.RefactoringRuleNamePageRow$RuleName": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_query_RefactoringRuleNamePageRow_erraiD_RuleName.class));
      case "org.kie.workbench.common.services.refactoring.model.index.terms.valueterms.ValueModuleRootPathIndexTerm": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValueModuleRootPathIndexTerm.class));
      case "org.drools.workbench.models.guided.dtable.shared.auditlog.MetadataColumnDetails": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_MetadataColumnDetails.class));
      case "org.drools.workbench.models.guided.dtable.shared.conversion.ConversionAsset": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_conversion_ConversionAsset.class));
      case "org.kie.server.controller.api.model.spec.ServerTemplateKey": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_controller_api_model_spec_ServerTemplateKey.class));
      case "org.dashbuilder.dataset.group.AggregateFunctionType": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_group_AggregateFunctionType.class));
      case "org.uberfire.ext.layout.editor.api.editor.LayoutComponent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_layout_editor_api_editor_LayoutComponent.class));
      case "org.kie.workbench.common.services.datamodeller.core.impl.AnnotationValuePairDefinitionImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_AnnotationValuePairDefinitionImpl.class));
      case "org.drools.workbench.models.datamodel.rule.ExpressionText": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionText.class));
      case "org.dashbuilder.dataset.filter.CoreFunctionType": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_filter_CoreFunctionType.class));
      case "org.kie.workbench.common.services.refactoring.service.impact.QueryOperationRequest": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_service_impact_QueryOperationRequest.class));
      case "org.uberfire.ext.plugin.event.PluginAdded": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_event_PluginAdded.class));
      case "org.kie.workbench.common.services.refactoring.model.index.terms.valueterms.ValueResourceIndexTerm": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValueResourceIndexTerm.class));
      case "org.drools.workbench.models.datamodel.rule.ExpressionGlobalVariable": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionGlobalVariable.class));
      case "org.uberfire.java.nio.file.FileSystemNotFoundException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_java_nio_file_FileSystemNotFoundException.class));
      case "org.guvnor.structure.repositories.RepositoryEnvironmentUpdatedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_RepositoryEnvironmentUpdatedEvent.class));
      case "org.drools.workbench.models.datamodel.rule.FromAccumulateCompositeFactPattern": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_FromAccumulateCompositeFactPattern.class));
      case "org.optaplanner.workbench.screens.domaineditor.model.ObjectPropertyPathImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_workbench_screens_domaineditor_model_ObjectPropertyPathImpl.class));
      case "org.kie.workbench.common.screens.examples.model.ExampleRepository": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_examples_model_ExampleRepository.class));
      case "org.kie.workbench.common.screens.explorer.model.FolderItem": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_explorer_model_FolderItem.class));
      case "org.drools.workbench.models.guided.dtable.shared.auditlog.ActionWorkItemColumnDetails": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_ActionWorkItemColumnDetails.class));
      case "org.dashbuilder.navigation.layout.LayoutNavigationRef": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_navigation_layout_LayoutNavigationRef.class));
      case "org.drools.workbench.models.guided.dtable.shared.auditlog.ColumnDetails": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_ColumnDetails.class));
      case "org.kie.workbench.common.services.datamodeller.core.impl.AnnotationDefinitionImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_AnnotationDefinitionImpl.class));
      case "org.guvnor.common.services.project.model.Package": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_Package.class));
      case "org.kie.soup.project.datamodel.imports.Import": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_soup_project_datamodel_imports_Import.class));
      case "org.kie.workbench.common.screens.datamodeller.events.DataModelStatusChangeEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataModelStatusChangeEvent.class));
      case "org.uberfire.ssh.service.shared.editor.PortableSSHPublicKey": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ssh_service_shared_editor_PortableSSHPublicKey.class));
      case "org.optaplanner.workbench.screens.solver.model.ConstructionHeuristicTypeModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_workbench_screens_solver_model_ConstructionHeuristicTypeModel.class));
      case "org.kie.server.controller.api.model.runtime.ContainerList": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_controller_api_model_runtime_ContainerList.class));
      case "org.drools.workbench.models.guided.dtable.shared.auditlog.LimitedEntryActionSetFieldColumnDetails": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_LimitedEntryActionSetFieldColumnDetails.class));
      case "org.guvnor.common.services.shared.metadata.model.Overview": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_shared_metadata_model_Overview.class));
      case "org.kie.workbench.common.screens.library.api.preferences.LibraryOrganizationalUnitPreferencesPortableGeneratedImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_library_api_preferences_LibraryOrganizationalUnitPreferencesPortableGeneratedImpl.class));
      case "org.kie.workbench.common.screens.server.management.model.ContainerSpecData": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_server_management_model_ContainerSpecData.class));
      case "org.kie.workbench.common.services.refactoring.model.index.terms.valueterms.ValueModuleNameIndexTerm": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValueModuleNameIndexTerm.class));
      case "org.uberfire.java.nio.file.DirectoryNotEmptyException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_java_nio_file_DirectoryNotEmptyException.class));
      case "org.dashbuilder.dataset.date.TimeFrame": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_date_TimeFrame.class));
      case "org.guvnor.structure.security.OrgUnitResourceType": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_security_OrgUnitResourceType.class));
      case "org.drools.workbench.models.datamodel.rule.ExpressionCollection": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionCollection.class));
      case "org.kie.workbench.common.services.datamodeller.core.impl.JavaTypeInfoImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_JavaTypeInfoImpl.class));
      case "org.uberfire.experimental.service.events.PortableExperimentalFeatureModifiedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_experimental_service_events_PortableExperimentalFeatureModifiedEvent.class));
      case "org.uberfire.ext.plugin.model.CodeType": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_CodeType.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.nodes.impl.TypeNodeImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_nodes_impl_TypeNodeImpl.class));
      case "org.drools.workbench.models.datamodel.workitems.PortableWorkDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableWorkDefinition.class));
      case "org.kie.workbench.common.services.shared.kmodule.SingleValueItemObjectModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_kmodule_SingleValueItemObjectModel.class));
      case "org.kie.server.controller.api.model.runtime.ServerInstance": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_controller_api_model_runtime_ServerInstance.class));
      case "org.drools.workbench.models.guided.dtable.shared.auditlog.ConditionColumnDetails": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_ConditionColumnDetails.class));
      case "org.kie.server.controller.api.model.events.RuleConfigUpdated": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_controller_api_model_events_RuleConfigUpdated.class));
      case "org.uberfire.preferences.shared.impl.PreferenceScopeImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_preferences_shared_impl_PreferenceScopeImpl.class));
      case "org.uberfire.workbench.events.ResourceAdded": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceAdded.class));
      case "org.uberfire.backend.vfs.impl.LockResult": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_backend_vfs_impl_LockResult.class));
      case "org.uberfire.ext.layout.editor.api.editor.LayoutTemplate$Style": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_layout_editor_api_editor_LayoutTemplate_erraiD_Style.class));
      case "org.guvnor.common.services.project.context.WorkspaceProjectContextChangeEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_context_WorkspaceProjectContextChangeEvent.class));
      case "org.drools.workbench.screens.factmodel.model.FactModels": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_screens_factmodel_model_FactModels.class));
      case "org.uberfire.java.nio.file.InvalidPathException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_java_nio_file_InvalidPathException.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.LimitedEntryActionInsertFactCol52": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_LimitedEntryActionInsertFactCol52.class));
      case "org.guvnor.structure.repositories.RepositoryAlreadyExistsException": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_RepositoryAlreadyExistsException.class));
      case "org.dashbuilder.dataset.def.DataSetDef": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_def_DataSetDef.class));
      case "org.kie.workbench.common.services.shared.kmodule.KModuleModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_kmodule_KModuleModel.class));
      case "org.dashbuilder.dataset.def.BeanDataSetDef": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_def_BeanDataSetDef.class));
      case "org.dashbuilder.dataset.impl.DataSetBuilderImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_impl_DataSetBuilderImpl.class));
      case "org.drools.verifier.api.reporting.Issue": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_verifier_api_reporting_Issue.class));
      case "org.kie.workbench.common.services.datamodeller.core.impl.TypeImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_TypeImpl.class));
      case "org.kie.workbench.common.services.refactoring.model.index.terms.SharedPartIndexTerm": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_SharedPartIndexTerm.class));
      case "org.drools.workbench.models.datamodel.auditlog.DefaultAuditLogFilter": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_auditlog_DefaultAuditLogFilter.class));
      case "org.guvnor.m2repo.preferences.ArtifactRepositoryPreferencePortableGeneratedImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_m2repo_preferences_ArtifactRepositoryPreferencePortableGeneratedImpl.class));
      case "org.drools.workbench.screens.globals.model.GlobalsModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_screens_globals_model_GlobalsModel.class));
      case "org.uberfire.spaces.Space": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_spaces_Space.class));
      case "org.kie.workbench.common.services.shared.kmodule.KBaseModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_kmodule_KBaseModel.class));
      case "org.drools.workbench.models.datamodel.rule.visitors.CopyExpressionVisitor": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_visitors_CopyExpressionVisitor.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.BRLActionColumn": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_BRLActionColumn.class));
      case "org.guvnor.structure.organizationalunit.UpdatedOrganizationalUnitEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_organizationalunit_UpdatedOrganizationalUnitEvent.class));
      case "org.guvnor.structure.organizationalunit.RemoveOrganizationalUnitEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_organizationalunit_RemoveOrganizationalUnitEvent.class));
      case "org.drools.workbench.models.datamodel.rule.ActionFieldValue": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionFieldValue.class));
      case "org.drools.verifier.api.reporting.Issues": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_verifier_api_reporting_Issues.class));
      case "org.guvnor.common.services.shared.exceptions.GenericPortableException": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_shared_exceptions_GenericPortableException.class));
      case "org.kie.workbench.common.services.refactoring.model.index.terms.PartIndexTerm": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_PartIndexTerm.class));
      case "org.kie.workbench.common.screens.datamodeller.events.DataObjectChangeEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectChangeEvent.class));
      case "org.uberfire.ext.plugin.model.Media": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_Media.class));
      case "org.drools.workbench.models.guided.dtable.shared.auditlog.DeleteRowAuditLogEntry": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_DeleteRowAuditLogEntry.class));
      case "org.drools.workbench.services.verifier.plugin.client.api.ModelMetaData": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_services_verifier_plugin_client_api_ModelMetaData.class));
      case "org.dashbuilder.dataprovider.DefaultProviderType": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataprovider_DefaultProviderType.class));
      case "org.ext.uberfire.social.activities.model.SocialPaged$Direction": return putMarshaller(a0, GWT.create(Marshaller_for_org_ext_uberfire_social_activities_model_SocialPaged_erraiD_Direction.class));
      case "org.kie.workbench.common.services.datamodeller.core.impl.JavaInterfaceImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_JavaInterfaceImpl.class));
      case "org.optaplanner.workbench.screens.domaineditor.validation.ScoreHolderGlobalTypeToBeChangedMessage": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_workbench_screens_domaineditor_validation_ScoreHolderGlobalTypeToBeChangedMessage.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.Pattern52": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_Pattern52.class));
      case "org.kie.workbench.common.screens.datamodeller.events.DataModelReload": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataModelReload.class));
      case "org.uberfire.workbench.events.ResourceAddedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceAddedEvent.class));
      case "org.kie.workbench.common.screens.datamodeller.validation.PersistenceDescriptorValidationMessage": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_validation_PersistenceDescriptorValidationMessage.class));
      case "org.kie.soup.project.datamodel.oracle.ModelField$FIELD_ORIGIN": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_soup_project_datamodel_oracle_ModelField_erraiD_FIELD_erraiU_ORIGIN.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.LimitedEntryActionRetractFactCol52": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_LimitedEntryActionRetractFactCol52.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.values.impl.IntegerValue": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_IntegerValue.class));
      case "org.dashbuilder.dataset.def.SQLDataSourceDef": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_def_SQLDataSourceDef.class));
      case "org.dashbuilder.dataset.impl.DataSetMetadataImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_impl_DataSetMetadataImpl.class));
      case "org.uberfire.workbench.events.ResourceCopiedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceCopiedEvent.class));
      case "org.uberfire.ext.properties.editor.model.validators.LongValidator": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_properties_editor_model_validators_LongValidator.class));
      case "org.optaplanner.workbench.screens.domaineditor.validation.ScoreHolderGlobalFileToBeRemovedMessage": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_workbench_screens_domaineditor_validation_ScoreHolderGlobalFileToBeRemovedMessage.class));
      case "org.dashbuilder.dataset.def.StaticDataSetDef": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_def_StaticDataSetDef.class));
      case "org.kie.workbench.common.services.refactoring.model.index.terms.valueterms.ValuePartReferenceIndexTerm": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValuePartReferenceIndexTerm.class));
      case "org.optaplanner.workbench.screens.solver.model.TerminationCompositionStyleModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_workbench_screens_solver_model_TerminationCompositionStyleModel.class));
      case "org.uberfire.ext.plugin.event.PluginRenamed": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_event_PluginRenamed.class));
      case "org.kie.workbench.common.screens.examples.model.ImportProject": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_examples_model_ImportProject.class));
      case "org.uberfire.ext.editor.commons.readonly.ReadOnlyPathPlaceRequest": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_editor_commons_readonly_ReadOnlyPathPlaceRequest.class));
      case "org.guvnor.structure.repositories.impl.git.GitRepository": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_impl_git_GitRepository.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.values.impl.DateValue": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_values_impl_DateValue.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.ActionWorkItemSetFieldCol52": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionWorkItemSetFieldCol52.class));
      case "org.dashbuilder.dataset.date.DayOfWeek": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_date_DayOfWeek.class));
      case "org.kie.server.controller.api.model.runtime.ServerInstanceKey": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_controller_api_model_runtime_ServerInstanceKey.class));
      case "org.drools.workbench.models.datamodel.rule.DSLComplexVariableValue": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_DSLComplexVariableValue.class));
      case "org.optaplanner.workbench.screens.domaineditor.validation.PlanningScoreToBeDeletedMessage": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_workbench_screens_domaineditor_validation_PlanningScoreToBeDeletedMessage.class));
      case "org.dashbuilder.dataset.DataSetLookup": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_DataSetLookup.class));
      case "org.uberfire.workbench.events.ResourceDeleted": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceDeleted.class));
      case "org.dashbuilder.dataset.impl.DataSetImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_impl_DataSetImpl.class));
      case "org.guvnor.common.services.project.model.Dependencies": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_Dependencies.class));
      case "org.optaplanner.workbench.screens.solver.model.SolverConfigModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_optaplanner_workbench_screens_solver_model_SolverConfigModel.class));
      case "org.kie.server.controller.api.model.spec.Capability": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_controller_api_model_spec_Capability.class));
      case "org.guvnor.messageconsole.events.UnpublishMessagesEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_messageconsole_events_UnpublishMessagesEvent.class));
      case "org.kie.server.api.model.KieContainerStatus": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_api_model_KieContainerStatus.class));
      case "org.drools.workbench.models.datamodel.rule.SingleFieldConstraint": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_SingleFieldConstraint.class));
      case "org.uberfire.workbench.events.ResourceCopied": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceCopied.class));
      case "org.kie.soup.project.datamodel.oracle.TypeSource": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_soup_project_datamodel_oracle_TypeSource.class));
      case "org.uberfire.ext.security.management.api.exception.SecurityManagementException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_exception_SecurityManagementException.class));
      case "org.drools.workbench.models.datamodel.rule.ExpressionUnboundFact": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionUnboundFact.class));
      case "org.kie.workbench.common.screens.projecteditor.model.GitUrl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_projecteditor_model_GitUrl.class));
      case "org.guvnor.structure.social.OrganizationalUnitEventType": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_social_OrganizationalUnitEventType.class));
      case "org.dashbuilder.navigation.impl.NavDividerImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_navigation_impl_NavDividerImpl.class));
      case "org.drools.workbench.screens.guided.template.model.GuidedTemplateEditorContent": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_screens_guided_template_model_GuidedTemplateEditorContent.class));
      case "org.drools.workbench.services.verifier.plugin.client.api.Update": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_services_verifier_plugin_client_api_Update.class));
      case "org.drools.workbench.models.guided.dtree.shared.model.parser.messages.AmbiguousRootParserMessage": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtree_shared_model_parser_messages_AmbiguousRootParserMessage.class));
      case "org.dashbuilder.dataset.impl.DataSetLookupBuilderImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_impl_DataSetLookupBuilderImpl.class));
      case "org.kie.workbench.common.services.datamodeller.core.JavaTypeKind": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_JavaTypeKind.class));
      case "org.uberfire.java.nio.file.FileSystemException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_java_nio_file_FileSystemException.class));
      case "org.guvnor.common.services.shared.test.Failure": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_shared_test_Failure.class));
      case "org.ext.uberfire.social.activities.model.SocialPaged": return putMarshaller(a0, GWT.create(Marshaller_for_org_ext_uberfire_social_activities_model_SocialPaged.class));
      case "org.uberfire.workbench.events.ResourceBatchChangesEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceBatchChangesEvent.class));
      case "org.dashbuilder.dataset.filter.LogicalExprType": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_filter_LogicalExprType.class));
      case "org.kie.workbench.common.services.refactoring.model.index.terms.valueterms.ValueRelationshipIndexTerm": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValueRelationshipIndexTerm.class));
      case "org.ext.uberfire.social.activities.model.SocialActivitiesEvent$LINK_TYPE": return putMarshaller(a0, GWT.create(Marshaller_for_org_ext_uberfire_social_activities_model_SocialActivitiesEvent_erraiD_LINK_erraiU_TYPE.class));
      case "org.uberfire.ext.editor.commons.file.exports.PdfExportPreferences": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_editor_commons_file_exports_PdfExportPreferences.class));
      case "org.kie.workbench.common.services.refactoring.model.index.terms.valueterms.ValueFullFileNameIndexTerm": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValueFullFileNameIndexTerm.class));
      case "org.uberfire.workbench.model.impl.PerspectiveDefinitionImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_model_impl_PerspectiveDefinitionImpl.class));
      case "org.guvnor.common.services.project.service.GAVAlreadyExistsException": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_service_GAVAlreadyExistsException.class));
      case "org.uberfire.ext.security.management.api.exception.GroupNotFoundException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_exception_GroupNotFoundException.class));
      case "org.kie.workbench.common.screens.library.api.preferences.LibraryProjectPreferencesPortableGeneratedImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_library_api_preferences_LibraryProjectPreferencesPortableGeneratedImpl.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.adaptors.Pattern52FactPatternAdaptor": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_adaptors_Pattern52FactPatternAdaptor.class));
      case "org.kie.workbench.common.services.refactoring.service.impact.AbstractOperationRequest": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_service_impact_AbstractOperationRequest.class));
      case "org.kie.workbench.common.services.shared.dependencies.EnhancedDependencies": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_dependencies_EnhancedDependencies.class));
      case "org.uberfire.ext.plugin.event.MediaDeleted": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_event_MediaDeleted.class));
      case "org.kie.workbench.common.services.datamodeller.driver.model.AnnotationSource": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_AnnotationSource.class));
      case "org.uberfire.preferences.shared.impl.exception.InvalidPreferenceScopeException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_preferences_shared_impl_exception_InvalidPreferenceScopeException.class));
      case "org.guvnor.messageconsole.events.PublishMessagesEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_messageconsole_events_PublishMessagesEvent.class));
      case "org.uberfire.ext.properties.editor.model.PropertyEditorCategory": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_properties_editor_model_PropertyEditorCategory.class));
      case "org.drools.workbench.screens.dsltext.model.DSLTextEditorContent": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_screens_dsltext_model_DSLTextEditorContent.class));
      case "org.kie.server.controller.api.model.events.ServerInstanceUpdated": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_controller_api_model_events_ServerInstanceUpdated.class));
      case "org.kie.workbench.common.services.datamodeller.core.impl.AnnotationImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_impl_AnnotationImpl.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.ActionCol52": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_ActionCol52.class));
      case "org.ext.uberfire.social.activities.events.SocialUserFollowedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_ext_uberfire_social_activities_events_SocialUserFollowedEvent.class));
      case "org.uberfire.ext.plugin.model.Activity": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_Activity.class));
      case "org.uberfire.ext.layout.editor.api.editor.LayoutRow": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_layout_editor_api_editor_LayoutRow.class));
      case "org.drools.workbench.models.testscenarios.shared.ActivateRuleFlowGroup": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_ActivateRuleFlowGroup.class));
      case "org.uberfire.ext.security.management.api.exception.OperationFailedException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_exception_OperationFailedException.class));
      case "org.uberfire.ext.security.management.impl.SearchRequestImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_impl_SearchRequestImpl.class));
      case "org.kie.workbench.common.services.shared.kmodule.ClockTypeOption": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_kmodule_ClockTypeOption.class));
      case "org.kie.workbench.common.screens.datamodeller.events.DataObjectFieldCreatedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_datamodeller_events_DataObjectFieldCreatedEvent.class));
      case "org.dashbuilder.navigation.layout.LayoutTemplateInfo": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_navigation_layout_LayoutTemplateInfo.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.BaseColumnFieldDiffImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_BaseColumnFieldDiffImpl.class));
      case "org.drools.workbench.services.verifier.plugin.client.api.FactTypes": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_services_verifier_plugin_client_api_FactTypes.class));
      case "org.dashbuilder.dataset.def.CSVDataSetDef": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_def_CSVDataSetDef.class));
      case "org.guvnor.structure.repositories.PullRequestAlreadyExistsException": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_PullRequestAlreadyExistsException.class));
      case "org.drools.workbench.models.guided.dtable.shared.auditlog.InsertColumnAuditLogEntry": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_auditlog_InsertColumnAuditLogEntry.class));
      case "org.kie.soup.project.datamodel.oracle.FieldAccessorsAndMutators": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_soup_project_datamodel_oracle_FieldAccessorsAndMutators.class));
      case "org.kie.workbench.common.screens.library.api.index.LibraryRepositoryRootIndexTerm": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_library_api_index_LibraryRepositoryRootIndexTerm.class));
      case "org.kie.workbench.common.services.datamodeller.driver.model.DriverResponse": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_DriverResponse.class));
      case "org.kie.workbench.common.services.refactoring.model.index.terms.ReferenceIndexTerm": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_ReferenceIndexTerm.class));
      case "org.kie.workbench.common.services.datamodeller.driver.model.AnnotationDefinitionRequest": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_driver_model_AnnotationDefinitionRequest.class));
      case "org.uberfire.preferences.shared.impl.PreferenceScopeResolutionStrategyInfo": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_preferences_shared_impl_PreferenceScopeResolutionStrategyInfo.class));
      case "org.guvnor.structure.config.SystemRepositoryChangedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_config_SystemRepositoryChangedEvent.class));
      case "org.uberfire.security.impl.authz.DefaultAuthorizationEntry": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_security_impl_authz_DefaultAuthorizationEntry.class));
      case "org.dashbuilder.dataset.date.TimeInstant": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_date_TimeInstant.class));
      case "org.kie.workbench.common.services.refactoring.model.index.terms.valueterms.ValueReferenceIndexTerm": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValueReferenceIndexTerm.class));
      case "org.drools.verifier.api.reporting.Severity": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_verifier_api_reporting_Severity.class));
      case "org.drools.workbench.models.testscenarios.shared.Scenario": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_testscenarios_shared_Scenario.class));
      case "org.uberfire.ext.editor.commons.file.exports.FileExportsPreferences": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_editor_commons_file_exports_FileExportsPreferences.class));
      case "org.guvnor.common.services.project.preferences.GeneralPreferences": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_preferences_GeneralPreferences.class));
      case "org.guvnor.common.services.project.preferences.GAVPreferences": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_preferences_GAVPreferences.class));
      case "org.kie.workbench.common.screens.library.api.preferences.LibraryPreferences": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_library_api_preferences_LibraryPreferences.class));
      case "org.kie.workbench.common.screens.library.api.preferences.LibraryInternalPreferences": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_library_api_preferences_LibraryInternalPreferences.class));
      case "org.uberfire.preferences.shared.bean.mock.PortablePreferenceMock": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_preferences_shared_bean_mock_PortablePreferenceMock.class));
      case "org.kie.workbench.common.screens.library.api.preferences.LibraryOrganizationalUnitPreferences": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_library_api_preferences_LibraryOrganizationalUnitPreferences.class));
      case "org.guvnor.m2repo.preferences.ArtifactRepositoryPreference": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_m2repo_preferences_ArtifactRepositoryPreference.class));
      case "org.kie.workbench.common.screens.library.api.preferences.LibraryProjectPreferences": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_library_api_preferences_LibraryProjectPreferences.class));
      case "org.kie.workbench.common.services.refactoring.model.index.terms.valueterms.ValueIndexTerm$TermSearchType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_model_index_terms_valueterms_ValueIndexTerm_erraiD_TermSearchType.class));
      case "org.uberfire.ext.services.shared.preferences.UserPreferencesType": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_services_shared_preferences_UserPreferencesType.class));
      case "org.uberfire.backend.plugin.PluginProcessor$PluginProcessorType": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_backend_plugin_PluginProcessor_erraiD_PluginProcessorType.class));
      case "org.kie.workbench.common.services.refactoring.service.impact.OperationType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_refactoring_service_impact_OperationType.class));
      case "org.dashbuilder.navigation.NavItem$Type": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_navigation_NavItem_erraiD_Type.class));
      case "org.dashbuilder.dataset.sort.SortOrder": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_sort_SortOrder.class));
      case "org.kie.workbench.common.screens.library.api.AssetQueryResult$ResultType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_library_api_AssetQueryResult_erraiD_ResultType.class));
      case "org.kie.workbench.common.screens.server.management.model.ContainerRuntimeState": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_server_management_model_ContainerRuntimeState.class));
      case "org.kie.workbench.common.screens.server.management.model.ContainerRuntimeOperation": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_screens_server_management_model_ContainerRuntimeOperation.class));
      case "org.uberfire.ext.properties.editor.model.PropertyEditorType": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_properties_editor_model_PropertyEditorType.class));
      case "org.kie.server.api.model.KieScannerStatus": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_server_api_model_KieScannerStatus.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.GuidedDecisionTable52$TableFormat": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_GuidedDecisionTable52_erraiD_TableFormat.class));
      case "org.drools.workbench.models.guided.dtable.shared.model.GuidedDecisionTable52$HitPolicy": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_guided_dtable_shared_model_GuidedDecisionTable52_erraiD_HitPolicy.class));
      case "org.uberfire.workbench.events.NotificationEvent$NotificationType": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_NotificationEvent_erraiD_NotificationType.class));
      case "org.kie.workbench.common.services.datamodeller.core.AnnotationValuePairDefinition$ValuePairType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodeller_core_AnnotationValuePairDefinition_erraiD_ValuePairType.class));
      case "org.kie.workbench.common.services.shared.kmodule.DeclarativeAgendaOption": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_shared_kmodule_DeclarativeAgendaOption.class));
      case "org.drools.workbench.services.verifier.plugin.client.builders.ModelMetaDataEnhancer$PatternType": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_services_verifier_plugin_client_builders_ModelMetaDataEnhancer_erraiD_PatternType.class));
      case "org.dashbuilder.dataset.date.TimeInstant$TimeMode": return putMarshaller(a0, GWT.create(Marshaller_for_org_dashbuilder_dataset_date_TimeInstant_erraiD_TimeMode.class));
      default: return false;
    }
  }

  public Marshaller getMarshaller(String a0) {
    if (a0 == null) {
      return null;
    }
    Marshaller m = marshallers.get(a0);
    if (m != null) {
      return m;
    } else if (loadMarshaller0(a0)) {
      return marshallers.get(a0);
    } else if (loadMarshaller1(a0)) {
      return marshallers.get(a0);
    }
    return null;
  }

  public void registerMarshaller(String a0, Marshaller a1) {
    marshallers.put(a0, a1);
  }
}